/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,T=me.length;D<T;D++)e[D]=ke[me[D]];return e};define(ke[157],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,R=new Map,b=new Map;function $(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function y(v,S){const l=v.get(S.detail);l&&(l>=0||v.set(S.detail,l+S.timestamp))}let L=[];typeof me=="function"&&typeof me.getStats=="function"&&(L=me.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of L)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(I,v);break;case 22:y(I,v);break;case 33:$(R,v);break;case 34:y(R,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;R.forEach(v=>C+=v);function m(v){const S=[];return v.forEach((l,f)=>S.push([f,l])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(R),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let R="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,L)=>{typeof y>"u"&&(y=$[L]="-");const C=y.toString().length;b[L]=Math.max(C,b[L])})}),g.forEach(($,y)=>{R+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),R+=`|
`,g.forEach(($,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,I.forEach($=>{$.forEach((y,L)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[L]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(ke[158],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(l,f,o){const i=T(l,f);if(i!==-1)return l[i]}e.$fb=D;function T(l,f,o=l.length-1){for(let i=o;i>=0;i--){const r=l[i];if(f(r))return i}return-1}e.$gb=T;function g(l,f){const o=I(l,f);return o===-1?void 0:l[o]}e.$hb=g;function I(l,f,o=0,i=l.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(l[c])?r=c+1:n=c}return r-1}e.$ib=I;function R(l,f){const o=b(l,f);return o===l.length?void 0:l[o]}e.$jb=R;function b(l,f,o=0,i=l.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(l[c])?n=c:r=c+1}return r}e.$kb=b;function $(l,f,o=0,i=l.length){const r=b(l,f,o,i);return r===l.length?-1:r}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=I(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=y;function L(l,f){if(l.length===0)return;let o=l[0];for(let i=1;i<l.length;i++){const r=l[i];f(r,o)>0&&(o=r)}return o}e.$nb=L;function C(l,f){if(l.length===0)return;let o=l[0];for(let i=1;i<l.length;i++){const r=l[i];f(r,o)>=0&&(o=r)}return o}e.$ob=C;function m(l,f){return L(l,(o,i)=>-f(o,i))}e.$pb=m;function v(l,f){if(l.length===0)return-1;let o=0;for(let i=1;i<l.length;i++){const r=l[i];f(r,l[o])>0&&(o=i)}return o}e.$qb=v;function S(l,f){for(const o of l){const i=f(o);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(R,b){const $=Object.create(null);for(const y of R){const L=b(y);let C=$[L];C||(C=$[L]=[]),C.push(y)}return $}e.$K=D;function T(R,b){const $=[],y=[];for(const L of R)b.has(L)||$.push(L);for(const L of b)R.has(L)||y.push(L);return{removed:$,added:y}}e.$L=T;function g(R,b){const $=[],y=[];for(const[L,C]of R)b.has(L)||$.push(C);for(const[L,C]of b)R.has(L)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(R,b){const $=new Set;for(const y of b)R.has(y)&&$.add(y);return $}e.$N=I}),define(ke[52],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function D(R){return(b,$,y)=>{let L=null,C=null;if(typeof y.value=="function"?(L="value",C=y.value):typeof y.get=="function"&&(L="get",C=y.get),!C)throw new Error("not supported");y[L]=R(C,$)}}function T(R,b,$){let y=null,L=null;if(typeof $.value=="function"?(y="value",L=$.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",L=$.get),!L)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,m)}),this[C]}}e.$xh=T;function g(R,b,$){return D((y,L)=>{const C=`$debounce$${L}`,m=`$debounce$result$${L}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},R)}})}e.$yh=g;function I(R,b,$){return D((y,L)=>{const C=`$throttle$timer$${L}`,m=`$throttle$result$${L}`,v=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...l)),this[S])return;const f=this[v]+R;f<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$zh=I}),define(ke[14],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function T(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=T;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=I;function R(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=R;function b(c){if(c instanceof Error){const{name:t,message:u}=c,s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:u,stack:s,noTelemetry:r.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof L?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class L extends Error{constructor(){super($),this.name=this.message}}e.$5=L;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function l(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=l;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const u=new r;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function I(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=I;function R(de,ge,_=(te,G)=>te===G){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let te=0,G=de.length;te<G;te++)if(!_(de[te],ge[te]))return!1;return!0}e.$ub=R;function b(de,ge){const _=de.length-1;ge<_&&(de[ge]=de[_]),de.pop()}e.$vb=b;function $(de,ge,_){return y(de.length,te=>_(de[te],ge))}e.$wb=$;function y(de,ge){let _=0,te=de-1;for(;_<=te;){const G=(_+te)/2|0,ie=ge(G);if(ie<0)_=G+1;else if(ie>0)te=G-1;else return G}return-(_+1)}e.$xb=y;function L(de,ge,_){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const te=ge[Math.floor(ge.length*Math.random())],G=[],ie=[],fe=[];for(const ve of ge){const Pe=_(ve,te);Pe<0?G.push(ve):Pe>0?ie.push(ve):fe.push(ve)}return de<G.length?L(de,G,_):de<G.length+fe.length?fe[0]:L(de-(G.length+fe.length),ie,_)}e.$yb=L;function C(de,ge){const _=[];let te;for(const G of de.slice(0).sort(ge))!te||ge(te[0],G)!==0?(te=[G],_.push(te)):te.push(G);return _}e.$zb=C;function*m(de,ge){let _,te;for(const G of de)te!==void 0&&ge(te,G)?_.push(G):(_&&(yield _),_=[G]),te=G;_&&(yield _)}e.$Ab=m;function v(de,ge){for(let _=0;_<=de.length;_++)ge(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=v;function S(de,ge){for(let _=0;_<de.length;_++)ge(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=S;function l(de,ge,_){const te=[];function G(ve,Pe,we){if(Pe===0&&we.length===0)return;const De=te[te.length-1];De&&De.start+De.deleteCount===ve?(De.deleteCount+=Pe,De.toInsert.push(...we)):te.push({start:ve,deleteCount:Pe,toInsert:we})}let ie=0,fe=0;for(;;){if(ie===de.length){G(ie,0,ge.slice(fe));break}if(fe===ge.length){G(ie,de.length-ie,[]);break}const ve=de[ie],Pe=ge[fe],we=_(ve,Pe);we===0?(ie+=1,fe+=1):we<0?(G(ie,1,[]),ie+=1):we>0&&(G(ie,0,[Pe]),fe+=1)}return te}e.$Db=l;function f(de,ge,_){const te=l(de,ge,_),G=[],ie=[];for(const fe of te)G.push(...de.slice(fe.start,fe.start+fe.deleteCount)),ie.push(...fe.toInsert);return{removed:G,added:ie}}e.$Eb=f;function o(de,ge,_){if(_===0)return[];const te=de.slice(0,_).sort(ge);return r(de,ge,te,_,de.length),te}e.top=o;function i(de,ge,_,te,G){return _===0?Promise.resolve([]):new Promise((ie,fe)=>{(async()=>{const ve=de.length,Pe=de.slice(0,_).sort(ge);for(let we=_,De=Math.min(_+te,ve);we<ve;we=De,De=Math.min(De+te,ve)){if(we>_&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new D.$5;r(de,ge,Pe,we,De)}return Pe})().then(ie,fe)})}e.$Gb=i;function r(de,ge,_,te,G){for(const ie=_.length;te<G;te++){const fe=de[te];if(ge(fe,_[ie-1])<0){_.pop();const ve=(0,T.$kb)(_,Pe=>ge(fe,Pe)<0);_.splice(ve,0,fe)}}}function n(de){return de.filter(ge=>!!ge)}e.$Hb=n;function c(de){let ge=0;for(let _=0;_<de.length;_++)de[_]&&(de[ge]=de[_],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,_){de.splice(_,0,de.splice(ge,1)[0])}e.$Jb=t;function u(de){return!Array.isArray(de)||de.length===0}e.$Kb=u;function s(de){return Array.isArray(de)&&de.length>0}e.$Lb=s;function h(de,ge=_=>_){const _=new Set;return de.filter(te=>{const G=ge(te);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=h;function a(de){const ge=new Set;return _=>{const te=de(_);return ge.has(te)?!1:(ge.add(te),!0)}}e.$Nb=a;function d(de,ge){return de.length>0?de[0]:ge}e.$Ob=d;function k(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=k;function A(de,ge,_=(te,G)=>te===G){let te=0;for(let G=0,ie=Math.min(de.length,ge.length);G<ie&&_(de[G],ge[G]);G++)te++;return te}e.$Qb=A;function p(de){return[].concat(...de)}e.$Rb=p;function w(de,ge){let _=typeof ge=="number"?de:0;typeof ge=="number"?_=de:(_=0,ge=de);const te=[];if(_<=ge)for(let G=_;G<ge;G++)te.push(G);else for(let G=_;G>ge;G--)te.push(G);return te}e.$Sb=w;function E(de,ge,_){return de.reduce((te,G)=>(te[ge(G)]=_?_(G):G,te),Object.create(null))}e.$Tb=E;function P(de,ge){return de.push(ge),()=>F(de,ge)}e.$Ub=P;function F(de,ge){const _=de.indexOf(ge);if(_>-1)return de.splice(_,1),ge}e.$Vb=F;function z(de,ge,_){const te=de.slice(0,ge),G=de.slice(ge);return te.concat(_,G)}e.$Wb=z;function N(de,ge){let _;if(typeof ge=="number"){let te=ge;_=()=>{const G=Math.sin(te++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let te=de.length-1;te>0;te-=1){const G=Math.floor(_()*(te+1)),ie=de[te];de[te]=de[G],de[G]=ie}}e.$Xb=N;function j(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.unshift(ge))}e.$Yb=j;function M(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.push(ge))}e.$Zb=M;function O(de,ge){for(const _ of ge)de.push(_)}e.$1b=O;function U(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=U;function Y(de){return Array.isArray(de)?de:[de]}e.$3b=Y;function le(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=le;function Z(de,ge,_){const te=X(de,ge),G=de.length,ie=_.length;de.length=G+ie;for(let fe=G-1;fe>=te;fe--)de[fe+ie]=de[fe];for(let fe=0;fe<ie;fe++)de[fe+te]=_[fe]}e.$5b=Z;function J(de,ge,_,te){const G=X(de,ge);let ie=de.splice(G,_);return ie===void 0&&(ie=[]),Z(de,G,te),ie}e.$6b=J;function X(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var ue;(function(de){function ge(ie){return ie<0}de.isLessThan=ge;function _(ie){return ie<=0}de.isLessThanOrEqual=_;function te(ie){return ie>0}de.isGreaterThan=te;function G(ie){return ie===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function x(de,ge){return(_,te)=>ge(de(_),de(te))}e.$7b=x;function be(...de){return(ge,_)=>{for(const te of de){const G=te(ge,_);if(!ue.isNeitherLessOrGreaterThan(G))return G}return ue.neitherLessOrGreaterThan}}e.$8b=be;const ce=(de,ge)=>de-ge;e.$9b=ce;const K=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=K;function V(de){return(ge,_)=>-de(ge,_)}e.$$b=V;class re{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const te=_===this.c?null:this.g.slice(this.c,_);return this.c=_,te}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const te=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=re;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(te=>ge(te)?_(te):!0))}map(ge){return new ye(_=>this.iterate(te=>_(ge(te))))}some(ge){let _=!1;return this.iterate(te=>(_=ge(te),!_)),_}findFirst(ge){let _;return this.iterate(te=>ge(te)?(_=te,!1):!0),_}findLast(ge){let _;return this.iterate(te=>(ge(te)&&(_=te),!0)),_}findLastMaxBy(ge){let _,te=!0;return this.iterate(G=>((te||ue.isGreaterThan(ge(G,_)))&&(te=!1,_=G),!0)),_}}e.$ac=ye}),define(ke[60],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function T($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=T;function g($,y="Unreachable"){throw new Error(y)}e.$6c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$7c=I;function R($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$8c=R;function b($,y){let L=0;for(;L<$.length-1;){const C=$[L],m=$[L+1];if(!y(C,m))return!1;L++}return!0}e.$9c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(T,g){const I=this;let R=!1,b;return function(){if(R)return b;if(R=!0,g)try{b=T.apply(I,arguments)}finally{g()}else b=T.apply(I,arguments);return b}}e.$db=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$gN=D,e.$hN=new D("id#")}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}T.is=g;const I=Object.freeze([]);function R(){return I}T.empty=R;function*b(t){yield t}T.single=b;function $(t){return g(t)?t:b(t)}T.wrap=$;function y(t){return t||I}T.from=y;function*L(t){for(let u=t.length-1;u>=0;u--)yield t[u]}T.reverse=L;function C(t){return!t||t[Symbol.iterator]().next().done===!0}T.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}T.first=m;function v(t,u){for(const s of t)if(u(s))return!0;return!1}T.some=v;function S(t,u){for(const s of t)if(u(s))return s}T.find=S;function*l(t,u){for(const s of t)u(s)&&(yield s)}T.filter=l;function*f(t,u){let s=0;for(const h of t)yield u(h,s++)}T.map=f;function*o(...t){for(const u of t)yield*u}T.concat=o;function i(t,u,s){let h=s;for(const a of t)h=u(h,a);return h}T.reduce=i;function*r(t,u,s=t.length){for(u<0&&(u+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);u<s;u++)yield t[u]}T.slice=r;function n(t,u=Number.POSITIVE_INFINITY){const s=[];if(u===0)return[s,t];const h=t[Symbol.iterator]();for(let a=0;a<u;a++){const d=h.next();if(d.done)return[s,T.empty()];s.push(d.value)}return[s,{[Symbol.iterator](){return h}}]}T.consume=n;async function c(t){const u=[];for await(const s of t)u.push(s);return Promise.resolve(u)}T.asyncToArray=c})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,u=!1){let s=0;const h=t.length;let a="",d=0,k=16,A=0;function p(j){let M=0,O=0;for(;M<j;){const U=t.charCodeAt(s);if(U>=48&&U<=57)O=O*16+U-48;else if(U>=65&&U<=70)O=O*16+U-65+10;else if(U>=97&&U<=102)O=O*16+U-97+10;else break;s++,M++}return M<j&&(O=-1),O}function w(j){s=j,a="",d=0,k=16,A=0}function E(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return A=3,t.substring(j,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;M=s}else A=3;return t.substring(j,M)}function P(){let j="",M=s;for(;;){if(s>=h){j+=t.substring(M,s),A=2;break}const O=t.charCodeAt(s);if(O===34){j+=t.substring(M,s),s++;break}if(O===92){if(j+=t.substring(M,s),s++,s>=h){A=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=p(4);Y>=0?j+=String.fromCharCode(Y):A=4;break}default:A=5}M=s;continue}if(O>=0&&O<=31)if($(O)){j+=t.substring(M,s),A=2;break}else A=6;s++}return j}function F(){if(a="",A=0,d=s,s>=h)return d=h,k=17;let j=t.charCodeAt(s);if(b(j)){do s++,a+=String.fromCharCode(j),j=t.charCodeAt(s);while(b(j));return k=15}if($(j))return s++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),k=14;switch(j){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,a=P(),k=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<h&&!$(t.charCodeAt(s));)s++;return a=t.substring(M,s),k=12}if(t.charCodeAt(s+1)===42){s+=2;const O=h-1;let U=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,A=1),a=t.substring(M,s),k=13}return a+=String.fromCharCode(j),s++,k=16}case 45:if(a+=String.fromCharCode(j),s++,s===h||!y(t.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=E(),k=11;default:for(;s<h&&z(j);)s++,j=t.charCodeAt(s);if(d!==s){switch(a=t.substring(d,s),a){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return a+=String.fromCharCode(j),s++,k=16}}function z(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:w,getPosition:()=>s,scan:u?N:F,getToken:()=>k,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>A}}e.$an=R;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function C(t,u){const s=[],h=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function A(p,w,E,P){d.value=p,d.offset=w,d.length=E,d.type=P,d.colonOffset=void 0,a=d}try{r(t,{onObjectBegin:(p,w)=>{if(u<=p)throw h;a=void 0,k=u>p,s.push("")},onObjectProperty:(p,w,E)=>{if(u<w||(A(p,w,E,"property"),s[s.length-1]=p,u<=w+E))throw h},onObjectEnd:(p,w)=>{if(u<=p)throw h;a=void 0,s.pop()},onArrayBegin:(p,w)=>{if(u<=p)throw h;a=void 0,s.push(0)},onArrayEnd:(p,w)=>{if(u<=p)throw h;a=void 0,s.pop()},onLiteralValue:(p,w,E)=>{if(u<w||(A(p,w,E,c(p)),u<=w+E))throw h},onSeparator:(p,w,E)=>{if(u<=w)throw h;if(p===":"&&a&&a.type==="property")a.colonOffset=w,k=!1,a=void 0;else if(p===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(k=!0,s[s.length-1]=""),a=void 0}}})}catch(p){if(p!==h)throw p}return{path:s,previousNode:a,isAtPropertyKey:k,matches:p=>{let w=0;for(let E=0;w<p.length&&E<s.length;E++)if(p[w]===s[E]||p[w]==="*")w++;else if(p[w]!=="**")return!1;return w===p.length}}}e.$bn=C;function m(t,u=[],s=I.DEFAULT){let h=null,a=[];const d=[];function k(p){Array.isArray(a)?a.push(p):h!==null&&(a[h]=p)}return r(t,{onObjectBegin:()=>{const p={};k(p),d.push(a),a=p,h=null},onObjectProperty:p=>{h=p},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const p=[];k(p),d.push(a),a=p,h=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:k,onError:(p,w,E)=>{u.push({error:p,offset:w,length:E})}},s),a[0]}e.$cn=m;function v(t,u=[],s=I.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){h.type==="property"&&(h.length=p-h.offset,h=h.parent)}function d(p){return h.children.push(p),p}r(t,{onObjectBegin:p=>{h=d({type:"object",offset:p,length:-1,parent:h,children:[]})},onObjectProperty:(p,w,E)=>{h=d({type:"property",offset:w,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:p,offset:w,length:E,parent:h})},onObjectEnd:(p,w)=>{h.length=p+w-h.offset,h=h.parent,a(p+w)},onArrayBegin:(p,w)=>{h=d({type:"array",offset:p,length:-1,parent:h,children:[]})},onArrayEnd:(p,w)=>{h.length=p+w-h.offset,h=h.parent,a(p+w)},onLiteralValue:(p,w,E)=>{d({type:c(p),offset:w,length:E,parent:h,value:p}),a(w+E)},onSeparator:(p,w,E)=>{h.type==="property"&&(p===":"?h.colonOffset=w:p===","&&a(w))},onError:(p,w,E)=>{u.push({error:p,offset:w,length:E})}},s);const A=h.children[0];return A&&delete A.parent,A}e.$dn=v;function S(t,u){if(!t)return;let s=t;for(const h of u)if(typeof h=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===h){s=d.children[1],a=!0;break}if(!a)return}else{const a=h;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.$en=S;function l(t){if(!t.parent||!t.parent.children)return[];const u=l(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;u.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&u.push(s)}return u}e.$fn=l;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const s of t.children){const h=s.children[1];h&&(u[s.children[0].value]=f(h))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=f;function o(t,u,s=!1){return u>=t.offset&&u<t.offset+t.length||s&&u===t.offset+t.length}e.$hn=o;function i(t,u,s=!1){if(o(t,u,s)){const h=t.children;if(Array.isArray(h))for(let a=0;a<h.length&&h[a].offset<=u;a++){const d=i(h[a],u,s);if(d)return d}return t}}e.$in=i;function r(t,u,s=I.DEFAULT){const h=R(t,!1);function a(x){return x?()=>x(h.getTokenOffset(),h.getTokenLength()):()=>!0}function d(x){return x?be=>x(be,h.getTokenOffset(),h.getTokenLength()):()=>!0}const k=a(u.onObjectBegin),A=d(u.onObjectProperty),p=a(u.onObjectEnd),w=a(u.onArrayBegin),E=a(u.onArrayEnd),P=d(u.onLiteralValue),F=d(u.onSeparator),z=a(u.onComment),N=d(u.onError),j=s&&s.disallowComments,M=s&&s.allowTrailingComma;function O(){for(;;){const x=h.scan();switch(h.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:j||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(x){case 12:case 13:j?U(10):z();break;case 16:U(1);break;case 15:case 14:break;default:return x}}}function U(x,be=[],ce=[]){if(N(x),be.length+ce.length>0){let K=h.getToken();for(;K!==17;){if(be.indexOf(K)!==-1){O();break}else if(ce.indexOf(K)!==-1)break;K=O()}}}function Y(x){const be=h.getTokenValue();return x?P(be):A(be),O(),!0}function le(){switch(h.getToken()){case 11:{let x=0;try{x=JSON.parse(h.getTokenValue()),typeof x!="number"&&(U(2),x=0)}catch{U(2)}P(x);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function Z(){return h.getToken()!==10?(U(3,[],[2,5]),!1):(Y(!1),h.getToken()===6?(F(":"),O(),ue()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function J(){k(),O();let x=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(x||U(4,[],[]),F(","),O(),h.getToken()===2&&M)break}else x&&U(6,[],[]);Z()||U(4,[],[2,5]),x=!0}return p(),h.getToken()!==2?U(7,[2],[]):O(),!0}function X(){w(),O();let x=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(x||U(4,[],[]),F(","),O(),h.getToken()===4&&M)break}else x&&U(6,[],[]);ue()||U(4,[],[4,5]),x=!0}return E(),h.getToken()!==4?U(8,[4],[]):O(),!0}function ue(){switch(h.getToken()){case 3:return X();case 1:return J();case 10:return Y(!0);default:return le()}}return O(),h.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ue()?(h.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.$jn=r;function n(t,u){const s=R(t),h=[];let a,d=0,k;do switch(k=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:d!==k&&h.push(t.substring(d,k)),u!==void 0&&h.push(s.getTokenValue().replace(/[^\r\n]/g,u)),d=s.getPosition();break}while(a!==17);return h.join("")}e.$kn=n;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=c}),define(ke[43],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const R=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(R){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$4c=T}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(r,n,c){let t=r.get(n);return t===void 0&&(t=c,r.set(n,t)),t}e.$xc=I;function R(r){const n=[];return r.forEach((c,t)=>{n.push(`${t} => ${c}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=R;function b(r){const n=[];return r.forEach(c=>{n.push(c)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,c){this.uri=n,this.value=c}}function y(r){return Array.isArray(r)}class L{static{this.c=n=>n.toString()}constructor(n,c){if(this[D]="ResourceMap",n instanceof L)this.d=new Map(n.d),this.e=c??L.c;else if(y(n)){this.d=new Map,this.e=c??L.c;for(const[t,u]of n)this.set(t,u)}else this.d=new Map,this.e=n??L.c}set(n,c){return this.d.set(this.e(n),new $(n,c)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,c){typeof c<"u"&&(n=n.bind(c));for(const[t,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=L;class C{constructor(n,c){this[T]="ResourceSet",!n||typeof n=="function"?this.c=new L(n):(this.c=new L(c),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,c){this.c.forEach((t,u)=>n.call(c,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,c=0){const t=this.c.get(n);if(t)return c!==0&&this.l(t,c),t.value}set(n,c,t=0){let u=this.c.get(n);if(u)u.value=c,t!==0&&this.l(u,t);else{switch(u={key:n,value:c,next:void 0,previous:void 0},t){case 0:this.j(u);break;case 1:this.i(u);break;case 2:this.j(u);break;default:this.j(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const c=this.c.get(n);if(c)return this.c.delete(n),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,c){const t=this.g;let u=this.d;for(;u;){if(c?n.bind(c)(u.value,u.key,this):n(u.value,u.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}values(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}entries(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>n;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const c=n.next,t=n.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}n.next=void 0,n.previous=void 0,this.g++}l(n,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(n===this.d)return;const t=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(t.previous=u,u.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(c===2){if(n===this.e)return;const t=n.next,u=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=u,u.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((c,t)=>{n.push([t,c])}),n}fromJSON(n){this.clear();for(const[c,t]of n)this.set(c,t)}}e.$Cc=v;class S extends v{constructor(n,c=1){super(),this.m=n,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,c=2){return super.get(n,c)}peek(n){return super.get(n,0)}set(n,c){return super.set(n,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class l{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let c=this.c.get(n)||0;return c===0?!1:(c--,c===0?this.c.delete(n):this.c.set(n,c),!0)}has(n){return this.c.has(n)}}e.$Ec=l;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[c,t]of n)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(n,c){this.c.set(n,c),this.d.set(c,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const c=this.c.get(n);return c===void 0?!1:(this.c.delete(n),this.d.delete(c),!0)}forEach(n,c){this.c.forEach((t,u)=>{n.call(c,t,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=f;class o{constructor(){this.c=new Map}add(n,c){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(c)}delete(n,c){const t=this.c.get(n);t&&(t.delete(c),t.size===0&&this.c.delete(n))}forEach(n,c){const t=this.c.get(n);t&&t.forEach(c)}get(n){const c=this.c.get(n);return c||new Set}}e.$Gc=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[c,t]of r)if(!n.has(c)||n.get(c)!==t)return!1;for(const[c]of n)if(!r.has(c))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(P){let F=this.b.get(P);return F||(F={parent:null,source:null,isSingleton:!1,value:P,idx:y.a++},this.b.set(P,F)),F}trackDisposable(P){const F=this.c(P);F.source||(F.source=new Error().stack)}setParent(P,F){const z=this.c(P);z.parent=F}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,F){const z=F.get(P);if(z)return z;const N=P.parent?this.f(this.c(P.parent),F):P;return F.set(P,N),N}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,P).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(P=10,F){let z;if(F)z=F;else{const U=new Map,Y=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,U).isSingleton);if(Y.length===0)return;const le=new Set(Y.map(Z=>Z.value));if(z=Y.filter(Z=>!(Z.parent&&le.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function N(U){function Y(Z,J){for(;Z.length>0&&J.some(X=>typeof X=="string"?X===Z[0]:Z[0].match(X));)Z.shift()}const le=U.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return Y(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const j=new g.$Gc;for(const U of z){const Y=N(U);for(let le=0;le<=Y.length;le++)j.add(Y.slice(0,le).join(`
`),U)}z.sort((0,D.$7b)(U=>U.idx,D.$9b));let M="",O=0;for(const U of z.slice(0,P)){O++;const Y=N(U),le=[];for(let Z=0;Z<Y.length;Z++){let J=Y[Z];J=`(shared with ${j.get(Y.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${J}`;const ue=j.get(Y.slice(0,Z).join(`
`)),x=(0,T.$K)([...ue].map(be=>N(be)[Z]),be=>be);delete x[Y[Z]];for(const[be,ce]of Object.entries(x))le.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${be}`);le.unshift(J)}M+=`


==================== Leaking disposable ${O}/${z.length}: ${U.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return z.length>P&&(M+=`


... and ${z.length-P} more leaking disposables

`),{leaks:z,details:M}}}e.$Ic=y;function L(E){$=E}if(e.$Jc=L,b){const E="__is_disposable_tracked__";L(new class{trackDisposable(P){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(F)},3e3)}setParent(P,F){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function C(E){return $?.trackDisposable(E),E}e.$Kc=C;function m(E){$?.markAsDisposed(E)}e.$Lc=m;function v(E,P){$?.setParent(E,P)}function S(E,P){if($)for(const F of E)$.setParent(F,P)}function l(E){return $?.markAsSingleton(E),E}e.$Mc=l;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Nc=f;function o(E){if(R.Iterable.is(E)){const P=[];for(const F of E)if(F)try{F.dispose()}catch(z){P.push(z)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Oc=o;function i(E){for(const P of E)f(P)&&P.dispose();return[]}e.$Pc=i;function r(...E){const P=n(()=>o(E));return S(E,P),P}e.$Qc=r;function n(E){const P=C({dispose:(0,I.$db)(()=>{m(P),E()})});return P}e.$Rc=n;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return v(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),v(P,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class u{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&v(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&v(P,null),P}}e.$Uc=u;class s{constructor(P){this.a=new u,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class h{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=h;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let F=P;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,m(this))},this}}e.$Xc=a;class d{constructor(){this.a=new Map}acquire(P,...F){let z=this.a.get(P);z||(z={counter:0,object:this.b(P,...F)},this.a.set(P,z));const{object:N}=z,j=(0,I.$db)(()=>{--z.counter===0&&(this.c(P,z.object),this.a.delete(P))});return z.counter++,{object:N,dispose:j}}}e.$Yc=d;class k{constructor(P){this.a=P}async acquire(P,...F){const z=this.a.acquire(P,...F);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(N){throw z.dispose(),N}}}e.$Zc=k;class A{constructor(P){this.object=P}dispose(){}}e.$1c=A;function p(E){const P=new c;try{E(P)}finally{P.dispose()}}e.$2c=p;class w{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,F,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(P)?.dispose(),this.a.set(P,F)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=w}),function(me,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var te=0;te<_.length;te++){var G=_[te];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,_,te){return _&&e(ge.prototype,_),te&&e(ge,te),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function T(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var te=Object.prototype.toString.call(ge).slice(8,-1);if(te==="Object"&&ge.constructor&&(te=ge.constructor.name),te==="Map"||te==="Set")return Array.from(ge);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var te=0,G=new Array(_);te<_;te++)G[te]=ge[te];return G}function I(ge,_){var te=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(te)return(te=te.call(ge)).next.bind(te);if(Array.isArray(ge)||(te=T(ge))||_&&ge&&typeof ge.length=="number"){te&&(ge=te);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(_){return m[_]};function S(ge,_){if(_){if($.test(ge))return ge.replace(y,v)}else if(L.test(ge))return ge.replace(C,v);return ge}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(l,function(_,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var te={replace:function(ie,fe){return fe=fe.source||fe,fe=fe.replace(o,"$1"),ge=ge.replace(ie,fe),te},getRegex:function(){return new RegExp(ge,_)}};return te}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,_,te){if(ge){var G;try{G=decodeURIComponent(f(te)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!n.test(te)&&(te=a(_,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ge,_){t[" "+ge]||(u.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=p(ge,"/",!0)),ge=t[" "+ge];var te=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?te?_:ge.replace(s,"$1")+_:_.charAt(0)==="/"?te?_:ge.replace(h,"$1")+_:ge+_}var d={exec:function(){}};function k(ge){for(var _=1,te,G;_<arguments.length;_++){te=arguments[_];for(G in te)Object.prototype.hasOwnProperty.call(te,G)&&(ge[G]=te[G])}return ge}function A(ge,_){var te=ge.replace(/\|/g,function(fe,ve,Pe){for(var we=!1,De=ve;--De>=0&&Pe[De]==="\\";)we=!we;return we?"|":" |"}),G=te.split(/ \|/),ie=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;ie<G.length;ie++)G[ie]=G[ie].trim().replace(/\\\|/g,"|");return G}function p(ge,_,te){var G=ge.length;if(G===0)return"";for(var ie=0;ie<G;){var fe=ge.charAt(G-ie-1);if(fe===_&&!te)ie++;else if(fe!==_&&te)ie++;else break}return ge.slice(0,G-ie)}function w(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var te=ge.length,G=0,ie=0;ie<te;ie++)if(ge[ie]==="\\")ie++;else if(ge[ie]===_[0])G++;else if(ge[ie]===_[1]&&(G--,G<0))return ie;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ge,_){if(_<1)return"";for(var te="";_>1;)_&1&&(te+=ge),_>>=1,ge+=ge;return te+ge}function F(ge,_,te,G){var ie=_.href,fe=_.title?S(_.title):null,ve=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Pe={type:"link",raw:te,href:ie,title:fe,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Pe}return{type:"image",raw:te,href:ie,title:fe,text:S(ve)}}function z(ge,_){var te=ge.match(/^(\s+)(?:```)/);if(te===null)return _;var G=te[1];return _.split(`
`).map(function(ie){var fe=ie.match(/^\s+/);if(fe===null)return ie;var ve=fe[0];return ve.length>=G.length?ie.slice(G.length):ie}).join(`
`)}var N=function(){function ge(te){this.options=te||me.defaults}var _=ge.prototype;return _.space=function(G){var ie=this.rules.block.newline.exec(G);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},_.code=function(G){var ie=this.rules.block.code.exec(G);if(ie){var fe=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:p(fe,`
`)}}},_.fences=function(G){var ie=this.rules.block.fences.exec(G);if(ie){var fe=ie[0],ve=z(fe,ie[3]||"");return{type:"code",raw:fe,lang:ie[2]?ie[2].trim():ie[2],text:ve}}},_.heading=function(G){var ie=this.rules.block.heading.exec(G);if(ie){var fe=ie[2].trim();if(/#$/.test(fe)){var ve=p(fe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(fe=ve.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(G){var ie=this.rules.block.hr.exec(G);if(ie)return{type:"hr",raw:ie[0]}},_.blockquote=function(G){var ie=this.rules.block.blockquote.exec(G);if(ie){var fe=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(G){var ie=this.rules.block.list.exec(G);if(ie){var fe,ve,Pe,we,De,B,Q,ee,q,oe,he,Le,je=ie[1].trim(),He=je.length>1,Je={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Le=!1,!(!(ie=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=ie[0],G=G.substring(fe.length),ee=ie[2].split(`
`,1)[0],q=G.split(`
`,1)[0],this.options.pedantic?(we=2,he=ee.trimLeft()):(we=ie[2].search(/[^ ]/),we=we>4?1:we,he=ee.slice(we),we+=ie[1].length),B=!1,!ee&&/^ *$/.test(q)&&(fe+=q+`
`,G=G.substring(q.length+1),Le=!0),!Le)for(var ct=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),Ae=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");G&&(oe=G.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Ae.test(ee)||ct.test(ee)||ot.test(G)));){if(ee.search(/[^ ]/)>=we||!ee.trim())he+=`
`+ee.slice(we);else if(!B)he+=`
`+ee;else break;!B&&!ee.trim()&&(B=!0),fe+=oe+`
`,G=G.substring(oe.length+1)}Je.loose||(Q?Je.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(he),ve&&(Pe=ve[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:fe,task:!!ve,checked:Pe,loose:!1,text:he}),Je.raw+=fe}Je.items[Je.items.length-1].raw=fe.trimRight(),Je.items[Je.items.length-1].text=he.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(De=0;De<ze;De++){this.lexer.state.top=!1,Je.items[De].tokens=this.lexer.blockTokens(Je.items[De].text,[]);var Re=Je.items[De].tokens.filter(function(ne){return ne.type==="space"}),Xe=Re.every(function(ne){for(var ae=ne.raw.split(""),Ie=0,qe=I(ae),Ye;!(Ye=qe()).done;){var nt=Ye.value;if(nt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Je.loose&&Re.length&&Xe&&(Je.loose=!0,Je.items[De].loose=!0)}return Je}},_.html=function(G){var ie=this.rules.block.html.exec(G);if(ie){var fe={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);fe.type="paragraph",fe.text=ve,fe.tokens=this.lexer.inline(ve)}return fe}},_.def=function(G){var ie=this.rules.block.def.exec(G);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var fe=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:ie[0],href:ie[2],title:ie[3]}}},_.table=function(G){var ie=this.rules.block.table.exec(G);if(ie){var fe={type:"table",header:A(ie[1]).map(function(Q){return{text:Q}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ie[0];var ve=fe.align.length,Pe,we,De,B;for(Pe=0;Pe<ve;Pe++)/^ *-+: *$/.test(fe.align[Pe])?fe.align[Pe]="right":/^ *:-+: *$/.test(fe.align[Pe])?fe.align[Pe]="center":/^ *:-+ *$/.test(fe.align[Pe])?fe.align[Pe]="left":fe.align[Pe]=null;for(ve=fe.rows.length,Pe=0;Pe<ve;Pe++)fe.rows[Pe]=A(fe.rows[Pe],fe.header.length).map(function(Q){return{text:Q}});for(ve=fe.header.length,we=0;we<ve;we++)fe.header[we].tokens=this.lexer.inline(fe.header[we].text);for(ve=fe.rows.length,we=0;we<ve;we++)for(B=fe.rows[we],De=0;De<B.length;De++)B[De].tokens=this.lexer.inline(B[De].text);return fe}}},_.lheading=function(G){var ie=this.rules.block.lheading.exec(G);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},_.paragraph=function(G){var ie=this.rules.block.paragraph.exec(G);if(ie){var fe=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(G){var ie=this.rules.block.text.exec(G);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},_.escape=function(G){var ie=this.rules.inline.escape.exec(G);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},_.tag=function(G){var ie=this.rules.inline.tag.exec(G);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},_.link=function(G){var ie=this.rules.inline.link.exec(G);if(ie){var fe=ie[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ve=p(fe.slice(0,-1),"\\");if((fe.length-ve.length)%2===0)return}else{var Pe=w(ie[2],"()");if(Pe>-1){var we=ie[0].indexOf("!")===0?5:4,De=we+ie[1].length+Pe;ie[2]=ie[2].substring(0,Pe),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var B=ie[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ee&&(B=ee[1],Q=ee[3])}else Q=ie[3]?ie[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(fe)?B=B.slice(1):B=B.slice(1,-1)),F(ie,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},_.reflink=function(G,ie){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var ve=(fe[2]||fe[1]).replace(/\s+/g," ");if(ve=ie[ve.toLowerCase()],!ve||!ve.href){var Pe=fe[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return F(fe,ve,fe[0],this.lexer)}},_.emStrong=function(G,ie,fe){fe===void 0&&(fe="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=ve[1]||ve[2]||"";if(!Pe||Pe&&(fe===""||this.rules.inline.punctuation.exec(fe))){var we=ve[0].length-1,De,B,Q=we,ee=0,q=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ie=ie.slice(-1*G.length+we);(ve=q.exec(ie))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(B=De.length,ve[3]||ve[4]){Q+=B;continue}else if((ve[5]||ve[6])&&we%3&&!((we+B)%3)){ee+=B;continue}if(Q-=B,!(Q>0)){if(B=Math.min(B,B+Q+ee),Math.min(we,B)%2){var oe=G.slice(1,we+ve.index+B);return{type:"em",raw:G.slice(0,we+ve.index+B+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var he=G.slice(2,we+ve.index+B-1);return{type:"strong",raw:G.slice(0,we+ve.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},_.codespan=function(G){var ie=this.rules.inline.code.exec(G);if(ie){var fe=ie[2].replace(/\n/g," "),ve=/[^ ]/.test(fe),Pe=/^ /.test(fe)&&/ $/.test(fe);return ve&&Pe&&(fe=fe.substring(1,fe.length-1)),fe=S(fe,!0),{type:"codespan",raw:ie[0],text:fe}}},_.br=function(G){var ie=this.rules.inline.br.exec(G);if(ie)return{type:"br",raw:ie[0]}},_.del=function(G){var ie=this.rules.inline.del.exec(G);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},_.autolink=function(G,ie){var fe=this.rules.inline.autolink.exec(G);if(fe){var ve,Pe;return fe[2]==="@"?(ve=S(this.options.mangle?ie(fe[1]):fe[1]),Pe="mailto:"+ve):(ve=S(fe[1]),Pe=ve),{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},_.url=function(G,ie){var fe;if(fe=this.rules.inline.url.exec(G)){var ve,Pe;if(fe[2]==="@")ve=S(this.options.mangle?ie(fe[0]):fe[0]),Pe="mailto:"+ve;else{var we;do we=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(we!==fe[0]);ve=S(fe[0]),fe[1]==="www."?Pe="http://"+ve:Pe=ve}return{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},_.inlineText=function(G,ie){var fe=this.rules.inline.text.exec(G);if(fe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]:ve=S(this.options.smartypants?ie(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",j._label).getRegex(),M.nolink=i(M.nolink).replace("ref",j._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=k({},M),M.pedantic=k({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=k({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=k({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ge){var _="",te,G,ie=ge.length;for(te=0;te<ie;te++)G=ge.charCodeAt(te),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var Y=function(){function ge(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||me.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:M.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=M.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=M.breaks:G.inline=M.gfm),this.tokenizer.rules=G}ge.lex=function(G,ie){var fe=new ge(ie);return fe.lex(G)},ge.lexInline=function(G,ie){var fe=new ge(ie);return fe.inlineTokens(G)};var _=ge.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},_.blockTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,q){return ee+"    ".repeat(q.length)});for(var ve,Pe,we,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(ve=Q.call({lexer:fe},G,ie))?(G=G.substring(ve.raw.length),ie.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(we=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),q=void 0;fe.options.extensions.startBlock.forEach(function(oe){q=oe.call({lexer:this},ee),typeof q=="number"&&q>=0&&(Q=Math.min(Q,q))}),Q<1/0&&Q>=0&&(we=G.substring(0,Q+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(we))){Pe=ie[ie.length-1],De&&Pe.type==="paragraph"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve),De=we.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,ie},_.inline=function(G,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:G,tokens:ie}),ie},_.inlineTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]);var ve,Pe,we,De=G,B,Q,ee;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,B.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(ve=he.call({lexer:fe},G,ie))?(G=G.substring(ve.raw.length),ie.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(ve=this.tokenizer.emStrong(G,De,ee)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.autolink(G,U)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,U))){G=G.substring(ve.raw.length),ie.push(ve);continue}if(we=G,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Le=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Le),typeof je=="number"&&je>=0&&(he=Math.min(he,je))}),he<1/0&&he>=0&&(we=G.substring(0,he+1))}(),ve=this.tokenizer.inlineText(we,O)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ee=ve.raw.slice(-1)),Q=!0,Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(G){var oe="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return ie},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:M}}}]),ge}(),le=function(){function ge(te){this.options=te||me.defaults}var _=ge.prototype;return _.code=function(G,ie,fe){var ve=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(G,ve);Pe!=null&&Pe!==G&&(fe=!0,G=Pe)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+S(ve,!0)+'">'+(fe?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:S(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,ie,fe,ve){if(this.options.headerIds){var Pe=this.options.headerPrefix+ve.slug(fe);return"<h"+ie+' id="'+Pe+'">'+G+"</h"+ie+`>
`}return"<h"+ie+">"+G+"</h"+ie+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,ie,fe){var ve=ie?"ol":"ul",Pe=ie&&fe!==1?' start="'+fe+'"':"";return"<"+ve+Pe+`>
`+G+"</"+ve+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ie+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,ie){var fe=ie.header?"th":"td",ve=ie.align?"<"+fe+' align="'+ie.align+'">':"<"+fe+">";return ve+G+("</"+fe+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<a href="'+S(G)+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=">"+fe+"</a>",ve},_.image=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<img src="'+G+'" alt="'+fe+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=this.options.xhtml?"/>":">",ve},_.text=function(G){return G},ge}(),Z=function(){function ge(){}var _=ge.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,ie,fe){return""+fe},_.image=function(G,ie,fe){return""+fe},_.br=function(){return""},ge}(),J=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,ie){var fe=G,ve=0;if(this.seen.hasOwnProperty(fe)){ve=this.seen[G];do ve++,fe=G+"-"+ve;while(this.seen.hasOwnProperty(fe))}return ie||(this.seen[G]=ve,this.seen[fe]=0),fe},_.slug=function(G,ie){ie===void 0&&(ie={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,ie.dryrun)},ge}(),X=function(){function ge(te){this.options=te||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new J}ge.parse=function(G,ie){var fe=new ge(ie);return fe.parse(G)},ge.parseInline=function(G,ie){var fe=new ge(ie);return fe.parseInline(G)};var _=ge.prototype;return _.parse=function(G,ie){ie===void 0&&(ie=!0);var fe="",ve,Pe,we,De,B,Q,ee,q,oe,he,Le,je,He,Je,_e,ct,ot,rt,Ae,ze=G.length;for(ve=0;ve<ze;ve++){if(he=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Ae=this.options.extensions.renderers[he.type].call({parser:this},he),Ae!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){fe+=Ae||"";continue}switch(he.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(he.tokens),he.depth,f(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(q="",ee="",De=he.header.length,Pe=0;Pe<De;Pe++)ee+=this.renderer.tablecell(this.parseInline(he.header[Pe].tokens),{header:!0,align:he.align[Pe]});for(q+=this.renderer.tablerow(ee),oe="",De=he.rows.length,Pe=0;Pe<De;Pe++){for(Q=he.rows[Pe],ee="",B=Q.length,we=0;we<B;we++)ee+=this.renderer.tablecell(this.parseInline(Q[we].tokens),{header:!1,align:he.align[we]});oe+=this.renderer.tablerow(ee)}fe+=this.renderer.table(q,oe);continue}case"blockquote":{oe=this.parse(he.tokens),fe+=this.renderer.blockquote(oe);continue}case"list":{for(Le=he.ordered,je=he.start,He=he.loose,De=he.items.length,oe="",Pe=0;Pe<De;Pe++)_e=he.items[Pe],ct=_e.checked,ot=_e.task,Je="",_e.task&&(rt=this.renderer.checkbox(ct),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Je,ot,ct);fe+=this.renderer.list(oe,Le,je);continue}case"html":{fe+=this.renderer.html(he.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(oe=he.tokens?this.parseInline(he.tokens):he.text;ve+1<ze&&G[ve+1].type==="text";)he=G[++ve],oe+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);fe+=ie?this.renderer.paragraph(oe):oe;continue}default:{var Re='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return fe},_.parseInline=function(G,ie){ie=ie||this.renderer;var fe="",ve,Pe,we,De=G.length;for(ve=0;ve<De;ve++){if(Pe=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(we=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){fe+=we||"";continue}switch(Pe.type){case"escape":{fe+=ie.text(Pe.text);break}case"html":{fe+=ie.html(Pe.text);break}case"link":{fe+=ie.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,ie));break}case"image":{fe+=ie.image(Pe.href,Pe.title,Pe.text);break}case"strong":{fe+=ie.strong(this.parseInline(Pe.tokens,ie));break}case"em":{fe+=ie.em(this.parseInline(Pe.tokens,ie));break}case"codespan":{fe+=ie.codespan(Pe.text);break}case"br":{fe+=ie.br();break}case"del":{fe+=ie.del(this.parseInline(Pe.tokens,ie));break}case"text":{fe+=ie.text(Pe.text);break}default:{var B='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return fe},ge}();function ue(ge,_,te){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(te=_,_=null),_=k({},ue.defaults,_||{}),E(_),te){var G=_.highlight,ie;try{ie=Y.lex(ge,_)}catch(De){return te(De)}var fe=function(B){var Q;if(!B)try{_.walkTokens&&ue.walkTokens(ie,_.walkTokens),Q=X.parse(ie,_)}catch(ee){B=ee}return _.highlight=G,B?te(B):te(null,Q)};if(!G||G.length<3||(delete _.highlight,!ie.length))return fe();var ve=0;ue.walkTokens(ie,function(De){De.type==="code"&&(ve++,setTimeout(function(){G(De.text,De.lang,function(B,Q){if(B)return fe(B);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),ve--,ve===0&&fe()})},0))}),ve===0&&fe();return}function Pe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(De.message+"",!0)+"</pre>";throw De}try{var we=Y.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(ue.walkTokens(we,_.walkTokens)).then(function(){return X.parse(we,_)}).catch(Pe);ue.walkTokens(we,_.walkTokens)}return X.parse(we,_)}catch(De){Pe(De)}}ue.options=ue.setOptions=function(ge){return k(ue.defaults,ge),b(ue.defaults),ue},ue.getDefaults=R,ue.defaults=me.defaults,ue.use=function(){for(var ge=arguments.length,_=new Array(ge),te=0;te<ge;te++)_[te]=arguments[te];var G=k.apply(void 0,[{}].concat(_)),ie=ue.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(ve){if(ve.extensions&&(fe=!0,ve.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var De=ie.renderers?ie.renderers[we.name]:null;De?ie.renderers[we.name]=function(){for(var B=arguments.length,Q=new Array(B),ee=0;ee<B;ee++)Q[ee]=arguments[ee];var q=we.renderer.apply(this,Q);return q===!1&&(q=De.apply(this,Q)),q}:ie.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[we.level]?ie[we.level].unshift(we.tokenizer):ie[we.level]=[we.tokenizer],we.start&&(we.level==="block"?ie.startBlock?ie.startBlock.push(we.start):ie.startBlock=[we.start]:we.level==="inline"&&(ie.startInline?ie.startInline.push(we.start):ie.startInline=[we.start]))}we.childTokens&&(ie.childTokens[we.name]=we.childTokens)})),ve.renderer&&function(){var we=ue.defaults.renderer||new le,De=function(ee){var q=we[ee];we[ee]=function(){for(var oe=arguments.length,he=new Array(oe),Le=0;Le<oe;Le++)he[Le]=arguments[Le];var je=ve.renderer[ee].apply(we,he);return je===!1&&(je=q.apply(we,he)),je}};for(var B in ve.renderer)De(B);G.renderer=we}(),ve.tokenizer&&function(){var we=ue.defaults.tokenizer||new N,De=function(ee){var q=we[ee];we[ee]=function(){for(var oe=arguments.length,he=new Array(oe),Le=0;Le<oe;Le++)he[Le]=arguments[Le];var je=ve.tokenizer[ee].apply(we,he);return je===!1&&(je=q.apply(we,he)),je}};for(var B in ve.tokenizer)De(B);G.tokenizer=we}(),ve.walkTokens){var Pe=ue.defaults.walkTokens;G.walkTokens=function(we){var De=[];return De.push(ve.walkTokens.call(this,we)),Pe&&(De=De.concat(Pe.call(this,we))),De}}fe&&(G.extensions=ie),ue.setOptions(G)})},ue.walkTokens=function(ge,_){for(var te=[],G=function(){var Pe=fe.value;switch(te=te.concat(_.call(ue,Pe)),Pe.type){case"table":{for(var we=I(Pe.header),De;!(De=we()).done;){var B=De.value;te=te.concat(ue.walkTokens(B.tokens,_))}for(var Q=I(Pe.rows),ee;!(ee=Q()).done;)for(var q=ee.value,oe=I(q),he;!(he=oe()).done;){var Le=he.value;te=te.concat(ue.walkTokens(Le.tokens,_))}break}case"list":{te=te.concat(ue.walkTokens(Pe.items,_));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Pe.type]?ue.defaults.extensions.childTokens[Pe.type].forEach(function(je){te=te.concat(ue.walkTokens(Pe[je],_))}):Pe.tokens&&(te=te.concat(ue.walkTokens(Pe.tokens,_)))}},ie=I(ge),fe;!(fe=ie()).done;)G();return te},ue.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=k({},ue.defaults,_||{}),E(_);try{var te=Y.lexInline(ge,_);return _.walkTokens&&ue.walkTokens(te,_.walkTokens),X.parseInline(te,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},ue.Parser=X,ue.parser=X.parse,ue.Renderer=le,ue.TextRenderer=Z,ue.Lexer=Y,ue.lexer=Y.lex,ue.Tokenizer=N,ue.Slugger=J,ue.parse=ue;var x=ue.options,be=ue.setOptions,ce=ue.use,K=ue.walkTokens,V=ue.parseInline,re=ue,ye=X.parse,de=Y.lex;me.Lexer=Y,me.Parser=X,me.Renderer=le,me.Slugger=J,me.TextRenderer=Z,me.Tokenizer=N,me.getDefaults=R,me.lexer=de,me.marked=ue,me.options=x,me.parse=re,me.parseInline=V,me.parser=ye,me.setOptions=be,me.use=ce,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function D(l){const f=I(l);if(f&&f.length>0)return new Uint32Array(f)}e.$Rj=D;let T=0;const g=new Uint32Array(10);function I(l){if(T=0,R(l,C,4352),T>0||(R(l,m,4449),T>0)||(R(l,v,4520),T>0)||(R(l,S,12593),T))return g.subarray(0,T);if(l>=44032&&l<=55203){const f=l-44032,o=f%588,i=Math.floor(f/588),r=Math.floor(o/28),n=o%28-1;if(i<C.length?R(i,C,0):4352+i-12593<S.length&&R(4352+i,S,12593),r<m.length?R(r,m,0):4449+r-12593<S.length&&R(4449+r-12593,S,12593),n>=0&&(n<v.length?R(n,v,0):4520+n-12593<S.length&&R(4520+n-12593,S,12593)),T>0)return g.subarray(0,T)}}function R(l,f,o){l>=o&&l<o+f.length&&b(f[l-o])}function b(l){l!==0&&(g[T++]=l&255,l>>8&&(g[T++]=l>>8&255),l>>16&&(g[T++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(y||(y={}));var L;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(L||(L={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const T=new D.$Dc(1e4);function g(y){return $(y,"NFC",T)}e.$Gl=g;const I=new D.$Dc(1e4);function R(y){return $(y,"NFD",I)}e.$Hl=R;const b=/[^\u0000-\u0080]/;function $(y,L,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(L):v=y,C.set(y,v),v}e.$Il=function(){const y=/[\u0300-\u036f]/g;return function(L){return R(L).replace(y,"")}}()}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$7l=D;function T(b,$){return($+b%$)%$}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=I;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=R}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function R($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(g+R.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:me)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return me[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(T,g,I){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:I})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var R in T)D.d(I,R,function(b){return T[b]}.bind(null,R));return I},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(T){var g;e=me.exports=ce,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,L=y++;$[L]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[L]+")\\.("+$[L]+")\\.("+$[L]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=y++;$[l]="(?:"+$[L]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var o=y++;$[o]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var r=y++;$[r]="[0-9A-Za-z-]+";var n=y++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var c=y++,t="v?"+$[v]+$[o]+"?"+$[n]+"?";$[c]="^"+t+"$";var u="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=y++;$[s]="^"+u+"$";var h=y++;$[h]="((?:<|>)?=?)";var a=y++;$[a]=$[C]+"|x|X|\\*";var d=y++;$[d]=$[L]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[d]+")(?:\\.("+$[d]+")(?:\\.("+$[d]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var A=y++;$[A]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var p=y++;$[p]="^"+$[h]+"\\s*"+$[k]+"$";var w=y++;$[w]="^"+$[h]+"\\s*"+$[A]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;$[P]="(?:~>?)";var F=y++;$[F]="(\\s*)"+$[P]+"\\s+",b[F]=new RegExp($[F],"g");var z=y++;$[z]="^"+$[P]+$[k]+"$";var N=y++;$[N]="^"+$[P]+$[A]+"$";var j=y++;$[j]="(?:\\^)";var M=y++;$[M]="(\\s*)"+$[j]+"\\s+",b[M]=new RegExp($[M],"g");var O=y++;$[O]="^"+$[j]+$[k]+"$";var U=y++;$[U]="^"+$[j]+$[A]+"$";var Y=y++;$[Y]="^"+$[h]+"\\s*("+u+")$|^$";var le=y++;$[le]="^"+$[h]+"\\s*("+t+")$|^$";var Z=y++;$[Z]="(\\s*)"+$[h]+"\\s*("+u+"|"+$[k]+")",b[Z]=new RegExp($[Z],"g");var J=y++;$[J]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var X=y++;$[X]="^\\s*("+$[A]+")\\s+-\\s+("+$[A]+")\\s*$";var ue=y++;$[ue]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)g(x,$[x]),b[x]||(b[x]=new RegExp($[x]));function be(q,oe){if(q instanceof ce)return q;if(typeof q!="string"||q.length>I||!(oe?b[s]:b[c]).test(q))return null;try{return new ce(q,oe)}catch{return null}}function ce(q,oe){if(q instanceof ce){if(q.loose===oe)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof ce))return new ce(q,oe);g("SemVer",q,oe),this.loose=oe;var he=q.trim().match(oe?b[s]:b[c]);if(!he)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<R)return je}return Le}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=be,e.valid=function(q,oe){var he=be(q,oe);return he?he.version:null},e.clean=function(q,oe){var he=be(q.trim().replace(/^[=v]+/,""),oe);return he?he.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(q){return g("SemVer.compare",this.version,this.loose,q),q instanceof ce||(q=new ce(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ce.prototype.compareMain=function(q){return q instanceof ce||(q=new ce(q,this.loose)),V(this.major,q.major)||V(this.minor,q.minor)||V(this.patch,q.patch)},ce.prototype.comparePre=function(q){if(q instanceof ce||(q=new ce(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var oe=0;do{var he=this.prerelease[oe],Le=q.prerelease[oe];if(g("prerelease compare",oe,he,Le),he===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(he===void 0)return-1;if(he!==Le)return V(he,Le)}while(++oe)},ce.prototype.inc=function(q,oe){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,oe,he,Le){typeof he=="string"&&(Le=he,he=void 0);try{return new ce(q,he).inc(oe,Le).version}catch{return null}},e.diff=function(q,oe){if(ge(q,oe))return null;var he=be(q),Le=be(oe);if(he.prerelease.length||Le.prerelease.length){for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Le[je])return je},e.compareIdentifiers=V;var K=/^[0-9]+$/;function V(q,oe){var he=K.test(q),Le=K.test(oe);return he&&Le&&(q=+q,oe=+oe),he&&!Le?-1:Le&&!he?1:q<oe?-1:q>oe?1:0}function re(q,oe,he){return new ce(q,he).compare(new ce(oe,he))}function ye(q,oe,he){return re(q,oe,he)>0}function de(q,oe,he){return re(q,oe,he)<0}function ge(q,oe,he){return re(q,oe,he)===0}function _(q,oe,he){return re(q,oe,he)!==0}function te(q,oe,he){return re(q,oe,he)>=0}function G(q,oe,he){return re(q,oe,he)<=0}function ie(q,oe,he,Le){var je;switch(oe){case"===":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q===he;break;case"!==":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q!==he;break;case"":case"=":case"==":je=ge(q,he,Le);break;case"!=":je=_(q,he,Le);break;case">":je=ye(q,he,Le);break;case">=":je=te(q,he,Le);break;case"<":je=de(q,he,Le);break;case"<=":je=G(q,he,Le);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function fe(q,oe){if(q instanceof fe){if(q.loose===oe)return q;q=q.value}if(!(this instanceof fe))return new fe(q,oe);g("comparator",q,oe),this.loose=oe,this.parse(q),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(q,oe){return V(oe,q)},e.major=function(q,oe){return new ce(q,oe).major},e.minor=function(q,oe){return new ce(q,oe).minor},e.patch=function(q,oe){return new ce(q,oe).patch},e.compare=re,e.compareLoose=function(q,oe){return re(q,oe,!0)},e.rcompare=function(q,oe,he){return re(oe,q,he)},e.sort=function(q,oe){return q.sort(function(he,Le){return e.compare(he,Le,oe)})},e.rsort=function(q,oe){return q.sort(function(he,Le){return e.rcompare(he,Le,oe)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=_,e.gte=te,e.lte=G,e.cmp=ie,e.Comparator=fe;var ve={};function Pe(q,oe){if(q instanceof Pe)return q.loose===oe?q:new Pe(q.raw,oe);if(q instanceof fe)return new Pe(q.value,oe);if(!(this instanceof Pe))return new Pe(q,oe);if(this.loose=oe,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function we(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,oe,he,Le,je,He,Je,_e,ct,ot,rt,Ae,ze){return((oe=we(he)?"":we(Le)?">="+he+".0.0":we(je)?">="+he+"."+Le+".0":">="+oe)+" "+(_e=we(ct)?"":we(ot)?"<"+(+ct+1)+".0.0":we(rt)?"<"+ct+"."+(+ot+1)+".0":Ae?"<="+ct+"."+ot+"."+rt+"-"+Ae:"<="+_e)).trim()}function B(q,oe){for(var he=0;he<q.length;he++)if(!q[he].test(oe))return!1;if(oe.prerelease.length){for(he=0;he<q.length;he++)if(g(q[he].semver),q[he].semver!==ve&&q[he].semver.prerelease.length>0){var Le=q[he].semver;if(Le.major===oe.major&&Le.minor===oe.minor&&Le.patch===oe.patch)return!0}return!1}return!0}function Q(q,oe,he){try{oe=new Pe(oe,he)}catch{return!1}return oe.test(q)}function ee(q,oe,he,Le){var je,He,Je,_e,ct;switch(q=new ce(q,Le),oe=new Pe(oe,Le),he){case">":je=ye,He=G,Je=de,_e=">",ct=">=";break;case"<":je=de,He=te,Je=ye,_e="<",ct="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(q,oe,Le))return!1;for(var ot=0;ot<oe.set.length;++ot){var rt=oe.set[ot],Ae=null,ze=null;if(rt.forEach(function(Re){Re.semver===ve&&(Re=new fe(">=0.0.0")),Ae=Ae||Re,ze=ze||Re,je(Re.semver,Ae.semver,Le)?Ae=Re:Je(Re.semver,ze.semver,Le)&&(ze=Re)}),Ae.operator===_e||Ae.operator===ct||(!ze.operator||ze.operator===_e)&&He(q,ze.semver)||ze.operator===ct&&Je(q,ze.semver))return!1}return!0}fe.prototype.parse=function(q){var oe=this.loose?b[Y]:b[le],he=q.match(oe);if(!he)throw new TypeError("Invalid comparator: "+q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ce(he[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(q){return g("Comparator.test",q,this.loose),this.semver===ve||(typeof q=="string"&&(q=new ce(q,this.loose)),ie(q,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(q,oe){if(!(q instanceof fe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Pe(q.value,oe),Q(this.value,he,oe);if(q.operator==="")return he=new Pe(this.value,oe),Q(q.semver,he,oe);var Le=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),He=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=ie(this.semver,"<",q.semver,oe)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),ct=ie(this.semver,">",q.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Le||je||He&&Je||_e||ct},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(q){var oe=this.loose;q=q.trim(),g("range",q,oe);var he=oe?b[X]:b[J];q=q.replace(he,De),g("hyphen replace",q),q=q.replace(b[Z],"$1$2$3"),g("comparator trim",q,b[Z]),q=(q=(q=q.replace(b[F],"$1~")).replace(b[M],"$1^")).split(/\s+/).join(" ");var Le=oe?b[Y]:b[le],je=q.split(" ").map(function(He){return function(Je,_e){return g("comp",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,ze){g("caret",Ae,ze);var Re=ze?b[U]:b[O];return Ae.replace(Re,function(Xe,ne,ae,Ie,qe){var Ye;return g("caret",Ae,Xe,ne,ae,Ie,qe),we(ne)?Ye="":we(ae)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":we(Ie)?Ye=ne==="0"?">="+ne+"."+ae+".0 <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+".0 <"+(+ne+1)+".0.0":qe?(g("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=ne==="0"?ae==="0"?">="+ne+"."+ae+"."+Ie+qe+" <"+ne+"."+ae+"."+(+Ie+1):">="+ne+"."+ae+"."+Ie+qe+" <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+"."+Ie+qe+" <"+(+ne+1)+".0.0"):(g("no pr"),Ye=ne==="0"?ae==="0"?">="+ne+"."+ae+"."+Ie+" <"+ne+"."+ae+"."+(+Ie+1):">="+ne+"."+ae+"."+Ie+" <"+ne+"."+(+ae+1)+".0":">="+ne+"."+ae+"."+Ie+" <"+(+ne+1)+".0.0"),g("caret return",Ye),Ye})}(rt,ot)}).join(" ")}(Je,_e),g("caret",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,ze){var Re=ze?b[N]:b[z];return Ae.replace(Re,function(Xe,ne,ae,Ie,qe){var Ye;return g("tilde",Ae,Xe,ne,ae,Ie,qe),we(ne)?Ye="":we(ae)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":we(Ie)?Ye=">="+ne+"."+ae+".0 <"+ne+"."+(+ae+1)+".0":qe?(g("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=">="+ne+"."+ae+"."+Ie+qe+" <"+ne+"."+(+ae+1)+".0"):Ye=">="+ne+"."+ae+"."+Ie+" <"+ne+"."+(+ae+1)+".0",g("tilde return",Ye),Ye})}(rt,ot)}).join(" ")}(Je,_e),g("tildes",Je),Je=function(ct,ot){return g("replaceXRanges",ct,ot),ct.split(/\s+/).map(function(rt){return function(Ae,ze){Ae=Ae.trim();var Re=ze?b[w]:b[p];return Ae.replace(Re,function(Xe,ne,ae,Ie,qe,Ye){g("xRange",Ae,Xe,ne,ae,Ie,qe,Ye);var nt=we(ae),it=nt||we(Ie),Oe=it||we(qe);return ne==="="&&Oe&&(ne=""),nt?Xe=ne===">"||ne==="<"?"<0.0.0":"*":ne&&Oe?(it&&(Ie=0),Oe&&(qe=0),ne===">"?(ne=">=",it?(ae=+ae+1,Ie=0,qe=0):Oe&&(Ie=+Ie+1,qe=0)):ne==="<="&&(ne="<",it?ae=+ae+1:Ie=+Ie+1),Xe=ne+ae+"."+Ie+"."+qe):it?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Oe&&(Xe=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0"),g("xRange return",Xe),Xe})}(rt,ot)}).join(" ")}(Je,_e),g("xrange",Je),Je=function(ct,ot){return g("replaceStars",ct,ot),ct.trim().replace(b[ue],"")}(Je,_e),g("stars",Je),Je}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Le)})),je=je.map(function(He){return new fe(He,oe)})},Pe.prototype.intersects=function(q,oe){if(!(q instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Le){return q.set.some(function(je){return je.every(function(He){return Le.intersects(He,oe)})})})})},e.toComparators=function(q,oe){return new Pe(q,oe).set.map(function(he){return he.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ce(q,this.loose));for(var oe=0;oe<this.set.length;oe++)if(B(this.set[oe],q))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(q,oe,he){var Le=null,je=null;try{var He=new Pe(oe,he)}catch{return null}return q.forEach(function(Je){He.test(Je)&&(Le&&je.compare(Je)!==-1||(je=new ce(Le=Je,he)))}),Le},e.minSatisfying=function(q,oe,he){var Le=null,je=null;try{var He=new Pe(oe,he)}catch{return null}return q.forEach(function(Je){He.test(Je)&&(Le&&je.compare(Je)!==1||(je=new ce(Le=Je,he)))}),Le},e.validRange=function(q,oe){try{return new Pe(q,oe).range||"*"}catch{return null}},e.ltr=function(q,oe,he){return ee(q,oe,"<",he)},e.gtr=function(q,oe,he){return ee(q,oe,">",he)},e.outside=ee,e.prerelease=function(q,oe){var he=be(q,oe);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(q,oe,he){return q=new Pe(q,he),oe=new Pe(oe,he),q.intersects(oe)},e.coerce=function(q){if(q instanceof ce)return q;if(typeof q!="string")return null;var oe=q.match(b[E]);return oe==null?null:be((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(me,e){var D,T,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var $,y=[],L=!1,C=-1;function m(){L&&$&&(L=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!L){var f=b(m);L=!0;for(var o=y.length;o;){for($=y,y=[];++C<o;)$&&$[C].run();C=-1,o=y.length}$=null,L=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(f)}}function S(f,o){this.fun=f,this.array=o}function l(){}g.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new S(f,o)),y.length!==1||L||b(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=l,g.addListener=l,g.once=l,g.off=l,g.removeListener=l,g.removeAllListeners=l,g.emit=l,g.prependListener=l,g.prependOnceListener=l,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(I){return new T(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=T}),define(ke[4],Se([1,0,14,74,3,75,38]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const b=!1,$=!1;var y;(function(p){p.None=()=>g.$Tc.None;function w(ie){if($){const{onDidAddListener:fe}=ie,ve=S.create();let Pe=0;ie.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function E(ie,fe){return le(ie,()=>{},0,void 0,!0,void 0,fe)}p.defer=E;function P(ie){return(fe,ve=null,Pe)=>{let we=!1,De;return De=ie(B=>{if(!we)return De?De.dispose():we=!0,fe.call(ve,B)},null,Pe),we&&De.dispose(),De}}p.once=P;function F(ie,fe,ve){return U((Pe,we=null,De)=>ie(B=>Pe.call(we,fe(B)),null,De),ve)}p.map=F;function z(ie,fe,ve){return U((Pe,we=null,De)=>ie(B=>{fe(B),Pe.call(we,B)},null,De),ve)}p.forEach=z;function N(ie,fe,ve){return U((Pe,we=null,De)=>ie(B=>fe(B)&&Pe.call(we,B),null,De),ve)}p.filter=N;function j(ie){return ie}p.signal=j;function M(...ie){return(fe,ve=null,Pe)=>{const we=(0,g.$Qc)(...ie.map(De=>De(B=>fe.call(ve,B))));return Y(we,Pe)}}p.any=M;function O(ie,fe,ve,Pe){let we=ve;return F(ie,De=>(we=fe(we,De),we),Pe)}p.reduce=O;function U(ie,fe){let ve;const Pe={onWillAddFirstListener(){ve=ie(we.fire,we)},onDidRemoveLastListener(){ve?.dispose()}};fe||w(Pe);const we=new r(Pe);return fe?.add(we),we.event}function Y(ie,fe){return fe instanceof Array?fe.push(ie):fe&&fe.add(ie),ie}function le(ie,fe,ve=100,Pe=!1,we=!1,De,B){let Q,ee,q,oe=0,he;const Le={leakWarningThreshold:De,onWillAddFirstListener(){Q=ie(He=>{oe++,ee=fe(ee,He),Pe&&!q&&(je.fire(ee),ee=void 0),he=()=>{const Je=ee;ee=void 0,q=void 0,(!Pe||oe>1)&&je.fire(Je),oe=0},typeof ve=="number"?(clearTimeout(q),q=setTimeout(he,ve)):q===void 0&&(q=0,queueMicrotask(he))})},onWillRemoveListener(){we&&oe>0&&he?.()},onDidRemoveLastListener(){he=void 0,Q.dispose()}};B||w(Le);const je=new r(Le);return B?.add(je),je.event}p.debounce=le;function Z(ie,fe=0,ve){return p.debounce(ie,(Pe,we)=>Pe?(Pe.push(we),Pe):[we],fe,void 0,!0,void 0,ve)}p.accumulate=Z;function J(ie,fe=(Pe,we)=>Pe===we,ve){let Pe=!0,we;return N(ie,De=>{const B=Pe||!fe(De,we);return Pe=!1,we=De,B},ve)}p.latch=J;function X(ie,fe,ve){return[p.filter(ie,fe,ve),p.filter(ie,Pe=>!fe(Pe),ve)]}p.split=X;function ue(ie,fe=!1,ve=[],Pe){let we=ve.slice(),De=ie(ee=>{we?we.push(ee):Q.fire(ee)});Pe&&Pe.add(De);const B=()=>{we?.forEach(ee=>Q.fire(ee)),we=null},Q=new r({onWillAddFirstListener(){De||(De=ie(ee=>Q.fire(ee)),Pe&&Pe.add(De))},onDidAddFirstListener(){we&&(fe?setTimeout(B):B())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Pe&&Pe.add(Q),Q.event}p.buffer=ue;function x(ie,fe){return(Pe,we,De)=>{const B=fe(new ce);return ie(function(Q){const ee=B.evaluate(Q);ee!==be&&Pe.call(we,ee)},void 0,De)}}p.chain=x;const be=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:be),this}reduce(fe,ve){let Pe=ve;return this.f.push(we=>(Pe=fe(Pe,we),Pe)),this}latch(fe=(ve,Pe)=>ve===Pe){let ve=!0,Pe;return this.f.push(we=>{const De=ve||!fe(we,Pe);return ve=!1,Pe=we,De?we:be}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===be)break;return fe}}function K(ie,fe,ve=Pe=>Pe){const Pe=(...Q)=>B.fire(ve(...Q)),we=()=>ie.on(fe,Pe),De=()=>ie.removeListener(fe,Pe),B=new r({onWillAddFirstListener:we,onDidRemoveLastListener:De});return B.event}p.fromNodeEventEmitter=K;function V(ie,fe,ve=Pe=>Pe){const Pe=(...Q)=>B.fire(ve(...Q)),we=()=>ie.addEventListener(fe,Pe),De=()=>ie.removeEventListener(fe,Pe),B=new r({onWillAddFirstListener:we,onDidRemoveLastListener:De});return B.event}p.fromDOMEventEmitter=V;function re(ie){return new Promise(fe=>P(ie)(fe))}p.toPromise=re;function ye(ie){const fe=new r;return ie.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}p.fromPromise=ye;function de(ie,fe,ve){return fe(ve),ie(Pe=>fe(Pe))}p.runAndSubscribe=de;function ge(ie,fe){let ve=null;function Pe(De){ve?.dispose(),ve=new g.$Sc,fe(De,ve)}Pe(void 0);const we=ie(De=>Pe(De));return(0,g.$Rc)(()=>{we.dispose(),ve?.dispose()})}p.runAndSubscribeWithStore=ge;class _{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const Pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||w(Pe),this.emitter=new r(Pe),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ie,fe){return new _(ie,fe).emitter.event}p.fromObservable=te;function G(ie){return(fe,ve,Pe)=>{let we=0,De=!1;const B={beginUpdate(){we++},endUpdate(){we--,we===0&&(ie.reportChanges(),De&&(De=!1,fe.call(ve)))},handlePossibleChange(){},handleChange(){De=!0}};ie.addObserver(B),ie.reportChanges();const Q={dispose(){ie.removeObserver(B)}};return Pe instanceof g.$Sc?Pe.add(Q):Array.isArray(Pe)&&Pe.push(Q),Q}}p.fromObservableLight=G})(y||(e.Event=y={}));class L{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${L.f++}`,L.all.add(this)}start(w){this.g=new R.$Rd,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$Td=L;let C=-1;function m(p){const w=C;return C=p,{dispose(){C=w}}}e.$Ud=m;class v{constructor(w,E=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=E,this.g=0}dispose(){this.f?.clear()}check(w,E){const P=this.threshold;if(P<=0||E<P)return;this.f||(this.f=new Map);const F=this.f.get(w.value)||0;if(this.f.set(w.value,F+1),this.g-=1,this.g<=0){this.g=P*.5;let z,N=0;for(const[j,M]of this.f)(!z||N<M)&&(z=j,N=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${N}):`),console.warn(z)}return()=>{const z=this.f.get(w.value)||0;this.f.set(w.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class f{constructor(w){this.value=w,this.id=l++}}const o=2,i=(p,w)=>{if(p instanceof f)w(p);else for(let E=0;E<p.length;E++){const P=p[E];P&&w(P)}};class r{constructor(w){this.w=0,this.f=w,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const w=this.t;queueMicrotask(()=>{i(w,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,E,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Tc.None;if(this.m)return g.$Tc.None;E&&(w=w.bind(E));const F=new f(w);let z,N;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=S.create(),z=this.g.check(F.stack,this.w+1)),b&&(F.stack=N??S.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Rc)(()=>{z?.(),this.x(F)});return P instanceof g.$Sc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,P=E.indexOf(w);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[P]=void 0;const F=this.u.current===this;if(this.w*o<=E.length){let z=0;for(let N=0;N<E.length;N++)E[N]?E[z++]=E[N]:F&&(this.u.end--,z<this.u.i&&this.u.i--);E.length=z}}y(w,E){if(!w)return;const P=this.f?.onListenerError||D.$1;if(!P){w.value(E);return}try{w.value(E)}catch(F){P(F)}}z(w){const E=w.current.t;for(;w.i<w.end;)this.y(E[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,w);else{const E=this.u;E.enqueue(this,w,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=r;const n=()=>new c;e.$Wd=n;class c{constructor(){this.i=-1,this.end=0}enqueue(w,E,P){this.i=0,this.end=P,this.current=w,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(w,E,P){if(this.t)for(this.h||(this.h=new I.$4c),i(this.t,F=>this.h.push([F.value,w]));this.h.size>0&&!E.isCancellationRequested;){const[F,z]=this.h.shift(),N=[],j={...z,token:E,waitUntil:M=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");P&&(M=P(M,F)),N.push(M)}};try{F(j)}catch(M){(0,D.$1)(M);continue}Object.freeze(N),await Promise.allSettled(N).then(M=>{for(const O of M)O.status==="rejected"&&(0,D.$1)(O.reason)})}}}e.$Xd=t;class u extends r{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new I.$4c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$Yd=u;class s extends u{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$Zd=s;class h extends r{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$1d=h;class a{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const E={event:w,listener:null};this.h.push(E),this.g&&this.m(E);const P=()=>{this.g&&this.o(E);const F=this.h.indexOf(E);this.h.splice(F,1)};return(0,g.$Rc)((0,T.$db)(P))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(E=>this.f.fire(E))}o(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.f.dispose()}}e.$2d=a;class d{constructor(w,E,P,F){this.f=new g.$Sc;const z=this.f.add(new a),N=this.f.add(new g.$3c);function j(M){N.set(M,z.add(F(M)))}for(const M of w)j(M);this.f.add(E(M=>{j(M)})),this.f.add(P(M=>{N.deleteAndDispose(M)})),this.event=z.event}dispose(){this.f.dispose()}}e.$3d=d;class k{constructor(){this.f=[]}wrapEvent(w){return(E,P,F)=>w(z=>{const N=this.f[this.f.length-1];N?N.push(()=>E.call(P,z)):E.call(P,z)},void 0,F)}bufferEvents(w){const E=[];this.f.push(E);const P=w();return this.f.pop(),E.forEach(F=>F()),P}}e.$4d=k;class A{constructor(){this.f=!1,this.g=y.None,this.h=g.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=A}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const T=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$6d=R}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$6d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ee=T;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Fe=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Ge=I}),define(ke[99],Se([1,0,14,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function g(n){const c=n;return c?typeof c.read=="function":!1}e.$7d=g;function I(n){const c=n;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$8d=I;function R(n){const c=n;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$9d=R;function b(n,c){return new $(n,c)}e.$0d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let u;switch(c){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(t);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(n,c){const t=[];let u;for(;(u=n.read())!==null;)t.push(u);return c(t)}e.$$d=y;function L(n,c,t){const u=[];let s;for(;(s=n.read())!==null&&u.length<t;)u.push(s);return s===null&&u.length>0?c(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const h=s;return s=void 0,h}return n.read()}}}e.$_d=L;function C(n,c){return new Promise((t,u)=>{const s=[];m(n,{onData:h=>{c&&s.push(h)},onError:h=>{c?u(h):t(void 0)},onEnd:()=>{t(c?c(s):void 0)}})})}e.$ae=C;function m(n,c,t){n.on("error",u=>{t?.isCancellationRequested||c.onError(u)}),n.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),n.on("data",u=>{t?.isCancellationRequested||c.onData(u)})}e.$be=m;function v(n,c){return new Promise((t,u)=>{const s=new T.$Sc,h=[],a=A=>{if(h.push(A),h.length>c)return s.dispose(),n.pause(),t({stream:n,buffer:h,ended:!1})},d=A=>(s.dispose(),u(A)),k=()=>(s.dispose(),t({stream:n,buffer:h,ended:!0}));s.add((0,T.$Rc)(()=>n.removeListener("error",d))),n.on("error",d),s.add((0,T.$Rc)(()=>n.removeListener("end",k))),n.on("end",k),s.add((0,T.$Rc)(()=>n.removeListener("data",a))),n.on("data",a)})}e.$ce=v;function S(n,c){const t=b(c);return t.end(n),t}e.$de=S;function l(){const n=b(()=>{throw new Error("not supported")});return n.end(),n}e.$ee=l;function f(n){let c=!1;return{read:()=>c?null:(c=!0,n)}}e.$fe=f;function o(n,c,t){const u=b(t);return m(n,{onData:s=>u.write(c.data(s)),onError:s=>u.error(c.error?c.error(s):s),onEnd:()=>u.end()}),u}e.$ge=o;function i(n,c,t){let u=!1;return{read:()=>{const s=c.read();return u?s:(u=!0,s!==null?t([n,s]):n)}}}e.$he=i;function r(n,c,t){let u=!1;const s=b(t);return m(c,{onData:h=>u?s.write(h):(u=!0,s.write(t([n,h]))),onError:h=>s.error(h),onEnd:()=>{u||(u=!0,s.write(n)),s.end()}}),s}e.$ie=r}),define(ke[22],Se([1,0,43,99]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const P=$.alloc(E.length);for(let F=0,z=E.length;F<z;F++)P.buffer[F]=E[F];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let N=0,j=E.length;N<j;N++)P+=E[N].byteLength}const F=$.alloc(P);let z=0;for(let N=0,j=E.length;N<j;N++){const M=E[N];F.set(M,z),z+=M.byteLength}return F}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,P){return new $(this.buffer.subarray(E,P))}set(E,P){if(E instanceof $)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,P){v(this.buffer,E,P)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,P){l(this.buffer,E,P)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,P){o(this.buffer,E,P)}indexOf(E,P=0){return y(this.buffer,E instanceof $?E.buffer:E,P)}}e.$je=$;function y(w,E,P=0){const F=E.byteLength,z=w.byteLength;if(F===0)return 0;if(F===1)return w.indexOf(E[0]);if(F>z-P)return-1;const N=I.value;N.fill(E.length);for(let U=0;U<E.length;U++)N[E[U]]=E.length-U-1;let j=P+E.length-1,M=j,O=-1;for(;j<z;)if(w[j]===E[M]){if(M===0){O=j;break}j--,M--}else j+=Math.max(E.length-M,N[w[j]]),M=E.length-1;return O}e.$ke=y;function L(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0}e.$le=L;function C(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255}e.$me=C;function m(w,E){return w[E]*2**24+w[E+1]*2**16+w[E+2]*2**8+w[E+3]}e.$ne=m;function v(w,E,P){w[P+3]=E,E=E>>>8,w[P+2]=E,E=E>>>8,w[P+1]=E,E=E>>>8,w[P]=E}e.$oe=v;function S(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0|w[E+2]<<16>>>0|w[E+3]<<24>>>0}e.$pe=S;function l(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255,E=E>>>8,w[P+2]=E&255,E=E>>>8,w[P+3]=E&255}e.$qe=l;function f(w,E){return w[E]}e.$re=f;function o(w,E,P){w[P]=E}e.$se=o;function i(w){return T.$$d(w,E=>$.concat(E))}e.$te=i;function r(w){return T.$fe(w)}e.$ue=r;function n(w){return T.$ae(w,E=>$.concat(E))}e.$ve=n;async function c(w){return w.ended?$.concat(w.buffer):$.concat([...w.buffer,await n(w.stream)])}e.$we=c;function t(w){return T.$de(w,E=>$.concat(E))}e.$xe=t;function u(w){return T.$ge(w,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ye=u;function s(w){return T.$0d(E=>$.concat(E),w)}e.$ze=s;function h(w,E){return T.$he(w,E,P=>$.concat(P))}e.$Ae=h;function a(w,E){return T.$ie(w,E,P=>$.concat(P))}e.$Be=a;function d(w){let E=0,P=0,F=0;const z=new Uint8Array(Math.floor(w.length/4*3)),N=M=>{switch(P){case 3:z[F++]=E|M,P=0;break;case 2:z[F++]=E|M>>>2,E=M<<6,P=3;break;case 1:z[F++]=E|M>>>4,E=M<<4,P=2;break;default:E=M<<2,P=1}};for(let M=0;M<w.length;M++){const O=w.charCodeAt(M);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[M]}`)}}const j=F;for(;P>0;)N(0);return $.wrap(z).slice(0,j)}e.$Ce=d;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:w},E=!0,P=!1){const F=P?A:k;let z="";const N=w.byteLength%3;let j=0;for(;j<w.byteLength-N;j+=3){const M=w[j+0],O=w[j+1],U=w[j+2];z+=F[M>>>2],z+=F[(M<<4|O>>>4)&63],z+=F[(O<<2|U>>>6)&63],z+=F[U&63]}if(N===1){const M=w[j+0];z+=F[M>>>2],z+=F[M<<4&63],E&&(z+="==")}else if(N===2){const M=w[j+0],O=w[j+1];z+=F[M>>>2],z+=F[(M<<4|O>>>4)&63],z+=F[O<<2&63],E&&(z+="=")}return z}e.$De=p}),define(ke[12],Se([1,0,162,43]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Je=g;const I=/{(\d+)}/g;function R(Ae,...ze){return ze.length===0?Ae:Ae.replace(I,function(Re,Xe){const ne=parseInt(Xe,10);return isNaN(ne)||ne<0||ne>=ze.length?Re:ze[ne]})}e.$Ke=R;const b=/{([^}]+)}/g;function $(Ae,ze){return Object.keys(ze).length===0?Ae:Ae.replace(b,(Re,Xe)=>ze[Xe]??Re)}e.$Le=$;function y(Ae){return Ae.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.$Me=y;function L(Ae){return Ae.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Ne=L;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=C;function m(Ae,ze){let Re=0;const Xe=ze.charCodeAt(0);for(let ne=Ae.length-1;ne>=0;ne--)Ae.charCodeAt(ne)===Xe&&Re++;return Re}e.$Pe=m;function v(Ae,ze,Re="\u2026"){return Ae.length<=ze?Ae:`${Ae.substr(0,ze)}${Re}`}e.$Qe=v;function S(Ae,ze,Re="\u2026"){if(Ae.length<=ze)return Ae;const Xe=Math.ceil(ze/2)-Re.length/2,ne=Math.floor(ze/2)-Re.length/2;return`${Ae.substr(0,Xe)}${Re}${Ae.substr(Ae.length-ne)}`}e.$Re=S;function l(Ae,ze=" "){const Re=f(Ae,ze);return o(Re,ze)}e.$Se=l;function f(Ae,ze){if(!Ae||!ze)return Ae;const Re=ze.length;if(Re===0||Ae.length===0)return Ae;let Xe=0;for(;Ae.indexOf(ze,Xe)===Xe;)Xe=Xe+Re;return Ae.substring(Xe)}e.$Te=f;function o(Ae,ze){if(!Ae||!ze)return Ae;const Re=ze.length,Xe=Ae.length;if(Re===0||Xe===0)return Ae;let ne=Xe,ae=-1;for(;ae=Ae.lastIndexOf(ze,ne-1),!(ae===-1||ae+Re!==ne);){if(ae===0)return"";ne=ae}return Ae.substring(0,ne)}e.$Ue=o;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=i;function r(Ae){return Ae.replace(/\*/g,"")}e.$We=r;function n(Ae,ze,Re={}){if(!Ae)throw new Error("Cannot create regex from empty string");ze||(Ae=C(Ae)),Re.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Xe="";return Re.global&&(Xe+="g"),Re.matchCase||(Xe+="i"),Re.multiline&&(Xe+="m"),Re.unicode&&(Xe+="u"),new RegExp(Ae,Xe)}e.$Xe=n;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ye=c;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ze=t;function u(Ae){for(let ze=0,Re=Ae.length;ze<Re;ze++){const Xe=Ae.charCodeAt(ze);if(Xe!==32&&Xe!==9)return ze}return-1}e.$1e=u;function s(Ae,ze=0,Re=Ae.length){for(let Xe=ze;Xe<Re;Xe++){const ne=Ae.charCodeAt(Xe);if(ne!==32&&ne!==9)return Ae.substring(ze,Xe)}return Ae.substring(ze,Re)}e.$2e=s;function h(Ae,ze=Ae.length-1){for(let Re=ze;Re>=0;Re--){const Xe=Ae.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Re}return-1}e.$3e=h;function a(Ae,ze,Re){const Xe=[];let ne=0;for(const ae of Ae.matchAll(ze)){if(Xe.push(Ae.slice(ne,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ne=ae.index+ae[0].length,Xe.push(Re(ae[0],...ae.slice(1),ae.index,Ae,ae.groups))}return Xe.push(Ae.slice(ne)),Promise.all(Xe).then(ae=>ae.join(""))}e.$4e=a;function d(Ae,ze){return Ae<ze?-1:Ae>ze?1:0}e.$5e=d;function k(Ae,ze,Re=0,Xe=Ae.length,ne=0,ae=ze.length){for(;Re<Xe&&ne<ae;Re++,ne++){const Ye=Ae.charCodeAt(Re),nt=ze.charCodeAt(ne);if(Ye<nt)return-1;if(Ye>nt)return 1}const Ie=Xe-Re,qe=ae-ne;return Ie<qe?-1:Ie>qe?1:0}e.$6e=k;function A(Ae,ze){return p(Ae,ze,0,Ae.length,0,ze.length)}e.$7e=A;function p(Ae,ze,Re=0,Xe=Ae.length,ne=0,ae=ze.length){for(;Re<Xe&&ne<ae;Re++,ne++){let Ye=Ae.charCodeAt(Re),nt=ze.charCodeAt(ne);if(Ye===nt)continue;if(Ye>=128||nt>=128)return k(Ae.toLowerCase(),ze.toLowerCase(),Re,Xe,ne,ae);E(Ye)&&(Ye-=32),E(nt)&&(nt-=32);const it=Ye-nt;if(it!==0)return it}const Ie=Xe-Re,qe=ae-ne;return Ie<qe?-1:Ie>qe?1:0}e.$8e=p;function w(Ae){return Ae>=48&&Ae<=57}e.$9e=w;function E(Ae){return Ae>=97&&Ae<=122}e.$0e=E;function P(Ae){return Ae>=65&&Ae<=90}e.$$e=P;function F(Ae,ze){return Ae.length===ze.length&&p(Ae,ze)===0}e.$_e=F;function z(Ae,ze){const Re=ze.length;return ze.length>Ae.length?!1:p(Ae,ze,0,Re)===0}e.$af=z;function N(Ae,ze){const Re=Math.min(Ae.length,ze.length);let Xe;for(Xe=0;Xe<Re;Xe++)if(Ae.charCodeAt(Xe)!==ze.charCodeAt(Xe))return Xe;return Re}e.$bf=N;function j(Ae,ze){const Re=Math.min(Ae.length,ze.length);let Xe;const ne=Ae.length-1,ae=ze.length-1;for(Xe=0;Xe<Re;Xe++)if(Ae.charCodeAt(ne-Xe)!==ze.charCodeAt(ae-Xe))return Xe;return Re}e.$cf=j;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$df=M;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$ef=O;function U(Ae,ze){return(Ae-55296<<10)+(ze-56320)+65536}e.$ff=U;function Y(Ae,ze,Re){const Xe=Ae.charCodeAt(Re);if(M(Xe)&&Re+1<ze){const ne=Ae.charCodeAt(Re+1);if(O(ne))return U(Xe,ne)}return Xe}e.$gf=Y;function le(Ae,ze){const Re=Ae.charCodeAt(ze-1);if(O(Re)&&ze>1){const Xe=Ae.charCodeAt(ze-2);if(M(Xe))return U(Xe,Re)}return Re}class Z{get offset(){return this.e}constructor(ze,Re=0){this.c=ze,this.d=ze.length,this.e=Re}setOffset(ze){this.e=ze}prevCodePoint(){const ze=le(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=Y(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$hf=Z;class J{get offset(){return this.c.offset}constructor(ze,Re=0){this.c=new Z(ze,Re)}nextGraphemeLength(){const ze=Le.getInstance(),Re=this.c,Xe=Re.offset;let ne=ze.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const ae=Re.offset,Ie=ze.getGraphemeBreakType(Re.nextCodePoint());if(oe(ne,Ie)){Re.setOffset(ae);break}ne=Ie}return Re.offset-Xe}prevGraphemeLength(){const ze=Le.getInstance(),Re=this.c,Xe=Re.offset;let ne=ze.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const ae=Re.offset,Ie=ze.getGraphemeBreakType(Re.prevCodePoint());if(oe(Ie,ne)){Re.setOffset(ae);break}ne=Ie}return Xe-Re.offset}eol(){return this.c.eol()}}e.$if=J;function X(Ae,ze){return new J(Ae,ze).nextGraphemeLength()}e.$jf=X;function ue(Ae,ze){return new J(Ae,ze).prevGraphemeLength()}e.$kf=ue;function x(Ae,ze){ze>0&&O(Ae.charCodeAt(ze))&&ze--;const Re=ze+X(Ae,ze);return[Re-ue(Ae,Re),Re]}e.$lf=x;function be(Ae){const ze=new J(Ae);let Re=0;for(;!ze.eol();)Re++,ze.nextGraphemeLength();return Re}e.$mf=be;let ce;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(Ae){return ce||(ce=K()),ce.test(Ae)}e.$nf=V;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Ae){return re.test(Ae)}e.$of=ye,e.$pf=/[\u2028\u2029]/;function de(Ae){return e.$pf.test(Ae)}e.$qf=de;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$rf=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$sf=_;function te(Ae,ze,Re=""){const Xe=Ae.trimStart();if(Xe.length<ze)return Xe;const ne=/\b/g;let ae=0;for(;ne.test(Xe)&&!(Xe.length-ne.lastIndex<ze);)ae=ne.lastIndex,ne.lastIndex+=1;return ae===0?Xe:Re+Xe.substring(ae).trimStart()}e.$tf=te;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(Ae){return Ae&&(Ae=Ae.replace(G,"").replace(ie,"")),Ae}e.$uf=fe,e.$vf=String.fromCharCode(65279);function ve(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$wf=ve;function Pe(Ae){return ve(Ae)?Ae.substr(1):Ae}e.$xf=Pe;function we(Ae,ze){if(!Ae||!ze||Ae.length<ze.length)return!1;const Re=ze.length,Xe=Ae.toLowerCase();let ne=0,ae=-1;for(;ne<Re;){const Ie=Xe.indexOf(ze[ne],ae+1);if(Ie<0)return!1;ae=Ie,ne++}return!0}e.$yf=we;function De(Ae,ze=!1){return Ae?(ze&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$zf=De;function B(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$Af=B;function Q(Ae,ze=1){if(ze===0)return"";let Re=-1;do Re=Ae.indexOf(`
`,Re+1),ze--;while(ze>0&&Re>=0);return Re===-1?Ae:(Ae[Re-1]==="\r"&&Re--,Ae.substr(0,Re))}e.$Bf=Q;function ee(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$Cf=ee;function q(Ae){return Le.getInstance().getGraphemeBreakType(Ae)}e.$Df=q;function oe(Ae,ze){return Ae===0?ze!==5&&ze!==7:Ae===2&&ze===3?!1:Ae===4||Ae===2||Ae===3||ze===4||ze===2||ze===3?!0:!(Ae===8&&(ze===8||ze===9||ze===11||ze===12)||(Ae===11||Ae===9)&&(ze===9||ze===10)||(Ae===12||Ae===10)&&ze===10||ze===5||ze===13||ze===7||Ae===1||Ae===13&&ze===14||Ae===6&&ze===6)}var he;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class Le{static{this.c=null}static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=je()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Re=this.d,Xe=Re.length/3;let ne=1;for(;ne<=Xe;)if(ze<Re[3*ne])ne=2*ne;else if(ze>Re[3*ne+1])ne=2*ne+1;else return Re[3*ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ae,ze){if(Ae===0)return 0;const Re=Je(Ae,ze);if(Re!==void 0)return Re;const Xe=new Z(ze,Ae);return Xe.prevCodePoint(),Xe.offset}e.$Ef=He;function Je(Ae,ze){const Re=new Z(ze,Ae);let Xe=Re.prevCodePoint();for(;_e(Xe)||Xe===65039||Xe===8419;){if(Re.offset===0)return;Xe=Re.prevCodePoint()}if(!_(Xe))return;let ne=Re.offset;return ne>0&&Re.prevCodePoint()===8205&&(ne=Re.offset),ne}function _e(Ae){return 127995<=Ae&&Ae<=127999}var ct;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.$Ff="\xA0";class ot{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Fe(ze=>{function Re(it){const Oe=new Map;for(let pt=0;pt<it.length;pt+=2)Oe.set(it[pt],it[pt+1]);return Oe}function Xe(it,Oe){const pt=new Map(it);for(const[St,Ft]of Oe)pt.set(St,Ft);return pt}function ne(it,Oe){if(!it)return Oe;const pt=new Map;for(const[St,Ft]of it)Oe.has(St)&&pt.set(St,Ft);return pt}const ae=this.c.value;let Ie=ze.filter(it=>!it.startsWith("_")&&it in ae);Ie.length===0&&(Ie=["_default"]);let qe;for(const it of Ie){const Oe=Re(ae[it]);qe=ne(qe,Oe)}const Ye=Re(ae._common),nt=Xe(Ye,qe);return new ot(nt)})}static getInstance(ze){return ot.d.get(Array.from(ze))}static{this.e=new T.$V(()=>Object.keys(ot.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ot.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=ot;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$Hf=rt}),define(ke[123],Se([1,0,28,161,12]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function I(...we){return function(De,B){for(let Q=0,ee=we.length;Q<ee;Q++){const q=we[Q](De,B);if(q)return q}return null}}e.or=I,e.$Tj=R.bind(void 0,!1),e.$Uj=R.bind(void 0,!0);function R(we,De,B){if(!B||B.length<De.length)return null;let Q;return we?Q=g.$af(B,De):Q=B.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function b(we,De){const B=De.toLowerCase().indexOf(we.toLowerCase());return B===-1?null:[{start:B,end:B+we.length}]}e.$Vj=b;function $(we,De){return y(we.toLowerCase(),De.toLowerCase(),0,0)}e.$Wj=$;function y(we,De,B,Q){if(B===we.length)return[];if(Q===De.length)return null;if(we[B]===De[Q]){let ee=null;return(ee=y(we,De,B+1,Q+1))?n({start:Q,end:Q+1},ee):null}return y(we,De,B,Q+1)}function L(we){return 97<=we&&we<=122}function C(we){return 65<=we&&we<=90}e.$Xj=C;function m(we){return 48<=we&&we<=57}function v(we){return we===32||we===9||we===10||we===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(we=>S.add(we.charCodeAt(0)));function l(we){return v(we)||S.has(we)}function f(we,De){return we===De||l(we)&&l(De)}const o=new Map;function i(we){if(o.has(we))return o.get(we);let De;const B=(0,T.$Rj)(we);return B&&(De=B),o.set(we,De),De}function r(we){return L(we)||C(we)||m(we)}function n(we,De){return De.length===0?De=[we]:we.end===De[0].start?De[0].start=we.start:De.unshift(we),De}function c(we,De){for(let B=De;B<we.length;B++){const Q=we.charCodeAt(B);if(C(Q)||m(Q)||B>0&&!r(we.charCodeAt(B-1)))return B}return we.length}function t(we,De,B,Q){if(B===we.length)return[];if(Q===De.length)return null;if(we[B]!==De[Q].toLowerCase())return null;{let ee=null,q=Q+1;for(ee=t(we,De,B+1,Q+1);!ee&&(q=c(De,q))<De.length;)ee=t(we,De,B+1,q),q++;return ee===null?null:n({start:Q,end:Q+1},ee)}}function u(we){let De=0,B=0,Q=0,ee=0,q=0;for(let He=0;He<we.length;He++)q=we.charCodeAt(He),C(q)&&De++,L(q)&&B++,r(q)&&Q++,m(q)&&ee++;const oe=De/we.length,he=B/we.length,Le=Q/we.length,je=ee/we.length;return{upperPercent:oe,lowerPercent:he,alphaPercent:Le,numericPercent:je}}function s(we){const{upperPercent:De,lowerPercent:B}=we;return B===0&&De>.6}function h(we){const{upperPercent:De,lowerPercent:B,alphaPercent:Q,numericPercent:ee}=we;return B>.2&&De<.8&&Q>.6&&ee<.2}function a(we){let De=0,B=0,Q=0,ee=0;for(let q=0;q<we.length;q++)Q=we.charCodeAt(q),C(Q)&&De++,L(Q)&&B++,v(Q)&&ee++;return(De===0||B===0)&&ee===0?we.length<=30:De<=5}function d(we,De){if(!De||(De=De.trim(),De.length===0)||!a(we)||De.length>60)return null;const B=u(De);if(!h(B)){if(!s(B))return null;De=De.toLowerCase()}let Q=null,ee=0;for(we=we.toLowerCase();ee<De.length&&(Q=t(we,De,0,ee))===null;)ee=c(De,ee+1);return Q}e.$Yj=d;function k(we,De,B=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(we=we.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=A(we,De,0,ee,B),Q===null);)ee=p(De,ee+1);return Q}e.$Zj=k;function A(we,De,B,Q,ee){let q=0;if(B===we.length)return[];if(Q===De.length)return null;if(!f(we.charCodeAt(B),De.charCodeAt(Q))){const Le=i(we.charCodeAt(B));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],De.charCodeAt(Q+je)))return null;q+=Le.length-1}let oe=null,he=Q+q+1;if(oe=A(we,De,B+1,he,ee),!ee)for(;!oe&&(he=p(De,he))<De.length;)oe=A(we,De,B+1,he,ee),he++;if(!oe)return null;if(we.charCodeAt(B)!==De.charCodeAt(Q)){const Le=i(we.charCodeAt(B));if(!Le)return oe;for(let je=0;je<Le.length;je++)if(Le[je]!==De.charCodeAt(Q+je))return oe}return n({start:Q,end:Q+q+1},oe)}function p(we,De){for(let B=De;B<we.length;B++)if(l(we.charCodeAt(B))||B>0&&l(we.charCodeAt(B-1)))return B;return we.length}const w=I(e.$Uj,d,b),E=I(e.$Uj,d,$),P=new D.$Dc(1e4);function F(we,De,B=!1){if(typeof we!="string"||typeof De!="string")return null;let Q=P.get(we);Q||(Q=new RegExp(g.$Ve(we),"i"),P.set(we,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:B?E(we,De):w(we,De)}e.$1j=F;function z(we,De){const B=_(we,we.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?j(B):null}e.$2j=z;function N(we,De,B,Q,ee,q){const oe=Math.min(13,we.length);for(;B<oe;B++){const he=_(we,De,B,Q,ee,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,q]}e.$3j=N;function j(we){if(typeof we>"u")return[];const De=[],B=we[1];for(let Q=we.length-1;Q>1;Q--){const ee=we[Q]+B,q=De[De.length-1];q&&q.end===ee?q.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$4j=j;const M=128;function O(){const we=[],De=[];for(let B=0;B<=M;B++)De[B]=0;for(let B=0;B<=M;B++)we.push(De.slice(0));return we}function U(we){const De=[];for(let B=0;B<=we;B++)De[B]=0;return De}const Y=U(2*M),le=U(2*M),Z=O(),J=O(),X=O(),ue=!1;function x(we,De,B,Q,ee){function q(he,Le,je=" "){for(;he.length<Le;)he=je+he;return he}let oe=` |   |${Q.split("").map(he=>q(he,3)).join("|")}
`;for(let he=0;he<=B;he++)he===0?oe+=" |":oe+=`${De[he-1]}|`,oe+=we[he].slice(0,ee+1).map(Le=>q(Le.toString(),3)).join("|")+`
`;return oe}function be(we,De,B,Q){we=we.substr(De),B=B.substr(Q),console.log(x(J,we,we.length,B,B.length)),console.log(x(X,we,we.length,B,B.length)),console.log(x(Z,we,we.length,B,B.length))}function ce(we,De){if(De<0||De>=we.length)return!1;const B=we.codePointAt(De);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$sf(B)}}function K(we,De){if(De<0||De>=we.length)return!1;switch(we.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function V(we,De,B){return De[we]!==B[we]}function re(we,De,B,Q,ee,q,oe=!1){for(;De<B&&ee<q;)we[De]===Q[ee]&&(oe&&(Y[De]=ee),De+=1),ee+=1;return De===B}e.$5j=re;var ye;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(we){we.Default=[-100,0];function De(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}we.isDefault=De})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,B){this.firstMatchCanBeWeak=De,this.boostFullMatch=B}}e.$6j=ge;function _(we,De,B,Q,ee,q,oe=ge.default){const he=we.length>M?M:we.length,Le=Q.length>M?M:Q.length;if(B>=he||q>=Le||he-B>Le-q||!re(De,B,he,ee,q,Le,!0))return;te(he,Le,B,q,De,ee);let je=1,He=1,Je=B,_e=q;const ct=[!1];for(je=1,Je=B;Je<he;je++,Je++){const Re=Y[Je],Xe=le[Je],ne=Je+1<he?le[Je+1]:Le;for(He=Re-q+1,_e=Re;_e<ne;He++,_e++){let ae=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Xe&&(ae=G(we,De,Je,B,Q,ee,_e,Le,q,Z[je-1][He-1]===0,ct));let qe=0;ae!==Number.MAX_SAFE_INTEGER&&(Ie=!0,qe=ae+J[je-1][He-1]);const Ye=_e>Re,nt=Ye?J[je][He-1]+(Z[je][He-1]>0?-5:0):0,it=_e>Re+1&&Z[je][He-1]>0,Oe=it?J[je][He-2]+(Z[je][He-2]>0?-5:0):0;if(it&&(!Ye||Oe>=nt)&&(!Ie||Oe>=qe))J[je][He]=Oe,X[je][He]=3,Z[je][He]=0;else if(Ye&&(!Ie||nt>=qe))J[je][He]=nt,X[je][He]=2,Z[je][He]=0;else if(Ie)J[je][He]=qe,X[je][He]=1,Z[je][He]=Z[je-1][He-1]+1;else throw new Error("not possible")}}if(ue&&be(we,B,Q,q),!ct[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const ot=[J[je][He],q];let rt=0,Ae=0;for(;je>=1;){let Re=He;do{const Xe=X[je][Re];if(Xe===3)Re=Re-2;else if(Xe===2)Re=Re-1;else break}while(Re>=1);rt>1&&De[B+je-1]===ee[q+He-1]&&!V(Re+q-1,Q,ee)&&rt+1>Z[je][Re]&&(Re=He),Re===He?rt++:rt=1,Ae||(Ae=Re),je--,He=Re-1,ot.push(He)}Le===he&&oe.boostFullMatch&&(ot[0]+=2);const ze=Ae-he;return ot[0]-=ze,ot}e.$7j=_;function te(we,De,B,Q,ee,q){let oe=we-1,he=De-1;for(;oe>=B&&he>=Q;)ee[oe]===q[he]&&(le[oe]=he,oe--),he--}function G(we,De,B,Q,ee,q,oe,he,Le,je,He){if(De[B]!==q[oe])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return oe===B-Q?Je=we[B]===ee[oe]?7:5:V(oe,ee,q)&&(oe===0||!V(oe-1,ee,q))?(Je=we[B]===ee[oe]?7:5,_e=!0):ce(q,oe)&&(oe===0||!ce(q,oe-1))?Je=5:(ce(q,oe-1)||K(q,oe-1))&&(Je=5,_e=!0),Je>1&&B===Q&&(He[0]=!0),_e||(_e=V(oe,ee,q)||ce(q,oe-1)||K(q,oe-1)),B===Q?oe>Le&&(Je-=_e?3:5):je?Je+=_e?2:0:Je+=_e?0:1,oe+1===he&&(Je-=_e?3:5),Je}function ie(we,De,B,Q,ee,q,oe){return ve(we,De,B,Q,ee,q,!0,oe)}e.$8j=ie;function fe(we,De,B,Q,ee,q,oe){return ve(we,De,B,Q,ee,q,!1,oe)}e.$9j=fe;function ve(we,De,B,Q,ee,q,oe,he){let Le=_(we,De,B,Q,ee,q,he);if(Le&&!oe)return Le;if(we.length>=3){const je=Math.min(7,we.length-1);for(let He=B+1;He<je;He++){const Je=Pe(we,He);if(Je){const _e=_(Je,Je.toLowerCase(),B,Q,ee,q,he);_e&&(_e[0]-=3,(!Le||_e[0]>Le[0])&&(Le=_e))}}}return Le}function Pe(we,De){if(De+1>=we.length)return;const B=we[De],Q=we[De+1];if(B!==Q)return we.slice(0,De)+Q+B+we.slice(De+2)}}),define(ke[54],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function T(o){return g(o,0)}e.$Ti=T;function g(o,i){switch(typeof o){case"object":return o===null?I(349,i):Array.isArray(o)?$(o,i):y(o,i);case"string":return b(o,i);case"boolean":return R(o,i);case"number":return I(o,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Ui=g;function I(o,i){return(i<<5)-i+o|0}e.$Vi=I;function R(o,i){return I(o?433:863,i)}function b(o,i){i=I(149417,i);for(let r=0,n=o.length;r<n;r++)i=I(o.charCodeAt(r),i);return i}e.$Wi=b;function $(o,i){return i=I(104579,i),o.reduce((r,n)=>g(n,r),i)}function y(o,i){return i=I(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=b(n,r),g(o[n],r)),i)}class L{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Xi=L;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(o,i,r=32){const n=r-i,c=~((1<<n)-1);return(o<<i|(c&o)>>>n)>>>0}function v(o,i=0,r=o.byteLength,n=0){for(let c=0;c<r;c++)o[i+c]=n}function S(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function l(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Yi=l;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let c=this.r,t=this.u,u,s;for(t!==0?(u=t,s=-1,t=0):(u=i.charCodeAt(0),s=0);;){let h=u;if(D.$df(u))if(s+1<r){const a=i.charCodeAt(s+1);D.$ef(a)?(s++,h=D.$ff(u,a)):h=65533}else{t=u;break}else D.$ef(u)&&(h=65533);if(c=this.w(n,c,h),s++,s<r)u=i.charCodeAt(s);else break}this.r=c,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,r=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,r.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let n=this.h,c=this.l,t=this.m,u=this.n,s=this.o,h,a,d;for(let k=0;k<80;k++)k<20?(h=c&t|~c&u,a=1518500249):k<40?(h=c^t^u,a=1859775393):k<60?(h=c&t|c&u|t&u,a=2400959708):(h=c^t^u,a=3395469782),d=m(n,5)+h+s+a+i.getUint32(k*4,!1)&4294967295,s=u,u=t,t=m(c,30),c=n,n=d;this.h=this.h+n&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+s&4294967295}}e.$Zi=f}),define(ke[39],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const I="error",R="warning",b="warn",$="info",y="ignore";function L(m){return m?D.$_e(I,m)?g.Error:D.$_e(R,m)||D.$_e(b,m)?g.Warning:D.$_e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=L;function C(m){switch(m){case g.Error:return I;case g.Warning:return R;case g.Info:return $;default:return y}}g.toString=C}(T||(T={})),e.default=T}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),l=this.b.charCodeAt(this.c);return S-l}value(){return this.b[this.c]}}e.$8h=g;class I{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$6e)(v,this.b,0,v.length,this.c,this.d):(0,T.$8e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=I;class R{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const l=this.b.charCodeAt(S);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$6e)(v,this.b,0,v.length,this.d,this.e):(0,T.$8e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=R;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$7e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$7e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$5e)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$5e)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(L||(L={}));class C{static forUris(v=()=>!1,S=()=>!1){return new C(new $(v,S))}static forPaths(v=!1){return new C(new R(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const l=S.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f,v)}else{const l=v.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f[0],f[1])}}set(v,S){const l=this.b.reset(v);let f;this.c||(this.c=new y,this.c.segment=l.value());const o=[];for(f=this.c;;){const r=l.cmp(f.segment);if(r>0)f.left||(f.left=new y,f.left.segment=l.value()),o.push([-1,f]),f=f.left;else if(r<0)f.right||(f.right=new y,f.right.segment=l.value()),o.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new y,f.mid.segment=l.value()),o.push([0,f]),f=f.mid;else break}const i=f.value;f.value=S,f.key=v;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const c=n.balanceFactor();if(c<-1||c>1){const t=o[r][0],u=o[r+1][0];if(t===1&&u===1)o[r][1]=n.rotateLeft();else if(t===-1&&u===-1)o[r][1]=n.rotateRight();else if(t===1&&u===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&u===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let l=this.c;for(;l;){const f=S.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(S.hasNext())S.next(),l=l.mid;else break}return l}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const l=this.b.reset(v),f=[];let o=this.c;for(;o;){const i=l.cmp(o.segment);if(i>0)f.push([-1,o]),o=o.left;else if(i<0)f.push([1,o]),o=o.right;else if(l.hasNext())l.next(),f.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:r,value:n,segment:c}=i;this.e(i.key,!1),o.key=r,o.value=n,o.segment=c}}else{const i=o.left??o.right;if(f.length>0){const[r,n]=f[f.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const r=f[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),f[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),f[i][1]=r.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let l=this.c,f;for(;l;){const o=S.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(S.hasNext())S.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(v){return this.g(v,!1)}g(v,S){const l=this.b.reset(v);let f=this.c;for(;f;){const o=l.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this.h(f.mid):S?f.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,l]of this)v(l,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const l=S.balanceFactor();return l<-1||l>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$_h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function D(c){return typeof c=="string"}e.$If=D;function T(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$Jf=T;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Kf=g;function I(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Lf=I;function R(c){return typeof c=="number"&&!isNaN(c)}e.$Mf=R;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Nf=b;function $(c){return c===!0||c===!1}e.$Of=$;function y(c){return typeof c>"u"}e.$Pf=y;function L(c){return!C(c)}e.$Qf=L;function C(c){return y(c)||c===null}e.$Rf=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Sf=m;function v(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Tf=v;function S(...c){const t=[];for(let u=0;u<c.length;u++){const s=c[u];if(C(s))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(s)}return t}e.$Uf=S;const l=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(l.call(c,t))return!1;return!0}e.$Vf=f;function o(c){return typeof c=="function"}e.$Wf=o;function i(...c){return c.length>0&&c.every(o)}e.$Xf=i;function r(c,t){const u=Math.min(c.length,t.length);for(let s=0;s<u;s++)n(c[s],t[s])}e.$Yf=r;function n(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=n}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=void 0;const T=Object.create(null);function g(b,$){if((0,D.$If)($)){const y=T[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return T[b]=$,{id:b}}function I(){return T}e.$0j=I;function R(){return Object.values(e.$_j)}e.$$j=R,e.$_j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugBreakpointPending:g("debug-breakpoint-pending",60377),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),surroundWith:g("surround-with",60452),gitStash:g("git-stash",60454),gitStashApply:g("git-stash-apply",60455),gitStashPop:g("git-stash-pop",60456),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?T(n):n}),i}e.$vn=T;function g(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(I.call(r,n)){const c=r[n];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Lf)(c)&&i.push(c)}}return o}e.$wn=g;const I=Object.prototype.hasOwnProperty;function R(o,i){return b(o,i,new Set)}e.$xn=R;function b(o,i,r){if((0,D.$Rf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const c=[];for(const t of o)c.push(b(t,i,r));return c}if((0,D.$Kf)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const c={};for(const t in o)I.call(o,t)&&(c[t]=b(o[t],i,r));return r.delete(o),c}return o}function $(o,i,r=!0){return(0,D.$Kf)(o)?((0,D.$Kf)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,D.$Kf)(o[n])&&(0,D.$Kf)(i[n])?$(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.$yn=$;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!y(o[r],i[r]))return!1}else{const c=[];for(n in o)c.push(n);c.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(c,t))return!1;for(r=0;r<c.length;r++)if(!y(o[c[r]],i[c[r]]))return!1}return!0}e.$zn=y;function L(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,D.$Kf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$An=L;function C(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],u=i[c];y(t,u)||(r[c]=u)}),r}e.$Bn=C;function m(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(c=>c.toLowerCase()===r);return n?o[n]:o[i]}e.$Cn=m;function v(o,i){const r=Object.create(null);for(const[n,c]of Object.entries(o))i(n,c)&&(r[n]=c);return r}e.$Dn=v;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$En=S;function l(o){const i=[];for(const r of S(o))typeof o[r]=="function"&&i.push(r);return i}e.$Fn=l;function f(o,i){const r=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},n={};for(const c of o)n[c]=r(c);return n}e.$Gn=f}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var T;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(T||(e.ThemeColor=T={}));function g(R){return{id:R}}e.$ak=g;var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const r=b.exec(i.id);if(!r)return $(D.$_j.error);const[,n,c]=r,t=["codicon","codicon-"+n];return c&&t.push("codicon-modifier-"+c.substring(1)),t}R.asClassNameArray=$;function y(i){return $(i).join(" ")}R.asClassName=y;function L(i){return"."+$(i).join(".")}R.asCSSSelector=L;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const r=m.exec(i);if(!r)return;const[,n]=r;return{id:n}}R.fromString=v;function S(i){return{id:i}}R.fromId=S;function l(i,r){let n=i.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),r&&(n=`${n}~${r}`),{id:n}}R.modify=l;function f(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}R.getModifier=f;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}R.isEqual=o})(I||(e.ThemeIcon=I={}))}),define(ke[164],Se([1,0,123,12,61]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const I="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(o){return o.replace(b,(i,r)=>r?i:`\\${i}`)}e.$bk=$;const y=new RegExp(`\\\\${R.source}`,"g");function L(o){return o.replace(y,i=>`\\${i}`)}e.$ck=L;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(o){return o.indexOf(I)===-1?o:o.replace(C,(i,r,n,c)=>n?i:r||c||"")}e.$dk=m;function v(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$ek=v;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(o){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const c=S.lastIndex,t=S.exec(o),u=o.substring(c,t?.index);if(u.length>0){i+=u;for(let s=0;s<u.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$fk=l;function f(o,i,r=!1){const{text:n,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$1j)(o,n,r);const t=(0,T.$Te)(n," "),u=n.length-t.length,s=(0,D.$1j)(o,t,r);if(s)for(const h of s){const a=c[h.start+u]+u;h.start+=a,h.end+=a}return s}e.$gk=f}),define(ke[124],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ie=e.$He=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(I){return I<0?0:I>255?255:I|0}e.$He=T;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Ie=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$pg=T,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y}}()}),define(ke[165],Se([1,0,19,53,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$nt=I;function R(C,m,v){const S={id:(0,g.$qg)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$ot=R;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return T.Iterable.some(this,([S,l])=>l.asFile())&&v.push("files"),L($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const S=this.a.get(m);S?S.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const S of v)yield[m,S]}b(m){return $(m)}}e.$pt=b;function $(C){return C.toLowerCase()}function y(C,m){return L($(C),m.map($))}e.$qt=y;function L(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,l,f]=v;return f==="*"?m.some(o=>o.startsWith(l+"/")):!1}e.$rt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$rt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function T(b,$,y,L=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,L,S=>{if(!C)return C=!0,clearTimeout(v),m(S)})})}e.$sg=T;function g(b,$,y,L){if($===0)return L(0);const C=new D.Socket;C.once("connect",()=>(R(C),g(b+y,$-1,y,L))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,L):L(b))),C.connect(b,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,L="127.0.0.1"){let C=!1,m,v=1;const S=D.createServer({pauseOnConnect:!0});function l(f,o){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),o(f))}return new Promise(f=>{m=setTimeout(()=>{l(0,f)},y),S.on("listening",()=>{l(b,f)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&v<$?(b++,v++,S.listen(b,L)):l(0,f)}),S.on("close",()=>{l(0,f)}),S.listen(b,L)})}e.$ug=I;function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;class T{constructor(b){const $=(0,D.$He)(b);this.c=$,this.a=T.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$He)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ft=T;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$gt=I}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(g){let I=0,R=0,b=0,$=0;for(let y=0,L=g.length;y<L;y++){const C=g.charCodeAt(y);C===13?(I===0&&(R=y),I++,y+1<L&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(R=y),I++,b=y+1)}return I===0&&(R=g.length),[I,R,g.length-b,$]}e.$ut=T}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const R=g.lineNumber|0,b=I.lineNumber|0;if(R===b){const $=g.column|0,y=I.column|0;return $-y}return R-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ts=D}),define(ke[29],Se([1,0,48]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class T{constructor(I,R,b,$){I>b||I===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return T.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return T.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return T.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return T.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return T.plusRange(this,I)}static plusRange(I,R){let b,$,y,L;return R.startLineNumber<I.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===I.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),R.endLineNumber>I.endLineNumber?(y=R.endLineNumber,L=R.endColumn):R.endLineNumber===I.endLineNumber?(y=R.endLineNumber,L=Math.max(R.endColumn,I.endColumn)):(y=I.endLineNumber,L=I.endColumn),new T(b,$,y,L)}intersectRanges(I){return T.intersectRanges(this,I)}static intersectRanges(I,R){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,L=I.endColumn;const C=R.startLineNumber,m=R.startColumn,v=R.endLineNumber,S=R.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,L=S):y===v&&(L=Math.min(L,S)),b>y||b===y&&$>L?null:new T(b,$,y,L)}equalsRange(I){return T.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(I){return new D.$Ts(I.endLineNumber,I.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(I){return new D.$Ts(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new T(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new T(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(I){return new T(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(I){return new T(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new T(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new T(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new T(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const y=I.startLineNumber|0,L=R.startLineNumber|0;if(y===L){const C=I.startColumn|0,m=R.startColumn|0;if(C===m){const v=I.endLineNumber|0,S=R.endLineNumber|0;if(v===S){const l=I.endColumn|0,f=R.endColumn|0;return l-f}return v-S}return C-m}return y-L}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Us=T}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class T{static insert(I,R){return{range:new D.$Us(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Vs=T}),define(ke[169],Se([1,0,48,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends T.$Us{constructor(b,$,y,L){super(b,$,y,L),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ts(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ts(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,L=b.length;y<L;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,L,C){return C===0?new I(b,$,y,L):new I(y,L,b,$)}}e.$Ws=I}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$ft{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$ht=g;function I(R){const b={};return $=>(b.hasOwnProperty($)||(b[$]=R($)),b[$])}e.$it=I(R=>new g(R))}),define(ke[126],Se([1,0,53,3,75]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$ts)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$us=I();function R(C){let m=e.$us;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$vs=R;const b=new g.$4c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,T.$Rc)(m)}e.$ws=$;function y(C,m,v,S,l){if(m=R(m),l||(l=D.Iterable.first(b)),v.length>l.maxLen){let n=C-l.maxLen/2;return n<0?n=0:S+=n,v=v.substring(n,C+l.maxLen/2),y(C,m,v,S,l)}const f=Date.now(),o=C-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-f>=l.timeBudget);n++){const c=o-l.windowSize*n;m.lastIndex=Math.max(0,c);const t=L(m,v,o,i);if(!t&&r||(r=t,c<=0))break;i=c}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return m.lastIndex=0,n}return null}e.$xs=y;function L(C,m,v,S){let l;for(;l=C.exec(m);){const f=l.index||0;if(f<=v&&C.lastIndex>=v)return l;if(S>0&&f>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),L=b.getStandardTokenType(y);return this.isOK(L)}g(b,$){for(let y=b;y<=$;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=T;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$St=g;function I(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(ke[173],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AZ=e.$zZ=e.$yZ=e.State=void 0;var T;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,l,f){const o=new Uint8Array(S*l);for(let i=0,r=S*l;i<r;i++)o[i]=f;this.a=o,this.rows=S,this.cols=l}get(S,l){return this.a[S*this.cols+l]}set(S,l,f){this.a[S*this.cols+l]=f}}class I{constructor(S){let l=0,f=0;for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];c>l&&(l=c),n>f&&(f=n),t>f&&(f=t)}l++,f++;const o=new g(f,l,0);for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];o.set(n,c,t)}this.a=o,this.b=l}nextState(S,l){return l<0||l>=this.b?0:this.a.get(S,l)}}e.$yZ=I;let R=null;function b(){return R===null&&(R=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function L(){if(y===null){y=new D.$ft(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<v.length;l++)y.set(v.charCodeAt(l),1);const S=".,;:";for(let l=0;l<S.length;l++)y.set(S.charCodeAt(l),2)}return y}class C{static a(S,l,f,o,i){let r=i-1;do{const n=l.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>o);if(o>0){const n=l.charCodeAt(o-1),c=l.charCodeAt(r);(n===40&&c===41||n===91&&c===93||n===123&&c===125)&&r--}return{range:{startLineNumber:f,startColumn:o+1,endLineNumber:f,endColumn:r+2},url:l.substring(o,r+1)}}static computeLinks(S,l=b()){const f=L(),o=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),c=n.length;let t=0,u=0,s=0,h=1,a=!1,d=!1,k=!1,A=!1;for(;t<c;){let p=!1;const w=n.charCodeAt(t);if(h===13){let E;switch(w){case 40:a=!0,E=0;break;case 41:E=a?0:1;break;case 91:k=!0,d=!0,E=0;break;case 93:k=!1,E=d?0:1;break;case 123:A=!0,E=0;break;case 125:E=A?0:1;break;case 39:case 34:case 96:s===w?E=1:s===39||s===34||s===96?E=0:E=1;break;case 42:E=s===42?1:0;break;case 124:E=s===124?1:0;break;case 32:E=k?0:1;break;default:E=f.get(w)}E===1&&(o.push(C.a(f,n,i,u,t)),p=!0)}else if(h===12){let E;w===91?(d=!0,E=0):E=f.get(w),E===1?p=!0:h=13}else h=l.nextState(h,w),h===0&&(p=!0);p&&(h=1,a=!1,d=!1,A=!1,u=t+1,s=w),t++}h===13&&o.push(C.a(f,n,i,u,c))}return o}}e.$zZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$AZ=m}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.$dv=e.$cv=e.ModelConstants=e.PositionAffinity=e.$bv=e.TrackedRangeStickiness=e.$av=e.$_u=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$zn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$_u=L;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$av=C;var m;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(n){return n&&typeof n.read=="function"}e.$bv=v;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var l;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class f{constructor(c,t,u,s,h,a){this.identifier=c,this.range=t,this.text=u,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=h,this._isTracked=a}}e.$cv=f;class o{constructor(c,t,u){this.regex=c,this.wordSeparators=t,this.simpleSearch=u}}e.$dv=o;class i{constructor(c,t,u){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=u}}e.$ev=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$fv=r}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class D{constructor(f,o){this.piece=f,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return g(this.right);let f=this;for(;f.parent!==e.$TB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}prev(){if(this.left!==e.$TB)return I(this.left);let f=this;for(;f.parent!==e.$TB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=D;var T;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$TB=new D(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function g(l){for(;l.left!==e.$TB;)l=l.left;return l}e.$UB=g;function I(l){for(;l.right!==e.$TB;)l=l.right;return l}e.$VB=I;function R(l){return l===e.$TB?0:l.size_left+l.piece.length+R(l.right)}function b(l){return l===e.$TB?0:l.lf_left+l.piece.lineFeedCnt+b(l.right)}function $(){e.$TB.parent=e.$TB}function y(l,f){const o=f.right;o.size_left+=f.size_left+(f.piece?f.piece.length:0),o.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=o.left,o.left!==e.$TB&&(o.left.parent=f),o.parent=f.parent,f.parent===e.$TB?l.root=o:f.parent.left===f?f.parent.left=o:f.parent.right=o,o.left=f,f.parent=o}e.$WB=y;function L(l,f){const o=f.left;f.left=o.right,o.right!==e.$TB&&(o.right.parent=f),o.parent=f.parent,f.size_left-=o.size_left+(o.piece?o.piece.length:0),f.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),f.parent===e.$TB?l.root=o:f===f.parent.right?f.parent.right=o:f.parent.left=o,o.right=f,f.parent=o}e.$XB=L;function C(l,f){let o,i;if(f.left===e.$TB?(i=f,o=i.right):f.right===e.$TB?(i=f,o=i.left):(i=g(f.right),o=i.right),i===l.root){l.root=o,o.color=0,f.detach(),$(),l.root.parent=e.$TB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===f?(o.parent=i.parent,S(l,o)):(i.parent===f?o.parent=i:o.parent=i.parent,S(l,o),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===l.root?l.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$TB&&(i.left.parent=i),i.right!==e.$TB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,S(l,i)),f.detach(),o.parent.left===o){const c=R(o),t=b(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const u=c-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,v(l,o.parent,u,s)}}if(S(l,o.parent),r){$();return}let n;for(;o!==l.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,y(l,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,L(l,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,y(l,o.parent),o=l.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,L(l,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(l,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,L(l,o.parent),o=l.root));o.color=0,$()}e.$YB=C;function m(l,f){for(S(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const o=f.parent.parent.right;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(l,f)),f.parent.color=0,f.parent.parent.color=1,L(l,f.parent.parent))}else{const o=f.parent.parent.left;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,L(l,f)),f.parent.color=0,f.parent.parent.color=1,y(l,f.parent.parent))}l.root.color=0}e.$ZB=m;function v(l,f,o,i){for(;f!==l.root&&f!==e.$TB;)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}e.$1B=v;function S(l,f){let o=0,i=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,o=R(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=o,f.lf_left+=i;f!==l.root&&(o!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}}e.$2B=S}),define(ke[175],Se([1,0,19,124]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,T.$Ie)($);const L=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(L.length+m),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,T.$Ie)($),y=(0,T.$Ie)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,T.$Ie)($),y=(0,T.$Ie)(y);const L=this.a,C=this.b;if($>=L.length)return!1;const m=L.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,T.$Ie)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let L=y;L<=$;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,L=this.a.length-1,C=0,m=0,v=0;for(;y<=L;)if(C=y+(L-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)L=C-1;else if($>=m)y=C+1;else break;return new R(C,$-v)}}e.$iv=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],L=y>0?this.d[y-1]:0;return new R(y,$-L)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const L=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+L;for(let m=0;m<L;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$jv=I;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$kv=R}),define(ke[176],Se([1,0,12,48,175]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=void 0;class I{constructor(b,$,y,L){this.d=b,this.f=$,this.g=y,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new T.$Ts(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let L=0;L<$;L++)y[L]=this.f[L].length+b;this.j=new g.$iv(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ze)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),L[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,L)}}e.$lv=I}),define(ke[100],Se([1,0,12,171,48,29,79]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=void 0;const b=999;class ${constructor(i,r,n,c){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$Xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new R.$dv(r,this.wordSeparators?(0,T.$it)(this.wordSeparators):null,n?this.searchString:null)}}e.$3B=$;function y(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$4B=y;function L(o,i,r){if(!r)return new R.$av(o,null);const n=[];for(let c=0,t=i.length;c<t;c++)n[c]=i[c];return new R.$av(o,n)}e.$5B=L;class C{constructor(i){const r=[];let n=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(r[n++]=c);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,c=r.length-1;if(c===-1||i<=r[0])return 0;for(;n<c;){const t=n+((c-n)/2>>0);r[t]>=i?c=t-1:r[t+1]>=i?(n=t,c=t):n=t+1}return n+1}}class m{static findMatches(i,r,n,c,t){const u=r.parseSearchRequest();return u?u.regex.multiline?this.b(i,n,new f(u.wordSeparators,u.regex),c,t):this.c(i,n,u,c,t):[]}static a(i,r,n,c,t,u){let s,h=0;c?(h=c.findLineFeedCountBeforeOffset(t),s=r+t+h):s=r+t;let a;if(c){const p=c.findLineFeedCountBeforeOffset(t+u.length)-h;a=s+u.length+p}else a=s+u.length;const d=i.getPositionAt(s),k=i.getPositionAt(a);return new I.$Us(d.lineNumber,d.column,k.lineNumber,k.column)}static b(i,r,n,c,t){const u=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),h=i.getEOL()===`\r
`?new C(s):null,a=[];let d=0,k;for(n.reset(0);k=n.next(s);)if(a[d++]=L(this.a(i,u,s,h,k.index,k[0]),k,c),d>=t)return a;return a}static c(i,r,n,c,t){const u=[];let s=0;if(r.startLineNumber===r.endLineNumber){const a=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,a,r.startLineNumber,r.startColumn-1,s,u,c,t),u}const h=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,h,r.startLineNumber,r.startColumn-1,s,u,c,t);for(let a=r.startLineNumber+1;a<r.endLineNumber&&s<t;a++)s=this.d(n,i.getLineContent(a),a,0,s,u,c,t);if(s<t){const a=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,a,r.endLineNumber,0,s,u,c,t)}return u}static d(i,r,n,c,t,u,s,h){const a=i.wordSeparators;if(!s&&i.simpleSearch){const A=i.simpleSearch,p=A.length,w=r.length;let E=-p;for(;(E=r.indexOf(A,E+p))!==-1;)if((!a||l(a,r,w,E,p))&&(u[t++]=new R.$av(new I.$Us(n,E+1+c,n,E+1+p+c),null),t>=h))return t;return t}const d=new f(i.wordSeparators,i.regex);let k;d.reset(0);do if(k=d.next(r),k&&(u[t++]=L(new I.$Us(n,k.index+1+c,n,k.index+1+k[0].length+c),k,s),t>=h))return t;while(k);return t}static findNextMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,u,c):this.f(i,n,u,c)}static e(i,r,n,c){const t=new g.$Ts(r.lineNumber,1),u=i.getOffsetAt(t),s=i.getLineCount(),h=i.getValueInRange(new I.$Us(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),a=i.getEOL()===`\r
`?new C(h):null;n.reset(r.column-1);const d=n.next(h);return d?L(this.a(i,u,h,a,d.index,d[0]),d,c):r.lineNumber!==1||r.column!==1?this.e(i,new g.$Ts(1,1),n,c):null}static f(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u),h=this.g(n,s,u,r.column,c);if(h)return h;for(let a=1;a<=t;a++){const d=(u+a-1)%t,k=i.getLineContent(d+1),A=this.g(n,k,d+1,1,c);if(A)return A}return null}static g(i,r,n,c,t){i.reset(c-1);const u=i.next(r);return u?L(new I.$Us(n,u.index+1,n,u.index+1+u[0].length),u,t):null}static findPreviousMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,u,c):this.j(i,n,u,c)}static h(i,r,n,c){const t=this.b(i,new I.$Us(1,1,r.lineNumber,r.column),n,c,10*b);if(t.length>0)return t[t.length-1];const u=i.getLineCount();return r.lineNumber!==u||r.column!==i.getLineMaxColumn(u)?this.h(i,new g.$Ts(u,i.getLineMaxColumn(u)),n,c):null}static j(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u).substring(0,r.column-1),h=this.k(n,s,u,c);if(h)return h;for(let a=1;a<=t;a++){const d=(t+u-a-1)%t,k=i.getLineContent(d+1),A=this.k(n,k,d+1,c);if(A)return A}return null}static k(i,r,n,c){let t=null,u;for(i.reset(0);u=i.next(r);)t=L(new I.$Us(n,u.index+1,n,u.index+1+u[0].length),u,c);return t}}e.$6B=m;function v(o,i,r,n,c){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n);if(o.get(u)!==0)return!0}return!1}function S(o,i,r,n,c){if(n+c===r)return!0;const t=i.charCodeAt(n+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n+c-1);if(o.get(u)!==0)return!0}return!1}function l(o,i,r,n,c){return v(o,i,r,n,c)&&S(o,i,r,n,c)}e.$7B=l;class f{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const c=n.index,t=n[0].length;if(c===this.b&&t===this.c){if(t===0){D.$gf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||l(this._wordSeparators,i,r,c,t))return n}while(n);return null}}e.$8B=f}),define(ke[127],Se([1,0,48,29,79,174,100]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const b=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,r,n,c,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=c,this.isBasicASCII=t}}function L(o,i=!0){const r=[0];let n=1;for(let c=0,t=o.length;c<t;c++){const u=o.charCodeAt(c);u===13?c+1<t&&o.charCodeAt(c+1)===10?(r[n++]=c+2,c++):r[n++]=c+1:u===10&&(r[n++]=c+1)}return i?$(r):r}e.$9B=L;function C(o,i){o.length=0,o[0]=0;let r=1,n=0,c=0,t=0,u=!0;for(let h=0,a=i.length;h<a;h++){const d=i.charCodeAt(h);d===13?h+1<a&&i.charCodeAt(h+1)===10?(t++,o[r++]=h+2,h++):(n++,o[r++]=h+1):d===10?(c++,o[r++]=h+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const s=new y($(o),n,c,t,u);return o.length=0,s}e.$0B=C;class m{constructor(i,r,n,c,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=c,this.length=t}}e.$$B=m;class v{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$_B=v;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==I.$TB&&i.iterate(i.root,n=>(n!==I.$TB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let c=0;c<n.length;c++){const t=n[c];if(t.node.parent===null||t.nodeStartOffset>=i){n[c]=null,r=!0;continue}}if(r){const c=[];for(const t of n)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=I.$TB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let c=null;for(let t=0,u=i.length;t<u;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const s=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,s)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=b,n=r-Math.floor(r/3),c=n*2;let t="",u=0;const s=[];if(this.iterate(this.root,h=>{const a=this.R(h),d=a.length;if(u<=n||u+d<c)return t+=a,u+=d,!0;const k=t.replace(/\r\n|\r|\n/g,i);return s.push(new v(k,L(k))),t=a,u=d,!0}),u>0){const h=t.replace(/\r\n|\r|\n/g,i);s.push(new v(h,L(h)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===I.$TB)return!0;const t=this.R(c),u=t.length,s=i.G(r),h=i.G(r+u),a=i.getValueInRange2(s,h);return r+=u,t===a})}getOffsetAt(i,r){let n=0,c=this.root;for(;c!==I.$TB;)if(c.left!==I.$TB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){n+=c.size_left;const t=this.B(c,i-c.lf_left-2);return n+=t+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,n+=c.size_left+c.piece.length,c=c.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const c=i;for(;r!==I.$TB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const u=this.getOffsetAt(n+1,1),s=c-u;return new D.$Ts(n+1,s+1)}return new D.$Ts(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===I.$TB){const t=this.getOffsetAt(n+1,1),u=c-i-t;return new D.$Ts(n+1,u+1)}else r=r.right;return new D.$Ts(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,c);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,h=this.a[s.piece.bufferIndex].buffer,a=this.u(s.piece.bufferIndex,s.piece.start);return h.substring(a+i.remainder,a+r.remainder)}let n=i.node;const c=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let u=c.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==I.$TB;){const s=this.a[n.piece.bufferIndex].buffer,h=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){u+=s.substring(h,h+r.remainder);break}else u+=s.substr(h,n.piece.length);n=n.next()}return u}getLinesContent(){const i=[];let r=0,n="",c=!1;return this.iterate(this.root,t=>{if(t===I.$TB)return!0;const u=t.piece;let s=u.length;if(s===0)return!0;const h=this.a[u.bufferIndex].buffer,a=this.a[u.bufferIndex].lineStarts,d=u.start.line,k=u.end.line;let A=a[d]+u.start.column;if(c&&(h.charCodeAt(A)===10&&(A++,s--),i[r++]=n,n="",c=!1,s===0))return!0;if(d===k)return!this.f&&h.charCodeAt(A+s-1)===13?(c=!0,n+=h.substr(A,s-1)):n+=h.substr(A,s),!0;n+=this.f?h.substring(A,Math.max(A,a[d+1]-this.e)):h.substring(A,a[d+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let p=d+1;p<k;p++)n=this.f?h.substring(a[p],a[p+1]-this.e):h.substring(a[p],a[p+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&h.charCodeAt(a[k]+u.end.column-1)===13?(c=!0,u.end.column===0?r--:n=h.substr(a[k],u.end.column-1)):n=h.substr(a[k],u.end.column),!0}),c&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,c,t,u,s,h,a,d,k){const A=this.a[i.piece.bufferIndex],p=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,u);let P;const F={line:0,column:0};let z,N;r._wordSeparators?(z=A.buffer.substring(w,E),N=j=>j+w,r.reset(0)):(z=A.buffer,N=j=>j,r.reset(w));do if(P=r.next(z),P){if(N(P.index)>=E)return d;this.s(i,N(P.index)-p,F);const j=this.t(i.piece.bufferIndex,t,F),M=F.line===t.line?F.column-t.column+c:F.column+1,O=M+P[0].length;if(k[d++]=(0,R.$5B)(new T.$Us(n+j,M,n+j,O),P,h),N(P.index)+P[0].length>=E||d>=a)return d}while(P);return d}findMatchesLineByLine(i,r,n,c){const t=[];let u=0;const s=new R.$8B(r.wordSeparators,r.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let d=this.s(h.node,h.remainder);const k=this.s(a.node,a.remainder);if(h.node===a.node)return this.findMatchesInNode(h.node,s,i.startLineNumber,i.startColumn,d,k,r,n,c,u,t),t;let A=i.startLineNumber,p=h.node;for(;p!==a.node;){const E=this.t(p.piece.bufferIndex,d,p.piece.end);if(E>=1){const F=this.a[p.piece.bufferIndex].lineStarts,z=this.u(p.piece.bufferIndex,p.piece.start),N=F[d.line+E],j=A===i.startLineNumber?i.startColumn:1;if(u=this.findMatchesInNode(p,s,A,j,d,this.s(p,N-z),r,n,c,u,t),u>=c)return t;A+=E}const P=A===i.startLineNumber?i.startColumn-1:0;if(A===i.endLineNumber){const F=this.getLineContent(A).substring(P,i.endColumn-1);return u=this.n(r,s,F,i.endLineNumber,P,u,t,n,c),t}if(u=this.n(r,s,this.getLineContent(A).substr(P),A,P,u,t,n,c),u>=c)return t;A++,h=this.H(A,1),p=h.node,d=this.s(h.node,h.remainder)}if(A===i.endLineNumber){const E=A===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(A).substring(E,i.endColumn-1);return u=this.n(r,s,P,i.endLineNumber,E,u,t,n,c),t}const w=A===i.startLineNumber?i.startColumn:1;return u=this.findMatchesInNode(a.node,s,A,w,d,k,r,n,c,u,t),t}n(i,r,n,c,t,u,s,h,a){const d=i.wordSeparators;if(!h&&i.simpleSearch){const A=i.simpleSearch,p=A.length,w=n.length;let E=-p;for(;(E=n.indexOf(A,E+p))!==-1;)if((!d||(0,R.$7B)(d,n,w,E,p))&&(s[u++]=new g.$av(new T.$Us(c,E+1+t,c,E+1+p+t),null),u>=a))return u;return u}let k;r.reset(0);do if(k=r.next(n),k&&(s[u++]=(0,R.$5B)(new T.$Us(c,k.index+1+t,c,k.index+1+k[0].length+t),k,h),u>=a))return u;while(k);return u}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==I.$TB){const{node:c,remainder:t,nodeStartOffset:u}=this.G(i),s=c.piece,h=s.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&u+s.length===i&&r.length<b){this.F(c,r),this.y();return}if(u===i)this.o(r,c),this.h.validate(i);else if(u+c.piece.length>i){const d=[];let k=new m(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),this.u(h,s.end)-this.u(h,a));if(this.K()&&this.M(r)&&this.I(c,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,t-1)===13){const E=this.s(c,t-1);this.C(c,E),r="\r"+r,c.piece.length===0&&d.push(c)}else this.C(c,a);else this.C(c,a);const A=this.w(r);k.length>0&&this.S(c,k);let p=c;for(let w=0;w<A.length;w++)p=this.S(p,A[w]);this.v(d)}else this.q(r,c)}else{const c=this.w(r);let t=this.T(null,c[0]);for(let u=1;u<c.length;u++)t=this.S(t,c[u])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===I.$TB)return;const n=this.G(i),c=this.G(i+r),t=n.node,u=c.node;if(t===u){const A=this.s(t,n.remainder),p=this.s(t,c.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const w=t.next();(0,I.$YB)(this,t),this.N(w),this.y();return}this.D(t,p),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,A),this.O(t),this.y();return}this.E(t,A,p),this.y();return}const s=[],h=this.s(t,n.remainder);this.C(t,h),this.h.validate(i),t.piece.length===0&&s.push(t);const a=this.s(u,c.remainder);this.D(u,a),u.piece.length===0&&s.push(u);const d=t.next();for(let A=d;A!==I.$TB&&A!==u;A=A.next())s.push(A);const k=t.piece.length===0?t.prev():t;this.v(s),this.O(k),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const u=r.piece,s={line:u.start.line+1,column:0},h=new m(u.bufferIndex,s,u.end,this.t(u.bufferIndex,s,u.end),u.length-1);r.piece=h,i+=`
`,(0,I.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const c=this.w(i);let t=this.T(r,c[c.length-1]);for(let u=c.length-2;u>=0;u--)t=this.T(t,c[u]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),c=this.S(r,n[0]);let t=c;for(let u=1;u<n.length;u++)t=this.S(t,n[u]);this.N(c)}s(i,r,n){const c=i.piece,t=i.piece.bufferIndex,u=this.a[t].lineStarts,h=u[c.start.line]+c.start.column+r;let a=c.start.line,d=c.end.line,k=0,A=0,p=0;for(;a<=d&&(k=a+(d-a)/2|0,p=u[k],k!==d);)if(A=u[k+1],h<p)d=k-1;else if(h>=A)a=k+1;else break;return n?(n.line=k,n.column=h-p,null):{line:k,column:h-p}}t(i,r,n){if(n.column===0)return n.line-r.line;const c=this.a[i].lineStarts;if(n.line===c.length-1)return n.line-r.line;const t=c[n.line+1],u=c[n.line]+n.column;if(t>u+1)return n.line-r.line;const s=u-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,I.$YB)(this,i[r])}w(i){if(i.length>b){const d=[];for(;i.length>b;){const A=i.charCodeAt(b-1);let p;A===13||A>=55296&&A<=56319?(p=i.substring(0,b-1),i=i.substring(b-1)):(p=i.substring(0,b),i=i.substring(b));const w=L(p);d.push(new m(this.a.length,{line:0,column:0},{line:w.length-1,column:p.length-w[w.length-1]},w.length-1,p.length)),this.a.push(new v(p,w))}const k=L(i);return d.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new v(i,k)),d}let r=this.a[0].buffer.length;const n=L(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let d=0;d<n.length;d++)n[d]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let d=0;d<n.length;d++)n[d]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[u],h={line:u,column:s},a=new m(0,c,h,this.t(0,c,h),t-r);return this.g=h,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,c="";const t=this.h.get2(i);if(t){n=t.node;const u=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,h=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)c=s.substring(h+u,h+n.piece.length);else{const a=this.B(n,i-t.nodeStartLineNumber);return s.substring(h+u,h+a-r)}}else{let u=0;const s=i;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const h=this.B(n,i-n.lf_left-2),a=this.B(n,i-n.lf_left-1),d=this.a[n.piece.bufferIndex].buffer,k=this.u(n.piece.bufferIndex,n.piece.start);return u+=n.size_left,this.h.set({node:n,nodeStartOffset:u,nodeStartLineNumber:s-(i-1-n.lf_left)}),d.substring(k+h,k+a-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const h=this.B(n,i-n.lf_left-2),a=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);c=a.substring(d+h,d+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==I.$TB;){const u=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),h=this.u(n.piece.bufferIndex,n.piece.start);return c+=u.substring(h,h+s-r),c}else{const s=this.u(n.piece.bufferIndex,n.piece.start);c+=u.substr(s,n.piece.length)}n=n.next()}return c}y(){let i=this.root,r=1,n=0;for(;i!==I.$TB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,c=this.s(i,r),t=c.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const u=this.t(i.piece.bufferIndex,n.start,c);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:c.column}}B(i,r){if(r<0)return 0;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?c[n.end.line]+n.end.column-c[n.start.line]-n.start.column:c[t]-c[n.start.line]-n.start.column}C(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),u=r,s=this.u(n.bufferIndex,u),h=this.t(n.bufferIndex,n.start,u),a=h-c,d=s-t,k=n.length+d;i.piece=new m(n.bufferIndex,n.start,u,h,k),(0,I.$1B)(this,i,d,a)}D(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),u=r,s=this.t(n.bufferIndex,u,n.end),h=this.u(n.bufferIndex,u),a=s-c,d=t-h,k=n.length+d;i.piece=new m(n.bufferIndex,u,n.end,s,k),(0,I.$1B)(this,i,d,a)}E(i,r,n){const c=i.piece,t=c.start,u=c.end,s=c.length,h=c.lineFeedCnt,a=r,d=this.t(c.bufferIndex,c.start,a),k=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,a,d,k),(0,I.$1B)(this,i,k-s,d-h);const A=new m(c.bufferIndex,n,u,this.t(c.bufferIndex,n,u),this.u(c.bufferIndex,u)-this.u(c.bufferIndex,n)),p=this.S(i,A);this.N(p)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const t=L(r,!1);for(let p=0;p<t.length;p++)t[p]+=c;if(n){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[u],h={line:u,column:s},a=i.piece.length+r.length,d=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,h),A=k-d;i.piece=new m(i.piece.bufferIndex,i.piece.start,h,k,a),this.g=h,(0,I.$1B)(this,i,r.length,A)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let c=0;for(;r!==I.$TB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,c=0;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1);return c+=n.size_left,{node:n,remainder:Math.min(t+r-1,u),nodeStartOffset:c}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:c};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==I.$TB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),u=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:u}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$TB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,c=r.start.line,t=n[c]+r.start.column;return c===n.length-1||n[c+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$TB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const u=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,s,u),(0,I.$1B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const h={line:r.piece.start.line+1,column:0},a=r.piece.length-1,d=this.t(r.piece.bufferIndex,h,r.piece.end);r.piece=new m(r.piece.bufferIndex,h,r.piece.end,d,a),(0,I.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const k=this.w(`\r
`);this.S(i,k[0]);for(let A=0;A<n.length;A++)(0,I.$YB)(this,n[A])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,I.$YB)(this,n);else{const c=n.piece,t={line:c.start.line+1,column:0},u=c.length-1,s=this.t(c.bufferIndex,t,c.end);n.piece=new m(c.bufferIndex,t,c.end,s,u),(0,I.$1B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===I.$TB)return r(I.$TB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===I.$TB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,c=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(c,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,c)}S(i,r){const n=new I.$SB(r,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.right===I.$TB)i.right=n,n.parent=i;else{const t=(0,I.$UB)(i.right);t.left=n,n.parent=t}return(0,I.$ZB)(this,n),n}T(i,r){const n=new I.$SB(r,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.left===I.$TB)i.left=n,n.parent=i;else{const c=(0,I.$VB)(i.left);c.right=n,n.parent=c}return(0,I.$ZB)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$aC=f}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const R=this.a.get(I);return this.a.delete(I),R}}addDragOperationTransfer(I,R){this.a.set(I,R)}}e.$n8=D;class T{constructor(I){this.identifier=I}}e.$o8=T}),define(ke[178],Se([1,0,4,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Vd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,T.$Rc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,T.$Rc)(()=>{const L=this.b.get(b);!L||L!==y||(this.b.delete(b),L.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$tt=g;class I extends T.$Tc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class I extends T.$Tc{constructor(m,v="",S="",l=!0,f){super(),this.h=this.B(new D.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=v,this.u=S,this.w=l,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,v){this.C&&await this.C(m)}}e.$Ki=I;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Vd),this.onWillRun=this.f.event,this.m=this.B(new D.$Vd),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,v)}catch(l){S=l}this.m.fire({action:m,error:S})}async u(m,v){await m.run(v)}}e.$Li=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const S of m)S.length&&(v.length?v=[...v,new b,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=b;class ${get actions(){return this.a}constructor(m,v,S,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=l,this.a=S}async run(){}}e.$Ni=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Oi=y;function L(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Pi=L}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const T=60,g=T*60,I=g*24,R=I*7,b=I*30,$=I*365;function y(C,m,v,S){typeof C!="number"&&(C=C.getTime());const l=Math.round((new Date().getTime()-C)/1e3);if(l<-30)return(0,D.localize)(0,null,y(new Date().getTime()+l*1e3,!1));if(!S&&l<30)return(0,D.localize)(1,null);let f;return l<T?(f=l,m?f===1?v?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):v?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?v?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):v?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<g?(f=Math.floor(l/T),m?f===1?v?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):v?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?v?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):v?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<I?(f=Math.floor(l/g),m?f===1?v?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):v?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?v?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):v?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<R?(f=Math.floor(l/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<b?(f=Math.floor(l/R),m?f===1?v?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):v?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?v?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):v?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<$?(f=Math.floor(l/b),m?f===1?v?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):v?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?v?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):v?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/$),m?f===1?v?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):v?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?v?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):v?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$vm=y;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=L}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),R(C.stack)||R(C.stacktrace)):b(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Hb(C),S=$(v[0],m);return v.length>1?g.localize(4,null,S,v.length):S}if(T.$If(C))return C;if(C.detail){const v=C.detail;if(v.error)return I(v.error,m);if(v.exception)return I(v.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Qi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Ri=y;function L(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Si=L}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[10],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,g=!1,I=!1,R=!1,b=!1,$=!1,y=!1,L=!1,C=!1,m=!1,v,S=e.$g,l=e.$g,f,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",c=n&&r?.type==="renderer";if(typeof r=="object"){T=r.platform==="win32",g=r.platform==="darwin",I=r.platform==="linux",R=I&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,y=n,C=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const w=r.env.VSCODE_NLS_CONFIG;if(w)try{const E=JSON.parse(w),P=E.availableLanguages["*"];v=E.locale,l=E.osLocale,S=P||e.$g,f=E._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,T=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=o.indexOf("Linux")>=0,m=o?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=v,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=u;let s=0;g?s=1:T?s=3:I&&(s=2),e.$i=T,e.$j=g,e.$k=I,e.$l=R,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=L,e.$s=m,e.$t=C,e.$u=s,e.$v=o,e.$w=S;var h;(function(w){function E(){return e.$w}w.value=E;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=P;function F(){return e.$w==="en"}w.isDefault=F})(h||(e.Language=h={})),e.$x=v,e.$y=l,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const w=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let F=0,z=w.length;F<z;F++){const N=w[F];if(N.id===P.data.vscodeScheduleAsyncWork){w.splice(F,1),N.callback();return}}});let E=0;return P=>{const F=++E;w.push({id:F,callback:P}),i.postMessage({vscodeScheduleAsyncWork:F},"*")}}return w=>setTimeout(w)})();var a;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=g||L?2:T?1:3;let d=!0,k=!1;function A(){if(!k){k=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,d=new Uint16Array(w.buffer)[0]===(2<<8)+1}return d}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(w){return parseFloat(w)>=20}e.$J=p}),define(ke[49],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;T={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(ke[17],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,g=97,I=90,R=122,b=46,$=47,y=92,L=58,C=63;class m extends Error{constructor(u,s,h){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const d=u.indexOf(".")!==-1?"property":"argument";let k=`The "${u}" ${d} ${a} of type ${s}`;k+=`. Received type ${typeof h}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,u){if(t===null||typeof t!="object")throw new m(u,"Object",t)}function S(t,u){if(typeof t!="string")throw new m(u,"string",t)}const l=D.$dc==="win32";function f(t){return t===$||t===y}function o(t){return t===$}function i(t){return t>=T&&t<=I||t>=g&&t<=R}function r(t,u,s,h){let a="",d=0,k=-1,A=0,p=0;for(let w=0;w<=t.length;++w){if(w<t.length)p=t.charCodeAt(w);else{if(h(p))break;p=$}if(h(p)){if(!(k===w-1||A===1))if(A===2){if(a.length<2||d!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const E=a.lastIndexOf(s);E===-1?(a="",d=0):(a=a.slice(0,E),d=a.length-1-a.lastIndexOf(s)),k=w,A=0;continue}else if(a.length!==0){a="",d=0,k=w,A=0;continue}}u&&(a+=a.length>0?`${s}..`:"..",d=2)}else a.length>0?a+=`${s}${t.slice(k+1,w)}`:a=t.slice(k+1,w),d=w-k-1;k=w,A=0}else p===b&&A!==-1?++A:A=-1}return a}function n(t,u){v(u,"pathObject");const s=u.dir||u.root,h=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${h}`:`${s}${t}${h}`:h}e.$fc={resolve(...t){let u="",s="",h=!1;for(let a=t.length-1;a>=-1;a--){let d;if(a>=0){if(d=t[a],S(d,"path"),d.length===0)continue}else u.length===0?d=D.cwd():(d=D.env[`=${u}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==u.toLowerCase()&&d.charCodeAt(2)===y)&&(d=`${u}\\`));const k=d.length;let A=0,p="",w=!1;const E=d.charCodeAt(0);if(k===1)f(E)&&(A=1,w=!0);else if(f(E))if(w=!0,f(d.charCodeAt(1))){let P=2,F=P;for(;P<k&&!f(d.charCodeAt(P));)P++;if(P<k&&P!==F){const z=d.slice(F,P);for(F=P;P<k&&f(d.charCodeAt(P));)P++;if(P<k&&P!==F){for(F=P;P<k&&!f(d.charCodeAt(P));)P++;(P===k||P!==F)&&(p=`\\\\${z}\\${d.slice(F,P)}`,A=P)}}}else A=1;else i(E)&&d.charCodeAt(1)===L&&(p=d.slice(0,2),A=2,k>2&&f(d.charCodeAt(2))&&(w=!0,A=3));if(p.length>0)if(u.length>0){if(p.toLowerCase()!==u.toLowerCase())continue}else u=p;if(h){if(u.length>0)break}else if(s=`${d.slice(A)}\\${s}`,h=w,w&&u.length>0)break}return s=r(s,!h,"\\",f),h?`${u}\\${s}`:`${u}${s}`||"."},normalize(t){S(t,"path");const u=t.length;if(u===0)return".";let s=0,h,a=!1;const d=t.charCodeAt(0);if(u===1)return o(d)?"\\":t;if(f(d))if(a=!0,f(t.charCodeAt(1))){let A=2,p=A;for(;A<u&&!f(t.charCodeAt(A));)A++;if(A<u&&A!==p){const w=t.slice(p,A);for(p=A;A<u&&f(t.charCodeAt(A));)A++;if(A<u&&A!==p){for(p=A;A<u&&!f(t.charCodeAt(A));)A++;if(A===u)return`\\\\${w}\\${t.slice(p)}\\`;A!==p&&(h=`\\\\${w}\\${t.slice(p,A)}`,s=A)}}}else s=1;else i(d)&&t.charCodeAt(1)===L&&(h=t.slice(0,2),s=2,u>2&&f(t.charCodeAt(2))&&(a=!0,s=3));let k=s<u?r(t.slice(s),!a,"\\",f):"";return k.length===0&&!a&&(k="."),k.length>0&&f(t.charCodeAt(u-1))&&(k+="\\"),h===void 0?a?`\\${k}`:k:a?`${h}\\${k}`:`${h}${k}`},isAbsolute(t){S(t,"path");const u=t.length;if(u===0)return!1;const s=t.charCodeAt(0);return f(s)||u>2&&i(s)&&t.charCodeAt(1)===L&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,s;for(let d=0;d<t.length;++d){const k=t[d];S(k,"path"),k.length>0&&(u===void 0?u=s=k:u+=`\\${k}`)}if(u===void 0)return".";let h=!0,a=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++a;const d=s.length;d>1&&f(s.charCodeAt(1))&&(++a,d>2&&(f(s.charCodeAt(2))?++a:h=!1))}if(h){for(;a<u.length&&f(u.charCodeAt(a));)a++;a>=2&&(u=`\\${u.slice(a)}`)}return e.$fc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u)return"";const s=e.$fc.resolve(t),h=e.$fc.resolve(u);if(s===h||(t=s.toLowerCase(),u=h.toLowerCase(),t===u))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===y;)a++;let d=t.length;for(;d-1>a&&t.charCodeAt(d-1)===y;)d--;const k=d-a;let A=0;for(;A<u.length&&u.charCodeAt(A)===y;)A++;let p=u.length;for(;p-1>A&&u.charCodeAt(p-1)===y;)p--;const w=p-A,E=k<w?k:w;let P=-1,F=0;for(;F<E;F++){const N=t.charCodeAt(a+F);if(N!==u.charCodeAt(A+F))break;N===y&&(P=F)}if(F!==E){if(P===-1)return h}else{if(w>E){if(u.charCodeAt(A+F)===y)return h.slice(A+F+1);if(F===2)return h.slice(A+F)}k>E&&(t.charCodeAt(a+F)===y?P=F:F===2&&(P=3)),P===-1&&(P=0)}let z="";for(F=a+P+1;F<=d;++F)(F===d||t.charCodeAt(F)===y)&&(z+=z.length===0?"..":"\\..");return A+=P,z.length>0?`${z}${h.slice(A,p)}`:(h.charCodeAt(A)===y&&++A,h.slice(A,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===y){if(u.charCodeAt(1)===y){const s=u.charCodeAt(2);if(s!==C&&s!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(i(u.charCodeAt(0))&&u.charCodeAt(1)===L&&u.charCodeAt(2)===y)return`\\\\?\\${u}`;return t},dirname(t){S(t,"path");const u=t.length;if(u===0)return".";let s=-1,h=0;const a=t.charCodeAt(0);if(u===1)return f(a)?t:".";if(f(a)){if(s=h=1,f(t.charCodeAt(1))){let A=2,p=A;for(;A<u&&!f(t.charCodeAt(A));)A++;if(A<u&&A!==p){for(p=A;A<u&&f(t.charCodeAt(A));)A++;if(A<u&&A!==p){for(p=A;A<u&&!f(t.charCodeAt(A));)A++;if(A===u)return t;A!==p&&(s=h=A+1)}}}}else i(a)&&t.charCodeAt(1)===L&&(s=u>2&&f(t.charCodeAt(2))?3:2,h=s);let d=-1,k=!0;for(let A=u-1;A>=h;--A)if(f(t.charCodeAt(A))){if(!k){d=A;break}}else k=!1;if(d===-1){if(s===-1)return".";d=s}return t.slice(0,d)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,h=-1,a=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,A=-1;for(d=t.length-1;d>=s;--d){const p=t.charCodeAt(d);if(f(p)){if(!a){s=d+1;break}}else A===-1&&(a=!1,A=d+1),k>=0&&(p===u.charCodeAt(k)?--k===-1&&(h=d):(k=-1,h=A))}return s===h?h=A:h===-1&&(h=t.length),t.slice(s,h)}for(d=t.length-1;d>=s;--d)if(f(t.charCodeAt(d))){if(!a){s=d+1;break}}else h===-1&&(a=!1,h=d+1);return h===-1?"":t.slice(s,h)},extname(t){S(t,"path");let u=0,s=-1,h=0,a=-1,d=!0,k=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(u=h=2);for(let A=t.length-1;A>=u;--A){const p=t.charCodeAt(A);if(f(p)){if(!d){h=A+1;break}continue}a===-1&&(d=!1,a=A+1),p===b?s===-1?s=A:k!==1&&(k=1):s!==-1&&(k=-1)}return s===-1||a===-1||k===0||k===1&&s===a-1&&s===h+1?"":t.slice(s,a)},format:n.bind(null,"\\"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.length;let h=0,a=t.charCodeAt(0);if(s===1)return f(a)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(a)){if(h=1,f(t.charCodeAt(1))){let P=2,F=P;for(;P<s&&!f(t.charCodeAt(P));)P++;if(P<s&&P!==F){for(F=P;P<s&&f(t.charCodeAt(P));)P++;if(P<s&&P!==F){for(F=P;P<s&&!f(t.charCodeAt(P));)P++;P===s?h=P:P!==F&&(h=P+1)}}}}else if(i(a)&&t.charCodeAt(1)===L){if(s<=2)return u.root=u.dir=t,u;if(h=2,f(t.charCodeAt(2))){if(s===3)return u.root=u.dir=t,u;h=3}}h>0&&(u.root=t.slice(0,h));let d=-1,k=h,A=-1,p=!0,w=t.length-1,E=0;for(;w>=h;--w){if(a=t.charCodeAt(w),f(a)){if(!p){k=w+1;break}continue}A===-1&&(p=!1,A=w+1),a===b?d===-1?d=w:E!==1&&(E=1):d!==-1&&(E=-1)}return A!==-1&&(d===-1||E===0||E===1&&d===A-1&&d===k+1?u.base=u.name=t.slice(k,A):(u.name=t.slice(k,d),u.base=t.slice(k,A),u.ext=t.slice(d,A))),k>0&&k!==h?u.dir=t.slice(0,k-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(l){const t=/\\/g;return()=>{const u=D.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let u="",s=!1;for(let h=t.length-1;h>=-1&&!s;h--){const a=h>=0?t[h]:c();S(a,"path"),a.length!==0&&(u=`${a}/${u}`,s=a.charCodeAt(0)===$)}return u=r(u,!s,"/",o),s?`/${u}`:u.length>0?u:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!u,"/",o),t.length===0?u?"/":s?"./":".":(s&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let u;for(let s=0;s<t.length;++s){const h=t[s];S(h,"path"),h.length>0&&(u===void 0?u=h:u+=`/${h}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const s=1,h=t.length,a=h-s,d=1,k=u.length-d,A=a<k?a:k;let p=-1,w=0;for(;w<A;w++){const P=t.charCodeAt(s+w);if(P!==u.charCodeAt(d+w))break;P===$&&(p=w)}if(w===A)if(k>A){if(u.charCodeAt(d+w)===$)return u.slice(d+w+1);if(w===0)return u.slice(d+w)}else a>A&&(t.charCodeAt(s+w)===$?p=w:w===0&&(p=0));let E="";for(w=s+p+1;w<=h;++w)(w===h||t.charCodeAt(w)===$)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(d+p)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$;let s=-1,h=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!h){s=a;break}}else h=!1;return s===-1?u?"/":".":u&&s===1?"//":t.slice(0,s)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,h=-1,a=!0,d;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,A=-1;for(d=t.length-1;d>=0;--d){const p=t.charCodeAt(d);if(p===$){if(!a){s=d+1;break}}else A===-1&&(a=!1,A=d+1),k>=0&&(p===u.charCodeAt(k)?--k===-1&&(h=d):(k=-1,h=A))}return s===h?h=A:h===-1&&(h=t.length),t.slice(s,h)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===$){if(!a){s=d+1;break}}else h===-1&&(a=!1,h=d+1);return h===-1?"":t.slice(s,h)},extname(t){S(t,"path");let u=-1,s=0,h=-1,a=!0,d=0;for(let k=t.length-1;k>=0;--k){const A=t.charCodeAt(k);if(A===$){if(!a){s=k+1;break}continue}h===-1&&(a=!1,h=k+1),A===b?u===-1?u=k:d!==1&&(d=1):u!==-1&&(d=-1)}return u===-1||h===-1||d===0||d===1&&u===h-1&&u===s+1?"":t.slice(u,h)},format:n.bind(null,"/"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.charCodeAt(0)===$;let h;s?(u.root="/",h=1):h=0;let a=-1,d=0,k=-1,A=!0,p=t.length-1,w=0;for(;p>=h;--p){const E=t.charCodeAt(p);if(E===$){if(!A){d=p+1;break}continue}k===-1&&(A=!1,k=p+1),E===b?a===-1?a=p:w!==1&&(w=1):a!==-1&&(w=-1)}if(k!==-1){const E=d===0&&s?1:d;a===-1||w===0||w===1&&a===k-1&&a===d+1?u.base=u.name=t.slice(E,k):(u.name=t.slice(E,a),u.base=t.slice(E,k),u.ext=t.slice(a,k))}return d>0?u.dir=t.slice(0,d-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,17]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const g=new D.$V(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(A,p,w=!1){const E=A||"",P=p||"",F=g.value.collator.compare(E,P);return g.value.collatorIsNumeric&&F===0&&E!==P?E<P?-1:1:F}e.$Iq=b;function $(A,p){const w=I.value.collator;return A=A||"",p=p||"",n(w,A,p)}e.$Jq=$;function y(A,p){const w=I.value.collator;return A=A||"",p=p||"",s(A,p)||n(w,A,p)}e.$Kq=y;function L(A,p){const w=I.value.collator;return A=A||"",p=p||"",u(A,p)||n(w,A,p)}e.$Lq=L;function C(A,p){return A=A||"",p=p||"",A===p?0:A<p?-1:1}e.$Mq=C;function m(A,p){const[w,E]=i(A),[P,F]=i(p);let z=g.value.collator.compare(E,F);if(z===0){if(g.value.collatorIsNumeric&&E!==F)return E<F?-1:1;if(z=g.value.collator.compare(w,P),g.value.collatorIsNumeric&&z===0&&w!==P)return w<P?-1:1}return z}e.$Nq=m;function v(A,p){A=A||"",p=p||"";const w=r(A),E=r(p),P=I.value.collator,F=R.value.collator;return n(F,w,E)||n(P,A,p)}e.$Oq=v;function S(A,p){A=A||"",p=p||"";const w=r(A),E=r(p),P=I.value.collator,F=R.value.collator;return n(F,w,E)||s(A,p)||n(P,A,p)}e.$Pq=S;function l(A,p){A=A||"",p=p||"";const w=r(A),E=r(p),P=I.value.collator,F=R.value.collator;return n(F,w,E)||u(A,p)||n(P,A,p)}e.$Qq=l;function f(A,p){A=A||"",p=p||"";const w=r(A).toLowerCase(),E=r(p).toLowerCase();return w!==E?w<E?-1:1:A!==p?A<p?-1:1:0}e.$Rq=f;const o=/^(.*?)(\.([^.]*))?$/;function i(A,p=!1){const w=A?o.exec(A):[];let E=[w&&w[1]||"",w&&w[3]||""];return p&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function r(A){const p=A?o.exec(A):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function n(A,p,w){const E=A.compare(p,w);return E!==0?E:p.length!==w.length?p.length<w.length?-1:1:0}function c(A){const p=A.charAt(0);return p.toLocaleUpperCase()!==p}function t(A){const p=A.charAt(0);return p.toLocaleLowerCase()!==p}function u(A,p){return c(A)&&t(p)?-1:t(A)&&c(p)?1:0}function s(A,p){return t(A)&&c(p)?-1:c(A)&&t(p)?1:0}function h(A,p,w=!1){return w||(A=A&&A.toLowerCase(),p=p&&p.toLowerCase()),A===p?0:A<p?-1:1}function a(A,p,w=!1){const E=A.split(T.sep),P=p.split(T.sep),F=E.length-1,z=P.length-1;let N,j;for(let M=0;;M++){if(N=F===M,j=z===M,N&&j)return b(E[M],P[M],w);if(N)return-1;if(j)return 1;const O=h(E[M],P[M],w);if(O!==0)return O}}e.$Sq=a;function d(A,p,w){const E=A.toLowerCase(),P=p.toLowerCase(),F=k(A,p,w);if(F)return F;const z=E.endsWith(w),N=P.endsWith(w);if(z!==N)return z?-1:1;const j=b(E,P);return j!==0?j:E.localeCompare(P)}e.$Tq=d;function k(A,p,w){const E=A.toLowerCase(),P=p.toLowerCase(),F=E.startsWith(w),z=P.startsWith(w);if(F!==z)return F?-1:1;if(F&&z){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}e.$Uq=k}),define(ke[33],Se([1,0,17,10,12,18]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function R(d){return d===47||d===92}e.$1f=R;function b(d){return d.replace(/[\\/]/g,D.$gc.sep)}e.$2f=b;function $(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$3f=$;function y(d,k=D.$gc.sep){if(!d)return"";const A=d.length,p=d.charCodeAt(0);if(R(p)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let E=3;const P=E;for(;E<A&&!R(d.charCodeAt(E));E++);if(P!==E&&!R(d.charCodeAt(E+1))){for(E+=1;E<A;E++)if(R(d.charCodeAt(E)))return d.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(o(p)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+k:d.slice(0,2);let w=d.indexOf("://");if(w!==-1){for(w+=3;w<A;w++)if(R(d.charCodeAt(w)))return d.slice(0,w+1)}return""}e.$4f=y;function L(d){if(!T.$i||!d||d.length<5)return!1;let k=d.charCodeAt(0);if(k!==92||(k=d.charCodeAt(1),k!==92))return!1;let A=2;const p=A;for(;A<d.length&&(k=d.charCodeAt(A),k!==92);A++);return!(p===A||(k=d.charCodeAt(A+1),isNaN(k)||k===92))}e.$5f=L;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,k=T.$i){const A=k?C:m;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||k&&v.test(d)||d==="."||d===".."||k&&d[d.length-1]==="."||k&&d.length!==d.trim().length||d.length>255)}e.$6f=S;function l(d,k,A){const p=d===k;return!A||p?p:!d||!k?!1:(0,g.$_e)(d,k)}e.$7f=l;function f(d,k,A,p=D.sep){if(d===k)return!0;if(!d||!k||k.length>d.length)return!1;if(A){if(!(0,g.$af)(d,k))return!1;if(k.length===d.length)return!0;let E=k.length;return k.charAt(k.length-1)===p&&E--,d.charAt(E)===p}return k.charAt(k.length-1)!==p&&(k+=p),d.indexOf(k)===0}e.$8f=f;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$9f=o;function i(d,k){return T.$i&&d.endsWith(":")&&(d+=D.sep),(0,D.$ic)(d)||(d=(0,D.$jc)(k,d)),d=(0,D.$hc)(d),T.$i?(d=(0,g.$Ue)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,g.$Ue)(d,D.sep),d||(d=D.sep)),d}e.$0f=i;function r(d){const k=(0,D.$hc)(d);return T.$i?d.length>3?!1:n(k)&&(d.length===2||k.charCodeAt(2)===92):k===D.$gc.sep}e.$$f=r;function n(d,k=T.$i){return k?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$_f=n;function c(d,k=T.$i){return n(d,k)?d[0]:void 0}e.$ag=c;function t(d,k,A){return k.length>d.length?-1:d===k?0:(A&&(d=d.toLowerCase(),k=k.toLowerCase()),d.indexOf(k))}e.$bg=t;function u(d){const k=d.split(":");let A,p,w;for(const E of k){const P=Number(E);(0,I.$Mf)(P)?p===void 0?p=P:w===void 0&&(w=P):A=A?[A,E].join(":"):E}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:p!==void 0?p:void 0,column:w!==void 0?w:p!==void 0?1:void 0}}e.$cg=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(d,k,A=8){let p="";for(let E=0;E<A;E++){let P;E===0&&T.$i&&!k&&(A===3||A===4)?P=h:P=s,p+=P.charAt(Math.floor(Math.random()*P.length))}let w;return k?w=`${k}-${p}`:w=p,d?(0,D.$jc)(d,w):w}e.$dg=a}),define(ke[129],Se([1,0,128,123,54,17,10,12]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;const $=0,y=[$,[]];function L(U,Y,le,Z){if(!U||!Y)return y;const J=U.length,X=Y.length;if(J<X)return y;const ue=U.toLowerCase();return C(Y,le,X,U,ue,J,Z)}e.$Vq=L;function C(U,Y,le,Z,J,X,ue){const x=[],be=[];for(let re=0;re<le;re++){const ye=re*X,de=ye-X,ge=re>0,_=U[re],te=Y[re];for(let G=0;G<X;G++){const ie=G>0,fe=ye+G,ve=fe-1,Pe=de+G-1,we=ie?x[ve]:0,De=ge&&ie?x[Pe]:0,B=ge&&ie?be[Pe]:0;let Q;!De&&ge?Q=0:Q=m(_,te,Z,J,G,B),Q&&De+Q>=we&&(ue||ge||J.startsWith(Y,G))?(be[fe]=B+1,x[fe]=De+Q):(be[fe]=$,x[fe]=we)}}const ce=[];let K=le-1,V=X-1;for(;K>=0&&V>=0;){const re=K*X+V;be[re]===$||(ce.push(V),K--),V--}return[x[le*X-1],ce.reverse()]}function m(U,Y,le,Z,J,X){let ue=0;if(!v(Y,Z[J]))return ue;if(ue+=1,X>0&&(ue+=X*5),U===le[J]&&(ue+=1),J===0)ue+=8;else{const x=S(le.charCodeAt(J-1));x?ue+=x:(0,T.$Xj)(le.charCodeAt(J))&&X===0&&(ue+=2)}return ue}function v(U,Y){return U===Y?!0:U==="/"||U==="\\"?Y==="/"||Y==="\\":!1}function S(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(U,Y,le=0,Z=0){const J=Y;return J.values&&J.values.length>1?o(U,J.values,le,Z):i(U,Y,le,Z)}e.$Wq=f;function o(U,Y,le,Z){let J=0;const X=[];for(const ue of Y){const[x,be]=i(U,ue,le,Z);if(typeof x!="number")return l;J+=x,X.push(...be)}return[J,A(X)]}function i(U,Y,le,Z){const J=(0,T.$7j)(Y.original,Y.originalLowercase,le,U,U.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,T.$4j)(J)]:l}const r=Object.freeze({score:0}),n=1<<18,c=1<<17,t=1<<16;function u(U,Y,le,Z){const J=Z.values?Z.values:[Z];return(0,g.$Ti)({[Z.normalized]:{values:J.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:U,description:Y,allowNonContiguousMatches:le}})}function s(U,Y,le,Z,J){if(!U||!Y.normalized)return r;const X=Z.getItemLabel(U);if(!X)return r;const ue=Z.getItemDescription(U),x=u(X,ue,le,Y),be=J[x];if(be)return be;const ce=h(X,ue,Z.getItemPath(U),Y,le);return J[x]=ce,ce}e.$Xq=s;function h(U,Y,le,Z,J){const X=!le||!Z.containsPathSeparator;return le&&(R.$k?Z.pathNormalized===le:(0,b.$_e)(Z.pathNormalized,le))?{score:n,labelMatch:[{start:0,end:U.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:Z.values&&Z.values.length>1?a(U,Y,le,Z.values,X,J):d(U,Y,le,Z,X,J)}function a(U,Y,le,Z,J,X){let ue=0;const x=[],be=[];for(const ce of Z){const{score:K,labelMatch:V,descriptionMatch:re}=d(U,Y,le,ce,J,X);if(K===$)return r;ue+=K,V&&x.push(...V),re&&be.push(...re)}return{score:ue,labelMatch:A(x),descriptionMatch:A(be)}}function d(U,Y,le,Z,J,X){if(J||!Y){const[ue,x]=L(U,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(ue){const be=(0,T.$Uj)(Z.normalized,U);let ce;if(be){ce=c;const K=Math.round(Z.normalized.length/U.length*100);ce+=K}else ce=t;return{score:ce+ue,labelMatch:be||k(x)}}}if(Y){let ue=Y;le&&(ue=`${Y}${I.sep}`);const x=ue.length,be=`${ue}${U}`,[ce,K]=L(be,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(ce){const V=k(K),re=[],ye=[];return V.forEach(de=>{de.start<x&&de.end>x?(re.push({start:0,end:de.end-x}),ye.push({start:de.start,end:x})):de.start>=x?re.push({start:de.start-x,end:de.end-x}):ye.push(de)}),{score:ce,labelMatch:re,descriptionMatch:ye}}}return r}function k(U){const Y=[];if(!U)return Y;let le;for(const Z of U)le&&le.end===Z?le.end+=1:(le={start:Z,end:Z+1},Y.push(le));return Y}function A(U){const Y=U.sort((J,X)=>J.start-X.start),le=[];let Z;for(const J of Y)!Z||!p(Z,J)?(Z=J,le.push(J)):(Z.start=Math.min(Z.start,J.start),Z.end=Math.max(Z.end,J.end));return le}function p(U,Y){return!(U.end<Y.start||Y.end<U.start)}function w(U,Y,le,Z,J,X){const ue=s(U,le,Z,J,X),x=s(Y,le,Z,J,X),be=ue.score,ce=x.score;if((be===n||ce===n)&&be!==ce)return be===n?-1:1;if(be>t||ce>t){if(be!==ce)return be>ce?-1:1;if(be<c&&ce<c){const _=P(ue.labelMatch,x.labelMatch);if(_!==0)return _}const de=J.getItemLabel(U)||"",ge=J.getItemLabel(Y)||"";if(de.length!==ge.length)return de.length-ge.length}if(be!==ce)return be>ce?-1:1;const K=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,V=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(K&&!V)return-1;if(V&&!K)return 1;const re=E(U,ue,J),ye=E(Y,x,J);return re&&ye&&re!==ye?ye>re?-1:1:F(U,Y,le,J)}e.$Yq=w;function E(U,Y,le){let Z=-1,J=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?Z=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(Z=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(J=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const X=le.getItemDescription(U);X&&(J+=X.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(J=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return J-Z}function P(U,Y){if(!U&&!Y||(!U||!U.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!U||!U.length)return 1;const le=U[0].start,J=U[U.length-1].end-le,X=Y[0].start,x=Y[Y.length-1].end-X;return J===x?0:x<J?1:-1}function F(U,Y,le,Z){const J=Z.getItemLabel(U)||"",X=Z.getItemLabel(Y)||"",ue=Z.getItemDescription(U),x=Z.getItemDescription(Y),be=J.length+(ue?ue.length:0),ce=X.length+(x?x.length:0);if(be!==ce)return be-ce;const K=Z.getItemPath(U),V=Z.getItemPath(Y);return K&&V&&K.length!==V.length?K.length-V.length:J!==X?(0,D.$Tq)(J,X,le.normalized):ue&&x&&ue!==x?(0,D.$Tq)(ue,x,le.normalized):K&&V&&K!==V?(0,D.$Tq)(K,V,le.normalized):0}function z(U){return U.startsWith('"')&&U.endsWith('"')}const N=" ";function j(U){typeof U!="string"&&(U="");const Y=U.toLowerCase(),{pathNormalized:le,normalized:Z,normalizedLowercase:J}=M(U),X=le.indexOf(I.sep)>=0,ue=z(U);let x;const be=U.split(N);if(be.length>1)for(const ce of be){const K=z(ce),{pathNormalized:V,normalized:re,normalizedLowercase:ye}=M(ce);re&&(x||(x=[]),x.push({original:ce,originalLowercase:ce.toLowerCase(),pathNormalized:V,normalized:re,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:U,originalLowercase:Y,pathNormalized:le,normalized:Z,normalizedLowercase:J,values:x,containsPathSeparator:X,expectContiguousMatch:ue}}e.$Zq=j;function M(U){let Y;R.$i?Y=U.replace(/\//g,I.sep):Y=U.replace(/\\/g,I.sep);const le=(0,b.$We)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:le,normalizedLowercase:le.toLowerCase()}}function O(U){return Array.isArray(U)?j(U.map(Y=>Y.original).join(N)):j(U.original)}e.$1q=O}),define(ke[101],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(L){const C=(0,D.$oc)(L),m=T[C.toLowerCase()];return m!==void 0?m:R(L)}e.$gs=I;function R(L){const C=(0,D.$oc)(L);return g[C.toLowerCase()]}e.$hs=R;function b(L){for(const C in g)if(g[C]===L)return C}e.$is=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(L,C){const m=$.exec(L);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:L}e.$js=y}),define(ke[102],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<L.length;v++)if(m.search(L[v])!==-1){delete b[m];break}})}e.$Rl=I;function R(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Sl=R}),define(ke[2],Se([1,0,17,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,R=/^\/\//;function b(h,a){if(!h.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!g.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!I.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(h,a){return!h&&!a?"file":h}function y(h,a){switch(h){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const L="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(a){return a instanceof v?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,d,k,A,p,w=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=$(a,w),this.authority=d||L,this.path=y(this.scheme,k||L),this.query=A||L,this.fragment=p||L,b(this,w))}get fsPath(){return n(this,!1)}with(a){if(!a)return this;let{scheme:d,authority:k,path:A,query:p,fragment:w}=a;return d===void 0?d=this.scheme:d===null&&(d=L),k===void 0?k=this.authority:k===null&&(k=L),A===void 0?A=this.path:A===null&&(A=L),p===void 0?p=this.query:p===null&&(p=L),w===void 0?w=this.fragment:w===null&&(w=L),d===this.scheme&&k===this.authority&&A===this.path&&p===this.query&&w===this.fragment?this:new f(d,k,A,p,w)}static parse(a,d=!1){const k=m.exec(a);return k?new f(k[2]||L,s(k[4]||L),s(k[5]||L),s(k[7]||L),s(k[9]||L),d):new f(L,L,L,L,L)}static file(a){let d=L;if(T.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const k=a.indexOf(C,2);k===-1?(d=a.substring(2),a=C):(d=a.substring(2,k),a=a.substring(k)||C)}return new f("file",d,a,L,L)}static from(a,d){return new f(a.scheme,a.authority,a.path,a.query,a.fragment,d)}static joinPath(a,...d){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$i&&a.scheme==="file"?k=v.file(D.$fc.join(n(a,!0),...d)).path:k=D.$gc.join(a.path,...d),a.with({path:k})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof v)return a;{const d=new f(a);return d._formatted=a.external??null,d._fsPath=a._sep===l?a.fsPath??null:null,d}}else return a}}e.URI=v;function S(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}e.$vc=S;const l=T.$i?1:void 0;class f extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=l),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(h,a,d){let k,A=-1;for(let p=0;p<h.length;p++){const w=h.charCodeAt(p);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||a&&w===47||d&&w===91||d&&w===93||d&&w===58)A!==-1&&(k+=encodeURIComponent(h.substring(A,p)),A=-1),k!==void 0&&(k+=h.charAt(p));else{k===void 0&&(k=h.substr(0,p));const E=o[w];E!==void 0?(A!==-1&&(k+=encodeURIComponent(h.substring(A,p)),A=-1),k+=E):A===-1&&(A=p)}}return A!==-1&&(k+=encodeURIComponent(h.substring(A))),k!==void 0?k:h}function r(h){let a;for(let d=0;d<h.length;d++){const k=h.charCodeAt(d);k===35||k===63?(a===void 0&&(a=h.substr(0,d)),a+=o[k]):a!==void 0&&(a+=h[d])}return a!==void 0?a:h}function n(h,a){let d;return h.authority&&h.path.length>1&&h.scheme==="file"?d=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?a?d=h.path.substr(1):d=h.path[1].toLowerCase()+h.path.substr(2):d=h.path,T.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=n;function c(h,a){const d=a?r:i;let k="",{scheme:A,authority:p,path:w,query:E,fragment:P}=h;if(A&&(k+=A,k+=":"),(p||A==="file")&&(k+=C,k+=C),p){let F=p.indexOf("@");if(F!==-1){const z=p.substr(0,F);p=p.substr(F+1),F=z.lastIndexOf(":"),F===-1?k+=d(z,!1,!1):(k+=d(z.substr(0,F),!1,!1),k+=":",k+=d(z.substr(F+1),!1,!0)),k+="@"}p=p.toLowerCase(),F=p.lastIndexOf(":"),F===-1?k+=d(p,!1,!0):(k+=d(p.substr(0,F),!1,!0),k+=p.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const F=w.charCodeAt(1);F>=65&&F<=90&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const F=w.charCodeAt(0);F>=65&&F<=90&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}k+=d(w,!0,!1)}return E&&(k+="?",k+=d(E,!1,!1)),P&&(k+="#",k+=a?P:i(P,!1,!1)),k}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(h){return h.match(u)?h.replace(u,a=>t(a)):h}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function T(y){const L=y;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$mq=T;function g(y){const L=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),L.push(...m)}catch{L.push("Unable to log remote console arguments",y.arguments)}return{args:L,stack:C}}e.$nq=g;function I(y){if(typeof y!="string")return I(g(y).stack);const L=y;if(L){const C=R(L),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$oq=I;function R(y){if(!y)return y;const L=y.indexOf(`
`);return L===-1?y:y.substring(0,L)}function b(y,L){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let S=R(m);S&&(S=`(${S.trim()})`);let l=[];if(typeof C[0]=="string"?S&&v?l=[`%c[${L}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:l=[`%c[${L}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${L}]%`,$("blue"),...C],S&&!v&&l.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,l)}e.log=b;function $(y){return`color: ${y}`}}),define(ke[55],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function g($){return JSON.stringify($,R)}e.$Ah=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$Bh=I;function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return T.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$je||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let L=0;L<$.length;++L)$[L]=b($[L],y+1);else for(const L in $)Object.hasOwnProperty.call($,L)&&($[L]=b($[L],y+1))}return $}e.$Ch=b}),define(ke[16],Se([1,0,14,10,12,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function b(m,v){return I.URI.isUri(m)?(0,g.$_e)(m.scheme,v):(0,g.$af)(m,v+":")}e.$eg=b;function $(m,...v){return v.some(S=>b(m,S))}e.$fg=$,e.$gg="vscode-tkn",e.$hg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,S,l){this.a[v]=S,this.b[v]=l}setConnectionToken(v,S){this.c[v]=S}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(r){return D.$1(r),v}const S=v.authority;let l=this.a[S];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(v.path)}`;return typeof o=="string"&&(i+=`&${e.$hg}=${encodeURIComponent(o)}`),I.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:i})}}e.$ig=new y,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class L{static{this.a=e.$ng}asBrowserUri(v){const S=this.b(v,me);return this.uriToBrowserUri(S)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$ig.rewrite(v):v.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${L.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||L.a,query:null,fragment:null}):v}asFileUri(v){const S=this.b(v,me);return this.uriToFileUri(S)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==L.a?v.authority:null,query:null,fragment:null}):v}b(v,S){return I.URI.isUri(v)?v:I.URI.parse(S.toUrl(v))}}e.$og=new L;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const S="vscode-coi";function l(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:I.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(S);if(r)return v.get(r)}m.getHeadersFromQuery=l;function f(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}m.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,16,10,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class R{constructor(m,v,S){this.id=m,this.dependencies=v,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,S)=>{typeof m!="string"&&(S=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new R(m,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,S)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",o),l.removeEventListener("error",i)},o=r=>{f(),v(this.c.pop())},i=r=>{f(),S(r)};l.addEventListener("load",o),l.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((v,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(l){S(l)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,o=v.readFileSync(f).toString(),i=l.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function L(C,m,v){if(D.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let l;if(/^\w[\w\d+.-]*:\/\//.test(S))l=S;else{const r=`${v&&!g.$o?T.$lg:T.$kg}/${S}`;l=T.$og.asBrowserUri(r).toString(!0)}const f=b.INSTANCE.load(l);return $.set(S,f),f}else return await new Promise((S,l)=>{me([C],S,l)})}e.$fD=L}),define(ke[23],Se([1,0,33,16,17,10,12,2]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function $(v){return(0,b.$wc)(v,!0)}e.$vg=$;class y{constructor(S){this.a=S}compare(S,l,f=!1){return S===l?0:(0,R.$5e)(this.getComparisonKey(S,f),this.getComparisonKey(l,f))}isEqual(S,l,f=!1){return S===l?!0:!S||!l?!1:this.getComparisonKey(S,f)===this.getComparisonKey(l,f)}getComparisonKey(S,l=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,l,f=!1){if(S.scheme===l.scheme){if(S.scheme===T.Schemas.file)return D.$8f($(S),$(l),this.a(S))&&S.query===l.query&&(f||S.fragment===l.fragment);if((0,e.$Mg)(S.authority,l.authority))return D.$8f(S.path,l.path,this.a(S),"/")&&S.query===l.query&&(f||S.fragment===l.fragment)}return!1}joinPath(S,...l){return b.URI.joinPath(S,...l)}basenameOrAuthority(S){return(0,e.$Eg)(S)||S.authority}basename(S){return g.$gc.basename(S.path)}extname(S){return g.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let l;return S.scheme===T.Schemas.file?l=b.URI.file(g.$mc($(S))).path:(l=g.$gc.dirname(S.path),S.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),l="/")),S.with({path:l})}normalizePath(S){if(!S.path.length)return S;let l;return S.scheme===T.Schemas.file?l=b.URI.file(g.$hc($(S))).path:l=g.$gc.normalize(S.path),S.with({path:l})}relativePath(S,l){if(S.scheme!==l.scheme||!(0,e.$Mg)(S.authority,l.authority))return;if(S.scheme===T.Schemas.file){const i=g.$lc($(S),$(l));return I.$i?D.$2f(i):i}let f=S.path||"/";const o=l.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(f.length,o.length);i<r&&!(f.charCodeAt(i)!==o.charCodeAt(i)&&f.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);f=o.substr(0,i)+f.substr(i)}return g.$gc.relative(f,o)}resolvePath(S,l){if(S.scheme===T.Schemas.file){const f=b.URI.file(g.$kc($(S),l));return S.with({authority:f.authority,path:f.path})}return l=D.$3f(l),S.with({path:g.$gc.resolve(S.path,l)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,l){return S===l||S!==void 0&&l!==void 0&&(0,R.$_e)(S,l)}hasTrailingPathSeparator(S,l=g.sep){if(S.scheme===T.Schemas.file){const f=$(S);return f.length>D.$4f(f).length&&f[f.length-1]===l}else{const f=S.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,l=g.sep){return(0,e.$Ng)(S,l)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,l=g.sep){let f=!1;if(S.scheme===T.Schemas.file){const o=$(S);f=o!==void 0&&o.length===D.$4f(o).length&&o[o.length-1]===l}else{l="/";const o=S.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$Ng)(S,l)?S.with({path:S.path+"/"}):S}}e.$wg=y,e.$xg=new y(()=>!1),e.$yg=new y(v=>v.scheme===T.Schemas.file?!I.$k:!0),e.$zg=new y(v=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function L(v,S){const l=[];for(let f=0;f<v.length;f++){const o=S(v[f]);v.some((i,r)=>r===f?!1:(0,e.$Bg)(o,S(i)))||l.push(v[f])}return l}e.$Qg=L;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,c]=r.split(":");n&&c&&f.set(n,c)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&f.set(v.META_DATA_MIME,i),f}v.parseMetaData=S})(C||(e.DataUri=C={}));function m(v,S,l){if(S){let f=v.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),v.with({scheme:l,authority:S,path:f})}return v.with({scheme:l})}e.$Rg=m}),define(ke[11],Se([1,0,21,14,4,3,23,10,163,43]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function L(_){return!!_&&typeof _.then=="function"}e.$Sg=L;function C(_){const te=new D.$6d,G=_(te.token),ie=new Promise((fe,ve)=>{const Pe=te.token.onCancellationRequested(()=>{Pe.dispose(),ve(new T.$5)});Promise.resolve(G).then(we=>{Pe.dispose(),te.dispose(),fe(we)},we=>{Pe.dispose(),te.dispose(),ve(we)})});return new class{cancel(){te.cancel(),te.dispose()}then(fe,ve){return ie.then(fe,ve)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.$Tg=C;function m(_,te,G){return new Promise((ie,fe)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ie(G)});_.then(ie,fe).finally(()=>ve.dispose())})}e.$Ug=m;function v(_,te){return new Promise((G,ie)=>{const fe=te.onCancellationRequested(()=>{fe.dispose(),ie(new T.$5)});_.then(G,ie).finally(()=>fe.dispose())})}e.$Vg=v;async function S(_){let te=-1;const G=_.map((ie,fe)=>ie.then(ve=>(te=fe,ve)));try{return await Promise.race(G)}finally{_.forEach((ie,fe)=>{fe!==te&&ie.cancel()})}}e.$Wg=S;function l(_,te,G){let ie;const fe=setTimeout(()=>{ie?.(void 0),G?.()},te);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(ve=>ie=ve)])}e.$Xg=l;function f(_){return new Promise((te,G)=>{const ie=_();L(ie)?ie.then(te,G):te(ie)})}e.$Yg=f;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const G=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(G,G).then(ie)})}return new Promise((G,ie)=>{this.b.then(G,ie)})}return this.a=te(),new Promise((G,ie)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,ie(fe)})})}dispose(){this.f=!0}}e.$Zg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=i;class r{constructor(){this.a=new Map}queue(te,G){const fe=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(te)===fe&&this.a.delete(te)});return this.a.set(te,fe),fe}}e.$2g=r;const n=(_,te)=>{let G=!0;const ie=setTimeout(()=>{G=!1,te()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ie),G=!1}}},c=_=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,_())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,G=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((fe,ve)=>{this.d=fe,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Sd?c(ie):n(G,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class u{constructor(te){this.a=new t(te),this.b=new o}trigger(te,G){return this.a.trigger(()=>this.b.queue(te),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=u;class s{constructor(){this.a=!1,this.b=new Promise((te,G)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=s;class h extends s{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=h;function a(_,te){return te?new Promise((G,ie)=>{const fe=setTimeout(()=>{ve.dispose(),G()},_),ve=te.onCancellationRequested(()=>{clearTimeout(fe),ve.dispose(),ie(new T.$5)})}):C(G=>a(_,G))}e.$7g=a;function d(_,te=0,G){const ie=setTimeout(()=>{_(),G&&fe.dispose()},te),fe=(0,I.$Rc)(()=>{clearTimeout(ie),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$8g=d;function k(_){const te=[];let G=0;const ie=_.length;function fe(){return G<ie?_[G++]():null}function ve(Pe){Pe!=null&&te.push(Pe);const we=fe();return we?we.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$9g=k;function A(_,te=ie=>!!ie,G=null){let ie=0;const fe=_.length,ve=()=>{if(ie>=fe)return Promise.resolve(G);const Pe=_[ie++];return Promise.resolve(Pe()).then(De=>te(De)?Promise.resolve(De):ve())};return ve()}e.$0g=A;function p(_,te=ie=>!!ie,G=null){if(_.length===0)return Promise.resolve(G);let ie=_.length;const fe=()=>{ie=-1;for(const ve of _)ve.cancel?.()};return new Promise((ve,Pe)=>{for(const we of _)we.then(De=>{--ie>=0&&te(De)?(fe(),ve(De)):ie===0&&ve(G)}).catch(De=>{--ie>=0&&(fe(),Pe(De))})})}e.$$g=p;class w{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new g.$Vd}whenIdle(){return this.size>0?g.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,ie)=>{this.g.push({factory:te,c:G,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const G=te.factory();G.then(te.c,te.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=w;class E extends w{constructor(){super(1)}}e.$ah=E;class P{constructor(){this.a=new J,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=P;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new x;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,G=R.$xg){const ie=G.getComparisonKey(te);return this.a.get(ie)?.size??0}queueFor(te,G,ie=R.$xg){const fe=ie.getComparisonKey(te);let ve=this.a.get(fe);if(!ve){ve=new E;const Pe=this.f++,we=g.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$3c),this.d.set(Pe,we),this.a.set(fe,ve)}return ve.queue(G)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=F;class z{constructor(te,G){this.a=-1,typeof te=="function"&&typeof G=="number"&&this.setIfNotSet(te,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},G)}setIfNotSet(te,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},G))}}e.$dh=z;class N{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,G,ie=globalThis){this.cancel();const fe=ie.setInterval(()=>{te()},G);this.d=(0,I.$Rc)(()=>{ie.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$eh=N;class j{constructor(te,G){this.b=-1,this.a=te,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=j;class M{constructor(te,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=te,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=M;class O extends j{constructor(te,G){super(te,G),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=O;class U extends I.$Tc{constructor(te,G){super(),this.g=te,this.h=G,this.a=[],this.b=this.B(new I.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of te)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(_,te)=>{(0,b.$B)(()=>{if(G)return;const ie=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$kh=(_,te,G)=>{const ie=_.requestIdleCallback(te,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(ie))}}},e.$jh=_=>(0,e.$kh)(globalThis,_)}();class Y{constructor(te,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=Y;class le extends Y{constructor(te){super(globalThis,te)}}e.$mh=le;async function Z(_,te,G){let ie;for(let fe=0;fe<G;fe++)try{return await _()}catch(ve){ie=ve,await a(te)}throw ie}e.$nh=Z;class J{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,G,ie){return this.a={taskId:te,cancel:()=>ie?.(),promise:G},G.then(()=>this.d(te),()=>this.d(te)),G}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let G,ie;const fe=new Promise((ve,Pe)=>{G=ve,ie=Pe});this.b={run:te,promise:fe,promiseResolve:G,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=J;class X{constructor(te,G=()=>Date.now()){this.d=te,this.f=G,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=X;var ue;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ue||(ue={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,G)=>{this.a=te,this.b=G})}complete(te){return new Promise(G=>{this.a(te),this.d={outcome:0,value:te},G()})}error(te){return new Promise(G=>{this.b(te),this.d={outcome:1,value:te},G()})}cancel(){return this.error(new T.$5)}}e.$qh=x;var be;(function(_){async function te(ie){let fe;const ve=await Promise.all(ie.map(Pe=>Pe.then(we=>we,we=>{fe||(fe=we)})));if(typeof fe<"u")throw fe;return ve}_.settled=te;function G(ie){return new Promise(async(fe,ve)=>{try{await ie(fe,ve)}catch(Pe){ve(Pe)}})}_.withAsyncBody=G})(be||(e.Promises=be={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=ce;class K{constructor(te){this.b=te,this.a=new y.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=K;var V;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(V||(V={}));class re{static fromArray(te){return new re(G=>{G.emitMany(te)})}static fromPromise(te){return new re(async G=>{G.emitMany(await te)})}static fromPromises(te){return new re(async G=>{await Promise.all(te.map(async ie=>G.emitOne(await ie)))})}static merge(te){return new re(async G=>{await Promise.all(te.map(async ie=>{for await(const fe of ie)G.emitOne(fe)}))})}static{this.EMPTY=re.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new g.$Vd,queueMicrotask(async()=>{const G={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(te(G)),this.j()}catch(ie){this.k(ie)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(te,G){return new re(async ie=>{for await(const fe of te)ie.emitOne(G(fe))})}map(te){return re.map(this,te)}static filter(te,G){return new re(async ie=>{for await(const fe of te)G(fe)&&ie.emitOne(fe)})}filter(te){return re.filter(this,te)}static coalesce(te){return re.filter(te,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(te){const G=[];for await(const ie of te)G.push(ie);return G}toPromise(){return re.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=re;class ye extends re{constructor(te,G){super(G),this.l=te}cancel(){this.l.cancel()}}e.$uh=ye;function de(_){const te=new D.$6d,G=_(te.token);return new ye(te,async ie=>{const fe=te.token.onCancellationRequested(()=>{fe.dispose(),te.dispose(),ie.reject(new T.$5)});try{for await(const ve of G){if(te.token.isCancellationRequested)return;ie.emitOne(ve)}fe.dispose(),te.dispose()}catch(ve){fe.dispose(),te.dispose(),ie.reject(ve)}})}e.$vh=de;class ge{constructor(){this.a=new x,this.b=new re(ie=>{if(te){ie.reject(te);return}return G&&ie.emitMany(G),this.d=fe=>ie.reject(fe),this.f=fe=>ie.emitOne(fe),this.a.p});let te,G;this.f=ie=>{G||(G=[]),G.push(ie)},this.d=ie=>{te||(te=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=ge}),define(ke[34],Se([1,0,19,11,33,28,17,10,12]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function y(){return Object.create(null)}e.$Hj=y,e.$Ij="**",e.$Jj="/";const L="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(le,Z){switch(le){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${Z?`|${L}${C}+`:""})*?`}}function S(le,Z){if(!le)return[];const J=[];let X=!1,ue=!1,x="";for(const be of le){switch(be){case Z:if(!X&&!ue){J.push(x),x="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}x+=be}return x&&J.push(x),J}e.$Kj=S;function l(le){if(!le)return"";let Z="";const J=S(le,e.$Jj);if(J.every(X=>X===e.$Ij))Z=".*";else{let X=!1;J.forEach((ue,x)=>{if(ue===e.$Ij){if(X)return;Z+=v(2,x===J.length-1)}else{let be=!1,ce="",K=!1,V="";for(const re of ue){if(re!=="}"&&be){ce+=re;continue}if(K&&(re!=="]"||!V)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!V?ye="^":re===e.$Jj?ye="":ye=(0,$.$Oe)(re),V+=ye;continue}switch(re){case"{":be=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${S(ce,",").map(ge=>l(ge)).join("|")})`;Z+=de,be=!1,ce="";break}case"]":{Z+="["+V+"]",K=!1,V="";break}case"?":Z+=C;continue;case"*":Z+=v(1);continue;default:Z+=(0,$.$Oe)(re)}}x<J.length-1&&(J[x+1]!==e.$Ij||x+2<J.length)&&(Z+=L)}X=ue===e.$Ij})}return Z}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),u=function(){return!1},s=function(){return null};function h(le,Z){if(!le)return s;let J;typeof le!="string"?J=le.pattern:J=le,J=J.trim();const X=`${J}_${!!Z.trimForExclusions}`;let ue=t.get(X);if(ue)return a(ue,le);let x;return f.test(J)?ue=k(J.substr(4),J):(x=o.exec(d(J,Z)))?ue=A(x[1],J):(Z.trimForExclusions?r:i).test(J)?ue=p(J,Z):(x=n.exec(d(J,Z)))?ue=w(x[1].substr(1),J,!0):(x=c.exec(d(J,Z)))?ue=w(x[1],J,!1):ue=E(J),t.set(X,ue),a(ue,le)}function a(le,Z){if(typeof Z=="string")return le;const J=function(X,ue){return(0,g.$8f)(X,Z.base,!b.$k)?le((0,$.$Te)(X.substr(Z.base.length),R.sep),ue):null};return J.allBasenames=le.allBasenames,J.allPaths=le.allPaths,J.basenames=le.basenames,J.patterns=le.patterns,J}function d(le,Z){return Z.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function k(le,Z){return function(J,X){return typeof J=="string"&&J.endsWith(le)?Z:null}}function A(le,Z){const J=`/${le}`,X=`\\${le}`,ue=function(be,ce){return typeof be!="string"?null:ce?ce===le?Z:null:be===le||be.endsWith(J)||be.endsWith(X)?Z:null},x=[le];return ue.basenames=x,ue.patterns=[Z],ue.allBasenames=x,ue}function p(le,Z){const J=U(le.slice(1,-1).split(",").map(ce=>h(ce,Z)).filter(ce=>ce!==s),le),X=J.length;if(!X)return s;if(X===1)return J[0];const ue=function(ce,K){for(let V=0,re=J.length;V<re;V++)if(J[V](ce,K))return le;return null},x=J.find(ce=>!!ce.allBasenames);x&&(ue.allBasenames=x.allBasenames);const be=J.reduce((ce,K)=>K.allPaths?ce.concat(K.allPaths):ce,[]);return be.length&&(ue.allPaths=be),ue}function w(le,Z,J){const X=R.sep===R.$gc.sep,ue=X?le:le.replace(m,R.sep),x=R.sep+ue,be=R.$gc.sep+le;let ce;return J?ce=function(K,V){return typeof K=="string"&&(K===ue||K.endsWith(x)||!X&&(K===le||K.endsWith(be)))?Z:null}:ce=function(K,V){return typeof K=="string"&&(K===ue||!X&&K===le)?Z:null},ce.allPaths=[(J?"*/":"./")+le],ce}function E(le){try{const Z=new RegExp(`^${l(le)}$`);return function(J){return Z.lastIndex=0,typeof J=="string"&&Z.test(J)?le:null}}catch{return s}}function P(le,Z,J){return!le||typeof Z!="string"?!1:F(le)(Z,void 0,J)}e.$Lj=P;function F(le,Z={}){if(!le)return u;if(typeof le=="string"||z(le)){const J=h(le,Z);if(J===s)return u;const X=function(ue,x){return!!J(ue,x)};return J.allBasenames&&(X.allBasenames=J.allBasenames),J.allPaths&&(X.allPaths=J.allPaths),X}return M(le,Z)}e.$Mj=F;function z(le){const Z=le;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Nj=z;function N(le){return le.allBasenames||[]}e.$Oj=N;function j(le){return le.allPaths||[]}e.$Pj=j;function M(le,Z){const J=U(Object.getOwnPropertyNames(le).map(ce=>O(ce,le[ce],Z)).filter(ce=>ce!==s)),X=J.length;if(!X)return s;if(!J.some(ce=>!!ce.requiresSiblings)){if(X===1)return J[0];const ce=function(re,ye){let de;for(let ge=0,_=J.length;ge<_;ge++){const te=J[ge](re,ye);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(de||(de=[]),de.push(te))}return de?(async()=>{for(const ge of de){const _=await ge;if(typeof _=="string")return _}return null})():null},K=J.find(re=>!!re.allBasenames);K&&(ce.allBasenames=K.allBasenames);const V=J.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return V.length&&(ce.allPaths=V),ce}const ue=function(ce,K,V){let re,ye;for(let de=0,ge=J.length;de<ge;de++){const _=J[de];_.requiresSiblings&&V&&(K||(K=(0,R.$nc)(ce)),re||(re=K.substr(0,K.length-(0,R.$oc)(ce).length)));const te=_(ce,K,re,V);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(ye||(ye=[]),ye.push(te))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},x=J.find(ce=>!!ce.allBasenames);x&&(ue.allBasenames=x.allBasenames);const be=J.reduce((ce,K)=>K.allPaths?ce.concat(K.allPaths):ce,[]);return be.length&&(ue.allPaths=be),ue}function O(le,Z,J){if(Z===!1)return s;const X=h(le,J);if(X===s)return s;if(typeof Z=="boolean")return X;if(Z){const ue=Z.when;if(typeof ue=="string"){const x=(be,ce,K,V)=>{if(!V||!X(be,ce))return null;const re=ue.replace("$(basename)",()=>K),ye=V(re);return(0,T.$Sg)(ye)?ye.then(de=>de?le:null):ye?le:null};return x.requiresSiblings=!0,x}}return X}function U(le,Z){const J=le.filter(ce=>!!ce.basenames);if(J.length<2)return le;const X=J.reduce((ce,K)=>{const V=K.basenames;return V?ce.concat(V):ce},[]);let ue;if(Z){ue=[];for(let ce=0,K=X.length;ce<K;ce++)ue.push(Z)}else ue=J.reduce((ce,K)=>{const V=K.patterns;return V?ce.concat(V):ce},[]);const x=function(ce,K){if(typeof ce!="string")return null;if(!K){let re;for(re=ce.length;re>0;re--){const ye=ce.charCodeAt(re-1);if(ye===47||ye===92)break}K=ce.substr(re)}const V=X.indexOf(K);return V!==-1?ue[V]:null};x.basenames=X,x.patterns=ue,x.allBasenames=X;const be=le.filter(ce=>!ce.basenames);return be.push(x),be}function Y(le,Z){return(0,D.$ub)(le,Z,(J,X)=>typeof J=="string"&&typeof X=="string"?J===X:typeof J!="string"&&typeof X!="string"?J.base===X.base&&J.pattern===X.pattern:!1)}e.$Qj=Y}),define(ke[80],Se([1,0,14,164,23,12,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=m(this.supportThemeIcons?(0,T.$bk)(i):i).replace(/([ \t]+)/g,(n,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${v(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,I.$Oe)(r),"g");return i.replace(n,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$hk=$;function y(o){return L(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.$ik=y;function L(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$jk=L;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,g.$Ag)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$kk=C;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=m;function v(o,i){const r=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$mk=v;function S(o){return o.replace(/"/g,"&quot;")}e.$nk=S;function l(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=l;function f(o){const i=[],r=o.split("|").map(c=>c.trim());o=r[0];const n=r[1];if(n){const c=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),u=c?c[1]:"",s=t?t[1]:"",h=isFinite(parseInt(s)),a=isFinite(parseInt(u));h&&i.push(`width="${s}"`),a&&i.push(`height="${u}"`)}return{href:o,dimensions:i}}e.$pk=f}),define(ke[103],Se([1,0,19,33,17,10,23,12]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function $(h,a){const{os:d,tildify:k,relative:A}=a;if(A){const E=y(h,A,d);if(typeof E=="string")return E}let p=h.fsPath;if(d===1&&!I.$i?p=p.replace(/\//g,"\\"):d!==1&&I.$i&&(p=p.replace(/\\/g,"/")),d!==1&&k?.userHome){const E=k.userHome.fsPath;let P;h.scheme!==k.userHome.scheme&&h.path[0]===g.$gc.sep&&h.path[1]!==g.$gc.sep?P=k.userHome.with({path:h.path}).fsPath:P=p,p=m(P,E,d)}return(d===1?g.$fc:g.$gc).normalize(L(p,d===1))}e.$Vv=$;function y(h,a,d){const k=d===1?g.$fc:g.$gc,A=d===3?R.$xg:R.$zg,p=a.getWorkspace(),w=(0,D.$Ob)(p.folders);if(!w)return;h.scheme!==w.uri.scheme&&h.path[0]===g.$gc.sep&&h.path[1]!==g.$gc.sep&&(h=w.uri.with({path:h.path}));const E=a.getWorkspaceFolder(h);if(!E)return;let P;if(A.isEqual(E.uri,h)?P="":P=A.relativePath(E.uri,h)??"",P&&(P=k.normalize(P)),p.folders.length>1&&!a.noPrefix){const F=E.name?E.name:A.basenameOrAuthority(E.uri);P=P?`${F} \u2022 ${P}`:F}return P}function L(h,a=I.$i){return(0,T.$_f)(h,a)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$Wv=L;let C=Object.create(null);function m(h,a,d=I.OS){if(d===1||!h||!a)return h;let k=C.original===a?C.normalized:void 0;k||(k=a,I.$i&&(k=(0,T.$2f)(k)),k=`${(0,b.$Ue)(k,g.$gc.sep)}${g.$gc.sep}`,C={original:a,normalized:k});let A=h;return I.$i&&(A=(0,T.$2f)(A)),(d===3?A.startsWith(k):(0,b.$af)(A,k))?`~/${A.substr(k.length)}`:h}e.$Xv=m;function v(h,a){return h.replace(/^~($|\/|\\)/,`${a}$1`)}e.$Yv=v;const S="\u2026",l="\\\\",f="~";function o(h,a=g.sep){const d=new Array(h.length);let k=!1;for(let A=0;A<h.length;A++){const p=h[A];if(p===""){d[A]=`.${a}`;continue}if(!p){d[A]=p;continue}k=!0;let w="",E=p;E.indexOf(l)===0?(w=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(a)===0?(w=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(f)===0&&(w=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const P=E.split(a);for(let F=1;k&&F<=P.length;F++)for(let z=P.length-F;k&&z>=0;z--){k=!1;let N=P.slice(z,z+F).join(a);for(let j=0;!k&&j<h.length;j++)if(j!==A&&h[j]&&h[j].indexOf(N)>-1){const M=z+F===P.length,O=z>0&&h[j].indexOf(a)>-1?a+N:N,U=h[j].endsWith(O);k=!M||U}if(!k){let j="";(P[0].endsWith(":")||w!=="")&&(z===1&&(z=0,F++,N=P[0]+a+N),z>0&&(j=P[0]+a),j=w+j),z>0&&(j=j+S+a),j=j+N,z+F<P.length&&(j=j+a+S),d[A]=j}}k&&(d[A]=p)}return d}e.$Zv=o;var i;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(h,a=Object.create(null)){const d=[];let k=!1,A="";for(const p of h)if(p==="$"||k&&p==="{")A&&d.push({value:A,type:i.TEXT}),A="",k=!0;else if(p==="}"&&k){const w=a[A];if(typeof w=="string")w.length&&d.push({value:w,type:i.VARIABLE});else if(w){const E=d[d.length-1];(!E||E.type!==i.SEPARATOR)&&d.push({value:w.label,type:i.SEPARATOR})}A="",k=!1}else A+=p;return A&&!k&&d.push({value:A,type:i.TEXT}),d.filter((p,w)=>{if(p.type===i.SEPARATOR){const E=d[w-1],P=d[w+1];return[E,P].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(p=>p.value).join("")}e.$1v=r;function n(h,a){return I.$j||a?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):h.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$2v=n;function c(h,a){return I.$j||a?h.replace(/\(&&\w\)|&&/g,""):I.$i?h.replace(/&&|&/g,d=>d==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$3v=c;function t(h){return h.replace(/&/g,"&&")}e.$4v=t;function u(h){if(h.endsWith("]")){const a=h.lastIndexOf(" [",h.length-2);if(a!==-1){const d=s(h.substring(0,a)),k=h.substring(a);return{name:d.name+k,parentPath:d.parentPath}}}return s(h)}e.$5v=u;function s(h){const a=h.indexOf("/")!==-1?g.$gc:g.$fc,d=a.basename(h),k=a.dirname(h);return d.length?{name:d,parentPath:k}:{name:k,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(T.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(T.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:T.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$4m=I,e.$5m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof T.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const l=R(C[S],m,v+1);l!==null&&(C[S]=l)}}return null}function b(C,m){const v=R(C,m,0);return v===null?C:v}e.$6m=b;function $(C,m,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?T.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$je)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const f=$(C[l],m,v,S+1);f!==null&&(C[l]=f)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$7m=y;function L(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$8m=L}),define(ke[31],Se([1,0,56,63,385,11,33,76,17,10,23,2]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(O,U=m.UNLINK,Y){if((0,R.$$f)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===m.UNLINK?l(O):S(O,Y)}async function S(O,U=(0,R.$dg)((0,T.tmpdir)())){try{try{await D.promises.rename(O,U)}catch(Y){return Y.code==="ENOENT"?void 0:l(O)}l(U).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function l(O){return(0,g.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function f(O){if((0,R.$$f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(O,U){return n(await(U?i(O):(0,g.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,g.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const U=[],Y=await o(O);for(const le of Y){let Z=!1,J=!1,X=!1;try{const ue=await e.Promises.lstat((0,$.$jc)(O,le));Z=ue.isFile(),J=ue.isDirectory(),X=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}U.push({name:le,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>X})}return U}function r(O){return n(D.readdirSync(O))}e.readdirSync=r;function n(O){return O.map(U=>typeof U=="string"?y.$j?(0,b.$Gl)(U):U:(U.name=y.$j?(0,b.$Gl)(U.name):U.name,U))}async function c(O){const U=await o(O),Y=[];for(const le of U)await u.existsDirectory((0,$.$jc)(O,le))&&Y.push(le);return Y}function t(O,U=1e3){return new Promise(Y=>{let le=!1;const Z=setInterval(()=>{le||(le=!0,D.access(O,J=>{le=!1,J&&(clearInterval(Z),Y(void 0))}))},U)})}e.whenDeleted=t;var u;(function(O){async function U(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ue}throw X}}O.stat=U;async function Y(Z){try{const{stat:J,symbolicLink:X}=await O.stat(Z);return J.isFile()&&X?.dangling!==!0}catch{}return!1}O.existsFile=Y;async function le(Z){try{const{stat:J,symbolicLink:X}=await O.stat(Z);return J.isDirectory()&&X?.dangling!==!0}catch{}return!1}O.existsDirectory=le})(u||(e.SymlinkSupport=u={}));const s=new I.$ch;function h(O,U,Y){return s.queueFor(C.URI.file(O),()=>{const le=p(Y);return new Promise((Z,J)=>k(O,U,le,X=>X?J(X):Z()))},L.$yg)}let a=!0;function d(O){a=O}e.configureFlushOnWrite=d;function k(O,U,Y,le){if(!a)return D.writeFile(O,U,{mode:Y.mode,flag:Y.flag},le);D.open(O,Y.flag,Y.mode,(Z,J)=>{if(Z)return le(Z);D.writeFile(J,U,X=>{if(X)return D.close(J,()=>le(X));D.fdatasync(J,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),d(!1)),D.close(J,x=>le(x))))})})}function A(O,U,Y){const le=p(Y);if(!a)return D.writeFileSync(O,U,{mode:le.mode,flag:le.flag});const Z=D.openSync(O,le.flag,le.mode);try{D.writeFileSync(Z,U);try{D.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),d(!1)}}finally{D.closeSync(Z)}}e.writeFileSync=A;function p(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U,Y=6e4){if(O!==U)try{y.$i&&typeof Y=="number"?await E(O,U,Date.now(),Y):await(0,g.promisify)(D.rename)(O,U)}catch(le){if(O.toLowerCase()!==U.toLowerCase()&&le.code==="EXDEV"||O.endsWith("."))await P(O,U,{preserveSymlinks:!1}),await v(O,m.MOVE);else throw le}}async function E(O,U,Y,le,Z=0){try{return await(0,g.promisify)(D.rename)(O,U)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-Y>=le)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let X=!1;try{const{stat:ue}=await u.stat(U);ue.isFile()||(X=!0)}catch{}if(X)throw J}return await(0,I.$7g)(Math.min(100,Z*10)),E(O,U,Y,le,Z+1)}}async function P(O,U,Y){return z(O,U,{root:{source:O,target:U},options:Y,handledSourcePaths:new Set})}const F=511;async function z(O,U,Y){if(Y.handledSourcePaths.has(O))return;Y.handledSourcePaths.add(O);const{stat:le,symbolicLink:Z}=await u.stat(O);if(Z){if(Y.options.preserveSymlinks)try{return await M(O,U,Y)}catch{}if(Z.dangling)return}return le.isDirectory()?N(O,U,le.mode&F,Y):j(O,U,le.mode&F)}async function N(O,U,Y,le){await e.Promises.mkdir(U,{recursive:!0,mode:Y});const Z=await o(O);for(const J of Z)await z((0,$.$jc)(O,J),(0,$.$jc)(U,J),le)}async function j(O,U,Y){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,Y)}async function M(O,U,Y){let le=await e.Promises.readlink(O);(0,R.$8f)(le,Y.root.source,!y.$k)&&(le=(0,$.$jc)(Y.root.target,le.substr(Y.root.source.length+1))),await e.Promises.symlink(le,U)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(O,U,Y,le,Z)=>new Promise((J,X)=>{D.read(O,U,Y,le,Z,(ue,x,be)=>ue?X(ue):J({bytesRead:x,buffer:be}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(O,U,Y,le,Z)=>new Promise((J,X)=>{D.write(O,U,Y,le,Z,(ue,x,be)=>ue?X(ue):J({bytesWritten:x,buffer:be}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return h}get rm(){return v}get rename(){return w}get copy(){return P}}}),define(ke[104],Se([1,0,56,17,10,12,31]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function b(m){if(g.$k)return m;const v=(0,T.$mc)(m);if(m===v)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(0,R.readdirSync)(v).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=b(v);if(o)return(0,T.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=b(v);if(i)return(0,T.$jc)(i,f[o])}}}catch{}return null}e.$tq=b;async function $(m){if(g.$k)return m;const v=(0,T.$mc)(m);if(m===v)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(await R.Promises.readdir(v)).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=await $(v);if(o)return(0,T.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=await $(v);if(i)return(0,T.$jc)(i,f[o])}}}catch{}return null}e.$uq=$;async function y(m){try{return await R.Promises.realpath(m)}catch{const S=C(m);return await R.Promises.access(S,D.constants.R_OK),S}}e.$vq=y;function L(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$wq=L;function C(m){return(0,I.$Ue)((0,T.$hc)(m),T.sep)}}),define(ke[105],Se([1,0,17,10,49,102,18,31]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Tl=$;function y(C){let m=[],v=!1;const S=function(l){if(v){m.push(l);return}(!C.send(l,o=>{if(o&&console.error(o),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(r=>S(r))}})||T.$i)&&(v=!0)};return{send:S}}e.$Ul=y;var L;(function(C){async function m(v,S,l){if(D.$ic(v))return v;if(S===void 0&&(S=g.cwd()),D.$mc(v)!=="."||(l===void 0&&R.$If(g.env.PATH)&&(l=g.env.PATH.split(D.$tc)),l===void 0||l.length===0))return D.$jc(S,v);async function o(i){if(await b.Promises.exists(i)){let r;try{r=await b.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await b.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of l){let r;if(D.$ic(i)?r=D.$jc(i,v):r=D.$jc(S,i,v),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return D.$jc(S,v)}C.findExecutable=m})(L||(e.win32=L={}))});var Ge=this&&this.__decorate||function(me,e,D,T){var g=arguments.length,I=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,T);else for(var b=me.length-1;b>=0;b--)(R=me[b])&&(I=(g<3?R(I):g>3?R(e,D,I):R(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(ke[81],Se([1,0,19,11,22,21,52,14,4,3,55,12,18]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var v;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(v||(v={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(l||(l={}));function f(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let J=0;for(let X=0;;X+=7){const ue=Z.read(1);if(J|=(ue.buffer[0]&127)<<X,!(ue.buffer[0]&128))return J}}const r=s(0);function n(Z,J){if(J===0){Z.write(r);return}let X=0;for(let x=J;x!==0;x=x>>>7)X++;const ue=g.$je.alloc(X);for(let x=0;J!==0;x++)ue.buffer[x]=J&127,J=J>>>7,J>0&&(ue.buffer[x]|=128);Z.write(ue)}class c{constructor(J){this.b=J,this.a=0}read(J){const X=this.b.slice(this.a,this.a+J);return this.a+=X.byteLength,X}}e.$Dh=c;class t{constructor(){this.a=[]}get buffer(){return g.$je.concat(this.a)}write(J){this.a.push(J)}}e.$Eh=t;var u;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(u||(u={}));function s(Z){const J=g.$je.alloc(1);return J.writeUInt8(Z,0),J}const h={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object),Uint:s(u.Int)},a=typeof Buffer<"u";function d(Z,J){if(typeof J>"u")Z.write(h.Undefined);else if(typeof J=="string"){const X=g.$je.fromString(J);Z.write(h.String),n(Z,X.byteLength),Z.write(X)}else if(a&&Buffer.isBuffer(J)){const X=g.$je.wrap(J);Z.write(h.Buffer),n(Z,X.byteLength),Z.write(X)}else if(J instanceof g.$je)Z.write(h.VSBuffer),n(Z,J.byteLength),Z.write(J);else if(Array.isArray(J)){Z.write(h.Array),n(Z,J.length);for(const X of J)d(Z,X)}else if(typeof J=="number"&&(J|0)===J)Z.write(h.Uint),n(Z,J);else{const X=g.$je.fromString(JSON.stringify(J));Z.write(h.Object),n(Z,X.byteLength),Z.write(X)}}e.$Fh=d;function k(Z){switch(Z.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return Z.read(i(Z)).toString();case u.Buffer:return Z.read(i(Z)).buffer;case u.VSBuffer:return Z.read(i(Z));case u.Array:{const X=i(Z),ue=[];for(let x=0;x<X;x++)ue.push(k(Z));return ue}case u.Object:return JSON.parse(Z.read(i(Z)).toString());case u.Int:return i(Z)}}e.$Gh=k;class A{constructor(J,X,ue=null,x=1e3){this.h=J,this.j=X,this.k=ue,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(be=>this.q(be)),this.m({type:200})}registerChannel(J,X){this.b.set(J,X),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const X=this.o([J.type]);this.k?.logOutgoing(X,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const X=this.o([J.type,J.id],J.data);this.k?.logOutgoing(X,J.id,1,f(J.type),J.data);return}}}o(J,X=void 0){const ue=new t;return d(ue,J),d(ue,X),this.p(ue.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const X=new c(J),ue=k(X),x=k(X),be=ue[0];switch(be){case 100:return this.k?.logIncoming(J.byteLength,ue[1],1,`${S(be)}: ${ue[2]}.${ue[3]}`,x),this.s({type:be,id:ue[1],channelName:ue[2],name:ue[3],arg:x});case 102:return this.k?.logIncoming(J.byteLength,ue[1],1,`${S(be)}: ${ue[2]}.${ue[3]}`,x),this.t({type:be,id:ue[1],channelName:ue[2],name:ue[3],arg:x});case 101:return this.k?.logIncoming(J.byteLength,ue[1],1,`${S(be)}`),this.u({type:be,id:ue[1]});case 103:return this.k?.logIncoming(J.byteLength,ue[1],1,`${S(be)}`),this.u({type:be,id:ue[1]})}}s(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const ue=new I.$6d;let x;try{x=X.call(this.j,J.name,J.arg,ue.token)}catch(K){x=Promise.reject(K)}const be=J.id;x.then(K=>{this.m({id:be,data:K,type:201})},K=>{K instanceof Error?this.m({id:be,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:be,data:K,type:203})}).finally(()=>{ce.dispose(),this.d.delete(J.id)});const ce=(0,y.$Rc)(()=>ue.cancel());this.d.set(J.id,ce)}t(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const ue=J.id,be=X.listen(this.j,J.name,J.arg)(ce=>this.m({id:ue,data:ce,type:204}));this.d.set(J.id,be)}u(J){const X=this.d.get(J.id);X&&(X.dispose(),this.d.delete(J.id))}v(J){let X=this.g.get(J.channelName);X||(X=[],this.g.set(J.channelName,X));const ue=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:J,timeoutTimer:ue})}w(J){const X=this.g.get(J);if(X){for(const ue of X)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=A;var p;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class w{constructor(J,X=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=X}getChannel(J){const X=this;return{call(ue,x,be){return X.a?Promise.reject(new b.$5):X.m(J,ue,x,be)},listen(ue,x){return X.a?$.Event.None:X.o(J,ue,x)}}}m(J,X,ue,x=I.CancellationToken.None){const be=this.g++,K={id:be,type:100,channelName:J,name:X,arg:ue};if(x.isCancellationRequested)return Promise.reject(new b.$5);let V;return new Promise((ye,de)=>{if(x.isCancellationRequested)return de(new b.$5);const ge=()=>{const ie=fe=>{switch(fe.type){case 201:this.f.delete(be),ye(fe.data);break;case 202:{this.f.delete(be);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,de(ve);break}case 203:this.f.delete(be),de(fe.data);break}};this.f.set(be,ie),this.p(K)};let _=null;this.b===o.Idle?ge():(_=(0,T.$Tg)(ie=>this.u()),_.then(()=>{_=null,ge()}));const te=()=>{_?(_.cancel(),_=null):this.p({id:be,type:101}),de(new b.$5)},G=x.onCancellationRequested(te);V=(0,y.$Qc)((0,y.$Rc)(te),G),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(J,X,ue){const x=this.g++,ce={id:x,type:102,channelName:J,name:X,arg:ue};let K=null;const V=new $.$Vd({onWillAddFirstListener:()=>{K=(0,T.$Tg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(V),this.p(ce)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(V),this.p({id:x,type:103}))}}),re=ye=>V.fire(ye.data);return this.f.set(x,re),V.event}p(J){switch(J.type){case 100:case 102:{const X=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(X,J.id,0,`${S(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const X=this.q([J.type,J.id]);this.j?.logOutgoing(X,J.id,0,S(J.type));return}}}q(J,X=void 0){const ue=new t;return d(ue,J),d(ue,X),this.r(ue.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const X=new c(J),ue=k(X),x=k(X),be=ue[0];switch(be){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(be)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ue[1],0,f(be),x),this.t({type:ue[0],id:ue[1],data:x})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=w,Ge([R.$xh],w.prototype,"onDidInitializePromise",null);class E{get connections(){const J=[];return this.f.forEach(X=>J.push(X)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Vd,this.onDidAddConnection=this.g.event,this.h=new $.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(J(({protocol:X,onDidClientDisconnect:ue})=>{const x=$.Event.once(X.onMessage);this.j.add(x(be=>{const ce=new c(be),K=k(ce),V=new A(X,K),re=new w(X);this.a.forEach((de,ge)=>V.registerChannel(ge,de));const ye={channelServer:V,channelClient:re,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(ue(()=>{V.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(J,X){const ue=this;return{call(x,be,ce){let K;if((0,m.$Wf)(X)){const re=(0,D.$4b)(ue.connections.filter(X));K=re?Promise.resolve(re):$.Event.toPromise($.Event.filter(ue.onDidAddConnection,X))}else K=X.routeCall(ue,x,be);const V=K.then(re=>re.channelClient.getChannel(J));return F(V).call(x,be,ce)},listen(x,be){if((0,m.$Wf)(X))return ue.k(J,X,x,be);const ce=X.routeEvent(ue,x,be).then(K=>K.channelClient.getChannel(J));return F(ce).listen(x,be)}}}k(J,X,ue,x){const be=this;let ce;const K=new $.$Vd({onWillAddFirstListener:()=>{ce=new y.$Sc;const V=new $.$2d,re=new Map,ye=ge=>{const te=ge.channelClient.getChannel(J).listen(ue,x),G=V.add(te);re.set(ge,G)},de=ge=>{const _=re.get(ge);_&&(_.dispose(),re.delete(ge))};be.connections.filter(X).forEach(ye),$.Event.filter(be.onDidAddConnection,X)(ye,void 0,ce),be.onDidRemoveConnection(de,void 0,ce),V.event(K.fire,K,ce),ce.add(V)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return K.event}registerChannel(J,X){this.a.set(J,X);for(const ue of this.f)ue.channelServer.registerChannel(J,X)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=E;class P{constructor(J,X,ue=null){const x=new t;d(x,X),J.send(x.buffer),this.a=new w(J,ue),this.d=new A(J,X,ue)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,X){this.d.registerChannel(J,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=P;function F(Z){return{call(J,X,ue){return Z.then(x=>x.call(J,X,ue))},listen(J,X){const ue=new $.$5d;return Z.then(x=>ue.input=x.listen(J,X)),ue.event}}}e.$Lh=F;function z(Z){let J=!1;return{call(X,ue,x){return J?Z.call(X,ue,x):(0,T.$7g)(0).then(()=>J=!0).then(()=>Z.call(X,ue,x))},listen(X,ue){if(J)return Z.listen(X,ue);const x=new $.$5d;return(0,T.$7g)(0).then(()=>J=!0).then(()=>x.input=Z.listen(X,ue)),x.event}}}e.$Mh=z;class N{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const X of J.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Nh=N;var j;(function(Z){function J(be,ce,K){const V=be,re=K&&K.disableMarshalling,ye=new Map;for(const de in V)ue(de)&&ye.set(de,$.Event.buffer(V[de],!0,void 0,ce));return new class{listen(de,ge,_){const te=ye.get(ge);if(te)return te;if(x(ge)){const G=V[ge];if(typeof G=="function")return G.call(V,_)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,_){const te=V[ge];if(typeof te=="function"){if(!re&&Array.isArray(_))for(let ie=0;ie<_.length;ie++)_[ie]=(0,L.$Ch)(_[ie]);let G=te.apply(V,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}Z.fromService=J;function X(be,ce){const K=ce&&ce.disableMarshalling;return new Proxy({},{get(V,re){if(typeof re=="string")return ce?.properties?.has(re)?ce.properties.get(re):x(re)?function(ye){return be.listen(re,ye)}:ue(re)?be.listen(re):async function(...ye){let de;ce&&!(0,m.$Rf)(ce.context)?de=[ce.context,...ye]:de=ye;const ge=await be.call(re,de);return K?ge:(0,L.$Ch)(ge)};throw new b.$bb(`Property not found: ${String(re)}`)}})}Z.toService=X;function ue(be){return be[0]==="o"&&be[1]==="n"&&C.$$e(be.charCodeAt(2))}function x(be){return/^onDynamic/.test(be)&&C.$$e(be.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const J=Z.toString();if(J!=="[object Object]")return J}return Z}function U(Z){return Array.isArray(Z)?Z.map(O):O(Z)}function Y(Z,J,X,ue,x,be,ce){ce=U(ce);const K=M[x],V=K[ue%K.length];let re=[`%c[${Z}]%c[${String(J).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${be}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(be)?(re=re.concat(ce),re.push(")")):re.push(ce),console.log.apply(console,re)}class le{constructor(J,X){this.d=J,this.f=X,this.a=0,this.b=0}logOutgoing(J,X,ue,x,be){this.b+=J,Y(this.d,this.b,J,X,ue,x,be)}logIncoming(J,X,ue,x,be){this.a+=J,Y(this.f,this.a,J,X,ue,x,be)}}e.$Oh=le}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(h){h.enableDiagnostics=!1,h.records=[];const a=new WeakMap;let d=0;function k(p,w){if(!a.has(p)){const E=String(++d);a.set(p,E)}return a.get(p)}function A(p,w,E,P){if(!h.enableDiagnostics)return;const F=k(p,w);if(P instanceof D.$je||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const z=D.$je.alloc(P.byteLength);z.set(P),h.records.push({timestamp:Date.now(),id:F,label:w,type:E,buff:z})}else h.records.push({timestamp:Date.now(),id:F,label:w,type:E,data:P})}h.traceSocketEvent=A})(b||(e.SocketDiagnostics=b={}));var $;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function L(){return y||(y=D.$je.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,d){if(a===0)return L();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const w=this.a[0];return d&&(this.a.shift(),this.b-=a),w}if(this.a[0].byteLength>a){const w=this.a[0].slice(0,a);return d&&(this.a[0]=this.a[0].slice(a),this.b-=a),w}const k=D.$je.alloc(a);let A=0,p=0;for(;a>0;){const w=this.a[p];if(w.byteLength>a){const E=w.slice(0,a);k.set(E,A),A+=a,d&&(this.a[p]=w.slice(a),this.b-=a),a-=a}else k.set(w,A),A+=w.byteLength,d?(this.a.shift(),this.b-=w.byteLength):p++,a-=w.byteLength}return k}}e.$Ph=C;var m;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class l{constructor(a,d,k,A){this.type=a,this.id=d,this.ack=k,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Tc{constructor(a){super(),this.f=this.B(new T.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,A=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new l(k,A,p,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.$je.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(d,a.data)}g(a,d){const k=this.f===0;return this.d.push(a,d),this.f+=a.byteLength+d.byteLength,k}h(){const a=D.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,d){this.g(a,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends g.$Tc{constructor(a){super(),this.f=new T.$Vd,this.onMessage=this.f.event,this.g=new T.$Vd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new l(1,0,0,a))}}e.$Qh=i;class r extends I.$Kh{static fromSocket(a,d){return new r(new i(a),d)}get onDidDispose(){return this.b.onDidDispose}constructor(a,d,k=null){super(a,d,k),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Rh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Sh=n;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,d=this.a;for(;d;)d=d.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let d=0,k=this.a;for(;k;)a[d++]=k.data,k=k.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const d=new c(a);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const a=Date.now();for(let d=0;d<u.a;d++)this.c[d]=a-1e3*d;setInterval(()=>{for(let d=u.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),d=(1+u.a)*1e3;let k=0;for(let A=0;A<u.a;A++)a-this.c[A]<=d&&k++;return 1-k/u.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??u.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Sc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new l(5,0,0,L());this.p.write(a),this.p.flush()}sendPause(){const a=new l(7,0,0,L());this.p.write(a)}sendResume(){const a=new l(8,0,0,L());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,d){this.a=!0,this.r.dispose(),this.r=new g.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new l(3,0,this.h,L());this.p.write(a);const d=this.b.toArray();for(let k=0,A=d.length;k<A;k++)this.p.write(d[k]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const d=this.b.peek();if(d&&d.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new l(6,0,0,L())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let k=0,A=d.length;k<A;k++)this.p.write(d[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const d=++this.c;this.h=this.g;const k=new l(1,d,this.h,a);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(a){const d=new l(2,0,0,a);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),d=Date.now()-a.writtenTime,k=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(d>=2e4&&k>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:k});return}const p=Math.max(2e4-d,2e4-k,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new l(3,0,this.h,L());this.p.write(a)}D(){this.h=this.g;const a=new l(9,0,this.h,L());this.p.write(a)}}e.$Th=s}),define(ke[187],Se([1,0,50,11,22,21,185,14,4,3,24,105,102,81]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class S extends v.$Hh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$je.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$qq=S;class l{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Vd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new T.$3g(r),this.d=null,this.f=null}getChannel(o){const i=this;return{call(r,n,c){return i.k(o,r,n,c)},listen(r,n){return i.l(o,r,n)}}}k(o,i,r,n=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(o),t=(0,T.$Tg)(h=>c.call(i,r,h)),u=n.onCancellationRequested(()=>t.cancel()),s=(0,y.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{u.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const c=new $.$Vd({onWillAddFirstListener:()=>{n=this.n(o).listen(i,r)(c.fire,c),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,L.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,m.$Sl)(i.env),this.d=(0,D.fork)(this.i,o,i);const r=new $.$Vd;$.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.$mq)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}r.fire(g.$je.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$Ul)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),u=r.event,s={send:t,onMessage:u};this.f=new v.$Ih(s);const h=()=>this.o();process.once("exit",h),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,d)=>{process.removeListener("exit",h),this.c.forEach(k=>(0,y.$Oc)(k)),this.c.clear(),a!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:d})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=l}),define(ke[188],Se([1,0,11,4,3,55,18]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$pp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class L extends g.$Tc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new T.$Yd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$4g(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,l)=>this.w(l,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===y.Closed)return;let l=!1;(0,R.$Rf)(S)?l=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),l=!0),l&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const l=this.f.get(v);return(0,R.$Rf)(l)?S:l}getBoolean(v,S){const l=this.get(v);return(0,R.$Rf)(l)?S:l==="true"}getNumber(v,S){const l=this.get(v);return(0,R.$Rf)(l)?S:parseInt(l,10)}getObject(v,S){const l=this.get(v);return(0,R.$Rf)(l)?S:(0,I.$Bh)(l)}async set(v,S,l=!1){if(this.c===y.Closed)return;if((0,R.$Rf)(S))return this.delete(v,l);const f=(0,R.$Kf)(S)||Array.isArray(S)?(0,I.$Ah)(S):String(S);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire({key:v,external:l}),this.D()}async delete(v,S=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$qp=L;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,l)=>this.a.set(l,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$rp=C}),define(ke[189],Se([1,0,12,10,22]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let I;function R(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function L(){return y||(y=T.$D()?R():$()),y}e.$at=L;function C(S,l,f){const o=new Uint16Array(S.buffer,l,f);return f>0&&(o[0]===65279||o[0]===65534)?m(S,l,f):R().decode(o)}e.$bt=C;function m(S,l,f){const o=[];let i=0;for(let r=0;r<f;r++){const n=g.$le(S,l);l+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class v{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return L().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const f=this.a-this.d;f<=1&&(f===0||D.$df(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const f=l.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=l;return}for(let o=0;o<f;o++)this.b[this.d++]=l.charCodeAt(o)}}e.$ct=v}),define(ke[190],Se([1,0,22,189]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,L,C,m){this.oldPosition=y,this.oldText=L,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,L,C){const m=L.length;D.$oe(y,m,C),C+=4;for(let v=0;v<m;v++)D.$me(y,L.charCodeAt(v),C),C+=2;return C}static d(y,L){const C=D.$ne(y,L);return L+=4,(0,T.$bt)(y,L,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,L){return D.$oe(y,this.oldPosition,L),L+=4,D.$oe(y,this.newPosition,L),L+=4,L=I.c(y,this.oldText,L),L=I.c(y,this.newText,L),L}static read(y,L,C){const m=D.$ne(y,L);L+=4;const v=D.$ne(y,L);L+=4;const S=I.d(y,L);L+=I.a(S);const l=I.d(y,L);return L+=I.a(l),C.push(new I(m,S,v,l)),L}}e.$dt=I;function R($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$et=R;class b{constructor(y,L){this.a=y,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,L=0,C=this.n(y),m=this.l(L);for(;y<this.f||L<this.h;){if(C===null){this.k(m),m=this.l(++L);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++L);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[o,i]=b.r(m,C.newPosition-m.oldPosition);this.k(o),m=i;continue}if(C.newPosition<m.oldPosition){const[o,i]=b.q(C,m.oldPosition-C.newPosition);this.m(o),C=i;continue}let l,f;if(m.oldEnd===C.newEnd)l=C,f=m,C=this.n(++y),m=this.l(++L);else if(m.oldEnd<C.newEnd){const[o,i]=b.q(C,m.oldLength);l=o,f=m,C=i,m=this.l(++L)}else{const[o,i]=b.r(m,C.newLength);l=C,f=o,C=this.n(++y),m=i}this.d[this.e++]=new I(l.oldPosition,l.oldText,f.newPosition,f.newText),this.g+=l.newLength-l.oldLength,this.j+=f.newLength-f.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,L){return new I(L.oldPosition-y,L.oldText,L.newPosition,L.newText)}static p(y,L){return new I(L.oldPosition,L.oldText,L.newPosition+y,L.newText)}static q(y,L){const C=y.newText.substr(0,L),m=y.newText.substr(L);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+L,m)]}static r(y,L){const C=y.oldText.substr(0,L),m=y.oldText.substr(L);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+L,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const L=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const S=y[v];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(L[C++]=m,m=S)}return L[C++]=m,L}static t(y){if(y.length===0)return y;const L=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(L[C++]=v)}return L}}}),define(ke[191],Se([1,0,34,17]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function g(I,R,b,$,y,L){if(Array.isArray(I)){let C=0;for(const m of I){const v=g(m,R,b,$,y,L);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:S,notebookType:l}=I;if(!$&&!S)return 0;l&&y&&(R=y);let f=0;if(v)if(v===R.scheme)f=10;else if(v==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(l)if(l===L)f=10;else if(l==="*"&&L!==void 0)f=Math.max(f,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,T.$hc)(m.base)},o===R.fsPath||(0,D.$Lj)(o,R.fsPath))f=10;else return 0}return f}else return 0}}e.$Bt=g}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class L extends y.$Tc{constructor(m,v,S,l,f,o,i){super(),this.m=this.B(new D.$Vd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=l,this.h=f,this.c=new R.$aC(m,S,i)}equals(m){return!(m instanceof L)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const S=m+v,l=this.getPositionAt(m),f=this.getPositionAt(S);return new g.$Us(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const o=this.n(v),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=m.endLineNumber-m.startLineNumber;f=r*n}return l-S+f}getCharacterCountInRange(m,v=0){if(this.j){let S=0;const l=m.startLineNumber,f=m.endLineNumber;for(let o=l;o<=f;o++){const i=this.getLineContent(o),r=o===l?m.startColumn-1:0,n=o===f?m.endColumn-1:i.length;for(let c=r;c<n;c++)T.$df(i.charCodeAt(c))?(S=S+1,c=c+1):S=S+1}return S+=this.n(v).length*(f-l),S}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=T.$1e(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=T.$3e(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,S){let l=this.g,f=this.h,o=this.j,i=!0,r=[];for(let a=0;a<m.length;a++){const d=m[a];i&&d._isTracked&&(i=!1);const k=d.range;if(d.text){let P=!0;o||(P=!T.$of(d.text),o=P),!l&&P&&(l=T.$nf(d.text)),!f&&P&&(f=T.$qf(d.text))}let A="",p=0,w=0,E=0;if(d.text){let P;[p,w,E,P]=(0,b.$ut)(d.text);const F=this.getEOL();P===0||P===(F===`\r
`?2:1)?A=d.text:A=d.text.replace(/\r\n|\r|\n/g,F)}r[a]={sortIndex:a,identifier:d.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:A,eolCount:p,firstLineLength:w,lastLineLength:E,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}r.sort(L.u);let n=!1;for(let a=0,d=r.length-1;a<d;a++){const k=r[a].range.getEndPosition(),A=r[a+1].range.getStartPosition();if(A.isBeforeOrEqual(k)){if(A.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const c=S||v?L._getInverseEditRanges(r):[],t=[];if(v)for(let a=0;a<r.length;a++){const d=r[a],k=c[a];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let A=k.startLineNumber;A<=k.endLineNumber;A++){let p="";A===k.startLineNumber&&(p=this.getLineContent(d.range.startLineNumber),T.$1e(p)!==-1)||t.push({lineNumber:A,oldContent:p})}}let u=null;if(S){let a=0;u=[];for(let d=0;d<r.length;d++){const k=r[d],A=c[d],p=this.getValueInRange(k.range),w=k.rangeOffset+a;a+=k.text.length-p.length,u[d]={sortIndex:k.sortIndex,identifier:k.identifier,range:A,text:p,textChange:new $.$dt(k.rangeOffset,p,w,k.text)}}n||u.sort((d,k)=>d.sortIndex-k.sortIndex)}this.g=l,this.h=f,this.j=o;const s=this.t(r);let h=null;if(v&&t.length>0){t.sort((a,d)=>d.lineNumber-a.lineNumber),h=[];for(let a=0,d=t.length;a<d;a++){const k=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===k)continue;const A=t[a].oldContent,p=this.getLineContent(k);p.length===0||p===A||T.$1e(p)!==-1||h.push(k)}}return this.m.fire(),new I.$ev(u,s,h)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const S=m[0].range,l=m[m.length-1].range,f=new g.$Us(S.startLineNumber,S.startColumn,l.endLineNumber,l.endColumn);let o=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,h=m.length;s<h;s++){const a=m[s],d=a.range;v=v||a.forceMoveMarkers,r.push(this.getValueInRange(new g.$Us(o,i,d.startLineNumber,d.startColumn))),a.text.length>0&&r.push(a.text),o=d.endLineNumber,i=d.endColumn}const n=r.join(""),[c,t,u]=(0,b.$ut)(n);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:n,eolCount:c,firstLineLength:t,lastLineLength:u,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(L.w);const v=[];for(let S=0;S<m.length;S++){const l=m[S],f=l.range.startLineNumber,o=l.range.startColumn,i=l.range.endLineNumber,r=l.range.endColumn;if(f===i&&o===r&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const n=new g.$Us(f,o,i,r);v.push({range:n,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,S,l){return this.c.findMatchesLineByLine(m,v,S,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const S=m.startLineNumber,l=m.startColumn,[f,o,i]=(0,b.$ut)(v);let r;if(v.length>0){const n=f+1;n===1?r=new g.$Us(S,l,S,l+o):r=new g.$Us(S,l,S+n-1,i+1)}else r=new g.$Us(S,l,S,l);return r}static _getInverseEditRanges(m){const v=[];let S=0,l=0,f=null;for(let o=0,i=m.length;o<i;o++){const r=m[o];let n,c;f?f.range.endLineNumber===r.range.startLineNumber?(n=S,c=l+(r.range.startColumn-f.range.endColumn)):(n=S+(r.range.startLineNumber-f.range.endLineNumber),c=r.range.startColumn):(n=r.range.startLineNumber,c=r.range.startColumn);let t;if(r.text.length>0){const u=r.eolCount+1;u===1?t=new g.$Us(n,c,n,c+r.firstLineLength):t=new g.$Us(n,c,n+u-1,r.lastLineLength+1)}else t=new g.$Us(n,c,n,c);S=t.endLineNumber,l=t.endColumn,v.push(t),f=r}return v}static u(m,v){const S=g.$Us.compareRangesUsingEnds(m.range,v.range);return S===0?m.sortIndex-v.sortIndex:S}static w(m,v){const S=g.$Us.compareRangesUsingEnds(m.range,v.range);return S===0?v.sortIndex-m.sortIndex:-S}}e.$bC=L}),define(ke[193],Se([1,0,12,127,192]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class I{constructor($,y,L,C,m,v,S,l,f){this.a=$,this.b=y,this.c=L,this.d=C,this.e=m,this.f=v,this.g=S,this.h=l,this.j=f}k($){const y=this.c+this.d+this.e,L=this.c+this.e;return y===0?$===1?`
`:`\r
`:L>y/2?`\r
`:`
`}create($){const y=this.k($),L=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=L.length;m<v;m++){const S=L[m].buffer.replace(/\r\n|\r|\n/g,y),l=(0,T.$9B)(S);L[m]=new T.$_B(S,l)}const C=new g.$bC(L,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$wf($)&&(this.b=D.$vf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,T.$0B)(this.e,$);this.a.push(new T.$_B($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$nf($)),this.k||(this.k=D.$qf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,T.$9B)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$cC=R}),define(ke[131],Se([1,0,22,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,v=C.length;m<v;m+=4){const S=C[m+0],l=C[m+1],f=C[m+2],o=C[m+3];C[m+0]=o,C[m+1]=f,C[m+2]=l,C[m+3]=S}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.$D()||I(m),D.$je.wrap(m)}function b(C){const m=C.buffer;if(T.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const S of C.deltas)m[v++]=S.start,m[v++]=S.deleteCount,S.data?(m[v++]=S.data.length,m.set(S.data,v),v+=S.data.length):m[v++]=0}return R(m)}e.$w$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function L(C){const m=b(C);let v=0;const S=m[v++];if(m[v++]===1){const i=m[v++],r=m.subarray(v,v+i);return v+=i,{id:S,type:"full",data:r}}const f=m[v++],o=[];for(let i=0;i<f;i++){const r=m[v++],n=m[v++],c=m[v++];let t;c>0&&(t=m.subarray(v,v+c),v+=c),o[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$x$=L}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,10,170,126,194]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(ae,Ie,qe,Ye){this.id=ae,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(ae,Ie){return v(ae,Ie)}compute(ae,Ie,qe){return qe}}class m{constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=m;function v(ne,ae){if(typeof ne!="object"||typeof ae!="object"||!ne||!ae)return new m(ae,ne!==ae);if(Array.isArray(ne)||Array.isArray(ae)){const qe=Array.isArray(ne)&&Array.isArray(ae)&&D.$ub(ne,ae);return new m(ae,!qe)}let Ie=!1;for(const qe in ae)if(ae.hasOwnProperty(qe)){const Ye=v(ne[qe],ae[qe]);Ye.didChange&&(ne[qe]=Ye.newValue,Ie=!0)}return new m(ne,Ie)}class S{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return this.defaultValue}}class l{constructor(ae,Ie,qe,Ye){this.id=ae,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,qe){return qe}}function f(ne,ae){return typeof ne>"u"?ae:ne==="false"?!1:!!ne}e.boolean=f;class o extends l{constructor(ae,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=qe),super(ae,Ie,qe,Ye)}validate(ae){return f(ae,this.defaultValue)}}function i(ne,ae,Ie,qe){if(typeof ne>"u")return ae;let Ye=parseInt(ne,10);return isNaN(Ye)?ae:(Ye=Math.max(Ie,Ye),Ye=Math.min(qe,Ye),Ye|0)}e.clampedInt=i;class r extends l{static clampedInt(ae,Ie,qe,Ye){return i(ae,Ie,qe,Ye)}constructor(ae,Ie,qe,Ye,nt,it=void 0){typeof it<"u"&&(it.type="integer",it.default=qe,it.minimum=Ye,it.maximum=nt),super(ae,Ie,qe,it),this.minimum=Ye,this.maximum=nt}validate(ae){return r.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function n(ne,ae,Ie,qe){if(typeof ne>"u")return ae;const Ye=c.float(ne,ae);return c.clamp(Ye,Ie,qe)}e.clampedFloat=n;class c extends l{static clamp(ae,Ie,qe){return ae<Ie?Ie:ae>qe?qe:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const qe=parseFloat(ae);return isNaN(qe)?Ie:qe}constructor(ae,Ie,qe,Ye,nt){typeof nt<"u"&&(nt.type="number",nt.default=qe),super(ae,Ie,qe,nt),this.validationFn=Ye}validate(ae){return this.validationFn(c.float(ae,this.defaultValue))}}class t extends l{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=qe),super(ae,Ie,qe,Ye)}validate(ae){return t.string(ae,this.defaultValue)}}function u(ne,ae,Ie,qe){return typeof ne!="string"?ae:qe&&ne in qe?qe[ne]:Ie.indexOf(ne)===-1?ae:ne}e.stringSet=u;class s extends l{constructor(ae,Ie,qe,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ye,nt.default=qe),super(ae,Ie,qe,nt),this.c=Ye}validate(ae){return u(ae,this.defaultValue,this.c)}}class h extends C{constructor(ae,Ie,qe,Ye,nt,it,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=nt,Oe.default=Ye),super(ae,Ie,qe,Oe),this.c=nt,this.d=it}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,qe){return qe===0?ae.accessibilitySupport:qe}}class k extends C{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var A;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(A||(e.TextEditorCursorBlinkingStyle=A={}));function p(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function E(ne){switch(ne){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(ne){switch(ne){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class F extends S{constructor(){super(140)}compute(ae,Ie,qe){const Ye=["monaco-editor"];return Ie.get(39)&&Ye.push(Ie.get(39)),ae.extraEditorClassName&&Ye.push(ae.extraEditorClassName),Ie.get(73)==="default"?Ye.push("mouse-default"):Ie.get(73)==="copy"&&Ye.push("mouse-copy"),Ie.get(110)&&Ye.push("showUnused"),Ie.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ae,Ie,qe){return qe&&ae.emptySelectionClipboard}}class N extends C{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:b.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":u(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":u(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"||ae.length===0?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?M.OFF:ae==="true"?M.TRANSLATE:ae:ae?M.TRANSLATE:M.OFF}compute(ae,Ie,qe){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class O extends S{constructor(){super(50)}compute(ae,Ie,qe){return ae.fontInfo}}class U extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ae){const Ie=c.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ie,6,100)}compute(ae,Ie,qe){return ae.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(r.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class le extends C{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:qe,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:qe,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:qe,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:qe,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:qe,description:b.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:u(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??u(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??u(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??u(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??u(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??u(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:b.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var J;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class X extends S{constructor(){super(143)}compute(ae,Ie,qe){return X.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,qe=Math.floor(ae.paddingTop/ae.lineHeight);let Ye=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ie-1));const nt=(qe+ae.viewLineCount+Ye)/(ae.pixelRatio*ae.height),it=Math.floor(ae.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ye,desiredRatio:nt,minimapLineCount:it}}static c(ae,Ie){const qe=ae.outerWidth,Ye=ae.outerHeight,nt=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const it=Ie.stableMinimapLayoutInput,Oe=it&&ae.outerHeight===it.outerHeight&&ae.lineHeight===it.lineHeight&&ae.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&ae.pixelRatio===it.pixelRatio&&ae.scrollBeyondLastLine===it.scrollBeyondLastLine&&ae.paddingTop===it.paddingTop&&ae.paddingBottom===it.paddingBottom&&ae.minimap.enabled===it.minimap.enabled&&ae.minimap.side===it.minimap.side&&ae.minimap.size===it.minimap.size&&ae.minimap.showSlider===it.minimap.showSlider&&ae.minimap.renderCharacters===it.minimap.renderCharacters&&ae.minimap.maxColumn===it.minimap.maxColumn&&ae.minimap.scale===it.minimap.scale&&ae.verticalScrollbarWidth===it.verticalScrollbarWidth&&ae.isViewportWrapping===it.isViewportWrapping,pt=ae.lineHeight,St=ae.typicalHalfwidthCharacterWidth,Ft=ae.scrollBeyondLastLine,Vt=ae.minimap.renderCharacters;let Et=nt>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Kt=ae.minimap.maxColumn,Ot=ae.minimap.size,Yt=ae.minimap.side,zt=ae.verticalScrollbarWidth,Rt=ae.viewLineCount,et=ae.remainingWidth,Gt=ae.isViewportWrapping,Jt=Vt?2:3;let ht=Math.floor(nt*Ye);const bt=ht/nt;let Ut=!1,Wt=!1,Dt=Jt*Et,ft=Et/nt,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:Te,desiredRatio:Fe,minimapLineCount:Ce}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ft,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ye,lineHeight:pt,pixelRatio:nt});if(Rt/Ce>1)Ut=!0,Wt=!0,Et=1,Dt=1,ft=Et/nt;else{let Ne=!1,We=Et+1;if(Ot==="fit"){const xe=Math.ceil((Nt+Rt+Te)*Dt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(Ne=!0,We=Ie.stableFitMaxMinimapScale):Ne=xe>ht}if(Ot==="fill"||Ne){Ut=!0;const xe=Et;Dt=Math.min(pt*nt,Math.max(1,Math.floor(1/Fe))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(We=Ie.stableFitMaxMinimapScale),Et=Math.min(We,Math.max(1,Math.floor(Dt/Jt))),Et>xe&&(At=Math.min(2,Et/xe)),ft=Et/nt/At,ht=Math.ceil(Math.max(gt,Nt+Rt+Te)*Dt),Gt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*ft),Ct=Math.min(xt,Math.max(0,Math.floor((et-zt-2)*ft/(St+ft)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(nt*Ct);const Tt=Qe/nt;Qe=Math.floor(Qe*At);const qt=Vt?1:2,Qt=Yt==="left"?0:qe-Ct-zt;return{renderMinimap:qt,minimapLeft:Qt,minimapWidth:Ct,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:Et,minimapLineHeight:Dt,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:bt}}static computeLayout(ae,Ie){const qe=Ie.outerWidth|0,Ye=Ie.outerHeight|0,nt=Ie.lineHeight|0,it=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,pt=Ie.maxDigitWidth,St=Ie.pixelRatio,Ft=Ie.viewLineCount,Vt=ae.get(135),Et=Vt==="inherit"?ae.get(134):Vt,Kt=Et==="inherit"?ae.get(130):Et,Ot=ae.get(133),Yt=Ie.isDominatedByLongLines,zt=ae.get(57),Rt=ae.get(67).renderType!==0,et=ae.get(68),Gt=ae.get(104),Jt=ae.get(83),ht=ae.get(72),bt=ae.get(102),Ut=bt.verticalScrollbarSize,Wt=bt.verticalHasArrows,Dt=bt.arrowSize,ft=bt.horizontalScrollbarSize,At=ae.get(43),xt=ae.get(109)!=="never";let Ct=ae.get(65);At&&xt&&(Ct+=16);let Qe=0;if(Rt){const st=Math.max(it,et);Qe=Math.round(st*pt)}let Tt=0;zt&&(Tt=nt*Ie.glyphMarginDecorationLaneCount);let qt=0,Qt=qt+Tt,gt=Qt+Qe,Nt=gt+Ct;const Te=qe-Tt-Qe-Ct;let Fe=!1,Ce=!1,se=-1;Et==="inherit"&&Yt?(Fe=!0,Ce=!0):Kt==="on"||Kt==="bounded"?Ce=!0:Kt==="wordWrapColumn"&&(se=Ot);const Ne=X.c({outerWidth:qe,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:Oe,pixelRatio:St,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:Ut,viewLineCount:Ft,remainingWidth:Te,isViewportWrapping:Ce},Ie.memory||new L);Ne.renderMinimap!==0&&Ne.minimapLeft===0&&(qt+=Ne.minimapWidth,Qt+=Ne.minimapWidth,gt+=Ne.minimapWidth,Nt+=Ne.minimapWidth);const We=Te-Ne.minimapWidth,xe=Math.max(1,Math.floor((We-Ut-2)/Oe)),Ke=Wt?Dt:0;return Ce&&(se=Math.max(1,xe),Kt==="bounded"&&(se=Math.min(se,Ot))),{width:qe,height:Ye,glyphMarginLeft:qt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Qe,decorationsLeft:gt,decorationsWidth:Ct,contentLeft:Nt,contentWidth:We,minimap:Ne,viewportColumn:xe,isWordWrapMinified:Fe,isViewportWrapping:Ce,wrappingColumn:se,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:ft,overviewRuler:{top:Ke,width:Ut,height:Ye-2*Ke,right:0}}}}e.EditorLayoutInfoComputer=X;class ue extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ae){return u(ae,"simple",["simple","advanced"])}compute(ae,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var x;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(x||(e.ShowLightbulbIconMode=x={}));class be extends C{constructor(){const ae={enabled:x.On};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"string",enum:[x.Off,x.OnCode,x.On],default:ae.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:u(ae.enabled,this.defaultValue.enabled,[x.Off,x.OnCode,x.On])}}}class ce extends C{constructor(){const ae={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:b.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:b.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:b.localize(65,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:u(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class V extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):r.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,qe){return qe<0?r.clampedInt(-qe*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class re extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>c.clamp(ae,0,150),{markdownDescription:b.localize(66,null)})}compute(ae,Ie,qe){return ae.fontInfo.lineHeight}}class ye extends C{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ae.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:b.localize(77,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:u(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Ie.side,this.defaultValue.side,["right","left"]),showSlider:u(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ie.scale,1,1,3),maxColumn:r.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ne){return ne==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:r.clampedInt(Ie.top,0,0,1e3),bottom:r.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends C{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:b.localize(81,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class te extends S{constructor(){super(141)}compute(ae,Ie,qe){return ae.pixelRatio}}class G extends C{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:ae.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:ae.other,description:b.localize(87,null)}},default:ae,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const St=ae?"on":"off";return{comments:St,strings:St,other:St}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Ye}=ae,nt=["on","inline","off"];let it,Oe,pt;return typeof Ie=="boolean"?it=Ie?"on":"off":it=u(Ie,this.defaultValue.other,nt),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=u(qe,this.defaultValue.comments,nt),typeof Ye=="boolean"?pt=Ye?"on":"off":pt=u(Ye,this.defaultValue.strings,nt),{other:it,comments:Oe,strings:pt}}}var ie;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(ae){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,qe=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function ve(ne){const ae=ne.get(97);return ae==="editable"?ne.get(90):ae!=="on"}e.filterValidationDecorations=ve;class Pe extends C{constructor(){const ae=[],Ie={type:"number",description:b.localize(94,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:ae,description:b.localize(96,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const qe of ae)if(typeof qe=="number")Ie.push({column:r.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ye=qe;Ie.push({column:r.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ie.sort((qe,Ye)=>qe.column-Ye.column),Ie}return this.defaultValue}}class we extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function De(ne,ae){if(typeof ne!="string")return ae;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends C{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ae.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,qe=r.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=r.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:r.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:r.clampedInt(Ie.verticalSliderSize,Ye,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:b.localize(115,null)}})}applyUpdate(ae,Ie){let qe=!1;Ie.allowedCharacters&&ae&&(T.$zn(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&ae&&(T.$zn(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},qe=!0));const Ye=super.applyUpdate(ae,Ie);return qe?new m(Ye.newValue,!0):Ye}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const qe={};for(const[Ye,nt]of Object.entries(ae))nt===!0&&(qe[Ye]=!0);return qe}}class ee extends C{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:b.localize(121,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:u(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class q extends C{constructor(){const ae={enabled:I.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:b.localize(123,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ae.bracketPairs,description:b.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(128,null),b.localize(129,null),b.localize(130,null)],default:ae.bracketPairsHorizontal,description:b.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:b.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:b.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(134,null),b.localize(135,null),b.localize(136,null)],default:ae.highlightActiveIndentation,description:b.localize(137,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ne,ae,Ie){const qe=Ie.indexOf(ne);return qe===-1?ae:Ie[qe]}class Le extends C{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(138,null),b.localize(139,null)],default:ae.insertMode,description:b.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:b.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:b.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:b.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(144,null),b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ae.selectionMode,markdownDescription:b.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:b.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:b.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:b.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:b.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:b.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:u(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:u(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(187,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Je extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(188,null),b.localize(189,null),b.localize(190,null),b.localize(191,null)],description:b.localize(192,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,qe){return Ie.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(ae,Ie,qe){const Ye=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class ct extends C{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:u(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends C{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(199,null),b.localize(200,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:u(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Ae:g.$k?ze:rt,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Xe;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(201,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(202,null),""],markdownDescription:b.localize(203,null)})),accessibilitySupport:Re(new d),accessibilityPageSize:Re(new r(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(204,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",b.localize(205,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingComments:Re(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(210,null),b.localize(211,null),""],description:b.localize(212,null)})),autoClosingDelete:Re(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(213,null),""],description:b.localize(214,null)})),autoClosingOvertype:Re(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(215,null),""],description:b.localize(216,null)})),autoClosingQuotes:Re(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(217,null),b.localize(218,null),""],description:b.localize(219,null)})),autoIndent:Re(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),automaticLayout:Re(new o(13,"automaticLayout",!1)),autoSurround:Re(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null),""],description:b.localize(229,null)})),bracketPairColorization:Re(new q),bracketPairGuides:Re(new oe),stickyTabStops:Re(new o(115,"stickyTabStops",!1,{description:b.localize(230,null)})),codeLens:Re(new o(17,"codeLens",!0,{description:b.localize(231,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:b.localize(232,null)})),codeLensFontSize:Re(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(233,null)})),colorDecorators:Re(new o(20,"colorDecorators",!0,{description:b.localize(234,null)})),colorDecoratorActivatedOn:Re(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),colorDecoratorsLimit:Re(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(239,null)})),columnSelection:Re(new o(22,"columnSelection",!1,{description:b.localize(240,null)})),comments:Re(new k),contextmenu:Re(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(241,null)})),cursorBlinking:Re(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(242,null)})),cursorSmoothCaretAnimation:Re(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),cursorStyle:Re(new h(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(247,null)})),cursorSurroundingLines:Re(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(248,null)})),cursorSurroundingLinesStyle:Re(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(249,null),b.localize(250,null)],markdownDescription:b.localize(251,null)})),cursorWidth:Re(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(252,null)})),disableLayerHinting:Re(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(34,"domReadOnly",!1)),dragAndDrop:Re(new o(35,"dragAndDrop",!0,{description:b.localize(253,null)})),emptySelectionClipboard:Re(new z),dropIntoEditor:Re(new ct),stickyScroll:Re(new ce),experimentalWhitespaceRendering:Re(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(254,null),b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(258,null)})),find:Re(new N),fixedOverflowWidgets:Re(new o(42,"fixedOverflowWidgets",!1)),folding:Re(new o(43,"folding",!0,{description:b.localize(259,null)})),foldingStrategy:Re(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(260,null),b.localize(261,null)],description:b.localize(262,null)})),foldingHighlight:Re(new o(45,"foldingHighlight",!0,{description:b.localize(263,null)})),foldingImportsByDefault:Re(new o(46,"foldingImportsByDefault",!1,{description:b.localize(264,null)})),foldingMaximumRegions:Re(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(265,null)})),unfoldOnClickAfterEndOfLine:Re(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(266,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(267,null)})),fontInfo:Re(new O),fontLigatures2:Re(new j),fontSize:Re(new U),fontWeight:Re(new Y),fontVariations:Re(new M),formatOnPaste:Re(new o(55,"formatOnPaste",!1,{description:b.localize(268,null)})),formatOnType:Re(new o(56,"formatOnType",!1,{description:b.localize(269,null)})),glyphMargin:Re(new o(57,"glyphMargin",!0,{description:b.localize(270,null)})),gotoLocation:Re(new le),hideCursorInOverviewRuler:Re(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(271,null)})),hover:Re(new Z),inDiffEditor:Re(new o(61,"inDiffEditor",!1)),letterSpacing:Re(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:b.localize(272,null)})),lightbulb:Re(new be),lineDecorationsWidth:Re(new V),lineHeight:Re(new re),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(69,"linkedEditing",!1,{description:b.localize(273,null)})),links:Re(new o(70,"links",!0,{description:b.localize(274,null)})),matchBrackets:Re(new s(71,"matchBrackets","always",["always","near","never"],{description:b.localize(275,null)})),minimap:Re(new ye),mouseStyle:Re(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new c(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(276,null)})),mouseWheelZoom:Re(new o(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(277,null):b.localize(278,null)})),multiCursorMergeOverlapping:Re(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Re(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Re(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Re(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Re(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Re(new o(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Re(new r(82,"overviewRulerLanes",3,0,3)),padding:Re(new ge),pasteAs:Re(new ot),parameterHints:Re(new _),peekWidgetDefaultFocus:Re(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Re(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Re(new G),quickSuggestionsDelay:Re(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Re(new o(90,"readOnly",!1)),readOnlyMessage:Re(new we),renameOnType:Re(new o(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Re(new o(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Re(new s(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Re(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Re(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Re(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Re(new Pe),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Re(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Re(new o(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Re(new o(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Re(new o(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Re(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Re(new o(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Re(new o(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Re(new K),snippetSuggestions:Re(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Re(new je),smoothScrolling:Re(new o(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Re(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Le),inlineSuggest:Re(new ee),inlineCompletionsAccessibilityVerbose:Re(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Re(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Re(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Re(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Re(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Re(new o(126,"useShadowDOM",!0)),useTabStops:Re(new o(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Re(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Re(new t(129,"wordSeparators",R.$ts,{description:b.localize(346,null)})),wordWrap:Re(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Re(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new F),defaultColorDecorators:Re(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Re(new te),tabFocusMode:Re(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Re(new X),wrappingInfo:Re(new _e),wrappingIndent:Re(new Je),wrappingStrategy:Re(new ue)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Mt=e.$Lt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Kt=e.$Jt=e.SymbolKinds=e.SymbolTag=e.$It=e.$Ht=e.SymbolKind=e.$Gt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ft=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Et=e.$Dt=e.$Ct=void 0;class ${constructor(j,M,O){this.offset=j,this.type=M,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ct=$;class y{constructor(j,M){this.tokens=j,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Dt=y;class L{constructor(j,M){this.tokens=j,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Et=L;var C;(function(N){N[N.Method=0]="Method",N[N.Function=1]="Function",N[N.Constructor=2]="Constructor",N[N.Field=3]="Field",N[N.Variable=4]="Variable",N[N.Class=5]="Class",N[N.Struct=6]="Struct",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Event=10]="Event",N[N.Operator=11]="Operator",N[N.Unit=12]="Unit",N[N.Value=13]="Value",N[N.Constant=14]="Constant",N[N.Enum=15]="Enum",N[N.EnumMember=16]="EnumMember",N[N.Keyword=17]="Keyword",N[N.Text=18]="Text",N[N.Color=19]="Color",N[N.File=20]="File",N[N.Reference=21]="Reference",N[N.Customcolor=22]="Customcolor",N[N.Folder=23]="Folder",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue",N[N.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(N){const j=new Map;j.set(0,D.$_j.symbolMethod),j.set(1,D.$_j.symbolFunction),j.set(2,D.$_j.symbolConstructor),j.set(3,D.$_j.symbolField),j.set(4,D.$_j.symbolVariable),j.set(5,D.$_j.symbolClass),j.set(6,D.$_j.symbolStruct),j.set(7,D.$_j.symbolInterface),j.set(8,D.$_j.symbolModule),j.set(9,D.$_j.symbolProperty),j.set(10,D.$_j.symbolEvent),j.set(11,D.$_j.symbolOperator),j.set(12,D.$_j.symbolUnit),j.set(13,D.$_j.symbolValue),j.set(15,D.$_j.symbolEnum),j.set(14,D.$_j.symbolConstant),j.set(15,D.$_j.symbolEnum),j.set(16,D.$_j.symbolEnumMember),j.set(17,D.$_j.symbolKeyword),j.set(27,D.$_j.symbolSnippet),j.set(18,D.$_j.symbolText),j.set(19,D.$_j.symbolColor),j.set(20,D.$_j.symbolFile),j.set(21,D.$_j.symbolReference),j.set(22,D.$_j.symbolCustomColor),j.set(23,D.$_j.symbolFolder),j.set(24,D.$_j.symbolTypeParameter),j.set(25,D.$_j.account),j.set(26,D.$_j.issues);function M(Y){let le=j.get(Y);return le||(console.info("No codicon found for CompletionItemKind "+Y),le=D.$_j.symbolProperty),le}N.toIcon=M;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function U(Y,le){let Z=O.get(Y);return typeof Z>"u"&&!le&&(Z=9),Z}N.fromString=U})(m||(e.CompletionItemKinds=m={}));var v;(function(N){N[N.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(N){N[N.None=0]="None",N[N.KeepWhitespace=1]="KeepWhitespace",N[N.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var l;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var f;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class o{constructor(j,M,O,U){this.range=j,this.text=M,this.completionKind=O,this.isSnippetText=U}equals(j){return I.$Us.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$Ft=o;var i;(function(N){N[N.Invoke=1]="Invoke",N[N.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function c(N){return N&&T.URI.isUri(N.uri)&&I.$Us.isIRange(N.range)&&(I.$Us.isIRange(N.originSelectionRange)||I.$Us.isIRange(N.targetSelectionRange))}e.$Gt=c;var t;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ht={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function u(N,j){return(0,b.localize)(26,null,N,e.$Ht[j])}e.$It=u;var s;(function(N){N[N.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var h;(function(N){const j=new Map;j.set(0,D.$_j.symbolFile),j.set(1,D.$_j.symbolModule),j.set(2,D.$_j.symbolNamespace),j.set(3,D.$_j.symbolPackage),j.set(4,D.$_j.symbolClass),j.set(5,D.$_j.symbolMethod),j.set(6,D.$_j.symbolProperty),j.set(7,D.$_j.symbolField),j.set(8,D.$_j.symbolConstructor),j.set(9,D.$_j.symbolEnum),j.set(10,D.$_j.symbolInterface),j.set(11,D.$_j.symbolFunction),j.set(12,D.$_j.symbolVariable),j.set(13,D.$_j.symbolConstant),j.set(14,D.$_j.symbolString),j.set(15,D.$_j.symbolNumber),j.set(16,D.$_j.symbolBoolean),j.set(17,D.$_j.symbolArray),j.set(18,D.$_j.symbolObject),j.set(19,D.$_j.symbolKey),j.set(20,D.$_j.symbolNull),j.set(21,D.$_j.symbolEnumMember),j.set(22,D.$_j.symbolStruct),j.set(23,D.$_j.symbolEvent),j.set(24,D.$_j.symbolOperator),j.set(25,D.$_j.symbolTypeParameter);function M(O){let U=j.get(O);return U||(console.info("No codicon found for SymbolKind "+O),U=D.$_j.symbolProperty),U}N.toIcon=M})(h||(e.SymbolKinds=h={}));class a{static asEditOperation(j){return g.$Vs.replace(I.$Us.lift(j.range),j.text)}}e.$Jt=a;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(j){switch(j){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(j)}constructor(j){this.value=j}}e.$Kt=d;var k;(function(N){function j(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}N.is=j})(k||(e.Command=k={}));var A;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(A||(e.CommentThreadCollapsibleState=A={}));var p;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(p||(e.CommentThreadState=p={}));var w;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(w||(e.CommentMode=w={}));var E;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(E||(e.CommentState=E={}));var P;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class F{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Lt=F,e.$Mt=new R.$tt;var z;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:L}),this.f.push(v)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,C=!1,m=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(b);return}const S=this.c.charCodeAt(L);if(C)C=!1;else if(S===47&&!m){L++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);L++}for(;L<this.c.length&&$.a.has(this.c.charCodeAt(L));)L++;this.e=L;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=$}),define(ke[237],Se([1,0,23,39,201,386]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||R.test(o)}e.$ap=$;function y(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$bp=y;function L(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),u=!1);let s=0;if(o.preRelease){const h=b.exec(o.preRelease);if(h){const[,a,d,k]=h;s=Date.UTC(Number(a),Number(d)-1,Number(k))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:c,patchBase:t,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$cp=L;function C(o,i,r){let n;typeof o=="string"?n=L(y(o)):n=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof r=="string"?t=L(y(r)):t=r,!n||!t)return!1;const u=n.majorBase,s=n.minorBase,h=n.patchBase;let a=t.majorBase,d=t.minorBase,k=t.patchBase;const A=t.notBefore;let p=t.majorMustEqual,w=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?u>a?!0:u<a?!1:s>d?!0:s<d||c&&c<A?!1:h>=k:(u===1&&a===0&&(!p||!w||!E)&&(a=1,d=0,k=0,p=!0,w=!1,E=!1),u<a?!1:u>a?!p:s<d?!1:s>d?!w:h<k?!1:h>k?!E:!(c&&c<A))}e.$dp=C;function m(o,i,r,n,c){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof n.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!n.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!f(n.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!f(n.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const h=(0,D.$Hg)(r,n.main);(0,D.$Bg)(h,r)||t.push([T.default.Warning,g.localize(10,null,h.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const h=(0,D.$Hg)(r,n.browser);(0,D.$Bg)(h,r)||t.push([T.default.Warning,g.localize(12,null,h.path,r.path)])}}if(!I.valid(n.version))return t.push([T.default.Error,g.localize(13,null)]),t;const u=[];if(!v(o,i,n,c,u))for(const h of u)t.push([T.default.Error,h]);return t}e.$ep=m;function v(o,i,r,n,c){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:l(o,i,r.engines.vscode,c)}e.$fp=v;function S(o,i,r){return o==="*"||l(i,r,o)}e.$gp=S;function l(o,i,r,n=[]){const c=L(y(r));if(!c)return n.push(g.localize(14,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return n.push(g.localize(15,null,r)),!1}else if(!c.majorMustEqual)return n.push(g.localize(16,null,r)),!1;return C(o,i,c)?!0:(n.push(g.localize(17,null,o,r)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class D{constructor(g,I=[],R=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$3h=D}),define(ke[84],Se([1,0,106]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const T=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$3h||($=new D.$3h($,[],!!y)),T.push([b,$])}e.$Yr=I;function R(){return T}e.$Zr=R}),define(ke[238],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class D{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=D;class T{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let b=this.a.get(R);return b||(b=new D(R,I),this.a.set(R,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,b]of this.a)I.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const b=new Set([I]),$=this.c(R,b);if($)return $}}c(I,R){for(const[b,$]of I.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this.c($,R);if(y)return y;R.delete(b)}}}e.$Dq=T}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(D||(e._util=D={})),e.$5h=g("instantiationService");function T(R,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:R,index:$}):(b[D.DI_DEPENDENCIES]=[{id:R,index:$}],b[D.DI_TARGET]=b)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const b=function($,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,$,L)};return b.toString=()=>R,D.serviceIds.set(R,b),b}e.$6h=g;function I(R){return R}e.$7h=I}),define(ke[51],Se([1,0,18,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,g.$6h)("configurationService");function I(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$Ai=I;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$Bi=R;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=$;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Di=y;function L(o,i){const r=Object.create(null);for(const n in o)C(r,n,o[n],i);return r}e.$Ei=L;function C(o,i,r,n){const c=i.split("."),t=c.pop();let u=o;for(let s=0;s<c.length;s++){const h=c[s];let a=u[h];switch(typeof a){case"undefined":a=u[h]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${c.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[t]=r}catch{n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}e.$Fi=C;function m(o,i){const r=i.split(".");v(o,r)}e.$Gi=m;function v(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(v(n,i),Object.keys(n).length===0&&delete o[r])}}function S(o,i,r){function n(u,s){let h=u;for(const a of s){if(typeof h!="object"||h===null)return;h=h[a]}return h}const c=i.split("."),t=n(o,c);return typeof t>"u"?r:t}e.$Hi=S;function l(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?D.$Kf(o[n])&&D.$Kf(i[n])?l(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.$Ii=l;function f(o){return o.replace(/[\[\]]/g,"")}e.$Ji=f}),define(ke[45],Se([1,0,10,12,236,5,197,14]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,V){if($.get(K)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,V)}e.$2i=y;const L=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),S=(0,R.localize)(1,null),l=(0,R.localize)(2,null),f=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),r=(0,R.localize)(6,null),n=(0,R.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=m){this.k=V,this.d=new g.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:g.$1i.getLexeme(ye),additionalInfo:de}),c.c}return re}catch(re){if(re!==c.c)throw re;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const re=this.o();V.push(re)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const re=this.s();V.push(re)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,f),re?.negate()}case 17:return this.z(),P.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,f),re}case 17:{const re=V.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,_=ge.lastIndexOf("/"),te=_===ge.length-1?void 0:this.w(ge.substring(_+1));let G;try{G=new RegExp(ge.substring(1,_),te)}catch{throw this.B("REGEX",de)}return O.create(re,G)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let _=this.D(),te=0;for(let Pe=0;Pe<de.lexeme.length;Pe++)de.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Pe=0;Pe<_.lexeme.length;Pe++)_.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--}if(te<0)break;ge.push(g.$1i.getLexeme(_)),this.z(),_=this.D()}const G=ge.join(""),ie=G.lastIndexOf("/"),fe=ie===G.length-1?void 0:this.w(G.substring(ie+1));let ve;try{ve=new RegExp(G.substring(1,ie),fe)}catch{throw this.B("REGEX",de)}return t.regex(re,ve)}case 18:{const ge=de.lexeme;this.z();let _=null;if(!(0,T.$Je)(ge)){const te=ge.indexOf("/"),G=ge.lastIndexOf("/");if(te!==G&&te>=0){const ie=ge.slice(te+1,G),fe=ge[G+1]==="i"?"i":"";try{_=new RegExp(ie,fe)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return O.create(re,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const de=this.u();return t.notIn(re,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(re,de);switch(de){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(re,de);switch(de){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,de)}}case 5:return this.z(),j.create(re,this.u());case 6:return this.z(),M.create(re,this.u());case 7:return this.z(),z.create(re,this.u());case 8:return this.z(),N.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:n}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,re){if(this.C(V))return this.z();throw this.B(re,this.D())}B(V,re,ye){const de=(0,R.localize)(8,null,V,g.$1i.getLexeme(re)),ge=re.offset,_=g.$1i.getLexeme(re);return this.h.push({message:de,offset:ge,lexeme:_,additionalInfo:ye}),c.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=c;class t{static false(){return a.INSTANCE}static true(){return d.INSTANCE}static has(V){return k.create(V)}static equals(V,re){return A.create(V,re)}static notEquals(V,re){return E.create(V,re)}static regex(V,re){return O.create(V,re)}static in(V,re){return p.create(V,re)}static notIn(V,re){return w.create(V,re)}static not(V){return P.create(V)}static and(...V){return le.create(V,null,!0)}static or(...V){return Z.create(V,null,!0)}static greater(V,re){return z.create(V,re)}static greaterEquals(V,re){return N.create(V,re)}static smaller(V,re){return j.create(V,re)}static smallerEquals(V,re){return M.create(V,re)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=t;function u(K){const V=new c({regexParsingWithErrorRecovery:!1});return K.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$5i=u;function s(K,V){const re=K?K.substituteConstants():void 0,ye=V?V.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$6i=s;function h(K,V){return K.cmp(V)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$7i=a;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return a.INSTANCE}}e.$8i=d;class k{static create(V,re=null){const ye=$.get(V);return typeof ye=="boolean"?ye?d.INSTANCE:a.INSTANCE:new k(V,re)}constructor(V,re){this.key=V,this.c=re,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:X(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=$.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:a.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$9i=k;class A{static create(V,re,ye=null){if(typeof re=="boolean")return re?k.create(V,ye):P.create(V,ye);const de=$.get(V);return typeof de=="boolean"?re===(de?"true":"false")?d.INSTANCE:a.INSTANCE:new A(V,re,ye)}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=$.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?d.INSTANCE:a.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$0i=A;class p{static create(V,re){return new p(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.f),ye=V.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?L.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$$i=p;class w{static create(V,re){return new w(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=11,this.c=p.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=w;class E{static create(V,re,ye=null){if(typeof re=="boolean")return re?P.create(V,ye):k.create(V,ye);const de=$.get(V);return typeof de=="boolean"?re===(de?"true":"false")?a.INSTANCE:d.INSTANCE:new E(V,re,ye)}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=$.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?a.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$aj=E;class P{static create(V,re=null){const ye=$.get(V);return typeof ye=="boolean"?ye?a.INSTANCE:d.INSTANCE:new P(V,re)}constructor(V,re){this.c=V,this.d=re,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:X(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=$.get(this.c);return typeof V=="boolean"?V?a.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$bj=P;function F(K,V){if(typeof K=="string"){const re=parseFloat(K);isNaN(re)||(K=re)}return typeof K=="string"||typeof K=="number"?V(K):a.INSTANCE}class z{static create(V,re,ye=null){return F(re,de=>new z(V,de,ye))}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$cj=z;class N{static create(V,re,ye=null){return F(re,de=>new N(V,de,ye))}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$dj=N;class j{static create(V,re,ye=null){return F(re,de=>new j(V,de,ye))}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$ej=j;class M{static create(V,re,ye=null){return F(re,de=>new M(V,de,ye))}constructor(V,re,ye){this.c=V,this.d=re,this.f=ye,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$fj=M;class O{static create(V,re){return new O(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const re=this.f?this.f.source:"",ye=V.f?V.f.source:"";return re<ye?-1:re>ye?1:0}equals(V){if(V.type===this.type){const re=this.f?this.f.source:"",ye=V.f?V.f.source:"";return this.d===V.d&&re===ye}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$gj=O;class U{static create(V){return new U(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new U(this.c.map(V))}negate(){return this.c}}e.$hj=U;function Y(K){let V=null;for(let re=0,ye=K.length;re<ye;re++){const de=K[re].substituteConstants();if(K[re]!==de&&V===null){V=[];for(let ge=0;ge<re;ge++)V[ge]=K[ge]}V!==null&&(V[re]=de)}return V===null?K:V}class le{static create(V,re,ye){return le.d(V,re,ye)}constructor(V,re){this.expr=V,this.c=re,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=h(this.expr[re],V.expr[re]);if(de!==0)return de}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:le.create(V,this.c,!1)}evaluate(V){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static d(V,re,ye){const de=[];let ge=!1;for(const _ of V)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&ge)return d.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(h);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const te=de.pop(),G=de.length===0,ie=Z.create(_.expr.map(fe=>le.create([fe,te],null,ye)),null,G);ie&&(de.push(ie),de.sort(h))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let te=_+1;te<de.length;te++)if(de[_].negate().equals(de[te]))return a.INSTANCE;if(de.length===1)return de[0]}return new le(de,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new le(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());this.c=Z.create(V,this,!0)}return this.c}}e.$ij=le;class Z{static create(V,re,ye){return Z.d(V,re,ye)}constructor(V,re){this.expr=V,this.c=re,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=h(this.expr[re],V.expr[re]);if(de!==0)return de}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:Z.create(V,this.c,!1)}evaluate(V){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(V))return!0;return!1}static d(V,re,ye){let de=[],ge=!1;if(V){for(let _=0,te=V.length;_<te;_++){const G=V[_];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return d.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&ge)return a.INSTANCE;de.sort(h)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let te=_+1;te<de.length;te++)if(de[_].negate().equals(de[te]))return d.INSTANCE;if(de.length===1)return de[0]}return new Z(de,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new Z(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),ye=V.shift(),de=[];for(const ge of ce(re))for(const _ of ce(ye))de.push(le.create([ge,_],null,!1));V.unshift(Z.create(de,null,!1))}this.c=Z.create(V,this,!0)}return this.c}}e.$jj=Z;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(V,re,ye){super(V,null),this.f=re,typeof ye=="object"?J.d.push({...ye,key:V}):ye!==!0&&J.d.push({key:V,description:ye,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return A.create(this.key,V)}notEqualsTo(V){return E.create(this.key,V)}}e.$kj=J,e.$lj=(0,I.$6h)("contextKeyService");function X(K,V){return K<V?-1:K>V?1:0}function ue(K,V,re,ye){return K<re?-1:K>re?1:V<ye?-1:V>ye?1:0}function x(K,V){if(K.type===0||V.type===1)return!0;if(K.type===9)return V.type===9?be(K.expr,V.expr):!1;if(V.type===9){for(const re of V.expr)if(x(K,re))return!0;return!1}if(K.type===6){if(V.type===6)return be(V.expr,K.expr);for(const re of K.expr)if(x(re,V))return!0;return!1}return K.equals(V)}e.$mj=x;function be(K,V){let re=0,ye=0;for(;re<K.length&&ye<V.length;){const de=K[re].cmp(V[ye]);if(de<0)return!1;de===0&&re++,ye++}return re===K.length}function ce(K){return K.type===9?K.expr:[K]}}),define(ke[239],Se([1,0,23,39,199,5,103,10,24]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.ConfirmResult=e.$8v=e.$7v=e.$6v=void 0,e.$6v=(0,I.$6h)("dialogService");var y;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(y||(y={}));class L{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,o){const i=[];switch(o){case y.Confirmation:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const r=f;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===T.default.Info?"info":f===T.default.Error?"error":f===T.default.Warning?"warning":"none"}f(f,o,i){const r=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&r.push(f.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$7v=L,e.$8v=(0,I.$6h)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(l){const f=[];return f.push(...l.slice(0,m).map(o=>typeof o=="string"?o:(0,D.$Eg)(o))),l.length>m&&(l.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,l.length-m))),f.push(""),f.join(`
`)}e.$9v=v;function S(l,f){const o=(0,$.$vn)(l);let i=(o.buttons??[]).map(t=>(0,R.$3v)(t)),r=(l.buttons||[]).map((t,u)=>u),n=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const u=r[c];r.splice(c,1),r.splice(1,0,u),c=1}b.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(c=n-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const u=r[c];r.splice(c,1),r.push(u),c=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=c,o.noLink=!0,o.title=o.title||f.nameLong,{options:o,buttonIndeces:r}}e.$0v=S}),define(ke[133],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,D.$6h)("environmentService"),e.$bi=(0,D.$7h)(e.$ai)}),define(ke[134],Se([1,0,200,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function g(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=g;function I(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=I;function R(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=R;function b(r,n){return n==="web"&&!r.includes("web")}e.$vo=b;function $(r,n,c){return b(n,c)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===c}e.$wo=$;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$xo=y;var L;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var C;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(r){r.Install="install",r.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$yo=(0,T.$6h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var l;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$zo=f;var o;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$Ao=i,e.$Bo=(0,T.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,T.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,T.$6h)("IExtensionTipsService"),e.$Go=(0,D.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a3b=e.$_2b=void 0,e.$_2b=(0,D.$6h)("externalTerminal"),e.$a3b="Terminal.app"}),define(ke[241],Se([1,0,50,52,16,17,10,102,31,105,202,240]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=e.$$0b=e.$00b=void 0;const m=L.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends v{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(D,c,y.$Tl(),t)}spawnTerminal(c,t,u,s){const h=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=I.$nc(h,".exe").toLowerCase();if(a==="cmder")return c.spawn(h,s?[s]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return h.indexOf(" ")>=0&&d.push('""'),d.push(h),a==="wt"&&d.push("-d ."),new Promise((k,A)=>{const p=o(process),w=c.spawn(u,d,{cwd:s,env:p,detached:!0});w.on("error",A),w.on("exit",()=>k())})}async runInTerminal(c,t,u,s,h){const a="windowsExec"in h&&h.windowsExec?h.windowsExec:S.getDefaultTerminalWindows(),d=await S.f();return new Promise((k,A)=>{const p=`"${t} - ${m}"`,w=`""${u.join('" "')}" & pause"`,E=Object.assign({},o(process),s);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const P={cwd:t,env:E,windowsVerbatimArguments:!0};let F,z;I.$nc(a,".exe")==="wt"?(F=a,z=["-d",".",S.b,"/c",w]):d?(F=d,z=["-d",t,a,"/c",w]):(F=S.b,z=["/c","start",p,"/wait",a,"/c",w]),D.spawn(F,z,P).on("error",j=>{A(i(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const c=await y.win32.findExecutable("wt");return await $.Promises.exists(c)?c:void 0}catch{return}}}e.$00b=S,Ge([T.$xh],S,"f",null);class l extends v{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,h){const a=h.osxExec||C.$a3b;return new Promise((d,k)=>{if(a===C.$a3b||a==="iTerm.app"){const A=a===C.$a3b?"TerminalHelper":"iTermHelper",w=[g.$og.asFileUri(`vs/workbench/contrib/externalTerminal/node/${A}.scpt`).fsPath,"-t",c||m,"-w",t];for(const F of u)w.push("-a"),w.push(F);if(s){const F=Object.assign({},o(process),s);for(const z in F){const N=F[z];N===null?(w.push("-u"),w.push(z)):(w.push("-e"),w.push(`${z}=${N}`))}}let E="";const P=D.spawn(l.b,w);P.on("error",F=>{k(i(F))}),P.stderr.on("data",F=>{E+=F.toString()}),P.on("exit",F=>{if(F===0)d(void 0);else if(E){const z=E.split(`
`,1);k(new Error(z[0]))}else k(new Error(L.localize(1,null,A,F)))})}else k(new Error(L.localize(2,null,a)))})}spawnTerminal(c,t,u){const s=t.osxExec||C.$a3b;return new Promise((h,a)=>{const d=["-a",s];u&&d.push(u);const k=o(process),A=c.spawn("/usr/bin/open",d,{cwd:u,env:k});A.on("error",a),A.on("exit",()=>h())})}}e.$$0b=l;class f extends v{static{this.b=L.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,h){const a=h.linuxExec?Promise.resolve(h.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((d,k)=>{const A=[];a.then(p=>{p.indexOf("gnome-terminal")>=0?A.push("-x"):A.push("-e"),A.push("bash"),A.push("-c");const w=`${r(u)}; echo; read -p "${f.b}" -n1;`;A.push(`''${w}''`);const E=Object.assign({},o(process),s);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const P={cwd:t,env:E};let F="";const z=D.spawn(p,A,P);z.on("error",N=>{k(i(N))}),z.stderr.on("data",N=>{F+=N.toString()}),z.on("exit",N=>{if(N===0)d(void 0);else if(F){const j=F.split(`
`,1);k(new Error(j[0]))}else k(new Error(L.localize(4,null,p,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.$k)f.d=Promise.resolve("xterm");else{const c=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(c,t,u){const s=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,a)=>{s.then(d=>{const k=o(process),A=c.spawn(d,[],{cwd:u,env:k});A.on("error",a),A.on("exit",()=>h())})})}}e.$_0b=f;function o(n){const c={...n.env};return(0,b.$Rl)(c),c}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(L.localize(5,null,n.path)):n}function r(n){let c="";for(const t of n)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(ke[32],Se([1,0,77,17,12,18,2,203,5,10,16,43]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,$.$6h)("fileService");function m(x){return x.create===!0}e.$rk=m;var v;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function l(x){const be=x;return!!be&&typeof be.onDidChange=="function"}e.$sk=l;var f;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function o(x){return!!(x.capabilities&2)}e.$tk=o;function i(x){return!!(x.capabilities&8)}e.$uk=i;function r(x){return!!(x.capabilities&131072)}e.$vk=r;function n(x){return!!(x.capabilities&4)}e.$wk=n;function c(x){return!!(x.capabilities&16)}e.$xk=c;function t(x){return o(x)?!!(x.capabilities&16384):!1}e.$yk=t;function u(x){return o(x)?!!(x.capabilities&32768):!1}e.$zk=u;function s(x){return!!(x.capabilities&65536)}e.$Ak=s;function h(x){return!!(x.capabilities&2048)}e.$Bk=h;var a;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class d extends Error{static create(be,ce){const K=new d(be.toString(),ce);return p(K,ce),K}constructor(be,ce){super(be),this.code=ce}}e.$Ck=d;function k(x,be){return d.create(x,be)}e.$Dk=k;function A(x){return x||k((0,b.localize)(0,null),a.Unknown)}e.$Ek=A;function p(x,be){return x.name=be?`${be} (FileSystemError)`:"FileSystemError",x}e.$Fk=p;function w(x){if(!x)return a.Unknown;if(x instanceof d)return x.code;const be=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!be)return a.Unknown;switch(be[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Gk=w;function E(x){if(x instanceof M)return x.fileOperationResult;switch(w(x)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Hk=E;var P;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class F{constructor(be,ce,K){this.resource=be,this.operation=ce,this.target=K}isOperation(be){return this.operation===be}}e.$Ik=F;var z;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class N{static{this.a=null}constructor(be,ce){this.c=ce,this.b=void 0,this.d=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawAdded.map(V=>[V,!0])),K}),this.f=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(V=>[V,!0])),K}),this.g=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(V=>[V,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of be){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==N.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(be,...ce){return this.h(be,{includeChildren:!1},...ce)}affects(be,...ce){return this.h(be,{includeChildren:!0},...ce)}h(be,ce,...K){if(!be)return!1;const V=K.length>0;return!!((!V||K.includes(1))&&(this.d.value.get(be)||ce.includeChildren&&this.d.value.findSuperstr(be))||(!V||K.includes(0))&&(this.f.value.get(be)||ce.includeChildren&&this.f.value.findSuperstr(be))||(!V||K.includes(2))&&(this.g.value.findSubstr(be)||ce.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=N;function j(x,be,ce){return!x||!be||x===be||be.length>x.length?!1:(be.charAt(be.length-1)!==T.sep&&(be+=T.sep),ce?(0,g.$af)(x,be):x.indexOf(be)===0)}e.$Kk=j;class M extends Error{constructor(be,ce,K){super(be),this.fileOperationResult=ce,this.options=K}}e.$Lk=M;class O extends M{constructor(be,ce,K,V){super(be,ce,V),this.fileOperationResult=ce,this.size=K}}e.$Mk=O;class U extends M{constructor(be,ce,K){super(be,2,K),this.stat=ce}}e.$Nk=U;var Y;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var le;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Vk="";function Z(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Wk=Z;async function J(x,be){if(!be.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(ce=>{const K=be.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===x.scheme&&V.added&&(K.dispose(),ce())})})}e.$Xk=J;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(be){return(0,I.$Mf)(be)||(be=0),be<X.KB?(0,b.localize)(1,null,be.toFixed(0)):be<X.MB?(0,b.localize)(2,null,(be/X.KB).toFixed(2)):be<X.GB?(0,b.localize)(3,null,(be/X.MB).toFixed(2)):be<X.TB?(0,b.localize)(4,null,(be/X.GB).toFixed(2)):(0,b.localize)(5,null,(be/X.TB).toFixed(2))}}e.$Yk=X;function ue(x){const be=typeof x=="string"||x?.scheme===L.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===L.Schemas.file?1024*X.MB:be?10*X.MB:y.$o?50*X.MB:1024*X.MB}e.$Zk=ue}),define(ke[242],Se([1,0,22,14,204,32]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function R(L,C,m,v,S,l){let f;try{await b(L,C,m,v,S,l)}catch(o){f=o}finally{f&&S.errorTransformer&&(f=S.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$bq=R;async function b(L,C,m,v,S,l){$(l);const f=await L.open(C,{create:!1});try{$(l);let o=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),c=S&&typeof S.position=="number"?S.position:0,t=0;do i=await L.read(f,c,n.buffer,t,n.byteLength-t),c+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await m.write(v(n)),n=D.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(l)&&y(o,S));if(t>0){let u=t;typeof r=="number"&&(u=Math.min(t,r)),m.write(v(n.slice(0,u)))}}catch(o){throw(0,I.$Ek)(o)}finally{await L.close(f)}}function $(L){if(L.isCancellationRequested)throw(0,T.$6)();return!0}function y(L,C){if(typeof C?.limits?.size=="number"&&L>C.limits.size)throw(0,I.$Dk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,34,3,17,10,2,32]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function $(o){return o.recursive===!0}e.$dq=$;class y extends T.$Tc{static{this.a=5}constructor(i,r,n,c){super(),this.h=i,this.j=r,this.m=n,this.n=c,this.c=this.B(new T.$Uc),this.f=void 0,this.g=0}s(){const i=new T.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=y;class L extends y{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$fq=L;class C extends y{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$gq=C;function m(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$hq=m;function v(o){const i=new f;for(const r of o)i.processEvent(r);return i.coalesce()}e.$iq=v;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$Ij)&&!(0,g.$ic)(i)?{base:o,pattern:i}:i}e.$jq=S;function l(o,i){const r=[];for(const n of i)r.push((0,D.$Mj)(S(o,n)));return r}e.$kq=l;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const c=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):c===2&&t===1?r.type=0:c===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,c)=>n.resource.fsPath.length-c.resource.fsPath.length).filter(n=>r.some(c=>(0,b.$Kk)(n.resource.fsPath,c,!I.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,56,11,21,33,3,76,17,10,23,2,104,31,85]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class l extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,c){super(),this.m=i,this.n=r,this.r=n,this.s=c,this.c=this.B(new T.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$hh(t=>this.z(t),l.b)),this.g=(0,S.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$kq)(this.m.path,this.m.includes):void 0,this.j=new g.$6d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await v.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await v.Promises.realpath(i.path),i.path===r&&(r=await(0,m.$uq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(y.$j&&(0,I.$8f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const n=new g.$6d(this.j.token),c=new R.$Sc;try{const t=C.URI.file(this.m.path),u=(0,$.$nc)(i),s=(0,D.watch)(i);c.add((0,R.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const h=new Set;if(r)try{for(const d of await v.Promises.readdir(i))h.add(d)}catch(d){this.D(d)}const a=new Map;c.add((0,R.$Rc)(()=>{for(const[,d]of a)d.dispose();a.clear()})),s.on("error",(d,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${k})`),this.dispose()}),s.on("change",(d,k)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${k}`);let A="";if(k&&(A=k.toString(),y.$j&&(A=(0,b.$Gl)(A))),!(!A||d!=="change"&&d!=="rename"))if(r)if(d==="rename"){a.get(A)?.dispose();const p=setTimeout(async()=>{if(a.delete(A),A===u&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.C((0,$.$jc)(i,A));if(n.token.isCancellationRequested)return;let E;w?h.has(A)?E=0:(E=1,h.add(A)):(h.delete(A),E=2),this.y({resource:(0,L.$Hg)(t,A),type:E,cId:this.m.correlationId})},l.a);a.set(A,(0,R.$Rc)(()=>clearTimeout(p)))}else{let p;h.has(A)?p=0:(p=1,h.add(A)),this.y({resource:(0,L.$Hg)(t,A),type:p,cId:this.m.correlationId})}else if(d==="rename"||A!==u){const p=setTimeout(async()=>{const w=await v.Promises.exists(i);n.token.isCancellationRequested||(w?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},l.a);c.clear(),c.add((0,R.$Rc)(()=>clearTimeout(p)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{n.dispose(!0),c.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$iq)(i);if(r.length>0){if(this.s)for(const c of r)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await v.Promises.readdir((0,$.$mc)(i))).some(c=>c===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=l;async function f(o,i,r,n,c=512){const t=await v.Promises.open(o,"r"),u=Buffer.allocUnsafe(c),s=new g.$6d(n);let h,a=!1;const d={path:o,excludes:[],recursive:!1},k=new l(d,A=>{(async()=>{for(const{type:p}of A)if(p===0){if(a)return;a=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:w}=await v.Promises.read(t,u,0,c,null);if(!w||s.token.isCancellationRequested)break;i(u.slice(0,w))}}catch(w){h=new Error(w),s.dispose(!0)}finally{a=!1}}})()});return await k.ready,r(),new Promise((A,p)=>{s.token.onCancellationRequested(async()=>{k.dispose();try{await v.Promises.close(t)}catch(w){h=new Error(w)}h?p(h):A()})})}e.$yq=f}),define(ke[244],Se([1,0,4,34,3,10,243]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class b extends g.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const L=this.j(y),C=L.filter(v=>{const S=this.c.get(v.path);return S?!(0,T.$Qj)(S.request.excludes,v.excludes)||!(0,T.$Qj)(S.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!L.find(S=>S.path===v.path&&(0,T.$Qj)(S.excludes,v.excludes)&&(0,T.$Qj)(S.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const L=new R.$xq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:L};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const L=this.c.get(y);L&&(this.c.delete(y),L.instance.dispose())}j(y){const L=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let v=L.get(C.correlationId);v||(v=new Map,L.set(C.correlationId,v)),v.set(m,C)}return Array.from(L.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,L]of this.c)L.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,L){return L?`[File Watcher (node.js)] ${y} (path: ${L.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$zq=b}),define(ke[245],Se([1,0,85,244]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class g extends D.$fq{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new T.$zq)}}e.$Aq=g}),define(ke[246],Se([1,0,16,81,187,85]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class R extends I.$gq{constructor($,y,L){super($,y,L),this.s()}r($){const y=$.add(new g.$rq(D.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:L,signal:C})=>this.t(`terminated by itself with code ${L}, signal: ${C}`))),T.ProxyChannel.toService((0,T.$Mh)(y.getChannel("watcher")))}}e.$sq=R}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class D{constructor(...g){this.a=new Map;for(const[I,R]of g)this.set(I,R)}set(g,I){const R=this.a.get(g);return this.a.set(g,I),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$4h=D}),define(ke[247],Se([1,0,11,14,3,106,238,5,107,75]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const L=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$4h,o=!1,i,r=L){this.f=f,this.g=o,this.h=i,this.i=r,this.o=new Set,this.f.set(b.$5h,this),this._globalGraph=r?i?._globalGraph??new R.$Dq(n=>n):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...o){const i=S.traceInvocation(this.i,f);let r=!1;try{return f({get:c=>{if(r)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(f,...o){let i,r;return f instanceof I.$3h?(i=S.traceCreation(this.i,f.ctor),r=this.j(f.ctor,f.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,f),r=this.j(f,o,i)),i.stop(),r}j(f,o=[],i){const r=b._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),n=[];for(const t of r){const u=this.m(t.id,i);u||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(u)}const c=r.length>0?r[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(f,o.concat(n))}k(f,o){if(this.f.get(f)instanceof I.$3h)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$3h?this.q(f,i,o.branch(f,!0)):(o.branch(f,!1),i)}q(f,o,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,i)}finally{this.o.delete(f)}}r(f,o,i){const r=new R.$Dq(t=>t.id.toString());let n=0;const c=[{id:f,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new C(r);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const s=this.l(u.id);if(s||this.u(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),s instanceof I.$3h){const h={id:u.id,desc:s,_trace:t._trace.branch(u.id,!0)};r.insertEdge(t,h),c.push(h)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:u}of t){if(this.l(u.id)instanceof I.$3h){const h=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,h)}r.removeNode(u)}}return this.l(f)}s(f,o,i=[],r,n){if(this.f.get(f)instanceof I.$3h)return this.t(f,o,i,r,n);if(this.h)return this.h.s(f,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,i=[],r,n){if(r){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,u=new D.$mh(()=>{const s=c.j(o,i,n);for(const[h,a]of t){const d=s[h];if(typeof d=="function")for(const k of a)k.disposable=d.apply(s,k.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,h){if(!u.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let k=t.get(h);return k||(k=new y.$4c,t.set(h,k)),(p,w,E)=>{if(u.isInitialized)return u.value[h](p,w,E);{const P={listener:[p,w,E],disposable:void 0},F=k.push(P);return(0,g.$Rc)(()=>{F(),P.disposable?.dispose()})}}}if(h in s)return s[h];const a=u.value;let d=a[h];return typeof d!="function"||(d=d.bind(a),s[h]=d),d},set(s,h,a){return u.value[h]=a,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,i,n)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$Eq=m;var v;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(f,o){return f?new S(1,o.name):S.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const i=new S(3,f.toString());return this.h.push([f,o,i]),i}stop(){const f=Date.now()-this.g;S.f+=f;let o=!1;function i(n,c){const t=[],u=new Array(n+1).join("	");for(const[s,h,a]of c.h)if(h&&a){o=!0,t.push(`${u}CREATES -> ${s}`);const d=i(n+1,a);d&&t.push(d)}else t.push(`${u}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(f>2||o)&&S.all.add(r.join(`
`))}}e.$Fq=S}),define(ke[13],Se([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,m.$6h)("logService"),e.$oj=(0,m.$6h)("loggerService");function v(){return new Date().toISOString()}function S(p){return(0,y.$Mf)(p)}e.$pj=S;var l;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$qj=l.Info;function f(p,w,E){switch(w){case l.Trace:p.trace(E);break;case l.Debug:p.debug(E);break;case l.Info:p.info(E);break;case l.Warning:p.warn(E);break;case l.Error:p.error(E);break;case l.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=f;function o(p,w=!1){let E="";for(let P=0;P<p.length;P++){let F=p[P];if(F instanceof Error&&(F=(0,D.$Qi)(F,w)),typeof F=="object")try{F=JSON.stringify(F)}catch{}E+=(P>0?" ":"")+F}return E}class i extends I.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new T.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==l.Off&&this.b<=w}}e.$sj=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...E){this.f(l.Trace)&&this.g(l.Trace,o([w,...E],!0))}debug(w,...E){this.f(l.Debug)&&this.g(l.Debug,o([w,...E]))}info(w,...E){this.f(l.Info)&&this.g(l.Info,o([w,...E]))}warn(w,...E){this.f(l.Warning)&&this.g(l.Warning,o([w,...E]))}error(w,...E){if(this.f(l.Error))if(w instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=w.stack,this.g(l.Error,o(P))}else this.g(l.Error,o([w,...E]))}flush(){}}e.$tj=r;class n extends i{constructor(w=e.$qj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...E){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}debug(w,...E){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}info(w,...E){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}warn(w,...E){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...E):console.warn(`[main ${v()}]`,w,...E))}error(w,...E){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...E):console.error(`[main ${v()}]`,w,...E))}flush(){}}e.$uj=n;class c extends i{constructor(w=e.$qj,E=!0){super(),this.g=E,this.setLevel(w)}trace(w,...E){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...E):console.log(w,...E))}debug(w,...E){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...E):console.log(w,...E))}info(w,...E){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...E):console.log(w,...E))}warn(w,...E){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...E):console.log(w,...E))}error(w,...E){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...E):console.error(w,...E))}flush(){}}e.$vj=c;class t extends i{constructor(w,E=e.$qj){super(),this.g=w,this.setLevel(E)}trace(w,...E){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(w),...E])}debug(w,...E){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(w),...E])}info(w,...E){this.f(l.Info)&&this.g.log(l.Info,[this.h(w),...E])}warn(w,...E){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(w),...E])}error(w,...E){this.f(l.Error)&&this.g.log(l.Error,[this.h(w),...E])}h(w){return typeof w=="string"?w:(0,D.$Qi)(w,this.f(l.Trace))}flush(){}}e.$wj=t;class u extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const E of this.g)E.setLevel(w);super.setLevel(w)}trace(w,...E){for(const P of this.g)P.trace(w,...E)}debug(w,...E){for(const P of this.g)P.debug(w,...E)}info(w,...E){for(const P of this.g)P.info(w,...E)}warn(w,...E){for(const P of this.g)P.warn(w,...E)}error(w,...E){for(const P of this.g)P.error(w,...E)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$xj=u;class s extends I.$Tc{constructor(w,E,P){if(super(),this.h=w,this.j=E,this.b=new R.$Ac,this.c=this.B(new T.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Vd),this.onDidChangeVisibility=this.g.event,P)for(const F of P)this.b.set(F.resource,{logger:void 0,info:F})}m(w){return(0,y.$If)(w)?[...this.b.values()].find(E=>E.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,E){const P=this.n(w),F=(0,y.$If)(w)?w:E?.id??(0,g.$Ti)(P.toString()).toString(16);let z=this.b.get(P)?.logger;const N=E?.logLevel==="always"?l.Trace:E?.logLevel;z||(z=this.s(P,N??this.getLogLevel(P)??this.h,{...E,id:F}));const j={logger:z,info:{resource:P,id:F,logLevel:N,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(P,j),z}n(w){return(0,y.$If)(w)?(0,$.$Hg)(this.j,`${w}.log`):w}setLogLevel(w,E){if(L.URI.isUri(w)){const P=w,F=E,z=this.b.get(P);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([P,F]))}else{this.h=w;for(const[P,F]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,E){const P=this.m(w);P&&E!==!P.info.hidden&&(P.info.hidden=!E,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,E]))}getLogLevel(w){let E;return w&&(E=this.b.get(w)?.info.logLevel),E??this.h}registerLogger(w){const E=this.b.get(w.resource);E?E.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const E=this.b.get(w);E&&(E.logger&&E.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=s;class h{constructor(){this.onDidChangeLogLevel=new T.$Vd().event}setLevel(w){}getLevel(){return l.Info}trace(w,...E){}debug(w,...E){}info(w,...E){}warn(w,...E){}error(w,...E){}critical(w,...E){}dispose(){}flush(){}}e.$zj=h;class a extends h{}e.$Aj=a;function d(p){if(p.verbose)return l.Trace;if(typeof p.logLevel=="string"){const w=A(p.logLevel.toLowerCase());if(w!==void 0)return w}return e.$qj}e.$Bj=d;function k(p){switch(p){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$Cj=k;function A(p){switch(p){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$Dj=A,e.$Ej=new C.$kj("logLevel",k(l.Info))}),define(ke[248],Se([1,0,19,11,14,4,3,17,85,13]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class L extends R.$Tc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new I.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$4g(0)),this.w=[],this.y=this.B(new T.$4g(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},l=(0,D.$Ub)(this.j,S);return this.r(),(0,R.$Rc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$hq)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$dq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$dq)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},l=(0,D.$Ub)(this.w,S);return this.C(),(0,R.$Rc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$hq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$lq=L}),define(ke[249],Se([1,0,56,387,11,28,22,4,33,3,17,10,23,99,31,205,32,242,248,44,246,245]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(u){console.error(`Error enabling graceful-fs: ${(0,r.$Qi)(u)}`)}})();class t extends i.$lq{static{this.I=!1}constructor(s,h){super(s,h),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(a=>m.$yg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:h,symbolicLink:a}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(h,a),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:f.FilePermission.Locked}}catch(h){throw this.fb(h)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const h=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),a=[];return await Promise.all(h.map(async d=>{try{let k;d.isSymbolicLink()?k=(await this.stat((0,m.$Hg)(s,d.name))).type:k=this.M(d),a.push([d.name,k])}catch(k){this.a.trace(k)}})),a}catch(h){throw this.fb(h)}}M(s,h){let a;return h?.dangling?a=f.FileType.Unknown:s.isFile()?a=f.FileType.File:s.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,h&&(a|=f.FileType.SymbolicLink),a}async O(s){const h=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let a;for(;a=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await a.wait();const d=new g.$5g;return this.N.set(s,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,y.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.N.get(s)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),d.open()})}async readFile(s,h){let a;try{h?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),a=await this.O(s));const d=this.H(s);return await S.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{a?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,h,a){const d=(0,v.$0d)(k=>R.$je.concat(k.map(A=>R.$je.wrap(A))).buffer);return(0,o.$bq)(this,s,d,k=>k.buffer,{...h,bufferSize:256*1024},a),d}async writeFile(s,h,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,m.$Hg)((0,m.$Gg)(s),`${(0,m.$Eg)(s)}${a.atomic.postfix}`),h,a):this.S(s,h,a)}async Q(s){try{const h=this.H(s),{symbolicLink:a}=await S.SymlinkSupport.stat(h);if(a)return!1}catch{}return!0}async R(s,h,a,d){const k=new y.$Sc;try{k.add(await this.O(s)),k.add(await this.O(h)),await this.S(h,a,d,!0);try{await this.rename(h,s,{overwrite:!0})}catch(A){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{k.dispose()}}async S(s,h,a,d){let k;try{const A=this.H(s);if(!a.create||!a.overwrite){if(await S.Promises.exists(A)){if(!a.overwrite)throw(0,f.$Dk)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.$Dk)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(s,{create:!0,unlock:a.unlock},d),await this.write(k,0,h,0,h.byteLength)}catch(A){throw await this.gb(s,A)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,h,a){const d=this.H(s);let k;(0,f.$rk)(h)&&!a&&(k=await this.O(s));let A;try{if((0,f.$rk)(h)&&h.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(d);w.mode&128||await S.Promises.chmod(d,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let p;if((0,f.$rk)(h)){if(C.$i)try{await S.Promises.truncate(d,0),p="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}p||(p="w")}else p="r";A=await S.Promises.open(d,p)}catch(p){throw k?.dispose(),(0,f.$rk)(h)?await this.gb(s,p):this.fb(p)}if(this.U.set(A,0),(0,f.$rk)(h)&&this.X.set(A,s),k){const p=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${d})`),this.W.set(A,k),p&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${d})`),p.dispose())}return A}async close(s){const h=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await S.Promises.close(s)}catch(a){throw this.fb(a)}finally{h&&(this.W.get(s)===h&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),h.dispose())}}async read(s,h,a,d,k){const A=this.Z(s,h);let p=null;try{p=(await S.Promises.read(s,a,d,k,A)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(s,A,p)}return p}Z(s,h){return h===this.U.get(s)?null:h}$(s,h,a){const d=this.U.get(s);typeof d=="number"&&(typeof h=="number"||(typeof a=="number"?this.U.set(s,d+a):this.U.delete(s)))}async write(s,h,a,d,k){return(0,g.$nh)(()=>this.ab(s,h,a,d,k),100,3)}async ab(s,h,a,d,k){const A=this.Z(s,h);let p=null;try{p=(await S.Promises.write(s,a,d,k,A)).bytesWritten}catch(w){throw await this.gb(this.X.get(s),w)}finally{this.$(s,A,p)}return p}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(h){throw this.fb(h)}}async delete(s,h){try{const a=this.H(s);if(h.recursive){let d;h?.atomic!==!1&&h.atomic.postfix&&(d=(0,L.$jc)((0,L.$mc)(a),`${(0,L.$nc)(a)}${h.atomic.postfix}`)),await S.Promises.rm(a,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(a)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let k=!1;try{const{stat:A,symbolicLink:p}=await S.SymlinkSupport.stat(a);k=A.isDirectory()&&!p}catch{}if(k)await S.Promises.rmdir(a);else throw d}else throw d}}catch(a){throw this.fb(a)}}async rename(s,h,a){const d=this.H(s),k=this.H(h);if(d!==k)try{await this.bb(s,h,"move",a.overwrite),await S.Promises.rename(d,k)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(2,null,(0,L.$nc)(d),(0,L.$nc)((0,L.$mc)(k)),A.toString()))),this.fb(A)}}async copy(s,h,a){const d=this.H(s),k=this.H(h);if(d!==k)try{await this.bb(s,h,"copy",a.overwrite),await S.Promises.copy(d,k,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(3,null,(0,L.$nc)(d),(0,L.$nc)((0,L.$mc)(k)),A.toString()))),this.fb(A)}}async bb(s,h,a,d){const k=this.H(s),A=this.H(h);let p=!1;if(!!(this.capabilities&1024)||(p=(0,$.$7f)(k,A,!0)),p){if(a==="copy")throw(0,f.$Dk)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const E=await this.L(s);if(!E)throw(0,f.$Dk)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(h);if(P){if(!d)throw(0,f.$Dk)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,h){return this.cb(s,h,!1)}async cb(s,h,a){const d=this.H(s),k=this.H(h),A=!!(this.capabilities&1024);if((0,$.$7f)(d,k,!A))return;const p=new y.$Sc;try{p.add(await this.O(s)),p.add(await this.O(h)),a&&await S.Promises.mkdir((0,L.$mc)(k),{recursive:!0}),await S.Promises.copyFile(d,k)}catch(w){if(w.code==="ENOENT"&&!a)return this.cb(s,h,!0);throw this.fb(w)}finally{p.dispose()}}t(s,h,a){return new n.$sq(d=>s(d),d=>h(d),a)}F(s,h,a){return new c.$Aq(d=>s(d),d=>h(d),a)}fb(s){if(s instanceof f.$Ck)return s;let h=s,a;switch(s.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=f.FileSystemProviderErrorCode.Unknown;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.$Dk)(h,a)}async gb(s,h){let a=this.fb(h);if(s&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.H(s));d.mode&128||(a=(0,f.$Dk)(h,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return a}}e.$Bq=t}),define(ke[250],Se([1,0,3,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;class g extends D.$Tc{constructor(R,b=[]){super(),this.a=new T.$xj([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$yO=g}),define(ke[251],Se([1,0,32,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,L,C,m,v){try{const S=await new Promise((f,o)=>{me(["@vscode/spdlog"],f,o)});S.setFlushOn(g.Trace);const l=await S.createAsyncRotatingLogger(y,L,C,m);return v?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(S){console.error(S)}return null}function R(y,L,C){switch(L){case T.LogLevel.Trace:y.trace(C);break;case T.LogLevel.Debug:y.debug(C);break;case T.LogLevel.Info:y.info(C);break;case T.LogLevel.Warning:y.warn(C);break;case T.LogLevel.Error:y.error(C);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function b(y,L){switch(L){case T.LogLevel.Trace:y.setLevel(g.Trace);break;case T.LogLevel.Debug:y.setLevel(g.Debug);break;case T.LogLevel.Info:y.setLevel(g.Info);break;case T.LogLevel.Warning:y.setLevel(g.Warning);break;case T.LogLevel.Error:y.setLevel(g.Error);break;case T.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class $ extends T.$tj{constructor(L,C,m,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(L,C,m,v),this.B(this.onDidChangeLogLevel(l=>{this.r&&b(this.r,l)}))}async s(L,C,m,v){const S=m?6:1,l=30/S*D.$Yk.MB,f=await I(L,C,l,S,v);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(L,C){this.r?R(this.r,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nO=$}),define(ke[135],Se([1,0,39,206,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(S,l){return l-S}$.compare=y;const L=Object.create(null);L[$.Error]=(0,T.localize)(0,null),L[$.Warning]=(0,T.localize)(1,null),L[$.Info]=(0,T.localize)(2,null);function C(S){return L[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(R||(e.MarkerSeverity=R={}));var b;(function($){const y="";function L(m){return C(m,!0)}$.makeKey=L;function C(m,v){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(R.toString(m.severity)):S.push(y),m.message&&v?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$At=(0,g.$6h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=T.default,e.$pv=(0,g.$6h)("notificationService");var I;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}e.$qv=b;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new L,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$rv=y;class L{infinite(){}done(){}total(m){}worked(m){}}e.$sv=L}),define(ke[253],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:I.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[136],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,D.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(me,e){return function(D,T){e(D,T,me)}};define(ke[86],Se([1,0,11,21,3,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,I.$6h)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$vv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$wv=$;let y=class extends g.$Tc{constructor(m,v){super(),this.a=new D.$qh,v.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Rc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$xv=y,e.$xv=y=Ge([Ve(1,e.$tv)],y);class L extends g.$Tc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Sc)}start(m){this.stop();const v=++this.a,S=new T.$6d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Rc)(()=>S.cancel())),this.b.add((0,g.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$yv=L,e.$zv=(0,I.$6h)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class g{constructor(){this.a=new Map}add(R,b){D.ok(T.$If(R)),D.ok(T.$Kf(b)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Hn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;T.$Hn.add(e.$In.JSONContribution,R)}),define(ke[87],Se([1,0,19,4,18,196,51,108,37]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Mn={Configuration:"base.contributions.configuration"};var L;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const C=$.$Hn.as(b.$In.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$Vd,this.onDidSchemaChange=this.i.event,this.j=new T.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const s=new Set;this.n(t,u,s),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const u=new Set;this.o(t,u),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const s=new Set;this.o(u,s),this.n(t,!1,s),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const s=[];for(const{overrides:h,source:a}of t)for(const d in h)if(u.add(d),e.$Wn.test(d)){const k=this.a.get(d),A=k?.valuesSources??new Map;if(a)for(const P of Object.keys(h[d]))A.set(P,a);const p={...k?.value||{},...h[d]};this.a.set(d,{source:a,value:p,valuesSources:A});const w=(0,R.$Ji)(d),E={type:"object",default:p,description:I.localize(1,null,w),$ref:e.$Tn,defaultDefaultValue:p,source:g.$If(a)?void 0:a,defaultValueSource:a};s.push(...l(d)),this.d[d]=E,this.b.properties[d]=E}else{this.a.set(d,{value:h[d],source:a});const k=this.d[d];k&&(this.w(d,k),this.r(d,k))}this.m(s)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:s,source:h}of t)for(const a in s){const d=this.a.get(a),k=g.$If(h)?h:h?.id,A=g.$If(d?.source)?d?.source:d?.source?.id;if(k===A)if(u.add(a),this.a.delete(a),e.$Wn.test(a))delete this.d[a],delete this.b.properties[a];else{const p=this.d[a];p&&(this.w(a,p),this.r(a,p))}}this.u()}deltaConfiguration(t){let u=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,s){t.forEach(h=>{this.p(h,u,h.extensionInfo,h.restrictedProperties,void 0,s),this.c.push(h),this.q(h)})}o(t,u){const s=h=>{if(h.properties)for(const a in h.properties){u.add(a);const d=this.d[a];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[a],this.s(a,h.properties[a])}h.allOf?.forEach(a=>s(a))};for(const h of t){s(h);const a=this.c.indexOf(h);a!==-1&&this.c.splice(a,1)}}p(t,u=!0,s,h,a=3,d){a=g.$Rf(t.scope)?a:t.scope;const k=t.properties;if(k)for(const p in k){const w=k[p];if(u&&r(p,w)){delete k[p];continue}if(w.source=s,w.defaultDefaultValue=k[p].default,this.w(p,w),e.$Wn.test(p)?w.scope=void 0:(w.scope=g.$Rf(w.scope)?a:w.scope,w.restricted=g.$Rf(w.restricted)?!!h?.includes(p):w.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.f[p]=k[p],delete k[p];continue}else this.d[p]=k[p],k[p].policy?.name&&this.e.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),d.add(p)}const A=t.allOf;if(A)for(const p of A)this.p(p,u,s,h,a,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=s=>{const h=s.properties;if(h)for(const d in h)this.r(d,h[d]);s.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Nn.properties[t]=u,u.scope){case 1:e.$On.properties[t]=u;break;case 2:e.$Pn.properties[t]=u;break;case 6:e.$Qn.properties[t]=u;break;case 3:e.$Rn.properties[t]=u;break;case 4:e.$Sn.properties[t]=u;break;case 5:e.$Sn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Nn.properties[t],u.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Tn};this.w(u,s),e.$Nn.properties[u]=s,e.$On.properties[u]=s,e.$Pn.properties[u]=s,e.$Qn.properties[u]=s,e.$Rn.properties[u]=s,e.$Sn.properties[u]=s}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,u){const s=this.a.get(t);let h=s?.value,a=s?.source;g.$Pf(h)&&(h=u.defaultDefaultValue,a=void 0),g.$Pf(h)&&(h=o(u.type)),u.default=h,u.defaultValueSource=a}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$Vn=`^(${v})+$`,e.$Wn=new RegExp(e.$Vn);function l(c){const t=[];if(e.$Wn.test(c)){let u=S.exec(c);for(;u?.length;){const s=u[1].trim();s&&t.push(s),u=S.exec(c)}}return(0,D.$Mb)(t)}e.$Xn=l;function f(c){return c.reduce((t,u)=>`${t}[${u}]`,"")}e.$Yn=f;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=o;const i=new m;$.$Hn.add(e.$Mn.Configuration,i);function r(c,t){return c.trim()?e.$Wn.test(c)?I.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$1n=r;function n(){const c=[],t=i.getConfigurationProperties();for(const u of Object.keys(t))c.push([u,t[u].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$2n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,87,37]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function v(u){return Object.isFrozen(u)?u:b.$wn(u)}class S{constructor(s={},h=[],a=[],d){this.b=s,this.c=h,this.d=a,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(h=>{if(h instanceof S)return h;const a=new l("");return a.parseRaw(h),a.configurationModel});this.f=s.reduce((h,a)=>a===h?a:h.merge(a),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.$Hi)(this.contents,s):this.contents}inspect(s,h){const a=this.rawConfiguration.getValue(s),d=h?this.rawConfiguration.getOverrideValue(s,h):void 0,k=h?this.rawConfiguration.override(h).getValue(s):a;return{value:a,override:d,merged:k}}getOverrideValue(s,h){const a=this.i(h);return a?s?(0,L.$Hi)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const h=[];for(const a of this.overrides)a.identifiers.includes(s)&&h.push(...a.keys);return D.$Mb(h)}getAllOverrideIdentifiers(){const s=[];for(const h of this.overrides)s.push(...h.identifiers);return D.$Mb(s)}override(s){let h=this.a.get(s);return h||(h=this.g(s),this.a.set(s,h)),h}merge(...s){const h=b.$vn(this.contents),a=b.$vn(this.overrides),d=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const A of s)if(k.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(h,A.contents);for(const p of A.overrides){const[w]=a.filter(E=>D.$ub(E.identifiers,p.identifiers));w?(this.h(w.contents,p.contents),w.keys.push(...p.keys),w.keys=D.$Mb(w.keys)):a.push(b.$vn(p))}for(const p of A.keys)d.indexOf(p)===-1&&d.push(p)}return new S(h,d,a,k.every(A=>A instanceof S)?void 0:k)}g(s){const h=this.i(s);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const a={};for(const d of D.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let k=this.contents[d];const A=h[d];A&&(typeof k=="object"&&typeof A=="object"?(k=b.$vn(k),this.h(k,A)):k=A),a[d]=k}return new S(a,this.keys,this.overrides)}h(s,h){for(const a of Object.keys(h)){if(a in s&&$.$Kf(s[a])&&$.$Kf(h[a])){this.h(s[a],h[a]);continue}s[a]=b.$vn(h[a])}}i(s){let h=null,a=null;const d=k=>{k&&(a?this.h(a,k):a=b.$vn(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?h=k.contents:k.identifiers.includes(s)&&d(k.contents);return d(h),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,h){this.j(s,h,!0)}setValue(s,h){this.j(s,h,!1)}removeValue(s){const h=this.keys.indexOf(s);h!==-1&&(this.keys.splice(h,1),(0,L.$Gi)(this.contents,s),C.$Wn.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,C.$Xn)(s))),1))}j(s,h,a){(0,L.$Fi)(this.contents,s,h,d=>console.error(d)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),C.$Wn.test(s)&&this.overrides.push({identifiers:(0,C.$Xn)(s),keys:Object.keys(this.contents[s]),contents:(0,L.$Ei)(this.contents[s],d=>console.error(d))})}}e.$3n=S;class l{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,h){if(!$.$Rf(s)){const a=this.g(s);this.parseRaw(a,h)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,h){this.a=s;const{contents:a,keys:d,overrides:k,restricted:A,hasExcludedProperties:p}=this.h(s,h);this.b=new S(a,d,k,p?[s]:void 0),this.c=A||[]}g(s){let h={},a=null,d=[];const k=[],A=[];function p(E){Array.isArray(d)?d.push(E):a!==null&&(d[a]=E)}const w={onObjectBegin:()=>{const E={};p(E),k.push(d),d=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{d=k.pop()},onArrayBegin:()=>{const E=[];p(E),k.push(d),d=E,a=null},onArrayEnd:()=>{d=k.pop()},onLiteralValue:p,onError:(E,P,F)=>{A.push({error:E,offset:P,length:F})}};if(s)try{g.$jn(s,w),h=d[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return h}h(s,h){const a=m.$Hn.as(C.$Mn.Configuration).getConfigurationProperties(),d=this.i(s,a,!0,h);s=d.raw;const k=(0,L.$Ei)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),A=Object.keys(s),p=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:A,overrides:p,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(s,h,a,d){let k=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const A={},p=[];for(const w in s)if(C.$Wn.test(w)&&a){const E=this.i(s[w],h,!1,d);A[w]=E.raw,k=k||E.hasExcludedProperties,p.push(...E.restricted)}else{const E=h[w],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&p.push(w),!d.exclude?.includes(w)&&(d.include?.includes(w)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&E?.restricted))?A[w]=s[w]:k=!0}return{raw:A,restricted:p,hasExcludedProperties:k}}j(s,h){const a=[];for(const d of Object.keys(s))if(C.$Wn.test(d)){const k={};for(const A in s[d])k[A]=s[d][A];a.push({identifiers:(0,C.$Xn)(d),keys:Object.keys(k),contents:(0,L.$Ei)(k,h)})}return a}}e.$4n=l;class f extends I.$Tc{constructor(s,h,a,d){super(),this.c=s,this.f=h,this.g=d,this.b=this.B(new T.$Vd),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&a.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=f;class o{constructor(s,h,a,d,k,A,p,w,E,P,F,z,N){this.a=s,this.b=h,this.c=a,this.overrideIdentifiers=d,this.d=k,this.f=A,this.g=p,this.h=w,this.i=E,this.j=P,this.k=F,this.l=z,this.m=N}get value(){return v(this.c)}n(s,h,a){const d=s.inspect(h,a);return{get value(){return v(d.value)},get override(){return v(d.override)},get merged(){return v(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,h,a,d,k=new S,A=new S,p=new R.$Ac,w=new S,E=new R.$Ac){this.c=s,this.d=h,this.f=a,this.g=d,this.h=k,this.i=A,this.j=p,this.l=w,this.m=E,this.a=null,this.b=new R.$Ac,this.n=null}getValue(s,h,a){return this.p(s,h,a).getValue(s)}updateValue(s,h,a={}){let d;a.resource?(d=this.m.get(a.resource),d||(d=new S,this.m.set(a.resource,d))):d=this.l,h===void 0?d.removeValue(s):d.setValue(s,h),a.resource||(this.a=null)}inspect(s,h,a){const d=this.p(s,h,a),k=this.t(h.resource,a),A=h.resource?this.m.get(h.resource)||this.l:this.l,p=new Set;for(const w of d.overrides)for(const E of w.identifiers)d.getOverrideValue(s,E)!==void 0&&p.add(E);return new o(s,h,d.getValue(s),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,k||void 0,A)}keys(s){const h=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,h){this.j.set(s,h),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,h){const a=[];if(!h){const{added:d,updated:k,removed:A}=c(this.c,s);h=[...d,...k,...A]}for(const d of h)for(const k of(0,C.$Xn)(d)){const A=this.c.getKeysForOverrideIdentifier(k),p=s.getKeysForOverrideIdentifier(k),w=[...p.filter(E=>A.indexOf(E)===-1),...A.filter(E=>p.indexOf(E)===-1),...A.filter(E=>!b.$zn(this.c.override(k).getValue(E),s.override(k).getValue(E)))];a.push([k,w])}return this.updateDefaultConfiguration(s),{keys:h,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:h,updated:a,removed:d}=c(this.d,s),k=[...h,...a,...d];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:h,updated:a,removed:d,overrides:k}=c(this.applicationConfiguration,s),A=[...h,...a,...d];return A.length&&this.updateApplicationConfiguration(s),{keys:A,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:h,updated:a,removed:d,overrides:k}=c(this.localUserConfiguration,s),A=[...h,...a,...d];return A.length&&this.updateLocalUserConfiguration(s),{keys:A,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:h,updated:a,removed:d,overrides:k}=c(this.remoteUserConfiguration,s),A=[...h,...a,...d];return A.length&&this.updateRemoteUserConfiguration(s),{keys:A,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:h,updated:a,removed:d,overrides:k}=c(this.workspaceConfiguration,s),A=[...h,...a,...d];return A.length&&this.updateWorkspaceConfiguration(s),{keys:A,overrides:k}}compareAndUpdateFolderConfiguration(s,h){const a=this.folderConfigurations.get(s),{added:d,updated:k,removed:A,overrides:p}=c(a,h),w=[...d,...k,...A];return(w.length||!a)&&this.updateFolderConfiguration(s,h),{keys:w,overrides:p}}compareAndDeleteFolderConfiguration(s){const h=this.folderConfigurations.get(s);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:d,removed:k,overrides:A}=c(h,void 0);return{keys:[...a,...d,...k],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,h,a){let d=this.q(h,a);return h.overrideIdentifier&&(d=d.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(d=d.merge(this.d)),d}q({resource:s},h){let a=this.r();if(h&&s){const d=h.getFolder(s);d&&(a=this.s(d.uri)||a);const k=this.m.get(s);k&&(a=a.merge(k))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let h=this.b.get(s);if(!h){const a=this.r(),d=this.j.get(s);d?(h=a.merge(d),this.b.set(s,h)):h=a}return h}t(s,h){if(h&&s){const a=h.getFolder(s);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,h)=>{const{contents:a,overrides:d,keys:k}=this.j.get(h);return s.push([h,{contents:a,overrides:d,keys:k}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(h=>s.add(h)),this.userConfiguration.keys.forEach(h=>s.add(h)),this.i.keys.forEach(h=>s.add(h)),this.j.forEach(h=>h.keys.forEach(a=>s.add(a))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}v(s){const h=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>h.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>h.add(a)),this.i.getKeysForOverrideIdentifier(s).forEach(a=>h.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(d=>h.add(d))),[...h.values()]}static parse(s){const h=this.w(s.defaults),a=this.w(s.policy),d=this.w(s.application),k=this.w(s.user),A=this.w(s.workspace),p=s.folders.reduce((w,E)=>(w.set(y.URI.revive(E[0]),this.w(E[1])),w),new R.$Ac);return new i(h,a,d,k,new S,A,p,new S,new R.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$6n=i;function r(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,h=new Map;for(const d of u)d.keys.forEach(k=>s.add(k)),d.overrides.forEach(([k,A])=>{const p=(0,R.$xc)(h,k,new Set);A.forEach(w=>p.add(w))});const a=[];return h.forEach((d,k)=>a.push([k,[...d.values()]])),{keys:[...s.values()],overrides:a}}e.$7n=r;class n{constructor(s,h,a,d){this.change=s,this.f=h,this.g=a,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,h){const a=this.a+s,d=this.d.indexOf(a);if(d<0)return!1;const k=d+a.length;if(k>=this.d.length)return!1;const A=this.d.charCodeAt(k);if(A!==this.b&&A!==this.c)return!1;if(h){const p=this.previousConfiguration?this.previousConfiguration.getValue(s,h,this.f?.workspace):void 0,w=this.g.getValue(s,h,this.h);return!b.$zn(p,w)}return!0}}e.$8n=n;function c(u,s){const{added:h,removed:a,updated:d}=t(s?.rawConfiguration,u?.rawConfiguration),k=[],A=u?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const w=p.filter(E=>!A.includes(E));for(const E of w)k.push([E,s.getKeysForOverrideIdentifier(E)])}if(u){const w=A.filter(E=>!p.includes(E));for(const E of w)k.push([E,u.getKeysForOverrideIdentifier(E)])}if(s&&u){for(const w of A)if(p.includes(w)){const E=t({contents:u.getOverrideValue(void 0,w)||{},keys:u.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});k.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:h,removed:a,updated:d,overrides:k}}function t(u,s){const h=u?s?u.keys.filter(k=>s.keys.indexOf(k)===-1):[...u.keys]:[],a=s?u?s.keys.filter(k=>u.keys.indexOf(k)===-1):[...s.keys]:[],d=[];if(u&&s){for(const k of s.keys)if(u.keys.indexOf(k)!==-1){const A=(0,L.$Hi)(s.contents,k),p=(0,L.$Hi)(u.contents,k);b.$zn(A,p)||d.push(k)}}return{added:h,removed:a,updated:d}}}),define(ke[255],Se([1,0,22,4,3,82]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrb=e.$xrb=e.$wrb=e.$vrb=void 0;const R=(y,L,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const v=(0,D.$De)(D.$je.wrap(m));return[`GET ws://localhost${y}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$vrb=R,e.$wrb=D.$je.fromString(`\r
\r
`);async function b(y,L,C,m,v){y.write(D.$je.fromString((0,e.$vrb)(L,C,m)));const S=new g.$Sc;try{return await new Promise((l,f)=>{let o;S.add(y.onData(i=>{o?o=D.$je.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.$wrb);if(r===-1)return;l(y),y.pauseData();const n=o.slice(r+e.$wrb.byteLength);n.byteLength&&v.onData.fire(n)})),S.add(y.onClose(i=>f(i??new Error("socket closed")))),S.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw y.dispose(),l}finally{S.dispose()}}e.$xrb=b;class $ extends g.$Tc{constructor(L,C){super(),this.g=L,this.a=this.B(new T.$Yd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new T.$Vd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,L,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$yrb=$}),define(ke[64],Se([1,0,14,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,T.$6h)("remoteAuthorityResolverService");var g;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=I;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=R;var b;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$$k=$;function y(L){const C=L.indexOf("+");return C===-1?L:L.substring(0,C)}e.$_k=y}),define(ke[65],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function T(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$al=T;function g(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.$bl=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$cl=I;function R(y){const{host:L,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:C}}e.$dl=R;function b(y,L){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=L),{host:C,port:m}}e.$el=b;function $(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,12,5,65]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function I(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$jm=I,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const i=typeof f=="string"?f:f.value,r=typeof o=="string"?o:o.value;return D.$_e(i,r)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$lm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$mm=y;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,o){this.c.set($.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=L;function C(l){return m(l)}e.$om=C;function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$pm=m;function v(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$qm=v;function S(l,f){if(f){const o=`onResolveRemoteAuthority:${(0,g.$bl)(f)}`;return!!l.activationEvents?.includes(o)}return!1}e.$rm=S,e.$sm=(0,T.$6h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,26]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(b[T.$lm.toKey($.identifier)]=y)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${T.$lm.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const L=R.contributes[$],C=Array.isArray(L)?L:[L];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$gF=g,e.$hF=new g}),define(ke[256],Se([1,0,11,22,21,14,4,3,57,38,30,82,64,65]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const S=30*1e3;var l;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const V=new g.$6d;return setTimeout(()=>V.cancel(),K),V.token}function i(K,V){if(K.isCancellationRequested||V.isCancellationRequested)return g.CancellationToken.Cancelled;const re=new g.$6d;return K.onCancellationRequested(()=>re.cancel()),V.onCancellationRequested(()=>re.cancel()),re.token}class r{get didTimeout(){return this.c==="timedout"}constructor(V){this.c="pending",this.d=new b.$Sc,this.promise=new Promise((re,ye)=>{this.f=re,this.g=ye}),V.isCancellationRequested?this.h():this.d.add(V.onCancellationRequested(()=>this.h()))}registerDisposable(V){this.c==="pending"?this.d.add(V):V.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(V))}reject(V){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(V))}}function n(K,V){const re=new r(V);return re.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=J(de);ge?re.reject(ge):re.resolve(de)})),re.promise}function c(K,V,re,ye,de,ge,_,te){const G=new r(te),ie=y.$Rd.create(!1);return K.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),V.connect(re,ye,de,_).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${_}) was successful after ${ie.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) returned an error after ${ie.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,V){const re=new r(V);return K.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function u(K,V,re,ye){const de=be(K,V);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,v.$cl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(V),`renderer-${f(V)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,te;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),_=K.reconnectionProtocol,te=!1):(_=new C.$Th({socket:ge}),te=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,L.$qg)()),ye),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};_.sendControl(T.$je.fromString(JSON.stringify(ie)));try{const fe=await n(_,i(ye,o(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Pe=await t(K.signService.sign(fe.data),ye),we={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:V};return re&&(we.args=re),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(T.$je.fromString(JSON.stringify(we))),{protocol:_,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(fe)),te&&Z(_),fe}}async function s(K,V,re,ye){const de=Date.now(),ge=be(K,V),{protocol:_,ownsProtocol:te}=await u(K,V,re,ye),G=new r(ye);return G.registerDisposable(_.onControlMessage(ie=>{const fe=JSON.parse(ie.toString()),ve=J(fe);ve?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(ve),te&&Z(_),G.reject(ve)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${ce(de)}!`),G.resolve({protocol:_,firstMessage:fe}))})),G.promise}async function h(K,V){const{protocol:re}=await s(K,1,void 0,V);return{protocol:re}}async function a(K,V,re){const{protocol:ye,firstMessage:de}=await s(K,2,V,re),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function d(K,V,re){const ye=Date.now(),de=be(K,3),{protocol:ge}=await u(K,3,V,re);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${ce(ye)}!`),ge}async function k(K,V,re){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:V,reconnectionProtocol:re,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function A(K,V,re){return w(K,async ye=>{const{protocol:de}=await h(ye,g.CancellationToken.None);return new Y(K,V,re,ye.reconnectionToken,de)})}e.$jl=A;async function p(K,V){return w(K,async re=>{const{protocol:ye,debugPort:de}=await a(re,V,g.CancellationToken.None);return new le(K,V,re.reconnectionToken,ye,de)})}e.$kl=p;async function w(K,V){for(let ye=1;;ye++)try{const de=(0,L.$qg)(),ge=await k(K,de,null);return await V(ge)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),U.triggerPermanentFailure(0,0,m.$$k.isHandled(de)),de}}async function E(K,V,re){const ye=await k(K,(0,L.$qg)(),null);return await d(ye,{host:V,port:re},g.CancellationToken.None)}e.$ll=E;function P(K){return(0,D.$Tg)(V=>new Promise((re,ye)=>{const de=setTimeout(re,K*1e3);V.onCancellationRequested(()=>{clearTimeout(de),re()})}))}var F;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(V,re){this.reconnectionToken=V,this.millisSinceLastIncomingData=re,this.type=0}}e.$ml=z;class N{constructor(V,re,ye,de){this.reconnectionToken=V,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$nl=N;class j{constructor(V,re,ye){this.reconnectionToken=V,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$ol=j;class M{constructor(V,re,ye){this.reconnectionToken=V,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$pl=M;class O{constructor(V,re,ye,de){this.reconnectionToken=V,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=de,this.type=3}}e.$ql=O;class U extends b.$Tc{static triggerPermanentFailure(V,re,ye){this._permanentFailure=!0,this.f=V,this.g=re,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(V=>V.y())}static debugPauseSocketWriting(){this.j.forEach(V=>V.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(V,re,ye,de,ge){super(),this.t=V,this.u=re,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new R.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const te=x(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const te=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Rc)(()=>{const _=U.j.indexOf(this);_>=0&&U.j.splice(_,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const V=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<re.length?re[ye]:re[re.length-1];try{if(de>0){const _=P(de);this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${V} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${V} resolving connection...`);const ge=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${V} connecting to ${ge.connectTo}...`),await this.G(ge,o(S)),this.u.logService.info(`${V} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$$k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$$k){this.u.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$$k.isHandled(ge));break}this.u.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(V,re,ye){this.w?U.triggerPermanentFailure(V,re,ye):this.D(V,re,ye)}D(V,re,ye){this.m.fire(new O(this.reconnectionToken,V,re,ye)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=U;class Y extends U{constructor(V,re,ye,de,ge){super(1,V,de,ge,!0),this.client=this.B(new C.$Rh(ge,{remoteAuthority:re,clientId:ye},V.ipcLogger))}async G(V,re){await h(V,re)}}e.$sl=Y;class le extends U{constructor(V,re,ye,de,ge){super(2,V,ye,de,!1),this.H=re,this.debugPort=ge}async G(V,re){await a(V,this.H,re)}}e.$tl=le;function Z(K){try{K.acceptDisconnect();const V=K.getSocket();K.dispose(),V.dispose()}catch(V){(0,I.$1)(V)}}function J(K){if(K&&K.type==="error"){const V=new Error(`Connection error: ${K.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function X(K,V){for(;K.length<V;)K+=" ";return K}function ue(K,V){return`[remote-connection][${X(f(K),13)}][${V.substr(0,5)}\u2026]`}function x(K,V,re){return`${ue(K,V)}[${re?"reconnect":"initial"}]`}function be(K,V){return`${x(V,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function ce(K){return`${Date.now()-K} ms`}}),define(ke[257],Se([1,0,3,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,T.$6h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,D.$Rc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,y){const L=this.b(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,b,$,y)}}e.$gl=g}),define(ke[258],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const R=String(D.a++);return this.b.set(R,I),{id:R,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(I)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$q7b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,D.$6h)(e.$hl)}),define(ke[138],Se([1,0,258]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=void 0;class T extends D.$q7b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(R=>new R.signer().sign(I))}h(){return new Promise((I,R)=>me(["vsda"],I,R))}}e.$l_b=T}),define(ke[259],Se([1,0,10,49,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,L,C,m,v,S,l,f){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=S,o.sessionID=(0,g.$qg)()+Date.now(),o.commitHash=C,o.version=m,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=T.$dc,o["common.nodeArch"]=L,o["common.product"]=f||"desktop",l&&(o["common.msftInternal"]=l);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const n=I(y);return n&&(o["common.platformDetail"]=n),o}e.$Jo=R;function b($){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const L=y.toLowerCase();return $.some(C=>L===C)}e.$Ko=b}),define(ke[260],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,D.$6h)("telemetryService"),e.$vl=(0,D.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var T;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[88],Se([1,0,24,18,65,259,260]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class b{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$Lo=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=$,e.$No=new $;class y{async publicLog(u,s,h){}async publicLogError(u,s,h){}}e.$Oo=y,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}e.$So=L;function C(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=C;function m(t){const u=t.getValue(R.$Cl),s=t.getValue(R.$Dl);if(t.getValue(R.$El)===!1||s===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=m;function v(t){const u={},s={},h={};f(t,h);for(let a in h){a=a.length>150?a.substr(a.length-149):a;const d=h[a];typeof d=="number"?s[a]=d:typeof d=="boolean"?s[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),u[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(u[a]=d)}return{properties:u,measurements:s}}e.$Vo=v;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const u=(0,g.$bl)(t);return S.has(u)?u:"other"}e.$Wo=l;function f(t,u,s=0,h){if(t)for(const a of Object.getOwnPropertyNames(t)){const d=t[a],k=h?h+a:a;Array.isArray(d)?u[k]=(0,D.$An)(d):d instanceof Date?u[k]=d.toISOString():(0,T.$Kf)(d)?s<2?f(d,u,s+1,k+"."):u[k]=(0,D.$An)(d):u[k]=d}}function o(t,u){const s=t.msftInternalDomains||[],h=u.getValue("telemetry.internalTesting");return(0,I.$Ko)(s)||h}e.$Xo=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=i;function r(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const h=[];for(const A of u)for(;;){const p=A.exec(t);if(!p)break;h.push([p.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(s="";;){const A=d.exec(t);if(!A)break;const p=h.some(([w,E])=>A.index<E&&w<d.lastIndex);!a.test(A[0])&&!p&&(s+=t.substring(k,A.index)+"<REDACTED: user-file-path>",k=d.lastIndex)}return k<t.length&&(s+=t.substr(k)),s}function n(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of u)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function c(t,u){return(0,D.$xn)(t,s=>{if(s instanceof b||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let h=s.replaceAll("%20"," ");h=r(h,u);for(const a of u)h=h.replace(a,"");return h=n(h),h}})}e.$Zo=c}),define(ke[261],Se([1,0,12,134,26,10,2,14,49,88]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function L(s,h){return s.uuid&&h.uuid?s.uuid===h.uuid:s.id===h.id?!0:(0,D.$7e)(s.id,h.id)===0}e.$1o=L;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(h){const a=h.manifest?h.manifest.version:h.version,d=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new m(h.identifier,a,d)}static parse(h){const a=C.exec(h);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(h,a,d="undefined"){this.version=a,this.targetPlatform=d,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof m?L(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$2o=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const h=v.exec(s);return h&&h[1]?[f(h[1]),h[2]]:[f(s),void 0]}e.$3o=S;function l(s,h){return`${s}.${h}`}e.$4o=l;function f(s){return s.toLowerCase()}e.$5o=f;function o(s,h){return f(l(s??g.$hm,h))}e.$6o=o;function i(s,h){const a=[],d=k=>{for(const A of a)if(A.some(p=>L(h(p),h(k))))return A;return null};for(const k of s){const A=d(k);A?A.push(k):a.push([k])}return a}e.$7o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$8o=r;function n(s){return{id:new y.$Lo(s.identifier.id),name:new y.$Lo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$9o=n,e.$0o=new g.$lm("pprice.better-merge");function c(s,h){const a=[],d=h.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const k=d.shift();if(k&&a.every(A=>!L(A.identifier,{id:k}))){const A=s.filter(p=>L(p.identifier,{id:k}));A.length===1&&(a.push(A[0]),d.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$$o=c;async function t(s,h){if(!I.$k)return!1;let a;try{a=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){h.debug("Error while getting the os-release file.",(0,b.$0)(k))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,h){const a=await t(s,h),d=(0,T.$uo)(a?"alpine":I.$u,$.$ec);return h.debug("ComputeTargetPlatform:",d),d}e.$_o=u}),define(ke[262],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function D($){return[...$.entries()]}e.$Mr=D;function T($){return $?[...$.entries()]:[]}e.$Nr=T;function g($){return new Map($)}e.$Or=g;function I($){return new Map($??[])}e.$Pr=I;function R($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),T(y[1].descriptionMap)])}e.$Qr=R;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Rr=b}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,R=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let L=this.a.get(g);if(L){L.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),R);L={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,L)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$Prb=D}),define(ke[264],Se([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var C;(function(n){function c(t,u){let s=t.defaults;for(;g.ThemeIcon.isThemeIcon(s);){const h=S.getIcon(s.id);if(!h)return;s=h.defaults}return s}n.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(n){function c(u){return{weight:u.weight,style:u.style,src:u.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=c;function t(u){const s=h=>(0,R.$If)(h)?h:void 0;if(u&&Array.isArray(u.src)&&u.src.every(h=>(0,R.$If)(h.format)&&(0,R.$If)(h.location)))return{weight:s(u.weight),style:s(u.style),src:u.src.map(h=>({format:h.format,location:b.URI.parse(h.location)}))}}n.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new I.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,u,s){const h=this.b[c];if(h){if(u&&!h.description){h.description=u,this.d.properties[c].markdownDescription=`${u} $(${c})`;const k=this.e.enum.indexOf(c);k!==-1&&(this.e.enumDescriptions[k]=u),this.a.fire()}return h}const a={id:c,description:u,defaults:t,deprecationMessage:s};this.b[c]=a;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),u&&(d.markdownDescription=`${u}: $(${c})`),this.d.properties[c]=d,this.e.enum.push(c),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const u=this.f[c];return u||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(h,a)=>h.id.localeCompare(a.id),t=h=>{for(;g.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(h=>this.b[h]);for(const h of s.filter(a=>!!a.description).sort(c))u.push(`|<i class="${t(h)}"></i>|${h.id}|${g.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const h of s.filter(a=>!g.ThemeIcon.isThemeIcon(a.defaults)).sort(c))u.push(`|<i class="${t(h)}"></i>|${h.id}|`);return u.join(`
`)}}const S=new v;L.$Hn.add(e.$ww.IconContribution,S);function l(n,c,t,u){return S.registerIcon(n,c,t,u)}e.$xw=l;function f(){return S}e.$yw=f;function o(){const n=(0,T.$0j)();for(const c in n){const t="\\"+n[c].toString(16);S.registerIcon(c,{fontCharacter:t})}}o(),e.$zw="vscode://schemas/icons";const i=L.$Hn.as(y.$In.JSONContribution);i.registerSchema(e.$zw,S.getIconSchema());const r=new D.$fh(()=>i.notifySchemaChanged(e.$zw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Aw=l("widget-close",T.$_j.close,(0,$.localize)(2,null)),e.$Bw=l("goto-previous-location",T.$_j.arrowUp,(0,$.localize)(3,null)),e.$Cw=l("goto-next-location",T.$_j.arrowDown,(0,$.localize)(4,null)),e.$Dw=g.ThemeIcon.modify(T.$_j.sync,"spin"),e.$Ew=g.ThemeIcon.modify(T.$_j.loading,"spin")}),define(ke[89],Se([1,0,4,51,5,13]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,g.$6h)("tunnelService"),e.$Bv=(0,g.$6h)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$Cv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function L(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Dv=L,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$Ev.indexOf(f)>=0}e.$Fv=C,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$Gv.indexOf(f)>=0}e.$Hv=m;function v(f,o,i,r){if(i===1)return!1;if(i===2&&m(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return f<1024}e.$Iv=v;class S{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this.b=r,this.a=new D.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=S;let l=class{constructor(o,i){this.k=o,this.l=i,this.a=new D.$Vd,this.onTunnelOpened=this.a.event,this.b=new D.$Vd,this.onTunnelClosed=this.b.event,this.c=new D.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const c of n){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,r,n,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(m(o)||C(o))&&(o=e.$Ev[0]);const r=this.s(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,c,t=!1,u,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${c}.`);const h=this.f??o;if(!h)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(h,i,r,n,c,t,u,s);return a?a.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async p(o,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this.e.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,r){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:r})}async r(o,i){const r=this.e.get(o);if(r){const n=r.get(i),c=n?await n.value:void 0;(!c||typeof c=="string")&&r.delete(i),r.size===0&&this.e.delete(o)}}s(o,i){const r=[o];C(o)?(r.push(...e.$Ev),r.push(...e.$Gv)):m(o)&&r.push(...e.$Gv);const n=r.map(c=>this.e.get(c));for(const c of n){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!L(o)}u(o,i,r,n,c,t,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const h=n===void 0?r:n,a={elevationRequired:c?this.isPortPrivileged(h):!1},d={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==b.Private:void 0,protocol:u},k=o.forwardPort(d,a);return k?(this.q(i,r,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),k}};e.$Kv=l,e.$Kv=l=Ge([Ve(0,I.$nj),Ve(1,T.$zi)],l)}),define(ke[265],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,D.$6h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,D.$6h)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[267],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=void 0;function T($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$GK=T;function g($){if($.folders.length)return $.folders.every(y=>T(y.uri))?$.folders[0].uri:void 0;if($.configuration&&T($.configuration))return $.configuration}e.$HK=g;function I($){return g($)?.scheme}e.$IK=I;function R($){return g($)?.authority}e.$JK=R;function b($){return g($)!==void 0}e.$KK=b}),define(ke[40],Se([1,0,209,17,77,23,2,5,16]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,b.$6h)("contextService");function y(h){const a=h;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.$di=y;function L(h){return typeof h?.id=="string"&&!y(h)&&!m(h)}e.$ei=L,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function C(h,a){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,T.$nc)(h)}:a?e.$fi:e.$gi;const d=h;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$hi=C;function m(h){const a=h;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.$ii=m;function v(h){const a=h;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const d=h;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(h?.id)return{id:h.id}}e.$ji=v;var S;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function l(h){const a=h;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$ki=l;function f(h){const a=h;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$li=f;class o{constructor(a,d,k,A,p){this.h=a,this.j=k,this.k=A,this.l=p,this.c=g.$_h.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=g.$_h.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=o;class i{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,I.$Hg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=i;function r(h){return new i({uri:h,index:0,name:(0,I.$Dg)(h)},{uri:h.toString()})}e.$oi=r,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,D.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function n(h,a){return I.$yg.isEqualOrParent(h,a.untitledWorkspacesHome)}e.$ti=n;function c(h){let a;return R.URI.isUri(h)?a=h:a=h.configuration,a?.scheme===$.Schemas.tmp}e.$ui=c,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.$vi}e.$wi=t;function u(h,a){return!n(h,a)&&!c(h)}e.$xi=u;function s(h){return(typeof h=="string"?(0,T.$oc)(h):(0,I.$Fg)(h))===e.$qi}e.$yi=s}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var r;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(h){const a=h;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&R.URI.isUri(a.location)&&R.URI.isUri(a.globalStorageHome)&&R.URI.isUri(a.settingsResource)&&R.URI.isUri(a.keybindingsResource)&&R.URI.isUri(a.tasksResource)&&R.URI.isUri(a.snippetsHome)&&R.URI.isUri(a.extensionsResource))}e.$2k=n,e.$3k=(0,L.$6h)("IUserDataProfilesService");function c(h,a){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:R.URI.revive(h.location).with({scheme:a}),globalStorageHome:R.URI.revive(h.globalStorageHome).with({scheme:a}),settingsResource:R.URI.revive(h.settingsResource).with({scheme:a}),keybindingsResource:R.URI.revive(h.keybindingsResource).with({scheme:a}),tasksResource:R.URI.revive(h.tasksResource).with({scheme:a}),snippetsHome:R.URI.revive(h.snippetsHome).with({scheme:a}),extensionsResource:R.URI.revive(h.extensionsResource).with({scheme:a}),cacheHome:R.URI.revive(h.cacheHome).with({scheme:a}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}e.$4k=c;function t(h,a,d,k,A,p){return{id:h,name:a,location:d,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:p&&A?.useDefaultFlags?.globalState?p.globalStorageHome:(0,I.$Hg)(d,"globalStorage"),settingsResource:p&&A?.useDefaultFlags?.settings?p.settingsResource:(0,I.$Hg)(d,"settings.json"),keybindingsResource:p&&A?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,I.$Hg)(d,"keybindings.json"),tasksResource:p&&A?.useDefaultFlags?.tasks?p.tasksResource:(0,I.$Hg)(d,"tasks.json"),snippetsHome:p&&A?.useDefaultFlags?.snippets?p.snippetsHome:(0,I.$Hg)(d,"snippets"),extensionsResource:p&&A?.useDefaultFlags?.extensions?p.extensionsResource:(0,I.$Hg)(d,"extensions.json"),cacheHome:(0,I.$Hg)(k,h),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$5k=t;let u=class extends g.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,d,k,A){super(),this.t=a,this.u=d,this.w=k,this.y=A,this.f=!0,this.h=this.B(new T.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),d=[a];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,i.$If)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}d.push(t((0,I.$Eg)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},a))}}catch(p){this.y.error(p)}const k=new v.$Ac,A=new Map;if(d.length)try{const p=this.Q();if(p.workspaces)for(const[w,E]of Object.entries(p.workspaces)){const P=R.URI.parse(w),F=d.find(z=>z.id===E);F&&k.set(P,F)}if(p.emptyWindows)for(const[w,E]of Object.entries(p.emptyWindows)){const P=d.find(F=>F.id===E);P&&A.set(w,P)}}catch(p){this.y.error(p)}this.z={profiles:d,workspaces:k,emptyWindows:A}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const d="Temp",k=new RegExp(`${(0,o.$Oe)(d)}\\s(\\d+)`);let A=0;for(const w of this.profiles){const E=k.exec(w.name),P=E?parseInt(E[1]):0;A=P>A?P:A}const p=`${d} ${A+1}`;return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),p,{transient:!0},a)}async createNamedProfile(a,d,k){return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),a,d,k)}async createProfile(a,d,k,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(a,d,k);return A&&await this.setProfileForWorkspace(A,p),p}async F(a,d,k){if(!(0,i.$If)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(d);return A||(A=(async()=>{try{const p=this.profiles.find(P=>P.name===d||P.id===a);if(p)return p;const w=t(a,d,(0,I.$Hg)(this.profilesHome,a),this.g,k,this.defaultProfile);await this.u.createFolder(w.location);const E=[];return this.j.fire({profile:w,join(P){E.push(P)}}),await l.Promises.settled(E),this.I([w],[],[]),w}finally{this.r.delete(d)}})(),this.r.set(d,A)),A}async updateProfile(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(A=>A.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);return k=t(k.id,d.name??k.name,k.location,this.g,{shortName:d.shortName??k.shortName,icon:d.icon===null?void 0:d.icon??k.icon,transient:d.transient??k.isTransient,useDefaultFlags:d.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(A=>A.id===a.id);if(!d)throw new Error(`Profile '${a.name}' does not exist`);const k=[];this.m.fire({profile:d,join(A){k.push(A)}});try{await Promise.allSettled(k)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(A){(0,y.$Hk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(A=>A.id===d.id);if(!k)throw new Error(`Profile '${d.name}' does not exist`);this.L(a,k)}unsetWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(d=>d.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(a.map(d=>this.removeProfile(d)))}getProfileForWorkspace(a){const d=this.G(a);return R.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(a){return(0,m.$di)(a)?a.uri:(0,m.$ii)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location)))}I(a,d,k){const A=[...this.profiles,...a],p=[];this.s.profiles=[];for(let w of A)w.isDefault||d.some(E=>w.id===E.id)||(w=k.find(E=>w.id===E.id)??w,w.isTransient?this.s.profiles.push(w):p.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(p),this.z=void 0,this.J(a,d,k)}J(a,d,k){this.h.fire({added:a,removed:d,updated:k,all:this.profiles})}L(a,d,k){k=d?.isTransient?!0:k,k||this.L(a,void 0,!0);const A=this.G(a),p=k?this.s:this.C;R.URI.isUri(A)?(p.workspaces.delete(A),d&&p.workspaces.set(A,d)):(p.emptyWindows.delete(A),d&&p.emptyWindows.set(A,d)),k||this.M()}M(){const a={};for(const[k,A]of this.C.workspaces.entries())a[k.toString()]=A.id;const d={};for(const[k,A]of this.C.emptyWindows.entries())d[k.toString()]=A.id;this.R({workspaces:a,emptyWindows:d}),this.z=void 0}N(a){const d={},k=this.D();if(a.workspaces)for(const[p,w]of Object.entries(a.workspaces)){const E=R.URI.parse(w);d[p]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const A={};if(a.emptyWindows)for(const[p,w]of Object.entries(a.emptyWindows)){const E=R.URI.parse(w);A[p]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:d,emptyWindows:A}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$6k=u,e.$6k=u=Ge([Ve(0,$.$ai),Ve(1,y.$qk),Ve(2,S.$1k),Ve(3,C.$nj)],u);class s extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$7k=s}),define(ke[269],Se([1,0,11,4,3,57,18,188,5,268]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,$.$6h)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const r=i.get(e.$tp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$vp=v;class S extends g.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new T.$Yd),this.c=this.B(new T.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,c){return T.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),c)}n(){this.j.value=(0,D.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:c,external:t}=n;if(c===e.$tp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:c,target:this.J(r)[c],external:t})}w(r){this.f.fire({reason:r})}get(r,n,c){return this.P(n)?.get(r,c)}getBoolean(r,n,c){return this.P(n)?.getBoolean(r,c)}getNumber(r,n,c){return this.P(n)?.getNumber(r,c)}getObject(r,n,c){return this.P(n)?.getObject(r,c)}storeAll(r,n){this.y(()=>{for(const c of r)this.store(c.key,c.value,c.scope,c.target,n)})}store(r,n,c,t,u=!1){if((0,R.$Rf)(n)){this.remove(r,c,u);return}this.y(()=>{this.z(r,c,t),this.P(c)?.set(r,n,u)})}remove(r,n,c=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,c)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const c=[],t=this.J(r);for(const u of Object.keys(t))t[u]===n&&c.push(u);return c}z(r,n,c,t=!1){const u=this.J(n);typeof c=="number"?u[r]!==c&&(u[r]=c,this.P(n)?.set(e.$tp,JSON.stringify(u),t)):typeof u[r]=="number"&&(delete u[r],this.P(n)?.set(e.$tp,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?v(n):Object.create(null)}isNew(r){return this.getBoolean(e.$sp,r)===!0}async flush(r=L.NONE){this.f.fire({reason:r});const n=this.P(-1),c=this.P(0),t=this.P(1);switch(r){case L.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(r,n,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(L.NONE),(0,y.$2k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||l(n)&&l(r))}N(r,n,c){this.y(()=>{const t=new Set;for(const[u,s]of r)t.add(u),n.get(u)!==s&&this.u(c,{key:u,external:!0});for(const[u]of n.items)t.has(u)||this.u(c,{key:u,external:!0})})}}e.$wp=S;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$xp=l;class f extends S{constructor(){super(),this.U=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$yp=f;async function o(i,r,n,c,t,u){const s=P=>{try{return JSON.parse(P)}catch{return P}},h=new Map,a=new Map;i.forEach((P,F)=>{h.set(F,P),a.set(F,s(P))});const d=new Map,k=new Map;r.forEach((P,F)=>{d.set(F,P),k.set(F,s(P))});const A=new Map,p=new Map;n.forEach((P,F)=>{A.set(F,P),p.set(F,s(P))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const w=[];if(h.forEach((P,F)=>{w.push({key:F,value:P})}),console.table(w),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((F,z)=>{P.push({key:z,value:F})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${u})`);const E=[];A.forEach((P,F)=>{E.push({key:F,value:P})}),console.table(E),console.groupEnd(),console.log(p)}e.$zp=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$agc=D}),define(ke[58],Se([1,0,16,23,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$wg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$dgc=I,e.$egc=(0,g.$6h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0,e.$rN=(0,D.$6h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let R=class extends g.$yO{constructor($,y,L){const C=L.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=L.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$kic=R,e.$kic=R=Ge([Ve(1,T.$oj),Ve(2,I.$rN)],R)}),define(ke[271],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;class T{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$fh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const C of y.values())C.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const y=new D.$qh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Ygc=T;class g extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$Zgc=g}),define(ke[272],Se([1,0,4,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,y){const C=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$Mhc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN=(0,D.$6h)("IExtHostRpcService");class T{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$cN=T}),define(ke[273],Se([1,0,26,4]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class g{#e;constructor(R,b){this.b=new T.$Vd,this.onDidChange=this.b.event,this.a=D.$lm.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$7gc=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,D.$6h)("IURITransformerService");class T{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$xgc=T}),define(ke[274],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilb=e.$hlb=void 0;class T{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new T,C=JSON.stringify(b,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const l=I(S);if(l)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:l,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(v=>{const S=new Uint8Array(v);return D.$je.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$hlb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),L=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:l}=S,f=y[l];if(S.view)switch(S.view.type){case 1:return new Int8Array(f,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return v}:void 0;return{message:JSON.parse(b,L),arrayBuffers:y}}e.$ilb=R}),define(ke[275],Se([1,0,276,388,389,62,2,13,390]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;const y=!1;function L(r,n,c,t,u,s){const h=s.environment.useHostProxy,a=typeof h=="boolean"?h:!s.remote.isRemote,d={resolveProxy:p=>r.resolveProxy(p),lookupProxyAuthorization:f.bind(void 0,t,u,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(n),addCertificatesV2:()=>v(n),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return w(p)}function w(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const p=[];if(s.remote.isRemote&&p.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const w=r.loadCertificates();w.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),p.push(w)}return(await Promise.all(p)).flat()},env:process.env},k=(0,$.createProxyResolver)(d),A=C(d,k);return l(c,A)}e.$Sic=L;function C(r,n){return{http:Object.assign(D,(0,$.createHttpPatch)(r,D,n)),https:Object.assign(T,(0,$.createHttpPatch)(r,T,n)),net:Object.assign(I,(0,$.createNetPatch)(r,I)),tls:Object.assign(g,(0,$.createTlsPatch)(r,g))}}function m(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function v(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const S=new Map;function l(r,n){return r.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(h,a,d){if(h==="net")return n.net;if(h==="tls")return n.tls;if(h!=="http"&&h!=="https")return u.apply(this,arguments);const k=c.findSubstr(R.URI.file(a.filename));let A=S.get(k);if(A||S.set(k,A={}),!A[h]){const p=n[h];A[h]={...p}}return A[h]}})}async function f(r,n,c,t,u,s,h,a){const d=t[s];h&&(t[s]=h),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${d}`);const k=h||d,A=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(n,A,u),A.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const p=await new Promise((z,N)=>{me(["kerberos"],z,N)}),w=new URL(s),E=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${E}`),"Negotiate "+await(await p.initializeClient(E)).step("")}catch(p){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let o=!1;function i(r,n,c){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;function T(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(I){return new D.$4m(T(I))}e.$3r=g}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,16,44,180,39]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var v;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function l(ce){const K=ce;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$IE=l;function f(ce,K,V){for(const re of V.visibleEditorPanes)if(re.group.id===K&&ce.matches(re.input))return re.getViewState()}e.$JE=f;function o(ce){if(k(ce))return!1;const K=ce;return g.URI.isUri(K?.resource)}e.$KE=o;function i(ce){if(k(ce))return!1;const K=ce;return K?.original!==void 0&&K.modified!==void 0}e.$LE=i;function r(ce){if(k(ce))return!1;const K=ce;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$ME=r;function n(ce){if(k(ce)||i(ce))return!1;const K=ce;return K?.primary!==void 0&&K.secondary!==void 0}e.$NE=n;function c(ce){if(k(ce))return!1;const K=ce;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$OE=c;function t(ce){if(k(ce))return!1;const K=ce;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$PE=t;var u;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class h{constructor(){this.a=new Map}registerSource(K,V){let re=this.a.get(K);return re||(re={source:K,label:V},this.a.set(K,re)),re.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$QE=new h;var a;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class d extends I.$Tc{}e.$RE=d;function k(ce){return ce instanceof d}e.$SE=k;function A(ce){const K=ce;return g.URI.isUri(K?.preferredResource)}function p(ce){const K=ce;return k(K?.primary)&&k(K?.secondary)}e.$TE=p;function w(ce){const K=ce;return k(K?.modified)&&k(K?.original)}e.$UE=w;function E(ce,K,V,re,ye){return be(re,[(0,C.$Pi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...V,limits:{size:Number.MAX_VALUE}};ce.openEditor(K,de)}}),(0,C.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$VE=E;function P(ce){return k(ce?.editor)}e.$WE=P;function F(ce){const K=ce;return P(ce)&&K?.group!==void 0}e.$XE=F;function z(ce){const K=ce;return typeof K?.groupId=="number"&&k(K.editor)}e.$YE=z;var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var M;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class O{getOriginalUri(K,V){if(!K)return;if(t(K))return e.$1E.getOriginalUri(K.result,V);if(V?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(V?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:V.filterByScheme})??this.getOriginalUri(de,{filterByScheme:V.filterByScheme});K=V.supportSideBySide===M.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=A(K)?K.preferredResource:K.resource;return!re||!V||!V.filterByScheme?re:this.b(re,V.filterByScheme)}a(K){return p(K)||n(K)?{primary:K.primary,secondary:K.secondary}:w(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,V){if(!K)return;if(t(K))return e.$1E.getCanonicalUri(K.result,V);if(V?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(V?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:V.filterByScheme});K=V.supportSideBySide===M.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=K.resource;return!re||!V||!V.filterByScheme?re:this.b(re,V.filterByScheme)}b(K,V){if(Array.isArray(V)){if(V.some(re=>K.scheme===re))return K}else if(V===K.scheme)return K}}var U;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function Y(ce,K,V,re){if(!ce.isSticky(K))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return V===U.MOUSE||V===U.KEYBOARD;case"mouse":return V===U.MOUSE;case"keyboard":return V===U.KEYBOARD}return!1}e.$ZE=Y,e.$1E=new O;var le;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(K){const V=this.a=K.get(R.$5h);for(const[re,ye]of this.c)this.e(re,ye,V);this.c.clear()}e(K,V,re){const ye=re.createInstance(V);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,T.$Tf)(this.b)}registerEditorSerializer(K,V){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,V,this.a):this.c.set(K,V),(0,I.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$Hn.add(e.$DE.EditorFactory,new Z);async function J(ce,K,V){return!ce||!ce.length?[]:await Promise.all(ce.map(async re=>{const ye=g.URI.revive(re.fileUri);if(!ye){V.info("Cannot resolve the path because it is not valid.",re);return}if(!await K.canHandleResource(ye)){V.info("Cannot resolve the path because it cannot be handled",re);return}let ge=re.exists,_=re.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){V.error(G),ge=!1}if(!ge&&re.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",re);return}if(_===$.FileType.Directory){V.info("Cannot resolve the path because it is a directory",re);return}const te={...re.options,pinned:!0};return ge?{resource:ye,options:te}:{resource:ye,options:te,forceUntitled:!0}}))}e.$2E=J;var X;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function ue(ce){const K=ce;if(!K)return!1;const V=K;if(V.modified)return ue(V.modified);const re=K;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$3E=ue;function x(ce){return(0,L.$Ri)(ce)}e.$4E=x;function be(ce,K,V){const re=(0,L.$Si)(ce,K);return re.forceMessage=V?.forceMessage,re.forceSeverity=V?.forceSeverity,re.allowDialog=V?.allowDialog,re}e.$5E=be}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,T.localize)(0,null),e.$8E=(0,C.$xw)("default-view-icon",L.$_j.window,(0,T.localize)(1,null));var m;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$9E=[0,1,2];function S(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=S;class l extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,h,a){const d=this.get(s.id);if(d)return d;const k=s;return k.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$xc)(this.g,h,[]).push(k),a?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:h}),k}deregisterViewContainer(s){for(const h of this.g.keys()){const a=this.g.get(h),d=a?.indexOf(s);if(d!==-1){a?.splice(d,1),a.length===0&&this.g.delete(h),this.f.fire({viewContainer:s,viewContainerLocation:h});return}}}get(s){return this.all.filter(h=>h.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(h=>this.getViewContainerLocation(h)===s)}}b.$Hn.add(m.ViewContainersRegistry,new l);var f;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(f||(e.ViewContentGroups=f={}));function o(u,s){const h=u.group??f.More,a=s.group??f.More;return h!==a?h.localeCompare(a):(u.order??5)-(s.order??5)}class i extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(s,h){this.registerViews2([{views:s,viewContainer:h}])}registerViews2(s){s.forEach(({views:h,viewContainer:a})=>this.r(h,a)),this.c.fire(s)}deregisterViews(s,h){const a=this.s(s,h);a.length&&this.f.fire({views:a,viewContainer:h})}moveViews(s,h){for(const a of this.m.keys())if(a!==h){const d=this.s(s,a);d.length&&(this.r(d,h),this.g.fire({views:d,from:a,to:h}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const h of this.j){const a=(this.m.get(h)||[]).filter(d=>d.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const h of this.j)if((this.m.get(h)||[]).filter(d=>d.id===s)[0])return h;return null}registerViewWelcomeContent(s,h){return this.n.add(s,h),this.h.fire(s),(0,I.$Rc)(()=>{this.n.delete(s,h),this.h.fire(s)})}registerViewWelcomeContent2(s,h){const a=new Map;for(const[d,k]of h)this.n.add(s,k),a.set(d,(0,I.$Rc)(()=>{this.n.delete(s,k),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const h=[];return this.n.forEach(s,a=>h.push(a)),h.sort(o)}r(s,h){let a=this.m.get(h);a||(a=[],this.m.set(h,a),this.j.push(h));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,T.localize)(2,null,d.id));a.push(d)}}s(s,h){const a=this.m.get(h);if(!a)return[];const d=[],k=[];for(const A of a)s.includes(A)?d.push(A):k.push(A);return d.length&&(k.length?this.m.set(h,k):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),d}}b.$Hn.add(m.ViewsRegistry,new i),e.$$E=(0,g.$6h)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(s,h){this.c=!1,this.d=!1,(0,y.$yn)(this,s),this.d=!!h,this.resolve=async a=>{if(h&&!this.c){const d=await h(a);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=c;class t extends Error{constructor(s){super((0,T.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$aF=t}),define(ke[279],Se([1,0,2,29,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Us.isIRange)}e.$3F=I;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$4F=R;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$5F=(0,g.$6h)("IChatService")}),define(ke[140],Se([1,0,4,11,226]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Vd,this.n=new D.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,L){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof L=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,L,b)};v(S)}},L)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$7g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,T.$7g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Nlb=I}),define(ke[280],Se([1,0,227,45,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new T.$kj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$SG=new T.$kj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$TG=new T.$kj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$UG="debugUx",e.$VG=new T.$kj(e.$UG,"default",{type:"string",description:D.localize(3,null)}),e.$WG=new T.$kj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$XG=new T.$kj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$YG=new T.$kj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$ZG=new T.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$1G=new T.$kj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$2G=new T.$kj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$3G=new T.$kj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$4G=new T.$kj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$5G=new T.$kj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$6G=new T.$kj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$7G=new T.$kj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$8G=new T.$kj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$9G=new T.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$0G=new T.$kj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$$G=new T.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$_G=new T.$kj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$aH=new T.$kj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$bH=new T.$kj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$cH=new T.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$dH=new T.$kj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$eH=new T.$kj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$fH=new T.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$gH=new T.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$hH=new T.$kj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$iH=new T.$kj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$jH=new T.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$kH=new T.$kj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$lH=new T.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$mH=new T.$kj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$nH=new T.$kj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$oH=new T.$kj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$pH=new T.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$qH=new T.$kj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$rH=new T.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$sH=new T.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$tH=new T.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$uH=new T.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$vH=new T.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$wH=new T.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$xH=new T.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$yH=new T.$kj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$zH=new T.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$AH=new T.$kj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$BH=new T.$kj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$CH=new T.$kj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$DH=new T.$kj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$EH=new T.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$FH=new T.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$GH=I,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$MH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var L;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$NH=(0,g.$6h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[281],Se([1,0,12,2,17,24,16,29,21,19]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const L=/{([^}]+)}/g;function C(A,p,w){return A.replace(L,function(E,P){return p&&P.length>0&&P[0]!=="_"?E:w&&w.hasOwnProperty(P)?w[P]:E})}e.$0F=C;function m(A){const p={};for(const w of Object.keys(A))w.startsWith("!")||(p[w]=A[w]);return p}e.$$F=m;function v(A){return A.configuration.request==="attach"&&!S(A)&&(!A.parentSession||v(A.parentSession))}e.$_F=v;function S(A){let p=A.configuration.type;if(p)return p==="vslsShare"&&(p=A.configuration.adapterProxy.configuration.type),(0,D.$_e)(p,"extensionhost")||(0,D.$_e)(p,"pwa-extensionhost")?A:A.parentSession?S(A.parentSession):void 0}e.$aG=S;function l(A){return A.type&&(A.label||A.program||A.runtime)}e.$bG=l;function f(A,p,w){let E,P=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=F.exec(A);){const N=z.index+1,j=N+z[0].length;if(N<=p&&j>=w){E=z[0],P=N;break}}if(E){const N=/\w+/g;let j=null;for(;(j=N.exec(E))&&!(j.index+1+P+j[0].length>=w););j&&(E=E.substring(0,N.lastIndex))}return E?{start:P,end:P+E.length-1}:{start:0,end:0}}e.$cG=f;async function o(A,p,w,E){if(A.evaluatableExpressionProvider.has(p)){const P=A.evaluatableExpressionProvider.ordered(p),F=(0,y.$Hb)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(p,w,E??$.CancellationToken.None)}catch{return}})));if(F.length>0){let z=F[0].expression;const N=F[0].range;return z||(z=p.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:z}}}else{const P=p.getLineContent(w.lineNumber),{start:F,end:z}=f(P,w.column,w.column),N=P.substring(F-1,z);return{matchingExpression:N,range:new b.$Us(w.lineNumber,F,w.lineNumber,F+N.length)}}return null}e.$dG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(A){return!!(A&&A.match(i))}e.$eG=r;function n(A){if(typeof A.path=="string"&&!(typeof A.sourceReference=="number"&&A.sourceReference>0)){if(r(A.path))return T.URI.parse(A.path);if((0,g.$ic)(A.path))return T.URI.file(A.path)}return A.path}function c(A){if(typeof A.path=="object"){const p=T.URI.revive(A.path);if(p)return p.scheme===R.Schemas.file?p.fsPath:p.toString()}return A.path}function t(A,p){const w=p?n:c,E=(0,I.$vn)(A);return s(E,(P,F)=>{P&&F&&(F.path=w(F))}),E}e.$fG=t;function u(A,p){const w=p?n:c,E=(0,I.$vn)(A);return s(E,(P,F)=>{!P&&F&&(F.path=w(F))}),E}e.$gG=u;function s(A,p){switch(A.type){case"event":{const w=A;switch(w.event){case"output":p(!1,w.body.source);break;case"loadedSource":p(!1,w.body.source);break;case"breakpoint":p(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=A;switch(w.command){case"setBreakpoints":p(!0,w.arguments.source);break;case"breakpointLocations":p(!0,w.arguments.source);break;case"source":p(!0,w.arguments.source);break;case"gotoTargets":p(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(E=>p(!1,E));break;default:break}break}case"response":{const w=A;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(E=>p(!1,E.source));break;case"loadedSources":w.body.sources.forEach(E=>p(!1,E));break;case"scopes":w.body.scopes.forEach(E=>p(!1,E.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(E=>p(!1,E.source));break;case"setBreakpoints":w.body.breakpoints.forEach(E=>p(!1,E.source));break;case"disassemble":w.body?.instructions.forEach(P=>p(!1,P.location));break;default:break}break}}}function h(A){return A.filter(p=>!p.presentation?.hidden).sort((p,w)=>p.presentation?w.presentation?p.presentation.group?w.presentation.group?p.presentation.group!==w.presentation.group?p.presentation.group.localeCompare(w.presentation.group):a(p.presentation.order,w.presentation.order):-1:w.presentation.group?1:a(p.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$hG=h;function a(A,p){return typeof A!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:A-p}async function d(A,p){const w=A.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(w!=="none"&&(await p.saveAll(),w==="allEditorsInActiveGroup")){const E=p.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await p.save({editor:E.input,groupId:E.group.id})}await A.reloadConfiguration()}e.$iG=d;const k=(A,p)=>!A||!p?A===p:A.name===p.name&&A.path===p.path&&A.sourceReference===p.sourceReference;e.$jG=k}),define(ke[282],Se([1,0,50,62,24,17,10,12,31,228,140]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=e.$qic=void 0;class C extends L.$Nlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",r=>this.w(r))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const c of n){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$qic=C;class m extends C{startSession(){return new Promise((o,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$ric=m;class v extends m{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$sic=v;class S extends m{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$tic=S;class l extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,r=this.y.options||{};try{if(o)if(I.$ic(o)){if(!await $.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=g.$yn(g.$vn(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const u=D.fork(i[0],i.slice(1),t);if(!u.pid)throw new Error(y.localize(2,null,i[0]));this.x=u}else throw new Error(y.localize(3,null));else{const c={env:n};r.cwd&&(c.cwd=r.cwd),this.x=D.spawn(o,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((o,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,c,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=I.$jc(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(I.$ic(o.program)?r.program=o.program:r.program=I.$jc(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=l.A(n.win,i)),n.winx86&&(r.winx86=l.A(n.winx86,i)),n.windows&&(r.windows=l.A(n.windows,i)),n.osx&&(r.osx=l.A(n.osx,i)),n.linux&&(r.linux=l.A(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const h of o)if(h.contributes){const a=h.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&b.$_e(d.type,i)).forEach(d=>{const k=l.A(d,h.extensionLocation.fsPath);r=g.$yn(r,k,h.isBuiltin)})}let n;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:R.$i?n=r.win||r.windows:R.$j?n=r.osx:R.$k&&(n=r.linux),n=n||r;const c=n.program||r.program,t=n.args||r.args,u=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$uic=l}),define(ke[283],Se([1,0,50,33,10]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;function I(y,L){return new Promise((C,m)=>{let v="";const S=D.spawn(y,L);S.pid&&S.stdout.on("data",l=>{v+=l.toString()}),S.on("error",l=>{m(l)}),S.on("close",l=>{C(v)})})}async function R(y){if(y)if(g.$i){const L=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{L.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$vic=R;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,L,C,m,v){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let l,f=" ";switch(S){case 1:if(l=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),m){const o=(0,T.$ag)(m);o&&(f+=`${o}:; `),f+=`cd ${l(m)}; `}if(v)for(const o in v){const i=v[o];i===null?f+=`Remove-Item env:${o}; `:f+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=C?o:l(o);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of L)f+=r==="<"||r===">"||C?r:l(r),f+=" "}break;case 0:if(l=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),m){const o=(0,T.$ag)(m);o&&(f+=`${o}: && `),f+=`cd ${l(m)} && `}if(v){f+='cmd /C "';for(const o in v){let i=v[o];i===null?f+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),f+=`set "${o}=${i}" && `)}}for(const o of L)f+=o==="<"||o===">"||C?o:l(o),f+=" ";v&&(f+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${l(m)} ; `),v){f+="/usr/bin/env";for(const i in v){const r=v[i];r===null?f+=` -u ${o(i)}`:f+=` ${o(`${i}=${r}`)}`}f+=" "}for(const i of L)f+=i==="<"||i===">"||C?i:l(i),f+=" ";break}}return f}e.$wic=$}),define(ke[284],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$fJ=(0,D.$6h)("INotebookExecutionService")}),define(ke[285],Se([1,0,3,29,193,100]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQb=void 0;class R extends D.$Tc{constructor($,y,L){super(),this._source=$,this.b=y,this.c=L,this.a=void 0}f($){const y=$.getLineCount();return new T.$Us(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$cC;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:L,disposable:C}=y.create(1);this.b=L,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$cC;y.acceptChunk($);const L=y.finish(!0),{textBuffer:C,disposable:m}=L.create(1);return this.B(m),C})),this.a}findInInputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();if(!L)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,L,!0,5e3)}findInOutputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),L,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$TQb=R}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new g([b]);const y=[R.id];for(let L=$;L&&L.id!==b;L=L.parent)y.push(L.id);return y.push(b),new g(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new g(R.split("\0"))}static join(R,b){return new g([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:g.isChild(R,b)?2:g.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$2J=g}),define(ke[90],Se([1,0,2,48,29,67]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$9J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$8J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7J=e.$6J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4J=e.$3J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var b;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$3J=[2,4,8,16,32,64];const y=M=>"runId"in M;e.$4J=y;var L;(function(M){M.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),M.deserialize=(O,U)=>({range:g.$Us.lift(U.range),uri:O.asCanonicalUri(D.URI.revive(U.uri))})})(L||(e.IRichLocation=L={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(M){M.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&L.serialize(O.location)}),M.deserialize=(O,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&L.deserialize(O,U.location)})})(m||(e.ITestErrorMessage=m={}));const v=(M,O)=>`${O?"s":"e"}${M}`;e.$5J=v;var S;(function(M){M.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&L.serialize(O.location)}),M.deserialize=(O,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&L.deserialize(O,U.location)})})(S||(e.ITestOutputMessage=S={}));var l;(function(M){M.serialize=O=>O.type===0?m.serialize(O):S.serialize(O),M.deserialize=(O,U)=>U.type===0?m.deserialize(O,U):S.deserialize(O,U)})(l||(e.ITestMessage=l={}));var f;(function(M){M.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),M.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(l.serialize)}),M.deserialize=(O,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Y=>l.deserialize(O,Y))})})(f||(e.ITestTaskState=f={}));const o="\0",i=(M,O)=>M+o+O;e.$6J=i;const r=M=>{const O=M.indexOf(o);return{ctrlId:M.slice(0,O),tagId:M.slice(O+1)}};e.$7J=r;var n;(function(M){M.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),M.deserialize=(O,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?O.asCanonicalUri(D.URI.revive(U.uri)):void 0,range:U.range?g.$Us.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(n||(e.ITestItem=n={}));var c;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(M){M.serialize=O=>({expand:O.expand,item:n.serialize(O.item)}),M.deserialize=(O,U)=>({controllerId:I.$2J.root(U.item.extId),expand:U.expand,item:n.deserialize(O,U.item)})})(t||(e.InternalTestItem=t={}));var u;(function(M){M.serialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.uri!==void 0&&(U.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(U.range=O.item.range?.toJSON()),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}},M.deserialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.range!==void 0&&(U.range=O.item.range?g.$Us.lift(O.item.range):null),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}}})(u||(e.ITestItemUpdate=u={}));const s=(M,O)=>{O.expand!==void 0&&(M.expand=O.expand),O.item!==void 0&&(M.item=M.item?Object.assign(M.item,O.item):O.item)};e.$8J=s;var h;(function(M){M.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serializeWithoutMessages)}),M.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serialize)}),M.deserialize=(O,U)=>({...t.deserialize(O,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Y=>f.deserialize(O,Y)),retired:!0})})(h||(e.TestResultItem=h={}));var a;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(O,U)=>{O.covered+=U.covered,O.total+=U.total}})(a||(e.ICoveredCount=a={}));var d;(function(M){M.serialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(w.serialize),uri:O.uri.toJSON()}),M.deserialize=(O,U)=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(w.deserialize),uri:O.asCanonicalUri(D.URI.revive(U.uri))})})(d||(e.IFileCoverage=d={}));function k(M){return{...M,location:M.location?.toJSON()}}function A(M){return M.location=M.location?T.$Ts.isIPosition(M.location)?T.$Ts.lift(M.location):g.$Us.lift(M.location):void 0,M}e.$9J=3;var p;(function(M){M[M.Function=0]="Function",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(p||(e.DetailType=p={}));var w;(function(M){M.serialize=O=>O.type===0?P.serialize(O):F.serialize(O),M.deserialize=O=>O.type===0?P.deserialize(O):F.deserialize(O)})(w||(e.CoverageDetails=w={}));var E;(function(M){M.serialize=k,M.deserialize=A})(E||(e.IBranchCoverage=E={}));var P;(function(M){M.serialize=k,M.deserialize=A})(P||(e.IFunctionCoverage=P={}));var F;(function(M){M.serialize=O=>({...k(O),branches:O.branches?.map(E.serialize)}),M.deserialize=O=>({...A(O),branches:O.branches?.map(E.deserialize)})})(F||(e.IStatementCoverage=F={}));var z;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var N;(function(M){M.deserialize=(O,U)=>U.op===0?{op:U.op,item:t.deserialize(O,U.item)}:U.op===1?{op:U.op,item:u.deserialize(U.item)}:U.op===2?{op:U.op,uri:O.asCanonicalUri(D.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:u.serialize(O.item)}:O})(N||(e.TestsDiffOp=N={}));class j{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const U=this.v();for(const Y of O)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),U);break;case 1:this.o(u.deserialize(Y.item),U);break;case 3:this.p(Y.itemId,U);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}U.complete?.()}l(O,U){const Y=I.$2J.parentId(O.item.extId)?.toString();let le;if(!Y)le=this.w(O),this.g.add(le),this.f.set(O.item.extId,le);else if(this.f.has(Y)){const Z=this.f.get(Y);Z.children.add(O.item.extId),le=this.w(O,Z),this.f.set(O.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return U.add?.(le),O.expand===2&&this.h++,le}o(O,U){const Y=this.f.get(O.extId);if(Y)return O.expand!==void 0&&(Y.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$8J)(Y,O),U.update?.(Y),Y}p(O,U){const Y=this.f.get(O);if(!Y)return;const le=I.$2J.parentId(Y.item.extId)?.toString();le?this.f.get(le).children.delete(Y.item.extId):this.g.delete(Y);const Z=[[O]];for(;Z.length;)for(const J of Z.pop()){const X=this.f.get(J);X&&(Z.push(X.children),this.f.delete(J),U.remove?.(X,X!==Y),X.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$0J=j}),define(ke[111],Se([1,0,11,4,3,60,90,67]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,r)=>i===r,C=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),m=(i,r)=>{let n;for(const[c,t]of C)t(i[c],r[c])||(n?n[c]=r[c]:n={[c]:r[c]});return n};class v extends g.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$fh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,R.$8J)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,R.$8J)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const c=this.tree.get(r);if(c){if((c.expandLevels===void 0||n>c.expandLevels)&&(c.expandLevels=n),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,n-1):t.wait().then(()=>this.L(c,n-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,n-1)):this.L(c,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(b.$2J.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const c of n.ops)this.w(r,c);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,I.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const c=b.$2J.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let u=this.tree.get(c.toString());if(!u){u={fullId:c,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(r)}}),this.I(r,u,n);return}if(u.actual===r){this.H(r,u,n);return}if(u.actual.uri?.toString()!==r.uri?.toString())return this.O(c.toString()),this.z(r,n);const s=this.s.getChildren(u.actual),h=u.actual,a=m(this.s.toITestItem(h),this.s.toITestItem(r));this.s.getApiFor(h).listener=void 0,u.actual=r,u.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(r.tags,h.tags,c.toString()),delete a.tags),this.w(u,{op:4,update:a})),this.I(r,u,n);for(const[d,k]of s)this.s.getChildren(r).get(k.id)||this.O(b.$2J.joinToString(c,k.id));this.y(u.actual.uri)}C(r,n,c){const t=new Set(n.map(u=>u.id));for(const u of r)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:c,item:{tags:r.map(u=>(0,R.$6J)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$6J)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,R.$6J)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,c){this.G(r,c);const t=this.s.getApiFor(r);t.parent=c?.actual,t.listener=u=>this.w(n,u),this.J(n)}I(r,n,c){this.H(r,n,c);for(const[t,u]of this.s.getChildren(r))this.z(u,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const c=[];for(const[t,u]of this.s.getChildren(r.actual)){const s=this.expand(b.$2J.joinToString(r.fullId,u.id),n);(0,D.$Sg)(s)&&c.push(s)}if(c.length)return Promise.all(c).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const u=new D.$5g;return u.open(),u}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$5g,c=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(u){c(u)}return(0,D.$Sg)(t)?t.catch(c).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const c=[n];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,s]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$2J.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$4M=v;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$5M=S;class l extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6M=l;class f extends Error{constructor(r,n,c){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${c}".`)}}e.$7M=f;const o=(i,r,n)=>{let c=new Map;return{get size(){return c.size},forEach(t,u){for(const s of c.values())t.call(u,s,this)},[Symbol.iterator](){return c.entries()},replace(t){const u=new Map,s=new Set(c.keys()),h={op:5,ops:[]};for(const a of t){if(!(a instanceof n))throw new l(a.id);const d=r(a).controllerId;if(d!==i.controllerId)throw new f(a.id,d,i.controllerId);if(u.has(a.id))throw new S(a.id);u.set(a.id,a),s.delete(a.id),h.ops.push({op:0,item:a})}for(const a of s.keys())h.ops.push({op:3,id:a});i.listener?.(h),c=u},add(t){if(!(t instanceof n))throw new l(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$8M=o}),define(ke[141],Se([1,0,111]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0;const T=new WeakMap,g=(R,b)=>{const $={controllerId:b};return T.set(R,$),$};e.$9M=g;const I=R=>{const b=T.get(R);if(!b)throw new D.$6M(R?.id||"<unknown>");return b};e.$0M=I}),define(ke[112],Se([1,0,16,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Evb=e.$Dvb=e.$Cvb=e.$Bvb=e.$Avb=void 0,e.$Avb="vscode-cdn.net",e.$Bvb=`vscode-resource.${e.$Avb}`,e.$Cvb=`'self' https://*.${e.$Avb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),T.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$Bvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$Dvb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$Evb=R}),define(ke[286],Se([1,0,4,3,112]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const L=$.getVisibleTextEditors();for(const C of this.c.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,L,C){let m;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===b){m=r;break}if(!m)throw new Error("not a visible editor");const v=this,S=this.a++,l=new D.$Vd,f=new D.$Vd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,g.$Dvb)(r,v.f)}get cspSource(){return g.$Cvb}set options(r){this.b=r,v.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,v.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(r){return v.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=o,this.onDidDispose=f.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),f.fire(),f.dispose(),l.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,L||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$ugc=I}),define(ke[287],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.VariableKind=e.$ZN=void 0,e.$ZN=(0,D.$6h)("configurationResolverService");var T;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class g extends Error{constructor(R,b){super(b),this.variable=R}}e.$1N=g}),define(ke[288],Se([1,0,17,49,18,24,10,103,231,287,12]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,l,f){this.h=new Map,this.a=v,this.b=S,this.g=l,f&&(this.c=f.then(o=>this.i(o)))}i(v){if(R.$i){const S=Object.create(null);return Object.keys(v).forEach(l=>{S[l.toLowerCase()]=v[l]}),S}return v}resolveWithEnvironment(v,S,l){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,l)}async resolveAsync(v,S){const l={env:await this.c,userHome:await this.g};return this.l(l,v?v.uri:void 0,S)}async j(v,S,l,f){const o=I.$vn(S);R.$i&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):R.$j&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):R.$k&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,o,l,f)}async resolveAnyAsync(v,S,l){return this.j(v,S,l)}async resolveAnyMap(v,S,l){const f=new Map;return{newConfig:await this.j(v,S,l,f),resolvedVariables:f}}resolveWithInteractionReplace(v,S,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,l,f,o){if(g.$If(l))return this.m(v,S,l,f,o);if(Array.isArray(l))return Promise.all(l.map(i=>this.l(v,S,i,f,o)));if(g.$Kf(l)){const i=Object.create(null),r=await Promise.all(Object.keys(l).map(async n=>[await this.m(v,S,n,f,o),await this.l(v,S,l[n],f,o)]));for(const[n,c]of r)i[n]=c;return i}return l}m(v,S,l,f,o){return(0,L.$4e)(l,C.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(C.VARIABLE_LHS))return i;let n=await this.o(v,i,r,S,f);return o?.set(r,n),n!==i&&g.$If(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(v,S,n,f,o)),n})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,l,f,o){let i;const r=l.split(":");r.length>1&&(l=r[0],i=r[1]);const n=u=>{const s=this.a.getFilePath();if(s)return(0,b.$Wv)(s);throw new y.$1N(u,(0,$.localize)(0,null,S))},c=u=>{const s=n(u);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,b.$Wv)(h)}throw new y.$1N(u,(0,$.localize)(1,null,S,D.$nc(s)))},t=u=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new y.$1N(u,(0,$.localize)(2,null,S,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$1N(u,(0,$.localize)(3,null,S)):new y.$1N(u,(0,$.localize)(4,null,S))};switch(l){case"env":if(i){if(v.env){const u=v.env[R.$i?i.toLowerCase():i];if(g.$If(u))return u}return""}throw new y.$1N(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const u=this.a.getConfigurationValue(f,i);if(g.$Rf(u))throw new y.$1N(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Kf(u))throw new y.$1N(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return u}throw new y.$1N(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,o,"command");case"input":return this.p(y.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const u=await this.a.getExtension(i);if(!u)throw new y.$1N(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(u.extensionLocation)}throw new y.$1N(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,b.$Wv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Wv)(this.n(t(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Wv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$1N(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new y.$1N(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new y.$1N(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const u=D.$mc(n(y.VariableKind.RelativeFileDirname));if(f||i){const s=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return D.$mc(n(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=D.$nc(n(y.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-D.$oc(u).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||S}case"execInstallFolder":{const u=this.a.getAppRoot();return u||S}case"pathSeparator":case"/":return D.sep;default:try{const u=i?`${l}:${i}`:l;return this.p(y.VariableKind.Unknown,S,u,o,void 0)}catch{return S}}}}p(v,S,l,f,o){if(l&&f){const i=o===void 0?f[l]:f[o+":"+l];if(typeof i=="string")return i;throw new y.$1N(v,(0,$.localize)(14,null,S))}return S}}e.$cO=C}),define(ke[142],Se([1,0,5,139]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,D.$6h)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const l=S;return(0,T.$SE)(l?.editor)&&(0,T.$SE)(l?.replacement)}e.$0C=y;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const l=S;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$$C=m;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=v}),define(ke[289],Se([1,0,5,142]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,D.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function g(I){const R=I;return typeof I=="number"||(0,T.$$C)(R)}e.$eD=g}),define(ke[143],Se([1,0,5,133]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=void 0,e.$uK=(0,D.$7h)(T.$ai)}),define(ke[144],Se([1,0,26,4,17,3]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=e.$s8b=e.$r8b=e.$q8b=e.$p8b=void 0;class R{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$p8b=R;class b{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new T.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$nm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=l(this.e,i),this.e=this.e.concat(o);const r=b.l(this.e);return this.e=l(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,r)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,s){this.addNode(u),this.addNode(s),this.c.has(u)?this.c.get(u).push(s):this.c.set(u,[s])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,s){const h=i.getArcs(u);for(let a=0;a<h.length;a++)if(!s.has(h[a]))return!1;return!0}getNodes(){return this.e}},r=new D.$nm;for(const u of o)if(r.set(u.identifier,u),u.extensionDependencies)for(const s of u.extensionDependencies)i.addArc(D.$lm.toKey(u.identifier),D.$lm.toKey(s));const n=new Set;i.getNodes().filter(u=>i.getArcs(u).length===0).forEach(u=>n.add(u));const c=i.getNodes().filter(u=>!n.has(u));let t;do{t=!1;for(let u=0;u<c.length;u++){const s=c[u];i.hasOnlyGoodArcs(s,n)&&(c.splice(u,1),u--,n.add(s),t=!0)}}while(t);return c.map(u=>r.get(u))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$q8b=b;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$r8b=$;class y{constructor(o){this.d=new m,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new L(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$s8b=y;class L extends I.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$t8b=L;class C{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this.c=i})}resolve(o){this.c(o)}}class m{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new C(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};o.resolve((0,I.$Rc)(n))}}var v;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(v||(v={}));function S(f,o){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(o.extensionLocation.path);return n<c?-1:n>c?1:0}function l(f,o){const i=new D.$mm(o);return f.filter(r=>!i.has(r.identifier))}}),define(ke[290],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[T.ENV_KEY]=this.pipeName}}e.$Pm=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Qm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Rm=I;function R(L){delete L[T.ENV_KEY],delete L[g.ENV_KEY],delete L[I.ENV_KEY]}function b(L,C){R(C),L.serialize(C)}e.$Sm=b;function $(L){if(L[T.ENV_KEY])return y(L,new T(L[T.ENV_KEY]));if(L[g.ENV_KEY])return y(L,new g);if(L[I.ENV_KEY])return y(L,new I);throw new Error("No connection information defined in environment!")}e.$Tm=$;function y(L,C){return R(L),C}}),define(ke[113],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(y){const L=D.$je.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$tm=R;function b(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$um=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[91],Se([1,0,5,4,13,27,113,65,88,24,2,3,217]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.$sN=void 0;let v=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new T.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Qo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,g.$pj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),c=new S(i,r,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this.f=o,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$bl)((0,$.$Wo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const c=r.filter(t=>!t.isDisposed);c.length===0?this.r.delete(n):this.r.set(n,c)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let c=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$sN=v,e.$sN=v=Ge([Ve(0,I.$rN),Ve(1,g.$oj)],v);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,c,t,u){this.g=r,this.h=n,this.i=c,this.j=t,this.a=new T.$Vd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$Zo)(i,[]),this.c&&(i=(0,y.$yn)(i,this.c)),this.b||(i=(0,y.$yn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$Zo)(r,[]),c=new Error(n.message,{cause:n.cause});c.stack=n.stack,c.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$tN=S;function l(f){const o=Date.now()-new Date(f).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$uN=l,e.$vN=(0,D.$6h)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,261,137,26,5]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new R.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,b.$6h)("extensionService");class ${constructor(c){this.dependency=c}}e.$zF=$;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,u){this.c=c,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$hF.createActivationEventsMap(this.d)}}set(c,t,u){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const s=[],h=[],a=[],d=[],k=C(this.d),A=C(t),p=(z,N)=>z.extensionLocation.toString()===N.extensionLocation.toString()||z.isBuiltin===N.isBuiltin||z.isUserBuiltin===N.isUserBuiltin||z.isUnderDevelopment===N.isUnderDevelopment;for(const z of this.d){const N=A.get(z.identifier);if(!N){s.push(z.identifier),k.delete(z.identifier);continue}if(!p(z,N)){s.push(z.identifier),k.delete(z.identifier);continue}}for(const z of t){const N=k.get(z.identifier);if(!N){h.push(z);continue}if(!p(N,z)){s.push(N.identifier),k.delete(N.identifier);continue}}const w=new R.$mm(this.e),E=new R.$mm(u);for(const z of this.e)E.has(z)||a.push(z);for(const z of u)w.has(z)||d.push(z);const P=I.$hF.createActivationEventsMap(h),F={versionId:c,toRemove:s,toAdd:h,addActivationEvents:P,myToRemove:a,myToAdd:d};return this.delta(F),F}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:s,myToAdd:h}=c,a=new R.$mm(t),d=new R.$mm(s);for(let k=0;k<this.d.length;k++)a.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)d.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of u)this.d.push(k);for(const k of h)this.e.push(k);return this.f=null,c}containsExtension(c){for(const t of this.e)if(R.$lm.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=I.$hF.readActivationEvents(t);for(const s of u)c.add(s)}return c}}e.$AF=L;function C(n){const c=new R.$nm;for(const t of n)c.set(t.identifier,t);return c}function m(n,c){return n.enabledApiProposals?n.enabledApiProposals.includes(c):!1}e.$BF=m;function v(n,c){if(!m(n,c))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$CF=v;class S{constructor(c,t,u,s){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=s}}e.$DF=S;class l{constructor(c,t){this.description=c,this.value=t}}e.$EF=l;var f;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,g.$6o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$FF=o;function i(n,c){return{identifier:new R.$lm((0,g.$4o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!c,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$GF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=r}),define(ke[291],Se([1,0,14,144,26,25,13,11]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$Qgc=$;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rgc=y;class L{constructor(o,i,r,n,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=c,this.subscriptions=t}}e.$Sgc=L;class C extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tgc=C;class m extends L{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ugc=m;class v extends L{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,r,n){this.g=n,this.a=o,this.b=i,this.c=r,this.d=new g.$nm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this.d)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const r=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const r=this.a.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new v(c));return this.c.onExtensionActivationError(o.id,c,new I.$zF(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of n){if(this.m(c))continue;const t=this.d.get(c);if(t){r.push(t);continue}if(this.l(c)){r.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const u=this.a.getExtensionDescription(c);if(u){if(!u.main&&!u.browser)continue;r.push(this.j({id:u.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${c}'`),a=this.k(o,i.displayName,[],new v(h));return this.c.onExtensionActivationError(i.identifier,h,new I.$zF(c)),a}return this.k(o,i.displayName,r,null)}k(o,i,r,n){const c=new l(o.id,i,o.reason,r,n,this.c,this.g);return this.d.set(o.id,c),c}l(o){return T.$q8b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Vgc=S,e.$Vgc=S=Ge([Ve(3,R.$nj)],S);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,r,n,c,t,u){this.c=o,this.d=i,this.f=r,this.g=n,this.h=c,this.j=t,this.k=u,this.a=new b.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new v(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new v(i),this.b&&D.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};l=Ge([Ve(6,R.$nj)],l)}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[293],Se([1,0,233,14,39,134,108,37,26,292,136,137]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const m=b.$Hn.as(R.$In.JSONContribution);class v{constructor(c,t,u){this.a=c,this.b=t,this.c=u}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$qF=v;class S{static a(c){const t=new $.$mm;for(let u=0,s=c.length;u<s;u++)t.add(c[u].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new S(t,[]);if(!t||!t.length)return new S([],c);const u=this.a(c),s=this.a(t),h=t.filter(d=>!u.has(d.description.identifier)),a=c.filter(d=>!s.has(d.description.identifier));return new S(h,a)}constructor(c,t){this.added=c,this.removed=t}}e.$rF=S;class l{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=S.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,T.$1)(c)}}}e.$sF=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$km},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new l(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$hF.register(c.extensionPoint,c.activationEventsGenerator),e.$tF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(o,e.$tF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};b.$Hn.add(r.ExtensionsRegistry,new i),e.$vF=b.$Hn.as(r.ExtensionsRegistry),m.registerSchema(o,e.$tF),m.registerSchema(L.$Gj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[294],Se([1,0,229,18,24,293,45,4]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(S,l,f){if(!S)return;const o=T.$If(S.type)?S.type:void 0;if(!o||o.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)T.$If(r)&&i.push(r);return{extensionId:l.value,taskType:o,required:i,properties:S.properties?g.$vn(S.properties):{},when:S.when?R.$4i.deserialize(S.when):void 0}}m.from=v})(y||(y={}));const L=I.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const S of m)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{L.setHandler((l,f)=>{this.c=void 0;try{for(const o of f.removed){const i=o.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const o of f.added){const i=o.value;for(const r of i){const n=y.from(r,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const l={type:"object",additionalProperties:!1};S.required.length>0&&(l.required=S.required.slice(0)),S.properties!==void 0?l.properties=g.$vn(S.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[S.taskType]},v.push(l)}this.c={oneOf:v}}return this.c}}e.$xG=new C}),define(ke[295],Se([1,0,230,18,23,24,45,294]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$kj("taskRunning",!1,D.localize(0,null)),e.$AG={value:D.localize(1,null),original:"Tasks"};var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$BG="$customized",function(M){function O(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=O}($||(e.ShellQuoting=$={}));var y;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L||(e.RevealKind=L={})),function(M){function O(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=O}(L||(e.RevealKind=L={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function O(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=O}(C||(e.RevealProblemKind=C={}));var m;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(m||(e.PanelKind=m={})),function(M){function O(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=O}(m||(e.PanelKind=m={}));var v;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function O(Y){switch(Y.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=O;function U(Y){switch(Y){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(S||(e.RuntimeType=S={}));var l;(function(M){function O(U){return T.$If(U)?U:U.value}M.value=O})(l||(e.CommandString=l={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function O(Y){return Y===M.Clean._id||Y===M.Build._id||Y===M.Rebuild._id||Y===M.Test._id}M.is=O;function U(Y){if(Y!==void 0)return T.$If(Y)?O(Y)?{_id:Y,isDefault:!1}:void 0:Y}M.from=U})(f||(e.TaskGroup=f={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function O(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var c;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(O,U,Y,le,Z,J){this._label="",this._id=O,U&&(this._label=U),Y&&(this.type=Y),this.runOptions=le,this.configurationProperties=Z,this._source=J}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,U=!1){if(O===void 0)return!1;if(T.$If(O))return O===this._label||O===this.configurationProperties.identifier||U&&O===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$CG=t;class u extends t{constructor(O,U,Y,le,Z,J,X,ue){super(O,Y,void 0,X,ue,U),this.command={},this._source=U,this.hasDefinedMatchers=J,Z&&(this.command=Z)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case S.Shell:U="shell";break;case S.Process:U="process";break;case S.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(O){return O instanceof u}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const Y={type:e.$BG,folder:O,id:U};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new u(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$DG=u;class s extends t{constructor(O,U,Y,le,Z,J,X){super(O,Y,le,J,X,U),this._source=U,this.configures=Z}static is(O){return O instanceof s}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const Y={type:e.$BG,folder:O,id:U};return JSON.stringify(Y)}}e.$EG=s;class h extends t{constructor(O,U,Y,le,Z,J,X,ue,x){super(O,Y,le,ue,x,U),this.defines=Z,this.hasDefinedMatchers=X,this.command=J,this.icon=x.icon,this.hide=x.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof h}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new h(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$FG=h;class a extends t{constructor(O,U,Y,le,Z,J){super(O,Y,le,Z,J,U),this._source=U}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$GG=a;var d;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(M){M._default=M.Terminal}(d||(e.ExecutionEngine=d={}));var k;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class A{constructor(O){this.c=new Map;for(let U=0;U<O.length;U++)this.c.set(O[U].uri.toString(),U)}compare(O,U){const Y=O.getWorkspaceFolder(),le=U.getWorkspaceFolder();if(Y&&le){let Z=this.c.get(Y.uri.toString());Z=Z===void 0?0:Z+1;let J=this.c.get(le.uri.toString());return J=J===void 0?0:J+1,Z===J?O._label.localeCompare(U._label):Z-J}else return!Y&&le?-1:Y&&!le?1:0}}e.$HG=A;var p;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(p||(e.TaskEventKind=p={}));var w;(function(M){M.SingleRun="singleRun",M.Background="background"})(w||(e.TaskRunType=w={}));var E;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(M){function O(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function U(ue,x,be){return{...O(ue),kind:"start",terminalId:x,resolvedVariables:be}}M.start=U;function Y(ue,x,be){return{...O(ue),kind:"processStarted",terminalId:x,processId:be}}M.processStarted=Y;function le(ue,x,be){return{...O(ue),kind:"processEnded",terminalId:x,exitCode:be}}M.processEnded=le;function Z(ue,x,be){return{...O(ue),kind:"terminated",exitReason:be,terminalId:x}}M.terminated=Z;function J(ue,x,be){return{...O(x),kind:ue,terminalId:be}}M.general=J;function X(){return{kind:"changed"}}M.changed=X})(P||(e.TaskEvent=P={}));var F;(function(M){function O(Y){const le=Object.keys(Y).sort();let Z="";for(const J of le){let X=Y[J];X instanceof Object?X=O(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Z+=J+","+X+","}return Z}function U(Y){const Z={_key:O(Y),type:Y.taskType};return Object.assign(Z,Y),Z}M.create=U})(F||(e.KeyedTaskIdentifier=F={}));var z;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var N;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var j;(function(M){function O(U,Y){const le=b.$xG.get(U.type);if(le===void 0){const ue=I.$vn(U);return delete ue._key,F.create(ue)}const Z=Object.create(null);Z.type=le.taskType;const J=new Set;le.required.forEach(ue=>J.add(ue));const X=le.properties;for(const ue of Object.keys(X)){const x=U[ue];if(x!=null)Z[ue]=x;else if(J.has(ue)){const be=X[ue];if(be.default!==void 0)Z[ue]=I.$vn(be.default);else switch(be.type){case"boolean":Z[ue]=!1;break;case"number":case"integer":Z[ue]=0;break;case"string":Z[ue]="";break;default:Y.error(D.localize(2,null,JSON.stringify(U,void 0,0),ue));return}}}return F.create(Z)}M.createTaskIdentifier=O})(j||(e.TaskDefinition=j={}))}),define(ke[296],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$u8b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$v8b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Qv=D;const T=[];function g(b){const $=new D(b);return T[$.nid]=$,$}e.$Rv=g;function I(b){return T[b].sid}e.$Sv=I;class R{constructor($){this.value=$}}e.$Tv=R}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.$0K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var L;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$9K=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$0K={MainThreadAuthentication:(0,D.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Rv)("MainThreadCommands"),MainThreadComments:(0,D.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Rv)("MainThreadSCM"),MainThreadSearch:(0,D.$Rv)("MainThreadSearch"),MainThreadShare:(0,D.$Rv)("MainThreadShare"),MainThreadTask:(0,D.$Rv)("MainThreadTask"),MainThreadWindow:(0,D.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Rv)("MainThreadInteractive"),MainThreadChat:(0,D.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Rv)("MainThreadIssueReporter")},e.$$K={ExtHostCommands:(0,D.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Rv)("ExtHostSCM"),ExtHostSearch:(0,D.$Rv)("ExtHostSearch"),ExtHostTask:(0,D.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Rv)("ExtHostProgress"),ExtHostComments:(0,D.$Rv)("ExtHostComments"),ExtHostSecretState:(0,D.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Rv)("ExtHostStorage"),ExtHostUrls:(0,D.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Rv)("ExtHostIssueReporter")}}),define(ke[92],Se([1,0,5,13,6,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0,e.$hgc=(0,D.$6h)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$0K.MainThreadTelemetry)}report($,y,L){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$igc=R,e.$igc=R=Ge([Ve(0,I.$bN),Ve(1,T.$nj)],R),e.$jgc=Object.freeze(new class{report(b,$,y){}})}),define(ke[297],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class T{constructor(I){const R=I.getProxy(D.$0K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$sgc=T}),define(ke[298],Se([1,0,24,6,27,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;let R=class{constructor(L,C){this.a=L.getProxy(T.$0K.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,C){const m=this,v=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){m.e(L,C,v,arguments)}})}e(L,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(L,m,v)}};e.$jic=R,e.$jic=R=Ge([Ve(0,I.$bN),Ve(1,g.$rN)],R);const b=1e5;function $(y,L){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}C.push(v)}if(L){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$An)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[299],Se([1,0,2,6,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class I{constructor(b){this.a=b.getProxy(T.$0K.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$CF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$nhc=I}),define(ke[300],Se([1,0,3,6]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(T.$0K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Ihc=g}),define(ke[114],Se([1,0,10,12,2,5,13,6,27,20]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;let L=class{constructor(m,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(b.$0K.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:S,args:l,comment:f}=v;if(this.c)return(0,T.$Le)(S,l??{});let o=S;f&&f.length>0&&(o+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$Le)(i??S,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(S),f=JSON.parse(l);v=m.isBuiltin?f.contents?.bundle:f}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${l.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:S})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$8gc=L,e.$8gc=L=Ge([Ve(0,$.$rN),Ve(1,y.$bN),Ve(2,R.$nj)],L),e.$9gc=(0,I.$6h)("IExtHostLocalizationService")}),define(ke[145],Se([1,0,13,6,27,20,2,55]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;let $=class extends D.$yj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$Ch)(v))),this.r=C.getProxy(T.$0K.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$iic=$,e.$iic=$=Ge([Ve(0,I.$bN),Ve(1,g.$rN)],$);class y extends D.$tj{constructor(C,m,v,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[115],Se([1,0,6,5,3,20,22]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,T.$6h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$0K.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),S=new g.$Sc;return this.d.set(m,new y(m,v,S)),S.add((0,g.$Rc)(()=>this.d.delete(m))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(v.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),S.dispose()})),S.add(v.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,R.$je.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$$gc=b,e.$$gc=b=Ge([Ve(0,I.$bN)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Tc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(ke[301],Se([1,0,6,13,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;function I(b){return b&&b.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$0K.MainThreadMessageService)}showMessage($,y,L,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,S=m),v.useCustom&&(0,g.$CF)($,"resolvers");const l=[];let f=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")l.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;l.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,L,v,l).then(o=>{if(typeof o=="number")return S[o]})}};e.$Khc=R,e.$Khc=R=Ge([Ve(1,T.$nj)],R)}),define(ke[302],Se([1,0,3,18,2,25,6]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(R.$0K.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,L,C){if((0,I.$CF)(y,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,C),this.a.$registerProfileContentHandler(L,C.name,C.description,y.identifier.value),(0,D.$Rc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(y,L,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(L,C,m)}async $readProfile(y,L,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,T.$If)(L)?L:g.URI.revive(L),C)}}e.$Thc=b}),define(ke[116],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=void 0;class I{constructor(b){this.b=new T.$Vd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$0K.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$5gc=I,e.$6gc=(0,g.$6h)("IExtHostSecretState")}),define(ke[303],Se([1,0,21,3,6]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$0K.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const L=new T.$Sc,C=new D.$6d;this.d.set($,C);const m=L.add(y.provideSpeechToTextSession(C.token));L.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const L=I.a++;return this.c.set(L,y),this.b.$registerProvider(L,$,{extension:b,displayName:b.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$1hc=I}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;class I{constructor(b,$){this.c=$,this.b=new T.$Vd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$0K.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const L=await this.a.$initializeExtensionStorage(b,$);let C;return L&&(C=this.d(b,$,L)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const L=this.d(b,$,y);L&&this.b.fire({shared:b,key:$,value:L})}d(b,$,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${L}`)}}}e.$Wgc=I,e.$Xgc=(0,g.$6h)("IExtHostStorage")}),define(ke[304],Se([1,0,3,16,2,6]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$0K.MainThreadUriOpeners)}registerExternalUriOpener($,y,L,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!R.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,L)}async $openUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},L)}}e.$cic=R}),define(ke[305],Se([1,0,6,2,3,14,26]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class b{static{this.a=0}constructor(y){this.c=new R.$mm,this.d=new Map,this.b=y.getProxy(D.$0K.MainThreadUrls)}registerUriHandler(y,L){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,L),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Rc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,L){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(L))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$dic=b}),define(ke[93],Se([1,0,4,3,16,24,2,237,274,112,6]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;class C{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(n,c,t,u,s,h,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Vd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=c,this.#s=t,this.#o=u,this.#n=s,this.#r=h,this.#l=m(h),this.#d=v(h),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,y.$Dvb)(n,this.#o)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===g.Schemas.https||n.scheme===g.Schemas.http){let c=n.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$Cvb}return y.$Cvb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#s}set options(n){this.a(),I.$zn(this.#s,n)||this.#t.$setOptions(this.#e,f(this.#r,this.#n,n)),this.#s=n}async postMessage(n){if(this.#c)return!1;const c=(0,$.$hlb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const c=this.#r.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,h,a,d,k)=>{const A=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),p=(0,y.$Dvb)(A,{isRemote:c,authority:t}).toString();return`${s}${p}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,h,a,d,k)=>{const A=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),p=(0,y.$Dvb)(A,{isRemote:c,authority:t}).toString();return`${s}${p}${k}`})}}e.$Hgc=C;function m(r){try{const n=(0,b.$cp)((0,b.$bp)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$Igc=m;function v(r){try{const n=(0,b.$cp)((0,b.$bp)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends T.$Tc{constructor(n,c,t,u,s){super(),this.c=c,this.f=t,this.g=u,this.h=s,this.b=new Map,this.a=n.getProxy(L.$0K.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,c,t){const u=this.j(n);if(u){const{message:s}=(0,$.$ilb)(c,t.value);u._onMessageEmitter.fire(s)}}$onMissingCsp(n,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,c,t){const u=new C(n,this.a,o(c),this.c,this.f,t,this.h);this.b.set(n,u);const s=u._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Jgc=S;function l(r){return{id:r.identifier,location:r.extensionLocation}}e.$Kgc=l;function f(r,n,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(r,n)}}e.$Lgc=f;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>R.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(c=>c.uri),r.extensionLocation]}}),define(ke[146],Se([1,0,4,6,2,16,12,5,20,25]),function(me,e,D,T,g,I,R,b,$,y){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0;let C=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$CF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new D.$Vd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=v.getProxy(T.$0K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:l})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let l;if(typeof v=="string"){l=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Je)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,l,S)}async asExternalUri(v,S){if((0,R.$Je)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(v,S);return g.URI.from(l)}};e.$fic=C,e.$fic=C=L=Ge([Ve(0,$.$bN)],C),e.$gic=(0,b.$6h)("IExtHostWindow")}),define(ke[306],Se([1,0,298,27,20]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;const I=1024*1024;let R=class extends D.$jic{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,L){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,L),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const L=process[$],C=L.write;let m="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(v,S,l)=>{if(!this.g){m+=v.toString(S);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(L,v,S,l)}})}};e.$Uic=R,e.$Uic=R=Ge([Ve(0,g.$bN),Ve(1,T.$rN)],R)}),define(ke[307],Se([1,0,145,16,251,30]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class R extends D.$iic{s($,y,L){return $.scheme===T.Schemas.file?new g.$nO(L?.name||(0,I.$qg)(),$.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.s($,y,L)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$7ic=R}),define(ke[308],Se([1,0,11,22,21,14,4,3,130,296,68]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.ResponsiveState=e.RequestInitiator=e.$x8b=e.$w8b=void 0;function m(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class l{constructor(P,F){this.jsonString=P,this.referencedBuffers=F}}function f(E,P=null,F=!1){const z=[];return{jsonString:(F?m:JSON.stringify)(E,(j,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof T.$je){const O=z.push(M)-1;return{[v]:O}}if(P)return P(j,M)}return M}),referencedBuffers:z}}e.$w8b=f;function o(E,P,F){return JSON.parse(E,(z,N)=>{if(N){const j=N[v];if(typeof j=="number")return P[j];if(F&&N.$mid===1)return F.transformIncoming(N)}return N})}e.$x8b=o;function i(E,P){return JSON.stringify(E,P)}function r(E){return E?(P,F)=>F&&F.$mid===1?E.transformOutgoing(F):F:null}var n;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var c;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class h extends b.$Tc{static{C=u}static{this.a=3*1e3}constructor(P,F=null,z=null){super(),this[C]=!0,this.b=this.B(new R.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=F,this.g=z,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,j=L.$Qv.count;N<j;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$fh(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const F=this.w[P];delete this.w[P],F.resolveErr(I.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$7m)(P,this.g):P}getProxy(P){const{nid:F,sid:z}=P;return this.s[F]||(this.s[F]=this.J(F,z)),this.s[F]}J(P,F){const z={get:(N,j)=>(typeof j=="string"&&!N[j]&&j.charCodeAt(0)===36&&(N[j]=(...M)=>this.U(P,j,M)),j===s?F:N[j])};return new Proxy(Object.create(null),z)}set(P,F){return this.m[P.nid]=F,F}assertRegistered(P){for(let F=0,z=P.length;F<z;F++){const N=P[F];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(P){if(this.j)return;const F=P.byteLength,z=d.read(P,0),N=z.readUInt8(),j=z.readUInt32();switch(N){case 1:case 2:{let{rpcId:M,method:O,args:U}=A.deserializeRequestJSONArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(F,j,M,O,U,N===2);break}case 3:case 4:{let{rpcId:M,method:O,args:U}=A.deserializeRequestMixedArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(F,j,M,O,U,N===4);break}case 5:{this.f?.logIncoming(F,j,0,"ack"),this.G(j);break}case 6:{this.N(F,j);break}case 7:{this.O(F,j,void 0);break}case 9:{let M=A.deserializeReplyOKJSON(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.O(F,j,M);break}case 10:{const M=A.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(F,j,M);break}case 8:{const M=A.deserializeReplyOKVSBuffer(z);this.O(F,j,M);break}case 11:{let M=A.deserializeReplyErrError(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.P(F,j,M);break}case 12:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,F,z,N,j,M){this.f?.logIncoming(P,F,1,`receiveRequest ${(0,L.$Sv)(z)}.${N}(`,j);const O=String(F);let U,Y;if(M){const Z=new g.$6d;j.push(Z.token),U=this.Q(z,N,j),Y=()=>Z.cancel()}else U=this.Q(z,N,j),Y=t;this.u[O]=Y;const le=A.serializeAcknowledged(F);this.f?.logOutgoing(le.byteLength,F,1,"ack"),this.c.send(le),U.then(Z=>{delete this.u[O];const J=A.serializeReplyOK(F,Z,this.h);this.f?.logOutgoing(J.byteLength,F,1,"reply:",Z),this.c.send(J)},Z=>{delete this.u[O];const J=A.serializeReplyErr(F,Z);this.f?.logOutgoing(J.byteLength,F,1,"replyErr:",Z),this.c.send(J)})}N(P,F){this.f?.logIncoming(P,F,1,"receiveCancel");const z=String(F);this.u[z]?.()}O(P,F,z){this.f?.logIncoming(P,F,0,"receiveReply:",z);const N=String(F);if(!this.w.hasOwnProperty(N))return;const j=this.w[N];delete this.w[N],j.resolveOk(z)}P(P,F,z){this.f?.logIncoming(P,F,0,"receiveReplyErr:",z);const N=String(F);if(!this.w.hasOwnProperty(N))return;const j=this.w[N];delete this.w[N];let M;z&&(z.$isError?(M=new Error,M.name=z.name,M.message=z.message,M.stack=z.stack):M=z),j.resolveErr(M)}Q(P,F,z){try{return Promise.resolve(this.S(P,F,z))}catch(N){return Promise.reject(N)}}S(P,F,z){const N=this.m[P];if(!N)throw new Error("Unknown actor "+(0,L.$Sv)(P));const j=N[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.$Sv)(P));return j.apply(N,z)}U(P,F,z){if(this.j)return new y.$v8b;let N=null;if(z.length>0&&g.CancellationToken.isCancellationToken(z[z.length-1])&&(N=z.pop()),N&&N.isCancellationRequested)return Promise.reject(I.$6());const j=A.serializeRequestArguments(z,this.h),M=++this.t,O=String(M),U=new y.$u8b,Y=new b.$Sc;N&&Y.add(N.onCancellationRequested(()=>{const Z=A.serializeCancel(M);this.f?.logOutgoing(Z.byteLength,M,0,"cancel"),this.c.send(A.serializeCancel(M))})),this.w[O]=new a(U,Y),this.F(M);const le=A.serializeRequest(M,P,F,j,!!N);return this.f?.logOutgoing(le.byteLength,M,0,`request: ${(0,L.$Sv)(P)}.${F}(`,z),this.c.send(le),U}}e.$y8b=h;class a{constructor(P,F){this.a=P,this.b=F}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,F,z){const N=new d(T.$je.alloc(z+1+4),0);return N.writeUInt8(P),N.writeUInt32(F),N}static read(P,F){return new d(P,F)}get buffer(){return this.a}constructor(P,F){this.a=P,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P);return this.b+=P,F}static sizeMixedArray(P){let F=0;F+=1;for(let z=0,N=P.length;z<N;z++){const j=P[z];switch(F+=1,j.type){case 1:F+=this.sizeLongString(j.value);break;case 2:F+=this.sizeVSBuffer(j.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let M=0;M<j.buffers.length;++M)F+=this.sizeVSBuffer(j.buffers[M]);break;case 4:break}}return F}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let F=0,z=P.length;F<z;F++){const N=P[F];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let j=0;j<N.buffers.length;++j)this.writeBuffer(N.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const F=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:F[z]=this.readLongString();break;case 2:F[z]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),M=this.readLongString(),O=[];for(let U=0;U<j;++U)O.push(this.readVSBuffer());F[z]=new L.$Tv(o(M,O,null));break}case 4:F[z]=void 0;break}return F}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class A{static a(P){for(let F=0,z=P.length;F<z;F++)if(P[F]instanceof T.$je||P[F]instanceof L.$Tv||typeof P[F]>"u")return!0;return!1}static serializeRequestArguments(P,F){if(this.a(P)){const z=[];for(let N=0,j=P.length;N<j;N++){const M=P[N];if(M instanceof T.$je)z[N]={type:2,value:M};else if(typeof M>"u")z[N]={type:4};else if(M instanceof L.$Tv){const{jsonString:O,referencedBuffers:U}=f(M.value,F);z[N]={type:3,value:T.$je.fromString(O),buffers:U}}else z[N]={type:1,value:T.$je.fromString(i(M,F))}}return{type:1,args:z}}return{type:0,args:i(P,F)}}static serializeRequest(P,F,z,N,j){switch(N.type){case 0:return this.b(P,F,z,N.args,j);case 1:return this.c(P,F,z,N.args,j)}}static b(P,F,z,N,j){const M=T.$je.fromString(z),O=T.$je.fromString(N);let U=0;U+=d.sizeUInt8(),U+=d.sizeShortString(M),U+=d.sizeLongString(O);const Y=d.alloc(j?2:1,P,U);return Y.writeUInt8(F),Y.writeShortString(M),Y.writeLongString(O),Y.buffer}static deserializeRequestJSONArgs(P){const F=P.readUInt8(),z=P.readShortString(),N=P.readLongString();return{rpcId:F,method:z,args:JSON.parse(N)}}static c(P,F,z,N,j){const M=T.$je.fromString(z);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(M),O+=d.sizeMixedArray(N);const U=d.alloc(j?4:3,P,O);return U.writeUInt8(F),U.writeShortString(M),U.writeMixedArray(N),U.buffer}static deserializeRequestMixedArgs(P){const F=P.readUInt8(),z=P.readShortString(),N=P.readMixedArray(),j=new Array(N.length);for(let M=0,O=N.length;M<O;M++){const U=N[M];typeof U=="string"?j[M]=JSON.parse(U):j[M]=U}return{rpcId:F,method:z,args:j}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,F,z){if(typeof F>"u")return this.d(P);if(F instanceof T.$je)return this.e(P,F);if(F instanceof L.$Tv){const{jsonString:N,referencedBuffers:j}=f(F.value,z,!0);return this.g(P,N,j)}else return this.f(P,m(F,z))}static d(P){return d.alloc(7,P,0).buffer}static e(P,F){let z=0;z+=d.sizeVSBuffer(F);const N=d.alloc(8,P,z);return N.writeVSBuffer(F),N.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,F){const z=T.$je.fromString(F);let N=0;N+=d.sizeLongString(z);const j=d.alloc(9,P,N);return j.writeLongString(z),j.buffer}static g(P,F,z){const N=T.$je.fromString(F);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(N);for(const O of z)j+=d.sizeVSBuffer(O);const M=d.alloc(10,P,j);M.writeUInt32(z.length),M.writeLongString(N);for(const O of z)M.writeBuffer(O);return M.buffer}static deserializeReplyOKJSON(P){const F=P.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(P,F){const z=P.readUInt32(),N=P.readLongString(),j=[];for(let M=0;M<z;++M)j.push(P.readVSBuffer());return new L.$Tv(o(N,j,F))}static serializeReplyErr(P,F){const z=F?m(I.$3(F),null):void 0;if(typeof z!="string")return this.h(P);const N=T.$je.fromString(z);let j=0;j+=d.sizeLongString(N);const M=d.alloc(11,P,j);return M.writeLongString(N),M.buffer}static deserializeReplyErrError(P){const F=P.readLongString();return JSON.parse(F)}static h(P){return d.alloc(12,P,0).buffer}}var p;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var w;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(w||(w={}))}),define(ke[309],Se([1,0,22,28,16,84,5]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=void 0,e.$UI=(0,R.$6h)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),y=7;function L(v){if(v.scheme!==g.Schemas.vscodeNotebookCell)return;const S=v.fragment.indexOf("s");if(S<0)return;const l=parseInt(v.fragment.substring(0,S).replace($,""),y),f=(0,D.$Ce)(v.fragment.substring(S+1)).toString();if(!isNaN(l))return{handle:l,notebook:v.with({scheme:f,fragment:null})}}e.$VI=L;function C(v,S){const l=S.toString(y),o=`${l.length<b.length?b[l.length-1]:"z"}${l}s${(0,D.$De)(D.$je.fromString(v.scheme),!0,!0)}`;return v.with({scheme:g.Schemas.vscodeNotebookCell,fragment:o})}e.$WI=C;class m{constructor(){this.a=new T.$Ac}getNotebook(S){if(S.scheme===g.Schemas.vscodeNotebookCell){const l=L(S);if(l){const f=this.a.get(l.notebook);if(f)return f}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$XI=m,(0,I.$Yr)(e.$UI,m,1)}),define(ke[118],Se([1,0,22,34,53,101,16,17,10,45,309]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellStatusbarAlignment=e.$_I=e.$$I=e.$0I=e.NotebookEditorPriority=e.$9I=e.$8I=e.$7I=e.$6I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$5I=e.$4I=e.$3I=e.$2I=e.CellKind=e.$1I=e.$ZI=e.$YI=void 0,e.$YI="workbench.editor.notebook",e.$ZI="workbench.editor.notebookTextDiffEditor",e.$1I="workbench.editor.interactive";var C;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(C||(e.CellKind=C={})),e.$2I=["application/json","application/javascript","text/html","image/svg+xml",I.$fs.latex,I.$fs.markdown,"image/png","image/jpeg",I.$fs.text],e.$3I=[I.$fs.latex,I.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$fs.text],e.$4I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$5I="_notAvailable";var m;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var l;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var f;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(U){U.scheme=R.Schemas.vscodeNotebookCell;function Y(x,be){return(0,L.$WI)(x,be)}U.generate=Y;function le(x){return(0,L.$VI)(x)}U.parse=le;function Z(x,be){return x.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${be??""},${x.scheme!==R.Schemas.file?x.scheme:""}`})}U.generateCellOutputUri=Z;function J(x){if(x.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const be=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!be)return;const ce=be[1]&&be[1]!==""?be[1]:void 0,K=be[2];return{outputId:ce,notebook:x.with({scheme:K||R.Schemas.file,fragment:null})}}U.parseCellOutputUri=J;function X(x,be,ce){return U.generate(x,be).with({scheme:ce})}U.generateCellPropertyUri=X;function ue(x,be){if(x.scheme===be)return U.parse(x.with({scheme:U.scheme}))}U.parseCellPropertyUri=ue})(n||(e.CellUri=n={}));const c=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(Y=[],le=e.$2I){this.e=le,this.d=[...new Set(Y)].map(Z=>({pattern:Z,matches:T.$Mj(c(Z))}))}sort(Y){const le=new Map(g.Iterable.map(Y,J=>[J,c(J)]));let Z=[];for(const{matches:J}of this.d)for(const[X,ue]of le)if(J(ue)){Z.push(X),le.delete(X);break}return le.size&&(Z=Z.concat([...le.keys()].sort((J,X)=>this.e.indexOf(J)-this.e.indexOf(X)))),Z}prioritize(Y,le){const Z=this.f(Y);if(Z===-1){this.d.unshift({pattern:Y,matches:T.$Mj(c(Y))});return}const J=new Set(le.map(ue=>this.f(ue,Z)));J.delete(-1);const X=Array.from(J).sort();this.d.splice(Z+1,0,...X.map(ue=>this.d[ue]));for(let ue=X.length-1;ue>=0;ue--)this.d.splice(X[ue],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,le=this.d.length){const Z=c(Y);for(let J=0;J<le;J++)if(this.d[J].matches(Z))return J;return-1}}e.$6I=t;function u(U,Y,le,Z=(J,X)=>J===X){const J=[];function X(be,ce,K){if(ce===0&&K.length===0)return;const V=J[J.length-1];V&&V.start+V.deleteCount===be?(V.deleteCount+=ce,V.toInsert.push(...K)):J.push({start:be,deleteCount:ce,toInsert:K})}let ue=0,x=0;for(;;){if(ue===U.length){X(ue,0,Y.slice(x));break}if(x===Y.length){X(ue,U.length-ue,[]);break}const be=U[ue],ce=Y[x];if(Z(be,ce)){ue+=1,x+=1;continue}le(ce)?(X(ue,1,[]),ue+=1):(X(ue,0,[ce]),x+=1)}return J}e.$7I=u,e.$8I=new y.$kj("notebookEditorCursorAtBoundary","none"),e.$9I=new y.$kj("notebookEditorCursorAtLineBoundary","none");var s;(function(U){U.default="default",U.option="option"})(s||(e.NotebookEditorPriority=s={}));function h(U){const Y=U;return!!((typeof Y.include=="string"||T.$Nj(Y.include))&&(typeof Y.exclude=="string"||T.$Nj(Y.exclude)))}e.$0I=h;function a(U,Y,le){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Y)>=0||U.viewType===Y)return!0;if(U.filenamePattern){const Z=h(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,J=h(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(T.$Lj(Z,(0,b.$nc)(le.fsPath).toLowerCase()))return!(J&&T.$Lj(J,(0,b.$nc)(le.fsPath).toLowerCase()))}return!1}e.$$I=a,e.$_I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var d;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class k{static{this.d="notebook/"}static create(Y){return`${k.d}${Y}`}static parse(Y){if(Y.startsWith(k.d))return Y.substring(k.d.length)}}e.$aJ=k;function A(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$bJ=A;const p=new TextDecoder;function w(U){const Y=[];let le=!1;for(const ue of U)(Y.length===0||le)&&(Y.push(ue),le=!0);let Z=F(Y);const J=D.$je.concat(Y.map(ue=>D.$je.wrap(ue))),X=O(J);return Z=Z||X.byteLength!==J.byteLength,{data:X,didCompression:Z}}e.$cJ=w,e.$dJ=`${String.fromCharCode(27)}[A`;const E=e.$dJ.split("").map(U=>U.charCodeAt(0)),P=10;function F(U){let Y=!1;return U.forEach((le,Z)=>{if(Z===0||le.length<e.$dJ.length)return;const J=U[Z-1],X=le.subarray(0,e.$dJ.length);if(X[0]===E[0]&&X[1]===E[1]&&X[2]===E[2]){const ue=J.lastIndexOf(P);if(ue===-1)return;Y=!0,U[Z-1]=J.subarray(0,ue),U[Z]=le.subarray(e.$dJ.length)}}),Y}function z(U){let Y=U;do U=Y,Y=U.replace(/[^\n]\x08/gm,"");while(Y.length<U.length);return U}function N(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Y=U.match(/^(.*)\r+/m)[1];let le=U.match(/\r+(.*)$/m)[1];le=le+Y.slice(le.length,Y.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return U}const j="\b".charCodeAt(0),M="\r".charCodeAt(0);function O(U){return!U.buffer.includes(j)&&!U.buffer.includes(M)?U:D.$je.fromString(N(z(p.decode(U.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,101,12,18,2,30,26,32,64,118]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";var l,f,o,i,r,n,c,t,u,s,h,a,d,k,A,p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$3M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$2M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestRunProfileKind=e.TestResultState=e.$HM=e.$GM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$FM=e.NotebookVariablesRequestKind=e.$EM=e.$DM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$CM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.ColorThemeKind=e.$wM=e.$vM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$uM=e.DebugConsoleMode=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$oM=e.$nM=e.FileChangeType=e.$mM=e.$lM=e.$kM=e.$jM=e.InlineCompletionTriggerKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.ConfigurationTarget=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YL=e.ViewBadge=e.ProgressLocation=e.$XL=e.$WL=e.TaskScope=e.ShellQuoting=e.$VL=e.$UL=e.$TL=e.TaskPanelKind=e.TaskRevealKind=e.$SL=e.TerminalLocation=e.$RL=e.$QL=e.$PL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OL=e.$NL=e.$ML=e.$LL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KL=e.StatusBarAlignment=e.ViewColumn=e.$JL=e.$IL=e.$HL=e.$GL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FL=e.$EL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.LanguageStatusSeverity=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CodeActionTriggerKind=e.$sL=e.$rL=e.SymbolTag=e.SymbolKind=e.$qL=e.$pL=e.DocumentHighlightKind=e.$oL=e.$nL=e.$mL=e.$lL=e.DiagnosticSeverity=e.DiagnosticTag=e.$kL=e.$jL=e.FileEditType=e.$iL=e.$hL=e.$gL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Me=pe.length===1?[]:pe[1];return Reflect.construct(H,Me,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Me,...Ze]=pe;return Reflect.construct(H,Ze,Me.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var F;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let z=l=class{static from(...W){let pe=W;return new l(function(){if(pe){for(const Me of pe)Me&&typeof Me.dispose=="function"&&Me.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_K=z,e.$_K=z=l=Ge([E],z);let N=f=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Me=1;Me<W.length;Me++){const Ze=W[Me];Ze.isBefore(pe)&&(pe=Ze)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Me=1;Me<W.length;Me++){const Ze=W[Me];Ze.isAfter(pe)&&(pe=Ze)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof f)return!0;const{line:pe,character:Me}=W;return typeof pe=="number"&&typeof Me=="number"}static of(W){if(W instanceof f)return W;if(this.isPosition(W))return new f(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("line must be non-negative");if(pe<0)throw(0,T.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,T.$7)();let Me;return typeof W>"u"?Me=0:typeof W=="number"?Me=W:(Me=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Me===0&&pe===0?this:new f(this.line+Me,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,T.$7)();let Me;return typeof W>"u"?Me=this.line:typeof W=="number"?Me=W:(Me=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Me===this.line&&pe===this.character?this:new f(Me,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$aL=N,e.$aL=N=f=Ge([E],N);let j=o=class{static isRange(W){return W instanceof o?!0:W?N.isPosition(W.start)&&N.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Me,Ze){let tt,lt;if(typeof W=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new N(W,pe),lt=new N(Me,Ze)):N.isPosition(W)&&N.isPosition(pe)&&(tt=N.of(W),lt=N.of(pe)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):N.isPosition(W)?!(N.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=N.Max(W.start,this.c),Me=N.Min(W.end,this.e);if(!pe.isAfter(Me))return new o(pe,Me)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=N.Min(W.start,this.c),Me=N.Max(W.end,this.end);return new o(pe,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,T.$7)();let Me;return W?N.isPosition(W)?Me=W:(Me=W.start||this.start,pe=W.end||this.end):Me=this.start,Me.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Me,pe)}toJSON(){return[this.start,this.end]}};e.$bL=j,e.$bL=j=o=Ge([E],j);let M=i=class extends j{static isSelection(W){return W instanceof i?!0:W?j.isRange(W)&&N.isPosition(W.anchor)&&N.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Me,Ze){let tt,lt;if(typeof W=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new N(W,pe),lt=new N(Me,Ze)):N.isPosition(W)&&N.isPosition(pe)&&(tt=N.of(W),lt=N.of(pe)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cL=M,e.$cL=M=i=Ge([E],M);const O=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,T.$7)("connectionToken")};class U{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Me){if(typeof W!="string"||W.length===0)throw(0,T.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$7)("port");typeof Me<"u"&&O(Me),this.host=W,this.port=Math.round(pe),this.connectionToken=Me}}e.$dL=U;class Y{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&O(pe)}}e.$eL=Y;class le extends Error{static NotAvailable(W,pe){return new le(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new le(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=v.RemoteAuthorityResolverErrorCode.Unknown,Me){super(W),this._message=W,this._code=pe,this._detail=Me,Object.setPrototypeOf(this,le.prototype)}}e.$fL=le;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let X=r=class{static isTextEdit(W){return W instanceof r?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new r(W,pe)}static insert(W,pe){return r.replace(new j(W,W),pe)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const pe=new r(new j(new N(0,0),new N(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,T.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gL=X,e.$gL=X=r=Ge([E],X);let ue=n=class{static isNotebookCellEdit(W){return W instanceof n?!0:W?ei.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new n(W,pe)}static insertCells(W,pe){return new n(new ei(W,W),pe)}static deleteCells(W){return new n(W,[])}static updateCellMetadata(W,pe){const Me=new n(new ei(W,W),[]);return Me.newCellMetadata=pe,Me}static updateNotebookMetadata(W){const pe=new n(new ei(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$hL=ue,e.$hL=ue=n=Ge([E],ue);class x{static isSnippetTextEdit(W){return W instanceof x?!0:W?j.isRange(W.range)&&K.isSnippetString(W.snippet):!1}static replace(W,pe){return new x(W,pe)}static insert(W,pe){return x.replace(new j(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$iL=x;var be;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Me,Ze){this.c.push({_type:1,from:W,to:pe,options:Me,metadata:Ze})}createFile(W,pe,Me){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Me})}deleteFile(W,pe,Me){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Me})}e(W,pe,Me){this.c.push({_type:3,metadata:Me,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Me,Ze){const tt=pe.start,lt=pe.end;(tt!==lt||Me.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:lt-tt,cells:Me,metadata:Ze})}g(W,pe,Me,Ze){this.c.push({_type:3,metadata:Ze,uri:W,edit:{editType:3,index:pe,metadata:Me}})}replace(W,pe,Me,Ze){this.c.push({_type:2,uri:W,edit:new X(pe,Me),metadata:Ze})}insert(W,pe,Me,Ze){this.replace(W,new j(pe,pe),Me,Ze)}delete(W,pe,Me){this.replace(W,pe,"",Me)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Me of pe){if(!Me)continue;let Ze,tt;Array.isArray(Me)?(Ze=Me[0],tt=Me[1]):Ze=Me,ue.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(W,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(W,Ze.newNotebookMetadata,tt):this.f(W,Ze.range,Ze.newCells,tt):x.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:W,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ze,metadata:tt})}else{for(let Me=0;Me<this.c.length;Me++){const Ze=this.c[Me];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===W.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(W){const pe=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===W.toString()&&pe.push(Me.edit);return pe}entries(){const W=new I.$Ac;for(const pe of this.c)if(pe._type===2){let Me=W.get(pe.uri);Me||(Me=[pe.uri,[]],W.set(pe.uri,Me)),Me[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jL=ce,e.$jL=ce=Ge([E],ce);let K=c=class{static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=c.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Me=new c;Me.e=this.e,W(Me),this.e=Me.e,W=Me.value}else W=c.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Me=W.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Me=new c;Me.e=this.e,pe(Me),this.e=Me.e,pe=Me.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$kL=K,e.$kL=K=c=Ge([E],K);var V;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var re;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&y.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(j.isRange(pe))this.range=j.of(pe);else if(N.isPosition(pe))this.range=new j(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lL=ye,e.$lL=ye=t=Ge([E],ye);let de=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&y.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$mL=de,e.$mL=de=Ge([E],de);let ge=class{constructor(W,pe,Me=re.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Me}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,D.$ub)(W.tags,pe.tags)&&(0,D.$ub)(W.relatedInformation,pe.relatedInformation,de.isEqual)}};e.$nL=ge,e.$nL=ge=Ge([E],ge);let _=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$oL=_,e.$oL=_=Ge([E],_);var te;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let G=class{constructor(W,pe=te.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$pL=G,e.$pL=G=Ge([E],G);let ie=class{constructor(W,pe){this.uri=W,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$qL=ie,e.$qL=ie=Ge([E],ie);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var ve;(function(H){H[H.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Pe=u=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Me,Ze,tt){this.name=W,this.kind=pe,this.containerName=tt,typeof Me=="string"&&(this.containerName=Me),Ze instanceof ye?this.location=Ze:Me instanceof j&&(this.location=new ye(Ze,Me)),u.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$rL=Pe,e.$rL=Pe=u=Ge([E],Pe);let we=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,pe,Me,Ze,tt){this.name=W,this.detail=pe,this.kind=Me,this.range=Ze,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$sL=we,e.$sL=we=s=Ge([E],we);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let B=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$tL=B,e.$tL=B=Ge([E],B);let Q=class{static{h=this}static{this.c="."}constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.c)}};e.$uL=Q,e.$uL=Q=h=Ge([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vL=ee,e.$vL=ee=Ge([E],ee);class q{constructor(W,pe,Me,Ze,tt,lt){this.kind=W,this.name=pe,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$wL=q;class oe{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$xL=oe;class he{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$yL=he;var Le;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$zL=je,e.$zL=je=Ge([E],je);let He=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new g.$hk(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$AL=He,e.$AL=He=a=Ge([E],He);let Je=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$BL=Je,e.$BL=Je=Ge([E],Je);let _e=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$CL=_e,e.$CL=_e=Ge([E],_e);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DL=ct,e.$DL=ct=Ge([E],ct);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Ae=class{constructor(W){this.value=W}};e.$EL=Ae,e.$EL=Ae=Ge([E],Ae);let ze=class{constructor(W,pe,Me){this.position=W,this.label=pe,this.kind=Me}};e.$FL=ze,e.$FL=ze=Ge([E],ze);var Re;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re||(e.CompletionTriggerKind=Re={}));var Xe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var ne;(function(H){H[H.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let ae=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GL=ae,e.$GL=ae=Ge([E],ae);let Ie=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$HL=Ie,e.$HL=Ie=Ge([E],Ie);let qe=class{constructor(W,pe,Me){this.insertText=W,this.range=pe,this.command=Me}};e.$IL=qe,e.$IL=qe=Ge([E],qe);let Ye=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$JL=Ye,e.$JL=Ye=Ge([E],Ye);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var it;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function Oe(H,W){return`${C.$lm.toKey(H)}.${W}`}e.$KL=Oe;var pt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(pt||(e.TextEditorLineNumbersStyle=pt={}));var St;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(St||(e.TextDocumentSaveReason=St={}));var Ft;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Vt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Kt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(H){function W(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function W(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=W}(Ot||(e.SyntaxTokenType=Ot={}));let Yt=class{constructor(W,pe){if(pe&&!y.URI.isUri(pe))throw(0,T.$7)("target");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.target=pe}};e.$LL=Yt,e.$LL=Yt=Ge([E],Yt);let zt=class{constructor(W,pe,Me,Ze){this.red=W,this.green=pe,this.blue=Me,this.alpha=Ze}};e.$ML=zt,e.$ML=zt=Ge([E],zt);let Rt=class{constructor(W,pe){if(pe&&!(pe instanceof zt))throw(0,T.$7)("color");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.color=pe}};e.$NL=Rt,e.$NL=Rt=Ge([E],Rt);let et=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$7)("label");this.label=W}};e.$OL=et,e.$OL=et=Ge([E],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class bt{constructor(W,pe,Me){if(this.startIndex=W,this.length=pe,this.tooltip=Me,typeof W!="number"||W<0)throw(0,T.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,T.$7)("tooltip")}}e.$PL=bt;class Ut{constructor(W){this.uri=W}}e.$QL=Ut;class Wt{constructor(W){this.terminalCommand=W}}e.$RL=Wt;var Dt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$7)("options")}}e.$SL=ft;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Ct=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,T.$7)("name");this.c=W}get id(){return this.c}};e.$TL=Ct,e.$TL=Ct=d=Ge([E],Ct);function Qe(H){let W="";for(let pe=0;pe<H.length;pe++)W+=H[pe].replace(/,/g,",,")+",";return W}let Tt=class{constructor(W,pe,Me){if(typeof W!="string")throw(0,T.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Me):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Qe(W)}};e.$UL=Tt,e.$UL=Tt=Ge([E],Tt);let qt=class{constructor(W,pe,Me){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,T.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W,this.f=pe,this.g=Me}else{if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Qe(W)}};e.$VL=qt,e.$VL=qt=Ge([E],qt);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Nt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.$qg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$WL=Nt;let Te=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Me,Ze,tt,lt){this.k=!1,this.l=this.definition=W;let mt;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Me,this.execution=Ze,mt=tt,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt):(this.target=pe,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Tt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof qt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Nt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,L.$qg)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=W}get scope(){return this.m}set target(W){this.A(),this.m=W}get name(){return this.n}set name(W){if(typeof W!="string")throw(0,T.$7)("name");this.A(),this.n=W}get execution(){return this.o}set execution(W){W===null&&(W=void 0),this.A(),this.o=W;const pe=this.l.type;(k.g===pe||k.e===pe||k.f===pe||k.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(W){if(Array.isArray(W))this.A(),this.q=W,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.A(),this.t=W}get source(){return this.u}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=W}get group(){return this.w}set group(W){W===null&&(W=void 0),this.A(),this.w=W}get detail(){return this.z}set detail(W){W===null&&(W=void 0),this.z=W}get presentationOptions(){return this.x}set presentationOptions(W){W==null&&(W=Object.create(null)),this.A(),this.x=W}get runOptions(){return this.y}set runOptions(W){W==null&&(W=Object.create(null)),this.A(),this.y=W}};e.$XL=Te,e.$XL=Te=k=Ge([E],Te);var Fe;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Ce;(function(H){function W(pe){const Me=pe;return(0,$.$Mf)(Me.value)?Me.tooltip&&!(0,$.$If)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=W})(Ce||(e.ViewBadge=Ce={}));let se=A=class{static isTreeItem(W,pe){const Me=W;if(Me.checkboxState!==void 0){const Ze=(0,$.$Mf)(Me.checkboxState)?Me.checkboxState:(0,$.$Kf)(Me.checkboxState)&&(0,$.$Mf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,tt=!(0,$.$Mf)(Me.checkboxState)&&(0,$.$Kf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==We.Checked&&Ze!==We.Unchecked||tt!==void 0&&!(0,$.$If)(tt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(W instanceof A)return!0;if(Me.label!==void 0&&!(0,$.$If)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$If)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$If)(Me.iconPath)&&!y.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$If)(Me.iconPath.id))){const Ze=Me.iconPath;if(!Ze||!(0,$.$If)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$If)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$If)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!y.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$If)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Ne.None&&Me.collapsibleState>Ne.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$If)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(W,pe=Ne.None){this.collapsibleState=pe,y.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$YL=se,e.$YL=se=A=Ge([E],se);var Ne;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Ne||(e.TreeItemCollapsibleState=Ne={}));var We;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(We||(e.TreeItemCheckboxState=We={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$ZL=xe,e.$ZL=xe=Ge([E],xe);class Ke extends xe{}e.$1L=Ke;class st extends Ke{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$2L=st;class $t{constructor(W,pe,Me,Ze){this.name=W,this.uri=pe,this._itemId=Me,this.c=Ze}data(){return this.c()}}e.$3L=$t;let Bt=class{#e=new Map;constructor(W){for(const[pe,Me]of W??[]){const Ze=this.#e.get(this.#t(pe));Ze?Ze.push(Me):this.#e.set(this.#t(pe),[Me])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Me,Ze]of this.#e)for(const tt of Ze)W.call(pe,tt,Me,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Me of pe)yield[W,Me]}#t(W){return W.toLowerCase()}};e.$4L=Bt,e.$4L=Bt=Ge([E],Bt);let kt=class{constructor(W){this.insertText=W}};e.$5L=kt,e.$5L=kt=Ge([E],kt);let It=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$6L=It,e.$6L=It=Ge([E],It);let yt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$7L=yt,e.$7L=yt=Ge([E],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let gi=class{constructor(W){this.id=W}};e.$8L=gi,e.$8L=gi=Ge([E],gi);var Lt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Lt||(e.ConfigurationTarget=Lt={}));let Di=class{get base(){return this.c}set base(W){this.c=W,this.e=y.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!y.URI.isUri(W)&&!y.URI.isUri(W.uri)))throw(0,T.$7)("base");if(typeof pe!="string")throw(0,T.$7)("pattern");typeof W=="string"?this.baseUri=y.URI.file(W):y.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9L=Di,e.$9L=Di=Ge([E],Di);const Gi=new WeakMap;function Pt(H,W){Gi.set(H,W)}e.$0L=Pt;let ri=class{constructor(W,pe,Me,Ze){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Me=="string"&&(this.hitCondition=Me),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Gi.get(this)??(0,L.$qg)()),this.c}};e.$$L=ri,e.$$L=ri=Ge([E],ri);let mi=class extends ri{constructor(W,pe,Me,Ze,tt){if(super(pe,Me,Ze,tt),W===null)throw(0,T.$7)("location");this.location=W}};e.$_L=mi,e.$_L=mi=Ge([E],mi);let ci=class extends ri{constructor(W,pe,Me,Ze,tt){super(pe,Me,Ze,tt),this.functionName=W}};e.$aM=ci,e.$aM=ci=Ge([E],ci);let Ci=class extends ri{constructor(W,pe,Me,Ze,tt,lt,mt){if(super(Ze,tt,lt,mt),!pe)throw(0,T.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Me}};e.$bM=Ci,e.$bM=Ci=Ge([E],Ci);let Ii=class{constructor(W,pe,Me){this.command=W,this.args=pe||[],this.options=Me}};e.$cM=Ii,e.$cM=Ii=Ge([E],Ii);let jt=class{constructor(W,pe){this.port=W,this.host=pe}};e.$dM=jt,e.$dM=jt=Ge([E],jt);let $i=class{constructor(W){this.path=W}};e.$eM=$i,e.$eM=$i=Ge([E],$i);let Pi=class{constructor(W){this.implementation=W}};e.$fM=Pi,e.$fM=Pi=Ge([E],Pi);let ui=class{constructor(W,pe,Me){this.session=W,this.threadId=pe,this.frameId=Me}};e.$gM=ui,e.$gM=ui=Ge([E],ui);let li=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$hM=li,e.$hM=li=Ge([E],li);let dt=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$iM=dt,e.$iM=dt=Ge([E],dt);var Ji;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(W,pe){this.range=W,this.text=pe}};e.$jM=_t,e.$jM=_t=Ge([E],_t);let si=class{constructor(W,pe,Me=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Me}};e.$kM=si,e.$kM=si=Ge([E],si);let bi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$lM=bi,e.$lM=bi=Ge([E],bi);let Ai=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$mM=Ai,e.$mM=Ai=Ge([E],Ai);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ri=p=class extends Error{static FileExists(W){return new p(W,m.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(W){return new p(W,m.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(W){return new p(W,m.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(W){return new p(W,m.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(W){return new p(W,m.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(W){return new p(W,m.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(W,pe=m.FileSystemProviderErrorCode.Unknown,Me){super(y.URI.isUri(W)?W.toString(!0):W),this.code=Me?.name??"Unknown",(0,m.$Fk)(this,pe),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$nM=Ri,e.$nM=Ri=p=Ge([E],Ri);let wi=class{constructor(W,pe,Me){this.start=W,this.end=pe,this.kind=Me}};e.$oM=wi,e.$oM=wi=Ge([E],wi);var Yi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Li;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Xi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var pi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Mi{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$pM=Mi;function un(H){return typeof H>"u"||(0,$.$Jf)(H)}class Ti{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let pe=0,Me=W.tokenTypes.length;pe<Me;pe++)this.k.set(W.tokenTypes[pe],pe);for(let pe=0,Me=W.tokenModifiers.length;pe<Me;pe++)this.l.set(W.tokenModifiers[pe],pe)}}push(W,pe,Me,Ze,tt){if(typeof W=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(W,pe,Me,Ze,tt);if(j.isRange(W)&&typeof pe=="string"&&un(Me))return this.n(W,pe,Me);throw(0,T.$7)()}n(W,pe,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,tt=W.start.character,lt=W.end.character-W.start.character,mt=this.k.get(pe);let Ht=0;if(Me)for(const Zt of Me){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);Ht|=1<<ii>>>0}this.o(Ze,tt,lt,mt,Ht)}o(W,pe,Me,Ze,tt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Ht=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<Ht;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Zt,Hi+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Zt=ai,ii=Hi}}let lt=W,mt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=W,this.e=pe}static q(W){const pe=[],Me=W.length/5|0;for(let mt=0;mt<Me;mt++)pe[mt]=mt;pe.sort((mt,Ht)=>{const Zt=W[5*mt],ii=W[5*Ht];if(Zt===ii){const ni=W[5*mt+1],ai=W[5*Ht+1];return ni-ai}return Zt-ii});const Ze=new Uint32Array(W.length);let tt=0,lt=0;for(let mt=0;mt<Me;mt++){const Ht=5*pe[mt],Zt=W[Ht+0],ii=W[Ht+1],ni=W[Ht+2],ai=W[Ht+3],Hi=W[Ht+4],Cn=Zt-tt,jn=Cn===0?ii-lt:ii,Ki=5*mt;Ze[Ki+0]=Cn,Ze[Ki+1]=jn,Ze[Ki+2]=ni,Ze[Ki+3]=ai,Ze[Ki+4]=Hi,tt=Zt,lt=ii}return Ze}build(W){return this.f?new oi(new Uint32Array(this.g),W):new oi(Ti.q(this.g),W)}}e.$qM=Ti;class oi{constructor(W,pe){this.resultId=pe,this.data=W}}e.$rM=oi;class ln{constructor(W,pe,Me){this.start=W,this.deleteCount=pe,this.data=Me}}e.$sM=ln;class hn{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$tM=hn;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$uM=di,e.$uM=di=Ge([E],di);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var vi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class en{static validate(W){if(typeof W.badge=="string"){let pe=(0,b.$jf)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,b.$jf)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!yt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Me){this.badge=W,this.tooltip=pe,this.color=Me}}e.$vM=en;let Ni=class{constructor(W){this.kind=W}};e.$wM=Ni,e.$wM=Ni=Ge([E],Ni);var Fi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class ei{static isNotebookRange(W){return W instanceof ei?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("start must be positive");if(pe<0)throw(0,T.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Me=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Me=W.end),pe===this.c&&Me===this.e?this:new ei(pe,Me)}}e.$xM=ei;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Me,Ze,tt,lt,mt){this.kind=W,this.value=pe,this.languageId=Me,this.mime=Ze,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,yi.validate(this)}}e.$yM=yi;class dn{constructor(W){this.cells=W}}e.$zM=dn;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Xt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Xt(W,pe)}static#e=new TextEncoder;static text(W,pe=R.$fs.text){const Me=Xt.#e.encode(String(W));return new Xt(Me,pe)}static json(W,pe="text/x-json"){const Me=JSON.stringify(W,void 0,"	");return Xt.text(Me,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Me=(0,R.$js)(pe,!0);if(!Me)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$AM=Xt;class Ei{static isNotebookCellOutput(W){return W instanceof Ei?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Me=new Set,Ze=new Set;for(let tt=0;tt<W.length;tt++){const lt=W[tt],mt=(0,R.$js)(lt.mime);if(!Me.has(mt)||(0,S.$bJ)(mt)){Me.add(mt);continue}Ze.add(tt),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?W:W.filter((tt,lt)=>!Ze.has(lt))}constructor(W,pe,Me){this.items=Ei.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Me):(this.id=(0,L.$qg)(),this.metadata=pe??Me)}}e.$BM=Ei;var ki;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(W,pe){this.text=W,this.alignment=pe}}e.$CM=tn;var at;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(at||(e.NotebookControllerAffinity=at={}));var wt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(wt||(e.NotebookControllerAffinity2=wt={}));class fn{constructor(W,pe=[]){this.uri=W,this.provides=(0,D.$3b)(pe)}}e.$DM=fn;class gn{constructor(W){this.label=W}}e.$EM=gn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let zi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$FM=zi,e.$FM=zi=Ge([E],zi);var fi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$GM=mn;class sn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$HM=sn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ui=class{constructor(W=void 0,pe=void 0,Me=void 0,Ze=!1){this.include=W,this.exclude=pe,this.profile=Me,this.continuous=Ze}};e.$IM=Ui,e.$IM=Ui=Ge([E],Ui);let Bi=w=class{static diff(W,pe,Me){const Ze=new w(W);return Ze.expectedOutput=pe,Ze.actualOutput=Me,Ze}constructor(W){this.message=W}};e.$JM=Bi,e.$JM=Bi=w=Ge([E],Bi);let Vi=class{constructor(W){this.id=W}};e.$KM=Vi,e.$KM=Vi=Ge([E],Vi);class Si{constructor(W,pe){this.covered=W,this.total=pe}}e.$LM=Si;const Wi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class qi{static fromDetails(W,pe){const Me=new Si(0,0),Ze=new Si(0,0),tt=new Si(0,0);for(const mt of pe)if("branches"in mt){Me.total+=1,Me.covered+=mt.executionCount>0?1:0;for(const Ht of mt.branches)Ze.total+=1,Ze.covered+=Ht.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new qi(W,Me,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=pe,lt}constructor(W,pe,Me,Ze){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Me,this.functionCoverage=Ze,Wi(pe),Wi(Me),Wi(Ze)}}e.$MM=qi;class $n{constructor(W,pe,Me=[]){this.executionCount=W,this.location=pe,this.branches=Me}}e.$NM=$n;class bn{constructor(W,pe,Me){this.executionCount=W,this.location=pe,this.label=Me}}e.$OM=bn;class $e{constructor(W,pe,Me){this.name=W,this.executionCount=pe,this.location=Me}}e.$PM=$e;var Ee;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var Ue;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ue||(e.WorkspaceTrustState=Ue={}));var ut;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ut||(e.PortAutoForwardAction=ut={}));class vt{constructor(W,pe,Me,Ze,tt,lt){this.kind=W,this.name=pe,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$QM=vt;class Mt{constructor(W){this.uri=W}}e.$RM=Mt;class cn{constructor(W,pe){this.original=W,this.modified=pe}}e.$SM=cn;class In{constructor(W,pe,Me,Ze){this.base=W,this.input1=pe,this.input2=Me,this.result=Ze}}e.$TM=In;class Pn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$UM=Pn;class An{constructor(W){this.viewType=W}}e.$VM=An;class Rn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$WM=Rn;class Ln{constructor(W,pe,Me){this.original=W,this.modified=pe,this.notebookType=Me}}e.$XM=Ln;class Mn{constructor(){}}e.$YM=Mn;class Tn{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$ZM=Tn;class Nn{constructor(W){this.providerId=W}}e.$1M=Nn;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Fn{constructor(W,pe){this.label=W,this.values=pe}}e.$2M=Fn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(W,pe){this.role=W,this.content=pe}}e.$3M=On;var kn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(ke[310],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$0K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new T.$_K(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$bgc=g}),define(ke[311],Se([1,0,4,6,7,26]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class R{constructor(y){this.b=new Map,this.c=new D.$Vd,this.onDidChangeSessions=this.c.event,this.d=new b,this.f=new b,this.a=y.getProxy(T.$0K.MainThreadAuthentication)}async getSession(y,L,C,m={}){const v=I.$lm.toKey(y.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${v} ${L} ${S}`,async()=>{await this.a.$ensureProvider(L);const l=y.displayName||y.name;return this.a.$getSession(L,C,v,l,m)})}async getSessions(y,L,C){const m=I.$lm.toKey(y.identifier),v=[...C].sort().join(" ");return await this.f.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(L);const S=y.displayName||y.name;return this.a.$getSessions(L,C,m,S)})}async removeSession(y,L){const C=this.b.get(y);return C?C.provider.removeSession(L):this.a.$removeSession(y,L)}registerAuthenticationProvider(y,L,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:L,provider:C,options:m??{supportsMultipleAccounts:!1}});const v=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(y,S));return this.a.$registerAuthenticationProvider(y,L,m?.supportsMultipleAccounts??!1),new g.$_K(()=>{v.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,L,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(L,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,L){return this.c.fire({provider:{id:y,label:L}}),Promise.resolve()}}e.$mgc=R;class b{constructor(){this.a=new Map}getOrCreate(y,L){const C=this.a.get(y);if(C)return C;const m=L().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(ke[147],Se([1,0,2,6,7,5,20,13,19,12,17,25]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,f){this.h=f,this.f=new Map,this.g=l.getProxy(T.$0K.MainThreadDecorations)}registerFileDecorationProvider(l,f){const o=m.c++;this.f.set(o,{provider:l,extensionDescription:f}),this.g.$registerDecorationProvider(o,f.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(r);if(n.length<=m.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,n.length);const c=n.map(s=>({uri:s,rank:(0,y.$Pe)(s.path,"/")})),t=(0,$.$zb)(c,(s,h)=>s.rank-h.rank||(0,y.$5e)(s.uri.path,h.uri.path)),u=[];e:for(const s of t){let h;for(const a of s){const d=(0,L.$mc)(a.uri.path);if(h!==d&&(h=d,u.push(a.uri)>=m.d))break e}}this.g.$onDidChange(o,u)});return new g.$_K(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(l,f,o){if(!this.f.has(l))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(l);return await Promise.all(f.map(async c=>{try{const{uri:t,id:u}=c,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),o));if(!s)return;try{g.$vM.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$CF)(n,"codiconDecoration"),i[u]=[s.propagate,s.tooltip,s.badge,s.color]}catch(h){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${h}`)}}catch(t){this.h.error(t)}})),i}};e.$lhc=v,e.$lhc=v=m=Ge([Ve(0,R.$bN),Ve(1,b.$nj)],v),e.$mhc=(0,I.$6h)("IExtHostDecorations")}),define(ke[312],Se([1,0,14,2,7,6,16,21,12]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(I.$0K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let S;if(typeof m.onDidChange=="function"){let l;S=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;l&&await l;const o=this.$provideTextDocumentContent(v,f).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(f);if(!r)return;const n=(0,$.$Ze)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{l===o&&(l=void 0)});l=o})}return new g.$_K(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$ohc=y}),define(ke[148],Se([1,0,60,16,12,176,126,7,19]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;const y=new Map;function L(S,l){l?y.set(S,l):y.delete(S)}e.$dN=L;function C(S){return y.get(S)}class m extends I.$lv{constructor(l,f,o,i,r,n,c,t){super(f,o,i,r),this.c=l,this.m=n,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===T.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(f){return f?l.s(f):l.getText()},get eol(){return l.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(f){return l.t(f)},offsetAt(f){return l.u(f)},positionAt(f){return l.v(f)},validateRange(f){return l.w(f)},validatePosition(f){return l.x(f)},getWordRangeAtPosition(f,o){return l.y(f,o)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,D.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,D.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const f=this.w(l);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const o=this.g,i=f.start.line,r=f.end.line,n=[];n.push(this.f[i].substring(f.start.character));for(let c=i+1;c<r;c++)n.push(this.f[c]);return n.push(this.f[r].substring(0,f.end.character)),n.join(o)}t(l){let f;if(l instanceof b.$aL?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new v(f,this.f[f],f===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const f=this.j.getIndexOf(l),o=this.f[f.index].length;return new b.$aL(f.index,Math.min(f.remainder,o))}w(l){if(!(l instanceof b.$bL))throw new Error("Invalid argument");const f=this.x(l.start),o=this.x(l.end);return f===l.start&&o===l.end?l:new b.$bL(f.line,f.character,o.line,o.character)}x(l){if(!(l instanceof b.$aL))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:f,character:o}=l,i=!1;if(f<0)f=0,o=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,o=this.f[f].length,i=!0;else{const r=this.f[f].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new b.$aL(f,o):l}y(l,f){const o=this.x(l);if(!f)f=C(this.m);else if((0,g.$Ye)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.$xs)(o.character+1,(0,R.$vs)(f),this.f[o.line],0);if(i)return new b.$bL(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$eN=m;class v{constructor(l,f,o){this.a=l,this.b=f,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$bL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$bL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fN=v}),define(ke[313],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$0K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const L=await y.provideEmbeddingVector(b,$);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new T.$_K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$qhc=g}),define(ke[69],Se([1,0,6,32,7,22,5,20,58,3,11,23,16]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0;let S=v=class{constructor(f,o){this.b=new Map,this.c=new L.$ch,this.a=f.getProxy(D.$0K.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const c=i.b.get(r.scheme);return c?(await i.a.$ensureActivation(r.scheme),n=await c.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===T.FilePermission.Readonly?1:void 0}}catch(n){v.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return v.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return v.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return v.e(n)}},async writeFile(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(c.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,I.$je.wrap(n))}catch(c){return v.e(c)}},async delete(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await c.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(c){return v.e(c)}},async rename(r,n,c){try{return await i.a.$rename(r,n,{overwrite:!1,...c})}catch(t){return v.e(t)}},async copy(r,n,c){try{return await i.a.$copy(r,n,{overwrite:!1,...c})}catch(t){return v.e(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(f,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await f.stat(i)).type&T.FileType.Directory))throw g.$nM.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(T.$Gk(n)!==T.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await f.createDirectory(i)}catch(c){if(T.$Gk(c)!==T.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$nM)throw f;if(f instanceof T.$Ck)switch(f.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$nM.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$nM.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$nM.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$nM.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$nM.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$nM.Unavailable(f.message);default:throw new g.$nM(f.message,f.name)}if(!(f instanceof Error))throw new g.$nM(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$nM.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$nM.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$nM.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$nM.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$nM.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$nM.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$nM.Unavailable(f.message);default:throw new g.$nM(f.message,f.name)}}addFileSystemProvider(f,o,i){return this.b.set(f,{impl:o,extUri:i?.isCaseSensitive?C.$xg:C.$zg,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$xg}};e.$Dgc=S,e.$Dgc=S=v=Ge([Ve(0,b.$bN),Ve(1,$.$egc)],S),e.$Egc=(0,R.$6h)("IExtHostConsumerFileSystem")}),define(ke[314],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class g{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$0K.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,b){const $=R.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new T.$_K(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,b){const $=R.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new T.$_K(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$Hhc=g}),define(ke[94],Se([1,0,5,27,13,69,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,D.$6h)("IExtensionStoragePaths");let b=class{constructor(y,L,C){this.d=L,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ggc=b,e.$Ggc=b=Ge([Ve(0,T.$rN),Ve(1,g.$nj),Ve(2,I.$Egc)],b)}),define(ke[315],Se([1,0,7,20,4]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let I=class{constructor(b){this.a=new D.$wM(D.ColorThemeKind.Dark),this.b=new g.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$wM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$hc=I,e.$$hc=I=Ge([Ve(0,T.$bN)],I)}),define(ke[70],Se([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wyb=e.$vyb=e.TunnelDtoConverter=void 0;class v extends $.$Jv{}var S;(function(f){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}f.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}f.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$vyb=(0,R.$6h)("IExtHostTunnelService");let l=class extends g.$Tc{constructor(o,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$0K.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,o.displayName);if(r){const n=new v(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const r=this.u();return this.r.set(r,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,r),new m.$_K(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,c){const t=[];for(const s of o){const h=this.r.get(s);if(!h)return[];t.push(...await Promise.all(i.map(async a=>{let d;try{d=await h.provider.providePortAttributes({port:a,pid:r,commandLine:n},c)}catch{d=await h.provider.providePortAttributes(a,r,n,c)}return{providedAttributes:d,port:a}})))}const u=t.filter(s=>!!s.providedAttributes);return u.length>0?u.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,c)=>await o.provideTunnel(n,c,new D.$6d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,g.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const r=o.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const r=this.g.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:c}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),r=o.filter((n,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$wyb=l,e.$wyb=l=Ge([Ve(0,C.$bN),Ve(1,L.$rN),Ve(2,b.$nj)],l)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,55,101,24,18,2,29,83,135,141,139,118,67,90,289,25,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aN=e.$_M=e.MarkdownString=e.$$M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Te){function Fe(se){const{selectionStartLineNumber:Ne,selectionStartColumn:We,positionLineNumber:xe,positionColumn:Ke}=se,st=new s.$aL(Ne-1,We-1),$t=new s.$aL(xe-1,Ke-1);return new s.$cL(st,$t)}Te.to=Fe;function Ce(se){const{anchor:Ne,active:We}=se;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Te.from=Ce})(h||(e.Selection=h={}));var a;(function(Te){function Fe(se){if(!se)return;const{start:Ne,end:We}=se;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Te.from=Fe;function Ce(se){if(!se)return;const{startLineNumber:Ne,startColumn:We,endLineNumber:xe,endColumn:Ke}=se;return new s.$bL(Ne-1,We-1,xe-1,Ke-1)}Te.to=Ce})(a||(e.Range=a={}));var d;(function(Te){function Fe(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Te.to=Fe})(d||(e.TokenType=d={}));var k;(function(Te){function Fe(se){return new s.$aL(se.lineNumber-1,se.column-1)}Te.to=Fe;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Te.from=Ce})(k||(e.Position=k={}));var A;(function(Te){function Fe(Ne,We,xe){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ke=>Ce(Ke,We,xe)))}Te.from=Fe;function Ce(Ne,We,xe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:xe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:se(Ne.scheme,We),pattern:ne.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:xe?.isBuiltin}}function se(Ne,We){return We&&typeof Ne=="string"?We.transformOutgoingScheme(Ne):Ne}})(A||(e.DocumentSelector=A={}));var p;(function(Te){function Fe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Te.from=Fe;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Te.to=Ce})(p||(e.DiagnosticTag=p={}));var w;(function(Te){function Fe(se){let Ne;return se.code&&((0,m.$If)(se.code)||(0,m.$Mf)(se.code)?Ne=String(se.code):Ne={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Ne,severity:P.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,D.$Hb)(se.tags.map(p.from)):void 0}}Te.from=Fe;function Ce(se){const Ne=new s.$nL(a.to(se),se.message,P.to(se.severity));return Ne.source=se.source,Ne.code=(0,m.$If)(se.code)?se.code:se.code?.value,Ne.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Ne.tags=se.tags&&(0,D.$Hb)(se.tags.map(p.to)),Ne}Te.to=Ce})(w||(e.Diagnostic=w={}));var E;(function(Te){function Fe(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Te.from=Fe;function Ce(se){return new s.$mL(new s.$lL(se.resource,a.to(se)),se.message)}Te.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var P;(function(Te){function Fe(se){switch(se){case s.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Te.from=Fe;function Ce(se){switch(se){case f.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Te.to=Ce})(P||(e.DiagnosticSeverity=P={}));var F;(function(Te){function Fe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$cD:t.$bD}Te.from=Fe;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ce})(F||(e.ViewColumn=F={}));function z(Te){return typeof Te.range<"u"}function N(Te){return Te.length===0?!0:!!z(Te[0])}e.$$M=N;var j;(function(Te){function Fe(Ke){return Ke.map(Te.from)}Te.fromMany=Fe;function Ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function se(Ke){let st;if(Ce(Ke)){const{language:It,value:yt}=Ke;st={value:"```"+It+`
`+yt+"\n```\n"}}else s.$AL.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const $t=Object.create(null);st.uris=$t;const Bt=It=>{try{let yt=v.URI.parse(It,!0);yt=yt.with({query:Ne(yt.query,$t)}),$t[It]=yt}catch{}return""},kt=new $.marked.Renderer;return kt.link=Bt,kt.image=It=>typeof It=="string"?Bt(R.$pk(It).href):"",(0,$.marked)(st.value,{renderer:kt}),st}Te.from=se;function Ne(Ke,st){if(!Ke)return Ke;let $t;try{$t=(0,y.$Bh)(Ke)}catch{}if(!$t)return Ke;let Bt=!1;return $t=(0,C.$xn)($t,kt=>{if(v.URI.isUri(kt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[It]=kt,Bt=!0,It}else return}),Bt?JSON.stringify($t):Ke}function We(Ke){const st=new s.$AL(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?v.URI.from(Ke.baseUri):void 0,st}Te.to=We;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Te.from(Ke)}Te.fromStrict=xe})(j||(e.MarkdownString=j={}));function M(Te){return N(Te)?Te.map(Fe=>({range:a.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?j.fromMany(Fe.hoverMessage):Fe.hoverMessage?j.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Te.map(Fe=>({range:a.from(Fe)}))}e.$_M=M;function O(Te){return typeof Te>"u"?Te:typeof Te=="string"?v.URI.file(Te):Te}e.$aN=O;var U;(function(Te){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Te.from=Fe})(U||(e.ThemableDecorationAttachmentRenderOptions=U={}));var Y;(function(Te){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?U.from(Ce.before):void 0,after:Ce.after?U.from(Ce.after):void 0}}Te.from=Fe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var le;(function(Te){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Fe})(le||(e.DecorationRangeBehavior=le={}));var Z;(function(Te){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?le.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?Y.from(Ce.light):void 0,dark:Ce.dark?Y.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?U.from(Ce.before):void 0,after:Ce.after?U.from(Ce.after):void 0}}Te.from=Fe})(Z||(e.DecorationRenderOptions=Z={}));var J;(function(Te){function Fe(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Te.from=Fe;function Ce(se){const Ne=new s.$gL(a.to(se.range),se.text);return Ne.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Ne}Te.to=Ce})(J||(e.TextEdit=J={}));var X;(function(Te){function Fe(se,Ne){const We={edits:[]};if(se instanceof s.$jL){const xe=new b.$Bc;for(const Ke of se._allEntries())Ke._type===1&&v.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of se._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,T.$De)(T.$je.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),We.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?We.edits.push({resource:Ke.uri,textEdit:J.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?We.edits.push({resource:Ke.uri,textEdit:{range:a.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?We.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&We.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(pt.from)}})}return We}Te.from=Fe;function Ce(se){const Ne=new s.$jL,We=new b.$Ac;for(const xe of se.edits)if(xe.textEdit){const Ke=xe,st=v.URI.revive(Ke.resource),$t=a.to(Ke.textEdit.range),Bt=Ke.textEdit.text,kt=Ke.textEdit.insertAsSnippet;let It;kt?It=s.$iL.replace($t,new s.$kL(Bt)):It=s.$gL.replace($t,Bt);const yt=We.get(st);yt?yt.push(It):We.set(st,[It])}else Ne.renameFile(v.URI.revive(xe.oldResource),v.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of We)Ne.set(xe,Ke);return Ne}Te.to=Ce})(X||(e.WorkspaceEdit=X={}));var ue;(function(Te){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ce(Ne){return typeof Fe[Ne]=="number"?Fe[Ne]:6}Te.from=Ce;function se(Ne){for(const We in Fe)if(Fe[We]===Ne)return Number(We);return s.SymbolKind.Property}Te.to=se})(ue||(e.SymbolKind=ue={}));var x;(function(Te){function Fe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Te.from=Fe;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Te.to=Ce})(x||(e.SymbolTag=x={}));var be;(function(Te){function Fe(se){return{name:se.name,kind:ue.from(se.kind),tags:se.tags&&se.tags.map(x.from),containerName:se.containerName,location:ye.from(se.location)}}Te.from=Fe;function Ce(se){const Ne=new s.$rL(se.name,ue.to(se.kind),se.containerName,ye.to(se.location));return Ne.tags=se.tags&&se.tags.map(x.to),Ne}Te.to=Ce})(be||(e.WorkspaceSymbol=be={}));var ce;(function(Te){function Fe(se){const Ne={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:ue.from(se.kind),tags:se.tags?.map(x.from)??[]};return se.children&&(Ne.children=se.children.map(Fe)),Ne}Te.from=Fe;function Ce(se){const Ne=new s.$sL(se.name,se.detail,ue.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,D.$Lb)(se.tags)&&(Ne.tags=se.tags.map(x.to)),se.children&&(Ne.children=se.children.map(Ce)),Ne}Te.to=Ce})(ce||(e.DocumentSymbol=ce={}));var K;(function(Te){function Fe(se){const Ne=new s.$wL(ue.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Te.to=Fe;function Ce(se,Ne,We){if(Ne=Ne??se._sessionId,We=We??se._itemId,Ne===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:We,name:se.name,detail:se.detail,kind:ue.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(x.from)}}Te.from=Ce})(K||(e.CallHierarchyItem=K={}));var V;(function(Te){function Fe(Ce){return new s.$xL(K.to(Ce.from),Ce.fromRanges.map(se=>a.to(se)))}Te.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var re;(function(Te){function Fe(Ce){return new s.$yL(K.to(Ce.to),Ce.fromRanges.map(se=>a.to(se)))}Te.to=Fe})(re||(e.CallHierarchyOutgoingCall=re={}));var ye;(function(Te){function Fe(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Te.from=Fe;function Ce(se){return new s.$lL(v.URI.revive(se.uri),a.to(se.range))}Te.to=Ce})(ye||(e.location=ye={}));var de;(function(Te){function Fe(se){const Ne=se,We=se;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:We.uri,range:a.from(Ne.targetRange?Ne.targetRange:We.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Te.from=Fe;function Ce(se){return{targetUri:v.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Te.to=Ce})(de||(e.DefinitionLink=de={}));var ge;(function(Te){function Fe(se){return{range:a.from(se.range),contents:j.fromMany(se.contents)}}Te.from=Fe;function Ce(se){return new s.$oL(se.contents.map(j.to),a.to(se.range))}Te.to=Ce})(ge||(e.Hover=ge={}));var _;(function(Te){function Fe(se){return{range:a.from(se.range),expression:se.expression}}Te.from=Fe;function Ce(se){return new s.$iM(a.to(se.range),se.expression)}Te.to=Ce})(_||(e.EvaluatableExpression=_={}));var te;(function(Te){function Fe(se){if(se instanceof s.$jM)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.$kM)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$lM)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Fe;function Ce(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Te.to=Ce})(te||(e.InlineValue=te={}));var G;(function(Te){function Fe(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Te.from=Fe;function Ce(se){return new s.$mM(se.frameId,a.to(se.stoppedLocation))}Te.to=Ce})(G||(e.InlineValueContext=G={}));var ie;(function(Te){function Fe(se){return{range:a.from(se.range),kind:se.kind}}Te.from=Fe;function Ce(se){return new s.$pL(a.to(se.range),se.kind)}Te.to=Ce})(ie||(e.DocumentHighlight=ie={}));var fe;(function(Te){function Fe(se){return{uri:se.uri,highlights:se.highlights.map(ie.from)}}Te.from=Fe;function Ce(se){return new s.$qL(v.URI.revive(se.uri),se.highlights.map(ie.to))}Te.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var ve;(function(Te){function Fe(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Te.to=Fe})(ve||(e.CompletionTriggerKind=ve={}));var Pe;(function(Te){function Fe(Ce){return{triggerKind:ve.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Te.to=Fe})(Pe||(e.CompletionContext=Pe={}));var we;(function(Te){function Fe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Te.from=Fe;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Te.to=Ce})(we||(e.CompletionItemTag=we={}));var De;(function(Te){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(We){return Fe.get(We)??9}Te.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne(We){return se.get(We)??s.CompletionItemKind.Property}Te.to=Ne})(De||(e.CompletionItemKind=De={}));var B;(function(Te){function Fe(Ce,se){const Ne=new s.$GL(Ce.label);return Ne.insertText=Ce.insertText,Ne.kind=De.to(Ce.kind),Ne.tags=Ce.tags?.map(we.to),Ne.detail=Ce.detail,Ne.documentation=R.$jk(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Ne.sortText=Ce.sortText,Ne.filterText=Ce.filterText,Ne.preselect=Ce.preselect,Ne.commitCharacters=Ce.commitCharacters,S.$Us.isIRange(Ce.range)?Ne.range=a.to(Ce.range):typeof Ce.range=="object"&&(Ne.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Ne.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Ne.insertText=new s.$kL(Ce.insertText):(Ne.insertText=Ce.insertText,Ne.textEdit=Ne.range instanceof s.$bL?new s.$gL(Ne.range,Ne.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ce.additionalTextEdits.map(We=>J.to(We))),Ne.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Ne}Te.to=Fe})(B||(e.CompletionItem=B={}));var Q;(function(Te){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:j.fromStrict(se.documentation)}}Te.from=Fe;function Ce(se){return{label:se.label,documentation:R.$jk(se.documentation)?j.to(se.documentation):se.documentation}}Te.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Te){function Fe(se){return{label:se.label,documentation:j.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Te.from=Fe;function Ce(se){return{label:se.label,documentation:R.$jk(se.documentation)?j.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Te.to=Ce})(ee||(e.SignatureInformation=ee={}));var q;(function(Te){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.from):[]}}Te.from=Fe;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.to):[]}}Te.to=Ce})(q||(e.SignatureHelp=q={}));var oe;(function(Te){function Fe(Ce,se){const Ne=new s.$FL(k.to(se.position),typeof se.label=="string"?se.label:se.label.map(he.to.bind(void 0,Ce)),se.kind&&Le.to(se.kind));return Ne.textEdits=se.textEdits&&se.textEdits.map(J.to),Ne.tooltip=R.$jk(se.tooltip)?j.to(se.tooltip):se.tooltip,Ne.paddingLeft=se.paddingLeft,Ne.paddingRight=se.paddingRight,Ne}Te.to=Fe})(oe||(e.InlayHint=oe={}));var he;(function(Te){function Fe(Ce,se){const Ne=new s.$EL(se.label);return Ne.tooltip=R.$jk(se.tooltip)?j.to(se.tooltip):se.tooltip,l.Command.is(se.command)&&(Ne.command=Ce.fromInternal(se.command)),se.location&&(Ne.location=ye.to(se.location)),Ne}Te.to=Fe})(he||(e.InlayHintLabelPart=he={}));var Le;(function(Te){function Fe(se){return se}Te.from=Fe;function Ce(se){return se}Te.to=Ce})(Le||(e.InlayHintKind=Le={}));var je;(function(Te){function Fe(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Te.from=Fe;function Ce(se){let Ne;if(se.url)try{Ne=typeof se.url=="string"?v.URI.parse(se.url,!0):v.URI.revive(se.url)}catch{}return new s.$LL(a.to(se.range),Ne)}Te.to=Ce})(je||(e.DocumentLink=je={}));var He;(function(Te){function Fe(se){const Ne=new s.$OL(se.label);return se.textEdit&&(Ne.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Ne.additionalTextEdits=se.additionalTextEdits.map(We=>J.to(We))),Ne}Te.to=Fe;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Ne=>J.from(Ne)):void 0}}Te.from=Ce})(He||(e.ColorPresentation=He={}));var Je;(function(Te){function Fe(se){return new s.$ML(se[0],se[1],se[2],se[3])}Te.to=Fe;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Te.from=Ce})(Je||(e.Color=Je={}));var _e;(function(Te){function Fe(se){return{range:a.from(se.range)}}Te.from=Fe;function Ce(se){return new s.$vL(a.to(se.range))}Te.to=Ce})(_e||(e.SelectionRange=_e={}));var ct;(function(Te){function Fe(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Te.to=Fe})(ct||(e.TextDocumentSaveReason=ct={}));var ot;(function(Te){function Fe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Fe;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Te.to=Ce})(ot||(e.TextEditorLineNumbersStyle=ot={}));var rt;(function(Te){function Fe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Te.from=Fe;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Te.to=Ce})(rt||(e.EndOfLine=rt={}));var Ae;(function(Te){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var ze;(function(Te){function Fe(se){const Ne={start:se.start+1,end:se.end+1};return se.kind&&(Ne.kind=Re.from(se.kind)),Ne}Te.from=Fe;function Ce(se){const Ne={start:se.start-1,end:se.end-1};return se.kind&&(Ne.kind=Re.to(se.kind)),Ne}Te.to=Ce})(ze||(e.FoldingRange=ze={}));var Re;(function(Te){function Fe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return l.$Kt.Comment;case s.FoldingRangeKind.Imports:return l.$Kt.Imports;case s.FoldingRangeKind.Region:return l.$Kt.Region}}Te.from=Fe;function Ce(se){if(se)switch(se.value){case l.$Kt.Comment.value:return s.FoldingRangeKind.Comment;case l.$Kt.Imports.value:return s.FoldingRangeKind.Imports;case l.$Kt.Region.value:return s.FoldingRangeKind.Region}}Te.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Xe;(function(Te){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$EE.id:void 0}}Te.from=Fe})(Xe||(e.TextEditorOpenOptions=Xe={}));var ne;(function(Te){function Fe(We){return We instanceof s.$9L?We.toJSON():typeof We=="string"?We:Ce(We)||se(We)?new s.$9L(We.baseUri??We.base,We.pattern).toJSON():We}Te.from=Fe;function Ce(We){const xe=We;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(We){const xe=We;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ne(We){return typeof We=="string"?We:new s.$9L(v.URI.revive(We.baseUri),We.pattern)}Te.to=Ne})(ne||(e.GlobPattern=ne={}));var ae;(function(Te){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ne.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Te.from=Fe})(ae||(e.LanguageSelector=ae={}));var Ie;(function(Te){function Fe(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(We=>We&&typeof We=="object"&&"uri"in We&&v.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(xe=>xe instanceof s.$bL)))}Te.is=Fe;function Ce(se){return{documents:se.documents.map(Ne=>Ne.map(We=>({uri:v.URI.from(We.uri),version:We.version,ranges:We.ranges.map(xe=>a.from(xe))})))}}Te.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var qe;(function(Te){function Fe(se){return{start:se.start,end:se.end}}Te.from=Fe;function Ce(se){return new s.$xM(se.start,se.end)}Te.to=Ce})(qe||(e.NotebookRange=qe={}));var Ye;(function(Te){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Te.to=Fe;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Te.from=Ce})(Ye||(e.NotebookCellExecutionSummary=Ye={}));var nt;(function(Te){function Fe(Ce){if(Ce===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===r.NotebookCellExecutionState.Pending)return;if(Ce===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Te.to=Fe})(nt||(e.NotebookCellExecutionState=nt={}));var it;(function(Te){function Fe(se){switch(se){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Te.from=Fe;function Ce(se){switch(se){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Te.to=Ce})(it||(e.NotebookCellKind=it={}));var Oe;(function(Te){function Fe(se){const Ne={metadata:se.metadata??Object.create(null),cells:[]};for(const We of se.cells)s.$yM.validate(We),Ne.cells.push(pt.from(We));return Ne}Te.from=Fe;function Ce(se){const Ne=new s.$zM(se.cells.map(pt.to));return(0,m.$Vf)(se.metadata)||(Ne.metadata=se.metadata),Ne}Te.to=Ce})(Oe||(e.NotebookData=Oe={}));var pt;(function(Te){function Fe(se){return{cellKind:it.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ye.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Ft.from):[]}}Te.from=Fe;function Ce(se){return new s.$yM(it.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Ft.to):void 0,se.metadata,se.internalMetadata?Ye.to(se.internalMetadata):void 0)}Te.to=Ce})(pt||(e.NotebookCellData=pt={}));var St;(function(Te){function Fe(se){return{mime:se.mime,valueBytes:T.$je.wrap(se.data)}}Te.from=Fe;function Ce(se){return new s.$AM(se.valueBytes.buffer,se.mime)}Te.to=Ce})(St||(e.NotebookCellOutputItem=St={}));var Ft;(function(Te){function Fe(se){return{outputId:se.id,items:se.items.map(St.from),metadata:se.metadata}}Te.from=Fe;function Ce(se){const Ne=se.items.map(St.to);return new s.$BM(Ne,se.outputId,se.metadata)}Te.to=Ce})(Ft||(e.NotebookCellOutput=Ft={}));var Vt;(function(Te){function Fe(Ne){return se(Ne)?{include:ne.from(Ne.include)??void 0,exclude:ne.from(Ne.exclude)??void 0}:ne.from(Ne)??void 0}Te.from=Fe;function Ce(Ne){return se(Ne)?{include:ne.to(Ne.include),exclude:ne.to(Ne.exclude)}:ne.to(Ne)}Te.to=Ce;function se(Ne){const We=Ne;return We?!(0,m.$Rf)(We.include)&&!(0,m.$Rf)(We.exclude):!1}})(Vt||(e.NotebookExclusiveDocumentPattern=Vt={}));var Et;(function(Te){function Fe(Ce,se,Ne){const We=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(We,Ne),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Te.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Kt;(function(Te){function Fe(Ce,se,Ne){const We=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(We,Ne),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Te.from=Fe})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Ot;(function(Te){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Te.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Yt;(function(Te){function Fe(se){return{uri:se.uri,provides:se.provides}}Te.from=Fe;function Ce(se){return new s.$DM(v.URI.revive(se.uri),se.provides)}Te.to=Ce})(Yt||(e.NotebookRendererScript=Yt={}));var zt;(function(Te){function Fe(se){return{message:j.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Te.from=Fe;function Ce(se){const Ne=new s.$JM(typeof se.message=="string"?se.message:j.to(se.message));return Ne.actualOutput=se.actual,Ne.expectedOutput=se.expected,Ne.contextValue=se.contextValue,Ne.location=se.location?ye.to(se.location):void 0,Ne}Te.to=Ce})(zt||(e.TestMessage=zt={}));var Rt;(function(Te){Te.namespace=c.$6J,Te.denamespace=c.$7J})(Rt||(e.TestTag=Rt={}));var et;(function(Te){function Fe(se){const Ne=(0,o.$0M)(se).controllerId;return{extId:n.$2J.fromExtHostTestItem(se,Ne).toString(),label:se.label,uri:v.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(We=>Rt.namespace(Ne,We.id)),range:S.$Us.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&j.fromStrict(se.error)||null}}Te.from=Fe;function Ce(se){return{parent:void 0,error:void 0,id:n.$2J.fromString(se.extId).localId,label:se.label,uri:v.URI.revive(se.uri),tags:(se.tags||[]).map(Ne=>{const{tagId:We}=Rt.denamespace(Ne);return new s.$KM(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Te.toPlain=Ce})(et||(e.TestItem=et={})),function(Te){function Fe(se){return{id:se.id}}Te.from=Fe;function Ce(se){return new s.$KM(se.id)}Te.to=Ce}(Rt||(e.TestTag=Rt={}));var Gt;(function(Te){const Fe=(se,Ne)=>{const We=[];for(const[Ke,st]of Ne)n.$2J.compare(st.item.extId,Ke)===2&&(Ne.delete(Ke),We.push(st));const xe={...et.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(zt.to)})),children:We.map(Ke=>Fe(Ke,Ne))};for(const Ke of xe.children)Ke.parent=xe;return xe};function Ce(se){const Ne=[],We=new Map;for(const xe of se.items){We.set(xe.item.extId,xe);const Ke=n.$2J.root(xe.item.extId);se.request.targets.some(st=>st.controllerId===Ke&&st.testIds.includes(xe.item.extId))&&Ne.push(xe)}return{completedAt:se.completedAt,results:Ne.map(xe=>Fe(xe,We))}}Te.to=Ce})(Gt||(e.TestResults=Gt={}));var Jt;(function(Te){function Fe(We){return{covered:We.covered,total:We.total}}function Ce(We){return"line"in We?k.from(We):a.from(We)}function se(We){return"branches"in We?{count:We.executionCount,location:Ce(We.location),type:1,branches:We.branches.length?We.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location),label:xe.label})):void 0}:{type:0,name:We.name,count:We.executionCount,location:Ce(We.location)}}Te.fromDetailed=se;function Ne(We){return{uri:We.uri,statement:Fe(We.statementCoverage),branch:We.branchCoverage&&Fe(We.branchCoverage),function:We.functionCoverage&&Fe(We.functionCoverage),details:We.detailedCoverage?.map(se)}}Te.fromFile=Ne})(Jt||(e.TestCoverage=Jt={}));var ht;(function(Te){function Fe(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Te.to=Fe})(ht||(e.CodeActionTriggerKind=ht={}));var bt;(function(Te){function Fe(se){const Ne=new s.$QM(ue.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Te.to=Fe;function Ce(se,Ne,We){if(Ne=Ne??se._sessionId,We=We??se._itemId,Ne===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:We,kind:ue.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(x.from)}}Te.from=Ce})(bt||(e.TypeHierarchyItem=bt={}));var Ut;(function(Te){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Te.from=Fe})(Ut||(e.ViewBadge=Ut={}));var Wt;(function(Te){function Fe(We,xe,Ke){const st=xe.fileData;return st?new s.$2L(new s.$3L(st.name,v.URI.revive(st.uri),st.id,(0,I.$db)(()=>Ke(st.id)))):We===L.$fs.uriList&&xe.uriListData?new s.$1L(Ne(xe.uriListData)):new s.$1L(xe.asString)}Te.to=Fe;async function Ce(We,xe){const Ke=await xe.asString();if(We===L.$fs.uriList)return{asString:Ke,fileData:void 0,uriListData:se(Ke)};const st=xe.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Te.from=Ce;function se(We){return g.$rt.split(We).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Ne(We){return g.$rt.create(We.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(Wt||(e.DataTransferItem=Wt={}));var Dt;(function(Te){function Fe(se,Ne){const We=se.items.map(([xe,Ke])=>[xe,Wt.to(xe,Ke,Ne)]);return new s.$4L(We)}Te.toDataTransfer=Fe;async function Ce(se){const Ne={items:[]},We=[];for(const[xe,Ke]of se)We.push((async()=>{Ne.items.push([xe,await Wt.from(xe,Ke)])})());return await Promise.all(We),Ne}Te.from=Ce})(Dt||(e.DataTransfer=Dt={}));var ft;(function(Te){function Fe(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Te.from=Fe})(ft||(e.ChatReplyFollowup=ft={}));var At;(function(Te){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Te.from=Fe})(At||(e.ChatFollowup=At={}));var xt;(function(Te){function Fe(se){const Ne=new s.$3M(Ct.to(se.role),se.content);return Ne.name=se.name,Ne}Te.to=Fe;function Ce(se){return{role:Ct.from(se.role),content:se.content,name:se.name}}Te.from=Ce})(xt||(e.ChatMessage=xt={}));var Ct;(function(Te){function Fe(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Te.to=Fe;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Te.from=Ce})(Ct||(e.ChatMessageRole=Ct={}));var Qe;(function(Te){function Fe(Ne){const We={};for(const xe of Object.keys(Ne))We[xe]=Ne[xe].map(Te.to);return We}Te.objectTo=Fe;function Ce(Ne){return{level:Tt.to(Ne.level),kind:Ne.kind,value:(0,v.$vc)(Ne.value)?v.URI.revive(Ne.value):Ne.value,description:Ne.description}}Te.to=Ce;function se(Ne){return{level:Tt.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Te.from=se})(Qe||(e.ChatVariable=Qe={}));var Tt;(function(Te){function Fe(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Te.to=Fe;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Te.from=Ce})(Tt||(e.ChatVariableLevel=Tt={}));var qt;(function(Te){function Fe(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Te.to=Fe})(qt||(e.InteractiveEditorResponseFeedbackKind=qt={}));var Qt;(function(Te){function Fe(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{content:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,u.$CF)(Ce,"chatAgents2Additions"),{content:j.from(se.markdownContent),kind:"markdownContent"}):"content"in se?"vulnerabilities"in se&&se.vulnerabilities?((0,u.$CF)(Ce,"chatAgents2Additions"),{content:se.content,vulnerabilities:se.vulnerabilities,kind:"vulnerability"}):typeof se.content=="string"?{content:se.content,kind:"content"}:((0,u.$CF)(Ce,"chatAgents2Additions"),{content:j.from(se.content),kind:"markdownContent"}):"documents"in se?{documents:se.documents.map(Ne=>({uri:Ne.uri,version:Ne.version,ranges:Ne.ranges.map(We=>a.from(We))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:a.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:a.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,u.$CF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):"treeData"in se?{treeData:se.treeData,kind:"treeData"}:"message"in se?{content:j.from(se.message),kind:"progressMessage"}:void 0}Te.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Te){function Fe(Ce){return{label:Ce.label,values:Ce.values.map(Qe.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Te.from=Fe})(gt||(e.ChatAgentCompletionItem=gt={}));var Nt;(function(Te){function Fe(Ce,se,Ne){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Ne)}Te.from=Fe})(Nt||(e.TerminalQuickFix=Nt={}))}),define(ke[316],Se([1,0,6,20,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$0K.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const L=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};e.$ngc=I,e.$ngc=I=Ge([Ve(0,T.$bN)],I)}),define(ke[317],Se([1,0,53,3,6,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class R{static{this.a=0}constructor(y,L){this.extension=y,this.provider=L,this.handle=R.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$0K.MainThreadChat)}registerChatProvider(y,L,C){const m=new R(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,L),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,L){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,L)}sendInteractiveRequestToProvider(y,L){this.d.$sendRequestToProvider(y,L)}async $prepareChat(y,L){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(L);if(!m)return;const v=b.a++;return this.c.set(v,m),{id:v,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,L){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(L);if(m)return m.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(S=>I.ChatReplyFollowup.from(S)):I.MarkdownString.from(v))}async $provideSampleQuestions(y,L){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(L);if(m)return m?.map(v=>I.ChatReplyFollowup.from(v))}$releaseSession(y){this.c.delete(y)}}e.$ogc=b}),define(ke[318],Se([1,0,11,21,44,4,38,18,2,210,86,6,15,7,279,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class f{static{this.a=0}constructor(r,n,c){this.i=n,this.j=c,this.b=new Map,this.g=new Map,this.h=new Map,this.d=r.getProxy(C.$0K.MainThreadChatAgents2)}createChatAgent(r,n,c){const t=f.a++,u=new o(r,n,this.d,t,c);return this.b.set(t,u),this.d.$registerAgent(t,n,{}),u.apiAgent}async $invokeAgent(r,n,c,t,u,s){this.g.delete(n);const h=this.b.get(r);if(!h)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let a=!1;function d(){if(a)throw new Error("Only valid while executing the command")}const k=new D.$qh;s.onCancellationRequested(()=>k.complete()),this.i.allowListExtensionWhile(h.extension.identifier,k.p);const A=t.command?await h.validateSlashCommand(t.command):void 0,p=R.$Rd.create(!1);let w;try{const E=h.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:A},{history:u.history.map(m.ChatMessage.to)},new L.$vv(P=>{d(),typeof w>"u"&&"content"in P&&(w=p.elapsed());const F=m.ChatResponseProgress.from(h.extension,P);if(!F){this.j.error("Unknown progress type: "+JSON.stringify(P));return}if("placeholder"in P&&"resolvedContent"in P){const z=Promise.all([this.d.$handleProgressChunk(c,F),P.resolvedContent]);(0,D.$Ug)(z,s).then(N=>{if(!N)return;const[j,M]=N,O=m.ChatResponseProgress.from(h.extension,M);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(M));return}this.d.$handleProgressChunk(c,O,j??void 0)})}else this.d.$handleProgressChunk(c,F)}),s);return await(0,D.$Ug)(Promise.resolve(E).then(P=>{if(P){this.g.set(n,P);let F=this.h.get(n);F||(F=new Map,this.h.set(n,F)),F.set(c,P);const z={firstProgress:w,totalElapsed:p.elapsed()};return{errorDetails:P.errorDetails,timings:z}}else this.g.delete(n)}),s)}catch(E){return this.j.error(E,h.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Qi)(E)),responseIsIncomplete:!0}}}finally{a=!0,k.complete()}}$releaseSession(r){this.g.delete(r),this.h.delete(r)}async $provideSlashCommands(r,n){const c=this.b.get(r);return c?c.provideSlashCommand(n):[]}$provideFollowups(r,n,c){const t=this.b.get(r);if(!t)return Promise.resolve([]);const u=this.g.get(n);return u?t.provideFollowups(u,c):Promise.resolve([])}$acceptFeedback(r,n,c,t,u){const s=this.b.get(r);if(!s)return;const h=this.h.get(n)?.get(c);if(!h)return;let a;switch(t){case S.InteractiveSessionVoteDirection.Down:a=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:a=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(u?{result:h,kind:a,reportIssue:u}:{result:h,kind:a}))}$acceptAction(r,n,c,t){const u=this.b.get(r);if(!u)return;const s=this.h.get(n)?.get(c);s&&t.action.kind!=="vote"&&u.acceptAction(Object.freeze({action:t.action,result:s}))}async $invokeCompletionProvider(r,n,c){const t=this.b.get(r);return t?(await t.invokeCompletionProvider(n,c)).map(m.ChatAgentCompletionItem.from):[]}}e.$qgc=f;class o{constructor(r,n,c,t,u){this.extension=r,this.t=n,this.u=c,this.w=t,this.x=u,this.o=new I.$Vd,this.q=new I.$Vd}acceptFeedback(r){this.o.fire(r)}acceptAction(r){this.q.fire(r)}async invokeCompletionProvider(r,n){return this.s?await this.s.provider.provideCompletionItems(r,n)??[]:[]}async validateSlashCommand(r){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,b.$Sf)(this.b));const n=this.b.find(c=>c.name===r);if(!n)throw new Error(`Unknown slashCommand: ${r}`);return n}async provideSlashCommand(r){if(!this.a)return[];const n=await this.a.provideSlashCommands(r);return n?(this.b=n,n.map(c=>({name:c.name,description:c.description,followupPlaceholder:c.followupPlaceholder,shouldRepopulate:c.shouldRepopulate,sampleRequest:c.sampleRequest}))):[]}async provideFollowups(r,n){if(!this.d)return[];const c=await this.d.provideFollowups(r,n);return c?c.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let r=!1,n=!1;const c=()=>{r||n||(n=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$7L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),n=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(u){t.g=u,c()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(u){t.h=u,c()},get iconPath(){return t.i},set iconPath(u){t.i=u,c()},get slashCommandProvider(){return t.a},set slashCommandProvider(u){t.a=u,c()},get followupProvider(){return t.d},set followupProvider(u){t.d=u,c()},get isDefault(){return(0,l.$CF)(t.extension,"defaultChatAgent"),t.j},set isDefault(u){(0,l.$CF)(t.extension,"defaultChatAgent"),t.j=u,c()},get helpTextPrefix(){return(0,l.$CF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(u){if((0,l.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=u,c()},get helpTextPostfix(){return(0,l.$CF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(u){if((0,l.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=u,c()},get isSecondary(){return(0,l.$CF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(u){(0,l.$CF)(t.extension,"defaultChatAgent"),t.n=u,c()},get sampleRequest(){return t.m},set sampleRequest(u){t.m=u,c()},get supportIssueReporting(){return(0,l.$CF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(u){(0,l.$CF)(t.extension,"chatAgents2Additions"),t.r=u,c()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(u){if(t.s=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,u.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,l.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){r=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(r,n,c,t){return this.x(r,n,c,t)}}}),define(ke[319],Se([1,0,21,3,6,15,86,26,11,4]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class L{constructor(S,l){this.stream=new $.$wh,this.stream=l??new $.$wh;const f=this;this.apiObj={option:S,response:f.stream.asyncIterable}}}class C{constructor(S,l){this.a=new y.$Vd,this.b=new Map,this.c=new $.$wh,this.d=!1;const f=this;this.apiObject={result:S,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){l.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let l=this.b.get(S.index);l||(this.b.size===0?l=new L(S.index,this.c):l=new L(S.index),this.b.set(S.index,l),this.a.fire(l.apiObj)),l.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,l){this.d=l,this.c=new Map,this.e=new Map,this.f=new b.$nm,this.b=S.getProxy(g.$0K.MainThreadChatProvider)}registerProvider(S,l,f,o){const i=m.a++;return this.c.set(i,{extension:S,provider:f}),this.b.$registerProvider(i,l,{extension:S,model:o.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,l,f,o,i){const r=this.c.get(S);if(!r)return;const n=new R.$vv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(l,{index:c.index,part:c.part})});return r.provider.provideChatResponse(f.map(I.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,l){this.f.set(S,l),l.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,l){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(l);if(!f)throw new Error(`ChatAccess '${l}' NOT found`);const o=this;return{get model(){return f.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,r,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const c=new D.$6d(n),t=Math.random()*1e6|0,u=o.b.$fetchResponse(S,l,t,i.map(I.ChatMessage.from),r??{},c.token),s=new C(u,c);return o.e.set(t,{res:s}),u.finally(()=>{o.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,l){const f=this.e.get(S);f&&f.res.handleFragment(l)}}e.$pgc=m}),define(ke[320],Se([1,0,3,6,14,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(T.$0K.MainThreadChatVariables)}async $resolveVariable($,y,L){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{prompt:y},L);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,L,C){const m=R.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:L},resolver:C}),this.c.$registerVariable(m,{name:y,description:L}),(0,D.$Rc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$rgc=R}),define(ke[321],Se([1,0,11,52,4,3,2,83,26,15,7,6,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;function v(S,l,f){const o=S.getProxy(C.$0K.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$nm,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const k=this.b.get(d.handle);return k?k.value:d}else if(d&&d.$mid===7){const k=this.b.get(d.commentControlHandle);if(!k)return d;const A=k.getCommentThread(d.commentThreadHandle);return A?A.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const A=k.getCommentThread(d.thread.commentThreadHandle);return A?d.$mid===8?A.value:{thread:A.value,text:d.text}:d}else if(d&&d.$mid===10){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const A=k.getCommentThread(d.thread.commentThreadHandle);if(!A)return d;const p=d.commentUniqueId,w=A.getCommentByUniqueId(p);return w||d}else if(d&&d.$mid===11){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const A=k.getCommentThread(d.thread.commentThreadHandle);if(!A)return d;const p=d.text,w=d.commentUniqueId,E=A.getCommentByUniqueId(w);return E?(typeof E.body=="string"?E.body=p:E.body=new L.$AL(p),E):d}return d}})}createCommentController(d,k,A){const p=i.a++,w=new n(d,p,k,A);this.b.set(w.handle,w);const E=this.c.get(d.identifier)||[];return E.push(w),this.c.set(d.identifier,E),w.value}async $createCommentThreadTemplate(d,k,A){const p=this.b.get(d);p&&p.$createCommentThreadTemplate(k,A)}async $updateCommentThreadTemplate(d,k,A){const p=this.b.get(d);p&&p.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(d,k){this.b.get(d)?.$deleteCommentThread(k)}$provideCommentingRanges(d,k,A){const p=this.b.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const w=f.getDocument(R.URI.revive(k));return(0,D.$Yg)(async()=>{const E=await p.commentingRangeProvider.provideCommentingRanges(w,A);let P;return Array.isArray(E)?P={ranges:E,fileComments:!1}:E?P={ranges:E.ranges||[],fileComments:E.fileComments||!1}:P=E??void 0,P}).then(E=>{let P;return E&&(P={ranges:E.ranges.map(F=>y.Range.from(F)),fileComments:E.fileComments}),P})}$toggleReaction(d,k,A,p,w){const E=this.b.get(d);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Yg)(()=>{const P=E.getCommentThread(k);if(P){const F=P.getCommentByUniqueId(p.uniqueIdInThread);if(E!==void 0&&F&&E.reactionHandler)return E.reactionHandler(F,u(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,k,A,p,w,E,P,F){this.m=k,this.n=A,this.o=p,this.p=w,this.q=E,this.extensionDescription=P,this.r=F,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Uc,this.l.value=new I.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(N){z.range=N},get comments(){return z.comments},set comments(N){z.comments=N},get collapsibleState(){return z.collapsibleState},set collapsibleState(N){z.collapsibleState=N},get canReply(){return z.canReply},set canReply(N){z.canReply=N},get contextValue(){return z.contextValue},set contextValue(N){z.contextValue=N},get label(){return z.label},set label(N){z.label=N},get state(){return z.state},set state(N){z.state=N},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Sc);const d=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};d("range")&&(k.range=y.Range.from(this.p)),d("label")&&(k.label=this.label),d("contextValue")&&(k.contextValue=this.contextValue??null),d("comments")&&(k.comments=this.q.map(A=>c(this,A,this.k,this.extensionDescription))),d("collapsibleState")&&(k.collapseState=s(this.g)),d("canReply")&&(k.canReply=this.canReply),d("state")&&(k.state=h(this.h)),d("isTemplate")&&(k.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(d){for(const k of this.k){const A=k[0],p=k[1];if(d===p)return A}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ge([(0,T.$yh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,k,A,p){this.f=d,this.g=k,this.h=A,this.i=p,this.a=new Map,o.$registerCommentController(this.handle,A,p,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,P,F){return w.createCommentThread(E,P,F).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,k,A){k===void 0&&(0,m.$CF)(this.f,"fileComments");const p=new r(this.id,this.handle,void 0,d,k,A,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(d,k){const A=new r(this.id,this.handle,void 0,R.URI.revive(d),y.Range.to(k),[],this.f,!0);return A.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(A.handle,A),A}$updateCommentThreadTemplate(d,k){const A=this.a.get(d);A&&(A.range=y.Range.to(k))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function c(a,d,k,A){let p=k.get(d);return p||(p=++a.commentHandle,k.set(d,p)),d.state!==void 0&&(0,m.$CF)(A,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,m.$CF)(A,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:p,body:typeof d.body=="string"?d.body:y.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>t(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?y.$aN(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(d=>d.name):a.reactors}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(d=>({name:d}))}}function s(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function h(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$vgc=v}),define(ke[322],Se([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class v{constructor(u,s){this.document=u,this.b=s,this.a=1,this.c=new L.$agc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,s){await this.f(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.f(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=c(this.document.uri)+this.a++;return(0,R.$Hg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const s=this.c.get(u,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(u,s){return this.a.get(this.b(u,s))}add(u,s,h){const a=this.b(u,s.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const d=new v(s,h);return this.a.set(a,d),d}delete(u,s){const h=this.b(u,s.uri);this.a.delete(h)}b(u,s){return`${u}@@@${s}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this.a=new Map}addTextProvider(u,s,h){return this.b(0,u,s,h)}addCustomProvider(u,s,h){return this.b(1,u,s,h)}get(u){return this.a.get(u)}b(u,s,h,a){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:u,extension:h,provider:a}),new m.$_K(()=>this.a.delete(s))}}class o{constructor(u,s,h,a,d){this.d=s,this.f=h,this.g=a,this.h=d,this.b=new f,this.c=new S,this.a=u.getProxy(C.$0K.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,h,a){const d=new g.$Sc;return r(h)?(d.add(this.b.addTextProvider(s,u,h)),this.a.$registerTextEditorProvider((0,y.$Kgc)(u),s,a.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,y.$Igc)(u))):(d.add(this.b.addCustomProvider(s,u,h)),i(h)&&d.add(h.onDidChangeCustomDocument(k=>{const A=this.i(s,k.document.uri);if(n(k)){const p=A.addEdit(k);this.a.$onDidEdit(k.document.uri,s,p,k.label)}else this.a.$onContentChange(k.document.uri,s)})),this.a.$registerCustomEditorProvider((0,y.$Kgc)(u),s,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,y.$Igc)(u))),m.$_K.from(d,new m.$_K(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,h,a,d){const k=this.b.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const A=b.URI.revive(u),p=await k.provider.openCustomDocument(A,{backupId:h,untitledDocumentData:a?.buffer},d);let w;return i(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(s,p,w),{editable:i(k.provider)}}async $disposeCustomDocument(u,s){const h=this.b.get(s);if(!h)throw new Error(`No provider found for '${s}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${s}'`);const a=b.URI.revive(u),{document:d}=this.i(s,a);this.c.delete(s,d),d.dispose()}async $resolveCustomEditor(u,s,h,a,d,k){const A=this.b.get(h);if(!A)throw new Error(`No provider found for '${h}'`);const p=$.ViewColumn.to(d),w=this.g.createNewWebview(s,a.contentOptions,A.extension),E=this.h.createNewWebviewPanel(s,h,a.title,p,a.options,w,a.active),P=b.URI.revive(u);switch(A.type){case 1:{const{document:F}=this.i(h,P);return A.provider.resolveCustomEditor(F,E,k)}case 0:{const F=this.d.getDocument(P);return A.provider.resolveCustomTextEditor(F,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,h){this.i(s,u).disposeEdits(h)}async $onMoveCustomEditor(u,s,h){const a=this.b.get(h);if(!a)throw new Error(`No provider found for '${h}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const k=b.URI.revive(s),A=this.d.getDocument(k);await a.provider.moveCustomTextEditor(A,d,D.CancellationToken.None)}async $undo(u,s,h,a){return this.i(s,u).undo(h,a)}async $redo(u,s,h,a){return this.i(s,u).redo(h,a)}async $revert(u,s,h){const a=this.i(s,u);await this.j(s).revertCustomDocument(a.document,h),a.disposeBackup()}async $onSave(u,s,h){const a=this.i(s,u);await this.j(s).saveCustomDocument(a.document,h),a.disposeBackup()}async $onSaveAs(u,s,h,a){const d=this.i(s,u);return this.j(s).saveCustomDocumentAs(d.document,b.URI.revive(h),a)}async $backup(u,s,h){const a=this.i(s,u),k=await this.j(s).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},h);return a.updateBackup(k),k.id}i(u,s){const h=this.c.get(u,b.URI.revive(s));if(!h)throw new Error("No custom document found");return h}j(u){const h=this.b.get(u)?.provider;if(!h||!i(h))throw new Error("Custom document is not editable");return h}}e.$Ngc=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const u=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ti)(u)+""}}),define(ke[323],Se([1,0,211,135,2,6,7,15,4,13,28,58]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0;class v{#e;#t;#i;constructor(f,o,i,r,n,c,t,u){this.d=f,this.e=o,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new L.$Ac(s=>c.getComparisonKey(s)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,o){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!o){this.delete(f);return}this.#i.set(f,o.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(v.k);for(const t of f){const[u,s]=t;if((!c||u.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=u,i.push(u),this.#i.set(u,[])),s)this.#i.get(u)?.push(...s);else{const h=this.#i.get(u);h&&(h.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const c of i){let t=[];const u=this.#i.get(c);if(u)if(u.length>this.g){t=[];const s=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const a of u)if(a.severity===s[h]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(s=>({...b.Diagnostic.from(s),modelVersionId:this.h(c)}));if(r.push([c,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,o){this.j();for(const[i,r]of this)f.call(o,i,r,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const o=this.#i.get(f);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,o){return f[0].toString()<o[0].toString()?-1:f[0].toString()>o[0].toString()?1:0}}e.$fgc=v;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const o=new L.$Ac;for(const i of f)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(f,o,i,r){this.j=o,this.k=i,this.l=r,this.g=new Map,this.h=new $.$Zd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$0K.MainThreadDiagnostics)}createDiagnosticCollection(f,o){const{g:i,f:r,h:n,j:c,k:t,l:u}=this,s=new class{$changeMany(d,k){r.$changeMany(d,k),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,d,k.length===0?"CLEARING":k)}$clear(d){r.$clear(d),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,d)}dispose(){r.dispose()}};let h;if(!o)o="_generated_diagnostic_collection_name_#"+m.c++,h=o;else if(!i.has(o))h=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do h=o+m.c++;while(i.has(h))}return new class extends v{constructor(){super(o,h,m.e,m.d,d=>u.getDocument(d)?.version,t.extUri,s,n),i.set(h,this)}dispose(){super.dispose(),i.delete(h)}}}getDiagnostics(f){if(f)return this.m(f);{const o=new Map,i=[];for(const r of this.g.values())r.forEach((n,c)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let o=[];for(const i of this.g.values())i.has(f)&&(o=o.concat(i.get(f)));return o}$acceptMarkersChange(f){if(!this.n){const o="_generated_mirror",i=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of f)this.n.set(g.URI.revive(o),i.map(b.Diagnostic.to))}};e.$ggc=S,e.$ggc=S=m=Ge([Ve(1,y.$nj),Ve(2,C.$egc)],S)}),define(ke[324],Se([1,0,2,14,7,15,75]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class b{constructor(y,L,C,m={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=C,this.g=m,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,C,m)=>{const S={dispose:this.a.push([L,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,L){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const l of[...this.a]){if(m)break;const f=this.d.getDocument(C),o=await this.h(l,{document:f,reason:I.TextDocumentSaveReason.to(L)});S.push(o)}}finally{clearTimeout(v)}return S}h([y,L,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,L,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const l=this.b.get(y);this.b.set(y,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,C,m){const v=[],S=Date.now(),{document:l,reason:f}=m,{version:o}=l,i=Object.freeze({document:l,reason:f,waitUntil(r){if(Object.isFrozen(v))throw(0,T.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{L.apply(C,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,n)=>{const c=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(c),r(t)}).catch(t=>{clearTimeout(c),n(t)})}).then(r=>{const n={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(t=>t instanceof g.$gL))for(const{newText:t,newEol:u,range:s}of c)n.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:s&&I.Range.from(s),text:t,eol:u&&I.EndOfLine.from(u)}});if(n.edits.length!==0)return o===l.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$phc=b}),define(ke[325],Se([1,0,4,3,2,6,148,15,18,24,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class C{constructor(v,S){this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=v.getProxy(I.$0K.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(l=>{for(const f of l)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const f of l)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const S=this.g.getDocument(v);if(S)return S}getDocument(v){const S=this.getDocumentData(v);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return S.document}ensureDocumentData(v){const S=this.g.getDocument(v);if(S)return Promise.resolve(S);let l=this.h.get(v.toString());return l||(l=this.f.$tryOpenDocument(v).then(f=>{this.h.delete(v.toString());const o=g.URI.revive(f);return(0,$.$Tf)(this.g.getDocument(o))},f=>(this.h.delete(v.toString()),Promise.reject(f))),this.h.set(v.toString(),l)),l}createDocumentData(v){return this.f.$tryCreateDocument(v).then(S=>g.URI.revive(S))}$acceptModelLanguageChanged(v,S){const l=g.URI.revive(v),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(S),this.a.fire(f.document)}$acceptModelSaved(v){const S=g.URI.revive(v),l=this.g.getDocument(S);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(v,S){const l=g.URI.revive(v),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(S),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,S,l){const f=g.URI.revive(v),o=this.g.getDocument(f);if(!o)throw new Error("unknown document");o._acceptIsDirty(l),o.onEvents(S);let i;S.isUndoing?i=L.TextDocumentChangeReason.Undo:S.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.$wn)({document:o.document,contentChanges:S.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(v,S){(0,R.$dN)(v,S)}}e.$cgc=C}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,R.$6h)("IExtHostEditorTabs");class C{constructor(f,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$RM(I.URI.revive(this.b.input.uri));case 2:return new L.$SM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new L.$TM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new L.$UM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$VM(this.b.input.viewType);case 4:return new L.$WM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$XM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$YM;case 9:return new L.$ZM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$1M(this.b.input.providerId);default:return}}}class m{constructor(f,o){this.c=[],this.d="",this.b=f,this.e=o;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const o=this.c.find(i=>i.tabId===f.tabDto.id);if(!o)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(f.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(f){this.b=new T.$Vd,this.c=new T.$Vd,this.e=[],this.a=f.getProxy(b.$0K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,o={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Tf)(f.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(f){const o=new Set(this.e.map(s=>s.groupId)),i=new Set(f.map(s=>s.groupId)),r=(0,D.$L)(o,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),c=[],t=[];this.e=f.map(s=>{const h=new m(s,()=>this.d);return r.added.includes(h.groupId)?c.push(h.apiObject):t.push(h.apiObject),h});const u=(0,g.$Tf)(f.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:c,closed:n,changed:t}))}$acceptTabGroupUpdate(f){const o=this.e.find(i=>i.groupId===f.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const o=this.e.find(r=>r.groupId===f.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(o=>o.apiObject===f)}async i(f,o){const i=[];for(const r of f){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(f,o){const i=[];for(const r of f){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$Pgc=v,e.$Pgc=v=Ge([Ve(0,$.$bN)],v);function S(l){return l.tabs!==void 0}}),define(ke[326],Se([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const f=this.a.indexOf(l);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),f=[];let o,i,r=14,n=14;for(const c of l){let t=o?(0,$.$bf)(o,c):0;for(t===0?i=1:i=n;t<c.length;t++)t+1===c.length?(r=n,n=9):n+=1,f.push([i,c.toUpperCase().charCodeAt(t),n]),f.push([i,c.toLowerCase().charCodeAt(t),n]),i=n;o=c,n=r}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$yZ(f)}}provideDocumentLinks(l){this.c();const f=[],o=b.$zZ.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this.b);for(const i of o){const r=R.DocumentLink.to(i);r.target&&f.push(r)}return f}}class v{constructor(l,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(T.$0K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,f,o,i={}){if(v.j(o),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const r=this.h++;this.b.add(f),this.d.add(f),this.c.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$CF)(l,"fsChunks"),n+=4);let c;i.isReadonly&&(0,C.$jk)(i.isReadonly)&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,f,n,c).catch(u=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=o.onDidChangeFile(u=>{const s=[];for(const h of u){const{uri:a,type:d}=h;if(a.scheme!==f)continue;let k;switch(d){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:k})}this.a.$onFileSystemChange(r,s)});return(0,g.$Rc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:f,ctime:o,mtime:i,size:r,permissions:n}=l;return{type:f,ctime:o,mtime:i,size:r,permissions:n}}$stat(l,f){return Promise.resolve(this.l(l).stat(D.URI.revive(f))).then(o=>v.k(o))}$readdir(l,f){return Promise.resolve(this.l(l).readDirectory(D.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this.l(l).readFile(D.URI.revive(f))).then(o=>y.$je.wrap(o))}$writeFile(l,f,o,i){return Promise.resolve(this.l(l).writeFile(D.URI.revive(f),o.buffer,i))}$delete(l,f,o){return Promise.resolve(this.l(l).delete(D.URI.revive(f),o))}$rename(l,f,o,i){return Promise.resolve(this.l(l).rename(D.URI.revive(f),D.URI.revive(o),i))}$copy(l,f,o,i){const r=this.l(l);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(f),D.URI.revive(o),i))}$mkdir(l,f){return Promise.resolve(this.l(l).createDirectory(D.URI.revive(f)))}$watch(l,f,o,i){const r=this.l(l).watch(D.URI.revive(o),i);this.f.set(f,r)}$unwatch(l,f){const o=this.f.get(f);o&&(o.dispose(),this.f.delete(f))}$open(l,f,o){const i=this.l(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),o))}$close(l,f){const o=this.l(l);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(f))}$read(l,f,o,i){const r=this.l(l);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$je.alloc(i);return Promise.resolve(r.read(f,o,n.buffer,0,i)).then(c=>n.slice(0,c))}$write(l,f,o,i){const r=this.l(l);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(f,o,i.buffer,0,i.byteLength))}l(l){const f=this.c.get(l);if(!f){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return f}}e.$rhc=v}),define(ke[327],Se([1,0,4,34,2,6,15,7,43]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,l,f,o,i){this.a=Math.random(),this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,T.$Mj)(o),n=typeof o=="string",c=i?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(c&&typeof u.session>"u")){if(!i?.ignoreCreateEvents)for(const s of u.created){const h=g.URI.revive(s);r(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const s of u.changed){const h=g.URI.revive(s);r(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const s of u.deleted){const h=g.URI.revive(s);r(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=b.$_K.from(this.i(v,l,o,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,l,f,o){const i=b.$_K.from();if(typeof l=="string")return i;const r=v.getProxy(I.$0K.MainThreadFileSystemEventService);let n=!1;return(l.pattern.includes(T.$Ij)||l.pattern.includes(T.$Jj))&&(n=!0),r.$watch(S.identifier.value,this.a,l.baseUri,{recursive:n,excludes:f?.excludes??[]},!!o),b.$_K.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,S,l){this.j=v,this.k=S,this.l=l,this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.g=new D.$Xd,this.h=new D.$Xd,this.i=new D.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,l,f){return new y(this.j,v,S,this.a.event,R.GlobPattern.from(l),f)}$onFileEvent(v){this.a.fire(new L(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(l=>({oldUri:g.URI.revive(l.source),newUri:g.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(l=>g.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(l=>g.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(l,f,o)=>{const i=function(n){l.call(f,n)};return i.extension=v,S.event(i,void 0,o)}}async $onWillRunFileOperation(v,S,l,f){switch(v){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:g.URI.revive(o.source),newUri:g.URI.revive(o.target)}))},l,f);case 1:return await this.n(this.i,{files:S.map(o=>g.URI.revive(o.target))},l,f);case 0:case 3:return await this.n(this.h,{files:S.map(o=>g.URI.revive(o.target))},l,f)}}async n(v,S,l,f){const o=new Set,i=[];if(await v.fireAsync(S,f,async(n,c)=>{const t=Date.now(),u=await Promise.resolve(n);u instanceof b.$jL&&(i.push([c.extension,u]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:c}=R.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(o)}}}e.$shc=C}),define(ke[328],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,14,11,25,213]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class s{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const ee=this.d.getDocument(B),q=await this.e.provideDocumentSymbols(ee,Q);if(!(0,L.$Kb)(q))return q[0]instanceof I.$sL?q.map(g.DocumentSymbol.from):s.f(q)}static f(B){B=B.slice(0).sort((q,oe)=>{let he=q.location.range.start.compareTo(oe.location.range.start);return he===0&&(he=oe.location.range.end.compareTo(q.location.range.end)),he});const Q=[],ee=[];for(const q of B){const oe={name:q.name||"!!MISSING: name!!",kind:g.SymbolKind.from(q.kind),tags:q.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:g.Range.from(q.location.range),selectionRange:g.Range.from(q.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Q.push(oe);break}const he=ee[ee.length-1];if(y.$Us.containsRange(he.range,oe.range)&&!y.$Us.equalsRange(he.range,oe.range)){he.children?.push(oe),ee.push(oe);break}ee.pop()}}return Q}}class h{constructor(B,Q,ee,q,oe,he){this.f=B,this.g=Q,this.h=ee,this.j=q,this.k=oe,this.l=he,this.d=new i.$agc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Q){const ee=this.f.getDocument(B),q=await this.h.provideCodeLenses(ee,Q);if(!q||Q.isCancellationRequested)return;const oe=this.d.add(q),he=new l.$Sc;this.e.set(oe,he);const Le={cacheId:oe,lenses:[]};for(let je=0;je<q.length;je++)Le.lenses.push({cacheId:[oe,je],range:g.Range.from(q[je].range),command:this.g.toInternal(q[je].command,he)});return Le}async resolveCodeLens(B,Q){const ee=B.cacheId&&this.d.get(...B.cacheId);if(!ee)return;let q;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?q=ee:q=await this.h.resolveCodeLens(ee,Q),q||(q=ee),Q.isCancellationRequested)return;const oe=B.cacheId&&this.e.get(B.cacheId[0]);if(oe){if(!q.command){const he=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,he),this.l.error(he);return}return B.command=this.g.toInternal(q.command,oe),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function a(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class d{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideDefinition(q,oe,ee);return a(he)}}class k{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideDeclaration(q,oe,ee);return a(he)}}class A{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideImplementation(q,oe,ee);return a(he)}}class p{constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideTypeDefinition(q,oe,ee);return a(he)}}class w{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideHover(q,oe,ee);if(!(!he||(0,L.$Kb)(he.contents)))return he.range||(he.range=q.getWordRangeAtPosition(oe)),he.range||(he.range=new I.$bL(oe,oe)),g.Hover.from(he)}}class E{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideEvaluatableExpression(q,oe,ee);if(he)return g.EvaluatableExpression.from(he)}}class P{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,ee,q){const oe=this.d.getDocument(B),he=await this.e.provideInlineValues(oe,g.Range.to(Q),g.InlineValueContext.to(ee),q);if(Array.isArray(he))return he.map(Le=>g.InlineValue.from(Le))}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideDocumentHighlights(q,oe,ee);if(Array.isArray(he))return he.map(g.DocumentHighlight.from)}}class z{constructor(B,Q){this.d=B,this.e=Q}async provideMultiDocumentHighlights(B,Q,ee,q){const oe=this.d.getDocument(B),he=ee.map(He=>this.d.getDocument(He)),Le=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(oe,Le,he,q);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,ee){const q=this.d.getDocument(B),oe=g.Position.to(Q),he=await this.e.provideLinkedEditingRanges(q,oe,ee);if(he&&Array.isArray(he.ranges))return{ranges:(0,L.$Hb)(he.ranges.map(g.Range.from)),wordPattern:he.wordPattern}}}class j{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,ee,q){const oe=this.d.getDocument(B),he=g.Position.to(Q),Le=await this.e.provideReferences(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.location.from)}}class M{static{this.d=1e3}constructor(B,Q,ee,q,oe,he,Le){this.g=B,this.h=Q,this.j=ee,this.k=q,this.l=oe,this.m=he,this.n=Le,this.e=new i.$agc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,ee,q){const oe=this.g.getDocument(B),he=m.$Ws.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Le=[];for(const ot of this.j.getDiagnostics(B))if(he.intersection(ot.range)&&Le.push(ot)>M.d)break;const je={diagnostics:Le,only:ee.only?new I.$uL(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,he,je,q);if(!(0,L.$Lb)(He)||q.isCancellationRequested)return;const Je=this.e.add(He),_e=new l.$Sc;this.f.set(Je,_e);const ct=[];for(let ot=0;ot<He.length;ot++){const rt=He[ot];rt&&(M.o(rt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)})):(je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ct.push({cacheId:[Je,ot],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(g.Diagnostic.from),edit:rt.edit&&g.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$BF)(this.m,"codeActionAI")?rt.isAI:!1,disabled:rt.disabled?.reason})))}return{cacheId:Je,actions:ct}}async resolveCodeAction(B,Q){const[ee,q]=B,oe=this.e.get(ee,q);if(!oe||M.o(oe))return{};if(!this.k.resolveCodeAction)return{};const he=await this.k.resolveCodeAction(oe,Q)??oe;let Le;he.edit&&(Le=g.WorkspaceEdit.from(he.edit,void 0));let je;if(he.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(he.command,He))}return{edit:Le,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class O{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,q,oe){this.d=B,this.e=Q,this.f=ee,this.g=q,this.h=oe}async prepareDocumentPaste(B,Q,ee,q){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(B),he=Q.map(He=>g.Range.to(He)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(oe,he,Le,q),q.isCancellationRequested)return;const je=Array.from(Le).filter(([,He])=>!(He instanceof I.$1L));return g.DataTransfer.from(je)}async providePasteEdits(B,Q,ee,q,oe){if(!this.f.provideDocumentPasteEdits)return;const he=this.e.getDocument(Q),Le=ee.map(Je=>g.Range.to(Je)),je=g.DataTransfer.toDataTransfer(q,async Je=>(await this.d.$resolvePasteFileData(this.g,B,Je)).buffer),He=await this.f.provideDocumentPasteEdits(he,Le,je,oe);if(He)return{label:He.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:O.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class U{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,ee){const q=this.d.getDocument(B),oe=await this.e.provideDocumentFormattingEdits(q,Q,ee);if(Array.isArray(oe))return oe.map(g.TextEdit.from)}}class Y{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,ee,q){const oe=this.d.getDocument(B),he=g.Range.to(Q),Le=await this.e.provideDocumentRangeFormattingEdits(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,ee,q){(0,C.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(B),he=Q.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class le{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ee,q,oe){const he=this.d.getDocument(B),Le=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(he,Le,ee,q,oe);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class Z{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$agc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const ee=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,L.$Lb)(ee))return{symbols:[]};const q=this.d.add(ee),oe={cacheId:q,symbols:[]};for(let he=0;he<ee.length;he++){const Le=ee[he];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}oe.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[q,he]})}return oe}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this.d.get(...B.cacheId);if(ee){const q=await this.e.resolveWorkspaceSymbol(ee,Q);return q&&(0,T.$yn)(B,g.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class J{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideRenameEdits(B,Q,ee,q){const oe=this.d.getDocument(B),he=g.Position.to(Q);try{const Le=await this.e.provideRenameEdits(oe,he,ee,q);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=J.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(B,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(B),oe=g.Position.to(Q);try{const he=await this.e.prepareRename(q,oe,ee);let Le,je;if(I.$bL.isRange(he)?(Le=he,je=q.getText(he)):(0,C.$Kf)(he)&&(Le=he.range,je=he.placeholder),!Le||!je)return;if(Le.start.line>oe.line||Le.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(he){const Le=J.g(he);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(he)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,Q){this.resultId=B,this.tokens=Q}}class ue{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,ee){const q=this.f.getDocument(B),oe=Q!==0?this.d.get(Q):null;let he=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(q,ee);return oe&&this.d.delete(Q),he?(he=ue.h(he),this.o(ue.n(oe,he),he)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ue.j(B)?ue.k(B)?B:new I.$rM(new Uint32Array(B.data),B.resultId):ue.l(B)?ue.m(B)?B:new I.$tM(B.edits.map(Q=>new I.$sM(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!ue.j(Q)||!B||!B.tokens)return Q;const ee=B.tokens,q=ee.length,oe=Q.data,he=oe.length;let Le=0;const je=Math.min(q,he);for(;Le<je&&ee[Le]===oe[Le];)Le++;if(Le===q&&Le===he)return new I.$tM([],Q.resultId);let He=0;const Je=je-Le;for(;He<Je&&ee[q-He-1]===oe[he-He-1];)He++;return new I.$tM([{start:Le,deleteCount:q-Le-He,data:oe.subarray(Le,he-He)}],Q.resultId)}o(B,Q){if(ue.j(B)){const ee=this.e++;return this.d.set(ee,new X(B.resultId,B.data)),(0,f.$w$)({id:ee,type:"full",data:B.data})}if(ue.l(B)){const ee=this.e++;return ue.j(Q)?this.d.set(ee,new X(Q.resultId,Q.data)):this.d.set(ee,new X(B.resultId)),(0,f.$w$)({id:ee,type:"delta",deltas:(B.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class x{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,ee){const q=this.d.getDocument(B),oe=await this.e.provideDocumentRangeSemanticTokens(q,g.Range.to(Q),ee);return oe?this.f(oe):null}f(B){return(0,f.$w$)({id:0,type:"full",data:B.data})}}class be{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,ee,q,oe){this.f=B,this.g=Q,this.h=ee,this.j=q,this.k=oe,this.d=new i.$agc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,ee,q){const oe=this.f.getDocument(B),he=g.Position.to(Q),Le=oe.getWordRangeAtPosition(he)||new I.$bL(he,he),je=Le.with({end:he}),He=new r.$Rd,Je=await this.h.provideCompletionItems(oe,he,q,g.CompletionContext.to(ee));if(!Je||q.isCancellationRequested)return;const _e=Array.isArray(Je)?new I.$HL(Je):Je,ct=be.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),ot=new l.$Sc;this.e.set(ct,ot);const rt=[],Ae={x:ct,b:rt,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let ze=0;ze<_e.items.length;ze++){const Re=_e.items[ze],Xe=this.l(Re,[ct,ze],je,Le);rt.push(Xe)}return Ae}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=this.l(ee,B),oe=await this.h.resolveCompletionItem(ee,Q);if(!oe)return;const he=this.l(oe,B);return(q.h!==he.h||q.i!==he.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==he.n||q.o!==he.o||!(0,T.$zn)(q.p,he.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,ee,q){const oe=this.e.get(Q[0]);if(!oe)throw Error("DisposableStore is missing...");const he=this.g.toInternal(B.command,oe),Le={x:Q,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=B.textEdit.newText):typeof B.insertText=="string"?Le.h=B.insertText:B.insertText instanceof I.$kL&&(Le.h=B.insertText.value,Le.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),I.$bL.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!q?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class ce{async provideInlineCompletions(B,Q,ee,q){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,ee){}handlePartialAccept(B,Q,ee){}}class K extends ce{constructor(B,Q,ee,q){super(),this.f=B,this.g=Q,this.h=ee,this.j=q,this.d=new V,this.e=(0,t.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,ee,q){const oe=this.g.getDocument(B),he=g.Position.to(Q),Le=await this.h.provideInlineCompletionItems(oe,he,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},q);if(!Le||q.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,He=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Je=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((ot,rt)=>{let Ae;ot.command&&(_e||(_e=new l.$Sc),Ae=this.j.toInternal(ot.command,_e));const ze=ot.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:ot.filterText,range:ot.range?g.Range.from(ot.range):void 0,command:Ae,idx:rt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:He.map(ot=>(_e||(_e=new l.$Sc),this.j.toInternal(ot,_e))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,ee){const q=this.d.get(B)?.items[Q];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,ee)}handlePartialAccept(B,Q,ee){const q=this.d.get(B)?.items[Q];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,ee)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class re{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$agc("SignatureHelp")}async provideSignatureHelp(B,Q,ee,q){const oe=this.e.getDocument(B),he=g.Position.to(Q),Le=this.g(ee),je=await this.f.provideSignatureHelp(oe,he,q,Le);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(B){let Q;if(B.activeSignatureHelp){const ee=g.SignatureHelp.to(B.activeSignatureHelp),q=this.d.get(B.activeSignatureHelp.id,0);q?(Q=q,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Q,ee,q,oe){this.f=B,this.g=Q,this.h=ee,this.j=q,this.k=oe,this.d=new i.$agc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,ee){const q=this.f.getDocument(B),oe=g.Range.to(Q),he=await this.h.provideInlayHints(q,oe,ee);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(he);this.e.set(Le,new l.$Sc);const je={hints:[],cacheId:Le};for(let He=0;He<he.length;He++)this.l(he[He],oe)&&je.hints.push(this.m(he[He],[Le,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=await this.h.resolveInlayHint(ee,Q);if(q&&this.l(q))return this.m(q,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const q={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")q.label=B.label;else{const oe=[];q.label=oe;for(const he of B.label){if(!he.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:he.value,tooltip:g.MarkdownString.fromStrict(he.tooltip)};I.$lL.isLocation(he.location)&&(Le.location=g.location.from(he.location)),he.command&&(Le.command=this.g.toInternal(he.command,ee)),oe.push(Le)}}return q}}class de{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$agc("DocumentLink")}async provideLinks(B,Q){const ee=this.e.getDocument(B),q=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(q)||q.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(g.DocumentLink.from)};{const oe=this.d.add(q),he={links:[],cacheId:oe};for(let Le=0;Le<q.length;Le++){if(!de.g(q[Le]))continue;const je=g.DocumentLink.from(q[Le]);je.cacheId=[oe,Le],he.links.push(je)}return he}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=await this.f.resolveDocumentLink(ee,Q);if(!(!q||!de.g(q)))return g.DocumentLink.from(q)}releaseLinks(B){this.d.delete(B)}}class ge{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const ee=this.d.getDocument(B),q=await this.e.provideDocumentColors(ee,Q);return Array.isArray(q)?q.map(he=>({color:g.Color.from(he.color),range:g.Range.from(he.range)})):[]}async provideColorPresentations(B,Q,ee){const q=this.d.getDocument(B),oe=g.Range.to(Q.range),he=g.Color.to(Q.color),Le=await this.e.provideColorPresentations(he,{document:q,range:oe},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,ee){const q=this.d.getDocument(B),oe=await this.e.provideFoldingRanges(q,Q,ee);if(Array.isArray(oe))return oe.map(g.FoldingRange.from)}}class te{constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideSelectionRanges(B,Q,ee){const q=this.d.getDocument(B),oe=Q.map(g.Position.to),he=await this.e.provideSelectionRanges(q,oe,ee);if(!(0,L.$Lb)(he))return[];if(he.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<oe.length;je++){const He=[];Le.push(He);let Je=oe[je],_e=he[je];for(;;){if(!_e.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Je=_e.range,_e=_e.parent}}return Le}}class G{constructor(B,Q){this.f=B,this.g=Q,this.d=new o.$gN(""),this.e=new Map}async prepareSession(B,Q,ee){const q=this.f.getDocument(B),oe=g.Position.to(Q),he=await this.g.prepareCallHierarchy(q,oe,ee);if(!he)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(he)?he.map(je=>this.h(Le,je)):[this.h(Le,he)]}async provideCallsTo(B,Q,ee){const q=this.j(B,Q);if(!q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(q,ee);if(oe)return oe.map(he=>({from:this.h(B,he.from),fromRanges:he.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(B,Q,ee){const q=this.j(B,Q);if(!q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(q,ee);if(oe)return oe.map(he=>({to:this.h(B,he.to),fromRanges:he.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),q=g.CallHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(q._itemId,Q),q}j(B,Q){return this.e.get(B)?.get(Q)}}class ie{constructor(B,Q){this.f=B,this.g=Q,this.d=new o.$gN(""),this.e=new Map}async prepareSession(B,Q,ee){const q=this.f.getDocument(B),oe=g.Position.to(Q),he=await this.g.prepareTypeHierarchy(q,oe,ee);if(!he)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(he)?he.map(je=>this.h(Le,je)):[this.h(Le,he)]}async provideSupertypes(B,Q,ee){const q=this.j(B,Q);if(!q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(q,ee);if(oe)return oe.map(he=>this.h(B,he))}async provideSubtypes(B,Q,ee){const q=this.j(B,Q);if(!q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(q,ee);if(oe)return oe.map(he=>this.h(B,he))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),q=g.TypeHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(q._itemId,Q),q}j(B,Q){return this.e.get(B)?.get(Q)}}class fe{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,q,oe){this.d=B,this.e=Q,this.f=ee,this.g=q,this.h=oe}async provideDocumentOnDropEdits(B,Q,ee,q,oe){const he=this.e.getDocument(Q),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(q,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Je)).buffer),He=await this.f.provideDocumentDropEdits(he,Le,je,oe);if(He)return{label:He.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:fe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class ve{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,ee,q){const oe=D.URI.revive(B),he=this.d.getDocument(oe),Le=ee.documents.map(Je=>Je.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(ct=>g.Range.to(ct))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(he,Q,je,q);return He?g.WorkspaceEdit.from(He):null}}class Pe{constructor(B,Q){this.adapter=B,this.extension=Q}}class we{static{this.d=0}constructor(B,Q,ee,q,oe,he,Le,je){this.g=Q,this.h=ee,this.j=q,this.k=oe,this.l=he,this.m=Le,this.n=je,this.f=new Map,this.e=B.getProxy(b.$0K.MainThreadLanguageFeatures)}o(B,Q){return g.DocumentSelector.from(B,this.g,Q)}p(B){return new I.$_K(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return we.d++}async s(B,Q,ee,q,oe,he=!1){const Le=this.f.get(B);if(!Le||!(Le.adapter instanceof Q))return q;const je=Date.now();he||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Le.adapter,Le.extension);return Promise.resolve(He).catch(Je=>{(0,n.$4)(Je)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Le.extension.identifier,Je))}).finally(()=>{he||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),v.CancellationToken.isCancellationToken(oe)?(0,c.$Vg)(He,oe):He}t(B,Q){const ee=this.q();return this.f.set(ee,new Pe(B,Q)),ee}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ee,q){const oe=this.t(new s(this.h,ee),B),he=q&&q.label||we.u(B);return this.e.$registerDocumentSymbolProvider(oe,this.o(Q,B),he),this.p(oe)}$provideDocumentSymbols(B,Q,ee){return this.s(B,s,q=>q.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(B,Q,ee){const q=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Pe(new h(this.h,this.j.converter,ee,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(q,this.o(Q,B),oe);let he=this.p(q);if(oe!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));he=I.$_K.from(he,Le)}return he}$provideCodeLenses(B,Q,ee){return this.s(B,h,q=>q.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(B,Q,ee){return this.s(B,h,q=>q.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,h,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,ee){const q=this.t(new d(this.h,ee),B);return this.e.$registerDefinitionSupport(q,this.o(Q,B)),this.p(q)}$provideDefinition(B,Q,ee,q){return this.s(B,d,oe=>oe.provideDefinition(D.URI.revive(Q),ee,q),[],q)}registerDeclarationProvider(B,Q,ee){const q=this.t(new k(this.h,ee),B);return this.e.$registerDeclarationSupport(q,this.o(Q,B)),this.p(q)}$provideDeclaration(B,Q,ee,q){return this.s(B,k,oe=>oe.provideDeclaration(D.URI.revive(Q),ee,q),[],q)}registerImplementationProvider(B,Q,ee){const q=this.t(new A(this.h,ee),B);return this.e.$registerImplementationSupport(q,this.o(Q,B)),this.p(q)}$provideImplementation(B,Q,ee,q){return this.s(B,A,oe=>oe.provideImplementation(D.URI.revive(Q),ee,q),[],q)}registerTypeDefinitionProvider(B,Q,ee){const q=this.t(new p(this.h,ee),B);return this.e.$registerTypeDefinitionSupport(q,this.o(Q,B)),this.p(q)}$provideTypeDefinition(B,Q,ee,q){return this.s(B,p,oe=>oe.provideTypeDefinition(D.URI.revive(Q),ee,q),[],q)}registerHoverProvider(B,Q,ee,q){const oe=this.t(new w(this.h,ee),B);return this.e.$registerHoverProvider(oe,this.o(Q,B)),this.p(oe)}$provideHover(B,Q,ee,q){return this.s(B,w,oe=>oe.provideHover(D.URI.revive(Q),ee,q),void 0,q)}registerEvaluatableExpressionProvider(B,Q,ee,q){const oe=this.t(new E(this.h,ee),B);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Q,B)),this.p(oe)}$provideEvaluatableExpression(B,Q,ee,q){return this.s(B,E,oe=>oe.provideEvaluatableExpression(D.URI.revive(Q),ee,q),void 0,q)}registerInlineValuesProvider(B,Q,ee,q){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new P(this.h,ee),B);this.e.$registerInlineValuesProvider(he,this.o(Q,B),oe);let Le=this.p(he);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Le=I.$_K.from(Le,je)}return Le}$provideInlineValues(B,Q,ee,q,oe){return this.s(B,P,he=>he.provideInlineValues(D.URI.revive(Q),ee,q,oe),void 0,oe)}registerDocumentHighlightProvider(B,Q,ee){const q=this.t(new F(this.h,ee),B);return this.e.$registerDocumentHighlightProvider(q,this.o(Q,B)),this.p(q)}registerMultiDocumentHighlightProvider(B,Q,ee){const q=this.t(new z(this.h,ee),B);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(Q,B)),this.p(q)}$provideDocumentHighlights(B,Q,ee,q){return this.s(B,F,oe=>oe.provideDocumentHighlights(D.URI.revive(Q),ee,q),void 0,q)}$provideMultiDocumentHighlights(B,Q,ee,q,oe){return this.s(B,z,he=>he.provideMultiDocumentHighlights(D.URI.revive(Q),ee,q.map(Le=>D.URI.revive(Le)),oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Q,ee){const q=this.t(new N(this.h,ee),B);return this.e.$registerLinkedEditingRangeProvider(q,this.o(Q,B)),this.p(q)}$provideLinkedEditingRanges(B,Q,ee,q){return this.s(B,N,async oe=>{const he=await oe.provideLinkedEditingRanges(D.URI.revive(Q),ee,q);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?we.w(he.wordPattern):void 0}},void 0,q)}registerReferenceProvider(B,Q,ee){const q=this.t(new j(this.h,ee),B);return this.e.$registerReferenceSupport(q,this.o(Q,B)),this.p(q)}$provideReferences(B,Q,ee,q,oe){return this.s(B,j,he=>he.provideReferences(D.URI.revive(Q),ee,q,oe),void 0,oe)}registerCodeActionProvider(B,Q,ee,q){const oe=new l.$Sc,he=this.t(new M(this.h,this.j.converter,this.k,ee,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(he,this.o(Q,B),{providedKinds:q?.providedCodeActionKinds?.map(Le=>Le.value),documentation:q?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,oe)}))},we.u(B),!!ee.resolveCodeAction),oe.add(this.p(he)),oe}$provideCodeActions(B,Q,ee,q,oe){return this.s(B,M,he=>he.provideCodeActions(D.URI.revive(Q),ee,q,oe),void 0,oe)}$resolveCodeAction(B,Q,ee){return this.s(B,M,q=>q.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(B,Q){this.s(B,M,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,ee){const q=this.t(new U(this.h,ee),B);return this.e.$registerDocumentFormattingSupport(q,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(q)}$provideDocumentFormattingEdits(B,Q,ee,q){return this.s(B,U,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Q),ee,q),void 0,q)}registerDocumentRangeFormattingEditProvider(B,Q,ee){const q=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new Y(this.h,ee),B);return this.e.$registerRangeFormattingSupport(oe,this.o(Q,B),B.identifier,B.displayName||B.name,q),this.p(oe)}$provideDocumentRangeFormattingEdits(B,Q,ee,q,oe){return this.s(B,Y,he=>he.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,q,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(B,Q,ee,q,oe){return this.s(B,Y,he=>he.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(B,Q,ee,q){const oe=this.t(new le(this.h,ee),B);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Q,B),q,B.identifier),this.p(oe)}$provideOnTypeFormattingEdits(B,Q,ee,q,oe,he){return this.s(B,le,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,q,oe,he),void 0,he)}registerWorkspaceSymbolProvider(B,Q){const ee=this.t(new Z(Q,this.l),B);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(B,Q,ee){return this.s(B,Z,q=>q.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,Q,ee){return this.s(B,Z,q=>q.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,Z,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,ee){const q=this.t(new J(this.h,ee,this.l),B);return this.e.$registerRenameSupport(q,this.o(Q,B),J.supportsResolving(ee)),this.p(q)}$provideRenameEdits(B,Q,ee,q,oe){return this.s(B,J,he=>he.provideRenameEdits(D.URI.revive(Q),ee,q,oe),void 0,oe)}$resolveRenameLocation(B,Q,ee,q){return this.s(B,J,oe=>oe.resolveRenameLocation(D.URI.revive(Q),ee,q),void 0,q)}registerDocumentSemanticTokensProvider(B,Q,ee,q){const oe=this.t(new ue(this.h,ee),B),he=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Q,B),q,he);let Le=this.p(oe);if(he){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(he));Le=I.$_K.from(Le,je)}return Le}$provideDocumentSemanticTokens(B,Q,ee,q){return this.s(B,ue,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Q),ee,q),null,q)}$releaseDocumentSemanticTokens(B,Q){this.s(B,ue,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ee,q){const oe=this.t(new x(this.h,ee),B);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Q,B),q),this.p(oe)}$provideDocumentRangeSemanticTokens(B,Q,ee,q){return this.s(B,x,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,q),null,q)}registerCompletionItemProvider(B,Q,ee,q){const oe=this.t(new be(this.h,this.j.converter,ee,this.m,B),B);return this.e.$registerCompletionsProvider(oe,this.o(Q,B),q,be.supportsResolving(ee),B.identifier),this.p(oe)}$provideCompletionItems(B,Q,ee,q,oe){return this.s(B,be,he=>he.provideCompletionItems(D.URI.revive(Q),ee,q,oe),void 0,oe)}$resolveCompletionItem(B,Q,ee){return this.s(B,be,q=>q.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(B,Q){this.s(B,be,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,ee,q){const oe=new K(B,this.h,ee,this.j.converter),he=this.t(oe,B);return this.e.$registerInlineCompletionsSupport(he,this.o(Q,B),oe.supportsHandleEvents,S.$lm.toKey(B.identifier.value),q?.yieldTo?.map(Le=>S.$lm.toKey(Le))||[]),this.p(he)}$provideInlineCompletions(B,Q,ee,q,oe){return this.s(B,ce,he=>he.provideInlineCompletions(D.URI.revive(Q),ee,q,oe),void 0,oe)}$handleInlineCompletionDidShow(B,Q,ee,q){this.s(B,ce,async oe=>{oe.handleDidShowCompletionItem(Q,ee,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,ee,q){this.s(B,ce,async oe=>{oe.handlePartialAccept(Q,ee,q)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ce,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,ee,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,he=this.t(new re(this.h,ee),B);return this.e.$registerSignatureHelpProvider(he,this.o(Q,B),oe),this.p(he)}$provideSignatureHelp(B,Q,ee,q,oe){return this.s(B,re,he=>he.provideSignatureHelp(D.URI.revive(Q),ee,q,oe),void 0,oe)}$releaseSignatureHelp(B,Q){this.s(B,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,ee){const q=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,B),B);this.e.$registerInlayHintsProvider(oe,this.o(Q,B),typeof ee.resolveInlayHint=="function",q,we.u(B));let he=this.p(oe);if(q!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(q));he=I.$_K.from(he,Le)}return he}$provideInlayHints(B,Q,ee,q){return this.s(B,ye,oe=>oe.provideInlayHints(D.URI.revive(Q),ee,q),void 0,q)}$resolveInlayHint(B,Q,ee){return this.s(B,ye,q=>q.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(B,Q){this.s(B,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,ee){const q=this.t(new de(this.h,ee),B);return this.e.$registerDocumentLinkProvider(q,this.o(Q,B),typeof ee.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(B,Q,ee){return this.s(B,de,q=>q.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(B,Q,ee){return this.s(B,de,q=>q.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,de,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,ee){const q=this.t(new ge(this.h,ee),B);return this.e.$registerDocumentColorProvider(q,this.o(Q,B)),this.p(q)}$provideDocumentColors(B,Q,ee){return this.s(B,ge,q=>q.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(B,Q,ee,q){return this.s(B,ge,oe=>oe.provideColorPresentations(D.URI.revive(Q),ee,q),void 0,q)}registerFoldingRangeProvider(B,Q,ee){const q=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Pe(new _(this.h,ee),B)),this.e.$registerFoldingRangeProvider(q,this.o(Q,B),B.identifier,oe);let he=this.p(q);if(oe!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));he=I.$_K.from(he,Le)}return he}$provideFoldingRanges(B,Q,ee,q){return this.s(B,_,oe=>oe.provideFoldingRanges(D.URI.revive(Q),ee,q),void 0,q)}registerSelectionRangeProvider(B,Q,ee){const q=this.t(new te(this.h,ee,this.l),B);return this.e.$registerSelectionRangeProvider(q,this.o(Q,B)),this.p(q)}$provideSelectionRanges(B,Q,ee,q){return this.s(B,te,oe=>oe.provideSelectionRanges(D.URI.revive(Q),ee,q),[],q)}registerCallHierarchyProvider(B,Q,ee){const q=this.t(new G(this.h,ee),B);return this.e.$registerCallHierarchyProvider(q,this.o(Q,B)),this.p(q)}$prepareCallHierarchy(B,Q,ee,q){return this.s(B,G,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,q)),void 0,q)}$provideCallHierarchyIncomingCalls(B,Q,ee,q){return this.s(B,G,oe=>oe.provideCallsTo(Q,ee,q),void 0,q)}$provideCallHierarchyOutgoingCalls(B,Q,ee,q){return this.s(B,G,oe=>oe.provideCallsFrom(Q,ee,q),void 0,q)}$releaseCallHierarchy(B,Q){this.s(B,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,ee){const q=this.t(new ie(this.h,ee),B);return this.e.$registerTypeHierarchyProvider(q,this.o(Q,B)),this.p(q)}$prepareTypeHierarchy(B,Q,ee,q){return this.s(B,ie,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,q)),void 0,q)}$provideTypeHierarchySupertypes(B,Q,ee,q){return this.s(B,ie,oe=>oe.provideSupertypes(Q,ee,q),void 0,q)}$provideTypeHierarchySubtypes(B,Q,ee,q){return this.s(B,ie,oe=>oe.provideSubtypes(Q,ee,q),void 0,q)}$releaseTypeHierarchy(B,Q){this.s(B,ie,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,ee,q){const oe=this.q();this.f.set(oe,new Pe(new fe(this.e,this.h,ee,oe,B),B));const he=(0,t.$BF)(B,"dropMetadata")&&q?fe.toInternalProviderId(B.identifier.value,q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Q,B),he,(0,t.$BF)(B,"dropMetadata")?q:void 0),this.p(oe)}$provideDocumentOnDropEdits(B,Q,ee,q,oe,he){return this.s(B,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(Q,D.URI.revive(ee),q,oe,he)),void 0,void 0)}registerMappedEditsProvider(B,Q,ee){const q=this.t(new ve(this.h,ee),B);return this.e.$registerMappedEditsProvider(q,this.o(Q,B)),this.p(q)}$provideMappedEdits(B,Q,ee,q,oe){return this.s(B,ve,he=>Promise.resolve(he.provideMappedEdits(Q,ee,q,oe)),null,oe)}registerDocumentPasteEditProvider(B,Q,ee,q){const oe=this.q();this.f.set(oe,new Pe(new O(this.e,this.h,ee,oe,B),B));const he=O.toInternalProviderId(B.identifier.value,q.id);return this.e.$registerPasteEditProvider(oe,this.o(Q,B),he,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(B,Q,ee,q,oe){return this.s(B,O,he=>he.prepareDocumentPaste(D.URI.revive(Q),ee,q,oe),void 0,oe)}$providePasteEdits(B,Q,ee,q,oe,he){return this.s(B,O,Le=>Le.providePasteEdits(Q,D.URI.revive(ee),q,oe,he),void 0,he)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:we.w(B.decreaseIndentPattern),increaseIndentPattern:we.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?we.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?we.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:we.w(B.beforeText),afterText:B.afterText?we.w(B.afterText):void 0,previousLineText:B.previousLineText?we.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(we.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(we.C)}setLanguageConfiguration(B,Q,ee){const{wordPattern:q}=ee;if(q&&(0,$.$Ye)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(Q,q):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const oe=this.q(),he={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?we.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?we.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?we.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?we.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Q,he),this.p(oe)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$kgc=we}),define(ke[329],Se([1,0,6,15,7,39,11,3,25]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class y{constructor(C,m,v,S){this.c=m,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$0K.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,S=T.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,S),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$bL(m.line,m.character,m.line,m.character)};if(!l)return f;const o={range:T.Range.to(l.range),type:T.TokenType.to(l.type)};return!o.range.contains(m)||v!==C.version?f:o}createLanguageStatusItem(C,m,v){const S=this.f++,l=this.a,f=this.g,o=`${C.identifier.value}/${m}`;if(f.has(o))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(o);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new b.$Sc,c=()=>{if(r?.dispose(),!f.has(o)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,R.$8g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),l.$removeLanguageStatus(S),f.delete(o)},get id(){return i.id},get name(){return i.name},set name(u){i.name=u,c()},get selector(){return i.selector},set selector(u){i.selector=u,c()},get text(){return i.text},set text(u){i.text=u,c()},set text2(u){(0,$.$CF)(C,"languageStatusText"),i.text=u,c()},get text2(){return(0,$.$CF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(u){i.detail=u,c()},get severity(){return i.severity},set severity(u){i.severity=u,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(u){i.accessibilityInformation=u,c()},get command(){return i.command},set command(u){i.command=u,c()},get busy(){return i.busy},set busy(u){i.busy=u,c()}};return c(),t}}e.$Jhc=y}),define(ke[330],Se([1,0,16,2,15,7,118]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;class b{constructor(C,m,v,S){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new I.$xM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const S=v.map(g.NotebookCellOutputItem.to),l=this.a.find(f=>f.id===C);if(l&&(m||(l.items.length=0),l.items.push(...S),l.items.length>1&&l.items.every(f=>R.$bJ(f.mime)))){const f=new Map,o=[];l.items.forEach(i=>{let r;f.has(i.mime)?r=f.get(i.mime):(r=[],f.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),l.items.length=0,o.forEach(i=>{const r=R.$cJ(f.get(i));l.items.push({mime:i,data:r.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$uhc=$;class y{static{this.a=0}constructor(C,m,v,S,l){this.k=C,this.l=m,this.m=v,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},l=[];for(const o of C.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),l.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),l.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const f=new Map;for(let o=0;o<l.length;o++){const i=l[o],r=f.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const S=[],l=[],f=[];if(C.reverse().forEach(o=>{const r=o[2].map(t=>{const u=new $(this,this.l,t);return m||l.push($.asModelAddData(this.apiNotebook,t)),u}),n=new b(o[0],o[1],[],r),c=this.b.splice(o[0],o[1],...r);for(const t of c)f.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),v)for(const o of S)v.push(o.asApiEvent())}s(C,m,v,S){const l=this.b.splice(C,m);this.b.splice(v,0,...l);const f=[new b(C,m,l.map(o=>o.apiCell),[]),new b(v,0,[],l)];for(const o of f)S.push(o.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,S){this.b[C].setOutputItems(m,v,S)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$vhc=y}),define(ke[331],Se([1,0,4,2,15,7]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class R{constructor($,y,L,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=L,this.f=C,this.a=new D.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,L,C)=>{const m=function(S){y.call(L,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,L){const C=T.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},L,async(l,f)=>{const o=Date.now(),i=await await Promise.resolve(l);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof I.$jL?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const l of v){const{edits:f}=g.WorkspaceEdit.from(l);S.edits=S.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Lhc=R}),define(ke[149],Se([1,0,14,15,7]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,L,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=L,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$xM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,T.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$whc=I}),define(ke[332],Se([1,0,4,13,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let I=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Vd,this.b=new D.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$Nhc=I,e.$Nhc=I=Ge([Ve(0,T.$nj)],I)}),define(ke[333],Se([1,0,4,6,149]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(T.$0K.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const L=this.c.getEditorById(b);this.a.get($)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(L=>L.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(L,C,m)=>this.d($).event(L,C,m),postMessage:(L,C)=>{g.$whc.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const m=C&&g.$whc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,L)}}}d(b){let $=this.a.get(b);return $||($=new D.$Vd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Qhc=I}),define(ke[334],Se([1,0,15,86,21,52,14]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,v){const S=this.b++,{title:l,location:f,cancellable:o}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(f),title:l,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(S,v,!!o)}d(C,m,v){let S;v&&(S=new g.$6d,this.c.set(C,S));const l=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let f;try{f=m(new y(this.a,C),v&&S?S.token:g.CancellationToken.None)}catch(o){throw l(C),o}return f.then(o=>l(C),o=>l(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$Uhc=b;function $(L,C){return L.message=C.message,typeof C.increment=="number"&&(typeof L.increment=="number"?L.increment+=C.increment:L.increment=C.increment),L}class y extends T.$vv{constructor(C,m){super(v=>this.throttledReport(v)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,I.$zh)(100,(L,C)=>$(L,C),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ke[335],Se([1,0,2,6,11,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(T.$0K.MainThreadQuickDiff)}$provideOriginalResource($,y,L){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Yg)(()=>m.provideOriginalResource(C,L)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,L,C){const m=R.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),L,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Vhc=R}),define(ke[336],Se([1,0,21,4,3,6,2,7,14,19,39,61,25,15]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;function S(l,f,o){const i=l.getProxy(I.$0K.MainThreadQuickOpen);class r{constructor(k,A){this.e=new Map,this.f=0,this.a=k,this.b=A}showQuickPick(k,A,p,w=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(A),P=++this.f,F=i.$show(P,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},w),z={},N=F.then(()=>z);return Promise.race([N,E]).then(j=>{if(j===z)return;const M=(0,m.$BF)(k,"quickPickItemTooltip");return E.then(O=>{const U=[];for(let Y=0;Y<O.length;Y++){const le=O[Y];if(typeof le=="string")U.push({label:le,handle:Y});else if(le.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:le.label});else{le.tooltip&&!M&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=le.iconPath?s(le.iconPath):void 0;U.push({label:le.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:M?v.MarkdownString.fromStrict(le.tooltip):void 0,handle:Y})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=Y=>{p.onDidSelectItem(O[Y])}),i.$setItems(P,U),F.then(Y=>{if(typeof Y=="number")return O[Y];if(Array.isArray(Y))return Y.map(le=>O[le])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(P,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,A=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",A).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(k){if(!this.d)return;const A=await this.d(k);if(!A||typeof A=="string")return A;let p;switch(A.severity){case b.InputBoxValidationSeverity.Info:p=L.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=L.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=L.default.Error;break;default:p=A.message?L.default.Error:L.default.Ignore;break}return{content:A.message,severity:p}}async showWorkspaceFolderPick(k,A=D.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!p)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(E=>E.uri.toString()===p.uri.toString())}createQuickPick(k){const A=new h(k,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}createInputBox(k){const A=new a(k,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}$onDidChangeValue(k,A){this.e.get(k)?._fireDidChangeValue(A)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,A){const p=this.e.get(k);p instanceof h&&p._fireDidChangeActive(A)}$onDidChangeSelection(k,A){const p=this.e.get(k);p instanceof h&&p._fireDidChangeSelection(A)}$onDidTriggerButton(k,A){this.e.get(k)?._fireDidTriggerButton(A)}$onDidTriggerItemButton(k,A,p){const w=this.e.get(k);w instanceof h&&w._fireDidTriggerItemButton(A,p)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,A){this.x=k,this.y=A,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Vd,this.q=new T.$Vd,this.r=new T.$Vd,this.s=new T.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((A,p)=>{const w=A===b.$uM.Back?-1:p;this.o.set(w,A)}),this.z({buttons:k.map((A,p)=>({...s(A.iconPath),tooltip:A.tooltip,handle:A===b.$uM.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const A=this.o.get(k);A&&this.r.fire(A)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const A of Object.keys(k)){const p=k[A];this.u[A]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(d){if(d instanceof b.$7L)return{id:d.id};const k=u(d),A=t(d);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof A=="string"?R.URI.file(A):A}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const k=c(d);let A,p;return"id"in k?p=C.ThemeIcon.asClassName(k):A=k,{iconPath:A,iconClass:p}}class h extends n{constructor(k,A){super(k.identifier,A),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Vd,this.L=[],this.M=new T.$Vd,this.N=new T.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,E)=>{this.C.set(E,w),this.D.set(w,E)});const A=(0,m.$BF)(this.O,"quickPickItemTooltip"),p=[];for(let w=0;w<k.length;w++){const E=k[w];if(E.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:E.label});else{E.tooltip&&!A&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=E.iconPath?s(E.iconPath):void 0;p.push({handle:w,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:A?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((F,z)=>({...s(F.iconPath),tooltip:F.tooltip,handle:z}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(A=>this.D.has(A)),this.z({activeItems:this.J.map(A=>this.D.get(A))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(A=>this.D.has(A)),this.z({selectedItems:this.L.map(A=>this.D.get(A))})}_fireDidChangeActive(k){const A=(0,y.$Hb)(k.map(p=>this.C.get(p)));this.J=A,this.K.fire(A)}_fireDidChangeSelection(k){const A=(0,y.$Hb)(k.map(p=>this.C.get(p)));this.L=A,this.M.fire(A)}_fireDidTriggerItemButton(k,A){const p=this.C.get(k);if(!p||!p.buttons||!p.buttons.length)return;const w=p.buttons[A];w&&this.N.fire({button:w,item:p})}}class a extends n{constructor(k,A){super(k.identifier,A),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:L.default.Error}):this.z({validationMessage:k.message,severity:k.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new r(f,o)}e.$Whc=S}),define(ke[337],Se([1,0,2,4,52,3,11,6,19,128,13,26,61,15,25,16,10]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;function i(P){return P instanceof D.URI}function r(P,F){return P.scheme===l.Schemas.file&&F.scheme===l.Schemas.file&&f.$k?P.toString()===F.toString():P.toString().toLowerCase()===F.toString().toLowerCase()}function n(P){if(P)return typeof P.iconPath=="string"?D.URI.file(P.iconPath):D.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function c(P){if(P.icon){if(D.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const F=P.icon;return{light:F.light,dark:F.dark}}}else return}function t(P,F){if(!P.iconPath&&!F.iconPath)return 0;if(P.iconPath){if(!F.iconPath)return 1}else return-1;const z=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,N=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,y.$Sq)(z,N)}function u(P,F){let z=0;if(P.strikeThrough!==F.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==F.faded)return P.faded?1:-1;if(P.tooltip!==F.tooltip)return(P.tooltip||"").localeCompare(F.tooltip||"");if(z=t(P,F),z!==0)return z;if(P.light&&F.light)z=t(P.light,F.light);else{if(P.light)return 1;if(F.light)return-1}if(z!==0)return z;if(P.dark&&F.dark)z=t(P.dark,F.dark);else{if(P.dark)return 1;if(F.dark)return-1}return z}function s(P,F){if(P.command!==F.command)return P.command<F.command?-1:1;if(P.title!==F.title)return P.title<F.title?-1:1;if(P.tooltip!==F.tooltip){if(P.tooltip!==void 0&&F.tooltip!==void 0)return P.tooltip<F.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(P.arguments===F.arguments)return 0;if(P.arguments)if(F.arguments){if(P.arguments.length!==F.arguments.length)return P.arguments.length-F.arguments.length}else return 1;else return-1;for(let z=0;z<P.arguments.length;z++){const N=P.arguments[z],j=F.arguments[z];if(N!==j&&!(i(N)&&i(j)&&r(N,j)))return N<j?-1:1}return 0}function h(P,F){let z=(0,y.$Sq)(P.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(z!==0)return z;if(P.command&&F.command)z=s(P.command,F.command);else{if(P.command)return 1;if(F.command)return-1}if(z!==0)return z;if(P.decorations&&F.decorations)z=u(P.decorations,F.decorations);else{if(P.decorations)return 1;if(F.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)z=(0,y.$Sq)(P.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)z=(0,y.$Sq)(P.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return z}function a(P,F){for(let z=0;z<P.length;z++)if(P[z]!==F[z])return!1;return!0}function d(P,F){return P.command===F.command&&P.title===F.title&&P.tooltip===F.tooltip&&(P.arguments&&F.arguments?a(P.arguments,F.arguments):P.arguments===F.arguments)}function k(P,F){return(0,$.$ub)(P,F,d)}class A{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.l,F),this.n(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.l,F),this.f=F}get validateInput(){return(0,S.$CF)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,S.$CF)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.l,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.l,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.l,F))}get document(){return(0,S.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(F,z,N,j,M){this.k=F,this.l=j,this.m=M,this.d="",this.e=new T.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=N}showValidationMessage(F,z){(0,S.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,F,z)}$onInputBoxValueChange(F){this.n(F)}n(F){this.d=F,this.e.fire(F)}}e.$Xhc=A;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,z,N,j,M,O,U){this.q=F,this.s=z,this.t=N,this.u=j,this.v=M,this.multiDiffEditorEnableViewChanges=O,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,z){const N=this.h.get(F);return N?(0,R.$Yg)(()=>this.s.executeCommand(N.command,...N.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(h),N=(0,$.$Db)(this.o,F,h).map(O=>{const U=O.toInsert.map(Y=>{const le=this.e++;this.g.set(le,Y);const Z=Y.resourceUri;let J;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const te=new I.$Sc;J=this.s.converter.toInternal(Y.command,te),this.j.set(le,te)}else this.h.set(le,Y.command);const X=(0,S.$BF)(this.w,"scmMultiDiffEditor"),ue=X?Y.multiDiffEditorOriginalUri:void 0,x=X?Y.multiFileDiffEditorModifiedUri:void 0,be=n(Y.decorations),ce=Y.decorations&&n(Y.decorations.light)||be,K=Y.decorations&&n(Y.decorations.dark)||be,V=[ce,K],re=Y.decorations&&Y.decorations.tooltip||"",ye=Y.decorations&&!!Y.decorations.strikeThrough,de=Y.decorations&&!!Y.decorations.faded,ge=Y.contextValue||"";return{rawResource:[le,Z,V,re,ye,de,ge,J,ue,x],handle:le}});return{start:O.start,deleteCount:O.deleteCount,toInsert:U}}),j=N.map(({start:O,deleteCount:U,toInsert:Y})=>[O,U,Y.map(le=>le.rawResource)]),M=N.reverse();for(const{start:O,deleteCount:U,toInsert:Y}of M){const le=Y.map(J=>J.handle),Z=this.n.splice(O,U,...le);for(const J of Z)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=F,j}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.w,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let z;(0,S.$BF)(this.x,"quickDiffProvider")&&(z=F?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!F,quickDiffLabel:z})}get historyProvider(){return(0,S.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(F){(0,S.$CF)(this.x,"scmHistoryProvider"),this.j=F,this.k.value=new I.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(F){F!==this.m&&(this.m=F,this.#e.$updateSourceControl(this.w,{commitTemplate:F}))}get acceptInputCommand(){return this.o}set acceptInputCommand(F){this.n.value=new I.$Sc,this.o=F;const z=this.y.converter.toInternal(F,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,S.$CF)(this.x,"scmActionButton"),this.q}set actionButton(F){(0,S.$CF)(this.x,"scmActionButton"),this.p.value=new I.$Sc,this.q=F;const z=F!==void 0?{command:this.y.converter.toInternal(F.command,this.p.value),secondaryCommands:F.secondaryCommands?.map(N=>N.map(j=>this.y.converter.toInternal(j,this.p.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(F){if(this.t&&F&&k(this.t,F))return;this.s.value=new I.$Sc,this.t=F;const z=(F||[]).map(N=>this.y.converter.toInternal(N,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(F,z,N,j,M,O,U){this.x=F,this.y=j,this.z=M,this.A=O,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Uc,this.m=void 0,this.n=new I.$Uc,this.o=void 0,this.p=new I.$Uc,this.s=new I.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Vd,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=N;const Y=D.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new A(F,z,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,M,O,U,Y)}createResourceGroup(F,z,N){const j=(0,S.$BF)(this.x,"scmMultiDiffEditor")&&N?.multiDiffEditorEnableViewChanges===!0,M=new p(this.#e,this.y,this.w,F,z,j,this.x),O=T.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,O),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const F=[],z=[];for(const[N,j]of this.C){j.dispose();const M=N.onDidUpdateResourceStates(()=>{this.D.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.D.delete(N),M.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.w,N.handle)}),F.push([N.handle,N.id,N.label,N.features,N.multiDiffEditorEnableViewChanges]);const O=N._takeResourceStateSnapshot();O.length>0&&z.push([N.handle,O]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.w,F,z),this.C.clear()}eventuallyUpdateResourceStates(){const F=[];this.D.forEach(z=>{const N=z._takeResourceStateSnapshot();N.length!==0&&F.push([z.handle,N])}),F.length>0&&this.#e.$spliceResourceStates(this.w,F),this.D.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.u=F,this.v.fire(F)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,g.$yh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$yh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,z,N,j){this.l=z,this.m=N,this.n=j,this.g=new Map,this.h=new C.$nm,this.j=new T.$Vd,this.e=F.getProxy(b.$0K.MainThreadSCM),this.f=F.getProxy(b.$0K.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const O=this.g.get(M.sourceControlHandle);if(!O)return M;const U=O.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const O=this.g.get(M.sourceControlHandle);return O?O.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const O=this.g.get(M.handle);return O||M}return M}})}createSourceControl(F,z,N,j){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,z,N,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const M=o.d++,O=new w(F,this.m,this.e,this.l,z,N,j);this.g.set(M,O);const U=this.h.get(F.identifier)||[];return U.push(O),this.h.set(F.identifier,U),O}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const z=this.h.get(F.identifier),N=z&&z[z.length-1];return N&&N.inputBox}$provideOriginalResource(F,z,N){const j=D.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",F,j.toString());const M=this.g.get(F);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Yg)(()=>M.quickDiffProvider.provideOriginalResource(j,N)).then(O=>O||null)}$onInputBoxValueChange(F,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const N=this.g.get(F);return N&&N.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(F,z,N,j){this.n.trace("ExtHostSCM#$executeResourceCommand",F,z,N);const M=this.g.get(F);if(!M)return Promise.resolve(void 0);const O=M.getResourceGroup(z);return O?O.$executeResourceCommand(N,j):Promise.resolve(void 0)}$validateInput(F,z,N){this.n.trace("ExtHostSCM#$validateInput",F);const j=this.g.get(F);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Yg)(()=>j.inputBox.validateInput(z,N)).then(M=>{if(!M)return Promise.resolve(void 0);const O=v.MarkdownString.fromStrict(M.message);return O?Promise.resolve([O,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,z,N){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupBase(z,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,z,N,j){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,N,j)??void 0}async $provideHistoryItems(F,z,N,j){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(z,N,j))?.map(U=>({...U,icon:c(U)}))??void 0}async $provideHistoryItemSummary(F,z,N,j){const M=this.g.get(F)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const O=await M.provideHistoryItemSummary(z,N,j);return O?{...O,icon:c(O)}:void 0}async $provideHistoryItemChanges(F,z,N,j){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(z,N,j)??void 0}};e.$Yhc=E,e.$Yhc=E=o=Ge([Ve(3,L.$nj)],E)}),define(ke[338],Se([1,0,6,15,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$0K.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:T.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,T.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Zhc=I}),define(ke[339],Se([1,0,7,6,216,3,15,18]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$8L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$8L("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,S,l,f,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Sc,this.#e=m,this.#t=v,f&&l){this.c=(0,D.$KL)(l.identifier,f);const r=S.get(this.c);r&&(o=r.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=f,this.g=o,this.h=this.u(i)}u(m){if((0,b.$Mf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Sc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const l=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,l,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$2hc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$_K(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(m,v){this.e=new Map,this.a=m.getProxy(T.$0K.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,S,l){return new $(this.a,this.b,this.e,m,v,S,l)}setStatusBarMessage(m,v){const S=this.c.setMessage(m);let l;return typeof v=="number"?l=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new D.$_K(()=>{S.dispose(),clearTimeout(l)})}}e.$3hc=L}),define(ke[150],Se([1,0,29,141,67,111,90,15,2]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;const y=(r,n,c,t)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!c(u,s)){const h=u;u=s,r.listener?.(t(s,h))}}}},L=(r,n)=>r===n,C={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(r,n)=>!(r.length!==n.length||r.some(c=>!n.find(t=>c.id===t.id)))},m=r=>n=>({op:4,update:r(n)}),v=(r,n)=>({range:(()=>{let c;const t=m(u=>({range:D.$Us.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return c},set(u){r.listener?.({op:6}),C.range(c,u)||(c=u,r.listener?.(t(u)))}}})(),label:y(r,n,C.label,m(c=>({label:c}))),description:y(r,void 0,C.description,m(c=>({description:c}))),sortText:y(r,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(r,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(r,!1,C.busy,m(c=>({busy:c}))),error:y(r,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(r,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=r=>{const n=g.$2J.fromString(r.extId),c=new f(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return c.range=b.Range.to(r.range||void 0),c.description=r.description||void 0,c.sortText=r.sortText||void 0,c.tags=r.tags.map(t=>b.TestTag.to({id:(0,R.$7J)(t).tagId})),c},l=r=>{let n;for(const c of r.tests){const t=S(c.item);(0,T.$0M)(t).parent=n,n=t}return n};e.$nN=l;class f{constructor(n,c,t,u){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const s=(0,T.$9M)(this,n);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,I.$8M)(s,T.$0M,f),enumerable:!0,writable:!1},...v(s,t)})}}e.$oN=f;class o extends f{constructor(n,c){super(n,n,c,void 0),this._isRoot=!0}}e.$pN=o;class i extends I.$4M{constructor(n,c,t){super({controllerId:n,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:T.$0M,getChildren:u=>u.children,root:new o(n,c),toITestItem:b.TestItem.from})}}e.$qN=i}),define(ke[35],Se([1,0,18,7,15,24,6,19,13,55,29,48,2,3,5,20,150,22,68,44,38,88,91,30]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=void 0;let s=class{#e;#t;#i;constructor(p,w,E){this.b=new Map,this.c=new Map,this.#e=p.getProxy(R.$0K.MainThreadCommands),this.d=w,this.#i=E,this.#t=p.getProxy(R.$0K.MainThreadTelemetry),this.converter=new h(this,P=>{const F=this.c.get(P);return F?.result===d.Void?F:void 0},w),this.f=[{processArgument(P){return(0,y.$Ch)(P)}},{processArgument(P){return(0,I.$xn)(P,function(F){if(L.$Us.isIRange(F))return g.Range.to(F);if(C.$Ts.isIPosition(F))return g.Position.to(F);if(L.$Us.isIRange(F.range)&&m.URI.isUri(F.uri))return g.location.to(F);if(F instanceof o.$je)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const w=this.registerCommand(!1,p.id,async(...E)=>{const P=p.args.map((z,N)=>{if(!z.validate(E[N]))throw new Error(`Invalid argument '${z.name}' when running '${p.id}', received: ${typeof E[N]=="object"?JSON.stringify(E[N],null,"	"):E[N]} `);return z.convert(E[N])}),F=await this.executeCommand(p.internalId,...P);return p.result.convert(F,E,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new T.$_K(()=>{w.dispose(),this.c.delete(p.id)})}registerCommand(p,w,E,P,F,z){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:E,thisArg:P,metadata:F,extension:z}),p&&this.#e.$registerCommand(w),new T.$_K(()=>{this.b.delete(w)&&p&&this.#e.$unregisterCommand(w)})}executeCommand(p,...w){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,w,!0)}async g(p,w,E){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,w,!1);{let P=!1;const F=(0,I.$xn)(w,function(z){if(z instanceof T.$aL)return g.Position.from(z);if(z instanceof T.$bL)return g.Range.from(z);if(z instanceof T.$lL)return g.location.from(z);if(T.$xM.isNotebookRange(z))return g.NotebookRange.from(z);if(z instanceof ArrayBuffer)return P=!0,o.$je.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return P=!0,o.$je.wrap(z);if(z instanceof o.$je)return P=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(p,P?new i.$Tv(F):F,E);return(0,y.$Ch)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(p,w,!1);throw z}}}async h(p,w,E){const P=this.b.get(p);if(!P)throw new Error("Unknown command");const{callback:F,thisArg:z,metadata:N}=P;if(N?.args)for(let M=0;M<N.args.length;M++)try{(0,D.$Zf)(w[M],N.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${N.args[M].name}' - ${N.args[M].description}`)}const j=n.$Rd.create();try{return await F.apply(z,w)}catch(M){if(p===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(p=O.command)}if(this.d.error(M,p,P.extension?.identifier),!E)throw M;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Qi)(M)),this.id=p,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,p,j.elapsed())}}j(p,w,E){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new c.$Lo(w),duration:E})}$executeContributedCommand(p,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const E=this.b.get(p);return E?(w=w.map(P=>this.f.reduce((F,z)=>z.processArgument(F,E.extension?.identifier),P)),this.h(p,w,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(w=>(p&&(w=w.filter(E=>E[0]!=="_")),w))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[w,E]of this.b){const{metadata:P}=E;P&&(p[w]=P)}return Promise.resolve(p)}};e.$wN=s,e.$wN=s=Ge([Ve(0,l.$bN),Ve(1,$.$nj),Ve(2,t.$vN)],s),e.$xN=(0,S.$6h)("IExtHostCommands");class h{constructor(p,w,E){this.d=p,this.f=w,this.g=E,this.delegatingCommandId=`__vsc${(0,u.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,w){if(!p)return;const E={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return E;const P=this.f(p.command);if(P)E.id=P.internalId,E.arguments=P.args.map((F,z)=>F.convert(p.arguments&&p.arguments[z]));else if((0,b.$Lb)(p.arguments)){const F=`${p.command} /${++this.c}`;this.b.set(F,p),w.add((0,v.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),E.$ident=F,E.id=this.delegatingCommandId,E.arguments=[F],this.g.trace("CommandsConverter#CREATE",p.command,F)}return E}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const w=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$yN=h;class a{static{this.Uri=new a("uri","Uri of a text document",p=>m.URI.isUri(p),p=>p)}static{this.Position=new a("position","A position in a text document",p=>T.$aL.isPosition(p),g.Position.from)}static{this.Range=new a("range","A range in a text document",p=>T.$bL.isRange(p),g.Range.from)}static{this.Selection=new a("selection","A selection in a text document",p=>T.$cL.isSelection(p),g.Selection.from)}static{this.Number=new a("number","",p=>typeof p=="number",p=>p)}static{this.String=new a("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=a.Arr(a.String)}static Arr(p){return new a(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,w=>Array.isArray(w)&&w.every(E=>p.validate(E)),w=>w.map(E=>p.convert(E)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",p=>p instanceof T.$wL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",p=>p instanceof T.$QM,g.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",p=>p instanceof f.$oN,g.TestItem.from)}constructor(p,w,E,P){this.name=p,this.description=w,this.validate=E,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,w){return new a(p??this.name,w??this.description,this.validate,this.convert)}}e.$zN=a;class d{static{this.Void=new d("no result",p=>p)}constructor(p,w){this.description=p,this.convert=w}}e.$AN=d;class k{constructor(p,w,E,P,F){this.id=p,this.internalId=w,this.description=E,this.args=P,this.result=F}}e.$BN=k}),define(ke[340],Se([1,0,19,16,2,83,131,45,35,15,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;const C=[new $.$BN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$BN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,D.$Kb)(l))return;class o extends L.$rL{static to(r){const n=new o(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new L.$lL(f[0],y.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=y.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return l.map(o.to)})),new $.$BN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$zN.Uri,new $.$zN("options","Formatting options",l=>!0,l=>l)],new $.$AN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$BN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$zN.Uri,$.$zN.Range,new $.$zN("options","Formatting options",l=>!0,l=>l)],new $.$AN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$BN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$zN.Uri,$.$zN.Position,new $.$zN("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$zN("options","Formatting options",l=>!0,l=>l)],new $.$AN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$BN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$BN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$BN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$zN.Uri,new $.$zN("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>L.$aL.isPosition(f)),l=>l.map(y.Position.from))],new $.$AN("A promise that resolves to an array of ranges.",l=>l.map(f=>{let o;for(const i of f.reverse())o=new L.$vL(y.Range.to(i),o);return o}))),new $.$BN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$zN.String.with("query","Search string")],new $.$AN("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(y.WorkspaceSymbol.to))),new $.$BN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(y.CallHierarchyItem.to))),new $.$BN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$zN.CallHierarchyItem],new $.$AN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(y.CallHierarchyIncomingCall.to))),new $.$BN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$zN.CallHierarchyItem],new $.$AN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(y.CallHierarchyOutgoingCall.to))),new $.$BN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:y.Range.to(l.range),placeholder:l.text}})),new $.$BN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("newName","The new symbol name")],new $.$AN("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return y.WorkspaceEdit.to(l)}})),new $.$BN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$zN.Uri,$.$zN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$AN("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(y.DocumentLink.to))),new $.$BN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$zN.Uri],new $.$AN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.$pM(l.tokenTypes,l.tokenModifiers)})),new $.$BN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$zN.Uri],new $.$AN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$x$)(l);if(f.type==="full")return new L.$rM(f.data,void 0)})),new $.$BN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$zN.Uri,$.$zN.Range.optional()],new $.$AN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.$pM(l.tokenTypes,l.tokenModifiers)})),new $.$BN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$zN.Uri,$.$zN.Range],new $.$AN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$x$)(l);if(f.type==="full")return new L.$rM(f.data,void 0)})),new $.$BN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$zN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$AN("A promise that resolves to a CompletionList-instance.",(l,f,o)=>{if(!l)return new L.$HL([]);const i=l.suggestions.map(r=>y.CompletionItem.to(r,o));return new L.$HL(i,l.incomplete)})),new $.$BN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$AN("A promise that resolves to SignatureHelp.",l=>{if(l)return y.SignatureHelp.to(l)})),new $.$BN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$zN.Uri,$.$zN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$AN("A promise that resolves to an array of CodeLens-instances.",(l,f,o)=>v(i=>new L.$zL(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(l))),new $.$BN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$zN.Uri,new $.$zN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.$bL.isRange(l),l=>L.$cL.isSelection(l)?y.Selection.from(l):y.Range.from(l)),$.$zN.String.with("kind","Code action kind to return code actions for").optional(),$.$zN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$AN("A promise that resolves to an array of Command-instances.",(l,f,o)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new L.$tL(i.title,i.kind?new L.$uL(i.kind):void 0);return i.edit&&(r.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(l))),new $.$BN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new L.$NL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$BN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$zN("color","The color to show and insert",l=>l instanceof L.$ML,y.Color.from),new $.$zN("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:y.Range.from(l.range)}))],new $.$AN("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(y.ColorPresentation.to):[])),new $.$BN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$zN.Uri,$.$zN.Range],new $.$AN("A promise that resolves to an array of Inlay objects",(l,f,o)=>l.map(y.InlayHint.to.bind(void 0,o)))),new $.$BN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(y.FoldingRange.to)})),new $.$BN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$AN("A promise that resolves to an array of NotebookContentProvider static info objects.",v(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$BN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$zN.Uri,$.$zN.Range,new $.$zN("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof L.$bL,l=>y.InlineValueContext.from(l))],new $.$AN("A promise that resolves to an array of InlineValue objects",l=>l.map(y.InlineValue.to))),new $.$BN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$zN("uriOrString","Uri-instance or string (only http/https)",l=>g.URI.isUri(l)||typeof l=="string"&&(0,T.$fg)(l,T.Schemas.http,T.Schemas.https),l=>l),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional(),$.$zN.String.with("label","").optional()],$.$AN.Void),new $.$BN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$zN.Uri.with("resource","Resource to open"),$.$zN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional()],$.$AN.Void),new $.$BN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$zN.Uri.with("left","Left-hand side resource of the diff editor"),$.$zN.Uri.with("right","Right-hand side resource of the diff editor"),$.$zN.String.with("title","Human readable title for the diff editor").optional(),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)]).optional()],$.$AN.Void),new $.$BN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$zN.String.with("title","Human readable title for the changes editor"),new $.$zN("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[o,i,r]=f;if(!g.URI.isUri(o)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},l=>l)],$.$AN.Void),new $.$BN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$zN.TypeHierarchyItem],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$zN.TypeHierarchyItem],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$zN.TestItem],$.$AN.Void),new $.$BN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$zN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$AN.Void),new $.$BN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$zN.String.with("name","The context key name"),new $.$zN("value","The context key value",()=>!0,l=>l)],$.$AN.Void),new $.$BN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$zN.Uri,$.$zN.StringArray,new $.$zN("MappedEditsContext","Mapped Edits Context",l=>y.MappedEditsContext.is(l),l=>y.MappedEditsContext.from(l))],new $.$AN("A promise that resolves to a workspace edit or null",l=>l?y.WorkspaceEdit.to(l):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$5i)}}e.$lgc=m;function v(l){return f=>{if(Array.isArray(f))return f.map(l)}}function S(l){if(!Array.isArray(l))return;const f=[];for(const o of l)I.$Gt(o)?f.push(y.DefinitionLink.to(o)):f.push(y.location.to(o));return f}}),define(ke[341],Se([1,0,3,2,6,15,7,35,11]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class y{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=y.a++}}class L{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,S,l,f){this.f=l,this.g=f,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$0K.MainThreadInlineChat),S.registerApiCommand(new b.$BN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$zN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?I.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?I.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?I.Position.from(o.position):void 0}})],b.$AN.Void))}registerProvider(v,S,l){const f=new y(v,S);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,l?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",l?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(v,S,l,f){const o=this.b.get(v);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),r=I.Selection.to(l),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},f);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new L(n)),{id:c,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(n.wholeRange),message:n.message}}async $provideResponse(v,S,l,f){const o=this.b.get(v);if(!o)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:l.prompt,selection:I.Selection.to(l.selection),wholeRange:I.Range.to(l.wholeRange),attempt:l.attempt,live:l.live,withIntentDetection:l.withIntentDetection};let n=!1;const c={report:async A=>{if(!l.live&&A.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||f.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:A.message,edits:A.edits?.map(I.TextEdit.from),editsShouldBeInstant:A.editsShouldBeInstant,slashCommand:A.slashCommand?.command,markdownFragment:R.$AL.isMarkdownString(A.content)?A.content.value:A.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,c,f));let u;try{u=await(0,$.$Ug)(t,f)}finally{n=!0}if(!u)return;const s=i.responses.push(u)-1,h={wholeRange:I.Range.from(u.wholeRange),placeholder:u.placeholder};if(!C.h(u))return{...h,id:s,type:"editorEdit",message:I.MarkdownString.from(u.contents),edits:[]};const{edits:a,contents:d}=u,k=d!==void 0?I.MarkdownString.from(d):void 0;return a instanceof R.$jL?{...h,id:s,type:"bulkEdit",edits:I.WorkspaceEdit.from(a),message:k}:{...h,id:s,type:"editorEdit",edits:a.map(I.TextEdit.from),message:k}}async $provideFollowups(v,S,l,f){const o=this.b.get(v),i=this.d.get(S),r=i?.responses[l];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,f));return(await(0,$.$Ug)(n,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(v,S,l,f){const o=this.b.get(v),i=this.d.get(S),r=i?.responses[l];if(o&&r){const n=I.InteractiveEditorResponseFeedbackKind.to(f);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$thc=C}),define(ke[342],Se([1,0,2,35]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class g{constructor(R,b,$,y,L){this.a=b,this.b=$,this.c=y;const C=new T.$BN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$zN("showOptions","Show Options",m=>!0,m=>m),new T.$zN("resource","Interactive resource Uri",m=>!0,m=>m),new T.$zN("controllerId","Notebook controller Id",m=>!0,m=>m),new T.$zN("title","Interactive editor title",m=>!0,m=>m)],new T.$AN("Notebook and input URI",m=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Ghc=g}),define(ke[343],Se([1,0,19,11,21,4,3,28,2,26,13,6,35,15,7,112,284,25,68]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0;let r=class{constructor(d,k,A,p,w){this.m=k,this.n=A,this.o=p,this.q=w,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(C.$0K.MainThreadNotebookKernels);const E=new m.$BN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$zN("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const F=this.n.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:F}}else if(P&&"notebookEditor"in P){const F=this.n.getIdByEditor(P.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return P})],m.$AN.Void);this.o.registerApiCommand(E)}createNotebookController(d,k,A,p,w,E){for(const x of this.j.values())if(x.controller.id===k&&y.$lm.equals(d.identifier,x.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,F=this;this.q.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${k}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${d.identifier}'`);let N=!1;const j=new I.$Vd,M=new I.$Vd,O={id:h(d.identifier,k),notebookType:A,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:p||d.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let U=w??z,Y,le;this.a.$addKernel(P,O).catch(x=>{console.log(x),N=!0});let Z=0;const J=()=>{if(N)return;const x=++Z;Promise.resolve().then(()=>{x===Z&&this.a.$updateKernel(P,O)})},X=new b.$Ac,ue={get id(){return k},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return O.label},set label(x){O.label=x??d.displayName??d.name,J()},get detail(){return O.detail??""},set detail(x){O.detail=x,J()},get description(){return O.description??""},set description(x){O.description=x,J()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(x){O.supportedLanguages=x,J()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(x){O.supportsExecutionOrder=x,J()},get rendererScripts(){return O.preloads?O.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(x){U=x??z},get interruptHandler(){return Y},set interruptHandler(x){Y=x,O.supportsInterrupt=!!x,J()},set variableProvider(x){(0,o.$CF)(d,"notebookVariableProvider"),le=x,O.hasVariableProvider=!!x,x?.onDidChangeVariables(be=>F.a.$variablesUpdated(be.uri)),J()},get variableProvider(){return le},createNotebookCellExecution(x){if(N)throw new Error("notebook controller is DISPOSED");if(!X.has(x.notebook.uri))throw F.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return F._createNotebookCellExecution(x,h(d.identifier,this.id))},createNotebookExecution(x){if((0,o.$CF)(d,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!X.has(x.uri))throw F.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.uri.toString()}`);return F._createNotebookExecution(x,h(d.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${P}], DISPOSED`),N=!0,this.j.delete(P),j.dispose(),M.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(x,be){be===S.NotebookControllerAffinity2.Hidden&&(0,o.$CF)(d,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(P,x.uri,be)},onDidReceiveMessage:M.event,postMessage(x,be){return(0,o.$CF)(d,"notebookMessaging"),F.a.$postMessage(P,be&&F.n.getIdByEditor(be),x)},asWebviewUri(x){return(0,o.$CF)(d,"notebookMessaging"),(0,l.$Dvb)(x,F.m.remote)}};return this.j.set(P,{extensionId:d.identifier,controller:ue,onDidReceiveMessage:M,onDidChangeSelection:j,associatedNotebooks:X}),ue}getIdByController(d){for(const[k,A]of this.j)if(A.controller===d)return h(A.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,k){const A=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${A}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(A,k);const w={dispose:()=>{this.f.delete(A),p.a.$removeKernelDetectionTask(A)}};return this.f.set(A,w),w}registerKernelSourceActionProvider(d,k,A){const p=this.i++,w=typeof A.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,E=this;this.h.set(p,A),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,k);let P;return w!==void 0&&(P=A.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(p),E.a.$removeKernelSourceActionProvider(p,p),P?.dispose()}}}async $provideKernelSourceActions(d,k){const A=this.h.get(d);if(A){const p=new R.$Sc;return(await A.provideNotebookKernelSourceActions(k)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,p))}return[]}$acceptNotebookAssociation(d,k,A){const p=this.j.get(d);if(p){const w=this.n.getNotebookDocument($.URI.revive(k));A?p.associatedNotebooks.set(w.uri,!0):p.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),A),p.onDidChangeSelection.fire({selected:A,notebook:w.apiNotebook})}}async $executeCells(d,k,A){const p=this.j.get(d);if(!p)return;const w=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const P of A){const F=w.getCell(P);F&&E.push(F.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),E.length),await p.controller.executeHandler.call(p.controller,E,w.apiNotebook,p.controller)}catch(P){this.q.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,k,A){const p=this.j.get(d);if(!p)return;const w=this.n.getNotebookDocument($.URI.revive(k));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,w.apiNotebook);else for(const E of A){const P=w.getCell(E);P&&this.b.get(P.uri)?.cancel()}if(p.controller.interruptHandler){const E=this.c.get(w.uri);A.length&&Array.isArray(E)&&E.length&&E.forEach(P=>P.dispose())}}async $provideVariables(d,k,A,p,w,E,P){const F=this.j.get(d);if(!F)return;const z=this.n.getNotebookDocument($.URI.revive(A)),N=F.controller.variableProvider;if(!N)return;let j;if(p){if(j=this.s[p],!j)return}else this.s={};const M=w==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,O=N.provideVariables(z.apiNotebook,j,M,E,P);for await(const U of O){if(P.isCancellationRequested)return;const Y={id:this.r++,name:U.variable.name,value:U.variable.value,hasNamedChildren:U.hasNamedChildren,indexedChildrenCount:U.indexedChildrenCount};this.s[Y.id]=U.variable,this.a.$receiveVariable(k,Y)}}$acceptKernelMessageFromRenderer(d,k,A){const p=this.j.get(d);if(!p)return;const w=this.n.getEditorById(k);p.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:A}))}$cellExecutionChanged(d,k,A){const w=this.n.getNotebookDocument($.URI.revive(d)).getCell(k);if(w){const E=A?v.NotebookCellExecutionState.to(A):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:w.apiCell,state:E})}}_createNotebookCellExecution(d,k){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const w=new c(k,p,this.a);this.b.set(p.uri,w);const E=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),E.dispose(),this.b.delete(p.uri))});return w.asApiObject()}_createNotebookExecution(d,k){const A=this.n.getNotebookDocument(d.uri),p=d.getCells().find(P=>{const F=A.getCellFromApiCell(P);return F&&this.b.has(F.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(A.uri))throw new Error(`duplicate notebook execution for ${A.uri}`);const w=new u(k,A,this.a),E=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),E.dispose(),this.c.delete(A.uri))});return this.c.set(A.uri,[w,E]),w.asApiObject()}};e.$Ohc=r,e.$Ohc=r=Ge([Ve(4,L.$nj)],r);var n;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(n||(n={}));class c extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,A){super(),this.m=k,this.n=A,this.b=c.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$6d),this.h=new s(10,p=>this.s(p)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const k=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new i.$Tv(k))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let k=this.m;if(d&&(k=this.m.notebook.getCellFromApiCell(d)),!k)throw new Error("INVALID cell");return k.handle}y(d){return d.map(k=>{const A=S.$BM.ensureUniqueMimeTypes(k.items,!0);return A===k.items?v.NotebookCellOutput.from(k):v.NotebookCellOutput.from({items:A,id:k.id,metadata:k.metadata})})}async z(d,k,A){const p=this.w(k),w=this.y((0,D.$3b)(d));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:p,append:A,outputs:w})}async C(d,k,A){return d=S.$BM.ensureUniqueMimeTypes((0,D.$3b)(d),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(v.NotebookCellOutputItem.from),outputId:k.id,append:A})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(A){d.j=A,d.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(A){if(d.f===n.Resolved||d.f===n.Started)throw new Error("Cannot call start again");d.f=n.Started,d.c.fire(),d.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:A})},end(A,p){if(d.f===n.Resolved)throw new Error("Cannot call resolve twice");d.f=n.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new i.$Tv({runEndTime:p,lastRunSuccess:A}))},clearOutput(A){return d.t(),d.z([],A,!1)},appendOutput(A,p){return d.t(),d.z(A,p,!0)},replaceOutput(A,p){return d.t(),d.z(A,p,!1)},appendOutputItems(A,p){return d.t(),d.C(A,p,!0)},replaceOutputItems(A,p){return d.t(),d.C(A,p,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,A){super(),this.h=k,this.j=A,this.b=u.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$6d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(d,k){this.f=d,this.g=k,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new T.$qh,this.b=Date.now(),(0,T.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>d.complete())}}function h(a,d){return`${a.value}/${d}`}e.$Phc=h}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,61,11,15,35]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,g.$6h)("IExtHostTerminalService");class r{constructor(p,w,E,P){this.l=p,this._id=w,this.m=E,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const F=this;this.value={get name(){return F.n||""},get processId(){return F.b},get creationOptions(){return F.m},get exitStatus(){return F.h},get state(){return F.j},get selection(){return F.k},sendText(z,N=!0){F.q(),F.l.$sendText(F._id,z,N)},show(z){F.q(),F.l.$show(F._id,z)},hide(){F.q(),F.l.$hide(F._id)},dispose(){F.a||(F.a=!0,F.l.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(p,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??w?.cwd??void 0,env:p.env??void 0,icon:a(p.iconPath)??void 0,color:l.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(p.location,w?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,w,E,P,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:l.ThemeColor.isThemeColor(F)?F.id:void 0,location:w?.location||this.o(p,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,w){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in p?{viewColumn:o.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,w){this.h=Object.freeze({code:p,reason:w})}setDimensions(p,w){return p===this.d&&w===this.g||p===0||w===0?!1:(this.d=p,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(w=>{w!==p&&(this.b=Promise.resolve(p))})}}e.$2gc=r;class n{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new D.$Vd,this.onProcessData=this.a.event,this.b=new D.$Vd,this.d=new D.$Vd,this.onDidChangeProperty=this.d.event,this.f=new D.$Vd,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,w){this.g.setDimensions?.({columns:p,rows:w})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,w,E){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Vd,this.onDidChangeShell=this.N.event,this.O=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(T.$0K.MainThreadTerminalService),this.y=new S.$Prb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:P=>{const F=z=>{const N=z;return this.W(N.instanceId)?.value};switch(P?.$mid){case 15:return F(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=F(P[z]);return P}}}}),this.B({dispose:()=>{for(const[P,F]of this.g)F.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,w){const E=new r(this.a,(0,v.$qg)(),p,p.name),P=new n(p.pty);return E.createExtensionTerminal(p.location,w,this.R(p,w).resolvedExtHostIdentifier,a(p.iconPath),d(p.color)).then(F=>{const z=this.S(F,P);this.h[F]=z}),this.f.push(E),E.value}R(p,w){if(w=w||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const E=p.location.parentTerminal;if(E){const P=this.f.find(F=>F.value===E);P&&(w.resolvedExtHostIdentifier=P._id)}}else p.location&&typeof p.location!="object"?w.location=p.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(p,w){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const P=new n(w),F=this.S(p,P);this.h[p]=F}async $acceptActiveTerminalChanged(p){const w=this.b;if(p===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const E=this.W(p);E&&(this.b=E,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,w){const E=this.W(p);E&&this.O.fire({terminal:E.value,data:w})}async $acceptTerminalDimensions(p,w,E){const P=this.W(p);P&&P.setDimensions(w,E)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(p,w){const E=this.W(p);E&&this.P.fire({terminal:E.value,...w})}async $acceptTerminalMaximumDimensions(p,w,E){this.g.get(p)?.resize(w,E)}async $acceptTerminalTitleChange(p,w){const E=this.W(p);E&&(E.name=w)}async $acceptTerminalClosed(p,w,E){const P=this.Y(this.f,p);if(P!==null){const F=this.f.splice(P,1)[0];F.setExitStatus(w,E),this.H.fire(F.value)}}$acceptTerminalOpened(p,w,E,P){if(w){const N=this.Y(this.f,w);if(N!==null){this.f[N]._id=p,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const F={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:I.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new r(this.a,p,F,E);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(p,w){this.W(p)?._setProcessId(w)}async $startExtensionTerminal(p,w){const E=this.W(p);if(!E)return{message:(0,y.localize)(0,null,p)};E.isOpen||await new Promise(F=>{const z=this.onDidOpenTerminal(async N=>{N===E.value&&(z.dispose(),F())})});const P=this.g.get(p);P?P.startSendingEvents(w):this.j[p]={initialDimensions:w}}S(p,w){const E=new b.$Sc;E.add(w.onProcessReady(F=>this.a.$sendProcessReady(p,F.pid,F.cwd,F.windowsPty))),E.add(w.onDidChangeProperty(F=>this.a.$sendProcessProperty(p,F))),this.y.startBuffering(p,w.onProcessData),E.add(w.onProcessExit(F=>this.U(p,F))),this.g.set(p,w);const P=this.j[p];return P&&w instanceof n&&(w.startSendingEvents(P.initialDimensions),delete this.j[p]),E}$acceptProcessAckDataEvent(p,w){this.g.get(p)?.acknowledgeDataEvent(w)}$acceptProcessInput(p,w){this.g.get(p)?.input(w)}$acceptTerminalInteraction(p){const w=this.W(p);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(p,w){this.W(p)?.setSelection(w)}$acceptProcessResize(p,w,E){try{this.g.get(p)?.resize(w,E)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(p,w){this.g.get(p)?.shutdown(w)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(w=>this.a.$sendProcessProperty(p,{type:"cwd",value:w}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$_K(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,w,E){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,E),this.a.$registerProfileProvider(w,p.identifier.value),new $.$_K(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(p,w,E){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,E),this.a.$registerQuickFixProvider(p,w),new $.$_K(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,w){const E=new m.$6d().token;if(E.isCancellationRequested)return;const P=this.D.get(p);if(!P)return;const F=await P.provideTerminalQuickFixes(w,E);if(F===null||Array.isArray(F)&&F.length===0)return;const z=new b.$Sc;if(this.w.value=z,!Array.isArray(F))return F?o.TerminalQuickFix.from(F,this.Q.converter,z):void 0;const N=[];for(const j of F){const M=o.TerminalQuickFix.from(j,this.Q.converter,z);M&&N.push(M)}return N}async $createContributedProfileTerminal(p,w){const E=new m.$6d().token;let P=await this.C.get(p)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,w);return}this.createTerminalFromOptions(P.options,w)}}async $provideLinks(p,w){const E=this.W(p);if(!E)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const F=new m.$6d;this.G.set(p,F);const z=[],N={terminal:E.value,line:w},j=[];for(const U of this.z)j.push(f.Promises.withAsyncBody(async Y=>{F.token.onCancellationRequested(()=>Y({provider:U,links:[]}));const le=await U.provideTerminalLinks(N,F.token)||[];F.token.isCancellationRequested||Y({provider:U,links:le})}));const M=await Promise.all(j);if(F.token.isCancellationRequested)return[];const O=new Map;for(const U of M)U&&U.links.length>0&&z.push(...U.links.map(Y=>{const le={id:c++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return O.set(le.id,{provider:U.provider,link:Y}),le}));return this.F.set(p,O),z}$activateLink(p,w){const E=this.F.get(p)?.get(w);E&&E.provider.handleTerminalLink(E.link)}U(p,w){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const E=this.h[p];E&&(E.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,w)}W(p){return this.X(this.f,p)}X(p,w){const E=this.Y(p,w);return E!==null?p[E]:null}Y(p,w){const E=p.findIndex(P=>P._id===w);return E===-1?null:E}getEnvironmentVariableCollection(p){let w=this.n.get(p.identifier.value);return w||(w=new u,this.$(p.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(p,w){const E=(0,C.$Mr)(w.map),P=(0,C.$Nr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(p,w.persistent,E.length===0?void 0:E,P)}$initEnvironmentVariableCollections(p){p.forEach(w=>{const E=w[0],P=new u(w[1]);this.$(E,P)})}$acceptDefaultProfile(p,w){const E=this.s;this.s=p,this.u=w,E?.path!==p.path&&this.N.fire(p.path)}$(p,w){this.n.set(p,w),w.onDidChangeCollection(()=>{this.Z(p,w)})}};e.$3gc=t,e.$3gc=t=Ge([Ve(1,i.$xN),Ve(2,R.$bN)],t);class u{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Vd,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const w=this.h(p);let E=this.a.get(w);return E||(E=new s(this,p),this.a.set(w,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(p,w,E,P){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:P})}append(p,w,E,P){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:P})}prepend(p,w,E,P){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:P})}f(p,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(p,w.scope),P=this.map.get(E),F=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==w.value||P.type!==w.type||P.options?.applyAtProcessCreation!==F.applyAtProcessCreation||P.options?.applyAtShellIntegration!==F.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const z=this.g(p,w.scope),N={variable:p,...w,options:F};this.map.set(z,N),this.d.fire()}}get(p,w){const E=this.g(p,w),P=this.map.get(E);return P?k(P):void 0}g(p,w){const E=this.h(w);return E.length?`${p}:::${E}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const w=new Map;for(const[E,P]of this.map)this.h(P.scope)===this.h(p)&&w.set(P.variable,k(P));return w}delete(p,w){const E=this.g(p,w);this.map.delete(E),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[w,E]of this.map)E.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(w);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,w){const E=this.h(w),P=this.descriptionMap.get(E);if(!P||P.description!==p){let F;typeof p=="string"?F=p:F=p?.value.split(`

`)[0];const z={description:F,scope:w};this.descriptionMap.set(E,z),this.d.fire()}}getDescription(p){const w=this.h(p);return this.descriptionMap.get(w)?.description}k(p){const w=this.h(p);this.descriptionMap.delete(w)}}class s{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,w){this.b=p,this.d=w,this.a=new D.$Vd}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,w,E){this.b.replace(p,w,E,this.d)}append(p,w,E){this.b.append(p,w,E,this.d)}prepend(p,w,E){this.b.prepend(p,w,E,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,w){this.b.getVariableMap(this.d).forEach((E,P)=>p.call(w,P,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends t{constructor(p,w){super(!1,p,w)}createTerminal(p,w,E){throw new L.$_}createTerminalFromOptions(p,w){throw new L.$_}};e.$4gc=h,e.$4gc=h=Ge([Ve(0,i.$xN),Ve(1,R.$bN)],h);function a(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function d(A){return l.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const p={...A};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[344],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0;let t=class extends $.$Tc{constructor(j,M,O,U){super(),this.w=U,this.f=this.B(new I.$Vd),this.g=new Map,this.s=this.B(new I.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(v.$0K.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,M),O.registerArgumentProcessor({processArgument:Y=>{switch(Y?.$mid){case 16:{const le=Y,Z=le.tests[le.tests.length-1].item.extId;return this.g.get(i.$2J.root(Z))?.collection.tree.get(Z)?.actual??(0,l.$nN)(Y)}case 18:{const{extId:le,message:Z}=Y;return{test:this.g.get(i.$2J.root(le))?.collection.tree.get(le)?.actual,message:f.TestMessage.to(Z)}}default:return Y}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Y=await O.executeCommand("_testing.getExplorerSelection"),le=Z=>{const J=this.g.get(i.$2J.root(Z));if(J)return i.$2J.isRoot(Z)?J.controller:J.collection.tree.get(Z)?.actual};return{include:Y?.include.map(le).filter(L.$Qf)||[],exclude:Y?.exclude.map(le).filter(L.$Qf)||[]}})}createTestController(j,M,O,U){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const Y=new $.$Sc,le=Y.add(new l.$qN(M,O,this.w));le.root.label=O;const Z=new Map,J=new Set,X=this.h,ue={items:le.root.children,get label(){return O},set label(be){O=be,le.root.label=be,X.$updateController(M,{label:O})},get refreshHandler(){return U},set refreshHandler(be){U=be,X.$updateController(M,{canRefresh:!!be})},get id(){return M},createRunProfile:(be,ce,K,V,re,ye)=>{let de=(0,b.$Ti)(be);for(;Z.has(de);)de++;return new F(this.h,Z,j,J,this.s.event,M,de,be,ce,K,V,re,ye)},createTestItem(be,ce,K){return new l.$oN(M,be,ce,K)},createTestRun:(be,ce,K=!0)=>this.j.createTestRun(j,M,le,be,ce,K),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const ce=be instanceof Array?be:[be];this.h.$markTestRetired(ce.map(K=>i.$2J.fromExtHostTestItem(K,M).toString()))}},set resolveHandler(be){le.resolveHandler=be},get resolveHandler(){return le.resolveHandler},dispose:()=>{Y.dispose()}};X.$registerTestController(M,O,!!U),Y.add((0,$.$Rc)(()=>X.$unregisterTestController(M)));const x={controller:ue,collection:le,profiles:Z,extension:j,activeProfiles:J};return this.g.set(M,x),Y.add((0,$.$Rc)(()=>this.g.delete(M))),Y.add(le.onDidGenerateDiff(be=>X.$publishDiff(M,be.map(n.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.m.checkout()}async runTests(j,M=g.CancellationToken.None){const O=d(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.g.get(O.controllerId);if(!U)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(Y=>i.$2J.fromExtHostTestItem(Y,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:z[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(Y=>Y.id)},M)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,M,O){return await this.j.getCoverageReport(j,M)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(j,M,O,U){return await this.j.getCoverageReport(j,M)?.resolveFileCoverage(O,U)??[]}$configureRunProfile(j,M){this.g.get(j)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(j){const M=new Map;for(const[O,U]of Object.entries(j)){const Y=this.g.get(O);if(!Y)continue;const le=new Map,Z=U.filter(X=>!Y.activeProfiles.has(X)),J=[...Y.activeProfiles].filter(X=>!U.includes(X));for(const X of Z)le.set(X,!0),Y.activeProfiles.add(X);for(const X of J)le.set(X,!1),Y.activeProfiles.delete(X);le.size&&M.set(O,le)}this.s.fire(M)}async $refreshTests(j,M){await this.g.get(j)?.controller.refreshHandler?.(M)}$publishTestResults(j){this.results=Object.freeze(j.map(M=>(0,y.$wn)(f.TestResults.to(M))).concat(this.results).sort((M,O)=>O.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,M){const O=this.g.get(i.$2J.fromString(j).controllerId)?.collection;O&&(await O.expand(j,M<0?1/0:M),O.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:O=>O},M)))}async $runControllerTests(j,M){return Promise.all(j.map(O=>this.y(O,!1,M)))}async $startContinuousRun(j,M){const O=new g.$6d(M),U=await Promise.all(j.map(Y=>this.y(Y,!0,O.token)));return!M.isCancellationRequested&&!U.some(Y=>Y.error)&&await new Promise(Y=>M.onCancellationRequested(Y)),O.dispose(!0),U}async y(j,M,O){const U=this.g.get(j.controllerId);if(!U)return{};const{collection:Y,profiles:le,extension:Z}=U,J=le.get(j.profileId);if(!J)return{};const X=j.testIds.map(ce=>Y.tree.get(ce)).filter(L.$Qf),ue=j.excludeExtIds.map(ce=>U.collection.tree.get(ce)).filter(L.$Qf).filter(ce=>X.some(K=>K.fullId.compare(ce.fullId)===2));if(!X.length)return{};const x=new o.$IM(X.some(ce=>ce.actual instanceof l.$pN)?void 0:X.map(ce=>ce.actual),ue.map(ce=>ce.actual),J,M),be=(0,n.$4J)(j)&&this.j.prepareForMainThreadTestRun(x,k.fromInternal(j,U.collection),Z,O);try{return await J.runHandler(x,O),{}}catch(ce){return{error:String(ce)}}finally{be&&(be.hasRunningTasks&&!O.isCancellationRequested&&await I.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$7hc=t,e.$7hc=t=Ge([Ve(0,S.$bN),Ve(1,m.$nj)],t);const u=1e4;var s;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(s||(s={}));class h extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,M,O,U,Y){super(),this.s=j,this.w=M,this.y=O,this.z=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Vd),this.m=this.B(new I.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$6d(Y));const le=this.B(new D.$fh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>le.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const M=this.s.id,O=this.s.controllerId,U=(0,C.$qg)(),Y=this.y,le=this.m;let Z;const J=be=>(ce,...K)=>{if(ue){this.z.warn(`Setting the state of test "${ce.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ce)&&(this.F(ce),be(ce,...K))},X=(be,ce)=>{const K=ce instanceof Array?ce.map(f.TestMessage.from):[f.TestMessage.from(ce)];if(be.uri&&be.range){const V={range:f.Range.from(be.range),uri:be.uri};for(const re of K)re.location=re.location||V}this.w.$appendTestMessagesInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),K)};let ue=!1;const x={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return Z?.provider},set coverageProvider(be){(0,c.$CF)(Y,"testCoverage"),Z=be&&new A(be),le.fire({taskId:U,runId:M,coverage:Z})},enqueued:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),1)}),skipped:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),5)}),started:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),2)}),errored:J((be,ce,K)=>{X(be,ce),this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),6,K)}),failed:J((be,ce,K)=>{X(be,ce),this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),4,K)}),passed:J((be,ce)=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,this.s.controllerId).toString(),3,ce)}),appendOutput:(be,ce,K)=>{ue||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(M,U,T.$je.fromString(be),ce&&f.location.from(ce),K&&i.$2J.fromExtHostTestItem(K,O).toString()))},end:()=>{ue||(ue=!0,this.w.$finishedTestRunTask(M,U),this.f.delete(U),this.f.size||this.D())}};return this.f.set(U,{run:x}),this.w.$startedTestRunTask(M,{id:U,name:j,running:!0}),x}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof l.$oN))throw new r.$6M(j.id);if(this.g.has(i.$2J.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const M=[],O=this.s.colllection.root;for(;;){const U=f.TestItem.from(j);if(M.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),j===O))break;j=j.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(j,M){this.g=j,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(j,M){return this.f.find(O=>O.runId===j)?.coverage.get(M)}prepareForMainThreadTestRun(j,M,O,U){return this.j(j,M,O,U)}cancelRunById(j){for(const M of this.c.values())if(M.id===j){M.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,M,O,U,Y,le){const Z=this.c.get(U);if(Z)return Z.createRun(Y);const J=k.fromPublic(M,O,U,le),X=d(U);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:X&&{group:z[X.kind],id:X.profileId},exclude:U.exclude?.map(x=>i.$2J.fromExtHostTestItem(x,O.root.id).toString())??[],id:J.id,include:U.include?.map(x=>i.$2J.fromExtHostTestItem(x,O.root.id).toString())??[O.root.id],persist:le});const ue=this.j(U,J,j);return I.Event.once(ue.onEnd)(()=>{this.g.$finishedExtensionTestRun(J.id),ue.dispose()}),ue.createRun(Y)}j(j,M,O,U){const Y=new h(M,this.g,O,this.h,U);this.c.set(j,Y);let le;const Z=Y.onDidCoverage(({runId:J,taskId:X,coverage:ue})=>{le||(le={runId:J,coverage:new Map},this.f.unshift(le),this.f.length>n.$9J&&this.f.pop()),le.coverage.set(X,ue),this.g.$signalCoverageAvailable(J,X,!!ue)});return I.Event.once(Y.onEnd)(()=>{this.c.delete(j),Z.dispose()}),Y}}e.$8hc=a;const d=N=>{if(N.profile){if(!(N.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class k{static fromPublic(j,M,O,U){return new k(j,(0,C.$qg)(),O.include?.map(Y=>i.$2J.fromExtHostTestItem(Y,j).toString())??[j],O.exclude?.map(Y=>i.$2J.fromExtHostTestItem(Y,j).toString())??[],U,M)}static fromInternal(j,M){return new k(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,M)}constructor(j,M,O,U,Y,le){this.controllerId=j,this.id=M,this.isPersisted=Y,this.colllection=le,this.c=O.map(Z=>Z+"\0"),this.f=U.map(Z=>Z+"\0")}isIncluded(j){const M=i.$2J.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.f)if(M===O||M.startsWith(O))return!1;for(const O of this.c)if(M===O||M.startsWith(O))return!0;return!1}}e.$9hc=k;class A{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(j,M){const O=await this.c;let U=O?.[j];return!this.provider||!O||!U?[]:(U.detailedCoverage||(U=O[j]=await this.provider.resolveFileCoverage?.(U,M)??U),U.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,f.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const M=i.$2J.parentId(j.item.extId);if(M&&this.h.has(M.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:M,g:O}=this;return{get added(){return[...j].map(U=>U.revived)},get updated(){return[...M].map(U=>U.revived)},get removed(){return[...O].map(U=>U.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends n.$0J{constructor(){super(...arguments),this.s=new I.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,M){return{...j,revived:f.TestItem.toPlain(j.item),depth:M?M.depth+1:0,children:new Set}}v(){return new p(this.s)}}class E{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(M=>M.revived)},dispose:(0,R.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new w({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}const P=(N,j,M,O)=>{M?Object.assign(M,O):j.$updateTestRunConfig(N.controllerId,N.profileId,O)};class F{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,P(this,this.#e,this.#n,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,P(this,this.#e,this.#n,{supportsContinuousRun:j}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?this.#i.add(this.profileId):this.#i.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,P(this,this.#e,this.#n,{tag:j?f.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,P(this,this.#e,this.#n,{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return(0,c.$CF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,j=>j.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(L.$Qf))}constructor(j,M,O,U,Y,le,Z,J,X,ue,x=!1,be=void 0,ce=!1){this.controllerId=le,this.profileId=Z,this.f=J,this.kind=X,this.runHandler=ue,this._tag=be,this.g=ce,this.#e=j,this.#r=M,this.#t=O,this.#i=U,this.#o=Y,M.set(Z,this);const K=z[X];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);x&&U.add(Z),this.#n={profileId:Z,controllerId:le,tag:be?f.TestTag.namespace(this.controllerId,be.id):null,label:J,group:K,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:ce},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$0hc=F;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[151],Se([1,0,60,14,121,15,7]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;class b{static{this.c=new g.$gN("TextEditorDecorationType")}constructor(m,v,S){const l=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,l,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$iN=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let S=null;if(m instanceof R.$aL)S=new R.$bL(m,m);else if(m instanceof R.$bL)S=m;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert(m,v){this.k(),this.l(new R.$bL(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof R.$bL)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,S){const l=this.c.validateRange(m);this.g.push({range:l,text:v,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=m}}class y{constructor(m,v,S,l){this.c=m,this.d=v,this._accept(S),this.e=l;const f=this;this.value={get tabSize(){return f.f},set tabSize(o){f.n(o)},get indentSize(){return f.g},set indentSize(o){f.p(o)},get insertSpaces(){return f.j},set insertSpaces(o){f.s(o)},get cursorStyle(){return f.k},set cursorStyle(o){f.t(o)},get lineNumbers(){return f.l},set lineNumbers(o){f.u(o)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}n(m){const v=this.m(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}p(m){const v=this.o(m);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const v=this.q(m);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let S=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(S=!0,v.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,S=!0,v.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(S=!0,v.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,S=!0,v.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(S=!0,v.insertSpaces=l):this.j!==l&&(this.j=l,S=!0,v.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,S=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,S=!0,v.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(m,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$jN=y;class L{constructor(m,v,S,l,f,o,i,r){this.id=m,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,o,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return l.value},set document(c){throw new T.$9("document")},get selection(){return n.c&&n.c[0]},set selection(c){if(!(c instanceof R.$cL))throw(0,T.$7)("selection");n.c=[c],n.l()},get selections(){return n.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof R.$cL)))throw(0,T.$7)("selections");n.c=c,n.l()},get visibleRanges(){return n.e},set visibleRanges(c){throw new T.$9("visibleRanges")},get options(){return n.d.value},set options(c){n.g||n.d.assign(c)},get viewColumn(){return n.f},set viewColumn(c){throw new T.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(l.value,t);return c(u),n.m(u)},insertSnippet(c,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(h=>I.Range.from(h));else if(t instanceof R.$aL){const{lineNumber:h,column:a}=I.Position.from(t);s=[{startLineNumber:h,startColumn:a,endLineNumber:h,endColumn:a}]}else if(t instanceof R.$bL)s=[I.Range.from(t)];else{s=[];for(const h of t)if(h instanceof R.$bL)s.push(I.Range.from(h));else{const{lineNumber:a,column:d}=I.Position.from(h);s.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return v.$tryInsertSnippet(m,l.value.version,c.value,s,u)},setDecorations(c,t){const u=t.length===0;u&&!n.h.has(c.key)||(u?n.h.delete(c.key):n.h.add(c.key),n.n(()=>{if(I.$$M(t))return v.$trySetDecorations(m,c.key,I.$_M(t));{const s=new Array(4*t.length);for(let h=0,a=t.length;h<a;h++){const d=t[h];s[4*h]=d.start.line+1,s[4*h+1]=d.start.character+1,s[4*h+2]=d.end.line+1,s[4*h+3]=d.end.character+1}return v.$trySetDecorationsFast(m,c.key,s)}}))},revealRange(c,t){n.n(()=>v.$tryRevealRange(m,I.Range.from(c),t||R.TextEditorRevealType.Default))},show(c){v.$tryShowEditor(m,I.ViewColumn.from(c))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(f=>f.range);S.sort((f,o)=>f.end.line===o.end.line?f.end.character===o.end.character?f.start.line===o.start.line?f.start.character-o.start.character:f.start.line-o.start.line:f.end.character-o.end.character:f.end.line-o.end.line);for(let f=0,o=S.length-1;f<o;f++){const i=S[f].end;if(S[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=v.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,l,{setEndOfLine:typeof v.setEndOfLine=="number"?I.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$kN=L}),define(ke[72],Se([1,0,60,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,c){this.h=n,this.i=c,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new T.$Vd,this.e=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const c=[],t=[],u=[];if(n.removedDocuments)for(const s of n.removedDocuments){const h=I.URI.revive(s),a=this.c.get(h);a?.unref()&&(this.c.delete(h),c.push(a.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const h=I.URI.revive(s.uri);let a=this.c.get(h);if(a&&h.scheme!==S.Schemas.vscodeNotebookCell&&h.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);a||(a=new o(new $.$eN(this.h.getProxy(b.$0K.MainThreadDocuments),h,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(h,a),t.push(a.value)),a.ref()}if(n.removedEditors)for(const s of n.removedEditors){const h=this.b.get(s);this.b.delete(s),h&&u.push(h)}if(n.addedEditors)for(const s of n.addedEditors){const h=I.URI.revive(s.documentUri);D.ok(this.c.has(h),`document '${h}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const a=this.c.get(h).value,d=new L.$kN(s.id,this.h.getProxy(b.$0K.MainThreadTextEditors),this.i,new f.$V(()=>a.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(k=>C.Range.to(k)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,d)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,g.$Oc)(c),(0,g.$Oc)(u),n.removedDocuments&&this.e.fire(c),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return l.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const c=this.b.get(this.a);return n?c:c?.value}allEditors(){return[...this.b.values()]}};e.$lN=i,e.$lN=i=Ge([Ve(0,y.$bN),Ve(1,m.$nj)],i),e.$mN=(0,R.$6h)("IExtHostDocumentsAndEditors")}),define(ke[345],Se([1,0,19,4,6,151,15,7]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class ${constructor(L,C){this.i=C,this.a=new T.$Vd,this.b=new T.$Vd,this.c=new T.$Vd,this.d=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(g.$0K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const C=this.i.allEditors();return L?C:C.map(m=>m.value)}async showTextDocument(L,C,m){let v;typeof C=="number"?v={position:R.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?v={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:v={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(L.uri,v),l=S&&this.i.getEditor(S);if(l)return l.value;throw S?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new I.$iN(this.h,L,C).value}$acceptEditorPropertiesChanged(L,C){const m=this.i.getEditor(L);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const v=C.selections.selections.map(R.Selection.to);m._acceptSelections(v)}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(R.Range.to));m._acceptVisibleRanges(v)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const v=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:m.value,selections:S,kind:v})}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(L){for(const C in L){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const v=R.ViewColumn.to(L[C]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$tgc=$}),define(ke[346],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0,e.$_hc=(0,T.$6h)("IExtHostTimeline");class L{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$0K.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$lm.equals(f,this.b.get(l.source)?.extension)){const o=l.uri===void 0?void 0:D.URI.revive(l.uri);return this.c.get(l.source)?.get(C(o))?.get(l.handle)}else return;return l}})}async $getTimeline(v,S,l,f){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(S),l,f)}registerTimelineProvider(v,S,l,f){const o=new I.$Sc,i=this.d(S.id,f,o).bind(this);let r;S.onDidChange&&(r=S.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:S.id}),this));const n=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(c,t,u){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(c,t,u);if(s==null)return;const h=i(c,t);return{...s,source:S.id,items:s.items.map(h)}},dispose(){for(const c of n.values())c.get(S.id)?.clear();r?.dispose(),o.dispose()}},l)}d(v,S,l){return(f,o)=>{let i;if(o?.cacheResults){let r=this.c.get(v);r===void 0&&(r=new Map,this.c.set(v,r));const n=C(f);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...c}=r,t=`${v}|${r.id??r.timestamp}`;i?.set(t,r);let u,s,h;r.iconPath&&(n instanceof R.$7L?h={id:n.id,color:n.color}:D.URI.isUri(n)?(u=n,s=n):{light:u,dark:s}=n);let a;return R.$AL.isMarkdownString(c.tooltip)?a=b.MarkdownString.from(c.tooltip):(0,y.$If)(c.tooltip)?a=c.tooltip:R.$AL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(c.detail)):(0,y.$If)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:v,command:r.command?S.toInternal(r.command,l):void 0,icon:u,iconDark:s,themeIcon:h,tooltip:a,accessibilityInformation:r.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,I.$Rc)(()=>{for(const f of this.c.values())f.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$aic=L;function C(m){return m?.toString()}}),define(ke[347],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;function o(n,c){if((0,L.$If)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends R.$Tc{constructor(c,t,u){super(),this.f=c,this.g=t,this.h=u,this.a=new Map,this.b=new l.$n8;function s(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>s(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(a=>s(a)?this.r(a):a):h})}registerTreeDataProvider(c,t,u){const s=this.createTreeView(c,{treeDataProvider:t},u);return{dispose:()=>s.dispose()}}createTreeView(c,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,k=this.m(c,t,u),A={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:h,hasHandleDrag:a,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(c,A),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,f.$CF)(u,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,f.$CF)(u,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,v.$jk)(E)&&(0,f.$CF)(u,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,P)=>k.reveal(E,P),dispose:async()=>{await p,this.a.delete(c),k.dispose()}};return this.B(w),w}$getChildren(c,t){const u=this.a.get(c);return u?u.getChildren(t):Promise.reject(new b.$aF(c))}async $handleDrop(c,t,u,s,h,a,d,k){const A=this.a.get(c);if(!A)return Promise.reject(new b.$aF(c));const p=m.DataTransfer.toDataTransfer(u,async w=>(await this.f.$resolveDropFileData(c,t,w)).buffer);return d===c&&k&&await this.j(p,A,k,h,a),A.onDrop(p,s,h)}async j(c,t,u,s,h){const a=this.b.removeDragOperationTransfer(h);if(a)(await a)?.forEach((d,k)=>{d&&c.set(k,d)});else if(h&&t.handleDrag){const d=t.handleDrag(u,c,s);this.b.addDragOperationTransfer(h,d),await d}return c}async $handleDrag(c,t,u,s){const h=this.a.get(c);if(!h)return Promise.reject(new b.$aF(c));const a=await this.j(new y.$4L,h,t,s,u);if(!(!a||s.isCancellationRequested))return m.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$aF(c);return t.hasResolve}$resolve(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);return s.resolveTreeItem(t,u)}$setExpanded(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);s.setExpanded(t,u)}$setSelectionAndFocus(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);s.setSelectionAndFocus(t,u)}$setVisible(c,t){const u=this.a.get(c);if(!u){if(!t)return;throw new b.$aF(c)}u.setVisible(t)}$changeCheckboxState(c,t){const u=this.a.get(c);if(!u)throw new b.$aF(c);u.setCheckboxState(t)}m(c,t,u){const s=this.B(new r(c,t,this.f,this.g.converter,this.h,u));return this.a.set(c,s),s}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$bic=i;class r extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.$Rf)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,u,s,h,a){if(super(),this.I=c,this.J=u,this.L=s,this.M=h,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$6d,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const w of a.contributes.views[p])w.id===c&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let d,k;const A=I.Event.debounce(this.F.event,(p,w)=>(p||(p={message:!1,elements:[]}),w.element!==!1&&(d||(d=new Promise(E=>k=E),this.G=this.G.then(()=>d)),Array.isArray(w.element)?p.elements.push(...w.element):p.elements.push(w.element)),w.message&&(p.message=!0),p),200,!0);this.B(A(({message:p,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const E=k;return d=null,this.$(w).then(()=>E())})),p&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let u=this.X(c);return u||(u=await this.Y(t)),u?u.map(s=>s.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const u=(0,L.$Rf)(t.select)?!0:t.select,s=(0,L.$Rf)(t.focus)?!1:t.focus,h=(0,L.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:a.map(k=>k.item)},{select:u,focus:s,expand:h})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:u,focus:s,expand:h})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const u=this.getExtensionElement(c);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(c,t){const u=!(0,C.$ub)(this.s,c);this.s=c;const s=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async u=>{const s=this.getExtensionElement(u.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(c,t,u){const s=[];for(const h of c){const a=this.getExtensionElement(h);a&&s.push(a)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,u){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(s,c,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(c);if(u){const s=this.m.get(u);if(s){const h=await this.f.resolveTreeItem(s.extensionItem,u,t)??s.extensionItem;return this.hb(h),s.item.tooltip=this.eb(h.tooltip),s.item.command=this.fb(s.disposableStore,h.command),s.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(s=>(u.push(s),u))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Yg)(()=>this.f.getParent(c))}W(c,t){const u=this.m.get(c);return u?Promise.resolve(u):(0,$.$Yg)(()=>this.f.getTreeItem(c)).then(s=>this.kb(c,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(s);if(h){const a=this.m.get(h);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const u=this.getExtensionElement(c);t=u?this.m.get(u):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new S.$6d(this.Z.token);try{const u=c?this.m.get(c):void 0,s=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const h=(0,C.$Hb)(s||[]),a=await Promise.all((0,C.$Hb)(h).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const d=a.map((k,A)=>k?this.db(h[A],k,u):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(c){if(c.some(u=>!u))return this.Z.dispose(!0),this.Z=new S.$6d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(c);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(c){const t=new Set,u=c.map(h=>this.m.get(h));for(const h of u)if(h&&!t.has(h.item.handle)){let a=h;for(;a&&a.parent&&u.findIndex(d=>a&&a.parent&&d&&d.item.handle===a.parent.item.handle)===-1;){const d=this.j.get(a.parent.item.handle);a=d?this.m.get(d):void 0}a&&!a.parent&&t.add(h.item.handle)}const s=[];return t.forEach(h=>{const a=this.j.get(h);if(a){const d=this.m.get(a);d&&(!d.parent||!t.has(d.parent.item.handle))&&s.push(h)}}),s}bb(c){const t={};return Promise.all(c.map(u=>this.cb(u).then(s=>{s&&(t[u]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,$.$Yg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const h=this.ib(t,s,u.parent);return this.pb(t,h,u,u.parent),u.dispose(),h}return null})}return Promise.resolve(null)}db(c,t,u){const s=this.ib(c,t,u);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,s),this.qb(s,u),s}eb(c){return y.$AL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,u,s;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,u=c.checkboxState.tooltip,s=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:s}}hb(c){if(!y.$YL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,u){this.hb(t);const s=this.B(new R.$Sc),h=this.kb(c,t,u),a=this.lb(t);return{item:{handle:h,parentHandle:u?u.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,L.$Rf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(c){return c.iconPath instanceof y.$7L?c.iconPath:void 0}kb(c,{id:t,label:u,resourceUri:s},h,a){if(t)return`${r.b}/${t}`;const d=o(u,this.N),k=h?h.item.handle:r.a;let A=d?d.label:s?(0,T.$Eg)(s):"";A=A.indexOf("/")!==-1?A.replace("/","//"):A;const p=this.m.has(c)?this.m.get(c).item.handle:void 0,w=this.X(h)||[];let E,P=0;do{if(E=`${k}/${P}:${A}`,a||!this.j.has(E)||p===E)break;P++}while(P<=w.length);return E}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$7L))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$7L)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,u,s){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(c,t);const h=this.X(s)||[],a=h.filter(d=>d.item.handle===u.item.handle)[0];a&&h.splice(h.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[348],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class L extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(S,l,f,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=l,this.#o=f,this.#i=o.viewType,this.#n=o.panelOptions,this.#s=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends T.$Tc{static c(){return(0,I.$qg)()}constructor(S,l,f){super(),this.j=l,this.m=f,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$0K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,l,f,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,b.$Igc)(S),t=C.c();this.f.$createWebviewPanel((0,b.$Kgc)(S),t,l,{title:f,panelOptions:m(i),webviewOptions:(0,b.$Lgc)(S,this.m,i),serializeBuffersForPostMessage:c},n);const u=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,l,f,r,i,u,!0)}$onDidChangeWebviewPanelViewStates(S){const l=Object.keys(S);l.sort((f,o)=>{const i=S[f],r=S[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const f of l){const o=this.getWebviewPanel(f);if(!o)continue;const i=S[f];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,l,f){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:f,extension:S}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,b.$Igc)(S)}),new y.$_K(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(S,l,f,o){const i=this.h.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:r,extension:n}=i,c=this.j.createNewWebview(S,f.webviewOptions,n),t=this.createNewWebviewPanel(S,l,f.title,o,f.panelOptions,c,f.active);await r.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(S,l,f,o,i,r,n){const c=new L(S,this.f,r,{viewType:l,title:f,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,c),c}getWebviewPanel(S){return this.g.get(S)}}e.$Mgc=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[349],Se([1,0,4,3,93,15,6,7]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class $ extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(C,m,v,S,l,f){super(),this.#n=!1,this.#u=this.B(new D.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Vd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=C,this.#t=m,this.#o=l,this.#r=f}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#n||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#n)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$0K.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Kgc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Igc)(C)}),new b.$_K(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,S,l){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:o,extension:i}=f,r=this.d.createNewWebview(C,{},i),n=new $(C,this.a,m,v,r,!0);this.c.set(C,n),await o.resolveWebviewView(n,{state:S},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$eic=y}),define(ke[350],Se([1,0,69,16,13,249,32,10]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(T.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Vic=$,e.$Vic=$=Ge([Ve(0,D.$Egc),Ve(1,g.$nj)],$);class y{constructor(C){this.b=C,this.a=new I.$Bq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[351],Se([1,0,17,63,30,35,3,6,2,20]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;let L=class extends R.$Tc{constructor(m,v){super();const S=m.getProxy(b.$0K.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=$.URI.file((0,D.$jc)((0,T.tmpdir)(),(0,g.$qg)()));return await S.$download(l,f),f})}};e.$Tic=L,e.$Tic=L=Ge([Ve(0,y.$bN),Ve(1,I.$xN)],L)}),define(ke[352],Se([1,0,56,17,2,94,3,16,11,31]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class L extends I.$Ggc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==b.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let h=0;do{let a;h===0?a=s:a=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${h}`:`${s}-${h}`,await C(a);const d=T.$jc(a,"vscode.lock"),k=await l(this.d,d,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(a);h++}while(h<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$6ic=L;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class S extends R.$Tc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new $.$eh),this.a.cancelAndSet(async()=>{const s=await f(t,u);(!s||s.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(u,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${u}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function l(c,t,u){try{const h={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){c.error(h)}const s=await f(c,t);return!s||s.pid!==process.pid?u?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new S(c,t))}async function f(c,t){let u;try{u=await y.Promises.readFile(t)}catch(s){return c.error(s),null}try{return JSON.parse(String(u))}catch(s){return c.error(s),null}}async function o(c,t){let u;try{u=await y.Promises.stat(t)}catch(s){return c.error(s),0}return u.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function r(c,t){const u=await f(c,t);if(!u)return c.info(`Lock '${t}': Could not read pid of lock holder.`),n(c,t);if(u.willReleaseAt){let k=u.willReleaseAt-Date.now();if(k<5e3){for(k>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$7g)(Math.min(100,k)),await o(c,t)===0)return n(c,t);k=u.willReleaseAt-Date.now()}return n(c,t)}}if(!i(u.pid))return c.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),n(c,t);const s=await o(c,t),h=Date.now()-s;if(h<=v)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$7g)(2e3);const a=await o(c,t),d=Date.now()-a;return d<=v?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(c,t))}async function n(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return l(c,t,!0)}}),define(ke[353],Se([1,0,30,20,46,35]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;let R=class extends g.$3gc{constructor($,y){super(!0,$,y)}createTerminal($,y,L){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:L})}createTerminalFromOptions($,y){const L=new g.$2gc(this.a,(0,D.$qg)(),$,$.name);return this.f.push(L),L.create($,this.R($,y)),L.value}};e.$oic=R,e.$oic=R=Ge([Ve(0,I.$xN),Ve(1,T.$bN)],R)}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.OutputChannelUpdateMode=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=void 0,e.$iK="text/x-code-output",e.$jK="output",e.$kK="Log",e.$lK="text/x-code-log-output",e.$mK="log",e.$nK="workbench.panel.output",e.$oK=new g.$kj("inOutput",!1),e.$pK=new g.$kj("activeLogOutput",!1),e.$qK=new g.$kj("outputView.scrollLock",!1),e.$rK=(0,I.$6h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sK={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(L=>y.push(L)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$Hn.add(e.$sK.OutputChannels,new b),e.$tK=new g.$kj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,26,13,354,69,27,58,182,22,18,32,4,3]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0;class o extends R.$tj{get disposed(){return this.n}constructor(c,t,u,s,h){super(),this.id=c,this.name=t,this.r=u,this.s=s,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$je.fromString(t).byteLength,(0,R.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let r=class{constructor(c,t,u,s,h,a){this.i=t,this.j=u,this.k=s,this.l=h,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$0K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(c,t,u){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,h=(0,v.$If)(t)?t:void 0;if((0,v.$If)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const d=this.i.environment.extensionLogLevel?.find(([A])=>I.$lm.equals(u.identifier,A))?.[1];d&&(a=(0,R.$Dj)(d));const k=s?this.o(c,a,u):this.n(c,h,u);return k.then(A=>{this.g.set(A.id,A),A.visible=A.id===this.h}),s?this.r(c,a??this.m.getLevel(),k):this.q(c,k)}async n(c,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,h=this.k.extUri.joinPath(s,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(c,h,t,u.identifier.value);return new o(d,c,a,this.a,u)}async o(c,t,u){const s=await this.p(u),h=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(s,`${h}.log`),d=`${u.identifier.value}.${h}`,k=this.l.createLogger(a,{id:d,name:c,logLevel:t,extensionId:u.identifier.value});return new i(d,c,k,this.a,u)}p(c){let t=this.d.get(c.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(s){if((0,S.$Gk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return u})())}return t}q(c,t){let u=!1;const s=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return c},append(h){s(),t.then(a=>a.append(h))},appendLine(h){s(),t.then(a=>a.appendLine(h))},clear(){s(),t.then(h=>h.clear())},replace(h){s(),t.then(a=>a.replace(h))},show(h,a){s(),t.then(d=>d.show(h,a))},hide(){s(),t.then(h=>h.hide())},dispose(){u=!0,t.then(h=>h.dispose())}}}r(c,t,u){const s=new f.$Sc,h=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},a=s.add(new l.$Vd);function d(k){t=k,a.fire(k)}return u.then(k=>{s.add(k),k.logLevel!==t&&d(k.logLevel),s.add(k.onDidChangeLogLevel(A=>d(A)))}),{...this.q(c,u),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(k,...A){h(),u.then(p=>p.trace(k,...A))},debug(k,...A){h(),u.then(p=>p.debug(k,...A))},info(k,...A){h(),u.then(p=>p.info(k,...A))},warn(k,...A){h(),u.then(p=>p.warn(k,...A))},error(k,...A){h(),u.then(p=>p.error(k,...A))},dispose(){s.dispose()}}}};e.$Rhc=r,e.$Rhc=r=Ge([Ve(0,g.$bN),Ve(1,y.$rN),Ve(2,$.$Egc),Ve(3,L.$egc),Ve(4,R.$oj),Ve(5,R.$nj)],r),e.$Shc=(0,T.$6h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,D.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,T.$7g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(I):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,223,87,37,40,51,3,4,153,10,24]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const v=new m;g.$Hn.add(e.$VH.ConfigurationMigration,v);let S=class extends b.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(r=>this.g(r,o?.uri))])}async g(o,i){const r=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of n){const u=[];for(const h of r.overrideIdentifiers??[]){const a=await this.h(o,{resource:i,overrideIdentifier:h},c);for(const d of a??[]){let k=u.find(([[A,p]])=>A===d[0]&&(0,C.$zn)(p.value,d[1].value));k||u.push(k=[d,[]]),k[1].push(h)}}const s=await this.h(o,{resource:i},c,r);for(const h of s??[])u.push([h,[]]);u.length&&await Promise.allSettled(u.map(async([[h,a],d])=>this.a.updateValue(h,a.value,{resource:i,overrideIdentifiers:d},t)))}}async h(o,i,r,n){const c=h=>t(this.a.inspect(h,i)),t=h=>{const a=h[r];return i.overrideIdentifier?a?.override:a?.value},u=n?t(n):c(o.key);if(u===void 0)return;const s=await o.migrateFn(u,c);return Array.isArray(s)?s:[[o.key,s]]}};e.$WH=S,e.$WH=S=Ge([Ve(0,R.$zi),Ve(1,I.$ci)],S);let l=class extends b.$Tc{constructor(o){super(),(async()=>{if(!L.$i&&(await o.getEnvironment())?.os!==1)return;g.$Hn.as(T.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$XH=l,e.$XH=l=Ge([Ve(0,y.$Lm)],l)}),define(ke[356],Se([1,0,34,16,17,23,232,355,87,5,37]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$hdb=e.$gdb=void 0,e.$gdb=(0,y.$6h)("editorResolverService"),e.$hdb="workbench.editorAssociations";const C=L.$Hn.as($.$Mn.Configuration),m={...b.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function l(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$idb=l;function f(o,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Eg)(i);return D.$Lj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$jdb=f}),define(ke[357],Se([1,0,33,16,17,10,23,2,5,267,40,143,153]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=void 0,e.$LK=(0,$.$6h)("pathService");let S=v=class{constructor(f,o,i,r){this.d=f,this.e=o,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??f})()}hasValidBasename(f,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(r=>this.h(f,r,o)):this.h(f,o,i)}h(f,o,i){return f.scheme===T.Schemas.file||f.scheme===T.Schemas.vscodeRemote?(0,D.$6f)(i??(0,R.$Eg)(f),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,y.$IK)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:T.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let o="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const r=f.indexOf("/",2);r===-1?(o=f.substring(2),f="/"):(o=f.substring(2,r),f=f.substring(r)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:o,path:f,query:"",fragment:""})}};e.$MK=S,e.$MK=S=v=Ge([Ve(1,m.$Lm),Ve(2,C.$uK),Ve(3,L.$ci)],S)}),define(ke[358],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,25,21,18,24,45]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.OnPortForward=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.TunnelSource=e.TunnelCloseReason=e.$xK=e.$wK=e.$vK=void 0;const t=10*1e3,u="remote.tunnels.toRestore";e.$vK="onTunnel",e.$wK=new c.$kj("forwardedPortsViewEnabled",!1,D.localize(0,null));function s(F){const z=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$xK=s;var h;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var a;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$yK={source:a.User,description:D.localize(1,null)},e.$zK={source:a.Auto,description:D.localize(2,null)};function d(F,z,N){const j=F.get(A(z,N));if(j)return j;if((0,S.$Fv)(z))for(const M of S.$Ev){const O=A(M,N);if(F.has(O))return F.get(O)}else if((0,S.$Hv)(z))for(const M of S.$Gv){const O=A(M,N);if(F.has(O))return F.get(O)}}e.$AK=d;function k(F,z,N){const j=d(F,z,N);if(j)return j;const M=(0,S.$Hv)(z)?"localhost":(0,S.$Fv)(z)?"0.0.0.0":void 0;if(M)return d(F,M,N)}e.$BK=k;function A(F,z){return F+":"+z}e.$CK=A;var p;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(p||(e.OnPortForward=p={}));function w(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}e.$DK=w;class E extends b.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new I.$Vd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(N=>{(N.affectsConfiguration(E.c)||N.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,N,j){let M=this.w(z,N,j,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const U=this.j[M];U.key===z?(O.onAutoForward=U.onAutoForward??O.onAutoForward,O.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:O.elevateIfNeeded,O.label=U.label??O.label,O.requireLocalPort=U.requireLocalPort,O.protocol=U.protocol):(O.onAutoForward=O.onAutoForward??U.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:U.elevateIfNeeded,O.label=O.label??U.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??U.protocol),M=this.w(z,N,j,this.j,M+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,r.$If)(z.host)&&(0,r.$Mf)(z.port)}w(z,N,j,M,O){if(O>=M.length)return-1;const U=!(0,S.$Fv)(N)&&!(0,S.$Hv)(N),le=M.slice(O).findIndex(Z=>(0,r.$Mf)(Z.key)?U?!1:Z.key===z:this.t(Z.key)?U?!1:z>=Z.key.start&&z<=Z.key.end:this.u(Z.key)?z===Z.key.port&&N===Z.key.host:j?Z.key.test(j):!1);return le>=0?le+O:-1}y(){const z=this.r.getValue(E.c);if(!z||!(0,r.$Kf)(z))return[];const N=[];for(const M in z){if(M===void 0)continue;const O=z[M];let U;if(Number(M))U=Number(M);else if((0,r.$If)(M))if(E.g.test(M)){const Y=M.match(E.g);U={start:Number(Y[1]),end:Number(Y[2])}}else if(E.h.test(M)){const Y=M.match(E.h);U={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(M)}catch{}Y&&(U=Y)}U&&N.push({key:U,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(N)}z(z){function N(j,M){return(0,r.$Mf)(j.key)?j.key:M.t(j.key)?j.key.start:M.u(j.key)?j.key.port:Number.MAX_VALUE}return z.sort((j,M)=>N(j,this)-N(M,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return p.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return p.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return p.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return p.OpenPreview;case S.ProvidedOnAutoForward.Silent:return p.Silent;case S.ProvidedOnAutoForward.Ignore:return p.Ignore;default:return}}async addAttributes(z,N,j){const O=this.r.inspect(E.c).userRemoteValue;let U;!O||!(0,r.$Kf)(O)?U={}:U=(0,n.$vn)(O),U[`${z}`]||(U[`${z}`]={});for(const Y in N)U[`${z}`][Y]=N[Y];return this.r.updateValue(E.c,U,j)}}e.$EK=E;let P=class extends b.$Tc{constructor(z,N,j,M,O,U,Y,le,Z,J){super(),this.H=z,this.I=N,this.J=j,this.L=M,this.M=O,this.N=U,this.O=Y,this.P=le,this.Q=Z,this.R=J,this.c=new Map,this.g=new I.$Vd,this.onForwardPort=this.g.event,this.h=new I.$Vd,this.onClosePort=this.h.event,this.j=new I.$Vd,this.onPortName=this.j.event,this.n=new I.$Vd,this.onCandidatesChanged=this.n.event,this.t=new I.$Vd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Vd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const ue=await this.getAttributes(X.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of X)if(x.localAddress){const be=A(x.tunnelRemoteHost,x.tunnelRemotePort),ce=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(be,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:ue?.get(x.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ue?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,privacy:x.privacy,source:e.$yK}),this.f.set(be,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const ue=A(X.tunnelRemoteHost,X.tunnelRemotePort);if(!k(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const x=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),be=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:be?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,be),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:X.privacy,source:e.$yK})}await this.$(),this.f.set(ue,X),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(X=>this.W(X,h.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$vK))?(this.R.createKey(e.$wK.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,N){const j=A(z.host,z.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(z))}X(z,N){if(z.startsWith("http"))return $.URI.parse(z);const j=N?.protocol??"http";return $.URI.parse(`${j}://${z}`)}async Y(){const z=this.N.getWorkspace(),N=z.configuration?(0,R.$Ti)(z.configuration.path):z.folders.length>0?(0,R.$Ti)(z.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${u}.${this.L.remoteAuthority}.${N}`}async Z(){const z=this.I.get(u,1);if(z)return this.I.remove(u,1),await this.$(),z;const N=await this.Y();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const N=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(j=>j.remotePort).join(", ")}`);for(const j of N){const M=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!M||j.source.source===a.Extension&&M?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!M&&this.D.set(A(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new b.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const N=await this.Y();N&&this.I.store(N,this.y,0,0)}}}async bb(z,N,j){if(!z.tunnelLocalPort||!j?.requireLocalPort||z.tunnelLocalPort===N)return;const M=new Date;if(this.ab.getTime()+t>M.getTime())return;this.ab=M;const O=D.localize(3,null,N,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,N){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(z,N)}async cb(z,N){await this.Q.activateByEvent(e.$vK);const j=k(this.forwarded,z.remote.host,z.remote.port);N=N??(N!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const M=z.local!==void 0?z.local:z.remote.port;let O;if(j)return this.eb(j,z,N);{const U=this.L.remoteAuthority,Y=U?{getAddress:async()=>(await this.M.resolveAuthority(U)).authority}:void 0,le=A(z.remote.host,z.remote.port);this.c.set(le,!0),z=this.db(le,z);const Z=await this.H.openTunnel(Y,z.remote.host,z.remote.port,void 0,M,z.elevateIfNeeded?z.elevateIfNeeded:N?.elevateIfNeeded,z.privacy,N?.protocol);if(typeof Z=="string")O=Z;else if(Z&&Z.localAddress){const J=k(this.m??new Map,z.remote.host,z.remote.port),X=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:N?.protocol??S.TunnelProtocol.Http,ue={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:N?.label??z.name,closeable:!0,localAddress:Z.localAddress,protocol:X,localUri:await this.X(Z.localAddress,N),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:z.source??e.$yK,privacy:Z.privacy};return this.forwarded.set(le,ue),this.f.set(le,Z),this.c.delete(le),await this.$(),await this.bb(Z,M,N),this.g.fire(ue),Z}this.c.delete(le)}return O}db(z,N){const j=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(j){const M=j.get(z);j.delete(z),M&&(N.name=M.name??N.name,N.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??N.local,N.privacy=M.privacy??N.privacy)}return N}async eb(z,N,j){const M=j?.label??N.name;let O;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(O||(O={}));let U=O.None;switch(M!==z.name&&(z.name=M,U=O.Fire),(j?.protocol||z.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&(N.source=z.source,U=O.Reopen),N.privacy&&z.privacy!==N.privacy&&(U=O.Reopen),U){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,h.User),await this.cb(N,j)}return k(this.f,N.remote.host,N.remote.port)}async name(z,N,j){const M=k(this.forwarded,z,N),O=A(z,N);if(M){M.name=j,await this.$(),this.j.fire({host:z,port:N});return}else this.detected.has(O)&&(this.detected.get(O).name=j,this.j.fire({host:z,port:N}))}async close(z,N,j){const M=A(z,N),O=this.forwarded.get(M);return j===h.AutoForwardEnd&&O&&O.source.source===a.Auto&&this.F.set(M,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,N),this.W({host:z,port:N},j)}address(z,N){const j=A(z,N);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const N of z){const j=k(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),M=typeof N.localAddress=="string"?N.localAddress:A(N.localAddress.host,N.localAddress.port);this.detected.set(A(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:M,protocol:S.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,M,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let N=z;this.r&&(N=await this.r(z));const j=this.fb(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(M=>M.port).join(", ")}`),this.n.fire(j)}fb(z){const N=this.m??new Map,j=new Map;return this.m=j,z.forEach(M=>{const O=A(M.host,M.port);j.set(O,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),N.has(O)&&N.delete(O);const U=k(this.forwarded,M.host,M.port);U&&(U.runningProcess=M.detail,U.hasRunningProcess=!0,U.pid=M.pid)}),N.forEach((M,O)=>{const U=s(O);if(!U)return;const Y=k(this.forwarded,U.host,U.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const le=k(this.detected,U.host,U.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),N=await this.getAttributes(z.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(N)for(const j of z){const M=N.get(j.remotePort);(M?.protocol||j.protocol!==S.TunnelProtocol.Http)&&M?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},M),M&&M.label&&M.label!==j.name&&await this.name(j.remoteHost,j.remotePort,M.label)}}async getAttributes(z,N=!0){const j=new Map,M=new Map;z.forEach(Z=>{const J=k(this.m??new Map,S.$Ev[0],Z.port)??Z;if(J){j.set(Z.port,J);const X=w(J)?J.pid:void 0;M.has(X)||M.set(X,[]),M.get(X)?.push(Z.port)}});const O=new Map;if(z.forEach(Z=>{const J=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);J&&O.set(Z.port,J)}),this.G.length===0||!N)return O.size>0?O:void 0;const U=await Promise.all((0,T.$Rb)(this.G.map(Z=>Array.from(M.entries()).map(J=>{const X=J[1],ue=j.get(X[0]);return Z.providePortAttributes(X,ue?.pid,ue?.detail,new i.$6d().token)})))),Y=new Map;if(U.forEach(Z=>Z.forEach(J=>{J&&Y.set(J.port,J)})),!O&&!Y)return;const le=new Map;return z.forEach(Z=>{const J=O.get(Z.port),X=Y.get(Z.port);le.set(Z.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??E.providedActionToAction(X?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),le}addAttributesProvider(z){this.G.push(z)}};e.$FK=P,Ge([(0,g.$yh)(1e3)],P.prototype,"$",null),e.$FK=P=Ge([Ve(0,S.$Av),Ve(1,v.$up),Ve(2,y.$zi),Ve(3,f.$uK),Ve(4,m.$8k),Ve(5,l.$ci),Ve(6,C.$nj),Ve(7,L.$6v),Ve(8,o.$yF),Ve(9,c.$lj)],P)}),define(ke[95],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oJ=e.$nJ=void 0;class D{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new D(0,0)}with(R){return new D(0,0)}}e.$nJ=D;class T{constructor(R,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,b),this.end=new D($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$oJ=T;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,12,5,17,14,95,11]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.SearchErrorCode=e.$DJ=e.$CJ=e.SearchSortOrder=e.ViewMode=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.SearchCompletionExitCode=e.$xJ=e.$wJ=e.$vJ=e.QueryType=e.SearchProviderType=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$pJ="workbench.view.search",e.$qJ="workbench.panel.search",e.$rJ="workbench.view.search",e.$sJ="search-result",e.$tJ="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",S=(m.length+v.length+5)*2;e.$uJ=(0,b.$6h)("searchService");var l;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(l||(e.SearchProviderType=l={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f||(e.QueryType=f={}));function o(X){return!!X.preview}e.$vJ=o;function i(X){return!!X.resource}e.$wJ=i;function r(X){return!!X.message}e.$xJ=r;var n;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class c{constructor(ue){this.resource=ue,this.results=[]}}e.$yJ=c;class t{constructor(ue,x,be,ce){this.ranges=x,this.webviewIndex=ce;const K=Array.isArray(x)?x:[x];if(be&&be.matchLines===1&&u(K)){ue=(0,R.$Bf)(ue,be.matchLines);let V="",re=0,ye=0;const de=Math.floor(be.charsPerLine/5),ge=[];for(const _ of K){const te=Math.max(_.startColumn-de,0),G=_.startColumn+be.charsPerLine;if(te>ye+de+S){const ie=m+(te-ye)+v;V+=ie+ue.slice(te,G),re+=te-(ye+ie.length)}else V+=ue.slice(ye,G);ge.push(new h(0,_.startColumn-re,_.endColumn-re)),ye=G}this.preview={text:V,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const V=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:ue,matches:(0,D.$2b)(x,re=>new s(re.startLineNumber-V,re.startColumn,re.endLineNumber-V,re.endColumn))}}}}e.$zJ=t;function u(X){const ue=X[0].startLineNumber;for(const x of X)if(x.startLineNumber!==ue||x.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,x,be,ce){this.startLineNumber=ue,this.startColumn=x,this.endLineNumber=be,this.endColumn=ce}}e.$AJ=s;class h extends s{constructor(ue,x,be){super(ue,x,ue,be)}}e.$BJ=h;var a;(function(X){X.List="list",X.Tree="tree"})(a||(e.ViewMode=a={}));var d;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function k(X,ue=!0){const x=X&&X.files&&X.files.exclude,be=ue&&X&&X.search&&X.search.exclude;if(!x&&!be)return;if(!x||!be)return x||be;let ce=Object.create(null);return ce=g.$yn(ce,g.$vn(x)),ce=g.$yn(ce,g.$vn(be),!0),ce}e.$CJ=k;function A(X,ue){return X.excludePattern&&T.$Lj(X.excludePattern,ue)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.$Lj(X.includePattern,ue)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(x=>{const be=x.folder.fsPath;if(I.$8f(ue,be)){const ce=$.$lc(be,ue);return!x.includePattern||!!T.$Lj(x.includePattern,ce)}else return!1}):!1:!0}e.$DJ=A;var p;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class w extends Error{constructor(ue,x){super(ue),this.code=x}}e.$EJ=w;function E(X){const ue=X.message;if((0,y.$4)(X))return new w(ue,p.canceled);try{const x=JSON.parse(ue);return new w(x.message,x.code)}catch{return new w(ue,p.other)}}e.$FJ=E;function P(X){const ue={message:X.message,code:X.code};return new Error(JSON.stringify(ue))}e.$GJ=P;function F(X){return X.type==="error"?!0:X.type==="success"}e.$HJ=F;function z(X){return X.type==="success"}e.$IJ=z;function N(X){return!!X.path}e.$JJ=N;function j(X,ue){const x=X.searchPath?X.searchPath:X.relativePath;return(0,R.$yf)(x,ue)}e.$KJ=j;class M{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LJ=M;function O(X,ue){const x={...X||{},...ue||{}};return Object.keys(x).filter(be=>{const ce=x[be];return typeof ce=="boolean"&&ce})}e.$MJ=O;class U{constructor(ue,x){this.c=null,this.a={...ue.excludePattern||{},...x.excludePattern||{}},this.b=T.$Mj(this.a);let be=ue.includePattern;x.includePattern&&(be?be={...be,...x.includePattern}:be=x.includePattern),be&&(this.c=T.$Mj(be))}matchesExcludesSync(ue,x,be){return!!(this.b&&this.b(ue,x,be))}includedInQuerySync(ue,x,be){return!(this.b&&this.b(ue,x,be)||this.c&&!this.c(ue,x,be))}includedInQuery(ue,x,be){const ce=this.b(ue,x,be),K=()=>this.c?!!this.c(ue,x,be):!0;return(0,C.$Sg)(ce)?ce.then(V=>V?!1:K()):K()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$NJ=U;function Y(X){for(const ue in X)if(typeof X[ue]!="boolean")return!0;return!1}function le(X){if(!X)return;let ue;return x=>(ue||(ue=(X()||Promise.resolve([])).then(be=>be?J(be):{})),ue.then(be=>!!be[x]))}e.$OJ=le;function Z(X){if(!X)return;let ue;return x=>{if(!ue){const be=X();ue=be?J(be):{}}return!!ue[x]}}e.$PJ=Z;function J(X){const ue={};for(const x of X)ue[x]=!0;return ue}}),define(ke[41],Se([1,0,19,11,21,4,3,77,16,122,23,12,2,221,5,13,252,40,58,27,20,15,7,66,36,6,55]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;function d(z,N,j){return new L.$wg(M=>w(M,j)).isEqual(z,N)}function k(z,N,j){return d(z.uri,N.uri,j)?0:(0,C.$5e)(z.uri.toString(),N.uri.toString())}function A(z,N,j){return z.index!==N.index?z.index<N.index?-1:1:d(z.uri,N.uri,j)?(0,C.$5e)(z.name,N.name):(0,C.$5e)(z.uri.toString(),N.uri.toString())}function p(z,N,j,M){const O=z.slice(0).sort((Y,le)=>j(Y,le,M)),U=N.slice(0).sort((Y,le)=>j(Y,le,M));return(0,D.$Eb)(O,U,(Y,le)=>j(Y,le,M))}function w(z,N){const j=N.getCapabilities(z.scheme);return!(j&&j&1024)}class E extends o.$mi{static toExtHostWorkspace(N,j,M,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:Y,folders:le,configuration:Z,transient:J,isUntitled:X}=N,ue=[],x=j;j?le.forEach((V,re)=>{const ye=m.URI.revive(V.uri),de=E.o(M||j,ye,O);de?(de.name=V.name,de.index=V.index,ue.push(de)):ue.push({uri:ye,name:V.name,index:re})}):ue.push(...le.map(({uri:V,name:re,index:ye})=>({uri:m.URI.revive(V),name:re,index:ye}))),ue.sort((V,re)=>V.index<re.index?-1:1);const be=new E(U,Y,ue,!!J,Z?m.URI.revive(Z):null,!!X,V=>w(V,O)),{added:ce,removed:K}=p(x?x.workspaceFolders:[],be.workspaceFolders,k,O);return{workspace:be,added:ce,removed:K}}static o(N,j,M){for(let O=0;O<N.folders.length;O++){const U=N.workspaceFolders[O];if(d(U.uri,j,M))return U}}constructor(N,j,M,O,U,Y,le){super(N,M.map(Z=>new o.$ni(Z)),O,U,le),this.t=j,this.u=Y,this.q=[],this.s=b.$_h.forUris(le),M.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,j){return j&&this.s.get(N)&&(N=(0,L.$Gg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let P=class{constructor(N,j,M,O,U){this.c=new I.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Xd,this.B=new Map,this.h=O,this.s=M,this.t=U,this.j=new y.$9l,this.k=new T.$5g,this.o=N.getProxy(h.$0K.MainThreadWorkspace),this.q=N.getProxy(h.$0K.MainThreadMessageService);const Y=j.workspace;this.l=Y?new E(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,le=>w(le,M)):void 0}$initializeWorkspace(N,j){this.v=j,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,L.$Eg)((0,L.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,j,M,...O){const U=[];if(Array.isArray(O)&&O.forEach(X=>{m.URI.isUri(X.uri)&&!U.some(ue=>d(ue.uri,X.uri,this.s))&&U.push({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri)})}),this.n||[j,M].some(X=>typeof X!="number"||X<0)||M===0&&U.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(j+M>Y.length)return!1;const le=Y.slice(0);le.splice(j,M,...U.map(X=>({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri),index:void 0})));for(let X=0;X<le.length;X++){const ue=le[X];if(le.some((x,be)=>be!==X&&d(ue.uri,x.uri,this.s)))return!1}le.forEach((X,ue)=>X.index=ue);const{added:Z,removed:J}=p(Y,le,A,this.s);if(Z.length===0&&J.length===0)return!1;if(this.o){const X=N.displayName||N.name;this.o.$updateWorkspaceFolders(X,j,M,U).then(void 0,ue=>{this.n=void 0;const x={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(f.Severity.Error,(0,v.localize)(0,null,X,ue.toString()),x,[])})}return this.y(le),!0}getWorkspaceFolder(N,j){if(this.x)return this.x.getWorkspaceFolder(N,j)}async getWorkspaceFolder2(N,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,j)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,j){let M,O="";if(typeof N=="string"?(M=m.URI.file(N),O=N):typeof N<"u"&&(M=N,O=N.fsPath),!M)return O;const U=this.getWorkspaceFolder(M,!0);if(!U)return O;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let Y=(0,L.$Jg)(U.uri,M);return j&&U.name&&(Y=`${U.name}/${Y}`),Y}y(N){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:j,added:M,removed:O}=E.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:O}))}findFiles(N,j,M,O,U=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let Y;if(j===null?Y=!1:j&&(typeof j=="string"?Y=j:Y=j.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Z}=F(c.GlobPattern.from(N));return this.o.$startFileSearch(le??null,Z??null,Y??null,M??null,U).then(J=>Array.isArray(J)?J.map(X=>m.URI.revive(X)):[])}async findTextInFiles(N,j,M,O,U=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),le=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Z,folder:J}=F(c.GlobPattern.from(j.include)),X=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ue={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:le,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Z,excludePattern:X},x=!1;if(this.u[Y]=be=>{if(x)return;const ce=m.URI.revive(be.resource);be.results.forEach(K=>{const V=(0,a.$Ch)(K);(0,s.$vJ)(V)?M({uri:ce,preview:{text:V.preview.text,matches:(0,D.$2b)(V.preview.matches,re=>new t.$bL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(V.ranges,re=>new t.$bL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):M({uri:ce,text:V.text,lineNumber:V.lineNumber})})},U.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(N,J??null,ue,Y,U);return delete this.u[Y],be||{}}catch(be){throw delete this.u[Y],be}}$handleTextSearchResult(N,j){this.u[j]?.(N)}async save(N){const j=await this.o.$save(N,{saveAs:!1});return m.URI.revive(j)}async saveAs(N){const j=await this.o.$save(N,{saveAs:!0});return m.URI.revive(j)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,j){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,j);const M=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,M),(0,R.$Rc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(N,j){this.h.info("Getting edit session identifier for workspaceFolder",N);const M=await this.resolveWorkspaceFolder(m.URI.revive(N));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const O=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!O),!O)return;const U=await O.provideEditSessionIdentity(M,j);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,j,M,O){this.h.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(m.URI.revive(N));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Y=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Y),!Y)return;const le=await Y.provideEditSessionIdentityMatch?.(j,M,O);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(N){return(j,M,O)=>{const U=function(le){j.call(M,le)};return U.extension=N,this.A.event(U,void 0,O)}}async $onWillCreateEditSessionIdentity(N,j,M){const O=await this.resolveWorkspaceFolder(m.URI.revive(N));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},j,async(U,Y)=>{const le=Date.now();await Promise.resolve(U),Date.now()-le>M&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(N,j){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,j);const M=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerCanonicalUriProvider(O,M),(0,R.$Rc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(N,j,M){const O=this.B.get(N.scheme);if(!O)return;const U=await O.provideCanonicalUri?.(m.URI.revive(N),j,M);if(U)return U}async $provideCanonicalUri(N,j,M){return this.provideCanonicalUri(m.URI.revive(N),{targetScheme:j},M)}};e.$ygc=P,e.$ygc=P=Ge([Ve(0,n.$bN),Ve(1,r.$rN),Ve(2,i.$egc),Ve(3,l.$nj),Ve(4,u.$wgc)],P),e.$zgc=(0,S.$6h)("IExtHostWorkspace");function F(z){let N,j;return z&&(typeof z=="string"?N=z:(N=z.pattern,j=m.URI.revive(z.baseUri))),{includePattern:N,folder:j}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,87,18,11,5,20,13,2]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=void 0;function l(u,s){if(s){const h=s.split(".");let a=u;for(let d=0;a&&d<h.length;d++)a=a[h[d]];return a}}function f(u){return u instanceof S.URI}function o(u){return u&&u.uri instanceof S.URI&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function r(u){return u&&u.uri instanceof S.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function n(u){if(f(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(i(u))return{overrideIdentifier:u.languageId};if(r(u))return{resource:u.uri};if(u===null)return{resource:null}}let c=class{constructor(s,h,a){this.a=s.getProxy(I.$0K.MainThreadConfiguration),this.c=h,this.b=a,this.d=new L.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,h){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,h))}};e.$Agc=c,e.$Agc=c=Ge([Ve(0,m.$bN),Ve(1,g.$zgc),Ve(2,v.$nj)],c);class t{constructor(s,h,a,d){this.a=new T.$Vd,this.b=s,this.f=d,this.c=h,this.e=b.$6n.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,h){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$6n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(h,a))}getConfiguration(s,h,a){const d=n(h)||{},k=this.g(s?l(this.e.getValue(void 0,d,this.c.workspace),s):this.e.getValue(void 0,d,this.c.workspace));s&&this.h(s,d,a?.identifier);function A(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(w){return typeof l(k,w)<"u"},get:(w,E)=>{this.h(s?`${s}.${w}`:w,d,a?.identifier);let P=l(k,w);if(typeof P>"u")P=E;else{let F;const z=(N,j)=>{if((0,y.$Kf)(N)){let M;const O=()=>{F=F||(0,D.$vn)(k),M=M||l(F,j)};return new Proxy(N,{get:(U,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return O(),()=>M;if(F)return M=M||l(F,j),M[Y];const le=U[Y];return typeof Y=="string"?z(le,`${j}.${Y}`):le},set:(U,Y,le)=>(O(),M&&(M[Y]=le),!0),deleteProperty:(U,Y)=>(O(),M&&delete M[Y],!0),defineProperty:(U,Y,le)=>(O(),M&&Object.defineProperty(M,Y,le),!0)})}return Array.isArray(N)?(0,D.$vn)(N):N};P=z(P,w)}return P},update:(w,E,P,F)=>{w=s?`${s}.${w}`:w;const z=A(P);return E!==void 0?this.b.$updateConfigurationOption(z,w,E,d,F):this.b.$removeConfigurationOption(z,w,d,F)},inspect:w=>{w=s?`${s}.${w}`:w;const E=this.e.inspect(w,d,this.c.workspace);if(E)return{key:w,defaultValue:(0,D.$vn)(E.policy?.value??E.default?.value),globalValue:(0,D.$vn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$vn)(E.workspace?.value),workspaceFolderValue:(0,D.$vn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$vn)(E.default?.override),globalLanguageValue:(0,D.$vn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$vn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$vn)(E.workspaceFolder?.override),languageIds:(0,D.$vn)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$yn)(p,k,!1),Object.freeze(p)}g(s){const h=a=>(0,y.$Kf)(a)?new Proxy(a,{get:(d,k)=>h(d[k]),set:(d,k,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(d,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(d,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return h(s)}h(s,h,a){const d=$.$Wn.test(s)?4:this.d.get(s),k=a?`[${a.value}] `:"";if(d===4){typeof h?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){h?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,h){const a=new b.$8n(s,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,k)=>a.affectsConfiguration(d,n(k))})}k(s){return s.reduce((h,a)=>(h.set(a[0],a[1]),h),new Map)}}e.$Bgc=t,e.$Cgc=(0,C.$6h)("IExtHostConfiguration")}),define(ke[96],Se([1,0,2,11,4,6,7,41,72,42,21,46,20,27,5,16,10,13,92,295,14]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=e.$4hc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(z){function N(M){if(M!=null)return M}z.from=N;function j(M){if(M!=null)return M}z.to=j})(c||(c={}));var t;(function(z){function N(M){if(M!=null)return M}z.from=N;function j(M){if(M!=null)return M}z.to=j})(t||(t={}));var u;(function(z){function N(M){if(M!=null)return M}z.from=N;function j(M){if(M!=null)return M}z.to=j})(u||(u={}));var s;(function(z){function N(O){if(O){const U=O;return U&&!!U.process}else return!1}z.is=N;function j(O){if(O==null)return;const U={process:O.process,args:O.args};return O.options&&(U.options=u.from(O.options)),U}z.from=j;function M(O){if(O!=null)return new R.$UL(O.process,O.args,O.options)}z.to=M})(s||(s={}));var h;(function(z){function N(M){if(M!=null)return M}z.from=N;function j(M){if(M!=null)return M}z.to=j})(h||(h={}));var a;(function(z){function N(O){if(O){const U=O;return U&&(!!U.commandLine||!!U.command)}else return!1}z.is=N;function j(O){if(O==null)return;const U={};return O.commandLine!==void 0?U.commandLine=O.commandLine:(U.command=O.command,U.args=O.args),O.options&&(U.options=h.from(O.options)),U}z.from=j;function M(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$VL(O.commandLine,O.options):new R.$VL(O.command,O.args?O.args:[],O.options)}z.to=M})(a||(a={}));var d;(function(z){function N(O){if(O){const U=O;return U&&U.customExecution==="customExecution"}else return!1}z.is=N;function j(O){return{customExecution:"customExecution"}}z.from=j;function M(O,U){return U.get(O)}z.to=M})(d||(e.CustomExecutionDTO=d={}));var k;(function(z){function N(j,M){let O;return j.scope!==void 0&&typeof j.scope!="number"?O=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?O=M.workspaceFile:O=r.$yG),{id:j._id,workspaceFolder:O}}z.from=N})(k||(e.TaskHandleDTO=k={}));var A;(function(z){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}z.from=N})(A||(A={}));var p;(function(z){function N(O,U){if(O==null)return[];const Y=[];for(const le of O){const Z=j(le,U);Z&&Y.push(Z)}return Y}z.fromMany=N;function j(O,U){if(O==null)return;let Y;O.execution instanceof R.$UL?Y=s.from(O.execution):O.execution instanceof R.$VL?Y=a.from(O.execution):O.execution&&O.execution instanceof R.$WL&&(Y=d.from(O.execution));const le=c.from(O.definition);let Z;return O.scope?typeof O.scope=="number"?Z=O.scope:Z=O.scope.uri:Z=R.TaskScope.Workspace,!le||!Z?void 0:{_id:O._id,definition:le,name:O.name,source:{extensionId:U.identifier.value,label:O.source,scope:Z},execution:Y,isBackground:O.isBackground,group:A.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=j;async function M(O,U,Y){if(O==null)return;let le;s.is(O.execution)?le=s.to(O.execution):a.is(O.execution)?le=a.to(O.execution):d.is(O.execution)&&(le=d.to(O._id,Y));const Z=c.to(O.definition);let J;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?J=O.source.scope:J=await U.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):J=R.TaskScope.Workspace),!Z||!J)return;const X=new R.$XL(Z,J,O.name,O.source.label,le,O.problemMatchers);return O.isBackground!==void 0&&(X.isBackground=O.isBackground),O.group!==void 0&&(X.group=R.$TL.from(O.group._id),X.group&&O.group.isDefault&&(X.group=new R.$TL(X.group.id,X.group.label),O.group.isDefault===!0&&(X.group.isDefault=O.group.isDefault))),O.presentationOptions&&(X.presentationOptions=t.to(O.presentationOptions)),O._id&&(X._id=O._id),O.detail&&(X.detail=O.detail),X}z.to=M})(p||(e.TaskDTO=p={}));var w;(function(z){function N(M){return M}z.from=N;function j(M){if(M)return Object.assign(Object.create(null),M)}z.to=j})(w||(w={}));class E{#e;constructor(N,j,M){this._id=j,this.a=M,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let P=class{constructor(N,j,M,O,U,Y,le,Z){this.q=new g.$Vd,this.r=new g.$Vd,this.s=new g.$Vd,this.u=new g.$Vd,this.a=N.getProxy(I.$0K.MainThreadTask),this.b=M,this.c=O,this.d=U,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,M){if(!M)return new R.$_K(()=>{});const O=this.x();return this.j.set(O,{type:j,provider:M,extension:N}),this.a.$registerTaskProvider(O,j),new R.$_K(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,j){this.a.$registerTaskSystem(N,j)}fetchTasks(N){return this.a.$fetchTasks(w.from(N)).then(async j=>{const M=[];for(const O of j){const U=await p.to(O,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const N=[];return this.k.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,j,M){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(j,await O.callback(M))),this.p=N.id,this.q.fire({execution:await this.z(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){if(!this.l.has(N.id))return;const j=await this.z(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const j=await this.z(N.id);this.s.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(N){const j=await this.z(N.id);this.u.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const M=this.j.get(N);if(!M)return Promise.reject(new Error("no handler found"));const O=[],U=(0,T.$Yg)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(Y=>this.v(j,O,M,Y));return new Promise(Y=>{U.then(le=>{Promise.all(O).then(()=>{Y(le)})})})}async $resolveTask(N,j){const M=this.j.get(N);if(!M)return Promise.reject(new Error("no handler found"));if(j.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${M.type}].`);const O=await p.to(j,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(O,L.CancellationToken.None);if(!U)return;this.A(U,M);const Y=p.from(U,M.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Y.execution)&&await this.y(Y,U,!0),await this.w(Y)}x(){return this.h++}async y(N,j,M){const O=await this.a.$createTaskId(N);!M&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,j.execution)),this.m.set(O,j.execution)}async z(N,j){if(typeof N=="string"){const U=this.l.get(N);if(!U)throw new n.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(N.id);if(M)return M;let O;return j?O=Promise.resolve(new E(this,N.id,j)):O=p.to(N.task,this.b,this.m).then(U=>{if(!U)throw new n.$bb("Unexpected: Task does not exist.");return new E(this,N.id,U)}),this.l.set(N.id,O),O.then(U=>(this.k.set(N.id,U),U))}A(N,j){N._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const M=this.n.values();let O=M.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=M.next()}};e.$4hc=P,e.$4hc=P=Ge([Ve(0,m.$bN),Ve(1,v.$rN),Ve(2,b.$zgc),Ve(3,$.$mN),Ve(4,y.$Cgc),Ve(5,C.$1gc),Ve(6,o.$nj),Ve(7,i.$hgc)],P);let F=class extends P{constructor(N,j,M,O,U,Y,le,Z){super(N,j,M,O,U,Y,le,Z),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const M=p.from(j,N);if(M===void 0)throw new Error("Task is not valid");if(d.is(M.execution))await this.y(M,j,!1);else throw new n.$_;const O=await this.z(await this.a.$getTaskExecution(M),j);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),O}v(N,j,M,O){const U=[];if(O)for(const Y of O){if(this.A(Y,M),!Y.definition||!N[Y.definition.type]){const Z=Y.source?Y.source:"No task source";this.f.warn(`The task [${Z}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=p.from(Y,M.extension);le&&d.is(le.execution)?(U.push(le),j.push(this.y(le,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(N){if(d.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,M){}};e.$5hc=F,e.$5hc=F=Ge([Ve(0,m.$bN),Ve(1,v.$rN),Ve(2,b.$zgc),Ve(3,$.$mN),Ve(4,y.$Cgc),Ve(5,C.$1gc),Ve(6,o.$nj),Ve(7,i.$hgc)],F),e.$6hc=(0,S.$6h)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=void 0;function g(R){return"cellResults"in R}e.$VJ=g,e.$WJ="rawCell#";function I(R,b){let $=-1;const y=[];let L=[];return R.forEach(m=>{m.range.startLineNumber!==$&&L.length>0&&(y.push([...L]),L=[]),L.push(m),$=m.range.endLineNumber}),L.length>0&&y.push([...L]),y.map(m=>{const v=[],S=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let f=S;f<=l;f++)v.push(b.getLineContent(f));return new D.$zJ(v.join(`
`)+`
`,m.map(f=>new T.$Us(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$XJ=I}),define(ke[360],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,330,149,24,16,285,359,356]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,d,k,A,p,w){this.q=k,this.r=A,this.s=p,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new g.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$agc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(m.$0K.MainThreadNotebook),this.c=a.getProxy(m.$0K.MainThreadNotebookDocuments),this.d=a.getProxy(m.$0K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const P=E.notebookEditor?.notebookUri,F=E.cell.handle,N=this.g.get(P)?.getCell(F);if(N)return N.apiCell}if(E&&E.$mid===14){const P=E.uri,F=this.g.get(P);if(F)return F.apiNotebook}return E}}),s.B(d)}getEditorById(a){const d=this.h.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(a){for(const[d,k]of this.h)if(k.apiEditor===a)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,d){const k=this.g.get(a);if(!k&&!d)throw new Error(`NO notebook document for '${a}'`);return k}static u(a,d){if(!d)return;const k=d.filenamePattern.map(A=>S.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(d.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:k,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,k){const A=s.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,p,d);let w;return p!==void 0&&(w=k.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(p))),new l.$_K(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,p),w?.dispose()})}async createNotebookDocument(a){const d=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&S.NotebookData.from(a.content)});return y.URI.revive(d)}async openNotebookDocument(a){const d=this.g.get(a);if(d)return d.apiNotebook;const k=await this.c.$tryOpenNotebook(a),A=this.g.get(y.URI.revive(k));return(0,$.$Tf)(A?.apiNotebook)}async showNotebookDocument(a,d){y.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let k;typeof d=="object"?k={position:S.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(S.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,k),p=A&&this.h.get(A)?.apiEditor;if(p)return p;throw A?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,k,A){const p=this.f.get(a),w=y.URI.revive(d),E=this.g.get(w);if(!E||!p)return;const P=E.getCellFromIndex(k);if(!P)return;const F=await p.provideCellStatusBarItems(P.apiCell,A);if(!F)return;const z=new I.$Sc,N=this.p.add([z]),M=(Array.isArray(F)?F:[F]).map(O=>S.NotebookStatusBarItem.from(O,this.i,z));return{cacheId:N,items:M}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,d,k,A,p){if((0,b.$Je)(d))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:d,serializer:k,options:A}),this.b.$registerNotebookSerializer(w,{id:a.identifier,location:a.extensionLocation},d,S.NotebookDocumentContentOptions.from(A),s.u(a,p)),(0,I.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(a,d,k){const A=this.x.get(a);if(!A)throw new Error("NO serializer found");const p=await A.serializer.deserializeNotebook(d.buffer,k);return new f.$Tv(S.NotebookData.from(p))}async $notebookToData(a,d,k){const A=this.x.get(a);if(!A)throw new Error("NO serializer found");const p=await A.serializer.serializeNotebook(S.NotebookData.to(d.value),k);return T.$je.wrap(p)}async $saveNotebook(a,d,k,A,p){const w=y.URI.revive(d),E=this.x.get(a);if(!E)throw new Error("NO serializer found");const P=this.g.get(w);if(!P)throw new Error("Document NOT found");if(P.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new L.$Lk((0,D.localize)(0,null,this.z(w)),6);await this.y(w,A);const F={metadata:(0,r.$Dn)(P.apiNotebook.metadata,O=>!(E.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of P.apiNotebook.getCells()){const U=new l.$yM(O.kind,O.document.getText(),O.document.languageId,O.mime,E.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);U.metadata=(0,r.$Dn)(O.metadata,Y=>!(E.options?.transientCellMetadata??{})[Y]),F.cells.push(U)}const z=await E.serializer.serializeNotebook(F,p);await this.s.value.writeFile(w,z);const N=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w);return{name:N.basename(w),isFile:(j.type&L.FileType.File)!==0,isDirectory:(j.type&L.FileType.Directory)!==0,isSymbolicLink:(j.type&L.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&L.FilePermission.Locked),etag:L.$Wk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(a,d,k,A,p){const w=this.x.get(a)?.serializer;if(!w)return{limitHit:!1,results:[]};const E=new R.$Bc;await(async(j,M,O)=>{await Promise.all(j.map(async U=>await Promise.all(U.filenamePatterns.map(Y=>{const le={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(le,M,Z=>{Z.forEach(J=>{E.has(J)||A.some(ue=>U.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(x=>(0,u.$jdb)(x,J)))||E.add(J)})})}))))})(k,p,d);const F=new R.$Ac;let z=!1;const N=Array.from(E).map(async j=>{const M=[];try{if(p.isCancellationRequested)return;if(d.maxResults&&[...F.values()].reduce((le,Z)=>le+Z.cellResults.length,0)>d.maxResults){z=!0;return}const O=[],U=this.g.get(j);if(U)U.apiNotebook.getCells().forEach(Z=>O.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(X=>X.data.toString()))}));else{const le=await this.s.value.readFile(j),Z=T.$je.fromString(le.toString()),J=await w.deserializeNotebook(Z.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(ue=>O.push({input:ue.source,outputs:ue.outputs.flatMap(x=>x.items.map(be=>be.valueBytes.toString()))}))}if(p.isCancellationRequested)return;O.forEach((le,Z)=>{const J=d.contentPattern.pattern,X=new c.$TQb(le.input,void 0,le.outputs),ue=X.findInInputs(J),x=X.findInOutputs(J),be=x.flatMap(ce=>(0,t.$XJ)(ce.matches,ce.textBuffer)).map((ce,K)=>(ce.webviewIndex=K,ce));if(ue.length>0||x.length>0){const ce={index:Z,contentResults:(0,t.$XJ)(ue,X.inputTextBuffer),webviewResults:be};M.push(ce)}});const Y={resource:j,cellResults:M};F.set(j,Y);return}catch{return}});return await Promise.all(N),{limitHit:z,results:[...F.values()]}}async y(a,d){const k=await this.s.value.stat(a);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==L.$Vk&&typeof k.mtime=="number"&&typeof k.size=="number"&&d.mtime<k.mtime&&d.etag!==L.$Wk({mtime:d.mtime,size:k.size}))throw new L.$Lk((0,D.localize)(1,null),3,d)}z(a){return a.scheme===n.Schemas.file?a.fsPath:a.toString()}A(a,d,k){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const A=new i.$whc(d,this.d,a,k.visibleRanges.map(S.NotebookRange.to),k.selections.map(S.NotebookRange.to),typeof k.viewColumn=="number"?S.ViewColumn.to(k.viewColumn):void 0);this.h.set(d,A)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const k of a.value.removedDocuments){const A=y.URI.revive(k),p=this.g.get(A);p&&(p.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(p.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===A.toString()&&this.h.delete(w.id)}if(a.value.addedDocuments){const k=[];for(const A of a.value.addedDocuments){const p=y.URI.revive(A.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const w=new o.$vhc(this.c,this.q,this.r,p,A);k.push(...A.cells.map(E=>o.$uhc.asModelAddData(w.apiNotebook,E))),this.g.get(p)?.dispose(),this.g.set(p,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(a.value.addedEditors)for(const k of a.value.addedEditors){if(this.h.has(k.id))return;const A=y.URI.revive(k.documentUri),p=this.g.get(A);p&&this.A(p,k.id,k)}const d=[];if(a.value.removedEditors)for(const k of a.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),d.push(A))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const p=k.has(A.id);A._acceptVisibility(p)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const d=v.$zN.String.with("notebookType","A notebook type"),k=new v.$BN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new v.$zN("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>T.$je.wrap(p))],new v.$AN("Notebook Data",p=>S.NotebookData.to(p.value))),A=new v.$BN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new v.$zN("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$Tv(S.NotebookData.from(p)))],new v.$AN("Bytes",p=>p.buffer));a.registerApiCommand(k),a.registerApiCommand(A)}}e.$Fhc=s}),define(ke[361],Se([1,0,17,21,44,34,23,38,36]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class y{constructor(m,v,S){this.k=m,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Mj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Mj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((S,l)=>{const f=o=>{this.f++,m(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(f,{base:o,basename:r})}),Promise.all(v.map(o=>this.p(o,f))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{l(new Error((0,g.$Qi)(o)))})})}async p(m,v){const S=new T.$6d,l=this.q(m),f=this.r(),o=new $.$NJ(this.k,m),i=!o.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=b.$Rd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,S.token),c=r.elapsed(),t=b.$Rd.create();return this.g&&!this.e||(n&&n.forEach(u=>{const s=D.$gc.relative(m.folder.path,u.path);if(i){const h=D.$nc(u.path);this.v(v,{base:m.folder,relativePath:s,basename:h});return}this.s(f,m.folder,s,v)}),this.g&&!this.e)?null:(this.u(f,o,v),{providerTime:c,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const v=(0,$.$MJ)(this.k.includePattern,m.includePattern),S=(0,$.$MJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,S,l){if(S===this.a){const o=D.$nc(this.a);this.v(l,{base:v,relativePath:this.a,basename:o})}function f(o){const i=D.$nc(o),r=D.$mc(o);let n=m[r];n||(n=m[r]=[],f(r)),n.push({base:v,relativePath:o,basename:i})}f(S)}u({rootEntries:m,pathToEntries:v},S,l){const f=this,o=this.a;function i(r){const n=(0,$.$PJ)(()=>r.map(c=>c.basename));for(let c=0,t=r.length;c<t;c++){const u=r[c],{relativePath:s,basename:h}=u;if(S.matchesExcludesSync(s,h,o!==h?n:void 0))continue;const a=v[s];if(a)i(a);else{if(s===o)continue;f.v(l,u)}if(f.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,S,l){const f=this.c(m.cacheKey),o=new y(m,v,f&&f.token);let i=0;const r=n=>{i+=n.length,S(n.map(c=>this.d(c)))};return this.e(o,L.a,r,l).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new T.$6d),this.b.get(m)}d(m){return m.relativePath?{resource:R.$Hg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,S,l){const f=l.onCancellationRequested(()=>{m.cancel()}),o=r=>{r&&(i.push(r),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return m.search(o).then(r=>(i.length&&S(i),f.dispose(),r),r=>(i.length&&S(i),f.dispose(),Promise.reject(r)))}}e.$xhc=L}),define(ke[362],Se([1,0,19,73,34,103,28,16,17,23,12,18,2,100,235,51,13,40,142,357,36]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=void 0;let c=class{constructor(w,E,P,F,z){this.a=w,this.b=E,this.c=P,this.d=F,this.e=z}text(w,E,P={}){w=this.f(w,P);const F=this.a.getValue(),z=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(o.$oi),P),type:2,contentPattern:w,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:F.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(w,E){const P=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const F={...w,wordSeparators:P.editor.wordSeparators};return this.j(w,E)&&(F.isCaseSensitive=!0),this.k(w)&&(F.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),F}file(w,E={}){return{...this.h(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(w,E){return w?(w=Array.isArray(w)?w.map(a):a(w),E?this.parseSearchPaths(w):{pattern:u(...Array.isArray(w)?w:[w])}):{}}h(w=[],E={}){const P=this.g(E.includePattern,E.expandPatterns),F=this.g(E.excludePattern,E.expandPatterns),z=w.length>1,N=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,E,F)):w.map(O=>this.r(O,E,F,z))).filter(O=>!!O),j={_reason:E._reason,folderQueries:N,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:F.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=D.$Hb(D.$Rb(this.c.groups.map(le=>le.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(le=>(0,n.$DJ)(j,le.fsPath)),Y=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...j,...Y}}const M=E.extraFileResources&&E.extraFileResources.filter(O=>(0,n.$DJ)(j,O.fsPath));return j.extraFileResources=M&&M.length?M:void 0,j}i(w){const E=[],P=new R.$Ac,F={};let z=!1;return w.forEach(N=>{if(N.scheme===b.Schemas.walkThrough)return;if((0,y.$Lg)(N)){const M=this.b.getWorkspaceFolder(N)?.uri??N.with({path:$.$mc(N.fsPath)});let O=P.get(M);O||(z=!0,O={folder:M,includePattern:{}},E.push(O),P.set(M,O));const U=$.$lc(M.fsPath,N.fsPath);(0,C.$Tf)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else N.fsPath&&(z=!0,F[N.fsPath]=!0)}),{folderQueries:E,includePattern:F,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(w,E){if(E.isSmartCase){if(w.isRegExp){if(L.$zf(w.pattern,!0))return!0}else if(L.$zf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$4B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),F=(Array.isArray(w)?w:s(w)).map(Y=>{const le=this.e.resolvedUserHome;return le?(0,I.$Yv)(Y,le.scheme===b.Schemas.file?le.fsPath:le.path):Y}),z=T.$K(F,Y=>E(Y)?"searchPaths":"exprSegments"),N=(z.exprSegments||[]).map(Y=>L.$Ue(Y,"/")).map(Y=>L.$Ue(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),h(Y))),j={},M=this.m(z.searchPaths||[]);M&&M.length&&(j.searchPaths=M);const O=D.$Rb(N),U=u(...O);return U&&(j.pattern=U),j}l(w,E){return E.disregardExcludeSettings?void 0:(0,n.$CJ)(w,!E.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const E=w.flatMap(F=>{let{pathPortion:z,globPortion:N}=t(F);return N&&(N=d(N)),this.n(z).flatMap(M=>this.o(M,N))}),P=new Map;return E.forEach(F=>{const z=F.searchPath.toString(),N=P.get(z);N?F.pattern&&(N.pattern=N.pattern||{},N.pattern[F.pattern]=!0):P.set(z,{searchPath:F.searchPath,pattern:F.pattern?u(F.pattern):void 0})}),Array.from(P.values())}n(w){if($.$ic(w)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:m.URI.file($.$hc(w))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(w=a(w),w.startsWith("../")||w===".."){const F=$.$gc.resolve(E.path,w);return[{searchPath:E.with({path:F})}]}const P=d(w);return[{searchPath:E,pattern:P}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(z=>{const N=E.match(new RegExp(`^${L.$Oe(z.name)}(?:/(.*)|$)`));return N?{match:N,folder:z}:null}).filter(C.$Qf);if(F.length)return F.map(z=>{const N=z.match[1];return{searchPath:z.folder.uri,pattern:N&&d(N)}});{const z=w.match(/\.[\/\\](.+)[\/\\]?/),N=z?z[1]:w,j=S.localize(0,null,N);throw new Error(j)}}}}o(w,E){const P=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,F=[{searchPath:w.searchPath,pattern:P}];return P&&!P.endsWith("**")&&F.push({searchPath:w.searchPath,pattern:P+"/**"}),F}q(w,E,P){const F=this.r((0,o.$oi)(w.searchPath),E,P,!1);return F?{...F,includePattern:w.pattern}:null}r(w,E,P,F){let z;const N=m.URI.isUri(w)?w:w.uri;if(P.searchPaths){const Y=P.searchPaths.filter(le=>(0,y.$Ag)(le.searchPath,N))[0];if(Y&&!Y.pattern)return null;Y&&(z=Y.pattern)}const j=this.a.getValue({resource:N}),O={...this.l(j,E)||{},...z||{}},U=m.URI.isUri(w)?(0,y.$Eg)(w):w.name;return{folder:N,folderName:F?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$NK=c,e.$NK=c=Ge([Ve(0,l.$zi),Ve(1,o.$ci),Ve(2,i.$9C),Ve(3,f.$nj),Ve(4,r.$LK)],c);function t(p){const w=p.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,P=p.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let F=p.substr(0,P.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:p.substr((P.index||0)+1)}}}return{pathPortion:p}}function u(...p){return p.length?p.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function s(p){return g.$Kj(p,",").map(w=>w.trim()).filter(w=>!!w.length)}function h(p){return[`**/${p}/**`,`**/${p}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function a(p){return p.replace(/\\/g,"/")}function d(p){return a(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(p){return p.replace(/([?*[\]])/g,"[$1]")}function A(p,w){p=D.$Mb(p,F=>F.toString());const E=[],P=w.getWorkspace();return p&&p.forEach(F=>{let z;if(w.getWorkbenchState()===2)z=(0,y.$Jg)(P.folders[0].uri,F),z&&z!=="."&&(z="./"+z);else{const N=w.getWorkspaceFolder(F);if(N){const j=N.name;if(P.folders.filter(O=>O.name===j).length===1){const O=(0,y.$Jg)(N.uri,F);O===""?z=`./${N.name}`:z=`./${N.name}/${O}`}else z=F.fsPath}}z&&E.push(k(z))}),E}e.$OK=A}),define(ke[363],Se([1,0,23,2,21,14,5,362,36,40]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsb=e.$vsb=void 0;const L=7e3;function C(l,f){const o=f.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const h of o)if(/^workspaceContains:/.test(h)){const a=h.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||l.forceUsingSearch?r.push(a):i.push(a)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const c=new Promise((h,a)=>{n=h}),t=h=>n({activationEvent:h}),u=Promise.all(i.map(h=>m(l,h,t))).then(()=>{}),s=v(l,f.identifier,r,t);return Promise.all([u,s]).then(()=>{n(void 0)}),c}e.$vsb=C;async function m(l,f,o){for(const i of l.folders)if(await l.exists(D.$Hg(T.URI.revive(i),f))){o(`workspaceContains:${f}`);return}}async function v(l,f,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new g.$6d,n=l.checkExists(l.folders,o,r.token),c=setTimeout(async()=>{r.cancel(),l.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await n}catch(u){I.$4(u)||I.$1(u)}r.dispose(),clearTimeout(c),t&&i(`workspaceContains:${o.join(",")}`)}function S(l,f,o,i){const r=l.get(R.$5h),n=l.get($.$uJ),t=r.createInstance(b.$NK).file(f.map(u=>(0,y.$oi)(T.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(u=>!!u.limitHit,u=>I.$4(u)?!1:Promise.reject(u))}e.$wsb=S}),define(ke[47],Se([1,0,212,17,57,23,11,3,77,2,13,6,42,291,117,41,25,144,14,26,22,271,7,64,5,27,94,20,107,70,46,4,363,116,273,16,114,38,10,115]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s,h,a,d,k,A,p,w,E,P,F,z,N,j,M,O){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=e.$_gc=void 0,e.$_gc=(0,s.$6h)("IHostUtils");let Y=U=class extends b.$Tc{constructor(K,V,re,ye,de,ge,_,te,G,ie,fe,ve){super(),this.X=ve,this.a=this.B(new w.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=re,this.f=_,this.j=ye,this.m=de,this.s=ge,this.t=G,this.u=ie,this.w=fe,this.y=this.g.getProxy(C.$0K.MainThreadWorkspace),this.z=this.g.getProxy(C.$0K.MainThreadTelemetry),this.C=this.g.getProxy(C.$0K.MainThreadExtensionService),this.D=new R.$5g,this.F=new R.$5g,this.G=new R.$5g,this.H=new R.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new o.$q8b(this.I,this.f.extensions.allExtensions);const Pe=new r.$mm(this.f.extensions.myExtensions);this.J=new o.$q8b(this.I,ue(this.L,Pe)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new S.$Wgc(this.g,this.s),this.N=new P.$5gc(this.g),this.O=te,this.h=K.createChild(new k.$4h([S.$Xgc,this.M],[P.$6gc,this.N])),this.P=this.B(new v.$Vgc(this.J,this.L,{onExtensionActivationError:(we,De,B)=>{this.C.$onExtensionActivationError(we,i.$3(De),B)},actualActivateExtension:async(we,De)=>{if(o.$q8b.isHostExtension(we,this.J,this.L))return await this.C.$activateExtension(we,De),new v.$Ugc;const B=this.J.getExtensionDescription(we);return this.db(B,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,R.$7g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const V=await this.C.$getExtension(K);return V&&{...V,identifier:new r.$lm(V.identifier.value),extensionLocation:y.URI.revive(V.extensionLocation)}}Z(K,V){return this.P.activateByEvent(K,V)}$(K,V){return this.P.activateById(K,V)}activateByIdWithErrors(K,V){return this.$(K,V).then(()=>{const re=this.P.getActivatedExtension(K);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===z.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(K.fsPath);return y.URI.file(V)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new x(K))),this.Q}async bb(K){const V=$.$_h.forUris(re=>I.$yg.ignorePathCasing(re));return await Promise.all(K.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);V.set(ye,re)}})),V}cb(K){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return V;const re=this.P.getActivatedExtension(K);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,b.$Oc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return V}async db(K,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,V).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,V),this.eb(K,V,"success",ye),re},re=>{throw this.eb(K,V,"failure"),re})}eb(K,V,re,ye){const de=Z(K,V);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:re})}fb(K,V){const re=Z(K,V);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(K);if(!ye)return Promise.resolve(new v.$Tgc(v.$Qgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${K.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const de=new v.$Rgc(V.startup);return Promise.all([this.vb(K,(0,I.$Hg)(K.extensionLocation,ye),de),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),U.hb(this.s,K.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const V=new c.$Zgc(K,this.M),re=new c.$Ygc(K.identifier.value,!1,this.M),ye=new F.$7gc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([V.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const _=this;let te,G;const ie=(0,f.$BF)(K,"ipc")?this.f.messagePorts?.get(r.$lm.toKey(K.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return T.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return _.O.globalValue(K).fsPath},get logPath(){return T.$jc(_.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,K.identifier.value)},get storageUri(){return _.O.workspaceValue(K)},get globalStorageUri(){return _.O.globalValue(K)},get extensionMode(){return de},get extension(){return te===void 0&&(te=new X(_,K.identifier,K,ge,!1)),te},get extensionRuntime(){return(0,f.$CF)(K,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!ie)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ie,"message",ve=>ve.data));ie.start(),G={onDidReceiveMessage:fe,postMessage:ie.postMessage.bind(ie)}}return G}})})}static hb(K,V,re,ye,de){return re=re||{activate:void 0,deactivate:void 0},this.ib(K,V,re,ye,de).then(ge=>new v.$Sgc(!1,null,de.build(),re,ge,ye.subscriptions))}static ib(K,V,re,ye,de){if(typeof re.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${V.value}`);const ge=typeof global=="object"?global:self,_=re.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(te=>(de.activateResolveStop(),te))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(re)}jb(K,V){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:V}).then(void 0,re=>{this.s.error(re)})}kb(K,V=0){const ye=Date.now();(0,M.$B)(()=>{for(let de=V;de<K.length;de+=1){const ge=K[de];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const V=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(V)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const V=this.j.workspace?this.j.workspace.folders:[],re=this.nb(V),ye=this.pb(),de=Promise.all([ye,K,re]).then(()=>{});return Promise.race([de,(0,R.$7g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(K,V))).then(()=>{})}async ob(K,V){if(this.isActivated(V.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:re||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,te)=>this.y.$checkExists(ge,_,te)},de=await(0,E.$vsb)(ye,V);if(de)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:V}=this.f.environment;if(!K||!V)throw new Error(D.localize(0,null));const re=await this.vb(null,V,new v.$Rgc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,V.toString()));return new Promise((ye,de)=>{const ge=(G,ie)=>{G?(M.$t&&this.s.error("Test runner called back with error",G),de(G)):(M.$t&&(ie?this.s.info(`Test runner called back with ${ie} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof ie=="number"&&ie>0?1:0))},_=(0,I.$vg)(V),te=re.run(_,ge);te&&te.then&&te.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{M.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,V){return this.R[K]=V,(0,b.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:V}=await this.sb(K);return V?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const V=K.indexOf("+");if(V===-1)throw new t.$fL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=K.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(K,V){const re=j.$Rd.create(!1),ye=()=>`[resolveAuthority(${(0,u.$_k)(K)},${V})][${re.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,q=void 0)=>this.s.error(`${ye()}${ee}`,q),te=ee=>{if(ee instanceof t.$fL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:q,authorityPrefix:oe}=await this.sb(ee);if(!q)throw _(`no resolver for ${oe}`),new t.$fL(`No remote extension installed to resolve ${oe}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:oe,remoteAuthority:ee}},ie=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${ie.join(" -> ")}`);let fe;try{fe=await Promise.all(ie.map(G)).catch(async ee=>{if(!(ee instanceof t.$fL)||ee._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return te(ee)}const ve=new R.$eh;ve.cancelAndSet(()=>de("waiting..."),1e3);let Pe,we;for(const[ee,{authorityPrefix:q,resolver:oe,remoteAuthority:he}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${q}`),Pe=await oe.resolve(he,{resolveAttempt:V,execServer:we}),g.mark(`code/extHost/didResolveAuthorityOK/${q}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$eL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(de(`invoking resolveExecServer() for ${he}`),g.mark(`code/extHost/willResolveExecServer/${q}`),we=await oe.resolveExecServer?.(he,{resolveAttempt:V,execServer:we}),!we)throw new t.$fL(`Exec server was not available for ${he}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${q}`),_("returned an error",Le),ve.dispose(),te(Le)}ve.dispose();const De={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$eL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$eL.isManagedResolvedAuthority(Pe)){const ee=V;this.X.setFactory(ee,Pe.makeConnection),Q={authority:K,connectTo:new u.$9k(ee),connectionToken:Pe.connectionToken}}else Q={authority:K,connectTo:new u.$0k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:B,tunnelInformation:De}}}async $getCanonicalURI(K,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$_k)(K)})`);const{resolver:re}=await this.sb(K);if(!re)return null;const ye=y.URI.revive(V);if(typeof re.getCanonicalURI>"u")return ye;const de=await(0,R.$Yg)(()=>re.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:V,myExtensions:re}=le(this.I,this.L,this.J,K);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(K,V){return V===1?this.D.wait().then(re=>this.Z(K,!1)):this.G.wait().then(re=>this.Z(K,!1))}async $activate(K,V){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,V),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:V,myExtensions:re}=le(this.I,this.L,this.J,K),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const V=n.$je.alloc(K),re=Math.random()%256;for(let ye=0;ye<K;ye++)V.writeUInt8(re,ye);return V}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$ahc=Y,e.$ahc=Y=U=Ge([Ve(0,s.$5h),Ve(1,e.$_gc),Ve(2,d.$bN),Ve(3,l.$zgc),Ve(4,m.$Cgc),Ve(5,L.$nj),Ve(6,h.$rN),Ve(7,a.$Fgc),Ve(8,A.$vyb),Ve(9,p.$1gc),Ve(10,N.$9gc),Ve(11,O.$0gc)],Y);function le(ce,K,V,re){ce.addActivationEvents(re.addActivationEvents);const ye=new o.$q8b(ce,K.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const de=new r.$mm(V.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of re.myToRemove)de.delete(_);for(const _ of re.myToAdd)de.add(_);const ge=ue(ye,de);return{globalRegistry:ye,myExtensions:ge}}function Z(ce,K){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function J(ce){return ce.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$bhc=(0,s.$6h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(K,V,re,ye,de){this.#e=K,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.$hc((0,I.$vg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$chc=X;function ue(ce,K){return ce.getAllExtensionDescriptions().filter(V=>K.has(V.identifier))}class x{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$dhc=x;class be{constructor(K){this.a=new r.$nm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const V of Object.keys(K))this.a.set(V,K[V])}}}),define(ke[364],Se([1,0,57,2,6,42,25,26,20,27,5,47,13,12]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;let l=class{constructor(n,c,t,u,s,h,a){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.h=h,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,n,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const c of n.nodeModuleName)this.a.set(c,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(c=>n.alternativeModuleName(c))}};e.$lic=l,e.$lic=l=Ge([Ve(2,L.$5h),Ve(3,I.$Cgc),Ve(4,C.$bhc),Ve(5,y.$rN),Ve(6,m.$nj)],l);let f=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const c=(0,v.$Oe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${s}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const c=this.b.exec(this.c(n));if(!c)return;const[,t,u,s]=c,h=S.a.get(u);if(h!==void 0)return console.warn(`${u} as been renamed to ${h}, please update your imports`),t+h+s}c(n){return n.replace(/\\/g,"/")}};f=S=Ge([Ve(0,y.$rN)],f);class o{constructor(n,c,t,u,s){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.nodeModuleName="vscode",this.a=new b.$nm}load(n,c){const t=this.d.findSubstr(c);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((s,h)=>u+=`	${h} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${u}`),this.b=this.c(R.$wF,this.e,this.f)}return this.b}}let i=class{constructor(n,c,t){this.e=n,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$0K.MainThreadTelemetry);const u=t.getProxy(g.$0K.MainThreadWindow);this.c=(s,h)=>{const a=T.URI.parse(s);return h?this.g(s,h):a.scheme==="http"||a.scheme==="https"?u.$openUri(a,s,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?u.$openUri(a,s,{}):this.g(s,h)}}load(n,c,t){const u=this.e.findSubstr(c);return u&&(this.a=u.identifier.value,this.h()),this.b=t(n),this.c}g(n,c){return this.i(),this.b(n,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([Ve(2,$.$bN)],i)}),define(ke[59],Se([1,0,43,3,17,49,5,72,71,47,7,41,288,42]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0,e.$ehc=(0,R.$6h)("IExtHostVariableResolverProvider");class S extends m.$cO{constructor(o,i,r,n,c,t,u){function s(){if(r){const h=r.activeEditor();if(h)return h.document.uri;const a=n.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof L.$SM||a.input instanceof L.$XM)return a.input.modified;if(a.input instanceof L.$RM||a.input instanceof L.$WM||a.input instanceof L.$UM)return a.input.uri}}}super({getFolderUri:h=>{const a=t.folders.filter(d=>d.name===h);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,a)=>c.getConfiguration(void 0,h).get(a),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=s();if(h)return g.$hc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const h=s();if(h){const a=i.getWorkspaceFolder(h);if(a)return g.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(r){const h=r.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(r){const h=r.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>o.getExtension(h)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(I.env))}}let l=class extends T.$Tc{constructor(o,i,r,n,c){super(),this.b=o,this.c=i,this.g=r,this.h=n,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$fhc=l,e.$fhc=l=Ge([Ve(0,y.$bhc),Ve(1,C.$zgc),Ve(2,b.$mN),Ve(3,v.$Cgc),Ve(4,$.$Ogc)],l)}),define(ke[97],Se([1,0,11,4,2,5,6,71,47,20,7,41,140,281,42,59]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0,e.$ghc=(0,I.$6h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,s,h,a,d,k){this.E=s,this.F=h,this.G=a,this.H=d,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Vd,this.n=new T.$Vd,this.o=new T.$Vd,this.u=new T.$Vd,this.k=u.getProxy(R.$0K.MainThreadDebugService),this.y=new T.$Vd,this.A=new T.$Vd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(A=>{A.onDidChange(p=>{this.J(A)}),this.J(A)})}asDebugSourceUri(u,s){const h=u;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let a=`debug:${encodeURIComponent(h.path||"")}`,d="?";return s&&(a+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),a+=`${d}ref=${h.sourceReference}`,g.URI.parse(a)}else{if(h.path)return g.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const s=[];for(const h of u.getAllExtensionDescriptions())if(h.contributes){const a=h.contributes.debuggers;if(a&&a.length>0)for(const d of a)(0,v.$bG)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(s=>u.push(s)),u}addBreakpoints(u){const s=u.filter(d=>{const k=d.id;return this.w.has(k)?!1:(this.w.set(k,d),!0)});this.U(s,[],[]);const h=[],a=new Map;for(const d of s)if(d instanceof L.$_L){let k=a.get(d.location.uri.toString());k||(k={type:"sourceMulti",uri:d.location.uri,lines:[]},a.set(d.location.uri.toString(),k),h.push(k)),k.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof L.$aM&&h.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(u){const s=u.filter(k=>this.w.delete(k.id));this.U([],s,[]);const h=s.filter(k=>k instanceof L.$_L).map(k=>k.id),a=s.filter(k=>k instanceof L.$aM).map(k=>k.id),d=s.filter(k=>k instanceof L.$bM).map(k=>k.id);return this.k.$unregisterBreakpoints(h,a,d)}startDebugging(u,s,h){return this.k.$startDebugging(u?u.uri:void 0,s,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,s,h){if(!s)return new L.$_K(()=>{});const a=this.d++;return this.f.push({type:u,handle:a,provider:s}),this.k.$registerDebugConfigurationProvider(u,h,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,a),new L.$_K(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(u,s,h){if(!h)return new L.$_K(()=>{});if(!this.Q(u,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:s,handle:a,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(s,a),new L.$_K(()=>{this.h=this.h.filter(d=>d.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(u,s){if(!s)return new L.$_K(()=>{});const h=this.i++;return this.j.push({type:u,handle:h,factory:s}),new L.$_K(()=>{this.j=this.j.filter(a=>a.factory!==s)})}async $runInTerminal(u,s){return Promise.resolve(void 0)}async $substituteVariables(u,s){let h;const a=await this.W(u);return a&&(h={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,s)}K(u,s){if(u.type==="implementation")return new n(u.implementation)}L(){}async $startDASession(u,s){const h=this,a=await this.V(s);return this.S(this.N(a.type),a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const k=this.M(d),A=this.K(k,a);if(!A)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const p=A;return this.B.set(u,p),this.R(a).then(w=>(w&&this.C.set(u,w),p.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const P=E,F={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(P.arguments.value);F.body={signature:z},p.sendResponse(F)}else throw new Error("no signer")}catch(z){F.success=!1,F.message=z.message,p.sendResponse(F)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(E),E=(0,v.$gG)(E,!0),h.k.$acceptDAMessage(u,E)}),p.onError(E=>{w&&w.onError&&w.onError(E),this.k.$acceptDAError(u,E.name,E.message,E.stack)}),p.onExit(E=>{w&&w.onExit&&w.onExit(E??void 0,void 0),this.k.$acceptDAExit(u,E??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),p.startSession()))})}$sendDAMessage(u,s){s=(0,v.$fG)(s,!1);const h=this.C.get(u);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(s),this.B.get(u)?.sendMessage(s)}$stopDASession(u){const s=this.C.get(u);this.C.delete(u),s&&s.onWillStopSession&&s.onWillStopSession();const h=this.B.get(u);return this.B.delete(u),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const s=[],h=[],a=[];if(u.added)for(const d of u.added){const k=d.id;if(k&&!this.w.has(k)){let A;if(d.type==="function")A=new L.$aM(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")A=new L.$bM(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const p=g.URI.revive(d.uri);A=new L.$_L(new L.$lL(p,new L.$aL(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,L.$0L)(A,k),this.w.set(k,A),s.push(A)}}if(u.removed)for(const d of u.removed){const k=this.w.get(d);k&&(this.w.delete(d),h.push(k))}if(u.changed){for(const d of u.changed)if(d.id){const k=this.w.get(d.id);if(k){if(k instanceof L.$aM&&d.type==="function"){const A=k;A.enabled=d.enabled,A.condition=d.condition,A.hitCondition=d.hitCondition,A.logMessage=d.logMessage,A.functionName=d.functionName}else if(k instanceof L.$_L&&d.type==="source"){const A=k;A.enabled=d.enabled,A.condition=d.condition,A.hitCondition=d.hitCondition,A.logMessage=d.logMessage,A.location=new L.$lL(g.URI.revive(d.uri),new L.$aL(d.line,d.character))}a.push(k)}}}this.U(s,h,a)}async $acceptStackFrameFocus(u){let s;const h=u.sessionId?await this.V(u.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?s=new L.$hM(h,u.threadId):s=new L.$gM(h,u.threadId,u.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(u,s,h){return(0,D.$Yg)(async()=>{const a=this.P(u);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(s);return a.provideDebugConfigurations(d,h)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(u,s,h,a){return(0,D.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(s);return d.resolveDebugConfiguration(k,h,a)})}$resolveDebugConfigurationWithSubstitutedVariables(u,s,h,a){return(0,D.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(s);return d.resolveDebugConfigurationWithSubstitutedVariables(k,h,a)})}async $provideDebugAdapter(u,s){const h=this.O(u);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(s);return this.S(h,a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const s=await this.V(u);this.m.fire(s)}async $acceptDebugSessionTerminated(u){const s=await this.V(u);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,s){(await this.V(u))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(u,s){const a={session:await this.V(u),event:s.event,body:s.body};this.u.fire(a)}M(u){if(u instanceof L.$cM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof L.$dM)return{type:"server",port:u.port,host:u.host};if(u instanceof L.$eM)return{type:"pipeServer",path:u.path};if(u instanceof L.$fM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const s=this.h.filter(h=>h.type===u);if(s.length>0)return s[0].factory}O(u){const s=this.h.filter(h=>h.handle===u);if(s.length>0)return s[0].factory}P(u){const s=this.f.filter(h=>h.handle===u);if(s.length>0)return s[0].provider}Q(u,s){if(u.contributes){const h=u.contributes.debuggers;if(h&&h.length>0){for(const a of h)if(a.label&&a.type&&a.type===s)return!0}}return!1}R(u){const h=u.configuration.type,a=this.j.filter(d=>d.type===h||d.type==="*").map(d=>(0,D.$Yg)(()=>d.factory.createDebugAdapterTracker(u)).then(k=>k,k=>null));return Promise.race([Promise.all(a).then(d=>{const k=d.filter(A=>!!A);if(k.length>0)return new r(k)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,s){const h=s.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new L.$dM(h));if(u){const d=await this.F.getExtensionRegistry();return(0,D.$Yg)(()=>u.createDebugAdapterDescriptor(s,this.T(s,d))).then(k=>{if(k)return k})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,a))}T(u,s){}U(u,s,h){(u.length>0||s.length>0||h.length>0)&&this.y.fire(Object.freeze({added:u,removed:s,changed:h}))}async V(u){if(u)if(typeof u=="string"){const s=this.l.get(u);if(s)return s}else{let s=this.l.get(u.id);if(!s){const h=await this.W(u.folderUri),a=u.parent?this.l.get(u.parent):void 0;s=new o(this.k,u.id,u.type,u.name,h,u.configuration,a),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(u){if(u){const s=g.URI.revive(u);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$hhc=f,e.$hhc=f=Ge([Ve(0,y.$bN),Ve(1,C.$zgc),Ve(2,$.$bhc),Ve(3,S.$Cgc),Ve(4,b.$Ogc),Ve(5,l.$ehc)],f);class o{constructor(u,s,h,a,d,k,A){this.d=u,this.f=s,this.g=h,this.h=a,this.i=d,this.j=k,this.k=A}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,s){return this.d.$customDebugAdapterRequest(this.f,u,s)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$ihc=o;class i{constructor(u){this.value=Object.freeze({append(s){u.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$jhc=i;class r{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(s=>s.onError?s.onError(u):void 0)}onExit(u,s){this.d.forEach(h=>h.onExit?h.onExit(u,s):void 0)}}class n extends m.$Nlb{constructor(u){super(),this.h=u,u.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(u,s,h,a,d,k){super(u,s,h,a,d,k)}};e.$khc=c,e.$khc=c=Ge([Ve(0,y.$bN),Ve(1,C.$zgc),Ve(2,$.$bhc),Ve(3,S.$Cgc),Ve(4,b.$Ogc),Ve(5,l.$ehc)],c)}),define(ke[365],Se([1,0,14,57,2,6,308,13,84,107,27,247,20,66,47,91]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;class f{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(b.$nj),t=r.get(m.$bN).getProxy(I.$0K.MainThreadErrors);D.setUnexpectedErrorHandler(u=>{n.error(u);const s=D.$3(u);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(b.$nj),c=r.get(m.$bN),t=r.get(S.$bhc),u=r.get(l.$vN),s=c.getProxy(I.$0K.MainThreadExtensionService),h=c.getProxy(I.$0K.MainThreadErrors),a=await t.getExtensionPathIndex(),d=new WeakMap;function k(w,E){if(d.has(w))return d.get(w).stack;let P="",F,z;for(const j of E)P+=`
	at ${j.toString()}`,z=j.getFileName(),!F&&z&&(F=a.findSubstr(g.URI.file(z)));const N=`${w.name||"Error"}: ${w.message||""}${P}`;return d.set(w,{extensionIdentifier:F?.identifier,stack:N}),N}const A=Symbol("prepareStackTrace wrapped");let p=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(w){if(w===k||!w||w[A]){p=w||k;return}p=function(E,P){return k(E,P),w.call(Error,E,P)},Object.assign(p,{[A]:!0})}}),D.setUnexpectedErrorHandler(w=>{n.error(w);const E=D.$3(w),P=d.get(w);if(!P?.extensionIdentifier){h.$onUnexpectedError(E);return}s.$onExtensionRuntimeError(P.extensionIdentifier,E);const F=u.onExtensionError(P.extensionIdentifier,w);n.trace("forwarded error to extension?",F,P)})}}e.$mic=f;class o{constructor(r,n,c,t,u){this.a=c,this.b=new R.$y8b(r,null,t),n=o.e(n,this.b);const s=new y.$4h(...(0,$.$Zr)());s.set(L.$rN,{_serviceBrand:void 0,...n,messagePorts:u}),s.set(m.$bN,new m.$cN(this.b)),s.set(v.$wgc,new v.$xgc(t)),s.set(S.$_gc,c);const h=new C.$Eq(s,!0);h.invokeFunction(f.installEarlyHandler),this.d=h.invokeFunction(a=>a.get(b.$nj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=h.invokeFunction(a=>a.get(S.$bhc)),this.c.initialize(),h.invokeFunction(f.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(I.$0K.MainThreadExtensionService);return g.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=g.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const c=r.environment.extensionDevelopmentLocationURI;return c&&(r.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=g.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=g.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$nic=o}),define(ke[366],Se([1,0,11,10,222,241,138,97,71,47,20,46,7,59,41,282,283,42]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;let i=class extends b.$hhc{constructor(u,s,h,a,d,k,A){super(u,s,h,a,k,A),this.Z=d,this.X=new c}K(u,s){switch(u.type){case"server":return new l.$sic(u);case"pipeServer":return new l.$tic(u);case"executable":return new l.$uic(u,s.type)}return super.K(u,s)}T(u,s){const h=l.$uic.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(h)return new m.$cM(h.command,h.args,h.options)}L(){return new R.$l_b}async $runInTerminal(u,s){if(u.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const h=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),k=u.title||g.localize(0,null),A=JSON.stringify({shell:a,shellArgs:d});let p=await this.X.checkout(A,k),w,E=!1;if(p)w=u.cwd;else{const N={shellPath:a,shellArgs:d,cwd:u.cwd,name:k,iconPath:new m.$7L("debug")};E=!0,p=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(p,A)}p.show(!0);const P=await p.processId;E?await new Promise(N=>setTimeout(N,1e3)):h.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):T.$i?p.sendText("cls"):p.sendText("clear"));const F=(0,f.$wic)(a,u.args,!!u.argsCanBeInterpretedByShell,w,u.env);p.sendText(F);const z=this.onDidTerminateDebugSession(N=>{N.id===s&&(this.X.free(p),z.dispose())});return P}else if(u.kind==="external")return n(u,await this.G.getConfigProvider());return super.$runInTerminal(u,s)}};e.$xic=i,e.$xic=i=Ge([Ve(0,L.$bN),Ve(1,S.$zgc),Ve(2,y.$bhc),Ve(3,o.$Cgc),Ve(4,C.$1gc),Ve(5,$.$Ogc),Ve(6,v.$ehc)],i);let r;function n(t,u){if(!r)if(T.$i)r=new I.$00b;else if(T.$j)r=new I.$$0b;else if(T.$k)r=new I.$_0b;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return r.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(u,s){const a=[...this.b.entries()].map(([d,k])=>(0,D.$Tg)(async A=>{if(d.name!==s||k.lastUsedAt!==-1&&await(0,f.$vic)(await d.processId))return null;const p=Date.now();return k.lastUsedAt+c.a>p||A.isCancellationRequested||k.config!==u?null:(k.lastUsedAt=p,d)}));return await(0,D.$$g)(a,d=>!!d)}insert(u,s){this.b.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this.b.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}}),define(ke[367],Se([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,59]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;let r=class extends m.$4hc{constructor(c,t,u,s,h,a,d,k,A){super(c,t,u,s,h,a,d,k),this.C=u,this.D=A,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=m.TaskHandleDTO.from(u,this.C),h=await this.a.$getTaskExecution(s);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(h,t);return this.a.$executeTask(s).catch(()=>{}),a}else{const s=m.TaskDTO.from(t,c);if(s===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const h=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),h}}v(c,t,u,s){const h=[];if(s)for(const a of s){this.A(a,u),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(a,u.extension);d&&(h.push(d),m.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,a,!0)))}return{tasks:h,extension:u.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const u=T.URI.file((0,o.homedir)());t=new $.$ni({uri:u,name:f.$Eg(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const u=T.URI.revive(c),s={process:void 0,variables:Object.create(null)},h=await this.b.resolveWorkspaceFolder(u),a=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),k=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const A of t.variables)s.variables[A]=await d.resolveAsync(k,A);if(t.process!==void 0){let A;if(t.process.path!==void 0){A=t.process.path.split(D.$tc);for(let p=0;p<A.length;p++)A[p]=await d.resolveAsync(k,A[p])}s.process=await g.win32.findExecutable(await d.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(k,t.process.cwd):void 0,A)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,u){return g.win32.findExecutable(c,t,u)}};e.$pic=r,e.$pic=r=Ge([Ve(0,L.$bN),Ve(1,C.$rN),Ve(2,I.$zgc),Ve(3,R.$mN),Ve(4,b.$Cgc),Ve(5,y.$1gc),Ve(6,S.$nj),Ve(7,l.$hgc),Ve(8,i.$ehc)],r)}),define(ke[368],Se([1,0,63,59]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class g extends T.$fhc{m(){return(0,D.homedir)()}}e.$8ic=g}),define(ke[154],Se([1,0,19,11,21,44,16,17,23,2,36]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class C{constructor(i,r,n,c){this.d=i,this.e=r,this.f=n,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],c=new g.$6d(r);return new Promise((t,u)=>{this.a=new v(i);let s=!1;const h=(a,d)=>{if(!s&&!this.b){const k=this.h(a);l(a)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,s=!0,c.cancel(),a=this.j(a,this.d.maxResults-this.c));const A=this.h(a);this.c+=A,(A>0||!l(a))&&this.a.add(a,d)}};Promise.all(n.map((a,d)=>this.k(a,k=>h(k,d),c.token))).then(a=>{c.dispose(),this.a.flush();const d=a.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||d,messages:(0,D.$Rb)(a.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},a=>{c.dispose();const d=(0,I.$Qi)(a);u(new Error(d))})})}h(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:c.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const c=new L.$NJ(this.d,i),t=[],u={report:a=>{if(!this.l(a))return;const d=i.folder.scheme===R.Schemas.file?(0,L.$OJ)(()=>this.f.readdir($.$Gg(a.uri))):void 0,k=$.$Jg(i.folder,a.uri);if(k){const A=c.includedInQuery(k,b.$nc(k),d);(0,T.$Sg)(A)?t.push(A.then(p=>{p&&r(a)})):A&&r(a)}}},s=this.n(i),h=await this.e.provideTextSearchResults(m(this.d.contentPattern),s,u,n);return t.length&&await Promise.all(t),h}l(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,L.$MJ)(this.d.includePattern,i.includePattern),n=(0,L.$MJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$yhc=C;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Ag(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$zhc=v;function S(o){return l(o)?{preview:{matches:(0,D.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function l(o){return!!o.preview}e.$Ahc=l;class f{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bhc=f}),define(ke[98],Se([1,0,3,6,5,361,20,66,13,2,154]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=e.$Chc=void 0,e.$Chc=(0,g.$6h)("IExtHostSearch");let C=class{constructor(l,f,o){this.k=l,this.l=f,this.n=o,this.c=this.k.getProxy(T.$0K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$xhc}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const o=this.d++;return this.e.set(o,f),this.c.$registerTextSearchProvider(o,this.o(l)),(0,D.$Rc)(()=>{this.g.delete(l),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(l,f){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const o=this.d++;return this.h.set(o,f),this.c.$registerFileSearchProvider(o,this.o(l)),(0,D.$Rc)(()=>{this.i.delete(l),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(l,f,o,i){const r=m(o),n=this.h.get(l);if(n)return this.j.fileSearch(r,n,c=>{this.c.$handleFileMatch(l,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,o){return{messages:[]}}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,o,i){const r=this.e.get(l);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const n=m(o);return this.q(n,r).search(t=>this.c.$handleTextMatch(l,f,t),i)}$enableExtensionHostSearch(){}q(l,f){return new L.$yhc(l,f,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Dhc=C,e.$Dhc=C=Ge([Ve(0,R.$bN),Ve(1,b.$wgc),Ve(2,$.$nj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(l=>y.URI.revive(l))}}e.$Ehc=m;function v(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[369],Se([1,0,21,14,4,3,16,39,2,132,191,172,79,26,32,13,65,88,266,6,310,340,92,311,316,317,318,319,320,297,286,35,321,42,322,97,147,323,299,312,324,325,72,71,313,47,326,69,327,58,27,341,342,314,300,328,329,114,115,301,360,331,272,332,343,333,152,302,334,335,336,20,337,98,116,338,303,339,117,94,96,91,46,344,345,315,346,347,70,15,7,304,66,305,93,348,349,146,41,280,113,25,95]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s,h,a,d,k,A,p,w,E,P,F,z,N,j,M,O,U,Y,le,Z,J,X,ue,x,be,ce,K,V,re,ye,de,ge,_,te,G,ie,fe,ve,Pe,we,De,B,Q,ee,q,oe,he,Le,je,He,Je,_e,ct,ot,rt,Ae,ze,Re,Xe,ne,ae,Ie,qe,Ye,nt,it,Oe,pt,St,Ft,Vt,Et,Kt,Ot,Yt,zt,Rt,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;function Jt(ht){const bt=ht.get(K.$rN),Ut=ht.get(ce.$egc),Wt=ht.get(x.$Egc),Dt=ht.get(X.$bhc),ft=ht.get(Yt.$zgc),At=ht.get(Re.$vN),xt=ht.get(P.$Cgc),Ct=ht.get(St.$wgc),Qe=ht.get(Le.$bN),Tt=ht.get(rt.$Xgc),qt=ht.get(Ae.$Fgc),Qt=ht.get(l.$oj),gt=ht.get(l.$nj),Nt=ht.get(nt.$vyb),Te=ht.get(t.$hgc),Fe=ht.get(Ot.$gic),Ce=ht.get(Je.$6gc),se=ht.get(Z.$Ogc),Ne=ht.get(G.$0gc);Qe.set(r.$$K.ExtHostFileSystemInfo,Ut),Qe.set(r.$$K.ExtHostLogLevelServiceShape,Qt),Qe.set(r.$$K.ExtHostWorkspace,ft),Qe.set(r.$$K.ExtHostConfiguration,xt),Qe.set(r.$$K.ExtHostExtensionService,Dt),Qe.set(r.$$K.ExtHostStorage,Tt),Qe.set(r.$$K.ExtHostTunnelService,Nt),Qe.set(r.$$K.ExtHostWindow,Fe),Qe.set(r.$$K.ExtHostSecretState,Ce),Qe.set(r.$$K.ExtHostTelemetry,At),Qe.set(r.$$K.ExtHostEditorTabs,se),Qe.set(r.$$K.ExtHostManagedSockets,Ne);const We=Qe.set(r.$$K.ExtHostDecorations,ht.get(N.$mhc)),xe=Qe.set(r.$$K.ExtHostDocumentsAndEditors,ht.get(le.$mN)),Ke=Qe.set(r.$$K.ExtHostCommands,ht.get(w.$xN)),st=Qe.set(r.$$K.ExtHostTerminalService,ht.get(Xe.$1gc)),$t=Qe.set(r.$$K.ExtHostDebugService,ht.get(z.$ghc)),Bt=Qe.set(r.$$K.ExtHostSearch,ht.get(He.$Chc)),kt=Qe.set(r.$$K.ExtHostTask,ht.get(ze.$6hc)),It=Qe.set(r.$$K.ExtHostOutputService,ht.get(Q.$Shc)),yt=Qe.set(r.$$K.ExtHostLocalization,ht.get(te.$9gc)),gi=Qe.set(r.$$K.ExtHostUrls,new Ft.$dic(Qe)),Lt=Qe.set(r.$$K.ExtHostDocuments,new Y.$cgc(Qe,xe)),Di=Qe.set(r.$$K.ExtHostDocumentContentProviders,new O.$ohc(Qe,xe,gt)),Gi=Qe.set(r.$$K.ExtHostDocumentSaveParticipant,new U.$phc(gt,Lt,Qe.getProxy(r.$0K.MainThreadBulkEdits))),Pt=Qe.set(r.$$K.ExtHostNotebook,new fe.$Fhc(Qe,Ke,xe,Lt,Wt,Bt)),ri=Qe.set(r.$$K.ExtHostNotebookDocuments,new Pe.$Mhc(Pt)),mi=Qe.set(r.$$K.ExtHostNotebookEditors,new we.$Nhc(gt,Pt)),ci=Qe.set(r.$$K.ExtHostNotebookKernels,new De.$Ohc(Qe,bt,Pt,Ke,gt)),Ci=Qe.set(r.$$K.ExtHostNotebookRenderers,new B.$Qhc(Qe,Pt)),Ii=Qe.set(r.$$K.ExtHostNotebookDocumentSaveParticipant,new ve.$Lhc(gt,Pt,Qe.getProxy(r.$0K.MainThreadBulkEdits))),jt=Qe.set(r.$$K.ExtHostEditors,new ae.$tgc(Qe,xe)),$i=Qe.set(r.$$K.ExtHostTreeViews,new Ye.$bic(Qe.getProxy(r.$0K.MainThreadTreeViews),Ke,gt)),Pi=Qe.set(r.$$K.ExtHostEditorInsets,new p.$ugc(Qe.getProxy(r.$0K.MainThreadEditorInsets),jt,bt.remote)),ui=Qe.set(r.$$K.ExtHostDiagnostics,new j.$ggc(Qe,gt,Ut,xe)),li=Qe.set(r.$$K.ExtHostLanguages,new _.$Jhc(Qe,Lt,Ke.converter,Ct)),dt=Qe.set(r.$$K.ExtHostLanguageFeatures,new ge.$kgc(Qe,Ct,Lt,Ke,ui,gt,Te,At)),Ji=Qe.set(r.$$K.ExtHostFileSystem,new ue.$rhc(Qe,dt)),_t=Qe.set(r.$$K.ExtHostFileSystemEventService,new be.$shc(Qe,gt,xe)),si=Qe.set(r.$$K.ExtHostQuickOpen,(0,he.$Whc)(Qe,ft,Ke)),bi=Qe.set(r.$$K.ExtHostSCM,new je.$Yhc(Qe,Ke,Lt,gt)),Ai=Qe.set(r.$$K.ExtHostQuickDiff,new oe.$Vhc(Qe,Ct)),Qi=Qe.set(r.$$K.ExtHostShare,new _e.$Zhc(Qe,Ct)),Ri=Qe.set(r.$$K.ExtHostComments,(0,E.$vgc)(Qe,Ke,Lt)),wi=Qe.set(r.$$K.ExtHostProgress,new q.$Uhc(Qe.getProxy(r.$0K.MainThreadProgress))),Yi=Qe.set(r.$$K.ExtHostLabelService,new de.$Ihc(Qe)),Li=Qe.set(r.$$K.ExtHostTheming,new Ie.$$hc(Qe)),hi=Qe.set(r.$$K.ExtHostAuthentication,new u.$mgc(Qe)),Xi=Qe.set(r.$$K.ExtHostTimeline,new qe.$aic(Qe,Ke)),pi=Qe.set(r.$$K.ExtHostWebviews,new Vt.$Jgc(Qe,bt.remote,ft,gt,Te)),Mi=Qe.set(r.$$K.ExtHostWebviewPanels,new Et.$Mgc(Qe,pi,ft)),un=Qe.set(r.$$K.ExtHostCustomEditors,new F.$Ngc(Qe,Lt,qt,pi,Mi)),Ti=Qe.set(r.$$K.ExtHostWebviewViews,new Kt.$eic(Qe,pi)),oi=Qe.set(r.$$K.ExtHostTesting,new ne.$7hc(Qe,gt,Ke,xe)),ln=Qe.set(r.$$K.ExtHostUriOpeners,new pt.$cic(Qe)),hn=Qe.set(r.$$K.ExtHostProfileContentHandlers,new ee.$Thc(Qe));Qe.set(r.$$K.ExtHostInteractive,new re.$Ghc(Qe,Pt,xe,Ke,gt));const Zi=Qe.set(r.$$K.ExtHostInlineChat,new V.$thc(Qe,Ke,Lt,gt)),di=Qe.set(r.$$K.ExtHostChatProvider,new d.$pgc(Qe,gt)),xi=Qe.set(r.$$K.ExtHostChatAgents2,new a.$qgc(Qe,di,gt)),_i=Qe.set(r.$$K.ExtHostChatVariables,new k.$rgc(Qe)),vi=Qe.set(r.$$K.ExtHostChat,new h.$ogc(Qe)),en=Qe.set(r.$$K.ExtHostAiRelatedInformation,new n.$bgc(Qe)),Ni=Qe.set(r.$$K.ExtHostAiEmbeddingVector,new J.$qhc(Qe)),Fi=Qe.set(r.$$K.ExtHostIssueReporter,new ye.$Hhc(Qe)),ei=Qe.set(r.$$K.ExtHostStatusBar,new ot.$3hc(Qe,Ke.converter)),yi=Qe.set(r.$$K.ExtHostSpeech,new ct.$1hc(Qe)),dn=Object.values(r.$$K);Qe.assertRegistered(dn);const Xt=new s.$ngc(Qe,xe),Ei=new A.$sgc(Qe),ki=new ie.$Khc(Qe,gt),Oi=new M.$nhc(Qe);return c.$lgc.register(Ke),function(Be,ti,tn){function at($e){return(Ee,Ue,ut)=>{const vt=$e(Mt=>{try{Ee.call(Ue,Mt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event`,{cause:cn})),At.onExtensionError(Be.identifier,cn)}});return ut?.push(vt),vt}}const wt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ut){if(Array.isArray(ut))ut.forEach(Ue);else if(typeof ut=="string")Ee();else{const vt=ut;typeof vt.scheme>"u"&&Ee(),typeof vt.exclusive=="boolean"&&(0,et.$CF)(Be,"documentFiltersExclusive")}return ut}}(),fn={getSession($e,Ee,Ue){return hi.getSession(Be,$e,Ee,Ue)},getSessions($e,Ee){return(0,et.$CF)(Be,"authGetSessions"),hi.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,et.$CF)(Be,"authSession"),!!await hi.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return at(hi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,Ue,ut){return hi.registerAuthenticationProvider($e,Ee,Ue,ut)}},gn={registerCommand($e,Ee,Ue){return Ke.registerCommand(!0,$e,Ee,Ue,void 0,Be)},registerTextEditorCommand($e,Ee,Ue){return Ke.registerCommand(!0,$e,(...ut)=>{const vt=jt.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return vt.edit(Mt=>{Ee.apply(Ue,[vt,Mt,...ut])}).then(Mt=>{Mt||gt.warn("Edits from command "+$e+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+$e,Mt)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,Ue)=>((0,et.$CF)(Be,"diffCommand"),Ke.registerCommand(!0,$e,async(...ut)=>{const vt=xe.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Mt=await jt.getDiffInformation(vt.id);Ee.apply(Ue,[Mt,...ut])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ke.executeCommand($e,...Ee)},getCommands($e=!1){return Ke.getCommands($e)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return at(st.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$CF)(Be,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$CF)(Be,"telemetry"),at(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Re.$uN)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Re.$tN.validateSender($e),At.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Fe.openUri($e,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===bt.environment.appUriScheme)return gi.createAppUri($e);try{return await Fe.asExternalUri($e,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,R.$eg)($e,R.Schemas.http)||(0,R.$eg)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$bl)(bt.remote.authority)},get remoteAuthority(){return(0,et.$CF)(Be,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return at(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$CF)(Be,"handleIssueUri"),Fi.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,et.$CF)(Be,"handleIssueUri"),Fi.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,et.$CF)(Be,"resolvers"),bt.quality},get appCommit(){return(0,et.$CF)(Be,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const zi={createTestController($e,Ee,Ue){return oi.createTestController(Be,$e,Ee,Ue)},createTestObserver(){return(0,et.$CF)(Be,"testObserver"),oi.createTestObserver()},runTests($e){return(0,et.$CF)(Be,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,et.$CF)(Be,"testObserver"),at(oi.onResultsChanged)},get testResults(){return(0,et.$CF)(Be,"testObserver"),oi.results}},fi=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension($e,Ee){(0,et.$BF)(Be,"extensionsAny")||(Ee=!1);const Ue=ti.mine.getExtensionDescription($e);if(Ue)return new X.$chc(Dt,Be.identifier,Ue,fi,!1);if(Ee){const ut=ti.all.getExtensionDescription($e);if(ut)return new X.$chc(Dt,Be.identifier,ut,fi,!0)}},get all(){const $e=[];for(const Ee of ti.mine.getAllExtensionDescriptions())$e.push(new X.$chc(Dt,Be.identifier,Ee,fi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$CF)(Be,"extensionsAny");const $e=new v.$mm(ti.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ti.all.getAllExtensionDescriptions()){const ut=!$e.has(Ue.identifier);Ee.push(new X.$chc(Dt,Be.identifier,Ue,fi,ut))}return Ee},get onDidChange(){return(0,et.$BF)(Be,"extensionsAny")?at(g.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):at(ti.mine.onDidChange)}},rn={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return at(ui.onDidChangeDiagnostics)},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const Ue=Lt.getDocumentData(Ee.uri)?.notebook;return(0,L.$Bt)(it.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,Ee,Ue){return dt.registerCodeActionProvider(Be,wt($e),Ee,Ue)},registerDocumentPasteEditProvider($e,Ee,Ue){return(0,et.$CF)(Be,"documentPaste"),dt.registerDocumentPasteEditProvider(Be,wt($e),Ee,Ue)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(Be,wt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(Be,wt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(Be,wt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(Be,wt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(Be,wt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(Be,wt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(Be,wt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(Be,wt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(Be,wt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(Be,wt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(Be,wt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(Be,wt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(Be,wt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Ue){return dt.registerDocumentSymbolProvider(Be,wt($e),Ee,Ue)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(Be,wt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(Be,wt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Ue,...ut){return dt.registerOnTypeFormattingEditProvider(Be,wt($e),Ee,[Ue].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,Ue){return dt.registerDocumentSemanticTokensProvider(Be,wt($e),Ee,Ue)},registerDocumentRangeSemanticTokensProvider($e,Ee,Ue){return dt.registerDocumentRangeSemanticTokensProvider(Be,wt($e),Ee,Ue)},registerSignatureHelpProvider($e,Ee,Ue,...ut){return typeof Ue=="object"?dt.registerSignatureHelpProvider(Be,wt($e),Ee,Ue):dt.registerSignatureHelpProvider(Be,wt($e),Ee,typeof Ue>"u"?[]:[Ue,...ut])},registerCompletionItemProvider($e,Ee,...Ue){return dt.registerCompletionItemProvider(Be,wt($e),Ee,Ue)},registerInlineCompletionItemProvider($e,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),Ue&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Be,wt($e),Ee,Ue)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(Be,wt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(Be,wt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(Be,wt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$CF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Ue){return dt.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,et.$BF)(Be,"dropMetadata")?Ue:void 0)}},mn={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument($e,Ee,Ue){const ut=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return jt.showTextDocument(ut,Ee,Ue)},createTextEditorDecorationType($e){return jt.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,Ue){return at(jt.onDidChangeActiveTextEditor)($e,Ee,Ue)},onDidChangeVisibleTextEditors($e,Ee,Ue){return at(jt.onDidChangeVisibleTextEditors)($e,Ee,Ue)},onDidChangeTextEditorSelection($e,Ee,Ue){return at(jt.onDidChangeTextEditorSelection)($e,Ee,Ue)},onDidChangeTextEditorOptions($e,Ee,Ue){return at(jt.onDidChangeTextEditorOptions)($e,Ee,Ue)},onDidChangeTextEditorVisibleRanges($e,Ee,Ue){return at(jt.onDidChangeTextEditorVisibleRanges)($e,Ee,Ue)},onDidChangeTextEditorViewColumn($e,Ee,Ue){return at(jt.onDidChangeTextEditorViewColumn)($e,Ee,Ue)},onDidCloseTerminal($e,Ee,Ue){return at(st.onDidCloseTerminal)($e,Ee,Ue)},onDidOpenTerminal($e,Ee,Ue){return at(st.onDidOpenTerminal)($e,Ee,Ue)},onDidChangeActiveTerminal($e,Ee,Ue){return at(st.onDidChangeActiveTerminal)($e,Ee,Ue)},onDidChangeTerminalDimensions($e,Ee,Ue){return(0,et.$CF)(Be,"terminalDimensions"),at(st.onDidChangeTerminalDimensions)($e,Ee,Ue)},onDidChangeTerminalState($e,Ee,Ue){return at(st.onDidChangeTerminalState)($e,Ee,Ue)},onDidWriteTerminalData($e,Ee,Ue){return(0,et.$CF)(Be,"terminalDataWriteEvent"),at(st.onDidWriteTerminalData)($e,Ee,Ue)},onDidExecuteTerminalCommand($e,Ee,Ue){return(0,et.$CF)(Be,"terminalExecuteCommandEvent"),at(st.onDidExecuteTerminalCommand)($e,Ee,Ue)},get state(){return Fe.getState(Be)},onDidChangeWindowState($e,Ee,Ue){return at(Fe.onDidChangeWindowState)($e,Ee,Ue)},showInformationMessage($e,...Ee){return ki.showMessage(Be,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return ki.showMessage(Be,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return ki.showMessage(Be,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Ue){return si.showQuickPick(Be,$e,Ee,Ue)},showWorkspaceFolderPick($e){return si.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return si.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(Be,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,Ue){let ut,vt,Mt;return typeof $e=="string"?(ut=$e,vt=Ee,Mt=Ue):(vt=$e,Mt=Ee),ei.createStatusBarEntry(Be,ut,vt,Mt)},setStatusBarMessage($e,Ee){return ei.setStatusBarMessage($e,Ee)},withScmProgress($e){return Te.report("window.withScmProgress",Be,"Use 'withProgress' instead."),wi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>$e({report(ut){}}))},withProgress($e,Ee){return wi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return It.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,Ue,ut){return Mi.createWebviewPanel(Be,$e,Ee,Ue,ut)},createWebviewTextEditorInset($e,Ee,Ue,ut){return(0,et.$CF)(Be,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,Ue,ut,Be)},createTerminal($e,Ee,Ue){return typeof $e=="object"?"pty"in $e?st.createExtensionTerminal($e):st.createTerminalFromOptions($e):st.createTerminal($e,Ee,Ue)},registerTerminalLinkProvider($e){return st.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return st.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$CF)(Be,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Mi.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,Ue={})=>un.registerCustomEditorProvider(Be,$e,Ee,Ue),registerFileDecorationProvider($e){return We.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return gi.registerUriHandler(Be,$e)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Ue){return at(Li.onDidChangeActiveColorTheme)($e,Ee,Ue)},registerWebviewViewProvider($e,Ee,Ue){return Ti.registerWebviewViewProvider(Be,$e,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Ue){return at(Pt.onDidChangeActiveNotebookEditor)($e,Ee,Ue)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,Ue){return at(mi.onDidChangeNotebookEditorSelection)($e,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Ue){return at(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,Ue)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Ue){return(0,et.$CF)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,$e,Ee,Ue)},registerProfileContentHandler($e,Ee){return(0,et.$CF)(Be,"profileContentHandlers"),hn.registerProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,Ue,ut){return(0,et.$CF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(wt($e),Ee,Ue,ut)},get tabGroups(){return se.tabGroups},registerShareProvider($e,Ee){return(0,et.$CF)(Be,"shareProvider"),Qi.registerShareProvider(wt($e),Ee)}},sn={get rootPath(){return Te.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new T.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new T.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new T.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Ue)=>ft.updateWorkspaceFolders(Be,$e,Ee||0,...Ue),onDidChangeWorkspaceFolders:function($e,Ee,Ue){return at(ft.onDidChangeWorkspace)($e,Ee,Ue)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,Ue,ut)=>ft.findFiles($e,Ee,Ue,Be.identifier,ut),findTextInFiles:($e,Ee,Ue,ut)=>{(0,et.$CF)(Be,"findTextInFiles");let vt,Mt;return typeof Ee=="object"?(vt=Ee,Mt=Ue):(vt={},Mt=Ee,ut=Ue),ft.findTextInFiles($e,vt||{},Mt,Be.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Xt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,Ue,ut)=>{let vt;return typeof Ee=="boolean"?vt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$CF)(Be,"createFileSystemWatcher"),vt={...Ee,correlate:!0}),_t.createFileSystemWatcher(ft,Be,$e,vt)},get textDocuments(){return Lt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new T.$9("textDocuments")},openTextDocument($e){let Ee;const Ue=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!Ue||typeof Ue=="object")Ee=Lt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Lt.ensureDocumentData(ut).then(vt=>vt.document))},onDidOpenTextDocument:($e,Ee,Ue)=>at(Lt.onDidAddDocument)($e,Ee,Ue),onDidCloseTextDocument:($e,Ee,Ue)=>at(Lt.onDidRemoveDocument)($e,Ee,Ue),onDidChangeTextDocument:($e,Ee,Ue)=>at(Lt.onDidChangeDocument)($e,Ee,Ue),onDidSaveTextDocument:($e,Ee,Ue)=>at(Lt.onDidSaveDocument)($e,Ee,Ue),onWillSaveTextDocument:($e,Ee,Ue)=>at(Gi.getOnWillSaveTextDocumentEvent(Be))($e,Ee,Ue),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Ue;if($.URI.isUri($e))Ue=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")Ue=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,Ee,Ue){return at(ri.onDidSaveNotebookDocument)($e,Ee,Ue)},onDidChangeNotebookDocument($e,Ee,Ue){return at(ri.onDidChangeNotebookDocument)($e,Ee,Ue)},onWillSaveNotebookDocument($e,Ee,Ue){return at(Ii.getOnWillSaveNotebookDocumentEvent(Be))($e,Ee,Ue)},get onDidOpenNotebookDocument(){return at(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,Ue,ut){return Pt.registerNotebookSerializer(Be,$e,Ee,Ue,(0,et.$BF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,Ue)=>at(tn.onDidChangeConfiguration)($e,Ee,Ue),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,tn.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Te.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,Ue){return(0,I.$Qc)(Ji.registerFileSystemProvider(Be,$e,Ee,Ue),Wt.addFileSystemProvider($e,Ee,Ue))},get fs(){return Wt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$CF)(Be,"fileSearchProvider"),Bt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$CF)(Be,"textSearchProvider"),Bt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$CF)(Be,"resolvers"),Dt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$CF)(Be,"resolvers"),Yi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$CF)(Be,"resolvers"),Dt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Ue)=>at(_t.onDidCreateFile)($e,Ee,Ue),onDidDeleteFiles:($e,Ee,Ue)=>at(_t.onDidDeleteFile)($e,Ee,Ue),onDidRenameFiles:($e,Ee,Ue)=>at(_t.onDidRenameFile)($e,Ee,Ue),onWillCreateFiles:($e,Ee,Ue)=>at(_t.getOnWillCreateFileEvent(Be))($e,Ee,Ue),onWillDeleteFiles:($e,Ee,Ue)=>at(_t.getOnWillDeleteFileEvent(Be))($e,Ee,Ue),onWillRenameFiles:($e,Ee,Ue)=>at(_t.getOnWillRenameFileEvent(Be))($e,Ee,Ue),openTunnel:$e=>((0,et.$CF)(Be,"tunnels"),Nt.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$CF)(Be,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:($e,Ee,Ue)=>((0,et.$CF)(Be,"tunnels"),at(Nt.onDidChangeTunnels)($e,Ee,Ue)),registerPortAttributesProvider:($e,Ee)=>((0,et.$CF)(Be,"portsAttributes"),Nt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$CF)(Be,"tunnelFactory"),Nt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$CF)(Be,"timeline"),Xi.registerTimelineProvider($e,Ee,Be.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,et.$CF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Ue)=>at(ft.onDidGrantWorkspaceTrust)($e,Ee,Ue),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$CF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Ue)=>((0,et.$CF)(Be,"editSessionIdentityProvider"),at(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Ee,Ue)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$CF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Ue)=>((0,et.$CF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,Ue))},on={get inputBox(){return Te.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Be)},createSourceControl($e,Ee,Ue){return bi.createSourceControl(Be,$e,Ee,Ue)}},an={createCommentController($e,Ee){return Ri.createCommentController(Be,$e,Ee)}},Ui={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession($e,Ee,Ue){return at($t.onDidStartDebugSession)($e,Ee,Ue)},onDidTerminateDebugSession($e,Ee,Ue){return at($t.onDidTerminateDebugSession)($e,Ee,Ue)},onDidChangeActiveDebugSession($e,Ee,Ue){return at($t.onDidChangeActiveDebugSession)($e,Ee,Ue)},onDidReceiveDebugSessionCustomEvent($e,Ee,Ue){return at($t.onDidReceiveDebugSessionCustomEvent)($e,Ee,Ue)},onDidChangeBreakpoints($e,Ee,Ue){return at($t.onDidChangeBreakpoints)($e,Ee,Ue)},onDidChangeStackFrameFocus($e,Ee,Ue){return(0,et.$CF)(Be,"debugFocus"),at($t.onDidChangeStackFrameFocus)($e,Ee,Ue)},registerDebugConfigurationProvider($e,Ee,Ue){return $t.registerDebugConfigurationProvider($e,Ee,Ue||zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return $t.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return $t.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?$t.startDebugging($e,Ee,{parentSession:Ue}):$t.startDebugging($e,Ee,Ue||{})},stopDebugging($e){return $t.stopDebugging($e)},addBreakpoints($e){return $t.addBreakpoints($e)},removeBreakpoints($e){return $t.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return $t.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>kt.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>kt.fetchTasks($e),executeTask:$e=>kt.executeTask(Be,$e),get taskExecutions(){return kt.taskExecutions},onDidStartTask:($e,Ee,Ue)=>at(kt.onDidStartTask)($e,Ee,Ue),onDidEndTask:($e,Ee,Ue)=>at(kt.onDidEndTask)($e,Ee,Ue),onDidStartTaskProcess:($e,Ee,Ue)=>at(kt.onDidStartTaskProcess)($e,Ee,Ue),onDidEndTaskProcess:($e,Ee,Ue)=>at(kt.onDidEndTaskProcess)($e,Ee,Ue)},Vi={createNotebookController($e,Ee,Ue,ut,vt){return ci.createNotebookController(Be,$e,Ee,Ue,ut,(0,et.$BF)(Be,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,et.$CF)(Be,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$CF)(Be,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Ue){return(0,et.$CF)(Be,"notebookCellExecutionState"),at(ci.onDidChangeNotebookCellExecutionState)($e,Ee,Ue)}},Si={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return yt.getMessage(Be.identifier.value,{message:Ee,args:Ue})}return yt.getMessage(Be.identifier.value,$e[0])},get bundle(){return yt.getBundle(Be.identifier.value)},get uri(){return yt.getBundleUri(Be.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),Zi.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),vi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),vi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,et.$CF)(Be,"interactive"),vi.transferChatSession($e,Ee)}},qi={getRelatedInformation($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),en.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),en.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),Ni.registerEmbeddingVectorProvider(Be,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,Ue){return(0,et.$CF)(Be,"chatProvider"),di.registerProvider(Be.identifier,$e,Ee,Ue)},requestChatAccess($e){return(0,et.$CF)(Be,"chatRequestAccess"),di.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,Ue){return(0,et.$CF)(Be,"chatAgents2"),_i.registerVariableResolver(Be,$e,Ee,Ue)},registerMappedEditsProvider($e,Ee){return(0,et.$CF)(Be,"mappedEditsProvider"),dt.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,et.$CF)(Be,"chatAgents2"),xi.createChatAgent(Be,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,et.$CF)(Be,"speech"),yi.registerProvider(Be.identifier,$e,Ee)}};return{version:bt.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:Ui,env:ji,extensions:nn,interactive:Wi,l10n:Si,languages:rn,notebooks:Vi,scm:on,speech:bn,tasks:Bi,tests:zi,window:mn,workspace:sn,Breakpoint:Oe.$$L,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$3M,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$2M,CallHierarchyIncomingCall:Oe.$xL,CallHierarchyItem:Oe.$wL,CallHierarchyOutgoingCall:Oe.$yL,CancellationError:T.$5,CancellationTokenSource:D.$6d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$tL,CodeActionKind:Oe.$uL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$zL,Color:Oe.$ML,ColorInformation:Oe.$NL,ColorPresentation:Oe.$OL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$GL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$HL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$WL,DebugAdapterExecutable:Oe.$cM,DebugAdapterInlineImplementation:Oe.$fM,DebugAdapterNamedPipeServer:Oe.$eM,DebugAdapterServer:Oe.$dM,DebugConfigurationProviderTriggerKind:zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$nL,DiagnosticRelatedInformation:Oe.$mL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$_K,DocumentHighlight:Oe.$pL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$qL,DocumentLink:Oe.$LL,DocumentSymbol:Oe.$sL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$iM,InlineValueText:Oe.$jM,InlineValueVariableLookup:Oe.$kM,InlineValueEvaluatableExpression:Oe.$lM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Vd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$vM,FileDecoration2:Oe.$vM,FileSystemError:Oe.$nM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$oM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$aM,InlineCompletionItem:Oe.$IL,InlineCompletionList:Oe.$JL,Hover:Oe.$oL,IndentAction:C.IndentAction,Location:Oe.$lL,MarkdownString:Oe.$AL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$BL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$aL,ProcessExecution:Oe.$UL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$uM,Range:Oe.$bL,RelativePattern:Oe.$9L,Selection:Oe.$cL,SelectionRange:Oe.$vL,SemanticTokens:Oe.$rM,SemanticTokensBuilder:Oe.$qM,SemanticTokensEdit:Oe.$sM,SemanticTokensEdits:Oe.$tM,SemanticTokensLegend:Oe.$pM,ShellExecution:Oe.$VL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$DL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$CL,SnippetString:Oe.$kL,SourceBreakpoint:Oe.$_L,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$rL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$XL,TaskGroup:Oe.$TL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$PL,TerminalQuickFixTerminalCommand:Oe.$RL,TerminalQuickFixOpener:Oe.$QL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$SL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$gL,SnippetTextEdit:Oe.$iL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$8L,ThemeIcon:Oe.$7L,TreeItem:Oe.$YL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$QM,UIKind:Rt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$jL,DocumentDropEdit:Oe.$5L,DocumentPasteEdit:Oe.$6L,InlayHint:Oe.$FL,InlayHintLabelPart:Oe.$EL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$fL,ResolvedAuthority:Oe.$dL,ManagedResolvedAuthority:Oe.$eL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$FM,NotebookRange:Oe.$xM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$yM,NotebookData:Oe.$zM,NotebookRendererScript:Oe.$DM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$BM,NotebookCellOutputItem:Oe.$AM,NotebookCellStatusBarItem:Oe.$CM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$hL,NotebookKernelSourceAction:Oe.$EM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$HM,LinkedEditingRanges:Oe.$GM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$IM,TestMessage:Oe.$JM,TestMessage2:Oe.$JM,TestTag:Oe.$KM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$4L,DataTransferItem:Oe.$ZL,CoveredCount:Oe.$LM,FileCoverage:Oe.$MM,StatementCoverage:Oe.$NM,BranchCoverage:Oe.$OM,FunctionCoverage:Oe.$PM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$RM,TabInputTextDiff:Oe.$SM,TabInputTextMerge:Oe.$TM,TabInputCustom:Oe.$UM,TabInputNotebook:Oe.$WM,TabInputNotebookDiff:Oe.$XM,TabInputWebview:Oe.$VM,TabInputTerminal:Oe.$YM,TabInputInteractiveWindow:Oe.$ZM,TabInputChat:Oe.$1M,TelemetryTrustedValue:o.$Lo,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$gM,ThreadFocus:Oe.$hM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$hic=Jt}),define(ke[370],Se([1,0,84,152,41,147,42,35,72,46,96,97,98,117,70,92,146,69,58,116,91,71,145,13,59,114,115]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(h.$9gc,h.$8gc,1),(0,D.$Yr)(u.$oj,t.$iic,1),(0,D.$Yr)(l.$hgc,l.$igc,1),(0,D.$Yr)(b.$xN,b.$wN,0),(0,D.$Yr)(R.$Cgc,R.$Agc,0),(0,D.$Yr)(o.$Egc,o.$Dgc,0),(0,D.$Yr)(C.$ghc,C.$khc,0),(0,D.$Yr)(I.$mhc,I.$lhc,0),(0,D.$Yr)($.$mN,$.$lN,0),(0,D.$Yr)(a.$0gc,a.$$gc,0),(0,D.$Yr)(i.$egc,i.$dgc,0),(0,D.$Yr)(T.$Shc,T.$Rhc,1),(0,D.$Yr)(m.$Chc,m.$Dhc,0),(0,D.$Yr)(v.$Xgc,v.$Wgc,0),(0,D.$Yr)(L.$6hc,L.$5hc,0),(0,D.$Yr)(y.$1gc,y.$4gc,0),(0,D.$Yr)(S.$vyb,S.$wyb,0),(0,D.$Yr)(f.$gic,f.$fic,0),(0,D.$Yr)(g.$zgc,g.$ygc,0),(0,D.$Yr)(r.$6gc,r.$5gc,0),(0,D.$Yr)(n.$vN,n.$sN,0),(0,D.$Yr)(c.$Ogc,c.$Pgc,0),(0,D.$Yr)(s.$ehc,s.$fhc,0)}),define(ke[119],Se([1,0,19,13,36,95]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=e.$yic=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$yic=R;function b(C,m,v,S){const l=(0,D.$2b)(v,$),f=new g.$zJ(m,l,S),o=f.preview.matches;return{ranges:(0,D.$2b)(l,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(o,y)}}}e.$zic=b;function $(C){return new g.$AJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$oJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Aic=L,e.$Aic=L=Ge([Ve(1,T.$nj)],L)}),define(ke[371],Se([1,0,50,17,76,33,10,12,119,372]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=e.$Cic=e.$Bic=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(r,n,c,t){const u=m(r,n,c,t),s=n.folder.fsPath;return{cmd:D.spawn(L,u.args,{cwd:s}),rgDiskPath:L,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}e.$Bic=C;function m(r,n,c,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],c,!1).forEach(h=>{const a=(0,$.$yic)(h);if(u.push("-g",a),R.$j){const d=(0,g.$Hl)(a);d!==a&&u.push("-g",d)}});const s=v([n],t,void 0,!1);return s.globArgs.forEach(h=>{const a=`!${(0,$.$yic)(h)}`;if(u.push("-g",a),R.$j){const d=(0,g.$Hl)(a);d!==a&&u.push("-g",d)}}),n.disregardIgnoreFiles!==!1?u.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),n.ignoreSymlinks||u.push("--follow"),r.exists&&u.push("--quiet"),u.push("--no-config"),n.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function v(r,n,c,t=!0){const u=[];let s={};return r.forEach(h=>{const a=Object.assign({},h.excludePattern||{},n||{}),d=l(a,t?h.folder.fsPath:void 0,c);u.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:u,siblingClauses:s}}function S(r,n,c=!0){const t=[];return r.forEach(u=>{const s=Object.assign({},n||{},u.includePattern||{}),h=l(s,c?u.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function l(r,n,c){const t=[],u={};return Object.keys(r).forEach(s=>{if(c&&c.has(s)||!s)return;const h=r[s];s=o(n?f(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof h=="boolean"&&h?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):h&&h.when&&(u[s]=h)}),{globArgs:t,siblingClauses:u}}function f(r,n){return T.$ic(n)?n:T.$jc(r,n)}e.$Cic=f;function o(r){return r=b.$Ue(r,"\\"),b.$Ue(r,"/")}function i(r){return I.$4f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$Dic=i}),define(ke[373],Se([1,0,50,56,17,374,19,44,34,76,33,10,38,12,18,31,36,371,129]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=e.$Eic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(h){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=h,this.b=h.filePattern||"",this.d=h.includePattern&&$.$Mj(h.includePattern),this.f=h.maxResults||null,this.g=!!h.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Zq)(this.b).normalizedLowercase),this.u=h.excludePattern&&$.$Mj(h.excludePattern),this.t=new Map,h.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),k=a.folder.fsPath;h.folderQueries.map(A=>A.folder.fsPath).filter(A=>A!==k).forEach(A=>{(0,L.$8f)(A,k)&&(d[g.$lc(k,A)]=!0)}),this.t.set(k,new t(d,k))})}cancel(){this.l=!0,r.forEach(h=>h())}walk(h,a,d,k,A){if(this.m=m.$Rd.create(!1),this.l)return A(null,this.j);a.forEach(p=>{const w=g.$nc(p.fsPath);this.u&&this.u(p.fsPath,w)||this.J(d,{relativePath:p.fsPath,searchPath:void 0})}),this.r=m.$Rd.create(!1),this.w(h,(p,w)=>{this.x(this.y,this,p,d,k,E=>{if(E){const P=(0,b.$Qi)(E);console.error(P),this.q.push(P),w(E,void 0)}else w(null,void 0)})},(p,w)=>{this.m.stop();const E=p?R.$Hb(p)[0]:null;A(E,this.j)})}w(h,a,d){const k=new Array(h.length),A=new Array(h.length);let p=!1,w=0;if(h.length===0)return d(null,[]);h.forEach((E,P)=>{a(E,(F,z)=>{if(F?(p=!0,k[P]=null,A[P]=F):(k[P]=z,A[P]=null),++w===h.length)return d(p?A:null,k)})})}x(h,a,...d){try{h.apply(a,d)}catch(k){d[d.length-1](k)}}y(h,a,d,k){const A=h.folder.fsPath,p=C.$j,w=()=>N&&N.kill();r.add(w);let E=U=>{r.delete(w),E=()=>{},k(U)},P="";const F=this.D(),z=(0,o.$Bic)(this.a,h,this.a.includePattern,this.t.get(h.folder.fsPath).expression),N=z.cmd,j=!Object.keys(z.siblingClauses).length,M=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let O=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),d({message:O}),this.s=0,this.z(N,"utf8",d,(U,Y,le)=>{if(U){E(U);return}if(this.j){E();return}const J=(P+(p?y.$Gl(Y||""):Y)).split(`
`);if(le){const X=J.length;J[X-1]=J[X-1].trim(),J[X-1]||J.pop()}else P=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const X of J)if(this.J(a,{base:A,relativePath:X,searchPath:this.N(h,X)}),this.j){w();break}(le||this.j)&&E();return}this.G(h,F,A,J,a),le&&(this.H(F,A,a),E())})}spawnFindCmd(h){const a=this.t.get(h.folder.fsPath),d=a.getBasenameTerms(),k=a.getPathTerms(),A=["-L","."];if(d.length||k.length){A.push("-not","(","(");for(const p of d)A.push("-name",p),A.push("-o");for(const p of k)A.push("-path",p),A.push("-o");A.pop(),A.push(")","-prune",")")}return A.push("-type","f"),D.spawn("find",A,{cwd:h.folder.fsPath})}readStdout(h,a,d){let k="";this.z(h,a,()=>{},(A,p,w)=>{if(A){d(A);return}k+=p,w&&d(null,k)})}z(h,a,d,k){let A=(E,P,F)=>{(E||F)&&(A=()=>{},this.r?.stop()),k(E,P,F)},p=!1;h.stdout?(this.A(h.stdout,a,A),h.stdout.once("data",()=>p=!0)):d({message:"stdout is null"});let w;h.stderr?w=this.B(h.stderr):d({message:"stderr is null"}),h.on("error",E=>{A(E)}),h.on("close",E=>{let P;!p&&(P=this.C(w,a))&&u(P)?A(new Error(`command failed with error code ${E}: ${this.C(w,a)}`)):(this.g&&E===0&&(this.j=!0),A(null,"",!0))})}A(h,a,d){const k=new I.StringDecoder(a);return h.on("data",A=>{d(null,k.write(A))}),k}B(h){const a=[];return h.on("data",d=>{a.push(d)}),a}C(h,a){const d=new I.StringDecoder(a);return h.map(k=>d.write(k)).join("")}D(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}G(h,{pathToEntries:a},d,k,A){k.indexOf(this.b)!==-1&&this.J(A,{base:d,relativePath:this.b,searchPath:this.N(h,this.b)});const p=w=>{const E=g.$nc(w),P=g.$mc(w);let F=a[P];F||(F=a[P]=[],p(P)),F.push({base:d,relativePath:w,basename:E,searchPath:this.N(h,w)})};k.forEach(p)}H({rootEntries:h,pathToEntries:a},d,k){const A=this,p=this.t.get(d),w=this.b;function E(P){A.o++;const F=(0,f.$PJ)(()=>P.map(z=>z.basename));for(let z=0,N=P.length;z<N;z++){const j=P[z],{relativePath:M,basename:O}=j;if(p.test(M,O,w!==O?F:void 0))continue;const U=a[M];if(U)E(U);else{if(A.p++,M===w)continue;A.J(k,j)}if(A.j)break}}E(h)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(h,a,d,k,A){const p=h.folder,w=(0,f.$PJ)(()=>d);this.w(d,(E,P)=>{if(this.l||this.j)return P(null);const F=a?[a,E].join(g.sep):E;if(this.t.get(h.folder.fsPath).test(F,E,this.a.filePattern!==E?w:void 0))return P(null);const z=[p.fsPath,F].join(g.sep);T.lstat(z,(N,j)=>{if(N||this.l||this.j)return P(null);this.L(z,j,(M,O)=>M||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(z,j,(U,Y)=>U||this.l||this.j||(Y=Y||"",this.v[Y])?P(null):(this.v[Y]=!0,l.Promises.readdir(z).then(le=>{if(this.l||this.j)return P(null);this.I(h,F,le,k,Z=>P(Z||null))},le=>{P(null)})))):(this.p++,F===this.b||this.h&&S.$Mf(O.size)&&O.size>this.h||this.J(k,{base:p.fsPath,relativePath:F,searchPath:this.N(h,F)}),P(null,void 0)))})},E=>{const P=E&&R.$Hb(E);return A(P&&P.length>0?P[0]:void 0)})}J(h,a){this.K(a)&&(!this.d||this.d(a.relativePath,g.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||h(a))}K(h){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$KJ)(h,this.c)}return!0}L(h,a,d){return a.isSymbolicLink()?T.stat(h,d):d(null,a)}M(h,a,d){return a.isSymbolicLink()?T.realpath(h,(k,A)=>k?d(k):d(null,A)):d(null,h)}N(h,a){return h.folderName?g.$jc(h.folderName,a):a}}e.$Eic=n;class c{constructor(h){this.a=h.folderQueries,this.b=h.extraFileResources||[],this.c=new n(h)}search(h,a,d){this.c.walk(this.a,this.b,h,a,(k,A)=>{d(k,{limitHit:A,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Fic=c;class t{constructor(h,a){this.expression=h,this.c=a,this.d(h)}d(h){let a,d;Object.keys(h).filter(k=>h[k]).forEach(k=>{g.$ic(k)?(a=a||$.$Hj(),a[k]=h[k]):(d=d||$.$Hj(),d[k]=h[k])}),this.a=a&&$.$Mj(a,{trimForExclusions:!0}),this.b=d&&$.$Mj(d,{trimForExclusions:!0})}test(h,a,d){return this.b&&this.b(h,a,d)||this.a&&this.a(g.$jc(this.c,h),a,d)}getBasenameTerms(){const h=[];return this.a&&h.push(...$.$Oj(this.a)),this.b&&h.push(...$.$Oj(this.b)),h}getPathTerms(){const h=[];return this.a&&h.push(...$.$Pj(this.a)),this.b&&h.push(...$.$Pj(this.b)),h}}function u(s){const h=s.trim().split(`
`),a=h[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return v.$Af(h[h.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(ke[375],Se([1,0,99,22,186,21]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.DecodeStreamErrorKind=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=void 0,e.$gD="utf8",e.$hD="utf8bom",e.$iD="utf16be",e.$jD="utf16le";function R(a){return[e.$gD,e.$hD,e.$iD,e.$jD].some(d=>d===a)}e.$kD=R,e.$lD=[254,255],e.$mD=[255,254],e.$nD=[239,187,191];const b=512,$=512,y=512*8,L=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(d,k){super(d),this.decodeStreamErrorKind=k}}e.$oD=m;class v{static async create(d){let k;if(d!==e.$gD)k=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const A=new TextDecoder;k={write(p){return A.decode(p,{stream:!0})},end(){return A.decode()}}}return new v(k)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function S(a,d){const k=d.minBytesRequiredForDetection??d.guessEncoding?y:$;return new Promise((A,p)=>{const w=(0,D.$0d)(j=>j.join("")),E=[];let P=0,F;const z=new I.$6d,N=async()=>{try{const j=await h({buffer:T.$je.concat(E),bytesRead:P},d.guessEncoding);if(j.seemsBinary&&d.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await d.overwriteEncoding(j.encoding),F=await v.create(j.encoding);const M=F.write(T.$je.concat(E).buffer);w.write(M),E.length=0,P=0,A({stream:w,detected:j})}catch(j){z.cancel(),w.destroy(),p(j)}};(0,D.$be)(a,{onData:async j=>{F?w.write(F.write(j.buffer)):(E.push(j),P+=j.byteLength,P>=k&&(a.pause(),await N(),setTimeout(()=>a.resume())))},onError:j=>w.error(j),onEnd:async()=>{F||await N(),w.end(F?.end())}},z.token)})}e.$pD=S;async function l(a,d,k){const p=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),k);let w=!1,E=!1;return{read(){if(E)return null;const P=a.read();if(typeof P!="string"){if(E=!0,!w&&k?.addBOM)switch(d){case e.$gD:case e.$hD:return T.$je.wrap(Uint8Array.from(e.$nD));case e.$iD:return T.$je.wrap(Uint8Array.from(e.$lD));case e.$jD:return T.$je.wrap(Uint8Array.from(e.$mD))}const F=p.end();return F&&F.length>0?(w=!0,T.$je.wrap(F)):null}return w=!0,T.$je.wrap(p.write(P))}}}e.$qD=l;async function f(a){return(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$rD=f;function o(a){return a===e.$hD||a===null?e.$gD:a}e.$sD=o;function i(a,d){if(!a||d<e.$lD.length)return null;const k=a.readUInt8(0),A=a.readUInt8(1);if(k===e.$lD[0]&&A===e.$lD[1])return e.$iD;if(k===e.$mD[0]&&A===e.$mD[1])return e.$jD;if(d<e.$nD.length)return null;const p=a.readUInt8(2);return k===e.$nD[0]&&A===e.$nD[1]&&p===e.$nD[2]?e.$hD:null}e.$tD=i;const r=["ascii","utf-16","utf-32"];async function n(a){const d=await(0,g.$fD)("jschardet","dist/jschardet.min.js"),k=a.slice(0,L),A=u(k.buffer),p=d.detect(A);if(!p||!p.encoding)return null;const w=p.encoding.toLowerCase();return 0<=r.indexOf(w)?null:t(p.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const d=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[d]||d}function u(a){let d="";for(let k=0;k<a.length;k++)d+=String.fromCharCode(a[k]);return d}function s(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=a.match(/windows(\d+)/);return d?"windows-"+d[1]:a}}}e.$uD=s;function h({buffer:a,bytesRead:d},k){let A=i(a,d),p=!1;if(A!==e.$iD&&A!==e.$jD&&a){let w=!0,E=!0,P=!1;for(let F=0;F<d&&F<b;F++){const z=F%2===1,N=a.readUInt8(F)===0;if(N&&(P=!0),w&&(z&&!N||!z&&N)&&(w=!1),E&&(z&&N||!z&&!N)&&(E=!1),N&&!w&&!E)break}P&&(w?A=e.$jD:E?A=e.$iD:p=!0)}return k&&!p&&!A&&a?n(a.slice(0,d)).then(w=>({seemsBinary:!1,encoding:w})):{seemsBinary:p,encoding:A}}e.$vD=h,e.$wD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,375,31,154]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class I extends g.$yhc{constructor(b,$,y=T,L="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$uD)(C)},L)}}e.$Nic=I}),define(ke[156],Se([1,0,50,391,374,19,73,34,12,2,36,95,392,372,119]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=e.$Kic=e.$Jic=e.$Iic=e.$Hic=e.$Gic=void 0;const l=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(w){this.a=w}provideTextSearchResults(w,E,P,F){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((z,N)=>{F.onCancellationRequested(()=>J());const j=t(w,E),M=E.folder.fsPath,O=j.map(ce=>ce.match(/^-/)?ce:`'${ce}'`).join(" ");this.a.appendLine(`${l} ${O}
 - cwd: ${M}`);let U=D.spawn(l,j,{cwd:M});U.on("error",ce=>{console.error(ce),this.a.appendLine("Error: "+(ce&&ce.message)),N((0,L.$GJ)(new L.$EJ(ce&&ce.message,L.SearchErrorCode.rgProcessError)))});let Y=!1;const le=new r(E.maxResults,E.folder,E.previewOptions);le.on("result",ce=>{Y=!0,ue="",P.report(ce)});let Z=!1;const J=()=>{Z=!0,U?.kill(),le?.cancel()};let X=!1;le.on("hitLimit",()=>{X=!0,J()});let ue="";U.stdout.on("data",ce=>{le.handleData(ce),Y||(ue+=ce)});let x=!1;U.stdout.once("data",()=>x=!0);let be="";U.stderr.on("data",ce=>{const K=ce.toString();this.a.appendLine(K),be.length+K.length<1e6&&(be+=K)}),U.on("close",()=>{if(this.a.appendLine(x?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),Z)z({limitHit:X});else{le.flush(),U=null;let ce;be&&!x&&(ce=o(be))?N((0,L.$GJ)(new L.$EJ(ce.message,ce.code))):z({limitHit:X})}})})}}e.$Gic=f;function o(p){const w=p.split(`
`),E=w[0].trim();if(w.some(F=>F.startsWith("regex parse error")))return new L.$EJ(i(w),L.SearchErrorCode.regexParseError);const P=E.match(/grep config error: unknown encoding: (.*)/);if(P)return new L.$EJ(`Unknown encoding: ${P[1]}`,L.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new L.$EJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new L.$EJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new L.$EJ(E,L.SearchErrorCode.regexParseError)}function i(p){const w=["Regex parse error"],E=p.filter(P=>P.startsWith("PCRE2:"));if(E.length>=1){const P=E[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const F=P.split(":")[1];w.push(":"+F)}}return w.join("")}class r extends T.EventEmitter{constructor(w,E,P){super(),this.g=w,this.h=E,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,E){return super.on(w,E),this}handleData(w){if(this.b)return;const E=typeof w=="string"?w:this.d.write(w);this.k(E)}k(w){let E=w.indexOf(`
`);const P=this.a+w;if(E>=0)E+=this.a.length;else{this.a=P;return}let F=0;for(;E>=0;)this.m(P.substring(F,E).trim()),F=E+1,E=P.indexOf(`
`,F);this.a=P.substring(F)}m(w){if(this.b||!w)return;let E;try{E=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(E.type==="match"){const P=n(E.data.path),F=y.URI.joinPath(this.h,P),z=this.n(E.data,F);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const P=n(E.data.path),F=y.URI.joinPath(this.h,P);this.o(E.data,F).forEach(N=>this.p(N))}}n(w,E){const P=w.line_number-1,F=n(w.lines),z=Buffer.from(F);let N=0,j=0,M=P;w.submatches.length===0&&w.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,I.$Hb)(w.submatches.map((U,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const le=n(U.match),Z=z.slice(N,U.start).toString(),J=c(Z),X=J.numLines>0?J.lastLineLength:J.lastLineLength+j,ue=c(le),x=J.numLines+M,be=ue.numLines+x,ce=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+X;return N=U.end,j=ce,M=be,new C.$oJ(x,X,be,ce)}));return(0,S.$zic)(E,F,O,this.j)}o(w,E){const P=n(w.lines),F=w.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((z,N)=>({text:z,uri:E,lineNumber:F+N}))}p(w){this.emit("result",w)}}e.$Hic=r;function n(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function c(p){const w=/\n/g;let E=0,P=-1,F;for(;F=w.exec(p);)E++,P=F.index;const z=P>=0?p.length-P-1:p.length;return{numLines:E,lastLineLength:z}}function t(p,w){const E=["--hidden","--no-require-git"];E.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:F}=(0,R.$K)(w.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const N=new Set;F.forEach(j=>{N.add(j)}),E.push("-g","!*"),N.forEach(j=>{u(j).map(S.$yic).forEach(M=>{E.push("-g",M)})})}P&&P.length&&P.forEach(N=>{E.push("-g",N)}),w.excludes.map(S.$yic).forEach(N=>E.push("-g",`!${N}`)),w.maxFileSize&&E.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),w.followSymlinks&&E.push("--follow"),w.encoding&&w.encoding!=="utf8"&&E.push("--encoding",w.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,$.$Oe)(p.pattern),p.isRegExp=!0),w.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),p.isRegExp&&(p.pattern=s(p.pattern),E.push("--engine","auto"));let z;if(p.isWordMatch){const j=(0,$.$Xe)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(p.isRegExp){let N=a(p.pattern);N=d(N),E.push("--regexp",N)}else z=p.pattern,E.push("--fixed-strings");return E.push("--no-config"),w.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),p.isMultiline&&E.push("--multiline"),w.beforeContext&&E.push("--before-context",w.beforeContext+""),w.afterContext&&E.push("--after-context",w.afterContext+""),E.push("--"),z&&E.push(z),E.push("."),E}e.$Iic=t;function u(p){return A(p).flatMap(E=>{const P=(0,b.$Kj)(E,"/");return P.map((F,z)=>P.slice(0,z+1).join("/"))})}function s(p){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(w);)p=p.replace(w,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");return p}e.$Jic=s;const h=p=>p.type==="Assertion"&&p.kind==="lookbehind";function a(p){let w;try{w=new m.RegExpParser().parsePattern(p)}catch{return p}let E="",P=0;const F=(j,M,O)=>{E+=p.slice(P,j)+O,P=M},z=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const M=z[0];if(!M)F(j.start,j.end,"\\r?\\n");else if(!z.some(h))if(M.type==="CharacterClass")if(M.negate){const O=p.slice(M.start+2,j.start)+p.slice(j.end,M.end-1);M.parent?.type==="Quantifier"?F(M.start,M.end,O?`[^${O}]`:"."):F(M.start,M.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=p.slice(M.start+1,j.start)+p.slice(j.end,M.end-1);F(M.start,M.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else M.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){z.unshift(j)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(j){z.unshift(j)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(j){z.unshift(j)},onCharacterClassLeave(){z.shift()},onAssertionEnter(j){h(j)&&z.push(j)},onAssertionLeave(j){z[0]===j&&z.shift()}}).visit(w),E+=p.slice(P),E}e.$Kic=a;function d(p){return p.replace(/\n/g,"\\r?\\n")}e.$Lic=d;function k(p){let w=!1,E=!1,P="",F="";for(let z=0;z<p.length;z++){const N=p[z];switch(N){case"\\":E?(w?F+="\\"+N:P+="\\"+N,E=!1):E=!0;break;case"{":if(E)w?F+=N:P+=N,E=!1;else{if(w)return{strInBraces:P+"{"+F+"{"+p.substring(z+1)};w=!0}break;case"}":if(E)w?F+=N:P+=N,E=!1;else{if(w)return{fixedStart:P,strInBraces:F,fixedEnd:p.substring(z+1)};P+=N}break;default:w?F+=(E?"\\":"")+N:P+=(E?"\\":"")+N,E=!1;break}}return{strInBraces:P+(w?"{"+F:"")}}function A(p){const{fixedStart:w,strInBraces:E,fixedEnd:P}=k(p);if(w===void 0||P===void 0)return[E];let F=(0,b.$Kj)(E,",");F.length||(F=[""]);const z=A(P);return F.flatMap(N=>{const j=w+N;return z.map(M=>j+M)})}e.$Mic=A}),define(ke[376],Se([1,0,21,156,86,16]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,C,m){const v=new T.$Gic(this.b);if(L.folder.scheme===I.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:I.Schemas.file})},l=new g.$vv(f=>C.report({...f,uri:f.uri.with({scheme:L.folder.scheme})}));return this.c(m,f=>v.provideTextSearchResults(y,S,l,f))}else return this.c(m,S=>v.provideTextSearchResults(y,L,C,S))}async c(y,L){const C=b(y);this.a.add(C);const m=await L(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Qic=R;function b($){const y=new D.$6d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[377],Se([1,0,31,156,155]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class I{constructor($){this.a=$}search($,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){L({message:v})}},m=new g.$Nic(this.a,new T.$Gic(C),D);return new Promise((v,S)=>m.search(l=>{y(l.map(R))},$).then(l=>v({limitHit:l.limitHit,type:"success",stats:l.stats}),S))}}e.$Oic=I;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const L=y;return $+(Array.isArray(L.ranges)?L.ranges.length:1)}else return $+1},0)}}}),define(ke[378],Se([1,0,19,11,14,4,129,17,38,2,32,36,373,377]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let c;const t=o(n),u=new I.$Vd({onDidAddFirstListener:()=>{c=(0,T.$Tg)(s=>this.doFileSearchWithEngine(m.$Fic,t,h=>u.fire(h),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}textSearch(n){let c;const t=o(n),u=new I.$Vd({onDidAddFirstListener:()=>{c=(0,T.$Tg)(s=>this.f(t,h=>u.fire(h),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}f(n,c,t){return n.maxFileSize=this.g().maxFileSize,new v.$Oic(n).search(t,c,c)}g(){return{maxFileSize:16*L.$Yk.GB}}doFileSearch(n,c,t){return this.doFileSearchWithEngine(m.$Fic,n,c,t)}doFileSearchWithEngine(n,c,t,u,s=S.a){let h=0;const a=k=>{Array.isArray(k)?(h+=k.length,t(k.map(A=>this.h(A)))):k.relativePath?(h++,t(this.h(k))):t(k)};if(c.sortByScore){let k=this.l(c,a,u);if(!k){const A=c.maxResults?Object.assign({},c,{maxResults:null}):c,p=new n(A);k=this.j(p,c,t,a,u)}return new Promise((A,p)=>{k.then(([w,E])=>{const P=E.map(F=>this.h(F));this.o(P,t,s),A(w)},p)})}const d=new n(c);return this.r(d,a,s,u).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:h,sortingTime:void 0}}))}h(n){return{path:n.base?(0,b.$jc)(n.base,n.relativePath):n.relativePath}}j(n,c,t,u,s){const h=new I.$Vd;let a=(0,T.$Tg)(k=>{let A=[];const p=w=>{Array.isArray(w)?A=w:(u(w),h.fire(w))};return this.r(n,p,-1,k).then(w=>[w,A])}),d;if(c.cacheKey){d=this.k(c.cacheKey);const k={promise:a,event:h.event,resolved:!1};d.resultsToSearchCache[c.filePattern||""]=k,a.then(()=>{k.resolved=!0},A=>{delete d.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([k,A])=>{const p=d?d.scorerCache:Object.create(null),w=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Rd.create(!1);return this.n(c,A,p,s).then(E=>{const P=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof c.maxResults=="number"&&A.length>c.maxResults},E]})})}k(n){const c=this.b[n];return c||(this.b[n]=new l)}l(n,c,t){const u=n.cacheKey&&this.b[n.cacheKey];if(!u)return;const s=this.q(u,n.filePattern||"",c,t);if(s)return s.then(([h,a,d])=>{const k=$.$Rd.create(!1);return this.n(n,a,u.scorerCache,t).then(A=>{const p=k.elapsed(),w={fromCache:!0,detailStats:d,type:this.d,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:h.limitHit||typeof n.maxResults=="number"&&a.length>n.maxResults,stats:w},A]})})}n(n,c,t,u){const s=(0,R.$Zq)(n.filePattern||""),h=(d,k)=>(0,R.$Yq)(d,k,s,!0,f,t),a=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(c,h,a,1e4,u)}o(n,c,t){if(t&&t>0)for(let u=0;u<n.length;u+=t)c(n.slice(u,u+t));else c(n)}q(n,c,t,u){const s=$.$Rd.create(!1),h=c.indexOf(b.sep)>=0;let a;for(const p in n.resultsToSearchCache)if(c.startsWith(p)){if(h&&p.indexOf(b.sep)<0&&p!=="")continue;const w=n.resultsToSearchCache[p];a={promise:this.s(w.promise),event:w.event,resolved:w.resolved};break}if(!a)return null;const d=s.elapsed(),k=$.$Rd.create(!1),A=a.event(t);return u&&u.onCancellationRequested(()=>{A.dispose()}),a.promise.then(([p,w])=>{if(u&&u.isCancellationRequested)throw(0,g.$6)();const E=[],P=(0,R.$Zq)(c).normalizedLowercase;for(const F of w)(0,C.$KJ)(F,P)&&E.push(F);return[p,E,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:k.elapsed(),cacheEntryCount:w.length}]})}r(n,c,t,u){return new Promise((s,h)=>{let a=[];u?.onCancellationRequested(()=>n.cancel()),n.search(d=>{d&&(t?(a.push(d),t>0&&a.length>=t&&(c(a),a=[])):c(d))},d=>{c(d)},(d,k)=>{a.length&&c(a),d?(c({message:"Search finished. Error: "+d.message}),h(d)):(c({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),s(k))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return n.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return n.finally(c)}}}}e.$Pic=S;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(r){return(0,b.$nc)(r.relativePath)}getItemDescription(r){return(0,b.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>y.URI.revive(n))}}function i(r){return{...r,folder:y.URI.revive(r.folder)}}}),define(ke[379],Se([1,0,3,16,2,31,13,27,20,98,66,36,378,376,119,155]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;let f=class extends y.$Dhc{constructor(i,r,n,c){super(i,n,c),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$Aic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new v.$Qic(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Aic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new v.$Qic(i))),this.x.add(this.z(T.Schemas.file,new m.$Pic("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,c){const t=(0,y.$Ehc)(n);if(i===this.t){const u=Date.now();return this.A(i,r,t,c).then(s=>{const h=Date.now()-u;return this.n.debug(`Ext host file search time: ${h}ms`),s})}return super.$provideFileSearchResults(i,r,n,c)}doInternalFileSearchWithCustomCallback(i,r,n){const c=t=>{if((0,C.$JJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(u=>g.URI.file(u.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,r)}async A(i,r,n,c){return this.doInternalFileSearchWithCustomCallback(n,c,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new l.$Nic(i,r,void 0,"textSearchProvider")}};e.$Ric=f,e.$Ric=f=Ge([Ve(0,$.$bN),Ve(1,b.$rN),Ve(2,L.$wgc),Ve(3,R.$nj)],f)}),define(ke[120],Se([1,0,393,62,63,394,22,14,4,3,17,10,30,81,82]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class l{traceSocketEvent(w,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,E)}constructor(w,E=""){this.f=!0,this.debugLabel=E,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const E=P=>{this.traceSocketEvent("read",P),w(R.$je.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(w){const E=P=>{w({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(w){const E=()=>{w()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Uh=l;var f;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(o||(o={}));class i extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,E){this.socket.traceSocketEvent(w,E)}constructor(w,E,P,F){super(),this.f=this.B(new $.$Vd),this.g=this.B(new $.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new r(this,E,P,F,this.f,(z,N)=>this.m(z,N))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Ph,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let E=0;for(;E<w.byteLength;)this.a.writeMessage(w.slice(E,Math.min(E+262144,w.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(w,{compressed:E,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let F=2;w.byteLength<126?F+=0:w.byteLength<2**16?F+=2:F+=8;const z=R.$je.alloc(F),N=E?64:0,j=P&15;if(z.writeUInt8(128|N|j,0),w.byteLength<126)z.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){z.writeUInt8(126,1);let M=1;z.writeUInt8(w.byteLength>>>8&255,++M),z.writeUInt8(w.byteLength>>>0&255,++M)}else{z.writeUInt8(127,1);let M=1;z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(w.byteLength>>>24&255,++M),z.writeUInt8(w.byteLength>>>16&255,++M),z.writeUInt8(w.byteLength>>>8&255,++M),z.writeUInt8(w.byteLength>>>0&255,++M)}this.socket.write(R.$je.concat([z,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),P=E.readUInt8(0),F=(P&128)>>>7,z=(P&64)>>>6,N=P&15,j=E.readUInt8(1),M=(j&128)>>>7,O=j&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),P=E.readUInt8(1),F=(P&128)>>>7;let z=P&127,N=1;z===126?z=E.readUInt8(++N)*2**8+E.readUInt8(++N):z===127&&(z=E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*2**24+E.readUInt8(++N)*2**16+E.readUInt8(++N)*2**8+E.readUInt8(++N));let j=0;F&&(j=E.readUInt8(++N)*2**24+E.readUInt8(++N)*2**16+E.readUInt8(++N)*2**8+E.readUInt8(++N)),this.j.state=3,this.j.readLen=z,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=i;class r extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$je.alloc(0)}constructor(w,E,P,F,z,N){super(),this.n=w,this.r=z,this.s=N,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new n(this.n,F,P,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(w,E){this.g.push({data:w,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:E}=this.g.shift();if(this.f&&E.compressed){const P=await this.w(this.f,w);this.s(P,E)}else this.s(w,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,E){return new Promise((P,F)=>{w.write(E),w.flush(z=>P(z))})}acceptFrame(w,E,P){this.h.push({data:w,isCompressed:E,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const E=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,E,P){return new Promise((F,z)=>{w.write(E),P&&w.write(R.$je.fromByteArray([0,0,255,255])),w.flush(N=>F(N))})}}class n extends y.$Tc{get recordedInflateBytes(){return this.j?R.$je.concat(this.f):R.$je.alloc(0)}constructor(w,E,P,F){super(),this.h=w,this.j=E,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$je.wrap(z))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$je.concat(this.g);this.g.length=0,w(E)})}}class c extends y.$Tc{constructor(w,E){super(),this.g=w,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$je.wrap(P))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$je.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),w(E)})}}function t(p,w){if(w===0)return;const E=p.byteLength>>>2;for(let M=0;M<E;M++){const O=p.readUInt32BE(M*4);p.writeUInt32BE(O^w,M*4)}const P=E*4,F=p.byteLength-P,z=w>>>24&255,N=w>>>16&255,j=w>>>8&255;F>=1&&p.writeUInt8(p.readUInt8(P)^z,P),F>=2&&p.writeUInt8(p.readUInt8(P+1)^N,P+1),F>=3&&p.writeUInt8(p.readUInt8(P+2)^j,P+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const p=(0,m.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const w=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,g.tmpdir)(),E=(0,L.$jc)(w,`vscode-ipc-${p}.sock`);return a(E),E}e.$Xh=s;function h(p,w,E){const F=(0,D.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${E}-${w}-sock`;const z=E.substr(0,4),N=w.substr(0,6);let j;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?j=(0,L.$jc)(e.$Wh,`vscode-${F}-${z}-${N}.sock`):j=(0,L.$jc)(p,`${z}-${N}.sock`),a(j),j}e.$Yh=h;function a(p){const w=u[C.$u];typeof w=="number"&&p.length>=w&&console.warn(`WARNING: IPC handle "${p}" is longer than ${w} chars, try a shorter --user-data-dir`)}class d extends v.$Jh{static b(w){const E=$.Event.fromNodeEventEmitter(w,"connection");return $.Event.map(E,P=>({protocol:new S.$Qh(new l(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(w){super(d.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=d;function k(p){return new Promise((w,E)=>{const P=(0,T.createServer)();P.on("error",E),P.listen(p,()=>{P.removeListener("error",E),w(new d(P))})})}e.$1h=k;function A(p,w){return new Promise((E,P)=>{const F=(0,T.createConnection)(p,()=>{F.removeListener("error",P),E(S.$Rh.fromSocket(new l(F,`ipc-client${w}`),w))});F.once("error",P)})}e.$2h=A}),define(ke[380],Se([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,89,22]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=e.$h_b=e.$g_b=void 0;async function o(t,u,s,h,a){let d;for(let k=3;k&&(d?.dispose(),d=await new i(t,u,s,h,a).waitForReady(),!(a&&g.$tg[a]||!g.$tg[d.tunnelLocalPort]));k--);return d}class i extends b.$Tc{constructor(u,s,h,a,d){super(),this.m=s,this.n=d,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=D.createServer(),this.c=new R.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,s=(0,l.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let h=await(0,g.$ug)(u,2,1e3,s),a=null;return this.b.listen(h,this.m),await this.c.wait(),a=this.b.address(),a||(h=0,this.b.listen(h,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(u){u.pause();const s=(0,l.$Fv)(this.tunnelRemoteHost)||(0,l.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,m.$ll)(this.a,s,this.tunnelRemotePort),a=h.getSocket(),d=h.readEntireBuffer();h.dispose(),d.byteLength>0&&u.write(d.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),a.end()}),u.on("close",()=>a.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),a instanceof I.$Uh?a.socket.destroy():a.end()}),a instanceof I.$Uh?this.t(u,a):this.s(u,a),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),a.end()})}s(u,s){s.onClose(()=>u.destroy()),s.onEnd(()=>u.end()),s.onData(h=>u.write(h.buffer)),u.on("data",h=>s.write(f.$je.wrap(h))),u.resume()}t(u,s){const h=s.socket;h.on("end",()=>u.end()),h.on("close",()=>u.end()),h.on("error",()=>{u.destroy()}),h.pipe(u),u.pipe(h)}}e.$g_b=i;let r=class extends l.$Kv{constructor(u,s,h,a,d){super(s,d),this.v=u,this.w=h,this.y=a}isPortPrivileged(u){return(0,l.$Iv)(u,this.m,$.OS,T.release())}t(u,s,h,a,d,k,A,p){const w=this.s(s,h);if(w)return++w.refcount,w.value;if((0,l.$Cv)(u))return this.u(u,s,h,d,k,A,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${h} on local port ${d}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(E,a,s,h,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,h,P),P}}};e.$h_b=r,e.$h_b=r=Ge([Ve(0,v.$fl),Ve(1,L.$nj),Ve(2,S.$il),Ve(3,C.$Fj),Ve(4,y.$zi)],r);let n=class extends r{constructor(u,s,h,a,d){super(u,s,h,a,d)}};e.$i_b=n,e.$i_b=n=Ge([Ve(0,v.$fl),Ve(1,L.$nj),Ve(2,S.$il),Ve(3,C.$Fj),Ve(4,y.$zi)],n);let c=class extends b.$Tc{constructor(u,s,h,a,d){super(),this.b=u,this.c=s,this.f=h,this.g=a,this.h=d,this.a=new Map}async openTunnel(u,s,h,a,d,k,A,p,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${a} on local port ${k}.`),!this.a.has(u)){const E=new n(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(u,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(s,h,a,d,k,A,p,w)}};e.$j_b=c,e.$j_b=c=Ge([Ve(0,v.$fl),Ve(1,L.$nj),Ve(2,C.$Fj),Ve(3,S.$il),Ve(4,y.$zi)],c)}),define(ke[381],Se([1,0,120,276,56,35,2,13,40]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0;class y{constructor(m,v,S){this.b=m,this.c=v,this.f=S,this.a=T.createServer((l,f)=>this.h(l,f)),this.g().catch(l=>(v.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const S=(f,o)=>{v.writeHead(f,{"content-type":"application/json"}),v.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},l=[];m.setEncoding("utf8"),m.on("data",f=>l.push(f)),m.on("end",async()=>{try{const f=JSON.parse(l.join(""));let o;switch(f.type){case"open":o=await this.i(f);break;case"openExternal":o=await this.j(f);break;case"status":o=await this.l(f);break;case"extensionManagement":o=await this.k(f);break;default:S(404,`Unknown message type: ${f.type}`);break}S(200,o)}catch(f){const o=f instanceof Error?f.message:JSON.stringify(f);S(500,o),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:v,folderURIs:S,forceNewWindow:l,diffMode:f,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:c,remoteAuthority:t}=m,u=[];if(Array.isArray(S))for(const d of S)try{u.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(v))for(const d of v)try{(0,$.$yi)(d)?u.push({workspaceUri:R.URI.parse(d)}):u.push({fileUri:R.URI.parse(d)})}catch{}const s=c?R.URI.file(c):void 0,a={forceNewWindow:l,diffMode:f,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,a)}async j(m){for(const v of m.uris){const S=R.URI.parse(v),l=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const v=l=>l?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),S={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$CN=y;let L=class extends y{constructor(m,v){super(m,v,(0,D.$Xh)())}};e.$DN=L,e.$DN=L=Ge([Ve(0,I.$xN),Ve(1,b.$nj)],L)}),define(ke[382],Se([1,0,57,369,364,275,47,351,2,16,7,381,104,306,350]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class l extends g.$lic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,h,a){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,m.$wq)(h.filename)),d=>n.apply(this,[d,h,a])):n.apply(this,arguments)};const c=r._resolveLookupPaths;r._resolveLookupPaths=(u,s)=>c.call(this,t(u),s);const t=u=>{for(const s of i.b){const h=s(u);if(h){u=h;break}}return u}}}class f extends R.$ahc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$Uic);const i=this.h.invokeFunction(T.$hic);if(this.h.createInstance(b.$Tic),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$DN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(S.$Vic),await this.h.createInstance(l,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,I.$Sic)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let c=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(r.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$Wic=f}),define(ke[383],Se([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,89,380,27,20,70,358]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=e.$2ic=e.$1ic=e.$Zic=e.$Yic=e.$Xic=void 0;function c(w){const E=w.trim().split(`
`),P=[];return E.forEach(z=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);N&&N.length>=3&&P.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),P.reduce((z,N)=>(z[N.socket]=N,z),{})}e.$Xic=c;function t(...w){const E=[].concat(...w.map(s));return[...new Map(E.filter(P=>P.st==="0A").map(P=>{const F=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:u(F[0]),port:parseInt(F[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Yic=t;function u(w){let E="";if(w.length===8)for(let P=w.length-2;P>=0;P-=2)E+=parseInt(w.substr(P,2),16),P!==0&&(E+=".");else for(let P=0;P<w.length;P+=8){const F=w.substring(P,P+8);let z="";for(let N=8;N>=2;N-=2)z+=F.substring(N-2,N),(N===6||N===2)&&(z=parseInt(z,16).toString(16),E+=`${z}`,z="",P+N!==w.length-6&&(E+=":"))}return E}e.$Zic=u;function s(w){const E=w.trim().split(`
`),P=E.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return E.map(z=>z.trim().split(/\s+/).reduce((N,j,M)=>(N[P[M]||M]=j,N),{}))}e.$1ic=s;function h(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function a(w){const E=w.trim().split(`
`),P=[];return E.forEach(F=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);z&&z.length>=4&&P.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),P}e.$2ic=a;async function d(w,E,P){const F=P.reduce((N,j)=>(N[j.pid]=j,N),{}),z=[];return w.forEach(({socket:N,ip:j,port:M})=>{const O=E[N]?E[N].pid:void 0,U=O?F[O]?.cmd:void 0;O&&U&&!h(U)&&z.push({host:j,port:M,detail:U,pid:O})}),z}e.$3ic=d;function k(w,E,P){const F=new Map,z=a(E);for(const N of w){const j=P.get(N.port);if(j){F.set(N.port,j);continue}const M=z.find(O=>O.cmd.includes(`${N.port}`));if(M){let O=M,U;do U=z.find(Y=>Y.ppid===O.pid),U&&(O=U);while(U);F.set(N.port,{host:N.ip,port:N.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else F.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return F}e.$4ic=k;let A=class extends r.$wyb{constructor(E,P,F,z){super(E,P,F),this.D=P,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new R.$0l;let z=0;for(;this.C;){const N=new Date().getTime(),j=(await this.I()).filter(U=>(0,l.$Fv)(U.host)||(0,l.$Hv)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-N;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),z++>3&&F.update(M),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const O=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(U=>setTimeout(()=>U(),O))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",P="";try{E=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(E,P),z=await new Promise(Z=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,X,ue)=>{Z(X)})}),N=c(z),j=await L.Promises.readdir("/proc"),M=[];for(const Z of j)try{const J=Number(Z),X=$.$Hg(y.URI.file("/proc"),Z);if((await L.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(J)){const x=await L.Promises.readlink($.$Hg(X,"cwd").fsPath),be=await L.Promises.readFile($.$Hg(X,"cmdline").fsPath,"utf8");M.push({pid:J,cwd:x,cmd:be})}}catch{}const O=[],U=F.filter(Z=>{const J=N[Z.socket];return J||O.push(Z),J}),Y=d(U,N,M);let le;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const Z=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(X,ue,x)=>{J(ue)})});this.z=k(O,Z,this.z),le=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(J=>J.port).join(", ")}`)}return Y.then(Z=>le?Z.concat(le):Z)}w(E){return async P=>{const F=new f.$g_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(N,j,M,O){const U=await E.makeConnection();return p.connect(U,j,M,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$9k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await F.waitForReady();const z=new g.$Vd;return{localAddress:(0,n.$xK)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{F.dispose(),z.fire(),z.dispose()}}}}};e.$5ic=A,e.$5ic=A=Ge([Ve(0,i.$bN),Ve(1,o.$rN),Ve(2,C.$nj),Ve(3,S.$il)],A);class p extends m.$yrb{static connect(E,P,F,z){const N=new I.$Sc,j={onClose:N.add(new g.$Vd),onData:N.add(new g.$Vd),onEnd:N.add(new g.$Vd)};N.add(E.onDidReceiveMessage(O=>j.onData.fire(T.$je.wrap(O)))),N.add(E.onDidEnd(()=>j.onEnd.fire())),N.add(E.onDidClose(O=>j.onClose.fire({type:0,error:O,hadError:!!O})));const M=new p(E,z,j);return M.B(N),(0,m.$xrb)(M,P,F,z,j)}constructor(E,P,F){super(P,F),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,84,353,367,366,379,382,383,97,47,98,96,46,70,94,352,307,13,368,59,270,106,109,138]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(L.$bhc,b.$Wic,0),(0,D.$Yr)(i.$oj,o.$7ic,1),(0,D.$Yr)(i.$nj,new t.$3h(c.$kic,[!1],!0)),(0,D.$Yr)(u.$il,s.$l_b,1),(0,D.$Yr)(l.$Fgc,f.$6ic,0),(0,D.$Yr)(y.$ghc,I.$xic,0),(0,D.$Yr)(C.$Chc,R.$Ric,0),(0,D.$Yr)(m.$6hc,g.$pic,0),(0,D.$Yr)(v.$1gc,T.$oic,0),(0,D.$Yr)(S.$vyb,$.$5ic,0),(0,D.$Yr)(n.$ehc,r.$8ic,0)}),define(ke[395],Se([1,0,62,396,57,14,82,120,253,113,365,22,31,104,11,132,277,290,370,384]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,v,S,l,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,k=d._load;d._load=function(A){if(A==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function c(d){process.exit=function(k){if(d)r(k);else{const A=new Error("An extension called process.exit() and this was prevented.");console.warn(A.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,A){k==="uncaughtException"&&(A=function(){try{return A.call(void 0,arguments)}catch{}}),n(k,A)}}let t=function(d){r()};function u(){const d=(0,o.$Tm)(process.env);if(d.type===3)return new Promise((k,A)=>{const p=w=>{const E=w[0],P=new R.$Sh;E.on("message",F=>P.fire(C.$je.wrap(F.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),k({onMessage:P.event,send:F=>E.postMessage(F.buffer)})};process.parentPort.on("message",w=>p(w.ports))});if(d.type===2)return new Promise((k,A)=>{let p=null;const w=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,P=3e5,F=new S.$gh(()=>t("renderer disconnected for too long (1)"),E),z=new S.$gh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(j,M)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const O=C.$je.wrap(Buffer.from(j.initialDataChunk,"base64"));let U;if(j.skipWebSocketFrames)U=new b.$Uh(M,"extHost-socket");else{const Y=C.$je.wrap(Buffer.from(j.inflateBytes,"base64"));U=new b.$Vh(new b.$Uh(M,"extHost-socket"),j.permessageDeflate,Y,!1)}p?(F.cancel(),z.cancel(),p.beginAcceptReconnection(U,O),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(w),p=new R.$Th({socket:U,initialChunk:O}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),k(p),p.onSocketClose(()=>{F.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;F.isScheduled()&&z.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const k=d.pipeName;return new Promise((A,p)=>{const w=D.createConnection(k,()=>{w.removeListener("error",p);const E=new R.$Th({socket:new b.$Uh(w,"extHost-renderer")});E.sendResume(),A(E)});w.once("error",p),w.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const d=await u();return new class{constructor(){this.a=new R.$Sh,this.onMessage=this.a.event,this.b=!1,d.onMessage(k=>{(0,y.$um)(k,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||d.send(k)}async drain(){if(d.drain)return d.drain()}}}function h(d){return new Promise(k=>{const A=d.onMessage(p=>{A.dispose();const w=JSON.parse(p.toString()),E=w.commit,P=$.default.commit;if(E&&P&&E!==P&&r(55),w.parentPid){let F=0;setInterval(function(){try{process.kill(w.parentPid,0),F=0}catch(N){N&&N.code==="EPERM"?(F++,F>=3&&t(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):t(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(w.parentPid)}catch(N){(0,I.$1)(N)}}d.send((0,y.$tm)(0)),k({protocol:d,initData:w})});d.send((0,y.$tm)(1))})}async function a(){const d=[];process.on("unhandledRejection",(F,z)=>{d.push(z),setTimeout(()=>{const N=d.indexOf(z);N>=0&&z.catch(j=>{d.splice(N,1),(0,I.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),F&&(0,I.$1)(F))})},1e3)}),process.on("rejectionHandled",F=>{const z=d.indexOf(F);z>=0&&d.splice(z,1)}),process.on("uncaughtException",function(F){(0,I.$Z)(F)||(0,I.$1)(F)}),g.mark("code/extHost/willConnectToRenderer");const k=await s();g.mark("code/extHost/didConnectToRenderer");const A=await h(k);g.mark("code/extHost/didWaitForInitData");const{initData:p}=A;c(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(z){r(z)}fsExists(z){return m.Promises.exists(z)}fsRealpath(z){return(0,v.$vq)(z)}};let E=null;p.remote.authority&&i.transformURIs&&(E=(0,f.$3r)(p.remote.authority));const P=new L.$nic(A.protocol,p,w,E);t=F=>P.terminate(F)}a().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aed5f4d65d2dbfda2c98abd7eb371751016838ab/core/vs/workbench/api/node/extensionHostProcess.js.map
