/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],y=0,M=ge.length;y<M;y++)e[y]=Pe[ge[y]];return e};define(Pe[67],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function y(P){return(m,f,w)=>{let R=null,k=null;if(typeof w.value=="function"?(R="value",k=w.value):typeof w.get=="function"&&(R="get",k=w.get),!k)throw new Error("not supported");w[R]=P(k,f)}}function M(P,m,f){let w=null,R=null;if(typeof f.value=="function"?(w="value",R=f.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",R=f.get),!R)throw new Error("not supported");const k=`$memoize$${m}`;f[w]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[k]}}e.$xh=M;function I(P,m,f){return y((w,R)=>{const k=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...p){this[l]||(this[l]=f?f():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...p),p=[this[l]]),this[k]=setTimeout(()=>{w.apply(this,p),this[l]=f?f():void 0},P)}})}e.$yh=I;function A(P,m,f){return y((w,R)=>{const k=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,b=`$throttle$pending$${R}`;return function(...r){if(this[l]||(this[l]=f?f():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[b])return;const a=this[p]+P;a<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=f?f():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}e.$zh=A}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class y{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$gN=y,e.$hN=new y("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function P(t,u=!1){let i=0;const g=t.length;let $="",d=0,S=16,L=0;function v(z){let C=0,N=0;for(;C<z;){const W=t.charCodeAt(i);if(W>=48&&W<=57)N=N*16+W-48;else if(W>=65&&W<=70)N=N*16+W-65+10;else if(W>=97&&W<=102)N=N*16+W-97+10;else break;i++,C++}return C<z&&(N=-1),N}function E(z){i=z,$="",d=0,S=16,L=0}function D(){const z=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return L=3,t.substring(z,i);let C=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;C=i}else L=3;return t.substring(z,C)}function T(){let z="",C=i;for(;;){if(i>=g){z+=t.substring(C,i),L=2;break}const N=t.charCodeAt(i);if(N===34){z+=t.substring(C,i),i++;break}if(N===92){if(z+=t.substring(C,i),i++,i>=g){L=2;break}switch(t.charCodeAt(i++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const ae=v(4);ae>=0?z+=String.fromCharCode(ae):L=4;break}default:L=5}C=i;continue}if(N>=0&&N<=31)if(f(N)){z+=t.substring(C,i),L=2;break}else L=6;i++}return z}function O(){if($="",L=0,d=i,i>=g)return d=g,S=17;let z=t.charCodeAt(i);if(m(z)){do i++,$+=String.fromCharCode(z),z=t.charCodeAt(i);while(m(z));return S=15}if(f(z))return i++,$+=String.fromCharCode(z),z===13&&t.charCodeAt(i)===10&&(i++,$+=`
`),S=14;switch(z){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,$=T(),S=10;case 47:{const C=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<g&&!f(t.charCodeAt(i));)i++;return $=t.substring(C,i),S=12}if(t.charCodeAt(i+1)===42){i+=2;const N=g-1;let W=!1;for(;i<N;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,L=1),$=t.substring(C,i),S=13}return $+=String.fromCharCode(z),i++,S=16}case 45:if($+=String.fromCharCode(z),i++,i===g||!w(t.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return $+=D(),S=11;default:for(;i<g&&G(z);)i++,z=t.charCodeAt(i);if(d!==i){switch($=t.substring(d,i),$){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return $+=String.fromCharCode(z),i++,S=16}}function G(z){if(m(z)||f(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>i,scan:u?q:O,getToken:()=>S,getTokenValue:()=>$,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>L}}e.$an=P;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function k(t,u){const i=[],g=new Object;let $;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(v,E,D,T){d.value=v,d.offset=E,d.length=D,d.type=T,d.colonOffset=void 0,$=d}try{o(t,{onObjectBegin:(v,E)=>{if(u<=v)throw g;$=void 0,S=u>v,i.push("")},onObjectProperty:(v,E,D)=>{if(u<E||(L(v,E,D,"property"),i[i.length-1]=v,u<=E+D))throw g},onObjectEnd:(v,E)=>{if(u<=v)throw g;$=void 0,i.pop()},onArrayBegin:(v,E)=>{if(u<=v)throw g;$=void 0,i.push(0)},onArrayEnd:(v,E)=>{if(u<=v)throw g;$=void 0,i.pop()},onLiteralValue:(v,E,D)=>{if(u<E||(L(v,E,D,h(v)),u<=E+D))throw g},onSeparator:(v,E,D)=>{if(u<=E)throw g;if(v===":"&&$&&$.type==="property")$.colonOffset=E,S=!1,$=void 0;else if(v===","){const T=i[i.length-1];typeof T=="number"?i[i.length-1]=T+1:(S=!0,i[i.length-1]=""),$=void 0}}})}catch(v){if(v!==g)throw v}return{path:i,previousNode:$,isAtPropertyKey:S,matches:v=>{let E=0;for(let D=0;E<v.length&&D<i.length;D++)if(v[E]===i[D]||v[E]==="*")E++;else if(v[E]!=="**")return!1;return E===v.length}}}e.$bn=k;function l(t,u=[],i=A.DEFAULT){let g=null,$=[];const d=[];function S(v){Array.isArray($)?$.push(v):g!==null&&($[g]=v)}return o(t,{onObjectBegin:()=>{const v={};S(v),d.push($),$=v,g=null},onObjectProperty:v=>{g=v},onObjectEnd:()=>{$=d.pop()},onArrayBegin:()=>{const v=[];S(v),d.push($),$=v,g=null},onArrayEnd:()=>{$=d.pop()},onLiteralValue:S,onError:(v,E,D)=>{u.push({error:v,offset:E,length:D})}},i),$[0]}e.$cn=l;function p(t,u=[],i=A.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(v){g.type==="property"&&(g.length=v-g.offset,g=g.parent)}function d(v){return g.children.push(v),v}o(t,{onObjectBegin:v=>{g=d({type:"object",offset:v,length:-1,parent:g,children:[]})},onObjectProperty:(v,E,D)=>{g=d({type:"property",offset:E,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:v,offset:E,length:D,parent:g})},onObjectEnd:(v,E)=>{g.length=v+E-g.offset,g=g.parent,$(v+E)},onArrayBegin:(v,E)=>{g=d({type:"array",offset:v,length:-1,parent:g,children:[]})},onArrayEnd:(v,E)=>{g.length=v+E-g.offset,g=g.parent,$(v+E)},onLiteralValue:(v,E,D)=>{d({type:h(v),offset:E,length:D,parent:g,value:v}),$(E+D)},onSeparator:(v,E,D)=>{g.type==="property"&&(v===":"?g.colonOffset=E:v===","&&$(E))},onError:(v,E,D)=>{u.push({error:v,offset:E,length:D})}},i);const L=g.children[0];return L&&delete L.parent,L}e.$dn=p;function b(t,u){if(!t)return;let i=t;for(const g of u)if(typeof g=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let $=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===g){i=d.children[1],$=!0;break}if(!$)return}else{const $=g;if(i.type!=="array"||$<0||!Array.isArray(i.children)||$>=i.children.length)return;i=i.children[$]}return i}e.$en=b;function r(t){if(!t.parent||!t.parent.children)return[];const u=r(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}e.$fn=r;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const u=Object.create(null);for(const i of t.children){const g=i.children[1];g&&(u[i.children[0].value]=a(g))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=a;function s(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}e.$hn=s;function n(t,u,i=!1){if(s(t,u,i)){const g=t.children;if(Array.isArray(g))for(let $=0;$<g.length&&g[$].offset<=u;$++){const d=n(g[$],u,i);if(d)return d}return t}}e.$in=n;function o(t,u,i=A.DEFAULT){const g=P(t,!1);function $(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function d(ie){return ie?be=>ie(be,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=$(u.onObjectBegin),L=d(u.onObjectProperty),v=$(u.onObjectEnd),E=$(u.onArrayBegin),D=$(u.onArrayEnd),T=d(u.onLiteralValue),O=d(u.onSeparator),G=$(u.onComment),q=d(u.onError),z=i&&i.disallowComments,C=i&&i.allowTrailingComma;function N(){for(;;){const ie=g.scan();switch(g.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ie){case 12:case 13:z?W(10):G();break;case 16:W(1);break;case 15:case 14:break;default:return ie}}}function W(ie,be=[],se=[]){if(q(ie),be.length+se.length>0){let Z=g.getToken();for(;Z!==17;){if(be.indexOf(Z)!==-1){N();break}else if(se.indexOf(Z)!==-1)break;Z=N()}}}function ae(ie){const be=g.getTokenValue();return ie?T(be):L(be),N(),!0}function de(){switch(g.getToken()){case 11:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&(W(2),ie=0)}catch{W(2)}T(ie);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return N(),!0}function we(){return g.getToken()!==10?(W(3,[],[2,5]),!1):(ae(!1),g.getToken()===6?(O(":"),N(),$e()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ye(){S(),N();let ie=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(ie||W(4,[],[]),O(","),N(),g.getToken()===2&&C)break}else ie&&W(6,[],[]);we()||W(4,[],[2,5]),ie=!0}return v(),g.getToken()!==2?W(7,[2],[]):N(),!0}function le(){E(),N();let ie=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(ie||W(4,[],[]),O(","),N(),g.getToken()===4&&C)break}else ie&&W(6,[],[]);$e()||W(4,[],[4,5]),ie=!0}return D(),g.getToken()!==4?W(8,[4],[]):N(),!0}function $e(){switch(g.getToken()){case 3:return le();case 1:return ye();case 10:return ae(!0);default:return de()}}return N(),g.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):$e()?(g.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$jn=o;function c(t,u){const i=P(t),g=[];let $,d=0,S;do switch(S=i.getPosition(),$=i.scan(),$){case 12:case 13:case 17:d!==S&&g.push(t.substring(d,S)),u!==void 0&&g.push(i.getTokenValue().replace(/[^\r\n]/g,u)),d=i.getPosition();break}while($!==17);return g.join("")}e.$kn=c;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var te=0;te<ce.length;te++){var Q=ce[te];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function y(Ce,ce,te){return ce&&e(Ce.prototype,ce),te&&e(Ce,te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function M(Ce,ce){if(Ce){if(typeof Ce=="string")return I(Ce,ce);var te=Object.prototype.toString.call(Ce).slice(8,-1);if(te==="Object"&&Ce.constructor&&(te=Ce.constructor.name),te==="Map"||te==="Set")return Array.from(Ce);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return I(Ce,ce)}}function I(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var te=0,Q=new Array(ce);te<ce;te++)Q[te]=Ce[te];return Q}function A(Ce,ce){var te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(te)return(te=te.call(Ce)).next.bind(te);if(Array.isArray(Ce)||(te=M(Ce))||ce&&Ce&&typeof Ce.length=="number"){te&&(Ce=te);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=P();function m(Ce){ge.defaults=Ce}var f=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function b(Ce,ce){if(ce){if(f.test(Ce))return Ce.replace(w,p)}else if(R.test(Ce))return Ce.replace(k,p);return Ce}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Ce){return Ce.replace(r,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var te={replace:function(ee,me){return me=me.source||me,me=me.replace(s,"$1"),Ce=Ce.replace(ee,me),te},getRegex:function(){return new RegExp(Ce,ce)}};return te}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,te){if(Ce){var Q;try{Q=decodeURIComponent(a(te)).replace(o,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=$(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},u=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(Ce,ce){t[" "+Ce]||(u.test(Ce)?t[" "+Ce]=Ce+"/":t[" "+Ce]=v(Ce,"/",!0)),Ce=t[" "+Ce];var te=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:Ce.replace(i,"$1")+ce:ce.charAt(0)==="/"?te?ce:Ce.replace(g,"$1")+ce:Ce+ce}var d={exec:function(){}};function S(Ce){for(var ce=1,te,Q;ce<arguments.length;ce++){te=arguments[ce];for(Q in te)Object.prototype.hasOwnProperty.call(te,Q)&&(Ce[Q]=te[Q])}return Ce}function L(Ce,ce){var te=Ce.replace(/\|/g,function(me,ve,Ae){for(var he=!1,Ee=ve;--Ee>=0&&Ae[Ee]==="\\";)he=!he;return he?"|":" |"}),Q=te.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function v(Ce,ce,te){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var me=Ce.charAt(Q-ee-1);if(me===ce&&!te)ee++;else if(me!==ce&&te)ee++;else break}return Ce.slice(0,Q-ee)}function E(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var te=Ce.length,Q=0,ee=0;ee<te;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Ce,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=Ce),ce>>=1,Ce+=Ce;return te+Ce}function O(Ce,ce,te,Q){var ee=ce.href,me=ce.title?b(ce.title):null,ve=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ae={type:"link",raw:te,href:ee,title:me,text:ve,tokens:Q.inlineTokens(ve)};return Q.state.inLink=!1,Ae}return{type:"image",raw:te,href:ee,title:me,text:b(ve)}}function G(Ce,ce){var te=Ce.match(/^(\s+)(?:```)/);if(te===null)return ce;var Q=te[1];return ce.split(`
`).map(function(ee){var me=ee.match(/^\s+/);if(me===null)return ee;var ve=me[0];return ve.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var q=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var me=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var me=ee[0],ve=G(me,ee[3]||"");return{type:"code",raw:me,lang:ee[2]?ee[2].trim():ee[2],text:ve}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var me=ee[2].trim();if(/#$/.test(me)){var ve=v(me,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(me=ve.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var me=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var me,ve,Ae,he,Ee,F,H,K,j,Y,x,ke,Te=ee[1].trim(),Ve=Te.length>1,Ke={type:"list",raw:"",ordered:Ve,start:Ve?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Ve?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Ve?Te:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ke=!1,!(!(ee=Xe.exec(Q))||this.rules.block.hr.test(Q)));){if(me=ee[0],Q=Q.substring(me.length),K=ee[2].split(`
`,1)[0],j=Q.split(`
`,1)[0],this.options.pedantic?(he=2,x=K.trimLeft()):(he=ee[2].search(/[^ ]/),he=he>4?1:he,x=K.slice(he),he+=ee[1].length),F=!1,!K&&/^ *$/.test(j)&&(me+=j+`
`,Q=Q.substring(j.length+1),ke=!0),!ke)for(var st=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(Y=Q.split(`
`,1)[0],K=Y,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(K)||at.test(K)||st.test(K)||nt.test(Q)));){if(K.search(/[^ ]/)>=he||!K.trim())x+=`
`+K.slice(he);else if(!F)x+=`
`+K;else break;!F&&!K.trim()&&(F=!0),me+=Y+`
`,Q=Q.substring(Y.length+1)}Ke.loose||(H?Ke.loose=!0:/\n *\n *$/.test(me)&&(H=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(x),ve&&(Ae=ve[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:me,task:!!ve,checked:Ae,loose:!1,text:x}),Ke.raw+=me}Ke.items[Ke.items.length-1].raw=me.trimRight(),Ke.items[Ke.items.length-1].text=x.trimRight(),Ke.raw=Ke.raw.trimRight();var ct=Ke.items.length;for(Ee=0;Ee<ct;Ee++){this.lexer.state.top=!1,Ke.items[Ee].tokens=this.lexer.blockTokens(Ke.items[Ee].text,[]);var Ue=Ke.items[Ee].tokens.filter(function(X){return X.type==="space"}),vt=Ue.every(function(X){for(var _=X.raw.split(""),pe=0,Be=A(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&(pe+=1),pe>1)return!0}return!1});!Ke.loose&&Ue.length&&vt&&(Ke.loose=!0,Ke.items[Ee].loose=!0)}return Ke}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var me={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]);me.type="paragraph",me.text=ve,me.tokens=this.lexer.inline(ve)}return me}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var me=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var me={type:"table",header:L(ee[1]).map(function(H){return{text:H}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ee[0];var ve=me.align.length,Ae,he,Ee,F;for(Ae=0;Ae<ve;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(ve=me.rows.length,Ae=0;Ae<ve;Ae++)me.rows[Ae]=L(me.rows[Ae],me.header.length).map(function(H){return{text:H}});for(ve=me.header.length,he=0;he<ve;he++)me.header[he].tokens=this.lexer.inline(me.header[he].text);for(ve=me.rows.length,he=0;he<ve;he++)for(F=me.rows[he],Ee=0;Ee<F.length;Ee++)F[Ee].tokens=this.lexer.inline(F[Ee].text);return me}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var me=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:b(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var me=ee[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ve=v(me.slice(0,-1),"\\");if((me.length-ve.length)%2===0)return}else{var Ae=E(ee[2],"()");if(Ae>-1){var he=ee[0].indexOf("!")===0?5:4,Ee=he+ee[1].length+Ae;ee[2]=ee[2].substring(0,Ae),ee[0]=ee[0].substring(0,Ee).trim(),ee[3]=""}}var F=ee[2],H="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);K&&(F=K[1],H=K[3])}else H=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var ve=(me[2]||me[1]).replace(/\s+/g," ");if(ve=ee[ve.toLowerCase()],!ve||!ve.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(me,ve,me[0],this.lexer)}},ce.emStrong=function(Q,ee,me){me===void 0&&(me="");var ve=this.rules.inline.emStrong.lDelim.exec(Q);if(ve&&!(ve[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=ve[1]||ve[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var he=ve[0].length-1,Ee,F,H=he,K=0,j=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,ee=ee.slice(-1*Q.length+he);(ve=j.exec(ee))!=null;)if(Ee=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ee){if(F=Ee.length,ve[3]||ve[4]){H+=F;continue}else if((ve[5]||ve[6])&&he%3&&!((he+F)%3)){K+=F;continue}if(H-=F,!(H>0)){if(F=Math.min(F,F+H+K),Math.min(he,F)%2){var Y=Q.slice(1,he+ve.index+F);return{type:"em",raw:Q.slice(0,he+ve.index+F+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var x=Q.slice(2,he+ve.index+F-1);return{type:"strong",raw:Q.slice(0,he+ve.index+F+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var me=ee[2].replace(/\n/g," "),ve=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return ve&&Ae&&(me=me.substring(1,me.length-1)),me=b(me,!0),{type:"codespan",raw:ee[0],text:me}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var me=this.rules.inline.autolink.exec(Q);if(me){var ve,Ae;return me[2]==="@"?(ve=b(this.options.mangle?ee(me[1]):me[1]),Ae="mailto:"+ve):(ve=b(me[1]),Ae=ve),{type:"link",raw:me[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.url=function(Q,ee){var me;if(me=this.rules.inline.url.exec(Q)){var ve,Ae;if(me[2]==="@")ve=b(this.options.mangle?ee(me[0]):me[0]),Ae="mailto:"+ve;else{var he;do he=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(he!==me[0]);ve=b(me[0]),me[1]==="www."?Ae="http://"+ve:Ae=ve}return{type:"link",raw:me[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.inlineText=function(Q,ee){var me=this.rules.inline.text.exec(Q);if(me){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):b(me[0]):me[0]:ve=b(this.options.smartypants?ee(me[0]):me[0]),{type:"text",raw:me[0],text:ve}}},Ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=S({},z),z.gfm=S({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=S({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",z._label).getRegex(),C.nolink=n(C.nolink).replace("ref",z._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=S({},C),C.pedantic=S({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=S({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=S({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Ce){var ce="",te,Q,ee=Ce.length;for(te=0;te<ee;te++)Q=Ce.charCodeAt(te),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:z.normal,inline:C.normal};this.options.pedantic?(Q.block=z.pedantic,Q.inline=C.pedantic):this.options.gfm&&(Q.block=z.gfm,this.options.breaks?Q.inline=C.breaks:Q.inline=C.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var me=new Ce(ee);return me.lex(Q)},Ce.lexInline=function(Q,ee){var me=new Ce(ee);return me.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(H,K,j){return K+"    ".repeat(j.length)});for(var ve,Ae,he,Ee;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ve=H.call({lexer:me},Q,ee))?(Q=Q.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.space(Q)){Q=Q.substring(ve.raw.length),ve.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(ve);continue}if(ve=this.tokenizer.code(Q)){Q=Q.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve);continue}if(ve=this.tokenizer.fences(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.heading(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.hr(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.blockquote(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.list(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.html(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.def(Q)){Q=Q.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.lheading(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,K=Q.slice(1),j=void 0;me.options.extensions.startBlock.forEach(function(Y){j=Y.call({lexer:this},K),typeof j=="number"&&j>=0&&(H=Math.min(H,j))}),H<1/0&&H>=0&&(he=Q.substring(0,H+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(he))){Ae=ee[ee.length-1],Ee&&Ae.type==="paragraph"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve),Ee=he.length!==Q.length,Q=Q.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(Q)){Q=Q.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve);continue}if(Q){var F="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]);var ve,Ae,he,Ee=Q,F,H,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)j.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,F.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(H||(K=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(ve=x.call({lexer:me},Q,ee))?(Q=Q.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.tag(Q)){Q=Q.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.link(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.emStrong(Q,Ee,K)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.codespan(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.br(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.del(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.autolink(Q,W)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(Q,W))){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,ke=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(Ve){Te=Ve.call({lexer:this},ke),typeof Te=="number"&&Te>=0&&(x=Math.min(x,Te))}),x<1/0&&x>=0&&(he=Q.substring(0,x+1))}(),ve=this.tokenizer.inlineText(he,N)){Q=Q.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(K=ve.raw.slice(-1)),H=!0,Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(Q){var Y="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ee},y(Ce,null,[{key:"rules",get:function(){return{block:z,inline:C}}}]),Ce}(),de=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,me){var ve=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(Q,ve);Ae!=null&&Ae!==Q&&(me=!0,Q=Ae)}return Q=Q.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+b(ve,!0)+'">'+(me?Q:b(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:b(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,me,ve){if(this.options.headerIds){var Ae=this.options.headerPrefix+ve.slug(me);return"<h"+ee+' id="'+Ae+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,me){var ve=ee?"ol":"ul",Ae=ee&&me!==1?' start="'+me+'"':"";return"<"+ve+Ae+`>
`+Q+"</"+ve+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var me=ee.header?"th":"td",ve=ee.align?"<"+me+' align="'+ee.align+'">':"<"+me+">";return ve+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var ve='<a href="'+b(Q)+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=">"+me+"</a>",ve},ce.image=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var ve='<img src="'+Q+'" alt="'+me+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=this.options.xhtml?"/>":">",ve},ce.text=function(Q){return Q},Ce}(),we=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,me){return""+me},ce.image=function(Q,ee,me){return""+me},ce.br=function(){return""},Ce}(),ye=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var me=Q,ve=0;if(this.seen.hasOwnProperty(me)){ve=this.seen[Q];do ve++,me=Q+"-"+ve;while(this.seen.hasOwnProperty(me))}return ee||(this.seen[Q]=ve,this.seen[me]=0),me},ce.slug=function(Q,ee){ee===void 0&&(ee={});var me=this.serialize(Q);return this.getNextSafeSlug(me,ee.dryrun)},Ce}(),le=function(){function Ce(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ye}Ce.parse=function(Q,ee){var me=new Ce(ee);return me.parse(Q)},Ce.parseInline=function(Q,ee){var me=new Ce(ee);return me.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var me="",ve,Ae,he,Ee,F,H,K,j,Y,x,ke,Te,Ve,Ke,Xe,st,nt,tt,at,ct=Q.length;for(ve=0;ve<ct;ve++){if(x=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(at=this.options.extensions.renderers[x.type].call({parser:this},x),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){me+=at||"";continue}switch(x.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(x.tokens),x.depth,a(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(j="",K="",Ee=x.header.length,Ae=0;Ae<Ee;Ae++)K+=this.renderer.tablecell(this.parseInline(x.header[Ae].tokens),{header:!0,align:x.align[Ae]});for(j+=this.renderer.tablerow(K),Y="",Ee=x.rows.length,Ae=0;Ae<Ee;Ae++){for(H=x.rows[Ae],K="",F=H.length,he=0;he<F;he++)K+=this.renderer.tablecell(this.parseInline(H[he].tokens),{header:!1,align:x.align[he]});Y+=this.renderer.tablerow(K)}me+=this.renderer.table(j,Y);continue}case"blockquote":{Y=this.parse(x.tokens),me+=this.renderer.blockquote(Y);continue}case"list":{for(ke=x.ordered,Te=x.start,Ve=x.loose,Ee=x.items.length,Y="",Ae=0;Ae<Ee;Ae++)Xe=x.items[Ae],st=Xe.checked,nt=Xe.task,Ke="",Xe.task&&(tt=this.renderer.checkbox(st),Ve?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=tt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=tt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:tt}):Ke+=tt),Ke+=this.parse(Xe.tokens,Ve),Y+=this.renderer.listitem(Ke,nt,st);me+=this.renderer.list(Y,ke,Te);continue}case"html":{me+=this.renderer.html(x.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Y=x.tokens?this.parseInline(x.tokens):x.text;ve+1<ct&&Q[ve+1].type==="text";)x=Q[++ve],Y+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);me+=ee?this.renderer.paragraph(Y):Y;continue}default:{var Ue='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return me},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var me="",ve,Ae,he,Ee=Q.length;for(ve=0;ve<Ee;ve++){if(Ae=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(he=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=he||"";continue}switch(Ae.type){case"escape":{me+=ee.text(Ae.text);break}case"html":{me+=ee.html(Ae.text);break}case"link":{me+=ee.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ee));break}case"image":{me+=ee.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ee.strong(this.parseInline(Ae.tokens,ee));break}case"em":{me+=ee.em(this.parseInline(Ae.tokens,ee));break}case"codespan":{me+=ee.codespan(Ae.text);break}case"br":{me+=ee.br();break}case"del":{me+=ee.del(this.parseInline(Ae.tokens,ee));break}case"text":{me+=ee.text(Ae.text);break}default:{var F='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function $e(Ce,ce,te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=S({},$e.defaults,ce||{}),D(ce),te){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(Ee){return te(Ee)}var me=function(F){var H;if(!F)try{ce.walkTokens&&$e.walkTokens(ee,ce.walkTokens),H=le.parse(ee,ce)}catch(K){F=K}return ce.highlight=Q,F?te(F):te(null,H)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return me();var ve=0;$e.walkTokens(ee,function(Ee){Ee.type==="code"&&(ve++,setTimeout(function(){Q(Ee.text,Ee.lang,function(F,H){if(F)return me(F);H!=null&&H!==Ee.text&&(Ee.text=H,Ee.escaped=!0),ve--,ve===0&&me()})},0))}),ve===0&&me();return}function Ae(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Ee.message+"",!0)+"</pre>";throw Ee}try{var he=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all($e.walkTokens(he,ce.walkTokens)).then(function(){return le.parse(he,ce)}).catch(Ae);$e.walkTokens(he,ce.walkTokens)}return le.parse(he,ce)}catch(Ee){Ae(Ee)}}$e.options=$e.setOptions=function(Ce){return S($e.defaults,Ce),m($e.defaults),$e},$e.getDefaults=P,$e.defaults=ge.defaults,$e.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),te=0;te<Ce;te++)ce[te]=arguments[te];var Q=S.apply(void 0,[{}].concat(ce)),ee=$e.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(ve){if(ve.extensions&&(me=!0,ve.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ee=ee.renderers?ee.renderers[he.name]:null;Ee?ee.renderers[he.name]=function(){for(var F=arguments.length,H=new Array(F),K=0;K<F;K++)H[K]=arguments[K];var j=he.renderer.apply(this,H);return j===!1&&(j=Ee.apply(this,H)),j}:ee.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[he.level]?ee[he.level].unshift(he.tokenizer):ee[he.level]=[he.tokenizer],he.start&&(he.level==="block"?ee.startBlock?ee.startBlock.push(he.start):ee.startBlock=[he.start]:he.level==="inline"&&(ee.startInline?ee.startInline.push(he.start):ee.startInline=[he.start]))}he.childTokens&&(ee.childTokens[he.name]=he.childTokens)})),ve.renderer&&function(){var he=$e.defaults.renderer||new de,Ee=function(K){var j=he[K];he[K]=function(){for(var Y=arguments.length,x=new Array(Y),ke=0;ke<Y;ke++)x[ke]=arguments[ke];var Te=ve.renderer[K].apply(he,x);return Te===!1&&(Te=j.apply(he,x)),Te}};for(var F in ve.renderer)Ee(F);Q.renderer=he}(),ve.tokenizer&&function(){var he=$e.defaults.tokenizer||new q,Ee=function(K){var j=he[K];he[K]=function(){for(var Y=arguments.length,x=new Array(Y),ke=0;ke<Y;ke++)x[ke]=arguments[ke];var Te=ve.tokenizer[K].apply(he,x);return Te===!1&&(Te=j.apply(he,x)),Te}};for(var F in ve.tokenizer)Ee(F);Q.tokenizer=he}(),ve.walkTokens){var Ae=$e.defaults.walkTokens;Q.walkTokens=function(he){var Ee=[];return Ee.push(ve.walkTokens.call(this,he)),Ae&&(Ee=Ee.concat(Ae.call(this,he))),Ee}}me&&(Q.extensions=ee),$e.setOptions(Q)})},$e.walkTokens=function(Ce,ce){for(var te=[],Q=function(){var Ae=me.value;switch(te=te.concat(ce.call($e,Ae)),Ae.type){case"table":{for(var he=A(Ae.header),Ee;!(Ee=he()).done;){var F=Ee.value;te=te.concat($e.walkTokens(F.tokens,ce))}for(var H=A(Ae.rows),K;!(K=H()).done;)for(var j=K.value,Y=A(j),x;!(x=Y()).done;){var ke=x.value;te=te.concat($e.walkTokens(ke.tokens,ce))}break}case"list":{te=te.concat($e.walkTokens(Ae.items,ce));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ae.type]?$e.defaults.extensions.childTokens[Ae.type].forEach(function(Te){te=te.concat($e.walkTokens(Ae[Te],ce))}):Ae.tokens&&(te=te.concat($e.walkTokens(Ae.tokens,ce)))}},ee=A(Ce),me;!(me=ee()).done;)Q();return te},$e.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},$e.defaults,ce||{}),D(ce);try{var te=ae.lexInline(Ce,ce);return ce.walkTokens&&$e.walkTokens(te,ce.walkTokens),le.parseInline(te,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=le,$e.parser=le.parse,$e.Renderer=de,$e.TextRenderer=we,$e.Lexer=ae,$e.lexer=ae.lex,$e.Tokenizer=q,$e.Slugger=ye,$e.parse=$e;var ie=$e.options,be=$e.setOptions,se=$e.use,Z=$e.walkTokens,V=$e.parseInline,ne=$e,Ie=le.parse,Le=ae.lex;ge.Lexer=ae,ge.Parser=le,ge.Renderer=de,ge.Slugger=ye,ge.TextRenderer=we,ge.Tokenizer=q,ge.getDefaults=P,ge.lexer=Le,ge.marked=$e,ge.options=ie,ge.parse=ne,ge.parseInline=V,ge.parser=Ie,ge.setOptions=be,ge.use=se,ge.walkTokens=Z,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function y(r){const a=A(r);if(a&&a.length>0)return new Uint32Array(a)}e.$Rj=y;let M=0;const I=new Uint32Array(10);function A(r){if(M=0,P(r,k,4352),M>0||(P(r,l,4449),M>0)||(P(r,p,4520),M>0)||(P(r,b,12593),M))return I.subarray(0,M);if(r>=44032&&r<=55203){const a=r-44032,s=a%588,n=Math.floor(a/588),o=Math.floor(s/28),c=s%28-1;if(n<k.length?P(n,k,0):4352+n-12593<b.length&&P(4352+n,b,12593),o<l.length?P(o,l,0):4449+o-12593<b.length&&P(4449+o-12593,b,12593),c>=0&&(c<p.length?P(c,p,0):4520+c-12593<b.length&&P(4520+c-12593,b,12593)),M>0)return I.subarray(0,M)}}function P(r,a,s){r>=s&&r<s+a.length&&m(a[r-s])}function m(r){r!==0&&(I[M++]=r&255,r>>8&&(I[M++]=r>>8&255),r>>16&&(I[M++]=r>>16&255))}var f;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var R;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(R||(R={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),b=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function y(m,f,w){return Math.min(Math.max(m,f),w)}e.$7l=y;function M(m,f){return(f+m%f)%f}e.rot=M;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=I;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=A;class P{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const w=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=P}),function(){function ge(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function P(f){A.push(f,Date.now())}function m(){const f=[];for(let w=0;w<A.length;w+=2)f.push({name:A[w],startTime:A[w+1]});return f}return{mark:P,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(I+P.startTime)});return A}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function y(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:ge)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function y(M){if(e[M])return e[M].exports;var I=e[M]={i:M,l:!1,exports:{}};return ge[M].call(I.exports,I,I.exports,y),I.l=!0,I.exports}return y.m=ge,y.c=e,y.d=function(M,I,A){y.o(M,I)||Object.defineProperty(M,I,{enumerable:!0,get:A})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,I){if(1&I&&(M=y(M)),8&I||4&I&&typeof M=="object"&&M&&M.__esModule)return M;var A=Object.create(null);if(y.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:M}),2&I&&typeof M!="string")for(var P in M)y.d(A,P,function(m){return M[m]}.bind(null,P));return A},y.n=function(M){var I=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(I,"a",I),I},y.o=function(M,I){return Object.prototype.hasOwnProperty.call(M,I)},y.p="",y(y.s=0)}([function(ge,e,y){(function(M){var I;e=ge.exports=se,I=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],w=0,R=w++;f[R]="0|[1-9]\\d*";var k=w++;f[k]="[0-9]+";var l=w++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;f[p]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var b=w++;f[b]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var r=w++;f[r]="(?:"+f[R]+"|"+f[l]+")";var a=w++;f[a]="(?:"+f[k]+"|"+f[l]+")";var s=w++;f[s]="(?:-("+f[r]+"(?:\\."+f[r]+")*))";var n=w++;f[n]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var o=w++;f[o]="[0-9A-Za-z-]+";var c=w++;f[c]="(?:\\+("+f[o]+"(?:\\."+f[o]+")*))";var h=w++,t="v?"+f[p]+f[s]+"?"+f[c]+"?";f[h]="^"+t+"$";var u="[v=\\s]*"+f[b]+f[n]+"?"+f[c]+"?",i=w++;f[i]="^"+u+"$";var g=w++;f[g]="((?:<|>)?=?)";var $=w++;f[$]=f[k]+"|x|X|\\*";var d=w++;f[d]=f[R]+"|x|X|\\*";var S=w++;f[S]="[v=\\s]*("+f[d]+")(?:\\.("+f[d]+")(?:\\.("+f[d]+")(?:"+f[s]+")?"+f[c]+"?)?)?";var L=w++;f[L]="[v=\\s]*("+f[$]+")(?:\\.("+f[$]+")(?:\\.("+f[$]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var v=w++;f[v]="^"+f[g]+"\\s*"+f[S]+"$";var E=w++;f[E]="^"+f[g]+"\\s*"+f[L]+"$";var D=w++;f[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=w++;f[T]="(?:~>?)";var O=w++;f[O]="(\\s*)"+f[T]+"\\s+",m[O]=new RegExp(f[O],"g");var G=w++;f[G]="^"+f[T]+f[S]+"$";var q=w++;f[q]="^"+f[T]+f[L]+"$";var z=w++;f[z]="(?:\\^)";var C=w++;f[C]="(\\s*)"+f[z]+"\\s+",m[C]=new RegExp(f[C],"g");var N=w++;f[N]="^"+f[z]+f[S]+"$";var W=w++;f[W]="^"+f[z]+f[L]+"$";var ae=w++;f[ae]="^"+f[g]+"\\s*("+u+")$|^$";var de=w++;f[de]="^"+f[g]+"\\s*("+t+")$|^$";var we=w++;f[we]="(\\s*)"+f[g]+"\\s*("+u+"|"+f[S]+")",m[we]=new RegExp(f[we],"g");var ye=w++;f[ye]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var le=w++;f[le]="^\\s*("+f[L]+")\\s+-\\s+("+f[L]+")\\s*$";var $e=w++;f[$e]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)I(ie,f[ie]),m[ie]||(m[ie]=new RegExp(f[ie]));function be(j,Y){if(j instanceof se)return j;if(typeof j!="string"||j.length>A||!(Y?m[i]:m[h]).test(j))return null;try{return new se(j,Y)}catch{return null}}function se(j,Y){if(j instanceof se){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(j,Y);I("SemVer",j,Y),this.loose=Y;var x=j.trim().match(Y?m[i]:m[h]);if(!x)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Te=+ke;if(Te>=0&&Te<P)return Te}return ke}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=be,e.valid=function(j,Y){var x=be(j,Y);return x?x.version:null},e.clean=function(j,Y){var x=be(j.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof se||(j=new se(j,this.loose)),this.compareMain(j)||this.comparePre(j)},se.prototype.compareMain=function(j){return j instanceof se||(j=new se(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},se.prototype.comparePre=function(j){if(j instanceof se||(j=new se(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],ke=j.prerelease[Y];if(I("prerelease compare",Y,x,ke),x===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(x===void 0)return-1;if(x!==ke)return V(x,ke)}while(++Y)},se.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,x,ke){typeof x=="string"&&(ke=x,x=void 0);try{return new se(j,x).inc(Y,ke).version}catch{return null}},e.diff=function(j,Y){if(Ce(j,Y))return null;var x=be(j),ke=be(Y);if(x.prerelease.length||ke.prerelease.length){for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==ke[Te])return"pre"+Te;return"prerelease"}for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==ke[Te])return Te},e.compareIdentifiers=V;var Z=/^[0-9]+$/;function V(j,Y){var x=Z.test(j),ke=Z.test(Y);return x&&ke&&(j=+j,Y=+Y),x&&!ke?-1:ke&&!x?1:j<Y?-1:j>Y?1:0}function ne(j,Y,x){return new se(j,x).compare(new se(Y,x))}function Ie(j,Y,x){return ne(j,Y,x)>0}function Le(j,Y,x){return ne(j,Y,x)<0}function Ce(j,Y,x){return ne(j,Y,x)===0}function ce(j,Y,x){return ne(j,Y,x)!==0}function te(j,Y,x){return ne(j,Y,x)>=0}function Q(j,Y,x){return ne(j,Y,x)<=0}function ee(j,Y,x,ke){var Te;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof x=="object"&&(x=x.version),Te=j===x;break;case"!==":typeof j=="object"&&(j=j.version),typeof x=="object"&&(x=x.version),Te=j!==x;break;case"":case"=":case"==":Te=Ce(j,x,ke);break;case"!=":Te=ce(j,x,ke);break;case">":Te=Ie(j,x,ke);break;case">=":Te=te(j,x,ke);break;case"<":Te=Le(j,x,ke);break;case"<=":Te=Q(j,x,ke);break;default:throw new TypeError("Invalid operator: "+Y)}return Te}function me(j,Y){if(j instanceof me){if(j.loose===Y)return j;j=j.value}if(!(this instanceof me))return new me(j,Y);I("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,Y){return V(Y,j)},e.major=function(j,Y){return new se(j,Y).major},e.minor=function(j,Y){return new se(j,Y).minor},e.patch=function(j,Y){return new se(j,Y).patch},e.compare=ne,e.compareLoose=function(j,Y){return ne(j,Y,!0)},e.rcompare=function(j,Y,x){return ne(Y,j,x)},e.sort=function(j,Y){return j.sort(function(x,ke){return e.compare(x,ke,Y)})},e.rsort=function(j,Y){return j.sort(function(x,ke){return e.rcompare(x,ke,Y)})},e.gt=Ie,e.lt=Le,e.eq=Ce,e.neq=ce,e.gte=te,e.lte=Q,e.cmp=ee,e.Comparator=me;var ve={};function Ae(j,Y){if(j instanceof Ae)return j.loose===Y?j:new Ae(j.raw,Y);if(j instanceof me)return new Ae(j.value,Y);if(!(this instanceof Ae))return new Ae(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function he(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ee(j,Y,x,ke,Te,Ve,Ke,Xe,st,nt,tt,at,ct){return((Y=he(x)?"":he(ke)?">="+x+".0.0":he(Te)?">="+x+"."+ke+".0":">="+Y)+" "+(Xe=he(st)?"":he(nt)?"<"+(+st+1)+".0.0":he(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Xe)).trim()}function F(j,Y){for(var x=0;x<j.length;x++)if(!j[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<j.length;x++)if(I(j[x].semver),j[x].semver!==ve&&j[x].semver.prerelease.length>0){var ke=j[x].semver;if(ke.major===Y.major&&ke.minor===Y.minor&&ke.patch===Y.patch)return!0}return!1}return!0}function H(j,Y,x){try{Y=new Ae(Y,x)}catch{return!1}return Y.test(j)}function K(j,Y,x,ke){var Te,Ve,Ke,Xe,st;switch(j=new se(j,ke),Y=new Ae(Y,ke),x){case">":Te=Ie,Ve=Q,Ke=Le,Xe=">",st=">=";break;case"<":Te=Le,Ve=te,Ke=Ie,Xe="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(j,Y,ke))return!1;for(var nt=0;nt<Y.set.length;++nt){var tt=Y.set[nt],at=null,ct=null;if(tt.forEach(function(Ue){Ue.semver===ve&&(Ue=new me(">=0.0.0")),at=at||Ue,ct=ct||Ue,Te(Ue.semver,at.semver,ke)?at=Ue:Ke(Ue.semver,ct.semver,ke)&&(ct=Ue)}),at.operator===Xe||at.operator===st||(!ct.operator||ct.operator===Xe)&&Ve(j,ct.semver)||ct.operator===st&&Ke(j,ct.semver))return!1}return!0}me.prototype.parse=function(j){var Y=this.loose?m[ae]:m[de],x=j.match(Y);if(!x)throw new TypeError("Invalid comparator: "+j);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new se(x[2],this.loose):this.semver=ve},me.prototype.toString=function(){return this.value},me.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===ve||(typeof j=="string"&&(j=new se(j,this.loose)),ee(j,this.operator,this.semver,this.loose))},me.prototype.intersects=function(j,Y){if(!(j instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Ae(j.value,Y),H(this.value,x,Y);if(j.operator==="")return x=new Ae(this.value,Y),H(j.semver,x,Y);var ke=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ve=this.semver.version===j.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Xe=ee(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),st=ee(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ke||Te||Ve&&Ke||Xe||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),I("range",j,Y);var x=Y?m[le]:m[ye];j=j.replace(x,Ee),I("hyphen replace",j),j=j.replace(m[we],"$1$2$3"),I("comparator trim",j,m[we]),j=(j=(j=j.replace(m[O],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ke=Y?m[ae]:m[de],Te=j.split(" ").map(function(Ve){return function(Ke,Xe){return I("comp",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){I("caret",at,ct);var Ue=ct?m[W]:m[N];return at.replace(Ue,function(vt,X,_,pe,Be){var Qe;return I("caret",at,vt,X,_,pe,Be),he(X)?Qe="":he(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":he(pe)?Qe=X==="0"?">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":">="+X+"."+_+".0 <"+(+X+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+Be+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+Be+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+Be+" <"+(+X+1)+".0.0"):(I("no pr"),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+" <"+(+X+1)+".0.0"),I("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Xe),I("caret",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var Ue=ct?m[q]:m[G];return at.replace(Ue,function(vt,X,_,pe,Be){var Qe;return I("tilde",at,vt,X,_,pe,Be),he(X)?Qe="":he(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":he(pe)?Qe=">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+X+"."+_+"."+pe+Be+" <"+X+"."+(+_+1)+".0"):Qe=">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0",I("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Xe),I("tildes",Ke),Ke=function(st,nt){return I("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var Ue=ct?m[E]:m[v];return at.replace(Ue,function(vt,X,_,pe,Be,Qe){I("xRange",at,vt,X,_,pe,Be,Qe);var it=he(_),rt=it||he(pe),Ne=rt||he(Be);return X==="="&&Ne&&(X=""),it?vt=X===">"||X==="<"?"<0.0.0":"*":X&&Ne?(rt&&(pe=0),Ne&&(Be=0),X===">"?(X=">=",rt?(_=+_+1,pe=0,Be=0):Ne&&(pe=+pe+1,Be=0)):X==="<="&&(X="<",rt?_=+_+1:pe=+pe+1),vt=X+_+"."+pe+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+pe+".0 <"+_+"."+(+pe+1)+".0"),I("xRange return",vt),vt})}(tt,nt)}).join(" ")}(Ke,Xe),I("xrange",Ke),Ke=function(st,nt){return I("replaceStars",st,nt),st.trim().replace(m[$e],"")}(Ke,Xe),I("stars",Ke),Ke}(Ve,Y)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Ve){return!!Ve.match(ke)})),Te=Te.map(function(Ve){return new me(Ve,Y)})},Ae.prototype.intersects=function(j,Y){if(!(j instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(ke){return j.set.some(function(Te){return Te.every(function(Ve){return ke.intersects(Ve,Y)})})})})},e.toComparators=function(j,Y){return new Ae(j,Y).set.map(function(x){return x.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new se(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(F(this.set[Y],j))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(j,Y,x){var ke=null,Te=null;try{var Ve=new Ae(Y,x)}catch{return null}return j.forEach(function(Ke){Ve.test(Ke)&&(ke&&Te.compare(Ke)!==-1||(Te=new se(ke=Ke,x)))}),ke},e.minSatisfying=function(j,Y,x){var ke=null,Te=null;try{var Ve=new Ae(Y,x)}catch{return null}return j.forEach(function(Ke){Ve.test(Ke)&&(ke&&Te.compare(Ke)!==1||(Te=new se(ke=Ke,x)))}),ke},e.validRange=function(j,Y){try{return new Ae(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,x){return K(j,Y,"<",x)},e.gtr=function(j,Y,x){return K(j,Y,">",x)},e.outside=K,e.prerelease=function(j,Y){var x=be(j,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(j,Y,x){return j=new Ae(j,x),Y=new Ae(Y,x),j.intersects(Y)},e.coerce=function(j){if(j instanceof se)return j;if(typeof j!="string")return null;var Y=j.match(m[D]);return Y==null?null:be((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,y(1))},function(ge,e){var y,M,I=ge.exports={};function A(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function m(a){if(y===setTimeout)return setTimeout(a,0);if((y===A||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:A}catch{y=A}try{M=typeof clearTimeout=="function"?clearTimeout:P}catch{M=P}})();var f,w=[],R=!1,k=-1;function l(){R&&f&&(R=!1,f.length?w=f.concat(w):k=-1,w.length&&p())}function p(){if(!R){var a=m(l);R=!0;for(var s=w.length;s;){for(f=w,w=[];++k<s;)f&&f[k].run();k=-1,s=w.length}f=null,R=!1,function(n){if(M===clearTimeout)return clearTimeout(n);if((M===P||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(n);try{M(n)}catch{try{return M.call(null,n)}catch{return M.call(this,n)}}}(a)}}function b(a,s){this.fun=a,this.array=s}function r(){}I.nextTick=function(a){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];w.push(new b(a,s)),w.length!==1||R||m(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(a){return[]},I.binding=function(a){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(a){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$7d=I;function A(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$8d=A;function P(c){const h=c;return h?A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$9d=P;function m(c,h){return new f(c,h)}e.$0d=m;class f{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,y.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let u;switch(h){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const i=u.indexOf(t);i>=0&&u.splice(i,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const t=[];let u;for(;(u=c.read())!==null;)t.push(u);return h(t)}e.$$d=w;function R(c,h,t){const u=[];let i;for(;(i=c.read())!==null&&u.length<t;)u.push(i);return i===null&&u.length>0?h(u):{read:()=>{if(u.length>0)return u.shift();if(typeof i<"u"){const g=i;return i=void 0,g}return c.read()}}}e.$_d=R;function k(c,h){return new Promise((t,u)=>{const i=[];l(c,{onData:g=>{h&&i.push(g)},onError:g=>{h?u(g):t(void 0)},onEnd:()=>{t(h?h(i):void 0)}})})}e.$ae=k;function l(c,h,t){c.on("error",u=>{t?.isCancellationRequested||h.onError(u)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",u=>{t?.isCancellationRequested||h.onData(u)})}e.$be=l;function p(c,h){return new Promise((t,u)=>{const i=new M.$Sc,g=[],$=L=>{if(g.push(L),g.length>h)return i.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},d=L=>(i.dispose(),u(L)),S=()=>(i.dispose(),t({stream:c,buffer:g,ended:!0}));i.add((0,M.$Rc)(()=>c.removeListener("error",d))),c.on("error",d),i.add((0,M.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),i.add((0,M.$Rc)(()=>c.removeListener("data",$))),c.on("data",$)})}e.$ce=p;function b(c,h){const t=m(h);return t.end(c),t}e.$de=b;function r(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$ee=r;function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$fe=a;function s(c,h,t){const u=m(t);return l(c,{onData:i=>u.write(h.data(i)),onError:i=>u.error(h.error?h.error(i):i),onEnd:()=>u.end()}),u}e.$ge=s;function n(c,h,t){let u=!1;return{read:()=>{const i=h.read();return u?i:(u=!0,i!==null?t([c,i]):c)}}}e.$he=n;function o(c,h,t){let u=!1;const i=m(t);return l(h,{onData:g=>u?i.write(g):(u=!0,i.write(t([c,g]))),onError:g=>i.error(g),onEnd:()=>{u||(u=!0,i.write(c)),i.end()}}),i}e.$ie=o}),define(Pe[22],Re([1,0,39,123]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const I=typeof Buffer<"u",A=new y.$V(()=>new Uint8Array(256));let P,m;class f{static alloc(D){return I?new f(Buffer.allocUnsafe(D)):new f(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new f(D)}static fromString(D,T){return!(T?.dontUseNodeBuffer||!1)&&I?new f(Buffer.from(D)):(P||(P=new TextEncoder),new f(P.encode(D)))}static fromByteArray(D){const T=f.alloc(D.length);for(let O=0,G=D.length;O<G;O++)T.buffer[O]=D[O];return T}static concat(D,T){if(typeof T>"u"){T=0;for(let q=0,z=D.length;q<z;q++)T+=D[q].byteLength}const O=f.alloc(T);let G=0;for(let q=0,z=D.length;q<z;q++){const C=D[q];O.set(C,G),G+=C.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=f.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(D,T){return new f(this.buffer.subarray(D,T))}set(D,T){if(D instanceof f)this.buffer.set(D.buffer,T);else if(D instanceof Uint8Array)this.buffer.set(D,T);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),T);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,T){p(this.buffer,D,T)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,T){r(this.buffer,D,T)}readUInt8(D){return a(this.buffer,D)}writeUInt8(D,T){s(this.buffer,D,T)}indexOf(D,T=0){return w(this.buffer,D instanceof f?D.buffer:D,T)}}e.$je=f;function w(E,D,T=0){const O=D.byteLength,G=E.byteLength;if(O===0)return 0;if(O===1)return E.indexOf(D[0]);if(O>G-T)return-1;const q=A.value;q.fill(D.length);for(let W=0;W<D.length;W++)q[D[W]]=D.length-W-1;let z=T+D.length-1,C=z,N=-1;for(;z<G;)if(E[z]===D[C]){if(C===0){N=z;break}z--,C--}else z+=Math.max(D.length-C,q[E[z]]),C=D.length-1;return N}e.$ke=w;function R(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}e.$le=R;function k(E,D,T){E[T+0]=D&255,D=D>>>8,E[T+1]=D&255}e.$me=k;function l(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}e.$ne=l;function p(E,D,T){E[T+3]=D,D=D>>>8,E[T+2]=D,D=D>>>8,E[T+1]=D,D=D>>>8,E[T]=D}e.$oe=p;function b(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}e.$pe=b;function r(E,D,T){E[T+0]=D&255,D=D>>>8,E[T+1]=D&255,D=D>>>8,E[T+2]=D&255,D=D>>>8,E[T+3]=D&255}e.$qe=r;function a(E,D){return E[D]}e.$re=a;function s(E,D,T){E[T]=D}e.$se=s;function n(E){return M.$$d(E,D=>f.concat(D))}e.$te=n;function o(E){return M.$fe(E)}e.$ue=o;function c(E){return M.$ae(E,D=>f.concat(D))}e.$ve=c;async function h(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await c(E.stream)])}e.$we=h;function t(E){return M.$de(E,D=>f.concat(D))}e.$xe=t;function u(E){return M.$ge(E,{data:D=>typeof D=="string"?f.fromString(D):f.wrap(D)},D=>f.concat(D))}e.$ye=u;function i(E){return M.$0d(D=>f.concat(D),E)}e.$ze=i;function g(E,D){return M.$he(E,D,T=>f.concat(T))}e.$Ae=g;function $(E,D){return M.$ie(E,D,T=>f.concat(T))}e.$Be=$;function d(E){let D=0,T=0,O=0;const G=new Uint8Array(Math.floor(E.length/4*3)),q=C=>{switch(T){case 3:G[O++]=D|C,T=0;break;case 2:G[O++]=D|C>>>2,D=C<<6,T=3;break;case 1:G[O++]=D|C>>>4,D=C<<4,T=2;break;default:D=C<<2,T=1}};for(let C=0;C<E.length;C++){const N=E.charCodeAt(C);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${E[C]}`)}}const z=O;for(;T>0;)q(0);return f.wrap(G).slice(0,z)}e.$Ce=d;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:E},D=!0,T=!1){const O=T?L:S;let G="";const q=E.byteLength%3;let z=0;for(;z<E.byteLength-q;z+=3){const C=E[z+0],N=E[z+1],W=E[z+2];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[(N<<2|W>>>6)&63],G+=O[W&63]}if(q===1){const C=E[z+0];G+=O[C>>>2],G+=O[C<<4&63],D&&(G+="==")}else if(q===2){const C=E[z+0],N=E[z+1];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[N<<2&63],D&&(G+="=")}return G}e.$De=v}),define(Pe[124],Re([1,0,28,121,12]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function A(...he){return function(Ee,F){for(let H=0,K=he.length;H<K;H++){const j=he[H](Ee,F);if(j)return j}return null}}e.or=A,e.$Tj=P.bind(void 0,!1),e.$Uj=P.bind(void 0,!0);function P(he,Ee,F){if(!F||F.length<Ee.length)return null;let H;return he?H=I.$af(F,Ee):H=F.indexOf(Ee)===0,H?Ee.length>0?[{start:0,end:Ee.length}]:[]:null}function m(he,Ee){const F=Ee.toLowerCase().indexOf(he.toLowerCase());return F===-1?null:[{start:F,end:F+he.length}]}e.$Vj=m;function f(he,Ee){return w(he.toLowerCase(),Ee.toLowerCase(),0,0)}e.$Wj=f;function w(he,Ee,F,H){if(F===he.length)return[];if(H===Ee.length)return null;if(he[F]===Ee[H]){let K=null;return(K=w(he,Ee,F+1,H+1))?c({start:H,end:H+1},K):null}return w(he,Ee,F,H+1)}function R(he){return 97<=he&&he<=122}function k(he){return 65<=he&&he<=90}e.$Xj=k;function l(he){return 48<=he&&he<=57}function p(he){return he===32||he===9||he===10||he===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>b.add(he.charCodeAt(0)));function r(he){return p(he)||b.has(he)}function a(he,Ee){return he===Ee||r(he)&&r(Ee)}const s=new Map;function n(he){if(s.has(he))return s.get(he);let Ee;const F=(0,M.$Rj)(he);return F&&(Ee=F),s.set(he,Ee),Ee}function o(he){return R(he)||k(he)||l(he)}function c(he,Ee){return Ee.length===0?Ee=[he]:he.end===Ee[0].start?Ee[0].start=he.start:Ee.unshift(he),Ee}function h(he,Ee){for(let F=Ee;F<he.length;F++){const H=he.charCodeAt(F);if(k(H)||l(H)||F>0&&!o(he.charCodeAt(F-1)))return F}return he.length}function t(he,Ee,F,H){if(F===he.length)return[];if(H===Ee.length)return null;if(he[F]!==Ee[H].toLowerCase())return null;{let K=null,j=H+1;for(K=t(he,Ee,F+1,H+1);!K&&(j=h(Ee,j))<Ee.length;)K=t(he,Ee,F+1,j),j++;return K===null?null:c({start:H,end:H+1},K)}}function u(he){let Ee=0,F=0,H=0,K=0,j=0;for(let Ve=0;Ve<he.length;Ve++)j=he.charCodeAt(Ve),k(j)&&Ee++,R(j)&&F++,o(j)&&H++,l(j)&&K++;const Y=Ee/he.length,x=F/he.length,ke=H/he.length,Te=K/he.length;return{upperPercent:Y,lowerPercent:x,alphaPercent:ke,numericPercent:Te}}function i(he){const{upperPercent:Ee,lowerPercent:F}=he;return F===0&&Ee>.6}function g(he){const{upperPercent:Ee,lowerPercent:F,alphaPercent:H,numericPercent:K}=he;return F>.2&&Ee<.8&&H>.6&&K<.2}function $(he){let Ee=0,F=0,H=0,K=0;for(let j=0;j<he.length;j++)H=he.charCodeAt(j),k(H)&&Ee++,R(H)&&F++,p(H)&&K++;return(Ee===0||F===0)&&K===0?he.length<=30:Ee<=5}function d(he,Ee){if(!Ee||(Ee=Ee.trim(),Ee.length===0)||!$(he)||Ee.length>60)return null;const F=u(Ee);if(!g(F)){if(!i(F))return null;Ee=Ee.toLowerCase()}let H=null,K=0;for(he=he.toLowerCase();K<Ee.length&&(H=t(he,Ee,0,K))===null;)K=h(Ee,K+1);return H}e.$Yj=d;function S(he,Ee,F=!1){if(!Ee||Ee.length===0)return null;let H=null,K=0;for(he=he.toLowerCase(),Ee=Ee.toLowerCase();K<Ee.length&&(H=L(he,Ee,0,K,F),H===null);)K=v(Ee,K+1);return H}e.$Zj=S;function L(he,Ee,F,H,K){let j=0;if(F===he.length)return[];if(H===Ee.length)return null;if(!a(he.charCodeAt(F),Ee.charCodeAt(H))){const ke=n(he.charCodeAt(F));if(!ke)return null;for(let Te=0;Te<ke.length;Te++)if(!a(ke[Te],Ee.charCodeAt(H+Te)))return null;j+=ke.length-1}let Y=null,x=H+j+1;if(Y=L(he,Ee,F+1,x,K),!K)for(;!Y&&(x=v(Ee,x))<Ee.length;)Y=L(he,Ee,F+1,x,K),x++;if(!Y)return null;if(he.charCodeAt(F)!==Ee.charCodeAt(H)){const ke=n(he.charCodeAt(F));if(!ke)return Y;for(let Te=0;Te<ke.length;Te++)if(ke[Te]!==Ee.charCodeAt(H+Te))return Y}return c({start:H,end:H+j+1},Y)}function v(he,Ee){for(let F=Ee;F<he.length;F++)if(r(he.charCodeAt(F))||F>0&&r(he.charCodeAt(F-1)))return F;return he.length}const E=A(e.$Uj,d,m),D=A(e.$Uj,d,f),T=new y.$Dc(1e4);function O(he,Ee,F=!1){if(typeof he!="string"||typeof Ee!="string")return null;let H=T.get(he);H||(H=new RegExp(I.$Ve(he),"i"),T.set(he,H));const K=H.exec(Ee);return K?[{start:K.index,end:K.index+K[0].length}]:F?D(he,Ee):E(he,Ee)}e.$1j=O;function G(he,Ee){const F=ce(he,he.toLowerCase(),0,Ee,Ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?z(F):null}e.$2j=G;function q(he,Ee,F,H,K,j){const Y=Math.min(13,he.length);for(;F<Y;F++){const x=ce(he,Ee,F,H,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,j]}e.$3j=q;function z(he){if(typeof he>"u")return[];const Ee=[],F=he[1];for(let H=he.length-1;H>1;H--){const K=he[H]+F,j=Ee[Ee.length-1];j&&j.end===K?j.end=K+1:Ee.push({start:K,end:K+1})}return Ee}e.$4j=z;const C=128;function N(){const he=[],Ee=[];for(let F=0;F<=C;F++)Ee[F]=0;for(let F=0;F<=C;F++)he.push(Ee.slice(0));return he}function W(he){const Ee=[];for(let F=0;F<=he;F++)Ee[F]=0;return Ee}const ae=W(2*C),de=W(2*C),we=N(),ye=N(),le=N(),$e=!1;function ie(he,Ee,F,H,K){function j(x,ke,Te=" "){for(;x.length<ke;)x=Te+x;return x}let Y=` |   |${H.split("").map(x=>j(x,3)).join("|")}
`;for(let x=0;x<=F;x++)x===0?Y+=" |":Y+=`${Ee[x-1]}|`,Y+=he[x].slice(0,K+1).map(ke=>j(ke.toString(),3)).join("|")+`
`;return Y}function be(he,Ee,F,H){he=he.substr(Ee),F=F.substr(H),console.log(ie(ye,he,he.length,F,F.length)),console.log(ie(le,he,he.length,F,F.length)),console.log(ie(we,he,he.length,F,F.length))}function se(he,Ee){if(Ee<0||Ee>=he.length)return!1;const F=he.codePointAt(Ee);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$sf(F)}}function Z(he,Ee){if(Ee<0||Ee>=he.length)return!1;switch(he.charCodeAt(Ee)){case 32:case 9:return!0;default:return!1}}function V(he,Ee,F){return Ee[he]!==F[he]}function ne(he,Ee,F,H,K,j,Y=!1){for(;Ee<F&&K<j;)he[Ee]===H[K]&&(Y&&(ae[Ee]=K),Ee+=1),K+=1;return Ee===F}e.$5j=ne;var Ie;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(he){he.Default=[-100,0];function Ee(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}he.isDefault=Ee})(Le||(e.FuzzyScore=Le={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ee,F){this.firstMatchCanBeWeak=Ee,this.boostFullMatch=F}}e.$6j=Ce;function ce(he,Ee,F,H,K,j,Y=Ce.default){const x=he.length>C?C:he.length,ke=H.length>C?C:H.length;if(F>=x||j>=ke||x-F>ke-j||!ne(Ee,F,x,K,j,ke,!0))return;te(x,ke,F,j,Ee,K);let Te=1,Ve=1,Ke=F,Xe=j;const st=[!1];for(Te=1,Ke=F;Ke<x;Te++,Ke++){const Ue=ae[Ke],vt=de[Ke],X=Ke+1<x?de[Ke+1]:ke;for(Ve=Ue-j+1,Xe=Ue;Xe<X;Ve++,Xe++){let _=Number.MIN_SAFE_INTEGER,pe=!1;Xe<=vt&&(_=Q(he,Ee,Ke,F,H,K,Xe,ke,j,we[Te-1][Ve-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,Be=_+ye[Te-1][Ve-1]);const Qe=Xe>Ue,it=Qe?ye[Te][Ve-1]+(we[Te][Ve-1]>0?-5:0):0,rt=Xe>Ue+1&&we[Te][Ve-1]>0,Ne=rt?ye[Te][Ve-2]+(we[Te][Ve-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!pe||Ne>=Be))ye[Te][Ve]=Ne,le[Te][Ve]=3,we[Te][Ve]=0;else if(Qe&&(!pe||it>=Be))ye[Te][Ve]=it,le[Te][Ve]=2,we[Te][Ve]=0;else if(pe)ye[Te][Ve]=Be,le[Te][Ve]=1,we[Te][Ve]=we[Te-1][Ve-1]+1;else throw new Error("not possible")}}if($e&&be(he,F,H,j),!st[0]&&!Y.firstMatchCanBeWeak)return;Te--,Ve--;const nt=[ye[Te][Ve],j];let tt=0,at=0;for(;Te>=1;){let Ue=Ve;do{const vt=le[Te][Ue];if(vt===3)Ue=Ue-2;else if(vt===2)Ue=Ue-1;else break}while(Ue>=1);tt>1&&Ee[F+Te-1]===K[j+Ve-1]&&!V(Ue+j-1,H,K)&&tt+1>we[Te][Ue]&&(Ue=Ve),Ue===Ve?tt++:tt=1,at||(at=Ue),Te--,Ve=Ue-1,nt.push(Ve)}ke===x&&Y.boostFullMatch&&(nt[0]+=2);const ct=at-x;return nt[0]-=ct,nt}e.$7j=ce;function te(he,Ee,F,H,K,j){let Y=he-1,x=Ee-1;for(;Y>=F&&x>=H;)K[Y]===j[x]&&(de[Y]=x,Y--),x--}function Q(he,Ee,F,H,K,j,Y,x,ke,Te,Ve){if(Ee[F]!==j[Y])return Number.MIN_SAFE_INTEGER;let Ke=1,Xe=!1;return Y===F-H?Ke=he[F]===K[Y]?7:5:V(Y,K,j)&&(Y===0||!V(Y-1,K,j))?(Ke=he[F]===K[Y]?7:5,Xe=!0):se(j,Y)&&(Y===0||!se(j,Y-1))?Ke=5:(se(j,Y-1)||Z(j,Y-1))&&(Ke=5,Xe=!0),Ke>1&&F===H&&(Ve[0]=!0),Xe||(Xe=V(Y,K,j)||se(j,Y-1)||Z(j,Y-1)),F===H?Y>ke&&(Ke-=Xe?3:5):Te?Ke+=Xe?2:0:Ke+=Xe?0:1,Y+1===x&&(Ke-=Xe?3:5),Ke}function ee(he,Ee,F,H,K,j,Y){return ve(he,Ee,F,H,K,j,!0,Y)}e.$8j=ee;function me(he,Ee,F,H,K,j,Y){return ve(he,Ee,F,H,K,j,!1,Y)}e.$9j=me;function ve(he,Ee,F,H,K,j,Y,x){let ke=ce(he,Ee,F,H,K,j,x);if(ke&&!Y)return ke;if(he.length>=3){const Te=Math.min(7,he.length-1);for(let Ve=F+1;Ve<Te;Ve++){const Ke=Ae(he,Ve);if(Ke){const Xe=ce(Ke,Ke.toLowerCase(),F,H,K,j,x);Xe&&(Xe[0]-=3,(!ke||Xe[0]>ke[0])&&(ke=Xe))}}}return ke}function Ae(he,Ee){if(Ee+1>=he.length)return;const F=he[Ee],H=he[Ee+1];if(F!==H)return he.slice(0,Ee)+H+F+he.slice(Ee+2)}}),define(Pe[31],Re([1,0,12]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(M||(M={})),function(I){const A="error",P="warning",m="warn",f="info",w="ignore";function R(l){return l?y.$_e(A,l)?I.Error:y.$_e(P,l)||y.$_e(m,l)?I.Warning:y.$_e(f,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function k(l){switch(l){case I.Error:return A;case I.Warning:return P;case I.Info:return f;default:return w}}I.toString=k}(M||(M={})),e.default=M}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,12]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return b-r}value(){return this.b[this.c]}}e.$8h=I;class A{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$6e)(p,this.b,0,p.length,this.c,this.d):(0,M.$8e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=A;class P{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const r=this.b.charCodeAt(b);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$6e)(p,this.b,0,p.length,this.d,this.e):(0,M.$8e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=P;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$7e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$7e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$5e)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$5e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=f;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class k{static forUris(p=()=>!1,b=()=>!1){return new k(new f(p,b))}static forPaths(p=!1){return new k(new P(void 0,!p))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new A)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const r=b.slice(0);(0,y.$Xb)(r);for(const a of r)this.set(a,p)}else{const r=p.slice(0);(0,y.$Xb)(r);for(const a of r)this.set(a[0],a[1])}}set(p,b){const r=this.b.reset(p);let a;this.c||(this.c=new w,this.c.segment=r.value());const s=[];for(a=this.c;;){const o=r.cmp(a.segment);if(o>0)a.left||(a.left=new w,a.left.segment=r.value()),s.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new w,a.right.segment=r.value()),s.push([1,a]),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new w,a.mid.segment=r.value()),s.push([0,a]),a=a.mid;else break}const n=a.value;a.value=b,a.key=p;for(let o=s.length-1;o>=0;o--){const c=s[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=s[o][0],u=s[o+1][0];if(t===1&&u===1)s[o][1]=c.rotateLeft();else if(t===-1&&u===-1)s[o][1]=c.rotateRight();else if(t===1&&u===-1)c.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=c.rotateLeft();else if(t===-1&&u===1)c.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let r=this.c;for(;r;){const a=b.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else break}return r}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const r=this.b.reset(p),a=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)a.push([-1,s]),s=s.left;else if(n<0)a.push([1,s]),s=s.right;else if(r.hasNext())r.next(),a.push([0,s]),s=s.mid;else break}if(s){if(b?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),s.key=o,s.value=c,s.segment=h}}else{const n=s.left??s.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let r=this.c,a;for(;r;){const s=b.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(b.hasNext())b.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(p){return this.g(p,!1)}g(p,b){const r=this.b.reset(p);let a=this.c;for(;a;){const s=r.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this.h(a.mid):b?a.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,r]of this)p(r,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const r=b.balanceFactor();return r<-1||r>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$_h=k}),define(Pe[44],Re([1,0,90]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var M;(function(P){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}P.isThemeColor=m})(M||(e.ThemeColor=M={}));function I(P){return{id:P}}e.$ak=I;var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function f(n){const o=m.exec(n.id);if(!o)return f(y.$_j.error);const[,c,h]=o,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}P.asClassNameArray=f;function w(n){return f(n).join(" ")}P.asClassName=w;function R(n){return"."+f(n).join(".")}P.asCSSSelector=R;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||M.isThemeColor(n.color))}P.isThemeIcon=k;const l=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function p(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}P.fromString=p;function b(n){return{id:n}}P.fromId=b;function r(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}P.modify=r;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}P.getModifier=a;function s(n,o){return n.id===o.id&&n.color?.id===o.color?.id}P.isEqual=s})(A||(e.ThemeIcon=A={}))}),define(Pe[126],Re([1,0,124,12,44]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const A="$(",P=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${P.source}`,"g");function f(s){return s.replace(m,(n,o)=>o?n:`\\${n}`)}e.$bk=f;const w=new RegExp(`\\\\${P.source}`,"g");function R(s){return s.replace(w,n=>`\\${n}`)}e.$ck=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function l(s){return s.indexOf(A)===-1?s:s.replace(k,(n,o,c,h)=>c?n:o||h||"")}e.$dk=l;function p(s){return s?s.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$ek=p;const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){b.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=b.lastIndex,t=b.exec(s),u=s.substring(h,t?.index);if(u.length>0){n+=u;for(let i=0;i<u.length;i++)o.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:o}}e.$fk=r;function a(s,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,y.$1j)(s,c,o);const t=(0,M.$Te)(c," "),u=c.length-t.length,i=(0,y.$1j)(s,t,o);if(i)for(const g of i){const $=h[g.start+u]+u;g.start+=$,g.end+=$}return i}e.$gk=a}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(I){return y.test(I)}e.$pg=M,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const A=new Uint8Array(16),P=[];for(let m=0;m<256;m++)P.push(m.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,w="";return w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w}}()}),define(Pe[127],Re([1,0,18,68,33]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function A(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$nt=A;function P(k,l,p){const b={id:(0,I.$qg)(),name:k,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$ot=P;class m{constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return M.Iterable.some(this,([b,r])=>r.asFile())&&p.push("files"),R(f(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return f(l)}}e.$pt=m;function f(k){return k.toLowerCase()}function w(k,l){return R(f(k),l.map(f))}e.$qt=w;function R(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,r,a]=p;return a==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.$rt=Object.freeze({create:k=>(0,y.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$rt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var y;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function M(I){let A=0,P=0,m=0,f=0;for(let w=0,R=I.length;w<R;w++){const k=I.charCodeAt(w);k===13?(A===0&&(P=w),A++,w+1<R&&I.charCodeAt(w+1)===10?(f|=2,w++):f|=3,m=w+1):k===10&&(f|=1,A===0&&(P=w),A++,m=w+1)}return A===0&&(P=I.length),[A,P,I.length-m,f]}e.$ut=M}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var y;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,w=m.notIn.length;f<w;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(f-2),R=m.getStandardTokenType(w);return this.isOK(R)}g(m,f){for(let w=m;w<=f;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=M;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)A(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),A(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),A(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),A(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&A(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$St=I;function A(P,m,f){P.has(m)?P.get(m).push(f):P.set(m,[f])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class y{constructor(a,s){this.piece=a,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return I(this.right);let a=this;for(;a.parent!==e.$TB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}prev(){if(this.left!==e.$TB)return A(this.left);let a=this;for(;a.parent!==e.$TB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=y;var M;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$TB=new y(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function I(r){for(;r.left!==e.$TB;)r=r.left;return r}e.$UB=I;function A(r){for(;r.right!==e.$TB;)r=r.right;return r}e.$VB=A;function P(r){return r===e.$TB?0:r.size_left+r.piece.length+P(r.right)}function m(r){return r===e.$TB?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function f(){e.$TB.parent=e.$TB}function w(r,a){const s=a.right;s.size_left+=a.size_left+(a.piece?a.piece.length:0),s.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=s.left,s.left!==e.$TB&&(s.left.parent=a),s.parent=a.parent,a.parent===e.$TB?r.root=s:a.parent.left===a?a.parent.left=s:a.parent.right=s,s.left=a,a.parent=s}e.$WB=w;function R(r,a){const s=a.left;a.left=s.right,s.right!==e.$TB&&(s.right.parent=a),s.parent=a.parent,a.size_left-=s.size_left+(s.piece?s.piece.length:0),a.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),a.parent===e.$TB?r.root=s:a===a.parent.right?a.parent.right=s:a.parent.left=s,s.right=a,a.parent=s}e.$XB=R;function k(r,a){let s,n;if(a.left===e.$TB?(n=a,s=n.right):a.right===e.$TB?(n=a,s=n.left):(n=I(a.right),s=n.right),n===r.root){r.root=s,s.color=0,a.detach(),f(),r.root.parent=e.$TB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===a?(s.parent=n.parent,b(r,s)):(n.parent===a?s.parent=n:s.parent=n.parent,b(r,s),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===r.root?r.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$TB&&(n.left.parent=n),n.right!==e.$TB&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,b(r,n)),a.detach(),s.parent.left===s){const h=P(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const u=h-s.parent.size_left,i=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,p(r,s.parent,u,i)}}if(b(r,s.parent),o){f();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,w(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,w(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,R(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,R(r,s.parent),s=r.root));s.color=0,f()}e.$YB=k;function l(r,a){for(b(r,a);a!==r.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const s=a.parent.parent.right;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,w(r,a)),a.parent.color=0,a.parent.parent.color=1,R(r,a.parent.parent))}else{const s=a.parent.parent.left;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,R(r,a)),a.parent.color=0,a.parent.parent.color=1,w(r,a.parent.parent))}r.root.color=0}e.$ZB=l;function p(r,a,s,n){for(;a!==r.root&&a!==e.$TB;)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}e.$1B=p;function b(r,a){let s=0,n=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,s=P(a.left)-a.size_left,n=m(a.left)-a.lf_left,a.size_left+=s,a.lf_left+=n;a!==r.root&&(s!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}}e.$2B=b}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const m=65535;function f(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class w{constructor(n,o,c,h,t){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function R(s,n=!0){const o=[0];let c=1;for(let h=0,t=s.length;h<t;h++){const u=s.charCodeAt(h);u===13?h+1<t&&s.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:u===10&&(o[c++]=h+1)}return n?f(o):o}e.$9B=R;function k(s,n){s.length=0,s[0]=0;let o=1,c=0,h=0,t=0,u=!0;for(let g=0,$=n.length;g<$;g++){const d=n.charCodeAt(g);d===13?g+1<$&&n.charCodeAt(g+1)===10?(t++,s[o++]=g+2,g++):(c++,s[o++]=g+1):d===10?(h++,s[o++]=g+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const i=new w(f(s),c,h,t,u);return s.length=0,i}e.$0B=k;class l{constructor(n,o,c,h,t){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$$B=l;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$_B=p;class b{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==A.$TB&&n.iterate(n.root,c=>(c!==A.$TB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=A.$TB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let t=0,u=n.length;t<u;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=R(n[t].buffer));const i=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,i)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=m,c=o-Math.floor(o/3),h=c*2;let t="",u=0;const i=[];if(this.iterate(this.root,g=>{const $=this.R(g),d=$.length;if(u<=c||u+d<h)return t+=$,u+=d,!0;const S=t.replace(/\r\n|\r|\n/g,n);return i.push(new p(S,R(S))),t=$,u=d,!0}),u>0){const g=t.replace(/\r\n|\r|\n/g,n);i.push(new p(g,R(g)))}this.create(i,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===A.$TB)return!0;const t=this.R(h),u=t.length,i=n.G(o),g=n.G(o+u),$=n.getValueInRange2(i,g);return o+=u,t===$})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==A.$TB;)if(h.left!==A.$TB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const t=this.B(h,n-h.lf_left-2);return c+=t+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==A.$TB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const t=this.A(o,n-o.size_left);if(c+=o.lf_left+t.index,t.index===0){const u=this.getOffsetAt(c+1,1),i=h-u;return new y.$Ts(c+1,i+1)}return new y.$Ts(c+1,t.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===A.$TB){const t=this.getOffsetAt(c+1,1),u=h-n-t;return new y.$Ts(c+1,u+1)}else o=o.right;return new y.$Ts(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(n,o){if(n.node===o.node){const i=n.node,g=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);return g.substring($+n.remainder,$+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let u=h.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==A.$TB;){const i=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){u+=i.substring(g,g+o.remainder);break}else u+=i.substr(g,c.piece.length);c=c.next()}return u}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===A.$TB)return!0;const u=t.piece;let i=u.length;if(i===0)return!0;const g=this.a[u.bufferIndex].buffer,$=this.a[u.bufferIndex].lineStarts,d=u.start.line,S=u.end.line;let L=$[d]+u.start.column;if(h&&(g.charCodeAt(L)===10&&(L++,i--),n[o++]=c,c="",h=!1,i===0))return!0;if(d===S)return!this.f&&g.charCodeAt(L+i-1)===13?(h=!0,c+=g.substr(L,i-1)):c+=g.substr(L,i),!0;c+=this.f?g.substring(L,Math.max(L,$[d+1]-this.e)):g.substring(L,$[d+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let v=d+1;v<S;v++)c=this.f?g.substring($[v],$[v+1]-this.e):g.substring($[v],$[v+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&g.charCodeAt($[S]+u.end.column-1)===13?(h=!0,u.end.column===0?o--:c=g.substr($[S],u.end.column-1)):c=g.substr($[S],u.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,t,u,i,g,$,d,S){const L=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,u);let T;const O={line:0,column:0};let G,q;o._wordSeparators?(G=L.buffer.substring(E,D),q=z=>z+E,o.reset(0)):(G=L.buffer,q=z=>z,o.reset(E));do if(T=o.next(G),T){if(q(T.index)>=D)return d;this.s(n,q(T.index)-v,O);const z=this.t(n.piece.bufferIndex,t,O),C=O.line===t.line?O.column-t.column+h:O.column+1,N=C+T[0].length;if(S[d++]=(0,P.$5B)(new M.$Us(c+z,C,c+z,N),T,g),q(T.index)+T[0].length>=D||d>=$)return d}while(T);return d}findMatchesLineByLine(n,o,c,h){const t=[];let u=0;const i=new P.$8B(o.wordSeparators,o.regex);let g=this.H(n.startLineNumber,n.startColumn);if(g===null)return[];const $=this.H(n.endLineNumber,n.endColumn);if($===null)return[];let d=this.s(g.node,g.remainder);const S=this.s($.node,$.remainder);if(g.node===$.node)return this.findMatchesInNode(g.node,i,n.startLineNumber,n.startColumn,d,S,o,c,h,u,t),t;let L=n.startLineNumber,v=g.node;for(;v!==$.node;){const D=this.t(v.piece.bufferIndex,d,v.piece.end);if(D>=1){const O=this.a[v.piece.bufferIndex].lineStarts,G=this.u(v.piece.bufferIndex,v.piece.start),q=O[d.line+D],z=L===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(v,i,L,z,d,this.s(v,q-G),o,c,h,u,t),u>=h)return t;L+=D}const T=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(T,n.endColumn-1);return u=this.n(o,i,O,n.endLineNumber,T,u,t,c,h),t}if(u=this.n(o,i,this.getLineContent(L).substr(T),L,T,u,t,c,h),u>=h)return t;L++,g=this.H(L,1),v=g.node,d=this.s(g.node,g.remainder)}if(L===n.endLineNumber){const D=L===n.startLineNumber?n.startColumn-1:0,T=this.getLineContent(L).substring(D,n.endColumn-1);return u=this.n(o,i,T,n.endLineNumber,D,u,t,c,h),t}const E=L===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode($.node,i,L,E,d,S,o,c,h,u,t),t}n(n,o,c,h,t,u,i,g,$){const d=n.wordSeparators;if(!g&&n.simpleSearch){const L=n.simpleSearch,v=L.length,E=c.length;let D=-v;for(;(D=c.indexOf(L,D+v))!==-1;)if((!d||(0,P.$7B)(d,c,E,D,v))&&(i[u++]=new I.$av(new M.$Us(h,D+1+t,h,D+1+v+t),null),u>=$))return u;return u}let S;o.reset(0);do if(S=o.next(c),S&&(i[u++]=(0,P.$5B)(new M.$Us(h,S.index+1+t,h,S.index+1+S[0].length+t),S,g),u>=$))return u;while(S);return u}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==A.$TB){const{node:h,remainder:t,nodeStartOffset:u}=this.G(n),i=h.piece,g=i.bufferIndex,$=this.s(h,t);if(h.piece.bufferIndex===0&&i.end.line===this.g.line&&i.end.column===this.g.column&&u+i.length===n&&o.length<m){this.F(h,o),this.y();return}if(u===n)this.o(o,h),this.h.validate(n);else if(u+h.piece.length>n){const d=[];let S=new l(i.bufferIndex,$,i.end,this.t(i.bufferIndex,$,i.end),this.u(g,i.end)-this.u(g,$));if(this.K()&&this.M(o)&&this.I(h,t)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,t-1)===13){const D=this.s(h,t-1);this.C(h,D),o="\r"+o,h.piece.length===0&&d.push(h)}else this.C(h,$);else this.C(h,$);const L=this.w(o);S.length>0&&this.S(h,S);let v=h;for(let E=0;E<L.length;E++)v=this.S(v,L[E]);this.v(d)}else this.q(o,h)}else{const h=this.w(o);let t=this.T(null,h[0]);for(let u=1;u<h.length;u++)t=this.S(t,h[u])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===A.$TB)return;const c=this.G(n),h=this.G(n+o),t=c.node,u=h.node;if(t===u){const L=this.s(t,c.remainder),v=this.s(t,h.remainder);if(c.nodeStartOffset===n){if(o===t.piece.length){const E=t.next();(0,A.$YB)(this,t),this.N(E),this.y();return}this.D(t,v),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+o){this.C(t,L),this.O(t),this.y();return}this.E(t,L,v),this.y();return}const i=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(n),t.piece.length===0&&i.push(t);const $=this.s(u,h.remainder);this.D(u,$),u.piece.length===0&&i.push(u);const d=t.next();for(let L=d;L!==A.$TB&&L!==u;L=L.next())i.push(L);const S=t.piece.length===0?t.prev():t;this.v(i),this.O(S),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const u=o.piece,i={line:u.start.line+1,column:0},g=new l(u.bufferIndex,i,u.end,this.t(u.bufferIndex,i,u.end),u.length-1);o.piece=g,n+=`
`,(0,A.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let t=this.T(o,h[h.length-1]);for(let u=h.length-2;u>=0;u--)t=this.T(t,h[u]);this.N(t),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let t=h;for(let u=1;u<c.length;u++)t=this.S(t,c[u]);this.N(h)}s(n,o,c){const h=n.piece,t=n.piece.bufferIndex,u=this.a[t].lineStarts,g=u[h.start.line]+h.start.column+o;let $=h.start.line,d=h.end.line,S=0,L=0,v=0;for(;$<=d&&(S=$+(d-$)/2|0,v=u[S],S!==d);)if(L=u[S+1],g<v)d=S-1;else if(g>=L)$=S+1;else break;return c?(c.line=S,c.column=g-v,null):{line:S,column:g-v}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const t=h[c.line+1],u=h[c.line]+c.column;if(t>u+1)return c.line-o.line;const i=u-1;return this.a[n].buffer.charCodeAt(i)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,A.$YB)(this,n[o])}w(n){if(n.length>m){const d=[];for(;n.length>m;){const L=n.charCodeAt(m-1);let v;L===13||L>=55296&&L<=56319?(v=n.substring(0,m-1),n=n.substring(m-1)):(v=n.substring(0,m),n=n.substring(m));const E=R(v);d.push(new l(this.a.length,{line:0,column:0},{line:E.length-1,column:v.length-E[E.length-1]},E.length-1,v.length)),this.a.push(new p(v,E))}const S=R(n);return d.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),d}let o=this.a[0].buffer.length;const c=R(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let d=0;d<c.length;d++)c[d]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let d=0;d<c.length;d++)c[d]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,i=t-this.a[0].lineStarts[u],g={line:u,column:i},$=new l(0,h,g,this.t(0,h,g),t-o);return this.g=g,[$]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const t=this.h.get2(n);if(t){c=t.node;const u=this.B(c,n-t.nodeStartLineNumber-1),i=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=i.substring(g+u,g+c.piece.length);else{const $=this.B(c,n-t.nodeStartLineNumber);return i.substring(g+u,g+$-o)}}else{let u=0;const i=n;for(;c!==A.$TB;)if(c.left!==A.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const g=this.B(c,n-c.lf_left-2),$=this.B(c,n-c.lf_left-1),d=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return u+=c.size_left,this.h.set({node:c,nodeStartOffset:u,nodeStartLineNumber:i-(n-1-c.lf_left)}),d.substring(S+g,S+$-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const g=this.B(c,n-c.lf_left-2),$=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);h=$.substring(d+g,d+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==A.$TB;){const u=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const i=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=u.substring(g,g+i-o),h}else{const i=this.u(c.piece.bufferIndex,c.piece.start);h+=u.substr(i,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==A.$TB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const u=this.t(n.piece.bufferIndex,c.start,h);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+o+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),u=o,i=this.u(c.bufferIndex,u),g=this.t(c.bufferIndex,c.start,u),$=g-h,d=i-t,S=c.length+d;n.piece=new l(c.bufferIndex,c.start,u,g,S),(0,A.$1B)(this,n,d,$)}D(n,o){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),u=o,i=this.t(c.bufferIndex,u,c.end),g=this.u(c.bufferIndex,u),$=i-h,d=t-g,S=c.length+d;n.piece=new l(c.bufferIndex,u,c.end,i,S),(0,A.$1B)(this,n,d,$)}E(n,o,c){const h=n.piece,t=h.start,u=h.end,i=h.length,g=h.lineFeedCnt,$=o,d=this.t(h.bufferIndex,h.start,$),S=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,t);n.piece=new l(h.bufferIndex,h.start,$,d,S),(0,A.$1B)(this,n,S-i,d-g);const L=new l(h.bufferIndex,c,u,this.t(h.bufferIndex,c,u),this.u(h.bufferIndex,u)-this.u(h.bufferIndex,c)),v=this.S(n,L);this.N(v)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const t=R(o,!1);for(let v=0;v<t.length;v++)t[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,i=this.a[0].buffer.length-this.a[0].lineStarts[u],g={line:u,column:i},$=n.piece.length+o.length,d=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,g),L=S-d;n.piece=new l(n.piece.bufferIndex,n.piece.start,g,S,$),this.g=g,(0,A.$1B)(this,n,o.length,L)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==A.$TB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const t={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==A.$TB;)if(c.left!==A.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),u=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+o-1,u),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+o-1<=c.piece.length)return{node:c,remainder:t+o-1,nodeStartOffset:h};o-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==A.$TB;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),u=this.J(c);return{node:c,remainder:Math.min(o-1,t),nodeStartOffset:u}}else if(c.piece.length>=o-1){const t=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:t}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$TB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,t=c[h]+o.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$TB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,i=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,i,u),(0,A.$1B)(this,n,-1,-1),n.piece.length===0&&c.push(n);const g={line:o.piece.start.line+1,column:0},$=o.piece.length-1,d=this.t(o.piece.bufferIndex,g,o.piece.end);o.piece=new l(o.piece.bufferIndex,g,o.piece.end,d,$),(0,A.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,A.$YB)(this,c[L])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,A.$YB)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},u=h.length-1,i=this.t(h.bufferIndex,t,h.end);c.piece=new l(h.bufferIndex,t,h.end,i,u),(0,A.$1B)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===A.$TB)return o(A.$TB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===A.$TB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,t)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new A.$SB(o,1);if(c.left=A.$TB,c.right=A.$TB,c.parent=A.$TB,c.size_left=0,c.lf_left=0,this.root===A.$TB)this.root=c,c.color=0;else if(n.right===A.$TB)n.right=c,c.parent=n;else{const t=(0,A.$UB)(n.right);t.left=c,c.parent=t}return(0,A.$ZB)(this,c),c}T(n,o){const c=new A.$SB(o,1);if(c.left=A.$TB,c.right=A.$TB,c.parent=A.$TB,c.size_left=0,c.lf_left=0,this.root===A.$TB)this.root=c,c.color=0;else if(n.left===A.$TB)n.left=c,c.parent=n;else{const h=(0,A.$VB)(n.left);h.right=c,c.parent=h}return(0,A.$ZB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$aC=a}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const P=this.a.get(A);return this.a.delete(A),P}}addDragOperationTransfer(A,P){this.a.set(A,P)}}e.$n8=y;class M{constructor(A){this.identifier=A}}e.$o8=M}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class A extends M.$Tc{constructor(l,p="",b="",r=!0,a){super(),this.h=this.B(new y.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=r,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ki=A;class P extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$Vd),this.onWillRun=this.f.event,this.m=this.B(new y.$Vd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(r){b=r}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Li=P;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new m,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=m;class f{get actions(){return this.a}constructor(l,p,b,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=b}async run(){}}e.$Ni=f;class w extends A{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Oi=w;function R(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Pi=R}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const M=60,I=M*60,A=I*24,P=A*7,m=A*30,f=A*365;function w(k,l,p,b){typeof k!="number"&&(k=k.getTime());const r=Math.round((new Date().getTime()-k)/1e3);if(r<-30)return(0,y.localize)(0,null,w(new Date().getTime()+r*1e3,!1));if(!b&&r<30)return(0,y.localize)(1,null);let a;return r<M?(a=r,l?a===1?p?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):p?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?p?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):p?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):r<I?(a=Math.floor(r/M),l?a===1?p?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):p?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?p?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):p?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):r<A?(a=Math.floor(r/I),l?a===1?p?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):p?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?p?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):p?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):r<P?(a=Math.floor(r/A),l?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):r<m?(a=Math.floor(r/P),l?a===1?p?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):p?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?p?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):p?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):r<f?(a=Math.floor(r/m),l?a===1?p?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):p?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?p?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):p?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(r/f),l?a===1?p?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):p?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?p?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):p?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}e.$vm=w;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=R}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function A(k,l){return l&&(k.stack||k.stacktrace)?I.localize(0,null,m(k),P(k.stack)||P(k.stacktrace)):m(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function f(k=null,l=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const p=y.$Hb(k),b=f(p[0],l);return p.length>1?I.localize(4,null,b,p.length):b}if(M.$If(k))return k;if(k.detail){const p=k.detail;if(p.error)return A(p.error,l);if(p.exception)return A(p.exception,l)}return k.stack?A(k,l):k.message?k.message:I.localize(5,null)}e.$Qi=f;function w(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ri=w;function R(k,l){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=l,p}e.$Si=R}),define(Pe[138],Re([1,0,39,19]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const I=new y.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(L,v,E=!1){const D=L||"",T=v||"",O=I.value.collator.compare(D,T);return I.value.collatorIsNumeric&&O===0&&D!==T?D<T?-1:1:O}e.$Iq=m;function f(L,v){const E=A.value.collator;return L=L||"",v=v||"",c(E,L,v)}e.$Jq=f;function w(L,v){const E=A.value.collator;return L=L||"",v=v||"",i(L,v)||c(E,L,v)}e.$Kq=w;function R(L,v){const E=A.value.collator;return L=L||"",v=v||"",u(L,v)||c(E,L,v)}e.$Lq=R;function k(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$Mq=k;function l(L,v){const[E,D]=n(L),[T,O]=n(v);let G=I.value.collator.compare(D,O);if(G===0){if(I.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(G=I.value.collator.compare(E,T),I.value.collatorIsNumeric&&G===0&&E!==T)return E<T?-1:1}return G}e.$Nq=l;function p(L,v){L=L||"",v=v||"";const E=o(L),D=o(v),T=A.value.collator,O=P.value.collator;return c(O,E,D)||c(T,L,v)}e.$Oq=p;function b(L,v){L=L||"",v=v||"";const E=o(L),D=o(v),T=A.value.collator,O=P.value.collator;return c(O,E,D)||i(L,v)||c(T,L,v)}e.$Pq=b;function r(L,v){L=L||"",v=v||"";const E=o(L),D=o(v),T=A.value.collator,O=P.value.collator;return c(O,E,D)||u(L,v)||c(T,L,v)}e.$Qq=r;function a(L,v){L=L||"",v=v||"";const E=o(L).toLowerCase(),D=o(v).toLowerCase();return E!==D?E<D?-1:1:L!==v?L<v?-1:1:0}e.$Rq=a;const s=/^(.*?)(\.([^.]*))?$/;function n(L,v=!1){const E=L?s.exec(L):[];let D=[E&&E[1]||"",E&&E[3]||""];return v&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function o(L){const v=L?s.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(L,v,E){const D=L.compare(v,E);return D!==0?D:v.length!==E.length?v.length<E.length?-1:1:0}function h(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function t(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function u(L,v){return h(L)&&t(v)?-1:t(L)&&h(v)?1:0}function i(L,v){return t(L)&&h(v)?-1:h(L)&&t(v)?1:0}function g(L,v,E=!1){return E||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function $(L,v,E=!1){const D=L.split(M.sep),T=v.split(M.sep),O=D.length-1,G=T.length-1;let q,z;for(let C=0;;C++){if(q=O===C,z=G===C,q&&z)return m(D[C],T[C],E);if(q)return-1;if(z)return 1;const N=g(D[C],T[C],E);if(N!==0)return N}}e.$Sq=$;function d(L,v,E){const D=L.toLowerCase(),T=v.toLowerCase(),O=S(L,v,E);if(O)return O;const G=D.endsWith(E),q=T.endsWith(E);if(G!==q)return G?-1:1;const z=m(D,T);return z!==0?z:D.localeCompare(T)}e.$Tq=d;function S(L,v,E){const D=L.toLowerCase(),T=v.toLowerCase(),O=D.startsWith(E),G=T.startsWith(E);if(O!==G)return O?-1:1;if(O&&G){if(D.length<T.length)return-1;if(D.length>T.length)return 1}return 0}e.$Uq=S}),define(Pe[45],Re([1,0,19,21,12,16]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function P(d){return d===47||d===92}e.$1f=P;function m(d){return d.replace(/[\\/]/g,y.$gc.sep)}e.$2f=m;function f(d){return d.indexOf("/")===-1&&(d=m(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$3f=f;function w(d,S=y.$gc.sep){if(!d)return"";const L=d.length,v=d.charCodeAt(0);if(P(v)){if(P(d.charCodeAt(1))&&!P(d.charCodeAt(2))){let D=3;const T=D;for(;D<L&&!P(d.charCodeAt(D));D++);if(T!==D&&!P(d.charCodeAt(D+1))){for(D+=1;D<L;D++)if(P(d.charCodeAt(D)))return d.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(s(v)&&d.charCodeAt(1)===58)return P(d.charCodeAt(2))?d.slice(0,2)+S:d.slice(0,2);let E=d.indexOf("://");if(E!==-1){for(E+=3;E<L;E++)if(P(d.charCodeAt(E)))return d.slice(0,E+1)}return""}e.$4f=w;function R(d){if(!M.$i||!d||d.length<5)return!1;let S=d.charCodeAt(0);if(S!==92||(S=d.charCodeAt(1),S!==92))return!1;let L=2;const v=L;for(;L<d.length&&(S=d.charCodeAt(L),S!==92);L++);return!(v===L||(S=d.charCodeAt(L+1),isNaN(S)||S===92))}e.$5f=R;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(d,S=M.$i){const L=S?k:l;return!(!d||d.length===0||/^\s+$/.test(d)||(L.lastIndex=0,L.test(d))||S&&p.test(d)||d==="."||d===".."||S&&d[d.length-1]==="."||S&&d.length!==d.trim().length||d.length>255)}e.$6f=b;function r(d,S,L){const v=d===S;return!L||v?v:!d||!S?!1:(0,I.$_e)(d,S)}e.$7f=r;function a(d,S,L,v=y.sep){if(d===S)return!0;if(!d||!S||S.length>d.length)return!1;if(L){if(!(0,I.$af)(d,S))return!1;if(S.length===d.length)return!0;let D=S.length;return S.charAt(S.length-1)===v&&D--,d.charAt(D)===v}return S.charAt(S.length-1)!==v&&(S+=v),d.indexOf(S)===0}e.$8f=a;function s(d){return d>=65&&d<=90||d>=97&&d<=122}e.$9f=s;function n(d,S){return M.$i&&d.endsWith(":")&&(d+=y.sep),(0,y.$ic)(d)||(d=(0,y.$jc)(S,d)),d=(0,y.$hc)(d),M.$i?(d=(0,I.$Ue)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,I.$Ue)(d,y.sep),d||(d=y.sep)),d}e.$0f=n;function o(d){const S=(0,y.$hc)(d);return M.$i?d.length>3?!1:c(S)&&(d.length===2||S.charCodeAt(2)===92):S===y.$gc.sep}e.$$f=o;function c(d,S=M.$i){return S?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$_f=c;function h(d,S=M.$i){return c(d,S)?d[0]:void 0}e.$ag=h;function t(d,S,L){return S.length>d.length?-1:d===S?0:(L&&(d=d.toLowerCase(),S=S.toLowerCase()),d.indexOf(S))}e.$bg=t;function u(d){const S=d.split(":");let L,v,E;for(const D of S){const T=Number(D);(0,A.$Mf)(T)?v===void 0?v=T:E===void 0&&(E=T):L=L?[L,D].join(":"):D}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:E!==void 0?E:v!==void 0?1:void 0}}e.$cg=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(d,S,L=8){let v="";for(let D=0;D<L;D++){let T;D===0&&M.$i&&!S&&(L===3||L===4)?T=g:T=i,v+=T.charAt(Math.floor(Math.random()*T.length))}let E;return S?E=`${S}-${v}`:E=v,d?(0,y.$jc)(d,E):E}e.$dg=$}),define(Pe[69],Re([1,0,19]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const k=(0,y.$oc)(R),l=M[k.toLowerCase()];return l!==void 0?l:P(R)}e.$gs=A;function P(R){const k=(0,y.$oc)(R);return I[k.toLowerCase()]}e.$hs=P;function m(R){for(const k in I)if(I[k]===R)return k}e.$is=m;const f=/^(.+)\/(.+?)(;.+)?$/;function w(R,k){const l=f.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:R}e.$js=w}),define(Pe[51],Re([1,0,22,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function I(f){return JSON.stringify(f,P)}e.$Ah=I;function A(f){let w=JSON.parse(f);return w=m(w),w}e.$Bh=A;function P(f,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(f,w=0){if(!f||w>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return M.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof y.$je||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let R=0;R<f.length;++R)f[R]=m(f[R],w+1);else for(const R in f)Object.hasOwnProperty.call(f,R)&&(f[R]=m(f[R],w+1))}return f}e.$Ch=m}),define(Pe[11],Re([1,0,15,21,12,2]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={}));function m(l,p){return A.URI.isUri(l)?(0,I.$_e)(l.scheme,p):(0,I.$af)(l,p+":")}e.$eg=m;function f(l,...p){return p.some(b=>m(l,b))}e.$fg=f,e.$gg="vscode-tkn",e.$hg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${P.vscodeRemoteResource}`}set(p,b,r){this.a[p]=b,this.b[p]=r}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return y.$1(o),p}const b=p.authority;let r=this.a[b];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const a=this.b[b],s=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof s=="string"&&(n+=`&${e.$hg}=${encodeURIComponent(s)}`),A.URI.from({scheme:M.$o?this.d:P.vscodeRemoteResource,authority:`${r}:${a}`,path:this.f,query:n})}}e.$ig=new w,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class R{static{this.a=e.$ng}asBrowserUri(p){const b=this.b(p,ge);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===P.vscodeRemote?e.$ig.rewrite(p):p.scheme===P.file&&(M.$m||M.$q===`${P.vscodeFileResource}://${R.a}`)?p.with({scheme:P.vscodeFileResource,authority:p.authority||R.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,ge);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===P.vscodeFileResource?p.with({scheme:P.file,authority:p.authority!==R.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return A.URI.isUri(p)?p:A.URI.parse(b.toUrl(p))}}e.$og=new R;var k;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function r(s){let n;typeof s=="string"?n=new URL(s).searchParams:s instanceof URL?n=s.searchParams:A.URI.isUri(s)&&(n=new URL(s.toString(!0)).searchParams);const o=n?.get(b);if(o)return p.get(o)}l.getHeadersFromQuery=r;function a(s,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";s instanceof URLSearchParams?s.set(b,c):s[b]=c}l.addSearchParam=a})(k||(e.COI=k={}))}),define(Pe[25],Re([1,0,45,11,19,21,12,2]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function f(p){return(0,m.$wc)(p,!0)}e.$vg=f;class w{constructor(b){this.a=b}compare(b,r,a=!1){return b===r?0:(0,P.$5e)(this.getComparisonKey(b,a),this.getComparisonKey(r,a))}isEqual(b,r,a=!1){return b===r?!0:!b||!r?!1:this.getComparisonKey(b,a)===this.getComparisonKey(r,a)}getComparisonKey(b,r=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,r,a=!1){if(b.scheme===r.scheme){if(b.scheme===M.Schemas.file)return y.$8f(f(b),f(r),this.a(b))&&b.query===r.query&&(a||b.fragment===r.fragment);if((0,e.$Mg)(b.authority,r.authority))return y.$8f(b.path,r.path,this.a(b),"/")&&b.query===r.query&&(a||b.fragment===r.fragment)}return!1}joinPath(b,...r){return m.URI.joinPath(b,...r)}basenameOrAuthority(b){return(0,e.$Eg)(b)||b.authority}basename(b){return I.$gc.basename(b.path)}extname(b){return I.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let r;return b.scheme===M.Schemas.file?r=m.URI.file(I.$mc(f(b))).path:(r=I.$gc.dirname(b.path),b.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),r="/")),b.with({path:r})}normalizePath(b){if(!b.path.length)return b;let r;return b.scheme===M.Schemas.file?r=m.URI.file(I.$hc(f(b))).path:r=I.$gc.normalize(b.path),b.with({path:r})}relativePath(b,r){if(b.scheme!==r.scheme||!(0,e.$Mg)(b.authority,r.authority))return;if(b.scheme===M.Schemas.file){const n=I.$lc(f(b),f(r));return A.$i?y.$2f(n):n}let a=b.path||"/";const s=r.path||"/";if(this.a(b)){let n=0;for(const o=Math.min(a.length,s.length);n<o&&!(a.charCodeAt(n)!==s.charCodeAt(n)&&a.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);a=s.substr(0,n)+a.substr(n)}return I.$gc.relative(a,s)}resolvePath(b,r){if(b.scheme===M.Schemas.file){const a=m.URI.file(I.$kc(f(b),r));return b.with({authority:a.authority,path:a.path})}return r=y.$3f(r),b.with({path:I.$gc.resolve(b.path,r)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,r){return b===r||b!==void 0&&r!==void 0&&(0,P.$_e)(b,r)}hasTrailingPathSeparator(b,r=I.sep){if(b.scheme===M.Schemas.file){const a=f(b);return a.length>y.$4f(a).length&&a[a.length-1]===r}else{const a=b.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,r=I.sep){return(0,e.$Ng)(b,r)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,r=I.sep){let a=!1;if(b.scheme===M.Schemas.file){const s=f(b);a=s!==void 0&&s.length===y.$4f(s).length&&s[s.length-1]===r}else{r="/";const s=b.path;a=s.length===1&&s.charCodeAt(s.length-1)===47}return!a&&!(0,e.$Ng)(b,r)?b.with({path:b.path+"/"}):b}}e.$wg=w,e.$xg=new w(()=>!1),e.$yg=new w(p=>p.scheme===M.Schemas.file?!A.$k:!0),e.$zg=new w(p=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function R(p,b){const r=[];for(let a=0;a<p.length;a++){const s=b(p[a]);p.some((n,o)=>o===a?!1:(0,e.$Bg)(s,b(n)))||r.push(p[a])}return r}e.$Qg=R;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(r){const a=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&a.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&a.set(p.META_DATA_MIME,n),a}p.parseMetaData=b})(k||(e.DataUri=k={}));function l(p,b,r){if(b){let a=p.path;return a&&a[0]!==I.$gc.sep&&(a=I.$gc.sep+a),p.with({scheme:r,authority:b,path:a})}return p.with({scheme:r})}e.$Rg=l}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function R(ce){return!!ce&&typeof ce.then=="function"}e.$Sg=R;function k(ce){const te=new y.$6d,Q=ce(te.token),ee=new Promise((me,ve)=>{const Ae=te.token.onCancellationRequested(()=>{Ae.dispose(),ve(new M.$5)});Promise.resolve(Q).then(he=>{Ae.dispose(),te.dispose(),me(he)},he=>{Ae.dispose(),te.dispose(),ve(he)})});return new class{cancel(){te.cancel(),te.dispose()}then(me,ve){return ee.then(me,ve)}catch(me){return this.then(void 0,me)}finally(me){return ee.finally(me)}}}e.$Tg=k;function l(ce,te,Q){return new Promise((ee,me)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ee(Q)});ce.then(ee,me).finally(()=>ve.dispose())})}e.$Ug=l;function p(ce,te){return new Promise((Q,ee)=>{const me=te.onCancellationRequested(()=>{me.dispose(),ee(new M.$5)});ce.then(Q,ee).finally(()=>me.dispose())})}e.$Vg=p;async function b(ce){let te=-1;const Q=ce.map((ee,me)=>ee.then(ve=>(te=me,ve)));try{return await Promise.race(Q)}finally{ce.forEach((ee,me)=>{me!==te&&ee.cancel()})}}e.$Wg=b;function r(ce,te,Q){let ee;const me=setTimeout(()=>{ee?.(void 0),Q?.()},te);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(ve=>ee=ve)])}e.$Xg=r;function a(ce){return new Promise((te,Q)=>{const ee=ce();R(ee)?ee.then(te,Q):te(ee)})}e.$Yg=a;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=te(),new Promise((Q,ee)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,ee(me)})})}dispose(){this.f=!0}}e.$Zg=s;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=n;class o{constructor(){this.a=new Map}queue(te,Q){const me=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(te)===me&&this.a.delete(te)});return this.a.set(te,me),me}}e.$2g=o;const c=(ce,te)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,te()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,Q=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((me,ve)=>{this.d=me,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===f.$Sd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class u{constructor(te){this.a=new t(te),this.b=new s}trigger(te,Q){return this.a.trigger(()=>this.b.queue(te),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=u;class i{constructor(){this.a=!1,this.b=new Promise((te,Q)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=i;class g extends i{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=g;function $(ce,te){return te?new Promise((Q,ee)=>{const me=setTimeout(()=>{ve.dispose(),Q()},ce),ve=te.onCancellationRequested(()=>{clearTimeout(me),ve.dispose(),ee(new M.$5)})}):k(Q=>$(ce,Q))}e.$7g=$;function d(ce,te=0,Q){const ee=setTimeout(()=>{ce(),Q&&me.dispose()},te),me=(0,A.$Rc)(()=>{clearTimeout(ee),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$8g=d;function S(ce){const te=[];let Q=0;const ee=ce.length;function me(){return Q<ee?ce[Q++]():null}function ve(Ae){Ae!=null&&te.push(Ae);const he=me();return he?he.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$9g=S;function L(ce,te=ee=>!!ee,Q=null){let ee=0;const me=ce.length,ve=()=>{if(ee>=me)return Promise.resolve(Q);const Ae=ce[ee++];return Promise.resolve(Ae()).then(Ee=>te(Ee)?Promise.resolve(Ee):ve())};return ve()}e.$0g=L;function v(ce,te=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const me=()=>{ee=-1;for(const ve of ce)ve.cancel?.()};return new Promise((ve,Ae)=>{for(const he of ce)he.then(Ee=>{--ee>=0&&te(Ee)?(me(),ve(Ee)):ee===0&&ve(Q)}).catch(Ee=>{--ee>=0&&(me(),Ae(Ee))})})}e.$$g=v;class E{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new I.$Vd}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,ee)=>{this.g.push({factory:te,c:Q,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const Q=te.factory();Q.then(te.c,te.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=E;class D extends E{constructor(){super(1)}}e.$ah=D;class T{constructor(){this.a=new ye,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=T;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new ie;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,Q=P.$xg){const ee=Q.getComparisonKey(te);return this.a.get(ee)?.size??0}queueFor(te,Q,ee=P.$xg){const me=ee.getComparisonKey(te);let ve=this.a.get(me);if(!ve){ve=new D;const Ae=this.f++,he=I.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Ae,he),this.a.set(me,ve)}return ve.queue(Q)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=O;class G{constructor(te,Q){this.a=-1,typeof te=="function"&&typeof Q=="number"&&this.setIfNotSet(te,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},Q)}setIfNotSet(te,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},Q))}}e.$dh=G;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,Q,ee=globalThis){this.cancel();const me=ee.setInterval(()=>{te()},Q);this.d=(0,A.$Rc)(()=>{ee.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$eh=q;class z{constructor(te,Q){this.b=-1,this.a=te,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=z;class C{constructor(te,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=te,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=C;class N extends z{constructor(te,Q){super(te,Q),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=N;class W extends A.$Tc{constructor(te,Q){super(),this.g=te,this.h=Q,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of te)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(ce,te)=>{(0,m.$B)(()=>{if(Q)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$kh=(ce,te,Q)=>{const ee=ce.requestIdleCallback(te,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(ee))}}},e.$jh=ce=>(0,e.$kh)(globalThis,ce)}();class ae{constructor(te,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ae;class de extends ae{constructor(te){super(globalThis,te)}}e.$mh=de;async function we(ce,te,Q){let ee;for(let me=0;me<Q;me++)try{return await ce()}catch(ve){ee=ve,await $(te)}throw ee}e.$nh=we;class ye{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,Q,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(te),()=>this.d(te)),Q}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let Q,ee;const me=new Promise((ve,Ae)=>{Q=ve,ee=Ae});this.b={run:te,promise:me,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=ye;class le{constructor(te,Q=()=>Date.now()){this.d=te,this.f=Q,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=le;var $e;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})($e||($e={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,Q)=>{this.a=te,this.b=Q})}complete(te){return new Promise(Q=>{this.a(te),this.d={outcome:0,value:te},Q()})}error(te){return new Promise(Q=>{this.b(te),this.d={outcome:1,value:te},Q()})}cancel(){return this.error(new M.$5)}}e.$qh=ie;var be;(function(ce){async function te(ee){let me;const ve=await Promise.all(ee.map(Ae=>Ae.then(he=>he,he=>{me||(me=he)})));if(typeof me<"u")throw me;return ve}ce.settled=te;function Q(ee){return new Promise(async(me,ve)=>{try{await ee(me,ve)}catch(Ae){ve(Ae)}})}ce.withAsyncBody=Q})(be||(e.Promises=be={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=se;class Z{constructor(te){this.b=te,this.a=new w.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=Z;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(te){return new ne(Q=>{Q.emitMany(te)})}static fromPromise(te){return new ne(async Q=>{Q.emitMany(await te)})}static fromPromises(te){return new ne(async Q=>{await Promise.all(te.map(async ee=>Q.emitOne(await ee)))})}static merge(te){return new ne(async Q=>{await Promise.all(te.map(async ee=>{for await(const me of ee)Q.emitOne(me)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new I.$Vd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(te,Q){return new ne(async ee=>{for await(const me of te)ee.emitOne(Q(me))})}map(te){return ne.map(this,te)}static filter(te,Q){return new ne(async ee=>{for await(const me of te)Q(me)&&ee.emitOne(me)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const Q=[];for await(const ee of te)Q.push(ee);return Q}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=ne;class Ie extends ne{constructor(te,Q){super(Q),this.l=te}cancel(){this.l.cancel()}}e.$uh=Ie;function Le(ce){const te=new y.$6d,Q=ce(te.token);return new Ie(te,async ee=>{const me=te.token.onCancellationRequested(()=>{me.dispose(),te.dispose(),ee.reject(new M.$5)});try{for await(const ve of Q){if(te.token.isCancellationRequested)return;ee.emitOne(ve)}me.dispose(),te.dispose()}catch(ve){me.dispose(),te.dispose(),ee.reject(ve)}})}e.$vh=Le;class Ce{constructor(){this.a=new ie,this.b=new ne(ee=>{if(te){ee.reject(te);return}return Q&&ee.emitMany(Q),this.d=me=>ee.reject(me),this.f=me=>ee.emitOne(me),this.a.p});let te,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=Ce}),define(Pe[34],Re([1,0,18,13,45,28,19,21,12]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function w(){return Object.create(null)}e.$Hj=w,e.$Ij="**",e.$Jj="/";const R="[/\\\\]",k="[^/\\\\]",l=/\//g;function p(de,we){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${we?`|${R}${k}+`:""})*?`}}function b(de,we){if(!de)return[];const ye=[];let le=!1,$e=!1,ie="";for(const be of de){switch(be){case we:if(!le&&!$e){ye.push(ie),ie="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ie+=be}return ie&&ye.push(ie),ye}e.$Kj=b;function r(de){if(!de)return"";let we="";const ye=b(de,e.$Jj);if(ye.every(le=>le===e.$Ij))we=".*";else{let le=!1;ye.forEach(($e,ie)=>{if($e===e.$Ij){if(le)return;we+=p(2,ie===ye.length-1)}else{let be=!1,se="",Z=!1,V="";for(const ne of $e){if(ne!=="}"&&be){se+=ne;continue}if(Z&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Jj?Ie="":Ie=(0,f.$Oe)(ne),V+=Ie;continue}switch(ne){case"{":be=!0;continue;case"[":Z=!0;continue;case"}":{const Le=`(?:${b(se,",").map(Ce=>r(Ce)).join("|")})`;we+=Le,be=!1,se="";break}case"]":{we+="["+V+"]",Z=!1,V="";break}case"?":we+=k;continue;case"*":we+=p(1);continue;default:we+=(0,f.$Oe)(ne)}}ie<ye.length-1&&(ye[ie+1]!==e.$Ij||ie+2<ye.length)&&(we+=R)}le=$e===e.$Ij})}return we}const a=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),u=function(){return!1},i=function(){return null};function g(de,we){if(!de)return i;let ye;typeof de!="string"?ye=de.pattern:ye=de,ye=ye.trim();const le=`${ye}_${!!we.trimForExclusions}`;let $e=t.get(le);if($e)return $($e,de);let ie;return a.test(ye)?$e=S(ye.substr(4),ye):(ie=s.exec(d(ye,we)))?$e=L(ie[1],ye):(we.trimForExclusions?o:n).test(ye)?$e=v(ye,we):(ie=c.exec(d(ye,we)))?$e=E(ie[1].substr(1),ye,!0):(ie=h.exec(d(ye,we)))?$e=E(ie[1],ye,!1):$e=D(ye),t.set(le,$e),$($e,de)}function $(de,we){if(typeof we=="string")return de;const ye=function(le,$e){return(0,I.$8f)(le,we.base,!m.$k)?de((0,f.$Te)(le.substr(we.base.length),P.sep),$e):null};return ye.allBasenames=de.allBasenames,ye.allPaths=de.allPaths,ye.basenames=de.basenames,ye.patterns=de.patterns,ye}function d(de,we){return we.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function S(de,we){return function(ye,le){return typeof ye=="string"&&ye.endsWith(de)?we:null}}function L(de,we){const ye=`/${de}`,le=`\\${de}`,$e=function(be,se){return typeof be!="string"?null:se?se===de?we:null:be===de||be.endsWith(ye)||be.endsWith(le)?we:null},ie=[de];return $e.basenames=ie,$e.patterns=[we],$e.allBasenames=ie,$e}function v(de,we){const ye=W(de.slice(1,-1).split(",").map(se=>g(se,we)).filter(se=>se!==i),de),le=ye.length;if(!le)return i;if(le===1)return ye[0];const $e=function(se,Z){for(let V=0,ne=ye.length;V<ne;V++)if(ye[V](se,Z))return de;return null},ie=ye.find(se=>!!se.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const be=ye.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return be.length&&($e.allPaths=be),$e}function E(de,we,ye){const le=P.sep===P.$gc.sep,$e=le?de:de.replace(l,P.sep),ie=P.sep+$e,be=P.$gc.sep+de;let se;return ye?se=function(Z,V){return typeof Z=="string"&&(Z===$e||Z.endsWith(ie)||!le&&(Z===de||Z.endsWith(be)))?we:null}:se=function(Z,V){return typeof Z=="string"&&(Z===$e||!le&&Z===de)?we:null},se.allPaths=[(ye?"*/":"./")+de],se}function D(de){try{const we=new RegExp(`^${r(de)}$`);return function(ye){return we.lastIndex=0,typeof ye=="string"&&we.test(ye)?de:null}}catch{return i}}function T(de,we,ye){return!de||typeof we!="string"?!1:O(de)(we,void 0,ye)}e.$Lj=T;function O(de,we={}){if(!de)return u;if(typeof de=="string"||G(de)){const ye=g(de,we);if(ye===i)return u;const le=function($e,ie){return!!ye($e,ie)};return ye.allBasenames&&(le.allBasenames=ye.allBasenames),ye.allPaths&&(le.allPaths=ye.allPaths),le}return C(de,we)}e.$Mj=O;function G(de){const we=de;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Nj=G;function q(de){return de.allBasenames||[]}e.$Oj=q;function z(de){return de.allPaths||[]}e.$Pj=z;function C(de,we){const ye=W(Object.getOwnPropertyNames(de).map(se=>N(se,de[se],we)).filter(se=>se!==i)),le=ye.length;if(!le)return i;if(!ye.some(se=>!!se.requiresSiblings)){if(le===1)return ye[0];const se=function(ne,Ie){let Le;for(let Ce=0,ce=ye.length;Ce<ce;Ce++){const te=ye[Ce](ne,Ie);if(typeof te=="string")return te;(0,M.$Sg)(te)&&(Le||(Le=[]),Le.push(te))}return Le?(async()=>{for(const Ce of Le){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Z=ye.find(ne=>!!ne.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const V=ye.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(se.allPaths=V),se}const $e=function(se,Z,V){let ne,Ie;for(let Le=0,Ce=ye.length;Le<Ce;Le++){const ce=ye[Le];ce.requiresSiblings&&V&&(Z||(Z=(0,P.$nc)(se)),ne||(ne=Z.substr(0,Z.length-(0,P.$oc)(se).length)));const te=ce(se,Z,ne,V);if(typeof te=="string")return te;(0,M.$Sg)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Le of Ie){const Ce=await Le;if(typeof Ce=="string")return Ce}return null})():null},ie=ye.find(se=>!!se.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const be=ye.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return be.length&&($e.allPaths=be),$e}function N(de,we,ye){if(we===!1)return i;const le=g(de,ye);if(le===i)return i;if(typeof we=="boolean")return le;if(we){const $e=we.when;if(typeof $e=="string"){const ie=(be,se,Z,V)=>{if(!V||!le(be,se))return null;const ne=$e.replace("$(basename)",()=>Z),Ie=V(ne);return(0,M.$Sg)(Ie)?Ie.then(Le=>Le?de:null):Ie?de:null};return ie.requiresSiblings=!0,ie}}return le}function W(de,we){const ye=de.filter(se=>!!se.basenames);if(ye.length<2)return de;const le=ye.reduce((se,Z)=>{const V=Z.basenames;return V?se.concat(V):se},[]);let $e;if(we){$e=[];for(let se=0,Z=le.length;se<Z;se++)$e.push(we)}else $e=ye.reduce((se,Z)=>{const V=Z.patterns;return V?se.concat(V):se},[]);const ie=function(se,Z){if(typeof se!="string")return null;if(!Z){let ne;for(ne=se.length;ne>0;ne--){const Ie=se.charCodeAt(ne-1);if(Ie===47||Ie===92)break}Z=se.substr(ne)}const V=le.indexOf(Z);return V!==-1?$e[V]:null};ie.basenames=le,ie.patterns=$e,ie.allBasenames=le;const be=de.filter(se=>!se.basenames);return be.push(ie),be}function ae(de,we){return(0,y.$ub)(de,we,(ye,le)=>typeof ye=="string"&&typeof le=="string"?ye===le:typeof ye!="string"&&typeof le!="string"?ye.base===le.base&&ye.pattern===le.pattern:!1)}e.$Qj=ae}),define(Pe[52],Re([1,0,15,126,25,12,2]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,y.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=l(this.supportThemeIcons?(0,M.$bk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${p(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,o){const c=new RegExp((0,A.$Oe)(o),"g");return n.replace(c,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$hk=f;function w(s){return R(s)?!s.value:Array.isArray(s)?s.every(w):!0}e.$ik=w;function R(s){return s instanceof f?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$jk=R;function k(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,I.$Ag)(P.URI.from(s.baseUri),P.URI.from(n.baseUri)))}e.$kk=k;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=l;function p(s,n){const o=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,s,`${"`".repeat(c)}`].join(`
`)}e.$mk=p;function b(s){return s.replace(/"/g,"&quot;")}e.$nk=b;function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=r;function a(s){const n=[],o=s.split("|").map(h=>h.trim());s=o[0];const c=o[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),u=h?h[1]:"",i=t?t[1]:"",g=isFinite(parseInt(i)),$=isFinite(parseInt(u));g&&n.push(`width="${i}"`),$&&n.push(`height="${u}"`)}return{href:s,dimensions:n}}e.$pk=a}),define(Pe[95],Re([1,0,18,45,19,21,25,12]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function f(g,$){const{os:d,tildify:S,relative:L}=$;if(L){const D=w(g,L,d);if(typeof D=="string")return D}let v=g.fsPath;if(d===1&&!A.$i?v=v.replace(/\//g,"\\"):d!==1&&A.$i&&(v=v.replace(/\\/g,"/")),d!==1&&S?.userHome){const D=S.userHome.fsPath;let T;g.scheme!==S.userHome.scheme&&g.path[0]===I.$gc.sep&&g.path[1]!==I.$gc.sep?T=S.userHome.with({path:g.path}).fsPath:T=v,v=l(T,D,d)}return(d===1?I.$fc:I.$gc).normalize(R(v,d===1))}e.$Vv=f;function w(g,$,d){const S=d===1?I.$fc:I.$gc,L=d===3?P.$xg:P.$zg,v=$.getWorkspace(),E=(0,y.$Ob)(v.folders);if(!E)return;g.scheme!==E.uri.scheme&&g.path[0]===I.$gc.sep&&g.path[1]!==I.$gc.sep&&(g=E.uri.with({path:g.path}));const D=$.getWorkspaceFolder(g);if(!D)return;let T;if(L.isEqual(D.uri,g)?T="":T=L.relativePath(D.uri,g)??"",T&&(T=S.normalize(T)),v.folders.length>1&&!$.noPrefix){const O=D.name?D.name:L.basenameOrAuthority(D.uri);T=T?`${O} \u2022 ${T}`:O}return T}function R(g,$=A.$i){return(0,M.$_f)(g,$)?g.charAt(0).toUpperCase()+g.slice(1):g}e.$Wv=R;let k=Object.create(null);function l(g,$,d=A.OS){if(d===1||!g||!$)return g;let S=k.original===$?k.normalized:void 0;S||(S=$,A.$i&&(S=(0,M.$2f)(S)),S=`${(0,m.$Ue)(S,I.$gc.sep)}${I.$gc.sep}`,k={original:$,normalized:S});let L=g;return A.$i&&(L=(0,M.$2f)(L)),(d===3?L.startsWith(S):(0,m.$af)(L,S))?`~/${L.substr(S.length)}`:g}e.$Xv=l;function p(g,$){return g.replace(/^~($|\/|\\)/,`${$}$1`)}e.$Yv=p;const b="\u2026",r="\\\\",a="~";function s(g,$=I.sep){const d=new Array(g.length);let S=!1;for(let L=0;L<g.length;L++){const v=g[L];if(v===""){d[L]=`.${$}`;continue}if(!v){d[L]=v;continue}S=!0;let E="",D=v;D.indexOf(r)===0?(E=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf($)===0?(E=D.substr(0,D.indexOf($)+$.length),D=D.substr(D.indexOf($)+$.length)):D.indexOf(a)===0&&(E=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length));const T=D.split($);for(let O=1;S&&O<=T.length;O++)for(let G=T.length-O;S&&G>=0;G--){S=!1;let q=T.slice(G,G+O).join($);for(let z=0;!S&&z<g.length;z++)if(z!==L&&g[z]&&g[z].indexOf(q)>-1){const C=G+O===T.length,N=G>0&&g[z].indexOf($)>-1?$+q:q,W=g[z].endsWith(N);S=!C||W}if(!S){let z="";(T[0].endsWith(":")||E!=="")&&(G===1&&(G=0,O++,q=T[0]+$+q),G>0&&(z=T[0]+$),z=E+z),G>0&&(z=z+b+$),z=z+q,G+O<T.length&&(z=z+$+b),d[L]=z}}S&&(d[L]=v)}return d}e.$Zv=s;var n;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(g,$=Object.create(null)){const d=[];let S=!1,L="";for(const v of g)if(v==="$"||S&&v==="{")L&&d.push({value:L,type:n.TEXT}),L="",S=!0;else if(v==="}"&&S){const E=$[L];if(typeof E=="string")E.length&&d.push({value:E,type:n.VARIABLE});else if(E){const D=d[d.length-1];(!D||D.type!==n.SEPARATOR)&&d.push({value:E.label,type:n.SEPARATOR})}L="",S=!1}else L+=v;return L&&!S&&d.push({value:L,type:n.TEXT}),d.filter((v,E)=>{if(v.type===n.SEPARATOR){const D=d[E-1],T=d[E+1];return[D,T].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$1v=o;function c(g,$){return A.$j||$?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):g.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$2v=c;function h(g,$){return A.$j||$?g.replace(/\(&&\w\)|&&/g,""):A.$i?g.replace(/&&|&/g,d=>d==="&"?"&&":"&"):g.replace(/&&/g,"_")}e.$3v=h;function t(g){return g.replace(/&/g,"&&")}e.$4v=t;function u(g){if(g.endsWith("]")){const $=g.lastIndexOf(" [",g.length-2);if($!==-1){const d=i(g.substring(0,$)),S=g.substring($);return{name:d.name+S,parentPath:d.parentPath}}}return i(g)}e.$5v=u;function i(g){const $=g.indexOf("/")!==-1?I.$gc:I.$fc,d=$.basename(g),S=$.dirname(g);return d.length?{name:d,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,22,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function I(k){return k.toJSON()}class A{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(M.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(M.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:M.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$4m=A,e.$5m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function P(k,l,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return l.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const r=P(k[b],l,p+1);r!==null&&(k[b]=r)}}return null}function m(k,l){const p=P(k,l,0);return p===null?k:p}e.$6m=m;function f(k,l,p,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?M.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof y.$je)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const a=f(k[r],l,p,b+1);a!==null&&(k[r]=a)}}return null}function w(k,l){const p=f(k,l,!1,0);return p===null?k:p}e.$7m=w;function R(k,l){const p=f(k,l,!0,0);return p===null?k:p}e.$8m=R}),define(Pe[140],Re([1,0,12,21,22]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let A;function P(){return A||(A=new TextDecoder("UTF-16LE")),A}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function R(){return w||(w=M.$D()?P():f()),w}e.$at=R;function k(b,r,a){const s=new Uint16Array(b.buffer,r,a);return a>0&&(s[0]===65279||s[0]===65534)?l(b,r,a):P().decode(s)}e.$bt=k;function l(b,r,a){const s=[];let n=0;for(let o=0;o<a;o++){const c=I.$le(b,r);r+=2,s[n++]=String.fromCharCode(c)}return s.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return R().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||y.$df(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<a;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$ct=p}),define(Pe[141],Re([1,0,22,140]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function I(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,R,k,l){this.oldPosition=w,this.oldText=R,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,R,k){const l=R.length;y.$oe(w,l,k),k+=4;for(let p=0;p<l;p++)y.$me(w,R.charCodeAt(p),k),k+=2;return k}static d(w,R){const k=y.$ne(w,R);return R+=4,(0,M.$bt)(w,R,k)}writeSize(){return 4+4+A.a(this.oldText)+A.a(this.newText)}write(w,R){return y.$oe(w,this.oldPosition,R),R+=4,y.$oe(w,this.newPosition,R),R+=4,R=A.c(w,this.oldText,R),R=A.c(w,this.newText,R),R}static read(w,R,k){const l=y.$ne(w,R);R+=4;const p=y.$ne(w,R);R+=4;const b=A.d(w,R);R+=A.a(b);const r=A.d(w,R);return R+=A.a(r),k.push(new A(l,b,p,r)),R}}e.$dt=A;function P(f,w){return f===null||f.length===0?w:new m(f,w).compress()}e.$et=P;class m{constructor(w,R){this.a=w,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,R=0,k=this.n(w),l=this.l(R);for(;w<this.f||R<this.h;){if(k===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(k),k=this.n(++w);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++R);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++w);continue}if(l.oldPosition<k.newPosition){const[s,n]=m.r(l,k.newPosition-l.oldPosition);this.k(s),l=n;continue}if(k.newPosition<l.oldPosition){const[s,n]=m.q(k,l.oldPosition-k.newPosition);this.m(s),k=n;continue}let r,a;if(l.oldEnd===k.newEnd)r=k,a=l,k=this.n(++w),l=this.l(++R);else if(l.oldEnd<k.newEnd){const[s,n]=m.q(k,l.oldLength);r=s,a=l,k=n,l=this.l(++R)}else{const[s,n]=m.r(l,k.newLength);r=k,a=s,k=this.n(++w),l=n}this.d[this.e++]=new A(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const p=m.s(this.d);return m.t(p)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,R){return new A(R.oldPosition-w,R.oldText,R.newPosition,R.newText)}static p(w,R){return new A(R.oldPosition,R.oldText,R.newPosition+w,R.newText)}static q(w,R){const k=w.newText.substr(0,R),l=w.newText.substr(R);return[new A(w.oldPosition,w.oldText,w.newPosition,k),new A(w.oldEnd,"",w.newPosition+R,l)]}static r(w,R){const k=w.oldText.substr(0,R),l=w.oldText.substr(R);return[new A(w.oldPosition,k,w.newPosition,w.newText),new A(w.oldPosition+R,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const R=[];let k=0,l=w[0];for(let p=1;p<w.length;p++){const b=w[p];l.oldEnd===b.oldPosition?l=new A(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(R[k++]=l,l=b)}return R[k++]=l,R}static t(w){if(w.length===0)return w;const R=[];let k=0;for(let l=0;l<w.length;l++){const p=w[l];p.oldText!==p.newText&&(R[k++]=p)}return R}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function I(A,P,m,f,w,R){if(Array.isArray(A)){let k=0;for(const l of A){const p=I(l,P,m,f,w,R);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof A=="string")return f?A==="*"?5:A===m?10:0:0;if(A){const{language:k,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:r}=A;if(!f&&!b)return 0;r&&w&&(P=w);let a=0;if(p)if(p===P.scheme)a=10;else if(p==="*")a=5;else return 0;if(k)if(k===m)a=10;else if(k==="*")a=Math.max(a,5);else return 0;if(r)if(r===R)a=10;else if(r==="*"&&R!==void 0)a=Math.max(a,5);else return 0;if(l){let s;if(typeof l=="string"?s=l:s={...l,base:(0,M.$hc)(l.base)},s===P.fsPath||(0,y.$Lj)(s,P.fsPath))a=10;else return 0}return a}else return 0}}e.$Bt=I}),define(Pe[143],Re([1,0,5,12,29,93,91,128,141,6]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class R extends w.$Tc{constructor(l,p,b,r,a,s,n){super(),this.m=this.B(new y.$Vd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!s,this.g=r,this.h=a,this.c=new P.$aC(l,b,n)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,r=this.getPositionAt(l),a=this.getPositionAt(b);return new I.$Us(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const s=this.n(p),n=this.getEOL();if(s.length!==n.length){const o=s.length-n.length,c=l.endLineNumber-l.startLineNumber;a=o*c}return r-b+a}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const r=l.startLineNumber,a=l.endLineNumber;for(let s=r;s<=a;s++){const n=this.getLineContent(s),o=s===r?l.startColumn-1:0,c=s===a?l.endColumn-1:n.length;for(let h=o;h<c;h++)M.$df(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n(p).length*(a-r),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=M.$1e(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=M.$3e(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let r=this.g,a=this.h,s=this.j,n=!0,o=[];for(let $=0;$<l.length;$++){const d=l[$];n&&d._isTracked&&(n=!1);const S=d.range;if(d.text){let T=!0;s||(T=!M.$of(d.text),s=T),!r&&T&&(r=M.$nf(d.text)),!a&&T&&(a=M.$qf(d.text))}let L="",v=0,E=0,D=0;if(d.text){let T;[v,E,D,T]=(0,m.$ut)(d.text);const O=this.getEOL();T===0||T===(O===`\r
`?2:1)?L=d.text:L=d.text.replace(/\r\n|\r|\n/g,O)}o[$]={sortIndex:$,identifier:d.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:v,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}o.sort(R.u);let c=!1;for(let $=0,d=o.length-1;$<d;$++){const S=o[$].range.getEndPosition(),L=o[$+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=b||p?R._getInverseEditRanges(o):[],t=[];if(p)for(let $=0;$<o.length;$++){const d=o[$],S=h[$];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let v="";L===S.startLineNumber&&(v=this.getLineContent(d.range.startLineNumber),M.$1e(v)!==-1)||t.push({lineNumber:L,oldContent:v})}}let u=null;if(b){let $=0;u=[];for(let d=0;d<o.length;d++){const S=o[d],L=h[d],v=this.getValueInRange(S.range),E=S.rangeOffset+$;$+=S.text.length-v.length,u[d]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:v,textChange:new f.$dt(S.rangeOffset,v,E,S.text)}}c||u.sort((d,S)=>d.sortIndex-S.sortIndex)}this.g=r,this.h=a,this.j=s;const i=this.t(o);let g=null;if(p&&t.length>0){t.sort(($,d)=>d.lineNumber-$.lineNumber),g=[];for(let $=0,d=t.length;$<d;$++){const S=t[$].lineNumber;if($>0&&t[$-1].lineNumber===S)continue;const L=t[$].oldContent,v=this.getLineContent(S);v.length===0||v===L||M.$1e(v)!==-1||g.push(S)}}return this.m.fire(),new A.$ev(u,i,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,r=l[l.length-1].range,a=new I.$Us(b.startLineNumber,b.startColumn,r.endLineNumber,r.endColumn);let s=b.startLineNumber,n=b.startColumn;const o=[];for(let i=0,g=l.length;i<g;i++){const $=l[i],d=$.range;p=p||$.forceMoveMarkers,o.push(this.getValueInRange(new I.$Us(s,n,d.startLineNumber,d.startColumn))),$.text.length>0&&o.push($.text),s=d.endLineNumber,n=d.endColumn}const c=o.join(""),[h,t,u]=(0,m.$ut)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:u,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const p=[];for(let b=0;b<l.length;b++){const r=l[b],a=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,o=r.range.endColumn;if(a===n&&s===o&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new I.$Us(a,s,n,o);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,r){return this.c.findMatchesLineByLine(l,p,b,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,r=l.startColumn,[a,s,n]=(0,m.$ut)(p);let o;if(p.length>0){const c=a+1;c===1?o=new I.$Us(b,r,b,r+s):o=new I.$Us(b,r,b+c-1,n+1)}else o=new I.$Us(b,r,b,r);return o}static _getInverseEditRanges(l){const p=[];let b=0,r=0,a=null;for(let s=0,n=l.length;s<n;s++){const o=l[s];let c,h;a?a.range.endLineNumber===o.range.startLineNumber?(c=b,h=r+(o.range.startColumn-a.range.endColumn)):(c=b+(o.range.startLineNumber-a.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let t;if(o.text.length>0){const u=o.eolCount+1;u===1?t=new I.$Us(c,h,c,h+o.firstLineLength):t=new I.$Us(c,h,c+u-1,o.lastLineLength+1)}else t=new I.$Us(c,h,c,h);b=t.endLineNumber,r=t.endColumn,p.push(t),a=o}return p}static u(l,p){const b=I.$Us.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=I.$Us.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$bC=R}),define(Pe[144],Re([1,0,12,91,143]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class A{constructor(f,w,R,k,l,p,b,r,a){this.a=f,this.b=w,this.c=R,this.d=k,this.e=l,this.f=p,this.g=b,this.h=r,this.j=a}k(f){const w=this.c+this.d+this.e,R=this.c+this.e;return w===0?f===1?`
`:`\r
`:R>w/2?`\r
`:`
`}create(f){const w=this.k(f),R=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,p=R.length;l<p;l++){const b=R[l].buffer.replace(/\r\n|\r|\n/g,w),r=(0,M.$9B)(b);R[l]=new M.$_B(b,r)}const k=new I.$bC(R,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class P{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&y.$wf(f)&&(this.b=y.$vf,f=f.substr(1));const w=f.charCodeAt(f.length-1);w===13||w>=55296&&w<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=w):(this.m(f,!1),this.c=!1,this.d=w)}m(f,w){!w&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const w=(0,M.$0B)(this.e,f);this.a.push(new M.$_B(f,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=y.$nf(f)),this.k||(this.k=y.$qf(f)))}finish(f=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const w=(0,M.$9B)(f.buffer);f.lineStarts=w,this.d===13&&this.f++}}}e.$cC=P}),define(Pe[96],Re([1,0,22,21]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function A(k){for(let l=0,p=k.length;l<p;l+=4){const b=k[l+0],r=k[l+1],a=k[l+2],s=k[l+3];k[l+0]=s,k[l+1]=a,k[l+2]=r,k[l+3]=b}}function P(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||A(l),y.$je.wrap(l)}function m(k){const l=k.buffer;if(M.$D()||A(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function f(k){const l=new Uint32Array(w(k));let p=0;if(l[p++]=k.id,k.type==="full")l[p++]=1,l[p++]=k.data.length,l.set(k.data,p),p+=k.data.length;else{l[p++]=2,l[p++]=k.deltas.length;for(const b of k.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return P(l)}e.$w$=f;function w(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(l+=p.data.length)}return l}function R(k){const l=m(k);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],o=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:o}}const a=l[p++],s=[];for(let n=0;n<a;n++){const o=l[p++],c=l[p++],h=l[p++];let t;h>0&&(t=l.subarray(p,p+h),p+=h),s[n]={start:o,deleteCount:c,data:t}}return{id:b,type:"delta",deltas:s}}e.$x$=R}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}compute(_,pe,Be){return Be}}class l{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=l;function p(X,_){if(typeof X!="object"||typeof _!="object"||!X||!_)return new l(_,X!==_);if(Array.isArray(X)||Array.isArray(_)){const Be=Array.isArray(X)&&Array.isArray(_)&&y.$ub(X,_);return new l(_,!Be)}let pe=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(X[Be],_[Be]);Qe.didChange&&(X[Be]=Qe.newValue,pe=!0)}return new l(X,pe)}class b{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return p(_,pe)}validate(_){return this.defaultValue}}class r{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,Be){return Be}}function a(X,_){return typeof X>"u"?_:X==="false"?!1:!!X}e.boolean=a;class s extends r{constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return a(_,this.defaultValue)}}function n(X,_,pe,Be){if(typeof X>"u")return _;let Qe=parseInt(X,10);return isNaN(Qe)?_:(Qe=Math.max(pe,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class o extends r{static clampedInt(_,pe,Be,Qe){return n(_,pe,Be,Qe)}constructor(_,pe,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,pe,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return o.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(X,_,pe,Be){if(typeof X>"u")return _;const Qe=h.float(X,_);return h.clamp(Qe,pe,Be)}e.clampedFloat=c;class h extends r{static clamp(_,pe,Be){return _<pe?pe:_>Be?Be:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const Be=parseFloat(_);return isNaN(Be)?pe:Be}constructor(_,pe,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,pe,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class t extends r{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return t.string(_,this.defaultValue)}}function u(X,_,pe,Be){return typeof X!="string"?_:Be&&X in Be?Be[X]:pe.indexOf(X)===-1?_:X}e.stringSet=u;class i extends r{constructor(_,pe,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,pe,Be,it),this.c=Qe}validate(_){return u(_,this.defaultValue,this.c)}}class g extends k{constructor(_,pe,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,pe,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function $(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,Be){return Be===0?_.accessibilitySupport:Be}}class S extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:m.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(X){switch(X){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function T(X){switch(X){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class O extends b{constructor(){super(140)}compute(_,pe,Be){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(_,pe,Be){return Be&&_.emptySelectionClipboard}}class q extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:m.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":u(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":u(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class z extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?z.OFF:_==="true"?z.ON:_:_?z.ON:z.OFF}}e.EditorFontLigatures=z;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?C.OFF:_==="true"?C.TRANSLATE:_:_?C.TRANSLATE:C.OFF}compute(_,pe,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class N extends b{constructor(){super(50)}compute(_,pe,Be){return _.fontInfo}}class W extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(_){const pe=h.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(_,pe,Be){return _.fontInfo.fontSize}}class ae extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(o.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class de extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:u(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??u(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??u(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??u(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??u(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??u(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:m.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var ye;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class le extends b{constructor(){super(143)}compute(_,pe,Be){return le.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,pe){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=pe.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Kt=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Ht=_.minimap.maxColumn,Nt=_.minimap.size,Yt=_.minimap.side,zt=_.verticalScrollbarWidth,Rt=_.viewLineCount,Ze=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let Ut=!1,Vt=!1,kt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Se,desiredRatio:Fe,minimapLineCount:fe}=le.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Kt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/fe>1)Ut=!0,Vt=!0,yt=1,kt=1,dt=yt/it;else{let Me=!1,je=yt+1;if(Nt==="fit"){const Ye=Math.ceil((Ft+Rt+Se)*kt);Gt&&Ne&&Ze<=pe.stableFitRemainingWidth?(Me=!0,je=pe.stableFitMaxMinimapScale):Me=Ye>lt}if(Nt==="fill"||Me){Ut=!0;const Ye=yt;kt=Math.min(Pt*it,Math.max(1,Math.floor(1/Fe))),Gt&&Ne&&Ze<=pe.stableFitRemainingWidth&&(je=pe.stableFitMaxMinimapScale),yt=Math.min(je,Math.max(1,Math.floor(kt/Jt))),yt>Ye&&(Ct=Math.min(2,yt/Ye)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Ft+Rt+Se)*kt),Gt?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Ze,pe.stableFitMaxMinimapScale=yt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const xt=Math.floor(Ht*dt),Dt=Math.min(xt,Math.max(0,Math.floor((Ze-zt-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*Dt);const Mt=qe/it;qe=Math.floor(qe*Ct);const Wt=Bt?1:2,Qt=Yt==="left"?0:Be-Dt-zt;return{renderMinimap:Wt,minimapLeft:Qt,minimapWidth:Dt,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Vt,minimapScale:yt,minimapLineHeight:kt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(_,pe){const Be=pe.outerWidth|0,Qe=pe.outerHeight|0,it=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,Pt=pe.maxDigitWidth,Tt=pe.pixelRatio,Kt=pe.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Ht=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Yt=pe.isDominatedByLongLines,zt=_.get(57),Rt=_.get(67).renderType!==0,Ze=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),Ut=$t.verticalScrollbarSize,Vt=$t.verticalHasArrows,kt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let Dt=_.get(65);Ct&&xt&&(Dt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ze);qe=Math.round(_e*Pt)}let Mt=0;zt&&(Mt=it*pe.glyphMarginDecorationLaneCount);let Wt=0,Qt=Wt+Mt,ft=Qt+qe,Ft=ft+Dt;const Se=Be-Mt-qe-Dt;let Fe=!1,fe=!1,J=-1;yt==="inherit"&&Yt?(Fe=!0,fe=!0):Ht==="on"||Ht==="bounded"?fe=!0:Ht==="wordWrapColumn"&&(J=Nt);const Me=le.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:Ut,viewLineCount:Kt,remainingWidth:Se,isViewportWrapping:fe},pe.memory||new R);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Wt+=Me.minimapWidth,Qt+=Me.minimapWidth,ft+=Me.minimapWidth,Ft+=Me.minimapWidth);const je=Se-Me.minimapWidth,Ye=Math.max(1,Math.floor((je-Ut-2)/Ne)),We=Vt?kt:0;return fe&&(J=Math.max(1,Ye),Ht==="bounded"&&(J=Math.min(J,Nt))),{width:Be,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Dt,contentLeft:Ft,contentWidth:je,minimap:Me,viewportColumn:Ye,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:J,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:dt,overviewRuler:{top:We,width:Ut,height:Qe-2*We,right:0}}}}e.EditorLayoutInfoComputer=le;class $e extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(_){return u(_,"simple",["simple","advanced"])}compute(_,pe,Be){return pe.get(2)===2?"advanced":Be}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class be extends k{constructor(){const _={enabled:ie.On};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[ie.Off,ie.OnCode,ie.On],default:_.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:u(_.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class se extends k{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:m.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:m.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Z extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:m.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:u(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):o.clampedInt(_,this.defaultValue,0,1e3)}compute(_,pe,Be){return Be<0?o.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:m.localize(66,null)})}compute(_,pe,Be){return _.fontInfo.lineHeight}}class Ie extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:_.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:m.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:u(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(pe.side,this.defaultValue.side,["right","left"]),showSlider:u(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(X){return X==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class ce extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:m.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class te extends b{constructor(){super(141)}compute(_,pe,Be){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:_.comments,description:m.localize(86,null)},other:{anyOf:pe,default:_.other,description:m.localize(87,null)}},default:_,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=u(pe,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=u(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=u(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var ee;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class me extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(_){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,Be=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function ve(X){const _=X.get(97);return _==="editable"?X.get(90):_!=="on"}e.filterValidationDecorations=ve;class Ae extends k{constructor(){const _=[],pe={type:"number",description:m.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:_,description:m.localize(96,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const Be of _)if(typeof Be=="number")pe.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;pe.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Be,Qe)=>Be.column-Qe.column),pe}return this.defaultValue}}class he extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function Ee(X,_){if(typeof X!="string")return _;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,Be=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ee(pe.vertical,this.defaultValue.vertical),horizontal:Ee(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:m.localize(115,null)}})}applyUpdate(_,pe){let Be=!1;pe.allowedCharacters&&_&&(M.$zn(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&_&&(M.$zn(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,pe);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class K extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:m.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:u(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class j extends k{constructor(){const _={enabled:A.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:m.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],default:_.bracketPairs,description:m.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(128,null),m.localize(129,null),m.localize(130,null)],default:_.bracketPairsHorizontal,description:m.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:m.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:m.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(134,null),m.localize(135,null),m.localize(136,null)],default:_.highlightActiveIndentation,description:m.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,_,pe){const Be=pe.indexOf(X);return Be===-1?_:pe[Be]}class ke extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(138,null),m.localize(139,null)],default:_.insertMode,description:m.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:m.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:m.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:m.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(144,null),m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:_.selectionMode,markdownDescription:m.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:m.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:m.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:m.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:m.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:m.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:u(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:u(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ke extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(188,null),m.localize(189,null),m.localize(190,null),m.localize(191,null)],description:m.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,Be){return pe.get(2)===2?0:Be}}class Xe extends b{constructor(){super(144)}compute(_,pe,Be){const Qe=pe.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(195,null),m.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:u(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(199,null),m.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:u(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?at:I.$k?ct:tt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var vt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(201,null)})),acceptSuggestionOnEnter:Ue(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(202,null),""],markdownDescription:m.localize(203,null)})),accessibilitySupport:Ue(new d),accessibilityPageSize:Ue(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(204,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(205,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoClosingComments:Ue(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(210,null),m.localize(211,null),""],description:m.localize(212,null)})),autoClosingDelete:Ue(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(213,null),""],description:m.localize(214,null)})),autoClosingOvertype:Ue(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(215,null),""],description:m.localize(216,null)})),autoClosingQuotes:Ue(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),autoIndent:Ue(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],$,{enumDescriptions:[m.localize(220,null),m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null)],description:m.localize(225,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(226,null),m.localize(227,null),m.localize(228,null),""],description:m.localize(229,null)})),bracketPairColorization:Ue(new j),bracketPairGuides:Ue(new Y),stickyTabStops:Ue(new s(115,"stickyTabStops",!1,{description:m.localize(230,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(231,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(232,null)})),codeLensFontSize:Ue(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(233,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(234,null)})),colorDecoratorActivatedOn:Ue(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),colorDecoratorsLimit:Ue(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(239,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(240,null)})),comments:Ue(new S),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(241,null)})),cursorBlinking:Ue(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:m.localize(242,null)})),cursorSmoothCaretAnimation:Ue(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),cursorStyle:Ue(new g(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(247,null)})),cursorSurroundingLines:Ue(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(248,null)})),cursorSurroundingLinesStyle:Ue(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(249,null),m.localize(250,null)],markdownDescription:m.localize(251,null)})),cursorWidth:Ue(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(252,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(253,null)})),emptySelectionClipboard:Ue(new G),dropIntoEditor:Ue(new st),stickyScroll:Ue(new se),experimentalWhitespaceRendering:Ue(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(258,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(259,null)})),foldingStrategy:Ue(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(263,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(264,null)})),foldingMaximumRegions:Ue(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(265,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(266,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(267,null)})),fontInfo:Ue(new N),fontLigatures2:Ue(new z),fontSize:Ue(new W),fontWeight:Ue(new ae),fontVariations:Ue(new C),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(268,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(269,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(270,null)})),gotoLocation:Ue(new de),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(271,null)})),hover:Ue(new we),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:m.localize(272,null)})),lightbulb:Ue(new be),lineDecorationsWidth:Ue(new V),lineHeight:Ue(new ne),lineNumbers:Ue(new me),lineNumbersMinChars:Ue(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(69,"linkedEditing",!1,{description:m.localize(273,null)})),links:Ue(new s(70,"links",!0,{description:m.localize(274,null)})),matchBrackets:Ue(new i(71,"matchBrackets","always",["always","near","never"],{description:m.localize(275,null)})),minimap:Ue(new Ie),mouseStyle:Ue(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(276,null)})),mouseWheelZoom:Ue(new s(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?m.localize(277,null):m.localize(278,null)})),multiCursorMergeOverlapping:Ue(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:Ue(new g(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:Ue(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:Ue(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:Ue(new i(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:Ue(new s(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:Ue(new o(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Ce),pasteAs:Ue(new nt),parameterHints:Ue(new ce),peekWidgetDefaultFocus:Ue(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:Ue(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:Ue(new s(90,"readOnly",!1)),readOnlyMessage:Ue(new he),renameOnType:Ue(new s(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:Ue(new s(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:Ue(new i(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:Ue(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:Ue(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:Ue(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:Ue(new Ae),scrollbar:Ue(new F),scrollBeyondLastColumn:Ue(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:Ue(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:Ue(new s(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:Ue(new s(106,"selectionClipboard",!0,{description:m.localize(312,null),included:I.$k})),selectionHighlight:Ue(new s(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:Ue(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:Ue(new s(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:Ue(new s(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:Ue(new Z),snippetSuggestions:Ue(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:Ue(new Te),smoothScrolling:Ue(new s(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:Ue(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ke),inlineSuggest:Ue(new K),inlineCompletionsAccessibilityVerbose:Ue(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:Ue(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:Ue(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:Ue(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:Ue(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new H),unusualLineTerminators:Ue(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:Ue(new s(126,"useShadowDOM",!0)),useTabStops:Ue(new s(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:Ue(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:Ue(new t(129,"wordSeparators",P.$ts,{description:m.localize(346,null)})),wordWrap:Ue(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:Ue(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:Ue(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new O),defaultColorDecorators:Ue(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:Ue(new te),tabFocusMode:Ue(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:Ue(new le),wrappingInfo:Ue(new Xe),wrappingIndent:Ue(new Ke),wrappingStrategy:Ue(new $e)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function A(...w){switch(w.length){case 1:return(0,M.localize)(0,null,w[0]);case 2:return(0,M.localize)(1,null,w[0],w[1]);case 3:return(0,M.localize)(2,null,w[0],w[1],w[2]);default:return}}const P=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),l=f.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const b=this.c.charCodeAt(R);if(k)k=!1;else if(b===47&&!l){R++;break}else b===91?l=!0:b===92?k=!0:b===93&&(l=!1);R++}for(;R<this.c.length&&f.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=f}),define(Pe[181],Re([1,0,25,31,152,294]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(s){return s=s.trim(),s==="*"||P.test(s)}e.$ap=f;function w(s){if(!f(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(P);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$bp=w;function R(s){if(!s)return null;const n=s.majorBase,o=s.majorMustEqual,c=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let u=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),u=!1);let i=0;if(s.preRelease){const g=m.exec(s.preRelease);if(g){const[,$,d,S]=g;i=Date.UTC(Number($),Number(d)-1,Number(S))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:u,isMinimum:s.hasGreaterEquals,notBefore:i}}e.$cp=R;function k(s,n,o){let c;typeof s=="string"?c=R(w(s)):c=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof o=="string"?t=R(w(o)):t=o,!c||!t)return!1;const u=c.majorBase,i=c.minorBase,g=c.patchBase;let $=t.majorBase,d=t.minorBase,S=t.patchBase;const L=t.notBefore;let v=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?u>$?!0:u<$?!1:i>d?!0:i<d||h&&h<L?!1:g>=S:(u===1&&$===0&&(!v||!E||!D)&&($=1,d=0,S=0,v=!0,E=!1,D=!1),u<$?!1:u>$?!v:i<d?!1:i>d?!E:g<S?!1:g>S?!D:!(h&&h<L))}e.$dp=k;function l(s,n,o,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([M.default.Error,I.localize(0,null)]),t;if(typeof c.name!="string")return t.push([M.default.Error,I.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([M.default.Error,I.localize(2,null,"version")]),t;if(!c.engines)return t.push([M.default.Error,I.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([M.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([M.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([M.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([M.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([M.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([M.default.Error,I.localize(9,null,"main")]),t;{const g=(0,y.$Hg)(o,c.main);(0,y.$Bg)(g,o)||t.push([M.default.Warning,I.localize(10,null,g.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([M.default.Error,I.localize(11,null,"browser")]),t;{const g=(0,y.$Hg)(o,c.browser);(0,y.$Bg)(g,o)||t.push([M.default.Warning,I.localize(12,null,g.path,o.path)])}}if(!A.valid(c.version))return t.push([M.default.Error,I.localize(13,null)]),t;const u=[];if(!p(s,n,c,h,u))for(const g of u)t.push([M.default.Error,g]);return t}e.$ep=l;function p(s,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:r(s,n,o.engines.vscode,h)}e.$fp=p;function b(s,n,o){return s==="*"||r(n,o,s)}e.$gp=b;function r(s,n,o,c=[]){const h=R(w(o));if(!h)return c.push(I.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,o)),!1;return k(s,n,h)?!0:(c.push(I.localize(17,null,s,o)),!1)}function a(s){if(!Array.isArray(s))return!1;for(let n=0,o=s.length;n<o;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class y{constructor(I,A=[],P=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.$3h=y}),define(Pe[53],Re([1,0,70]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const M=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function A(m,f,w){f instanceof y.$3h||(f=new y.$3h(f,[],!!w)),M.push([m,f])}e.$Yr=A;function P(){return M}e.$Zr=P}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class y{constructor(A,P){this.key=A,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=y;class M{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const P of this.a.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const m=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(P);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(A){const P=this.b(A);this.a.delete(P);for(const m of this.a.values())m.outgoing.delete(P),m.incoming.delete(P)}lookupOrInsertNode(A){const P=this.b(A);let m=this.a.get(P);return m||(m=new y(P,A),this.a.set(P,m)),m}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[P,m]of this.a)A.push(`${P}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,P]of this.a){const m=new Set([A]),f=this.c(P,m);if(f)return f}}c(A,P){for(const[m,f]of A.outgoing){if(P.has(m))return[...P,m].join(" -> ");P.add(m);const w=this.c(f,P);if(w)return w;P.delete(m)}}}e.$Dq=M}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var y;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(y||(e._util=y={})),e.$5h=I("instantiationService");function M(P,m,f){m[y.DI_TARGET]===m?m[y.DI_DEPENDENCIES].push({id:P,index:f}):(m[y.DI_DEPENDENCIES]=[{id:P,index:f}],m[y.DI_TARGET]=m)}function I(P){if(y.serviceIds.has(P))return y.serviceIds.get(P);const m=function(f,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,f,R)};return m.toString=()=>P,y.serviceIds.set(P,m),m}e.$6h=I;function A(P){return P}e.$7h=A}),define(Pe[46],Re([1,0,16,2,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,I.$6h)("configurationService");function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}e.$Ai=A;function P(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}e.$Bi=P;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=f;function w(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Di=w;function R(s,n){const o=Object.create(null);for(const c in s)k(o,c,s[c],n);return o}e.$Ei=R;function k(s,n,o,c){const h=n.split("."),t=h.pop();let u=s;for(let i=0;i<h.length;i++){const g=h[i];let $=u[g];switch(typeof $){case"undefined":$=u[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,i+1).join(".")} is ${JSON.stringify($)}`);return}u=$}if(typeof u=="object"&&u!==null)try{u[t]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}e.$Fi=k;function l(s,n){const o=n.split(".");p(s,o)}e.$Gi=l;function p(s,n){const o=n.shift();if(n.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const c=s[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete s[o])}}function b(s,n,o){function c(u,i){let g=u;for(const $ of i){if(typeof g!="object"||g===null)return;g=g[$]}return g}const h=n.split("."),t=c(s,h);return typeof t>"u"?o:t}e.$Hi=b;function r(s,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?y.$Kf(s[c])&&y.$Kf(n[c])?r(s[c],n[c],o):o&&(s[c]=n[c]):s[c]=n[c])})}e.$Ii=r;function a(s){return s.replace(/[\[\]]/g,"")}e.$Ji=a}),define(Pe[35],Re([1,0,21,12,180,4,149,15]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",y.$j),f.set("isLinux",y.$k),f.set("isWindows",y.$i),f.set("isWeb",y.$o),f.set("isMacNative",y.$j&&!y.$o),f.set("isEdge",y.$H),f.set("isFirefox",y.$F),f.set("isChrome",y.$E),f.set("isSafari",y.$G);function w(Z,V){if(f.get(Z)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Z,V)}e.$2i=w;const R=Object.prototype.hasOwnProperty;var k;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},p=(0,P.localize)(0,null),b=(0,P.localize)(1,null),r=(0,P.localize)(2,null),a=(0,P.localize)(3,null),s=(0,P.localize)(4,null),n=(0,P.localize)(5,null),o=(0,P.localize)(6,null),c=(0,P.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Le=Ie.type===17?n:void 0;throw this.h.push({message:s,offset:Ie.offset,lexeme:I.$1i.getLexeme(Ie),additionalInfo:Le}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),$.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,a),ne?.negate()}case 17:return this.z(),T.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,a),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ce=Le.lexeme,ce=Ce.lastIndexOf("/"),te=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),te)}catch{throw this.B("REGEX",Le)}return N.create(ne,Q)}switch(Le.type){case 10:case 19:{const Ce=[Le.lexeme];this.z();let ce=this.D(),te=0;for(let Ae=0;Ae<Le.lexeme.length;Ae++)Le.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--}if(te<0)break;Ce.push(I.$1i.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),me=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let ve;try{ve=new RegExp(Q.substring(1,ee),me)}catch{throw this.B("REGEX",Le)}return t.regex(ne,ve)}case 18:{const Ce=Le.lexeme;this.z();let ce=null;if(!(0,M.$Je)(Ce)){const te=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(te!==Q&&te>=0){const ee=Ce.slice(te+1,Q),me=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,me)}catch{throw this.B("REGEX",Le)}}}if(ce===null)throw this.B("REGEX",Le);return N.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Le=this.u();return t.notIn(ne,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return t.equals(ne,Le);switch(Le){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return t.notEquals(ne,Le);switch(Le){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Le)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),q.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Le=(0,P.localize)(8,null,V,I.$1i.getLexeme(ne)),Ce=ne.offset,ce=I.$1i.getLexeme(ne);return this.h.push({message:Le,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=h;class t{static false(){return $.INSTANCE}static true(){return d.INSTANCE}static has(V){return S.create(V)}static equals(V,ne){return L.create(V,ne)}static notEquals(V,ne){return D.create(V,ne)}static regex(V,ne){return N.create(V,ne)}static in(V,ne){return v.create(V,ne)}static notIn(V,ne){return E.create(V,ne)}static not(V){return T.create(V)}static and(...V){return de.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ne){return G.create(V,ne)}static greaterEquals(V,ne){return q.create(V,ne)}static smaller(V,ne){return z.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=t;function u(Z){const V=new h({regexParsingWithErrorRecovery:!1});return Z.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,P.localize)(9,null,Ie.additionalInfo):(0,P.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$5i=u;function i(Z,V){const ne=Z?Z.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$6i=i;function g(Z,V){return Z.cmp(V)}class ${static{this.INSTANCE=new $}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$7i=$;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return $.INSTANCE}}e.$8i=d;class S{static create(V,ne=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?d.INSTANCE:$.INSTANCE:new S(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:$.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$9i=S;class L{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?S.create(V,Ie):T.create(V,Ie);const Le=f.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?d.INSTANCE:$.INSTANCE:new L(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?d.INSTANCE:$.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$0i=L;class v{static create(V,ne){return new v(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$$i=v;class E{static create(V,ne){return new E(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=v.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=E;class D{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?T.create(V,Ie):S.create(V,Ie);const Le=f.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?$.INSTANCE:d.INSTANCE:new D(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?$.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$aj=D;class T{static create(V,ne=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?$.INSTANCE:d.INSTANCE:new T(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?$.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$bj=T;function O(Z,V){if(typeof Z=="string"){const ne=parseFloat(Z);isNaN(ne)||(Z=ne)}return typeof Z=="string"||typeof Z=="number"?V(Z):$.INSTANCE}class G{static create(V,ne,Ie=null){return O(ne,Le=>new G(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$cj=G;class q{static create(V,ne,Ie=null){return O(ne,Le=>new q(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$dj=q;class z{static create(V,ne,Ie=null){return O(ne,Le=>new z(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$ej=z;class C{static create(V,ne,Ie=null){return O(ne,Le=>new C(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=C;class N{static create(V,ne){return new N(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$gj=N;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$hj=W;function ae(Z){let V=null;for(let ne=0,Ie=Z.length;ne<Ie;ne++){const Le=Z[ne].substituteConstants();if(Z[ne]!==Le&&V===null){V=[];for(let Ce=0;Ce<ne;Ce++)V[Ce]=Z[Ce]}V!==null&&(V[ne]=Le)}return V===null?Z:V}class de{static create(V,ne,Ie){return de.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Le=g(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:de.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Le=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return $.INSTANCE;if(ce.type===6){Le.push(...ce.expr);continue}Le.push(ce)}if(Le.length===0&&Ce)return d.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(g);for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ce=Le[Le.length-1];if(ce.type!==9)break;Le.pop();const te=Le.pop(),Q=Le.length===0,ee=we.create(ce.expr.map(me=>de.create([me,te],null,Ie)),null,Q);ee&&(Le.push(ee),Le.sort(g))}if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return $.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new de(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=we.create(V,this,!0)}return this.c}}e.$ij=de;class we{static create(V,ne,Ie){return we.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Le=g(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Le=[],Ce=!1;if(V){for(let ce=0,te=V.length;ce<te;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return d.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&Ce)return $.INSTANCE;Le.sort(g)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return d.INSTANCE;if(Le.length===1)return Le[0]}return new we(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new we(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Le=[];for(const Ce of se(ne))for(const ce of se(Ie))Le.push(de.create([Ce,ce],null,!1));V.unshift(we.create(Le,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$jj=we;class ye extends S{static{this.d=[]}static all(){return ye.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?ye.d.push({...Ie,key:V}):Ie!==!0&&ye.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$kj=ye,e.$lj=(0,A.$6h)("contextKeyService");function le(Z,V){return Z<V?-1:Z>V?1:0}function $e(Z,V,ne,Ie){return Z<ne?-1:Z>ne?1:V<Ie?-1:V>Ie?1:0}function ie(Z,V){if(Z.type===0||V.type===1)return!0;if(Z.type===9)return V.type===9?be(Z.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(ie(Z,ne))return!0;return!1}if(Z.type===6){if(V.type===6)return be(V.expr,Z.expr);for(const ne of Z.expr)if(ie(ne,V))return!0;return!1}return Z.equals(V)}e.$mj=ie;function be(Z,V){let ne=0,Ie=0;for(;ne<Z.length&&Ie<V.length;){const Le=Z[ne].cmp(V[Ie]);if(Le<0)return!1;Le===0&&ne++,Ie++}return ne===Z.length}function se(Z){return Z.type===9?Z.expr:[Z]}}),define(Pe[183],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,y.$6h)("environmentService"),e.$bi=(0,y.$7h)(e.$ai)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function I(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=I;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=A;function P(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=P;function m(o,c){return c==="web"&&!o.includes("web")}e.$vo=m;function f(o,c,h){return m(c,h)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===h}e.$wo=f;function w(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$xo=w;var R;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var k;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$yo=(0,M.$6h)("extensionGalleryService");var b;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class a extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$zo=a;var s;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Ao=n,e.$Bo=(0,M.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,M.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,M.$6h)("IExtensionTipsService"),e.$Go=(0,y.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,y.localize2)(1,"Preferences")}),define(Pe[41],Re([1,0,50,19,12,16,2,153,4,21,11,39]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,f.$6h)("fileService");function l(ie){return ie.create===!0}e.$rk=l;var p;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function r(ie){const be=ie;return!!be&&typeof be.onDidChange=="function"}e.$sk=r;var a;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function s(ie){return!!(ie.capabilities&2)}e.$tk=s;function n(ie){return!!(ie.capabilities&8)}e.$uk=n;function o(ie){return!!(ie.capabilities&131072)}e.$vk=o;function c(ie){return!!(ie.capabilities&4)}e.$wk=c;function h(ie){return!!(ie.capabilities&16)}e.$xk=h;function t(ie){return s(ie)?!!(ie.capabilities&16384):!1}e.$yk=t;function u(ie){return s(ie)?!!(ie.capabilities&32768):!1}e.$zk=u;function i(ie){return!!(ie.capabilities&65536)}e.$Ak=i;function g(ie){return!!(ie.capabilities&2048)}e.$Bk=g;var $;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class d extends Error{static create(be,se){const Z=new d(be.toString(),se);return v(Z,se),Z}constructor(be,se){super(be),this.code=se}}e.$Ck=d;function S(ie,be){return d.create(ie,be)}e.$Dk=S;function L(ie){return ie||S((0,m.localize)(0,null),$.Unknown)}e.$Ek=L;function v(ie,be){return ie.name=be?`${be} (FileSystemError)`:"FileSystemError",ie}e.$Fk=v;function E(ie){if(!ie)return $.Unknown;if(ie instanceof d)return ie.code;const be=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!be)return $.Unknown;switch(be[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}e.$Gk=E;function D(ie){if(ie instanceof C)return ie.fileOperationResult;switch(E(ie)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}e.$Hk=D;var T;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class O{constructor(be,se,Z){this.resource=be,this.operation=se,this.target=Z}isOperation(be){return this.operation===be}}e.$Ik=O;var G;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor(be,se){this.c=se,this.b=void 0,this.d=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawAdded.map(V=>[V,!0])),Z}),this.f=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(V=>[V,!0])),Z}),this.g=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(V=>[V,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of be){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.b!==q.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(be,...se){return this.h(be,{includeChildren:!1},...se)}affects(be,...se){return this.h(be,{includeChildren:!0},...se)}h(be,se,...Z){if(!be)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.d.value.get(be)||se.includeChildren&&this.d.value.findSuperstr(be))||(!V||Z.includes(0))&&(this.f.value.get(be)||se.includeChildren&&this.f.value.findSuperstr(be))||(!V||Z.includes(2))&&(this.g.value.findSubstr(be)||se.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=q;function z(ie,be,se){return!ie||!be||ie===be||be.length>ie.length?!1:(be.charAt(be.length-1)!==M.sep&&(be+=M.sep),se?(0,I.$af)(ie,be):ie.indexOf(be)===0)}e.$Kk=z;class C extends Error{constructor(be,se,Z){super(be),this.fileOperationResult=se,this.options=Z}}e.$Lk=C;class N extends C{constructor(be,se,Z,V){super(be,se,V),this.fileOperationResult=se,this.size=Z}}e.$Mk=N;class W extends C{constructor(be,se,Z){super(be,2,Z),this.stat=se}}e.$Nk=W;var ae;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var de;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Vk="";function we(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Wk=we;async function ye(ie,be){if(!be.hasProvider(P.URI.from({scheme:ie.scheme})))return new Promise(se=>{const Z=be.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ie.scheme&&V.added&&(Z.dispose(),se())})})}e.$Xk=ye;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(be){return(0,A.$Mf)(be)||(be=0),be<le.KB?(0,m.localize)(1,null,be.toFixed(0)):be<le.MB?(0,m.localize)(2,null,(be/le.KB).toFixed(2)):be<le.GB?(0,m.localize)(3,null,(be/le.MB).toFixed(2)):be<le.TB?(0,m.localize)(4,null,(be/le.GB).toFixed(2)):(0,m.localize)(5,null,(be/le.TB).toFixed(2))}}e.$Yk=le;function $e(ie){const be=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*le.MB:be?10*le.MB:w.$o?50*le.MB:1024*le.MB}e.$Zk=$e}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class y{constructor(...I){this.a=new Map;for(const[A,P]of I)this.set(A,P)}set(I,A){const P=this.a.get(I);return this.a.set(I,A),P}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$4h=y}),define(Pe[184],Re([1,0,13,15,6,70,182,4,71,185]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const R=!1;class k extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$4h,s=!1,n,o=R){this.f=a,this.g=s,this.h=n,this.i=o,this.o=new Set,this.f.set(m.$5h,this),this._globalGraph=o?n?._globalGraph??new P.$Dq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...s){const n=b.traceInvocation(this.i,a);let o=!1;try{return a({get:h=>{if(o)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{o=!0,n.stop()}}createInstance(a,...s){let n,o;return a instanceof A.$3h?(n=b.traceCreation(this.i,a.ctor),o=this.j(a.ctor,a.staticArguments.concat(s),n)):(n=b.traceCreation(this.i,a),o=this.j(a,s,n)),n.stop(),o}j(a,s=[],n){const o=m._util.getServiceDependencies(a).sort((t,u)=>t.index-u.index),c=[];for(const t of o){const u=this.m(t.id,n);u||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(u)}const h=o.length>0?o[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(a,s.concat(c))}k(a,s){if(this.f.get(a)instanceof A.$3h)this.f.set(a,s);else if(this.h)this.h.k(a,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const s=this.f.get(a);return!s&&this.h?this.h.l(a):s}m(a,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof A.$3h?this.q(a,n,s.branch(a,!0)):(s.branch(a,!1),n)}q(a,s,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,s,n)}finally{this.o.delete(a)}}r(a,s,n){const o=new P.$Dq(t=>t.id.toString());let c=0;const h=[{id:a,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(o.lookupOrInsertNode(t),c++>1e3)throw new k(o);for(const u of m._util.getServiceDependencies(t.desc.ctor)){const i=this.l(u.id);if(i||this.u(`[createInstance] ${a} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),i instanceof A.$3h){const g={id:u.id,desc:i,_trace:t._trace.branch(u.id,!0)};o.insertEdge(t,g),h.push(g)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:u}of t){if(this.l(u.id)instanceof A.$3h){const g=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,g)}o.removeNode(u)}}return this.l(a)}s(a,s,n=[],o,c){if(this.f.get(a)instanceof A.$3h)return this.t(a,s,n,o,c);if(this.h)return this.h.s(a,s,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(a,s,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const t=new Map,u=new y.$mh(()=>{const i=h.j(s,n,c);for(const[g,$]of t){const d=i[g];if(typeof d=="function")for(const S of $)S.disposable=d.apply(i,S.listener)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,g){if(!u.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let S=t.get(g);return S||(S=new w.$4c,t.set(g,S)),(v,E,D)=>{if(u.isInitialized)return u.value[g](v,E,D);{const T={listener:[v,E,D],disposable:void 0},O=S.push(T);return(0,I.$Rc)(()=>{O(),T.disposable?.dispose()})}}}if(g in i)return i[g];const $=u.value;let d=$[g];return typeof d!="function"||(d=d.bind($),i[g]=d),d},set(i,g,$){return u.value[g]=$,!0},getPrototypeOf(i){return s.prototype}})}else return this.j(s,n,c)}u(a,s){if(s&&console.warn(a),this.g)throw new Error(a)}}e.$Eq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,s){return a?new b(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(a,s){return a?new b(1,s.name):b.c}static{this.f=0}constructor(a,s){this.type=a,this.name=s,this.g=Date.now(),this.h=[]}branch(a,s){const n=new b(3,a.toString());return this.h.push([a,s,n]),n}stop(){const a=Date.now()-this.g;b.f+=a;let s=!1;function n(c,h){const t=[],u=new Array(c+1).join("	");for(const[i,g,$]of h.h)if(g&&$){s=!0,t.push(`${u}CREATES -> ${i}`);const d=n(c+1,$);d&&t.push(d)}else t.push(`${u}uses -> ${i}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(a>2||s)&&b.all.add(o.join(`
`))}}e.$Fq=b}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,l.$6h)("logService"),e.$oj=(0,l.$6h)("loggerService");function p(){return new Date().toISOString()}function b(v){return(0,w.$Mf)(v)}e.$pj=b;var r;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$qj=r.Info;function a(v,E,D){switch(E){case r.Trace:v.trace(D);break;case r.Debug:v.debug(D);break;case r.Info:v.info(D);break;case r.Warning:v.warn(D);break;case r.Error:v.error(D);break;case r.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=a;function s(v,E=!1){let D="";for(let T=0;T<v.length;T++){let O=v[T];if(O instanceof Error&&(O=(0,y.$Qi)(O,E)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(T>0?" ":"")+O}return D}class n extends A.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new M.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==r.Off&&this.b<=E}}e.$sj=n;class o extends n{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f(r.Trace)&&this.g(r.Trace,s([E,...D],!0))}debug(E,...D){this.f(r.Debug)&&this.g(r.Debug,s([E,...D]))}info(E,...D){this.f(r.Info)&&this.g(r.Info,s([E,...D]))}warn(E,...D){this.f(r.Warning)&&this.g(r.Warning,s([E,...D]))}error(E,...D){if(this.f(r.Error))if(E instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=E.stack,this.g(r.Error,s(T))}else this.g(r.Error,s([E,...D]))}flush(){}}e.$tj=o;class c extends n{constructor(E=e.$qj){super(),this.setLevel(E),this.g=!m.$i}trace(E,...D){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}debug(E,...D){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}info(E,...D){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}warn(E,...D){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,E,...D):console.warn(`[main ${p()}]`,E,...D))}error(E,...D){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,E,...D):console.error(`[main ${p()}]`,E,...D))}flush(){}}e.$uj=c;class h extends n{constructor(E=e.$qj,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}flush(){}}e.$vj=h;class t extends n{constructor(E,D=e.$qj){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(E),...D])}debug(E,...D){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(E),...D])}info(E,...D){this.f(r.Info)&&this.g.log(r.Info,[this.h(E),...D])}warn(E,...D){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(E),...D])}error(E,...D){this.f(r.Error)&&this.g.log(r.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,y.$Qi)(E,this.f(r.Trace))}flush(){}}e.$wj=t;class u extends n{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const T of this.g)T.trace(E,...D)}debug(E,...D){for(const T of this.g)T.debug(E,...D)}info(E,...D){for(const T of this.g)T.info(E,...D)}warn(E,...D){for(const T of this.g)T.warn(E,...D)}error(E,...D){for(const T of this.g)T.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$xj=u;class i extends A.$Tc{constructor(E,D,T){if(super(),this.h=E,this.j=D,this.b=new P.$Ac,this.c=this.B(new M.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Vd),this.onDidChangeVisibility=this.g.event,T)for(const O of T)this.b.set(O.resource,{logger:void 0,info:O})}m(E){return(0,w.$If)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const T=this.n(E),O=(0,w.$If)(E)?E:D?.id??(0,I.$Ti)(T.toString()).toString(16);let G=this.b.get(T)?.logger;const q=D?.logLevel==="always"?r.Trace:D?.logLevel;G||(G=this.s(T,q??this.getLogLevel(T)??this.h,{...D,id:O}));const z={logger:G,info:{resource:T,id:O,logLevel:q,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(z.info),this.b.set(T,z),G}n(E){return(0,w.$If)(E)?(0,f.$Hg)(this.j,`${E}.log`):E}setLogLevel(E,D){if(R.URI.isUri(E)){const T=E,O=D,G=this.b.get(T);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([T,O]))}else{this.h=E;for(const[T,O]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const T=this.m(E);T&&D!==!T.info.hidden&&(T.info.hidden=!D,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=i;class g{constructor(){this.onDidChangeLogLevel=new M.$Vd().event}setLevel(E){}getLevel(){return r.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$zj=g;class $ extends g{}e.$Aj=$;function d(v){if(v.verbose)return r.Trace;if(typeof v.logLevel=="string"){const E=L(v.logLevel.toLowerCase());if(E!==void 0)return E}return e.$qj}e.$Bj=d;function S(v){switch(v){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Cj=S;function L(v){switch(v){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Dj=L,e.$Ej=new k.$kj("logLevel",S(r.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;class I extends y.$Tc{constructor(P,m=[]){super(),this.a=new M.$xj([P,...m]),this.B(P.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...m){this.a.trace(P,...m)}debug(P,...m){this.a.debug(P,...m)}info(P,...m){this.a.info(P,...m)}warn(P,...m){this.a.warn(P,...m)}error(P,...m){this.a.error(P,...m)}flush(){this.a.flush()}}e.$yO=I}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var P;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(f){function w(b,r){return r-b}f.compare=w;const R=Object.create(null);R[f.Error]=(0,M.localize)(0,null),R[f.Warning]=(0,M.localize)(1,null),R[f.Info]=(0,M.localize)(2,null);function k(b){return R[b]||""}f.toString=k;function l(b){switch(b){case y.default.Error:return f.Error;case y.default.Warning:return f.Warning;case y.default.Info:return f.Info;case y.default.Ignore:return f.Hint}}f.fromSeverity=l;function p(b){switch(b){case f.Error:return y.default.Error;case f.Warning:return y.default.Warning;case f.Info:return y.default.Info;case f.Hint:return y.default.Ignore}}f.toSeverity=p}(P||(e.MarkerSeverity=P={}));var m;(function(f){const w="";function R(l){return k(l,!0)}f.makeKey=R;function k(l,p){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(P.toString(l.severity)):b.push(w),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}f.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$At=(0,I.$6h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=M.default,e.$pv=(0,I.$6h)("notificationService");var A;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));function m(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$qv=m;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class w{constructor(){this.progress=new R,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$rv=w;class R{infinite(){}done(){}total(l){}worked(l){}}e.$sv=R}),define(Pe[188],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,y.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,y,M){var I=arguments.length,A=I<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ge,e,y,M);else for(var m=ge.length-1;m>=0;m--)(P=ge[m])&&(A=(I<3?P(A):I>3?P(e,y,A):P(e,y))||A);return I>3&&A&&Object.defineProperty(e,y,A),A},He=this&&this.__param||function(ge,e){return function(y,M){e(y,M,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,A.$6h)("progressService");var P;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$vv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$wv=f;let w=class extends I.$Tc{constructor(l,p){super(),this.a=new y.$qh,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$xv=w,e.$xv=w=Je([He(1,e.$tv)],w);class R extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const p=++this.a,b=new M.$6d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>b.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$yv=R,e.$zv=(0,A.$6h)("editorProgressService")}),define(Pe[30],Re([1,0,54,16]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class I{constructor(){this.a=new Map}add(P,m){y.ok(M.$If(P)),y.ok(M.$Kf(m)),y.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,m)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Hn=new I}),define(Pe[73],Re([1,0,5,30]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class A{constructor(){this.b=new y.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,w){this.a[I(f)]=w,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const P=new A;M.$Hn.add(e.$In.JSONContribution,P)}),define(Pe[55],Re([1,0,18,5,16,148,46,73,30]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$Mn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const k=f.$Hn.as(m.$In.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Vd,this.onDidSchemaChange=this.i.event,this.j=new M.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const i=new Set;this.n(t,u,i),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const u=new Set;this.o(t,u),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const i=new Set;this.o(u,i),this.n(t,!1,i),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const i=[];for(const{overrides:g,source:$}of t)for(const d in g)if(u.add(d),e.$Wn.test(d)){const S=this.a.get(d),L=S?.valuesSources??new Map;if($)for(const T of Object.keys(g[d]))L.set(T,$);const v={...S?.value||{},...g[d]};this.a.set(d,{source:$,value:v,valuesSources:L});const E=(0,P.$Ji)(d),D={type:"object",default:v,description:A.localize(1,null,E),$ref:e.$Tn,defaultDefaultValue:v,source:I.$If($)?void 0:$,defaultValueSource:$};i.push(...r(d)),this.d[d]=D,this.b.properties[d]=D}else{this.a.set(d,{value:g[d],source:$});const S=this.d[d];S&&(this.w(d,S),this.r(d,S))}this.m(i)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:i,source:g}of t)for(const $ in i){const d=this.a.get($),S=I.$If(g)?g:g?.id,L=I.$If(d?.source)?d?.source:d?.source?.id;if(S===L)if(u.add($),this.a.delete($),e.$Wn.test($))delete this.d[$],delete this.b.properties[$];else{const v=this.d[$];v&&(this.w($,v),this.r($,v))}}this.u()}deltaConfiguration(t){let u=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,i){t.forEach(g=>{this.p(g,u,g.extensionInfo,g.restrictedProperties,void 0,i),this.c.push(g),this.q(g)})}o(t,u){const i=g=>{if(g.properties)for(const $ in g.properties){u.add($);const d=this.d[$];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[$],this.s($,g.properties[$])}g.allOf?.forEach($=>i($))};for(const g of t){i(g);const $=this.c.indexOf(g);$!==-1&&this.c.splice($,1)}}p(t,u=!0,i,g,$=3,d){$=I.$Rf(t.scope)?$:t.scope;const S=t.properties;if(S)for(const v in S){const E=S[v];if(u&&o(v,E)){delete S[v];continue}if(E.source=i,E.defaultDefaultValue=S[v].default,this.w(v,E),e.$Wn.test(v)?E.scope=void 0:(E.scope=I.$Rf(E.scope)?$:E.scope,E.restricted=I.$Rf(E.restricted)?!!g?.includes(v):E.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),d.add(v)}const L=t.allOf;if(L)for(const v of L)this.p(v,u,i,g,$,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=i=>{const g=i.properties;if(g)for(const d in g)this.r(d,g[d]);i.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Nn.properties[t]=u,u.scope){case 1:e.$On.properties[t]=u;break;case 2:e.$Pn.properties[t]=u;break;case 6:e.$Qn.properties[t]=u;break;case 3:e.$Rn.properties[t]=u;break;case 4:e.$Sn.properties[t]=u;break;case 5:e.$Sn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Nn.properties[t],u.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Tn};this.w(u,i),e.$Nn.properties[u]=i,e.$On.properties[u]=i,e.$Pn.properties[u]=i,e.$Qn.properties[u]=i,e.$Rn.properties[u]=i,e.$Sn.properties[u]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,u){const i=this.a.get(t);let g=i?.value,$=i?.source;I.$Pf(g)&&(g=u.defaultDefaultValue,$=void 0),I.$Pf(g)&&(g=s(u.type)),u.default=g,u.defaultValueSource=$}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$Vn=`^(${p})+$`,e.$Wn=new RegExp(e.$Vn);function r(h){const t=[];if(e.$Wn.test(h)){let u=b.exec(h);for(;u?.length;){const i=u[1].trim();i&&t.push(i),u=b.exec(h)}}return(0,y.$Mb)(t)}e.$Xn=r;function a(h){return h.reduce((t,u)=>`${t}[${u}]`,"")}e.$Yn=a;function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=s;const n=new l;f.$Hn.add(e.$Mn.Configuration,n);function o(h,t){return h.trim()?e.$Wn.test(h)?A.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?A.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$1n=o;function c(){const h=[],t=n.getConfigurationProperties();for(const u of Object.keys(t))h.push([u,t[u].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$2n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,46,55,30]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function p(u){return Object.isFrozen(u)?u:m.$wn(u)}class b{constructor(i={},g=[],$=[],d){this.b=i,this.c=g,this.d=$,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(g=>{if(g instanceof b)return g;const $=new r("");return $.parseRaw(g),$.configurationModel});this.f=i.reduce((g,$)=>$===g?$:g.merge($),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,R.$Hi)(this.contents,i):this.contents}inspect(i,g){const $=this.rawConfiguration.getValue(i),d=g?this.rawConfiguration.getOverrideValue(i,g):void 0,S=g?this.rawConfiguration.override(g).getValue(i):$;return{value:$,override:d,merged:S}}getOverrideValue(i,g){const $=this.i(g);return $?i?(0,R.$Hi)($,i):$:void 0}getKeysForOverrideIdentifier(i){const g=[];for(const $ of this.overrides)$.identifiers.includes(i)&&g.push(...$.keys);return y.$Mb(g)}getAllOverrideIdentifiers(){const i=[];for(const g of this.overrides)i.push(...g.identifiers);return y.$Mb(i)}override(i){let g=this.a.get(i);return g||(g=this.g(i),this.a.set(i,g)),g}merge(...i){const g=m.$vn(this.contents),$=m.$vn(this.overrides),d=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of i)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(g,L.contents);for(const v of L.overrides){const[E]=$.filter(D=>y.$ub(D.identifiers,v.identifiers));E?(this.h(E.contents,v.contents),E.keys.push(...v.keys),E.keys=y.$Mb(E.keys)):$.push(m.$vn(v))}for(const v of L.keys)d.indexOf(v)===-1&&d.push(v)}return new b(g,d,$,S.every(L=>L instanceof b)?void 0:S)}g(i){const g=this.i(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const $={};for(const d of y.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let S=this.contents[d];const L=g[d];L&&(typeof S=="object"&&typeof L=="object"?(S=m.$vn(S),this.h(S,L)):S=L),$[d]=S}return new b($,this.keys,this.overrides)}h(i,g){for(const $ of Object.keys(g)){if($ in i&&f.$Kf(i[$])&&f.$Kf(g[$])){this.h(i[$],g[$]);continue}i[$]=m.$vn(g[$])}}i(i){let g=null,$=null;const d=S=>{S&&($?this.h($,S):$=m.$vn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?g=S.contents:S.identifiers.includes(i)&&d(S.contents);return d(g),$}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,g){this.j(i,g,!0)}setValue(i,g){this.j(i,g,!1)}removeValue(i){const g=this.keys.indexOf(i);g!==-1&&(this.keys.splice(g,1),(0,R.$Gi)(this.contents,i),k.$Wn.test(i)&&this.overrides.splice(this.overrides.findIndex($=>y.$ub($.identifiers,(0,k.$Xn)(i))),1))}j(i,g,$){(0,R.$Fi)(this.contents,i,g,d=>console.error(d)),$=$||this.keys.indexOf(i)===-1,$&&this.keys.push(i),k.$Wn.test(i)&&this.overrides.push({identifiers:(0,k.$Xn)(i),keys:Object.keys(this.contents[i]),contents:(0,R.$Ei)(this.contents[i],d=>console.error(d))})}}e.$3n=b;class r{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,g){if(!f.$Rf(i)){const $=this.g(i);this.parseRaw($,g)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,g){this.a=i;const{contents:$,keys:d,overrides:S,restricted:L,hasExcludedProperties:v}=this.h(i,g);this.b=new b($,d,S,v?[i]:void 0),this.c=L||[]}g(i){let g={},$=null,d=[];const S=[],L=[];function v(D){Array.isArray(d)?d.push(D):$!==null&&(d[$]=D)}const E={onObjectBegin:()=>{const D={};v(D),S.push(d),d=D,$=null},onObjectProperty:D=>{$=D},onObjectEnd:()=>{d=S.pop()},onArrayBegin:()=>{const D=[];v(D),S.push(d),d=D,$=null},onArrayEnd:()=>{d=S.pop()},onLiteralValue:v,onError:(D,T,O)=>{L.push({error:D,offset:T,length:O})}};if(i)try{I.$jn(i,E),g=d[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return g}h(i,g){const $=l.$Hn.as(k.$Mn.Configuration).getConfigurationProperties(),d=this.i(i,$,!0,g);i=d.raw;const S=(0,R.$Ei)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),L=Object.keys(i),v=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:S,keys:L,overrides:v,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(i,g,$,d){let S=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const L={},v=[];for(const E in i)if(k.$Wn.test(E)&&$){const D=this.i(i[E],g,!1,d);L[E]=D.raw,S=S||D.hasExcludedProperties,v.push(...D.restricted)}else{const D=g[E],T=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&v.push(E),!d.exclude?.includes(E)&&(d.include?.includes(E)||(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&!(d.skipRestricted&&D?.restricted))?L[E]=i[E]:S=!0}return{raw:L,restricted:v,hasExcludedProperties:S}}j(i,g){const $=[];for(const d of Object.keys(i))if(k.$Wn.test(d)){const S={};for(const L in i[d])S[L]=i[d][L];$.push({identifiers:(0,k.$Xn)(d),keys:Object.keys(S),contents:(0,R.$Ei)(S,g)})}return $}}e.$4n=r;class a extends A.$Tc{constructor(i,g,$,d){super(),this.c=i,this.f=g,this.g=d,this.b=this.B(new M.$Vd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch($.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&$.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=a;class s{constructor(i,g,$,d,S,L,v,E,D,T,O,G,q){this.a=i,this.b=g,this.c=$,this.overrideIdentifiers=d,this.d=S,this.f=L,this.g=v,this.h=E,this.i=D,this.j=T,this.k=O,this.l=G,this.m=q}get value(){return p(this.c)}n(i,g,$){const d=i.inspect(g,$);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(i,g,$,d,S=new b,L=new b,v=new P.$Ac,E=new b,D=new P.$Ac){this.c=i,this.d=g,this.f=$,this.g=d,this.h=S,this.i=L,this.j=v,this.l=E,this.m=D,this.a=null,this.b=new P.$Ac,this.n=null}getValue(i,g,$){return this.p(i,g,$).getValue(i)}updateValue(i,g,$={}){let d;$.resource?(d=this.m.get($.resource),d||(d=new b,this.m.set($.resource,d))):d=this.l,g===void 0?d.removeValue(i):d.setValue(i,g),$.resource||(this.a=null)}inspect(i,g,$){const d=this.p(i,g,$),S=this.t(g.resource,$),L=g.resource?this.m.get(g.resource)||this.l:this.l,v=new Set;for(const E of d.overrides)for(const D of E.identifiers)d.getOverrideValue(i,D)!==void 0&&v.add(D);return new s(i,g,d.getValue(i),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,$?this.i:void 0,S||void 0,L)}keys(i){const g=this.t(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,g){this.j.set(i,g),this.b.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const $=[];if(!g){const{added:d,updated:S,removed:L}=h(this.c,i);g=[...d,...S,...L]}for(const d of g)for(const S of(0,k.$Xn)(d)){const L=this.c.getKeysForOverrideIdentifier(S),v=i.getKeysForOverrideIdentifier(S),E=[...v.filter(D=>L.indexOf(D)===-1),...L.filter(D=>v.indexOf(D)===-1),...L.filter(D=>!m.$zn(this.c.override(S).getValue(D),i.override(S).getValue(D)))];$.push([S,E])}return this.updateDefaultConfiguration(i),{keys:g,overrides:$}}compareAndUpdatePolicyConfiguration(i){const{added:g,updated:$,removed:d}=h(this.d,i),S=[...g,...$,...d];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:g,updated:$,removed:d,overrides:S}=h(this.applicationConfiguration,i),L=[...g,...$,...d];return L.length&&this.updateApplicationConfiguration(i),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:$,removed:d,overrides:S}=h(this.localUserConfiguration,i),L=[...g,...$,...d];return L.length&&this.updateLocalUserConfiguration(i),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:$,removed:d,overrides:S}=h(this.remoteUserConfiguration,i),L=[...g,...$,...d];return L.length&&this.updateRemoteUserConfiguration(i),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:$,removed:d,overrides:S}=h(this.workspaceConfiguration,i),L=[...g,...$,...d];return L.length&&this.updateWorkspaceConfiguration(i),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(i,g){const $=this.folderConfigurations.get(i),{added:d,updated:S,removed:L,overrides:v}=h($,g),E=[...d,...S,...L];return(E.length||!$)&&this.updateFolderConfiguration(i,g),{keys:E,overrides:v}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:$,updated:d,removed:S,overrides:L}=h(g,void 0);return{keys:[...$,...d,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(i,g,$){let d=this.q(g,$);return g.overrideIdentifier&&(d=d.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(d=d.merge(this.d)),d}q({resource:i},g){let $=this.r();if(g&&i){const d=g.getFolder(i);d&&($=this.s(d.uri)||$);const S=this.m.get(i);S&&($=$.merge(S))}return $}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(i){let g=this.b.get(i);if(!g){const $=this.r(),d=this.j.get(i);d?(g=$.merge(d),this.b.set(i,g)):g=$}return g}t(i,g){if(g&&i){const $=g.getFolder(i);if($)return this.j.get($.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,g)=>{const{contents:$,overrides:d,keys:S}=this.j.get(g);return i.push([g,{contents:$,overrides:d,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(g=>i.add(g)),this.userConfiguration.keys.forEach(g=>i.add(g)),this.i.keys.forEach(g=>i.add(g)),this.j.forEach(g=>g.keys.forEach($=>i.add($))),[...i.values()]}u(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach($=>i.add($))),[...i.values()]}v(i){const g=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach($=>g.add($)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach($=>g.add($)),this.i.getKeysForOverrideIdentifier(i).forEach($=>g.add($)),this.j.forEach($=>$.getKeysForOverrideIdentifier(i).forEach(d=>g.add(d))),[...g.values()]}static parse(i){const g=this.w(i.defaults),$=this.w(i.policy),d=this.w(i.application),S=this.w(i.user),L=this.w(i.workspace),v=i.folders.reduce((E,D)=>(E.set(w.URI.revive(D[0]),this.w(D[1])),E),new P.$Ac);return new n(g,$,d,S,new b,L,v,new b,new P.$Ac)}static w(i){return new b(i.contents,i.keys,i.overrides)}}e.$6n=n;function o(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,g=new Map;for(const d of u)d.keys.forEach(S=>i.add(S)),d.overrides.forEach(([S,L])=>{const v=(0,P.$xc)(g,S,new Set);L.forEach(E=>v.add(E))});const $=[];return g.forEach((d,S)=>$.push([S,[...d.values()]])),{keys:[...i.values()],overrides:$}}e.$7n=o;class c{constructor(i,g,$,d){this.change=i,this.f=g,this.g=$,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(i,g){const $=this.a+i,d=this.d.indexOf($);if(d<0)return!1;const S=d+$.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(g){const v=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.f?.workspace):void 0,E=this.g.getValue(i,g,this.h);return!m.$zn(v,E)}return!0}}e.$8n=c;function h(u,i){const{added:g,removed:$,updated:d}=t(i?.rawConfiguration,u?.rawConfiguration),S=[],L=u?.getAllOverrideIdentifiers()||[],v=i?.getAllOverrideIdentifiers()||[];if(i){const E=v.filter(D=>!L.includes(D));for(const D of E)S.push([D,i.getKeysForOverrideIdentifier(D)])}if(u){const E=L.filter(D=>!v.includes(D));for(const D of E)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(i&&u){for(const E of L)if(v.includes(E)){const D=t({contents:u.getOverrideValue(void 0,E)||{},keys:u.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});S.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:g,removed:$,updated:d,overrides:S}}function t(u,i){const g=u?i?u.keys.filter(S=>i.keys.indexOf(S)===-1):[...u.keys]:[],$=i?u?i.keys.filter(S=>u.keys.indexOf(S)===-1):[...i.keys]:[],d=[];if(u&&i){for(const S of i.keys)if(u.keys.indexOf(S)!==-1){const L=(0,R.$Hi)(i.contents,S),v=(0,R.$Hi)(u.contents,S);m.$zn(L,v)||d.push(S)}}return{added:g,removed:$,updated:d}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,M.$6h)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=A;class P{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=P;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends y.$bb{static isNotAvailable(k){return k instanceof f&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,l=m.Unknown,p){super(k),this._message=k,this._code=l,this._detail=p,this.isHandled=l===m.NotAvailable&&p===!0,Object.setPrototypeOf(this,f.prototype)}}e.$$k=f;function w(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$_k=w}),define(Pe[56],Re([1,0,11]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function M(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.$al=M;function I(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$bl=I;function A(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$cl=A;function P(w){const{host:R,port:k}=f(w);if(typeof k>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:k}}e.$dl=P;function m(w,R){let{host:k,port:l}=f(w);return typeof l>"u"&&(l=R),{host:k,port:l}}e.$el=m;function f(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[23],Re([1,0,12,4,56]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function A(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$jm=A,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(P||(e.ExtensionType=P={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,s){if(typeof a>"u"||a===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof a=="string"||typeof s=="string"){const n=typeof a=="string"?a:a.value,o=typeof s=="string"?s:s.value;return y.$_e(n,o)}return a._lower===s._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$lm=f;class w{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const s of a)this.add(s)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$mm=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,s){this.c.set(f.toKey(a),s)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=R;function k(r){return l(r)}e.$om=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$pm=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$qm=p;function b(r,a){if(a){const s=`onResolveRemoteAuthority:${(0,I.$bl)(a)}`;return!!r.activationEvents?.includes(s)}return!1}e.$rm=b,e.$sm=(0,M.$6h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,23]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(P,m){this.a.set(P,m)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const m=Object.create(null);for(const f of P){const w=this.readActivationEvents(f);w.length>0&&(m[M.$lm.toKey(f.identifier)]=w)}return m}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const m=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${M.$lm.toKey(P.identifier)}`);if(!P.contributes)return m;for(const f in P.contributes){const w=this.a.get(f);if(!w)continue;const R=P.contributes[f],k=Array.isArray(R)?R:[R];try{w(k,m)}catch(l){(0,y.$1)(l)}}return m}}e.$gF=I,e.$hF=new I}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function A(f){if(y.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function P(f,w,R,k,l,p,b,r,a){const s=Object.create(null);s["common.machineId"]=p,s["common.sqmId"]=b,s.sessionID=(0,I.$qg)()+Date.now(),s.commitHash=k,s.version=l,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,y.$h)(y.$u),s["common.nodePlatform"]=M.$dc,s["common.nodeArch"]=R,s["common.product"]=a||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),y.$l&&(s["common.snap"]="true");const c=A(w);return c&&(s["common.platformDetail"]=c),s}e.$Jo=P;function m(f){const w=M.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return f.some(k=>R===k)}e.$Ko=m}),define(Pe[191],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,y.$6h)("telemetryService"),e.$vl=(0,y.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var M;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[57],Re([1,0,26,16,56,190,191]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class m{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$Lo=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=f,e.$No=new f;class w{async publicLog(u,i,g){}async publicLogError(u,i,g){}}e.$Oo=w,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}e.$So=R;function k(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=k;function l(t){const u=t.getValue(P.$Cl),i=t.getValue(P.$Dl);if(t.getValue(P.$El)===!1||i===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=l;function p(t){const u={},i={},g={};a(t,g);for(let $ in g){$=$.length>150?$.substr($.length-149):$;const d=g[$];typeof d=="number"?i[$]=d:typeof d=="boolean"?i[$]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${d.length}`),u[$]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(u[$]=d)}return{properties:u,measurements:i}}e.$Vo=p;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const u=(0,I.$bl)(t);return b.has(u)?u:"other"}e.$Wo=r;function a(t,u,i=0,g){if(t)for(const $ of Object.getOwnPropertyNames(t)){const d=t[$],S=g?g+$:$;Array.isArray(d)?u[S]=(0,y.$An)(d):d instanceof Date?u[S]=d.toISOString():(0,M.$Kf)(d)?i<2?a(d,u,i+1,S+"."):u[S]=(0,y.$An)(d):u[S]=d}}function s(t,u){const i=t.msftInternalDomains||[],g=u.getValue("telemetry.internalTesting");return(0,A.$Ko)(i)||g}e.$Xo=s;function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=n;function o(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let i=t;const g=[];for(const L of u)for(;;){const v=L.exec(t);if(!v)break;g.push([v.index,L.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(i="";;){const L=d.exec(t);if(!L)break;const v=g.some(([E,D])=>L.index<D&&E<d.lastIndex);!$.test(L[0])&&!v&&(i+=t.substring(S,L.index)+"<REDACTED: user-file-path>",S=d.lastIndex)}return S<t.length&&(i+=t.substr(S)),i}function c(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of u)if(i.regex.test(t))return`<REDACTED: ${i.label}>`;return t}function h(t,u){return(0,y.$xn)(t,i=>{if(i instanceof m||Object.hasOwnProperty.call(i,"isTrustedTelemetryValue"))return i.value;if(typeof i=="string"){let g=i.replaceAll("%20"," ");g=o(g,u);for(const $ of u)g=g.replace($,"");return g=c(g),g}})}e.$Zo=h}),define(Pe[192],Re([1,0,12,97,23,21,2,15,74,57]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function R(i,g){return i.uuid&&g.uuid?i.uuid===g.uuid:i.id===g.id?!0:(0,y.$7e)(i.id,g.id)===0}e.$1o=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const $=g.manifest?g.manifest.version:g.version,d=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,$,d)}static parse(g){const $=k.exec(g);return $&&$[1]&&$[2]?new l({id:$[1]},$[2],$[4]||void 0):null}constructor(g,$,d="undefined"){this.version=$,this.targetPlatform=d,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?R(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$2o=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(i){const g=p.exec(i);return g&&g[1]?[a(g[1]),g[2]]:[a(i),void 0]}e.$3o=b;function r(i,g){return`${i}.${g}`}e.$4o=r;function a(i){return i.toLowerCase()}e.$5o=a;function s(i,g){return a(r(i??I.$hm,g))}e.$6o=s;function n(i,g){const $=[],d=S=>{for(const L of $)if(L.some(v=>R(g(v),g(S))))return L;return null};for(const S of i){const L=d(S);L?L.push(S):$.push([S])}return $}e.$7o=n;function o(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$8o=o;function c(i){return{id:new w.$Lo(i.identifier.id),name:new w.$Lo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$9o=c,e.$0o=new I.$lm("pprice.better-merge");function h(i,g){const $=[],d=g.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const S=d.shift();if(S&&$.every(L=>!R(L.identifier,{id:S}))){const L=i.filter(v=>R(v.identifier,{id:S}));L.length===1&&($.push(L[0]),d.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}e.$$o=h;async function t(i,g){if(!A.$k)return!1;let $;try{$=(await i.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await i.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){g.debug("Error while getting the os-release file.",(0,m.$0)(S))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(i,g){const $=await t(i,g),d=(0,M.$uo)($?"alpine":A.$u,f.$ec);return g.debug("ComputeTargetPlatform:",d),d}e.$_o=u}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function y(f){return[...f.entries()]}e.$Mr=y;function M(f){return f?[...f.entries()]:[]}e.$Nr=M;function I(f){return new Map(f)}e.$Or=I;function A(f){return new Map(f??[])}e.$Pr=A;function P(f){return Array.from(f.entries()).map(w=>[w[0],y(w[1].map),M(w[1].descriptionMap)])}e.$Qr=P;function m(f){return new Map(f.map(w=>[w[0],{map:I(w[1]),descriptionMap:A(w[2])}]))}e.$Rr=m}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prb=void 0;class y{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,P=5){const m=A(f=>{const w=typeof f=="string"?f:f.data;let R=this.a.get(I);if(R){R.data.push(w);return}const k=setTimeout(()=>this.flushBuffer(I),P);R={data:[w],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),m.dispose()}},this.a.set(I,R)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.$Prb=y}),define(Pe[195],Re([1,0,13,90,44,5,16,2,155,73,30]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var k;(function(c){function h(t,u){let i=t.defaults;for(;I.ThemeIcon.isThemeIcon(i);){const g=b.getIcon(i.id);if(!g)return;i=g.defaults}return i}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(u){return{weight:u.weight,style:u.style,src:u.src.map(i=>({format:i.format,location:i.location.toString()}))}}c.toJSONObject=h;function t(u){const i=g=>(0,P.$If)(g)?g:void 0;if(u&&Array.isArray(u.src)&&u.src.every(g=>(0,P.$If)(g.format)&&(0,P.$If)(g.location)))return{weight:i(u.weight),style:i(u.style),src:u.src.map(g=>({format:g.format,location:m.URI.parse(g.location)}))}}c.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new A.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,u,i){const g=this.b[h];if(g){if(u&&!g.description){g.description=u,this.d.properties[h].markdownDescription=`${u} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=u),this.a.fire()}return g}const $={id:h,description:u,defaults:t,deprecationMessage:i};this.b[h]=$;const d={$ref:"#/definitions/icons"};return i&&(d.deprecationMessage=i),u&&(d.markdownDescription=`${u}: $(${h})`),this.d.properties[h]=d,this.e.enum.push(h),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const u=this.f[h];return u||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(g,$)=>g.id.localeCompare($.id),t=g=>{for(;I.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(g=>this.b[g]);for(const g of i.filter($=>!!$.description).sort(h))u.push(`|<i class="${t(g)}"></i>|${g.id}|${I.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const g of i.filter($=>!I.ThemeIcon.isThemeIcon($.defaults)).sort(h))u.push(`|<i class="${t(g)}"></i>|${g.id}|`);return u.join(`
`)}}const b=new p;R.$Hn.add(e.$ww.IconContribution,b);function r(c,h,t,u){return b.registerIcon(c,h,t,u)}e.$xw=r;function a(){return b}e.$yw=a;function s(){const c=(0,M.$0j)();for(const h in c){const t="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:t})}}s(),e.$zw="vscode://schemas/icons";const n=R.$Hn.as(w.$In.JSONContribution);n.registerSchema(e.$zw,b.getIconSchema());const o=new y.$fh(()=>n.notifySchemaChanged(e.$zw),200);b.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Aw=r("widget-close",M.$_j.close,(0,f.localize)(2,null)),e.$Bw=r("goto-previous-location",M.$_j.arrowUp,(0,f.localize)(3,null)),e.$Cw=r("goto-next-location",M.$_j.arrowDown,(0,f.localize)(4,null)),e.$Dw=I.ThemeIcon.modify(M.$_j.sync,"spin"),e.$Ew=I.ThemeIcon.modify(M.$_j.loading,"spin")}),define(Pe[196],Re([1,0,5,46,4,14]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,I.$6h)("tunnelService"),e.$Bv=(0,I.$6h)("sharedTunnelsService");var P;(function(a){a.Http="http",a.Https="https"})(P||(e.TunnelProtocol=P={}));var m;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(m||(e.TunnelPrivacyId=m={}));function f(a){return!!a.forwardPort}e.$Cv=f;var w;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(s)return{address:s[1],port:+s[2]}}e.$Dv=R,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(a){return e.$Ev.indexOf(a)>=0}e.$Fv=k,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$Gv.indexOf(a)>=0}e.$Hv=l;function p(a,s,n,o){if(n===1)return!1;if(n===2&&l(s)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Iv=p;class b{constructor(s,n,o){this.remoteAddress=s,this.localAddress=n,this.b=o,this.a=new y.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=b;let r=class{constructor(s,n){this.k=s,this.l=n,this.a=new y.$Vd,this.onTunnelOpened=this.a.event,this.b=new y.$Vd,this.onTunnelClosed=this.b.event,this.c=new y.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const t=await h.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,o,c,h){this.q(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(l(s)||k(s))&&(s=e.$Ev[0]);const o=this.s(s,n);if(o)return++o.refcount,o.value}openTunnel(s,n,o,c,h,t=!1,u,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const g=this.f??s;if(!g)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.t(g,n,o,c,h,t,u,i);return $?$.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(d);return(d.tunnelRemoteHost!==n||d.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const o=n.get(s.tunnelRemotePort);o&&(o.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,o))}}}}async p(s,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),c}}async closeTunnel(s,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const o=this.e.get(s);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.p(s,n,c)}}q(s,n,o){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:o})}async r(s,n){const o=this.e.get(s);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(s)}}s(s,n){const o=[s];k(s)?(o.push(...e.$Ev),o.push(...e.$Gv)):l(s)&&o.push(...e.$Gv);const c=o.map(h=>this.e.get(h));for(const h of c){const t=h?.get(n);if(t)return t}}canTunnel(s){return!!R(s)}u(s,n,o,c,h,t,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const i=o;this.j.add(i);const g=c===void 0?o:c,$={elevationRequired:h?this.isPortPrivileged(g):!1},d={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:t,public:t?t!==m.Private:void 0,protocol:u},S=s.forwardPort(d,$);return S?(this.q(n,o,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$Kv=r,e.$Kv=r=Je([He(0,A.$nj),He(1,M.$zi)],r)}),define(Pe[197],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,y.$6h)("editSessionIdentityService");var M;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Pe[198],Re([1,0,11]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=void 0;function M(f){return f.scheme!==y.Schemas.file&&f.scheme!==y.Schemas.vscodeRemote}e.$GK=M;function I(f){if(f.folders.length)return f.folders.every(w=>M(w.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.$HK=I;function A(f){return I(f)?.scheme}e.$IK=A;function P(f){return I(f)?.authority}e.$JK=P;function m(f){return I(f)!==void 0}e.$KK=m}),define(Pe[47],Re([1,0,156,19,50,25,2,4,11]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,m.$6h)("contextService");function w(g){const $=g;return typeof $?.id=="string"&&P.URI.isUri($.uri)}e.$di=w;function R(g){return typeof g?.id=="string"&&!w(g)&&!l(g)}e.$ei=R,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function k(g,$){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,M.$nc)(g)}:$?e.$fi:e.$gi;const d=g;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$hi=k;function l(g){const $=g;return typeof $?.id=="string"&&P.URI.isUri($.configPath)}e.$ii=l;function p(g){const $=g;if($?.uri)return{id:$.id,uri:P.URI.revive($.uri)};const d=g;if(d?.configPath)return{id:d.id,configPath:P.URI.revive(d.configPath)};if(g?.id)return{id:g.id}}e.$ji=p;var b;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function r(g){const $=g;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}e.$ki=r;function a(g){const $=g;return!!($&&typeof $=="object"&&P.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}e.$li=a;class s{constructor($,d,S,L,v){this.h=$,this.j=S,this.k=L,this.l=v,this.c=I.$_h.forUris(this.l,()=>!0),this.folders=d}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=I.$_h.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=s;class n{constructor($,d){this.raw=d,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,A.$Hg)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=n;function o(g){return new n({uri:g,index:0,name:(0,A.$Dg)(g)},{uri:g.toString()})}e.$oi=o,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,y.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function c(g,$){return A.$yg.isEqualOrParent(g,$.untitledWorkspacesHome)}e.$ti=c;function h(g){let $;return P.URI.isUri(g)?$=g:$=g.configuration,$?.scheme===f.Schemas.tmp}e.$ui=h,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$vi}e.$wi=t;function u(g,$){return!c(g,$)&&!h(g)}e.$xi=u;function i(g){return(typeof g=="string"?(0,M.$oc)(g):(0,A.$Fg)(g))===e.$qi}e.$yi=i}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class y{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$agc=y}),define(Pe[42],Re([1,0,11,25,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;class A{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$wg(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$dgc=A,e.$egc=(0,I.$6h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0,e.$rN=(0,y.$6h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let P=class extends I.$yO{constructor(f,w,R){const k=R.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=R.remote.isRemote?(0,y.localize)(0,null):f?(0,y.localize)(1,null):(0,y.localize)(2,null);super(w.createLogger(k,{name:l}))}};e.$kic=P,e.$kic=P=Je([He(1,M.$oj),He(2,A.$rN)],P)}),define(Pe[200],Re([1,0,13]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;class M{constructor(P,m,f){this.h=new Map,this.a=P,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new y.$fh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const k of w.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,m){let f=this.f[P];return typeof f>"u"&&(f=m),f}update(P,m){this.f[P]=m;const f=this.h.get(P);if(f!==void 0)return f.p;const w=new y.$qh;return this.h.set(P,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Ygc=M;class I extends M{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,m){super(P.identifier.value,!0,m),this.j=P}}e.$Zgc=I}),define(Pe[201],Re([1,0,5,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class I{constructor(P){this.c=P,this.a=new y.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,m,f,w){const k=this.c.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(m.value,f,w);this.b.fire(k)}$acceptDirtyStateChanged(P,m){this.c.getNotebookDocument(M.URI.revive(P)).acceptDirty(m)}$acceptModelSaved(P){const m=this.c.getNotebookDocument(M.URI.revive(P));this.a.fire(m.apiNotebook)}}e.$Mhc=I}),define(Pe[17],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN=(0,y.$6h)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$cN=M}),define(Pe[202],Re([1,0,23,5]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class I{#e;constructor(P,m){this.b=new M.$Vd,this.onDidChange=this.b.event,this.a=y.$lm.toKey(P.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(P){return this.#e.get(this.a,P)}store(P,m){return this.#e.store(this.a,P,m)}delete(P){return this.#e.delete(this.a,P)}}e.$7gc=I}),define(Pe[58],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,y.$6h)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$xgc=M}),define(Pe[203],Re([1,0,22]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilb=e.$hlb=void 0;class M{constructor(){this.buffers=[]}add(f){let w=this.buffers.indexOf(f);return w<0&&(w=this.buffers.length,this.buffers.push(f)),w}}function I(m,f){if(f.serializeBuffersForPostMessage){const w=new M,k=JSON.stringify(m,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const r=A(b);if(r)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:r,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map(p=>{const b=new Uint8Array(p);return y.$je.wrap(b)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$hlb=I;function A(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(m,f){const w=f.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),R=f.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:r}=b,a=w[r];if(b.view)switch(b.view.type){case 1:return new Int8Array(a,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return p}:void 0;return{message:JSON.parse(m,R),arrayBuffers:w}}e.$ilb=P}),define(Pe[102],Re([1,0,170,16,2,6,4,30,41,11,40,134,31]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function r(se){const Z=se;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.$IE=r;function a(se,Z,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===Z&&se.matches(ne.input))return ne.getViewState()}e.$JE=a;function s(se){if(S(se))return!1;const Z=se;return I.URI.isUri(Z?.resource)}e.$KE=s;function n(se){if(S(se))return!1;const Z=se;return Z?.original!==void 0&&Z.modified!==void 0}e.$LE=n;function o(se){if(S(se))return!1;const Z=se;return!Z||Z.resources&&!Array.isArray(Z.resources)?!1:!!Z.resources||!!Z.multiDiffSource}e.$ME=o;function c(se){if(S(se)||n(se))return!1;const Z=se;return Z?.primary!==void 0&&Z.secondary!==void 0}e.$NE=c;function h(se){if(S(se))return!1;const Z=se;return Z?Z.resource===void 0||Z.resource.scheme===w.Schemas.untitled||Z.forceUntitled===!0:!1}e.$OE=h;function t(se){if(S(se))return!1;const Z=se;return I.URI.isUri(Z?.base?.resource)&&I.URI.isUri(Z?.input1?.resource)&&I.URI.isUri(Z?.input2?.resource)&&I.URI.isUri(Z?.result?.resource)}e.$PE=t;var u;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var i;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class g{constructor(){this.a=new Map}registerSource(Z,V){let ne=this.a.get(Z);return ne||(ne={source:Z,label:V},this.a.set(Z,ne)),ne.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.$QE=new g;var $;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})($||(e.EditorInputCapabilities=$={}));class d extends A.$Tc{}e.$RE=d;function S(se){return se instanceof d}e.$SE=S;function L(se){const Z=se;return I.URI.isUri(Z?.preferredResource)}function v(se){const Z=se;return S(Z?.primary)&&S(Z?.secondary)}e.$TE=v;function E(se){const Z=se;return S(Z?.modified)&&S(Z?.original)}e.$UE=E;function D(se,Z,V,ne,Ie){return be(ne,[(0,k.$Pi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};se.openEditor(Z,Le)}}),(0,k.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$VE=D;function T(se){return S(se?.editor)}e.$WE=T;function O(se){const Z=se;return T(se)&&Z?.group!==void 0}e.$XE=O;function G(se){const Z=se;return typeof Z?.groupId=="number"&&S(Z.editor)}e.$YE=G;var q;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var z;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var C;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class N{getOriginalUri(Z,V){if(!Z)return;if(t(Z))return e.$1E.getOriginalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Z);if(Ie&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===C.PRIMARY?Ie:Le}}if(n(Z)||o(Z)||c(Z)||t(Z))return;const ne=L(Z)?Z.preferredResource:Z.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(Z){return v(Z)||c(Z)?{primary:Z.primary,secondary:Z.secondary}:E(Z)||n(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,V){if(!Z)return;if(t(Z))return e.$1E.getCanonicalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Z);if(Ie&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===C.PRIMARY?Ie:Le}}if(n(Z)||o(Z)||c(Z)||t(Z))return;const ne=Z.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(Z,V){if(Array.isArray(V)){if(V.some(ne=>Z.scheme===ne))return Z}else if(V===Z.scheme)return Z}}var W;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function ae(se,Z,V,ne){if(!se.isSticky(Z))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$ZE=ae,e.$1E=new N;var de;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class we{constructor(){this.c=new Map,this.d=new Map}start(Z){const V=this.a=Z.get(P.$5h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(Z,V,ne){const Ie=ne.createInstance(V);this.d.set(Z,Ie)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,M.$Tf)(this.b)}registerEditorSerializer(Z,V){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,V,this.a):this.c.set(Z,V),(0,A.$Rc)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}m.$Hn.add(e.$DE.EditorFactory,new we);async function ye(se,Z,V){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Z.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,ce=ne.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Z.stat(Ie)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return Ce?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$2E=ye;var le;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function $e(se){const Z=se;if(!Z)return!1;const V=Z;if(V.modified)return $e(V.modified);const ne=Z;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$3E=$e;function ie(se){return(0,R.$Ri)(se)}e.$4E=ie;function be(se,Z,V){const ne=(0,R.$Si)(se,Z);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$5E=be}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,M.localize)(0,null),e.$8E=(0,k.$xw)("default-view-icon",R.$_j.window,(0,M.localize)(1,null));var l;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$9E=[0,1,2];function b(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=b;class r extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(i,g,$){const d=this.get(i.id);if(d)return d;const S=i;return S.openCommandActionDescriptor=$?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,P.$xc)(this.g,g,[]).push(S),$?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(i){for(const g of this.g.keys()){const $=this.g.get(g),d=$?.indexOf(i);if(d!==-1){$?.splice(d,1),$.length===0&&this.g.delete(g),this.f.fire({viewContainer:i,viewContainerLocation:g});return}}}get(i){return this.all.filter(g=>g.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter($=>$?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(g=>this.getViewContainerLocation(g)===i)}}m.$Hn.add(l.ViewContainersRegistry,new r);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a||(e.ViewContentGroups=a={}));function s(u,i){const g=u.group??a.More,$=i.group??a.More;return g!==$?g.localeCompare($):(u.order??5)-(i.order??5)}class n extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new P.$Gc}registerViews(i,g){this.registerViews2([{views:i,viewContainer:g}])}registerViews2(i){i.forEach(({views:g,viewContainer:$})=>this.r(g,$)),this.c.fire(i)}deregisterViews(i,g){const $=this.s(i,g);$.length&&this.f.fire({views:$,viewContainer:g})}moveViews(i,g){for(const $ of this.m.keys())if($!==g){const d=this.s(i,$);d.length&&(this.r(d,g),this.g.fire({views:d,from:$,to:g}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const g of this.j){const $=(this.m.get(g)||[]).filter(d=>d.id===i)[0];if($)return $}return null}getViewContainer(i){for(const g of this.j)if((this.m.get(g)||[]).filter(d=>d.id===i)[0])return g;return null}registerViewWelcomeContent(i,g){return this.n.add(i,g),this.h.fire(i),(0,A.$Rc)(()=>{this.n.delete(i,g),this.h.fire(i)})}registerViewWelcomeContent2(i,g){const $=new Map;for(const[d,S]of g)this.n.add(i,S),$.set(d,(0,A.$Rc)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),$}getViewWelcomeContent(i){const g=[];return this.n.forEach(i,$=>g.push($)),g.sort(s)}r(i,g){let $=this.m.get(g);$||($=[],this.m.set(g,$),this.j.push(g));for(const d of i){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));$.push(d)}}s(i,g){const $=this.m.get(g);if(!$)return[];const d=[],S=[];for(const L of $)i.includes(L)?d.push(L):S.push(L);return d.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),d}}m.$Hn.add(l.ViewsRegistry,new n),e.$$E=(0,I.$6h)("viewDescriptorService");var o;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(i,g){this.c=!1,this.d=!1,(0,w.$yn)(this,i),this.d=!!g,this.resolve=async $=>{if(g&&!this.c){const d=await g($);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}$.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=h;class t extends Error{constructor(i){super((0,M.localize)(3,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$aF=t}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function A(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof y.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(M.$Us.isIRange)}e.$3F=A;function P(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(A)}e.$4F=P;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$5F=(0,I.$6h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlb=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new y.$Vd,this.n=new y.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,f,w,R){const k={command:m};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.s("request",k),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const b={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,I.localize)(0,null,R,m)};p(b)}},R)}return w&&this.f.set(k.seq,w),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,f){return m.type!=="event"||f.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$7g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,w=this.f.get(f.request_seq);w&&(this.f.delete(f.request_seq),w(f));break}}}}s(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,w)=>m.set(w,f)),await(0,M.$7g)(500),m.forEach((f,w)=>{f({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Nlb=A}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new M.$kj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$SG=new M.$kj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$TG=new M.$kj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$UG="debugUx",e.$VG=new M.$kj(e.$UG,"default",{type:"string",description:y.localize(3,null)}),e.$WG=new M.$kj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$XG=new M.$kj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$YG=new M.$kj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$ZG=new M.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$1G=new M.$kj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$2G=new M.$kj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$3G=new M.$kj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$4G=new M.$kj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$5G=new M.$kj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$6G=new M.$kj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$7G=new M.$kj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$8G=new M.$kj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$9G=new M.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$0G=new M.$kj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$$G=new M.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$_G=new M.$kj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$aH=new M.$kj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$bH=new M.$kj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$cH=new M.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$dH=new M.$kj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$eH=new M.$kj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$fH=new M.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$gH=new M.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$hH=new M.$kj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$iH=new M.$kj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$jH=new M.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$kH=new M.$kj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$lH=new M.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$mH=new M.$kj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$nH=new M.$kj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$oH=new M.$kj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$pH=new M.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$qH=new M.$kj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$rH=new M.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$sH=new M.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$tH=new M.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$uH=new M.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$vH=new M.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$wH=new M.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$xH=new M.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$yH=new M.$kj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$zH=new M.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$AH=new M.$kj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$BH=new M.$kj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$CH=new M.$kj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$DH=new M.$kj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$EH=new M.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$FH=new M.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const A=l=>y.localize(52,null,l);e.$GH=A,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var P;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(P||(e.State=P={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=m;var f;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(f||(e.MemoryRangeType=f={})),e.$MH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$NH=(0,I.$6h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE",l[l.TRIGGER_POINT=3]="TRIGGER_POINT"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Re([1,0,12,2,19,26,11,29,20,18]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const R=/{([^}]+)}/g;function k(L,v,E){return L.replace(R,function(D,T){return v&&T.length>0&&T[0]!=="_"?D:E&&E.hasOwnProperty(T)?E[T]:D})}e.$0F=k;function l(L){const v={};for(const E of Object.keys(L))E.startsWith("!")||(v[E]=L[E]);return v}e.$$F=l;function p(L){return L.configuration.request==="attach"&&!b(L)&&(!L.parentSession||p(L.parentSession))}e.$_F=p;function b(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,y.$_e)(v,"extensionhost")||(0,y.$_e)(v,"pwa-extensionhost")?L:L.parentSession?b(L.parentSession):void 0}e.$aG=b;function r(L){return L.type&&(L.label||L.program||L.runtime)}e.$bG=r;function a(L,v,E){let D,T=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(L);){const q=G.index+1,z=q+G[0].length;if(q<=v&&z>=E){D=G[0],T=q;break}}if(D){const q=/\w+/g;let z=null;for(;(z=q.exec(D))&&!(z.index+1+T+z[0].length>=E););z&&(D=D.substring(0,q.lastIndex))}return D?{start:T,end:T+D.length-1}:{start:0,end:0}}e.$cG=a;async function s(L,v,E,D){if(L.evaluatableExpressionProvider.has(v)){const T=L.evaluatableExpressionProvider.ordered(v),O=(0,w.$Hb)(await Promise.all(T.map(async G=>{try{return await G.provideEvaluatableExpression(v,E,D??f.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const q=O[0].range;return G||(G=v.getLineContent(E.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:G}}}else{const T=v.getLineContent(E.lineNumber),{start:O,end:G}=a(T,E.column,E.column),q=T.substring(O-1,G);return{matchingExpression:q,range:new m.$Us(E.lineNumber,O,E.lineNumber,O+q.length)}}return null}e.$dG=s;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(L){return!!(L&&L.match(n))}e.$eG=o;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(o(L.path))return M.URI.parse(L.path);if((0,I.$ic)(L.path))return M.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const v=M.URI.revive(L.path);if(v)return v.scheme===P.Schemas.file?v.fsPath:v.toString()}return L.path}function t(L,v){const E=v?c:h,D=(0,A.$vn)(L);return i(D,(T,O)=>{T&&O&&(O.path=E(O))}),D}e.$fG=t;function u(L,v){const E=v?c:h,D=(0,A.$vn)(L);return i(D,(T,O)=>{!T&&O&&(O.path=E(O))}),D}e.$gG=u;function i(L,v){switch(L.type){case"event":{const E=L;switch(E.event){case"output":v(!1,E.body.source);break;case"loadedSource":v(!1,E.body.source);break;case"breakpoint":v(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=L;switch(E.command){case"setBreakpoints":v(!0,E.arguments.source);break;case"breakpointLocations":v(!0,E.arguments.source);break;case"source":v(!0,E.arguments.source);break;case"gotoTargets":v(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>v(!1,D));break;default:break}break}case"response":{const E=L;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>v(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>v(!1,D));break;case"scopes":E.body.scopes.forEach(D=>v(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>v(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>v(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(T=>v(!1,T.location));break;default:break}break}}}function g(L){return L.filter(v=>!v.presentation?.hidden).sort((v,E)=>v.presentation?E.presentation?v.presentation.group?E.presentation.group?v.presentation.group!==E.presentation.group?v.presentation.group.localeCompare(E.presentation.group):$(v.presentation.order,E.presentation.order):-1:E.presentation.group?1:$(v.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.$hG=g;function $(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function d(L,v){const E=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(E!=="none"&&(await v.saveAll(),E==="allEditorsInActiveGroup")){const D=v.activeEditorPane;D&&D.input.resource?.scheme===P.Schemas.untitled&&await v.save({editor:D.input,groupId:D.group.id})}await L.reloadConfiguration()}e.$iG=d;const S=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$jG=S}),define(Pe[209],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.CellExecutionUpdateType=void 0;var M;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$fJ=(0,y.$6h)("INotebookExecutionService")}),define(Pe[210],Re([1,0,6,29,144,94]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQb=void 0;class P extends y.$Tc{constructor(f,w,R){super(),this._source=f,this.b=w,this.c=R,this.a=void 0}f(f){const w=f.getLineCount();return new M.$Us(1,1,w,this.g(f,w))}g(f,w){if(w<1||w>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const f=new I.$cC;f.acceptChunk(this._source);const w=f.finish(!0),{textBuffer:R,disposable:k}=w.create(1);this.b=R,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const w=new I.$cC;w.acceptChunk(f);const R=w.finish(!0),{textBuffer:k,disposable:l}=R.create(1);return this.B(l),k})),this.a}findInInputs(f){const R=new A.$3B(f,!1,!1,null).parseSearchRequest();if(!R)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,R,!0,5e3)}findInOutputs(f){const R=new A.$3B(f,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),R,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$TQb=P}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(A){A.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class I{static fromExtHostTestItem(P,m,f=P.parent){if(P._isRoot)return new I([m]);const w=[P.id];for(let R=f;R&&R.id!==m;R=R.parent)w.push(R.id);return w.push(m),new I(w.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const m=P.indexOf("\0");return m===-1?P:P.slice(0,m)}static fromString(P){return new I(P.split("\0"))}static join(P,m){return new I([...P.path,m])}static joinToString(P,m){return P.toString()+"\0"+m}static parentId(P){const m=P.lastIndexOf("\0");return m===-1?void 0:P.slice(0,m)}static localId(P){const m=P.lastIndexOf("\0");return m===-1?P:P.slice(m+1)}static isChild(P,m){return m.startsWith(P)&&m[P.length]==="\0"}static compare(P,m){return P===m?0:I.isChild(P,m)?2:I.isChild(m,P)?3:1}constructor(P,m=P.length){if(this.path=P,this.d=m,P.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new I(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new I(this.path,P)}compare(P){if(typeof P=="string")return I.compare(this.toString(),P);for(let m=0;m<P.d&&m<this.d;m++)if(P.path[m]!==this.path[m])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$2J=I}),define(Pe[59],Re([1,0,2,92,29,48]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$9J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$8J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7J=e.$6J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4J=e.$3J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var P;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(P||(e.TestResultState=P={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$3J=[2,4,8,16,32,64];const w=C=>"runId"in C;e.$4J=w;var R;(function(C){C.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({range:I.$Us.lift(W.range),uri:N.asCanonicalUri(y.URI.revive(W.uri))})})(R||(e.IRichLocation=R={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&R.deserialize(N,W.location)})})(l||(e.ITestErrorMessage=l={}));const p=(C,N)=>`${N?"s":"e"}${C}`;e.$5J=p;var b;(function(C){C.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&R.deserialize(N,W.location)})})(b||(e.ITestOutputMessage=b={}));var r;(function(C){C.serialize=N=>N.type===0?l.serialize(N):b.serialize(N),C.deserialize=(N,W)=>W.type===0?l.deserialize(N,W):b.deserialize(N,W)})(r||(e.ITestMessage=r={}));var a;(function(C){C.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),C.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),C.deserialize=(N,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(ae=>r.deserialize(N,ae))})})(a||(e.ITestTaskState=a={}));const s="\0",n=(C,N)=>C+s+N;e.$6J=n;const o=C=>{const N=C.indexOf(s);return{ctrlId:C.slice(0,N),tagId:C.slice(N+1)}};e.$7J=o;var c;(function(C){C.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),C.deserialize=(N,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?N.asCanonicalUri(y.URI.revive(W.uri)):void 0,range:W.range?I.$Us.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(C){C.serialize=N=>({expand:N.expand,item:c.serialize(N.item)}),C.deserialize=(N,W)=>({controllerId:A.$2J.root(W.item.extId),expand:W.expand,item:c.deserialize(N,W.item)})})(t||(e.InternalTestItem=t={}));var u;(function(C){C.serialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.uri!==void 0&&(W.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(W.range=N.item.range?.toJSON()),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}},C.deserialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.range!==void 0&&(W.range=N.item.range?I.$Us.lift(N.item.range):null),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}}})(u||(e.ITestItemUpdate=u={}));const i=(C,N)=>{N.expand!==void 0&&(C.expand=N.expand),N.item!==void 0&&(C.item=C.item?Object.assign(C.item,N.item):N.item)};e.$8J=i;var g;(function(C){C.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(a.serializeWithoutMessages)}),C.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(a.serialize)}),C.deserialize=(N,W)=>({...t.deserialize(N,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(ae=>a.deserialize(N,ae)),retired:!0})})(g||(e.TestResultItem=g={}));var $;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(N,W)=>{N.covered+=W.covered,N.total+=W.total}})($||(e.ICoveredCount=$={}));var d;(function(C){C.serialize=N=>({statement:N.statement,branch:N.branch,function:N.function,details:N.details?.map(E.serialize),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(E.deserialize),uri:N.asCanonicalUri(y.URI.revive(W.uri))})})(d||(e.IFileCoverage=d={}));function S(C){return{...C,location:C.location?.toJSON()}}function L(C){return C.location=C.location?M.$Ts.isIPosition(C.location)?M.$Ts.lift(C.location):I.$Us.lift(C.location):void 0,C}e.$9J=3;var v;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(v||(e.DetailType=v={}));var E;(function(C){C.serialize=N=>N.type===0?T.serialize(N):O.serialize(N),C.deserialize=N=>N.type===0?T.deserialize(N):O.deserialize(N)})(E||(e.CoverageDetails=E={}));var D;(function(C){C.serialize=S,C.deserialize=L})(D||(e.IBranchCoverage=D={}));var T;(function(C){C.serialize=S,C.deserialize=L})(T||(e.IFunctionCoverage=T={}));var O;(function(C){C.serialize=N=>({...S(N),branches:N.branches?.map(D.serialize)}),C.deserialize=N=>({...L(N),branches:N.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var q;(function(C){C.deserialize=(N,W)=>W.op===0?{op:W.op,item:t.deserialize(N,W.item)}:W.op===1?{op:W.op,item:u.deserialize(W.item)}:W.op===2?{op:W.op,uri:N.asCanonicalUri(y.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:u.serialize(N.item)}:N})(q||(e.TestsDiffOp=q={}));class z{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const W=this.v();for(const ae of N)switch(ae.op){case 0:this.l(t.deserialize(this.k,ae.item),W);break;case 1:this.o(u.deserialize(ae.item),W);break;case 3:this.p(ae.itemId,W);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}W.complete?.()}l(N,W){const ae=A.$2J.parentId(N.item.extId)?.toString();let de;if(!ae)de=this.w(N),this.g.add(de),this.f.set(N.item.extId,de);else if(this.f.has(ae)){const we=this.f.get(ae);we.children.add(N.item.extId),de=this.w(N,we),this.f.set(N.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return W.add?.(de),N.expand===2&&this.h++,de}o(N,W){const ae=this.f.get(N.extId);if(ae)return N.expand!==void 0&&(ae.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$8J)(ae,N),W.update?.(ae),ae}p(N,W){const ae=this.f.get(N);if(!ae)return;const de=A.$2J.parentId(ae.item.extId)?.toString();de?this.f.get(de).children.delete(ae.item.extId):this.g.delete(ae);const we=[[N]];for(;we.length;)for(const ye of we.pop()){const le=this.f.get(ye);le&&(we.push(le.children),this.f.delete(ye),W.remove?.(le,le!==ae),le.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$0J=z}),define(Pe[76],Re([1,0,13,5,6,54,59,48]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const w=(n,o)=>n===o,k=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,t]of k)t(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class p extends I.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new y.$fh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,P.$8J)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,P.$8J)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,c){switch(c.op){case 3:this.O(m.$2J.joinToString(o.fullId,c.id));break;case 0:this.z(c.item,o);break;case 5:for(const h of c.ops)this.w(o,h);break;case 1:this.C(c.new,c.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.y(o.actual.uri);break;default:(0,A.$6c)(c)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,c){const h=m.$2J.fromExtHostTestItem(o,this.root.id,c?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(o.id);let u=this.tree.get(h.toString());if(!u){u={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(o)}}),this.I(o,u,c);return}if(u.actual===o){this.H(o,u,c);return}if(u.actual.uri?.toString()!==o.uri?.toString())return this.O(h.toString()),this.z(o,c);const i=this.s.getChildren(u.actual),g=u.actual,$=l(this.s.toITestItem(g),this.s.toITestItem(o));this.s.getApiFor(g).listener=void 0,u.actual=o,u.expand=0,$&&($.hasOwnProperty("tags")&&(this.C(o.tags,g.tags,h.toString()),delete $.tags),this.w(u,{op:4,update:$})),this.I(o,u,c);for(const[d,S]of i)this.s.getChildren(o).get(S.id)||this.O(m.$2J.joinToString(h,S.id));this.y(u.actual.uri)}C(o,c,h){const t=new Set(c.map(u=>u.id));for(const u of o)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(u=>(0,P.$6J)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$6J)(this.s.controllerId,o.id)}}))}F(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,P.$6J)(this.s.controllerId,o)}))}G(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}H(o,c,h){this.G(o,h);const t=this.s.getApiFor(o);t.parent=h?.actual,t.listener=u=>this.w(c,u),this.J(c)}I(o,c,h){this.H(o,c,h);for(const[t,u]of this.s.getChildren(o))this.z(u,c)}J(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.M(o))}L(o,c){if(c<0)return;const h=[];for(const[t,u]of this.s.getChildren(o.actual)){const i=this.expand(m.$2J.joinToString(o.fullId,u.id),c);(0,y.$Sg)(i)&&h.push(i)}if(h.length)return Promise.all(h).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const u=new y.$5g;return u.open(),u}o.expand=2,this.N(o);const c=o.resolveBarrier=new y.$5g,h=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(u){h(u)}return(0,y.$Sg)(t)?t.catch(h).then(()=>{c.open(),this.J(o)}):(c.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,i]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$2J.joinToString(t.fullId,i.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$4M=p;class b extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$5M=b;class r extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6M=r;class a extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$7M=a;const s=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,u){for(const i of h.values())t.call(u,i,this)},[Symbol.iterator](){return h.entries()},replace(t){const u=new Map,i=new Set(h.keys()),g={op:5,ops:[]};for(const $ of t){if(!($ instanceof c))throw new r($.id);const d=o($).controllerId;if(d!==n.controllerId)throw new a($.id,d,n.controllerId);if(u.has($.id))throw new b($.id);u.set($.id,$),i.delete($.id),g.ops.push({op:0,item:$})}for(const $ of i.keys())g.ops.push({op:3,id:$});n.listener?.(g),h=u},add(t){if(!(t instanceof c))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$8M=s}),define(Pe[103],Re([1,0,76]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0;const M=new WeakMap,I=(P,m)=>{const f={controllerId:m};return M.set(P,f),f};e.$9M=I;const A=P=>{const m=M.get(P);if(!m)throw new y.$6M(P?.id||"<unknown>");return m};e.$0M=A}),define(Pe[77],Re([1,0,11,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Evb=e.$Dvb=e.$Cvb=e.$Bvb=e.$Avb=void 0,e.$Avb="vscode-cdn.net",e.$Bvb=`vscode-resource.${e.$Avb}`,e.$Cvb=`'self' https://*.${e.$Avb}`;function I(m,f){return m.scheme===y.Schemas.http||m.scheme===y.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===y.Schemas.file&&(m=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:f.authority,path:m.path})),M.URI.from({scheme:y.Schemas.https,authority:`${m.scheme}+${A(m.authority)}.${e.$Bvb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Dvb=I;function A(m){return m.replace(/./g,f=>{const w=f.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?f:"-"+w.toString(16).padStart(4,"0")})}function P(m){return m.replace(/-([0-9a-f]{4})/g,(f,w)=>String.fromCharCode(parseInt(w,16)))}e.$Evb=P}),define(Pe[211],Re([1,0,5,6,77]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class A{constructor(m,f,w){this.d=m,this.e=f,this.f=w,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const R=f.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,w,R,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,r=new y.$Vd,a=new y.$Vd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,I.$Dvb)(o,p.f)}get cspSource(){return I.$Cvb}set options(o){this.b=o,p.d.$setOptions(b,o)}get options(){return this.b}set html(o){this.a=o,p.d.$setHtml(b,o)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(o){return p.d.$postMessage(b,o)}},n=new class{constructor(){this.editor=m,this.line=f,this.height=w,this.webview=s,this.onDidDispose=a.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,f+1,w,R||{},k.identifier,k.extensionLocation),this.c.set(b,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$ugc=A}),define(Pe[212],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.VariableKind=e.$ZN=void 0,e.$ZN=(0,y.$6h)("configurationResolverService");var M;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class I extends Error{constructor(P,m){super(m),this.variable=P}}e.$1N=I}),define(Pe[213],Re([1,0,19,74,16,26,21,95,176,212,12]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,r,a){this.h=new Map,this.a=p,this.b=b,this.g=r,a&&(this.c=a.then(s=>this.i(s)))}i(p){if(P.$i){const b=Object.create(null);return Object.keys(p).forEach(r=>{b[r.toLowerCase()]=p[r]}),b}return p}resolveWithEnvironment(p,b,r){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,r)}async resolveAsync(p,b){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,b)}async j(p,b,r,a){const s=A.$vn(b);P.$i&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):P.$j&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):P.$k&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,s,r,a)}async resolveAnyAsync(p,b,r){return this.j(p,b,r)}async resolveAnyMap(p,b,r){const a=new Map;return{newConfig:await this.j(p,b,r,a),resolvedVariables:a}}resolveWithInteractionReplace(p,b,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,r,a,s){if(I.$If(r))return this.m(p,b,r,a,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,b,n,a,s)));if(I.$Kf(r)){const n=Object.create(null),o=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,b,c,a,s),await this.l(p,b,r[c],a,s)]));for(const[c,h]of o)n[c]=h;return n}return r}m(p,b,r,a,s){return(0,R.$4e)(r,k.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(k.VARIABLE_LHS))return n;let c=await this.o(p,n,o,b,a);return s?.set(o,c),c!==n&&I.$If(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,a,s)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,r,a,s){let n;const o=r.split(":");o.length>1&&(r=o[0],n=o[1]);const c=u=>{const i=this.a.getFilePath();if(i)return(0,m.$Wv)(i);throw new w.$1N(u,(0,f.localize)(0,null,b))},h=u=>{const i=c(u);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,m.$Wv)(g)}throw new w.$1N(u,(0,f.localize)(1,null,b,y.$nc(i)))},t=u=>{if(n){const i=this.a.getFolderUri(n);if(i)return i;throw new w.$1N(u,(0,f.localize)(2,null,b,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new w.$1N(u,(0,f.localize)(3,null,b)):new w.$1N(u,(0,f.localize)(4,null,b))};switch(r){case"env":if(n){if(p.env){const u=p.env[P.$i?n.toLowerCase():n];if(I.$If(u))return u}return""}throw new w.$1N(w.VariableKind.Env,(0,f.localize)(5,null,b));case"config":if(n){const u=this.a.getConfigurationValue(a,n);if(I.$Rf(u))throw new w.$1N(w.VariableKind.Config,(0,f.localize)(6,null,b,n));if(I.$Kf(u))throw new w.$1N(w.VariableKind.Config,(0,f.localize)(7,null,b,n));return u}throw new w.$1N(w.VariableKind.Config,(0,f.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,s,"command");case"input":return this.p(w.VariableKind.Input,b,n,s,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new w.$1N(w.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,b,n));return this.n(u.extensionLocation)}throw new w.$1N(w.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,b));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$Wv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,m.$Wv)(this.n(t(w.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Wv)(y.$nc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.$1N(w.VariableKind.UserHome,(0,f.localize)(11,null,b))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new w.$1N(w.VariableKind.LineNumber,(0,f.localize)(12,null,b))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new w.$1N(w.VariableKind.SelectedText,(0,f.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?y.$lc(this.n(t(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const u=y.$mc(c(w.VariableKind.RelativeFileDirname));if(a||n){const i=y.$lc(this.n(t(w.VariableKind.RelativeFileDirname)),u);return i.length===0?".":i}return u}case"fileDirname":return y.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return y.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return y.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=y.$nc(c(w.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-y.$oc(u).length)}case"fileDirnameBasename":return y.$nc(y.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||b}case"execInstallFolder":{const u=this.a.getAppRoot();return u||b}case"pathSeparator":case"/":return y.sep;default:try{const u=n?`${r}:${n}`:r;return this.p(w.VariableKind.Unknown,b,u,s,void 0)}catch{return b}}}}p(p,b,r,a,s){if(r&&a){const n=s===void 0?a[r]:a[s+":"+r];if(typeof n=="string")return n;throw new w.$1N(p,(0,f.localize)(14,null,b))}return b}}e.$cO=k}),define(Pe[104],Re([1,0,4,102]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,y.$6h)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var A;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var m;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function w(b){const r=b;return(0,M.$SE)(r?.editor)&&(0,M.$SE)(r?.replacement)}e.$0C=w;var R;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(b){const r=b;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$$C=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=p}),define(Pe[214],Re([1,0,4,104]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,y.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function I(A){const P=A;return typeof A=="number"||(0,M.$$C)(P)}e.$eD=I}),define(Pe[215],Re([1,0,4,183]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=void 0,e.$uK=(0,y.$7h)(M.$ai)}),define(Pe[105],Re([1,0,23,5,19,6]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=e.$s8b=e.$r8b=e.$q8b=e.$p8b=void 0;class P{constructor(s,n){this.versionId=s,this.removedDueToLooping=n}}e.$p8b=P;class m{static isHostExtension(s,n,o){if(n.getExtensionDescription(s))return!1;const c=o.getExtensionDescription(s);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(s,n){this.j=s,this.c=new M.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new y.$nm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const n=this.j.readActivationEvents(s);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,n){this.e=r(this.e,n),this.e=this.e.concat(s);const o=m.l(this.e);return this.e=r(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new P(this.d,o)}static l(s){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,i){this.addNode(u),this.addNode(i),this.c.has(u)?this.c.get(u).push(i):this.c.set(u,[i])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,i){const g=n.getArcs(u);for(let $=0;$<g.length;$++)if(!i.has(g[$]))return!1;return!0}getNodes(){return this.e}},o=new y.$nm;for(const u of s)if(o.set(u.identifier,u),u.extensionDependencies)for(const i of u.extensionDependencies)n.addArc(y.$lm.toKey(u.identifier),y.$lm.toKey(i));const c=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>c.add(u));const h=n.getNodes().filter(u=>!c.has(u));let t;do{t=!1;for(let u=0;u<h.length;u++){const i=h[u];n.hasOnlyGoodArcs(i,c)&&(h.splice(u,1),u--,c.add(i),t=!0)}}while(t);return h.map(u=>o.get(u))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const n=this.h.get(s);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new f(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const n=this.f.get(s);return n||void 0}getExtensionDescriptionByUUID(s){for(const n of this.g)if(n.uuid===s)return n}getExtensionDescriptionByIdOrUUID(s,n){return this.getExtensionDescription(s)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$q8b=m;class f{constructor(s,n){this.versionId=s,this.extensions=n}}e.$r8b=f;class w{constructor(s){this.d=new l,this.c=new m(s,[])}async acquireLock(s){const n=await this.d.acquire(s);return new R(this,n)}deltaExtensions(s,n,o){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,n){return this.c.getExtensionDescriptionByIdOrUUID(s,n)}}e.$s8b=w;class R extends A.$Tc{constructor(s,n){super(),this.f=s,this.c=!1,this.B(n)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$t8b=R;class k{constructor(s){this.name=s,this.promise=new Promise((n,o)=>{this.c=n})}resolve(s){this.c(s)}}class l{constructor(){this.c=[],this.d=!1}async acquire(s){const n=new k(s);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};s.resolve((0,A.$Rc)(c))}}var p;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(p||(p={}));function b(a,s){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=I.$gc.basename(a.extensionLocation.path),h=I.$gc.basename(s.extensionLocation.path);return c<h?-1:c>h?1:0}function r(a,s){const n=new y.$mm(s);return a.filter(o=>!n.has(o.identifier))}}),define(Pe[78],Re([1,0,22]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(M||(e.UIKind=M={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var A;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function P(w){const R=y.$je.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$tm=P;function m(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$um=m;var f;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[60],Re([1,0,4,5,14,27,78,56,57,26,2,6,164]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.$sN=void 0;let p=class extends k.$Tc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new M.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$Qo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,I.$pj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,o){const c=this.getTelemetryDetails(),h=new b(n,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,o){this.f=s,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:n["common.uikind"]="web";break;case P.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$bl)((0,f.$Wo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$sN=p,e.$sN=p=Je([He(0,A.$rN),He(1,I.$oj)],p);class b{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,o,c,h,t,u){this.g=o,this.h=c,this.i=h,this.j=t,this.a=new M.$Vd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,f.$Zo)(n,[]),this.c&&(n=(0,w.$yn)(n,this.c)),this.b||(n=(0,w.$yn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,f.$Zo)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$tN=b;function r(a){const s=Date.now()-new Date(a).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$uN=r,e.$vN=(0,y.$6h)("IExtHostTelemetry")}),define(Pe[24],Re([1,0,5,2,192,101,23,4]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new P.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,m.$6h)("extensionService");class f{constructor(h){this.dependency=h}}e.$zF=f;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,u){this.c=h,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$hF.createActivationEventsMap(this.d)}}set(h,t,u){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const i=[],g=[],$=[],d=[],S=k(this.d),L=k(t),v=(G,q)=>G.extensionLocation.toString()===q.extensionLocation.toString()||G.isBuiltin===q.isBuiltin||G.isUserBuiltin===q.isUserBuiltin||G.isUnderDevelopment===q.isUnderDevelopment;for(const G of this.d){const q=L.get(G.identifier);if(!q){i.push(G.identifier),S.delete(G.identifier);continue}if(!v(G,q)){i.push(G.identifier),S.delete(G.identifier);continue}}for(const G of t){const q=S.get(G.identifier);if(!q){g.push(G);continue}if(!v(q,G)){i.push(q.identifier),S.delete(q.identifier);continue}}const E=new P.$mm(this.e),D=new P.$mm(u);for(const G of this.e)D.has(G)||$.push(G);for(const G of u)E.has(G)||d.push(G);const T=A.$hF.createActivationEventsMap(g),O={versionId:h,toRemove:i,toAdd:g,addActivationEvents:T,myToRemove:$,myToAdd:d};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:i,myToAdd:g}=h,$=new P.$mm(t),d=new P.$mm(i);for(let S=0;S<this.d.length;S++)$.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)d.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of u)this.d.push(S);for(const S of g)this.e.push(S);return this.f=null,h}containsExtension(h){for(const t of this.e)if(P.$lm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=A.$hF.readActivationEvents(t);for(const i of u)h.add(i)}return h}}e.$AF=R;function k(c){const h=new P.$nm;for(const t of c)h.set(t.identifier,t);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$BF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$CF=p;class b{constructor(h,t,u,i){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=i}}e.$DF=b;class r{constructor(h,t){this.description=h,this.value=t}}e.$EF=r;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$6o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$FF=s;function n(c,h){return{identifier:new P.$lm((0,I.$4o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$GF=n;class o{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=o}),define(Pe[216],Re([1,0,15,105,23,24,14,13]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(s,n,o,c){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$Qgc=f;class w{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rgc=w;class R{constructor(s,n,o,c,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=t}}e.$Sgc=R;class k extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tgc=k;class l extends R{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ugc=l;class p extends R{constructor(s){super(!0,s,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(s,n,o,c){this.g=c,this.a=s,this.b=n,this.c=o,this.d=new I.$nm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(s){const n=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new p(h));return this.c.onExtensionActivationError(s.id,h,new A.$zF(s.id.value)),t}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){o.push(t);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const u=this.a.getExtensionDescription(h);if(u){if(!u.main&&!u.browser)continue;o.push(this.j({id:u.identifier,reason:s.reason}));continue}const i=n.displayName||n.identifier.value,g=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${h}'`),$=this.k(s,n.displayName,[],new p(g));return this.c.onExtensionActivationError(n.identifier,g,new A.$zF(h)),$}return this.k(s,n.displayName,o,null)}k(s,n,o,c){const h=new r(s.id,n,s.reason,o,c,this.c,this.g);return this.d.set(s.id,h),h}l(s){return M.$q8b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Vgc=b,e.$Vgc=b=Je([He(3,P.$nj)],b);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,o,c,h,t,u){this.c=s,this.d=n,this.f=o,this.g=c,this.h=h,this.j=t,this.k=u,this.a=new m.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new p(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new p(n),this.b&&y.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([He(6,P.$nj)],r)}),define(Pe[217],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[218],Re([1,0,178,15,31,97,73,30,23,217,188,101]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const l=m.$Hn.as(P.$In.JSONContribution);class p{constructor(h,t,u){this.a=h,this.b=t,this.c=u}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$qF=p;class b{static a(h){const t=new f.$mm;for(let u=0,i=h.length;u<i;u++)t.add(h[u].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new b(t,[]);if(!t||!t.length)return new b([],h);const u=this.a(h),i=this.a(t),g=t.filter(d=>!u.has(d.description.identifier)),$=h.filter(d=>!i.has(d.description.identifier));return new b(g,$)}constructor(h,t){this.added=h,this.removed=t}}e.$rF=b;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,M.$1)(h)}}}e.$sF=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$km},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$mo}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$mo}},extensionKind:{description:y.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&k.$hF.register(h.extensionPoint,h.activationEventsGenerator),e.$tF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(s,e.$tF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$Hn.add(o.ExtensionsRegistry,new n),e.$vF=m.$Hn.as(o.ExtensionsRegistry),l.registerSchema(s,e.$tF),l.registerSchema(R.$Gj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[219],Re([1,0,174,16,26,218,35,5]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var w;(function(l){function p(b,r,a){if(!b)return;const s=M.$If(b.type)?b.type:void 0;if(!s||s.length===0){a.error(y.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const o of b.required)M.$If(o)&&n.push(o);return{extensionId:r.value,taskType:s,required:n,properties:b.properties?I.$vn(b.properties):{},when:b.when?P.$4i.deserialize(b.when):void 0}}l.from=p})(w||(w={}));const R=A.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new m.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{R.setHandler((r,a)=>{this.c=void 0;try{for(const s of a.removed){const n=s.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of a.added){const n=s.value;for(const o of n){const c=w.from(o,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const r={type:"object",additionalProperties:!1};b.required.length>0&&(r.required=b.required.slice(0)),b.properties!==void 0?r.properties=I.$vn(b.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[b.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$xG=new k}),define(Pe[220],Re([1,0,175,16,25,26,35,219]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new P.$kj("taskRunning",!1,y.localize(0,null)),e.$AG={value:y.localize(1,null),original:"Tasks"};var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$BG="$customized",function(C){function N(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=N}(f||(e.ShellQuoting=f={}));var w;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(R||(e.RevealKind=R={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=N}(R||(e.RevealKind=R={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=N}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function N(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=N}(l||(e.PanelKind=l={}));var p;(function(C){C.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(C){function N(ae){switch(ae.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=N;function W(ae){switch(ae){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}(b||(e.RuntimeType=b={}));var r;(function(C){function N(W){return M.$If(W)?W:W.value}C.value=N})(r||(e.CommandString=r={}));var a;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function N(ae){return ae===C.Clean._id||ae===C.Build._id||ae===C.Rebuild._id||ae===C.Test._id}C.is=N;function W(ae){if(ae!==void 0)return M.$If(ae)?N(ae)?{_id:ae,isDefault:!1}:void 0:ae}C.from=W})(a||(e.TaskGroup=a={}));var s;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function N(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var o;(function(C){C.parallel="parallel",C.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(N,W,ae,de,we,ye){this._label="",this._id=N,W&&(this._label=W),ae&&(this.type=ae),this.runOptions=de,this.configurationProperties=we,this._source=ye}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(M.$If(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$CG=t;class u extends t{constructor(N,W,ae,de,we,ye,le,$e){super(N,ae,void 0,le,$e,W),this.command={},this._source=W,this.hasDefinedMatchers=ye,we&&(this.command=we)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case b.Shell:W="shell";break;case b.Process:W="process";break;case b.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof u}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$BG,folder:N,id:W};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new u(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$DG=u;class i extends t{constructor(N,W,ae,de,we,ye,le){super(N,ae,de,ye,le,W),this._source=W,this.configures=we}static is(N){return N instanceof i}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$BG,folder:N,id:W};return JSON.stringify(ae)}}e.$EG=i;class g extends t{constructor(N,W,ae,de,we,ye,le,$e,ie){super(N,ae,de,$e,ie,W),this.defines=we,this.hasDefinedMatchers=le,this.command=ye,this.icon=ie.icon,this.hide=ie.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof g}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new g(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$FG=g;class $ extends t{constructor(N,W,ae,de,we,ye){super(N,ae,de,we,ye,W),this._source=W}clone(){return new $(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof $}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new $(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$GG=$;var d;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(C){C._default=C.Terminal}(d||(e.ExecutionEngine=d={}));var S;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(N){this.c=new Map;for(let W=0;W<N.length;W++)this.c.set(N[W].uri.toString(),W)}compare(N,W){const ae=N.getWorkspaceFolder(),de=W.getWorkspaceFolder();if(ae&&de){let we=this.c.get(ae.uri.toString());we=we===void 0?0:we+1;let ye=this.c.get(de.uri.toString());return ye=ye===void 0?0:ye+1,we===ye?N._label.localeCompare(W._label):we-ye}else return!ae&&de?-1:ae&&!de?1:0}}e.$HG=L;var v;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(v||(e.TaskEventKind=v={}));var E;(function(C){C.SingleRun="singleRun",C.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var T;(function(C){function N($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function W($e,ie,be){return{...N($e),kind:"start",terminalId:ie,resolvedVariables:be}}C.start=W;function ae($e,ie,be){return{...N($e),kind:"processStarted",terminalId:ie,processId:be}}C.processStarted=ae;function de($e,ie,be){return{...N($e),kind:"processEnded",terminalId:ie,exitCode:be}}C.processEnded=de;function we($e,ie,be){return{...N($e),kind:"terminated",exitReason:be,terminalId:ie}}C.terminated=we;function ye($e,ie,be){return{...N(ie),kind:$e,terminalId:be}}C.general=ye;function le(){return{kind:"changed"}}C.changed=le})(T||(e.TaskEvent=T={}));var O;(function(C){function N(ae){const de=Object.keys(ae).sort();let we="";for(const ye of de){let le=ae[ye];le instanceof Object?le=N(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),we+=ye+","+le+","}return we}function W(ae){const we={_key:N(ae),type:ae.taskType};return Object.assign(we,ae),we}C.create=W})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var z;(function(C){function N(W,ae){const de=m.$xG.get(W.type);if(de===void 0){const $e=A.$vn(W);return delete $e._key,O.create($e)}const we=Object.create(null);we.type=de.taskType;const ye=new Set;de.required.forEach($e=>ye.add($e));const le=de.properties;for(const $e of Object.keys(le)){const ie=W[$e];if(ie!=null)we[$e]=ie;else if(ye.has($e)){const be=le[$e];if(be.default!==void 0)we[$e]=A.$vn(be.default);else switch(be.type){case"boolean":we[$e]=!1;break;case"number":case"integer":we[$e]=0;break;case"string":we[$e]="";break;default:ae.error(y.localize(2,null,JSON.stringify(W,void 0,0),$e));return}}}return O.create(we)}C.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(Pe[221],Re([1,0,15]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,m)=>{this.b=P,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,y.$1)(P))}then(P,m){return this.j().then(P,m)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$u8b=M;class I extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$v8b=I}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class y{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++y.count}}e.$Qv=y;const M=[];function I(m){const f=new y(m);return M[f.nid]=f,f}e.$Rv=I;function A(m){return M[m].sid}e.$Sv=A;class P{constructor(f){this.value=f}}e.$Tv=P}),define(Pe[3],Re([1,0,49]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.$0K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var A;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var P;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var w;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(a){return a._id=k.a++,a}}e.$9K=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$0K={MainThreadAuthentication:(0,y.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Rv)("MainThreadCommands"),MainThreadComments:(0,y.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Rv)("MainThreadSCM"),MainThreadSearch:(0,y.$Rv)("MainThreadSearch"),MainThreadShare:(0,y.$Rv)("MainThreadShare"),MainThreadTask:(0,y.$Rv)("MainThreadTask"),MainThreadWindow:(0,y.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Rv)("MainThreadInteractive"),MainThreadChat:(0,y.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Rv)("MainThreadIssueReporter")},e.$$K={ExtHostCommands:(0,y.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Rv)("ExtHostSCM"),ExtHostSearch:(0,y.$Rv)("ExtHostSearch"),ExtHostTask:(0,y.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Rv)("ExtHostProgress"),ExtHostComments:(0,y.$Rv)("ExtHostComments"),ExtHostSecretState:(0,y.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Rv)("ExtHostStorage"),ExtHostUrls:(0,y.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Rv)("ExtHostIssueReporter")}}),define(Pe[79],Re([1,0,4,14,3,17]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0,e.$hgc=(0,y.$6h)("IExtHostApiDeprecationService");let P=class{constructor(f,w){this.c=w,this.a=new Set,this.b=f.getProxy(I.$0K.MainThreadTelemetry)}report(f,w,R){const k=this.d(f,w);this.a.has(k)||(this.a.add(k),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:f}))}d(f,w){return`${f}-${w.identifier.value}`}};e.$igc=P,e.$igc=P=Je([He(0,A.$bN),He(1,M.$nj)],P),e.$jgc=Object.freeze(new class{report(m,f,w){}})}),define(Pe[222],Re([1,0,3]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class M{constructor(A){const P=A.getProxy(y.$0K.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(m){return P.$writeText(m)}})}}e.$sgc=M}),define(Pe[223],Re([1,0,26,3,27,17]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;let P=class{constructor(R,k){this.a=R.getProxy(M.$0K.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,k){const l=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,k,p,arguments)}})}e(R,k,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f(p,this.b)}),this.c&&this.f(R,l,p)}};e.$jic=P,e.$jic=P=Je([He(0,A.$bN),He(1,I.$rN)],P);const m=1e5;function f(w,R){const k=[];if(w.length)for(let l=0;l<w.length;l++){let p=w[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}k.push(p)}if(R){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,y.$An)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[224],Re([1,0,2,3,24]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class A{constructor(m){this.a=m.getProxy(M.$0K.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,I.$CF)(m,"showLocal"),this.a.$showOpenDialog(f).then(w=>w?w.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?y.URI.revive(f):void 0)}}e.$nhc=A}),define(Pe[225],Re([1,0,6,3]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class I{constructor(P){this.b=0,this.a=P.getProxy(M.$0K.MainThreadLabelService)}$registerResourceLabelFormatter(P){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,P),(0,y.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Ihc=I}),define(Pe[80],Re([1,0,21,12,2,4,14,3,27,17]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;let R=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy(m.$0K.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===y.$g}getMessage(l,p){const{message:b,args:r,comment:a}=p;if(this.c)return(0,M.$Le)(b,r??{});let s=b;a&&a.length>0&&(s+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(l)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$Le)(n??b,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(b),a=JSON.parse(r);p=l.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$8gc=R,e.$8gc=R=Je([He(0,f.$rN),He(1,w.$bN),He(2,P.$nj)],R),e.$9gc=(0,A.$6h)("IExtHostLocalizationService")}),define(Pe[226],Re([1,0,14,3,27,17,2,51]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;let f=class extends y.$yj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,m.$Ch)(p))),this.r=k.getProxy(M.$0K.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(P.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,p){return new w(this.r,k,l,p)}};e.$iic=f,e.$iic=f=Je([He(0,A.$bN),He(1,I.$rN)],f);class w extends y.$tj{constructor(k,l,p,b){super(b?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const p=[[k,l]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[81],Re([1,0,3,4,6,17,22]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,M.$6h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$0K.MainThreadManagedSockets)}setFactory(k,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,p=await this.c.makeConnection(),b=new I.$Sc;return this.d.set(l,new w(l,p,b)),b.add((0,I.$Rc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),b.dispose()})),b.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,P.$je.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$$gc=m,e.$$gc=m=Je([He(0,A.$bN)],m);class f{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class w extends I.$Tc{constructor(k,l,p){super(),this.socketId=k,this.actual=l,this.B(p)}}}),define(Pe[227],Re([1,0,3,14,24]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;function A(m){return m&&m.title}let P=class{constructor(f,w){this.b=w,this.a=f.getProxy(y.$0K.MainThreadMessageService)}showMessage(f,w,R,k,l){const p={source:{identifier:f.identifier,label:f.displayName||f.name}};let b;typeof k=="string"||A(k)?b=[k,...l]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,b=l),p.useCustom&&(0,I.$CF)(f,"resolvers");const r=[];let a=!1;for(let s=0;s<b.length;s++){const n=b[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;r.push({title:o,isCloseAffordance:!!c,handle:s}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(w,R,p,r).then(s=>{if(typeof s=="number")return b[s]})}};e.$Khc=P,e.$Khc=P=Je([He(1,M.$nj)],P)}),define(Pe[228],Re([1,0,6,16,2,24,3]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(P.$0K.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,R,k){if((0,A.$CF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,w.identifier.value),(0,y.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,k,l){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(R,k,l)}async $readProfile(w,R,k){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,M.$If)(R)?R:I.URI.revive(R),k)}}e.$Thc=m}),define(Pe[82],Re([1,0,3,5,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=void 0;class A{constructor(m){this.b=new M.$Vd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(y.$0K.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,w){return this.a.$setPassword(m,f,w)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$5gc=A,e.$6gc=(0,I.$6h)("IExtHostSecretState")}),define(Pe[229],Re([1,0,20,6,3]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class A{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$0K.MainThreadSpeech)}async $createSpeechToTextSession(m,f){const w=this.c.get(m);if(!w)return;const R=new M.$Sc,k=new y.$6d;this.d.set(f,k);const l=R.add(w.provideSpeechToTextSession(k.token));R.add(l.onDidChange(p=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,p)})),R.add(k.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,w){const R=A.a++;return this.c.set(R,w),this.b.$registerProvider(R,f,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$1hc=A}),define(Pe[83],Re([1,0,3,5,4]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;class A{constructor(m,f){this.c=f,this.b=new M.$Vd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(y.$0K.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,w){const R=await this.a.$initializeExtensionStorage(m,f);let k;return R&&(k=this.d(m,f,R)),k||w}setValue(m,f,w){return this.a.$setValue(m,f,w)}$acceptValue(m,f,w){const R=this.d(m,f,w);R&&this.b.fire({shared:m,key:f,value:R})}d(m,f,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${R}`)}}}e.$Wgc=A,e.$Xgc=(0,I.$6h)("IExtHostStorage")}),define(Pe[230],Re([1,0,6,11,2,3]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class P{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(A.$0K.MainThreadUriOpeners)}registerExternalUriOpener(f,w,R,k){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=k.schemes.find(p=>!P.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,k.schemes,f,k.label),(0,y.$Rc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(f,w,R){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const l=I.URI.revive(w);return k.canOpenExternalUri(l,R)}async $openUri(f,w,R){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},R)}}e.$cic=P}),define(Pe[231],Re([1,0,3,2,6,15,23]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class m{static{this.a=0}constructor(w){this.c=new P.$mm,this.d=new Map,this.b=w.getProxy(y.$0K.MainThreadUrls)}registerUriHandler(w,R){const k=w.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,R),this.b.$registerUriHandler(l,k,w.displayName||w.name),(0,I.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,R){const k=this.d.get(w);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(l){(0,A.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return M.URI.revive(await this.b.$createAppUri(w))}}e.$dic=m}),define(Pe[61],Re([1,0,5,6,11,26,2,181,203,77,3]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;class k{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(c,h,t,u,i,g,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Vd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=t,this.#o=u,this.#n=i,this.#r=g,this.#l=l(g),this.#d=p(g),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$Dvb)(c,this.#o)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$Cvb}return w.$Cvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),A.$zn(this.#s,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#n,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,f.$hlb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,i,g,$,d,S)=>{const L=P.URI.from({scheme:$||"file",path:decodeURIComponent(d)}),v=(0,w.$Dvb)(L,{isRemote:h,authority:t}).toString();return`${i}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,i,g,$,d,S)=>{const L=P.URI.from({scheme:$||"file",path:decodeURIComponent(d)}),v=(0,w.$Dvb)(L,{isRemote:h,authority:t}).toString();return`${i}${v}${S}`})}}e.$Hgc=k;function l(o){try{const c=(0,m.$cp)((0,m.$bp)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Igc=l;function p(o){try{const c=(0,m.$cp)((0,m.$bp)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends M.$Tc{constructor(c,h,t,u,i){super(),this.c=h,this.f=t,this.g=u,this.h=i,this.b=new Map,this.a=c.getProxy(R.$0K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,t){const u=this.j(c);if(u){const{message:i}=(0,f.$ilb)(h,t.value);u._onMessageEmitter.fire(i)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,t){const u=new k(c,this.a,s(h),this.c,this.f,t,this.h);this.b.set(c,u);const i=u._onDidDispose(()=>{i.dispose(),this.deleteWebview(c)});return u}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Jgc=b;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.$Kgc=r;function a(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$Lgc=a;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>P.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Pe[106],Re([1,0,5,3,2,11,12,4,17,24]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$CF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new y.$Vd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(M.$0K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:r})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let r;if(typeof p=="string"){r=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,P.$Je)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,b)}async asExternalUri(p,b){if((0,P.$Je)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,b);return I.URI.from(r)}};e.$fic=k,e.$fic=k=R=Je([He(0,f.$bN)],k),e.$gic=(0,m.$6h)("IExtHostWindow")}),define(Pe[232],Re([1,0,223,27,17]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;let A=class extends y.$jic{constructor(m,f){super(m,f)}f(m,f,w){f.apply(console,w)}};e.$skc=A,e.$skc=A=Je([He(0,I.$bN),He(1,M.$rN)],A)}),define(Pe[233],Re([1,0,13,22,20,15,5,6,139,221,49]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.ResponsiveState=e.RequestInitiator=e.$x8b=e.$w8b=void 0;function l(D,T){try{return JSON.stringify(D,T)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class r{constructor(T,O){this.jsonString=T,this.referencedBuffers=O}}function a(D,T=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(D,(z,C)=>{if(typeof C>"u")return b;if(typeof C=="object"){if(C instanceof M.$je){const N=G.push(C)-1;return{[p]:N}}if(T)return T(z,C)}return C}),referencedBuffers:G}}e.$w8b=a;function s(D,T,O){return JSON.parse(D,(G,q)=>{if(q){const z=q[p];if(typeof z=="number")return T[z];if(O&&q.$mid===1)return O.transformIncoming(q)}return q})}e.$x8b=s;function n(D,T){return JSON.stringify(D,T)}function o(D){return D?(T,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},u=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class g extends m.$Tc{static{k=u}static{this.a=3*1e3}constructor(T,O=null,G=null){super(),this[k]=!0,this.b=this.B(new P.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=O,this.g=G,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,z=R.$Qv.count;q<z;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$fh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const O=this.w[T];delete this.w[T],O.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,f.$7m)(T,this.g):T}getProxy(T){const{nid:O,sid:G}=T;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(T,O){const G={get:(q,z)=>(typeof z=="string"&&!q[z]&&z.charCodeAt(0)===36&&(q[z]=(...C)=>this.U(T,z,C)),z===i?O:q[z])};return new Proxy(Object.create(null),G)}set(T,O){return this.m[T.nid]=O,O}assertRegistered(T){for(let O=0,G=T.length;O<G;O++){const q=T[O];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(T){if(this.j)return;const O=T.byteLength,G=d.read(T,0),q=G.readUInt8(),z=G.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:N,args:W}=L.deserializeRequestJSONArgs(G);this.g&&(W=(0,f.$7m)(W,this.g)),this.M(O,z,C,N,W,q===2);break}case 3:case 4:{let{rpcId:C,method:N,args:W}=L.deserializeRequestMixedArgs(G);this.g&&(W=(0,f.$7m)(W,this.g)),this.M(O,z,C,N,W,q===4);break}case 5:{this.f?.logIncoming(O,z,0,"ack"),this.G(z);break}case 6:{this.N(O,z);break}case 7:{this.O(O,z,void 0);break}case 9:{let C=L.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$7m)(C,this.g)),this.O(O,z,C);break}case 10:{const C=L.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,z,C);break}case 8:{const C=L.deserializeReplyOKVSBuffer(G);this.O(O,z,C);break}case 11:{let C=L.deserializeReplyErrError(G);this.g&&(C=(0,f.$7m)(C,this.g)),this.P(O,z,C);break}case 12:{this.P(O,z,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,O,G,q,z,C){this.f?.logIncoming(T,O,1,`receiveRequest ${(0,R.$Sv)(G)}.${q}(`,z);const N=String(O);let W,ae;if(C){const we=new I.$6d;z.push(we.token),W=this.Q(G,q,z),ae=()=>we.cancel()}else W=this.Q(G,q,z),ae=t;this.u[N]=ae;const de=L.serializeAcknowledged(O);this.f?.logOutgoing(de.byteLength,O,1,"ack"),this.c.send(de),W.then(we=>{delete this.u[N];const ye=L.serializeReplyOK(O,we,this.h);this.f?.logOutgoing(ye.byteLength,O,1,"reply:",we),this.c.send(ye)},we=>{delete this.u[N];const ye=L.serializeReplyErr(O,we);this.f?.logOutgoing(ye.byteLength,O,1,"replyErr:",we),this.c.send(ye)})}N(T,O){this.f?.logIncoming(T,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(T,O,G){this.f?.logIncoming(T,O,0,"receiveReply:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const z=this.w[q];delete this.w[q],z.resolveOk(G)}P(T,O,G){this.f?.logIncoming(T,O,0,"receiveReplyErr:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const z=this.w[q];delete this.w[q];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),z.resolveErr(C)}Q(T,O,G){try{return Promise.resolve(this.S(T,O,G))}catch(q){return Promise.reject(q)}}S(T,O,G){const q=this.m[T];if(!q)throw new Error("Unknown actor "+(0,R.$Sv)(T));const z=q[O];if(typeof z!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.$Sv)(T));return z.apply(q,G)}U(T,O,G){if(this.j)return new w.$v8b;let q=null;if(G.length>0&&I.CancellationToken.isCancellationToken(G[G.length-1])&&(q=G.pop()),q&&q.isCancellationRequested)return Promise.reject(A.$6());const z=L.serializeRequestArguments(G,this.h),C=++this.t,N=String(C),W=new w.$u8b,ae=new m.$Sc;q&&ae.add(q.onCancellationRequested(()=>{const we=L.serializeCancel(C);this.f?.logOutgoing(we.byteLength,C,0,"cancel"),this.c.send(L.serializeCancel(C))})),this.w[N]=new $(W,ae),this.F(C);const de=L.serializeRequest(C,T,O,z,!!q);return this.f?.logOutgoing(de.byteLength,C,0,`request: ${(0,R.$Sv)(T)}.${O}(`,G),this.c.send(de),W}}e.$y8b=g;class ${constructor(T,O){this.a=T,this.b=O}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class d{static alloc(T,O,G){const q=new d(M.$je.alloc(G+1+4),0);return q.writeUInt8(T),q.writeUInt32(O),q}static read(T,O){return new d(T,O)}get buffer(){return this.a}constructor(T,O){this.a=T,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+T);return this.b+=T,O}static sizeMixedArray(T){let O=0;O+=1;for(let G=0,q=T.length;G<q;G++){const z=T[G];switch(O+=1,z.type){case 1:O+=this.sizeLongString(z.value);break;case 2:O+=this.sizeVSBuffer(z.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(z.value);for(let C=0;C<z.buffers.length;++C)O+=this.sizeVSBuffer(z.buffers[C]);break;case 4:break}}return O}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let O=0,G=T.length;O<G;O++){const q=T[O];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let z=0;z<q.buffers.length;++z)this.writeBuffer(q.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const O=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),C=this.readLongString(),N=[];for(let W=0;W<z;++W)N.push(this.readVSBuffer());O[G]=new R.$Tv(s(C,N,null));break}case 4:O[G]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class L{static a(T){for(let O=0,G=T.length;O<G;O++)if(T[O]instanceof M.$je||T[O]instanceof R.$Tv||typeof T[O]>"u")return!0;return!1}static serializeRequestArguments(T,O){if(this.a(T)){const G=[];for(let q=0,z=T.length;q<z;q++){const C=T[q];if(C instanceof M.$je)G[q]={type:2,value:C};else if(typeof C>"u")G[q]={type:4};else if(C instanceof R.$Tv){const{jsonString:N,referencedBuffers:W}=a(C.value,O);G[q]={type:3,value:M.$je.fromString(N),buffers:W}}else G[q]={type:1,value:M.$je.fromString(n(C,O))}}return{type:1,args:G}}return{type:0,args:n(T,O)}}static serializeRequest(T,O,G,q,z){switch(q.type){case 0:return this.b(T,O,G,q.args,z);case 1:return this.c(T,O,G,q.args,z)}}static b(T,O,G,q,z){const C=M.$je.fromString(G),N=M.$je.fromString(q);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(C),W+=d.sizeLongString(N);const ae=d.alloc(z?2:1,T,W);return ae.writeUInt8(O),ae.writeShortString(C),ae.writeLongString(N),ae.buffer}static deserializeRequestJSONArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readLongString();return{rpcId:O,method:G,args:JSON.parse(q)}}static c(T,O,G,q,z){const C=M.$je.fromString(G);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(C),N+=d.sizeMixedArray(q);const W=d.alloc(z?4:3,T,N);return W.writeUInt8(O),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readMixedArray(),z=new Array(q.length);for(let C=0,N=q.length;C<N;C++){const W=q[C];typeof W=="string"?z[C]=JSON.parse(W):z[C]=W}return{rpcId:O,method:G,args:z}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,O,G){if(typeof O>"u")return this.d(T);if(O instanceof M.$je)return this.e(T,O);if(O instanceof R.$Tv){const{jsonString:q,referencedBuffers:z}=a(O.value,G,!0);return this.g(T,q,z)}else return this.f(T,l(O,G))}static d(T){return d.alloc(7,T,0).buffer}static e(T,O){let G=0;G+=d.sizeVSBuffer(O);const q=d.alloc(8,T,G);return q.writeVSBuffer(O),q.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,O){const G=M.$je.fromString(O);let q=0;q+=d.sizeLongString(G);const z=d.alloc(9,T,q);return z.writeLongString(G),z.buffer}static g(T,O,G){const q=M.$je.fromString(O);let z=0;z+=d.sizeUInt32,z+=d.sizeLongString(q);for(const N of G)z+=d.sizeVSBuffer(N);const C=d.alloc(10,T,z);C.writeUInt32(G.length),C.writeLongString(q);for(const N of G)C.writeBuffer(N);return C.buffer}static deserializeReplyOKJSON(T){const O=T.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(T,O){const G=T.readUInt32(),q=T.readLongString(),z=[];for(let C=0;C<G;++C)z.push(T.readVSBuffer());return new R.$Tv(s(q,z,O))}static serializeReplyErr(T,O){const G=O?l(A.$3(O),null):void 0;if(typeof G!="string")return this.h(T);const q=M.$je.fromString(G);let z=0;z+=d.sizeLongString(q);const C=d.alloc(11,T,z);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(T){const O=T.readLongString();return JSON.parse(O)}static h(T){return d.alloc(12,T,0).buffer}}var v;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Pe[234],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;const y=function(A){const P=m=>{globalThis.removeEventListener("message",P);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,R){f.postMessage(w,R)}},onmessage:{get(){return f.onmessage},set(w){f.onmessage=w}}}),f.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};globalThis.addEventListener("message",P)}.toString();class M extends EventTarget{constructor(A,P,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${y})('${P}'))`,w=new Blob([f],{type:"application/javascript"}),R=URL.createObjectURL(w),k=new MessageChannel,l=R,p={type:"_newWorker",id:l,port:k.port2,url:R,options:m};A(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{A({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(b){k.port1.onmessage=b}},onmessageerror:{get(){return k.port1.onmessageerror},set(b){k.port1.onmessageerror=b}}}),k.port1.addEventListener("messageerror",b=>{const r=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",b=>{const r=new MessageEvent("message",{data:b.data});this.dispatchEvent(r)}),k.port1.start()}}e.$ukc=M}),define(Pe[235],Re([1,0,22,28,11,53,4]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=void 0,e.$UI=(0,P.$6h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),w=7;function R(p){if(p.scheme!==I.Schemas.vscodeNotebookCell)return;const b=p.fragment.indexOf("s");if(b<0)return;const r=parseInt(p.fragment.substring(0,b).replace(f,""),w),a=(0,y.$Ce)(p.fragment.substring(b+1)).toString();if(!isNaN(r))return{handle:r,notebook:p.with({scheme:a,fragment:null})}}e.$VI=R;function k(p,b){const r=b.toString(w),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,y.$De)(y.$je.fromString(p.scheme),!0,!0)}`;return p.with({scheme:I.Schemas.vscodeNotebookCell,fragment:s})}e.$WI=k;class l{constructor(){this.a=new M.$Ac}getNotebook(b){if(b.scheme===I.Schemas.vscodeNotebookCell){const r=R(b);if(r){const a=this.a.get(r.notebook);if(a)return a}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$XI=l,(0,A.$Yr)(e.$UI,l,1)}),define(Pe[84],Re([1,0,22,34,68,69,11,19,21,35,235]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellStatusbarAlignment=e.$_I=e.$$I=e.$0I=e.NotebookEditorPriority=e.$9I=e.$8I=e.$7I=e.$6I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$5I=e.$4I=e.$3I=e.$2I=e.CellKind=e.$1I=e.$ZI=e.$YI=void 0,e.$YI="workbench.editor.notebook",e.$ZI="workbench.editor.notebookTextDiffEditor",e.$1I="workbench.editor.interactive";var k;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(k||(e.CellKind=k={})),e.$2I=["application/json","application/javascript","text/html","image/svg+xml",A.$fs.latex,A.$fs.markdown,"image/png","image/jpeg",A.$fs.text],e.$3I=[A.$fs.latex,A.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$fs.text],e.$4I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$5I="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var b;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var r;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var o;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var c;(function(W){W.scheme=P.Schemas.vscodeNotebookCell;function ae(ie,be){return(0,R.$WI)(ie,be)}W.generate=ae;function de(ie){return(0,R.$VI)(ie)}W.parse=de;function we(ie,be){return ie.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${be??""},${ie.scheme!==P.Schemas.file?ie.scheme:""}`})}W.generateCellOutputUri=we;function ye(ie){if(ie.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const be=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!be)return;const se=be[1]&&be[1]!==""?be[1]:void 0,Z=be[2];return{outputId:se,notebook:ie.with({scheme:Z||P.Schemas.file,fragment:null})}}W.parseCellOutputUri=ye;function le(ie,be,se){return W.generate(ie,be).with({scheme:se})}W.generateCellPropertyUri=le;function $e(ie,be){if(ie.scheme===be)return W.parse(ie.with({scheme:W.scheme}))}W.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const h=W=>f.$i?W.replace(/\//g,"\\"):W;class t{constructor(ae=[],de=e.$2I){this.e=de,this.d=[...new Set(ae)].map(we=>({pattern:we,matches:M.$Mj(h(we))}))}sort(ae){const de=new Map(I.Iterable.map(ae,ye=>[ye,h(ye)]));let we=[];for(const{matches:ye}of this.d)for(const[le,$e]of de)if(ye($e)){we.push(le),de.delete(le);break}return de.size&&(we=we.concat([...de.keys()].sort((ye,le)=>this.e.indexOf(ye)-this.e.indexOf(le)))),we}prioritize(ae,de){const we=this.f(ae);if(we===-1){this.d.unshift({pattern:ae,matches:M.$Mj(h(ae))});return}const ye=new Set(de.map($e=>this.f($e,we)));ye.delete(-1);const le=Array.from(ye).sort();this.d.splice(we+1,0,...le.map($e=>this.d[$e]));for(let $e=le.length-1;$e>=0;$e--)this.d.splice(le[$e],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,de=this.d.length){const we=h(ae);for(let ye=0;ye<de;ye++)if(this.d[ye].matches(we))return ye;return-1}}e.$6I=t;function u(W,ae,de,we=(ye,le)=>ye===le){const ye=[];function le(be,se,Z){if(se===0&&Z.length===0)return;const V=ye[ye.length-1];V&&V.start+V.deleteCount===be?(V.deleteCount+=se,V.toInsert.push(...Z)):ye.push({start:be,deleteCount:se,toInsert:Z})}let $e=0,ie=0;for(;;){if($e===W.length){le($e,0,ae.slice(ie));break}if(ie===ae.length){le($e,W.length-$e,[]);break}const be=W[$e],se=ae[ie];if(we(be,se)){$e+=1,ie+=1;continue}de(se)?(le($e,1,[]),$e+=1):(le($e,0,[se]),ie+=1)}return ye}e.$7I=u,e.$8I=new w.$kj("notebookEditorCursorAtBoundary","none"),e.$9I=new w.$kj("notebookEditorCursorAtLineBoundary","none");var i;(function(W){W.default="default",W.option="option"})(i||(e.NotebookEditorPriority=i={}));function g(W){const ae=W;return!!((typeof ae.include=="string"||M.$Nj(ae.include))&&(typeof ae.exclude=="string"||M.$Nj(ae.exclude)))}e.$0I=g;function $(W,ae,de){if(Array.isArray(W.viewType)&&W.viewType.indexOf(ae)>=0||W.viewType===ae)return!0;if(W.filenamePattern){const we=g(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,ye=g(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Lj(we,(0,m.$nc)(de.fsPath).toLowerCase()))return!(ye&&M.$Lj(ye,(0,m.$nc)(de.fsPath).toLowerCase()))}return!1}e.$$I=$,e.$_I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var d;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class S{static{this.d="notebook/"}static create(ae){return`${S.d}${ae}`}static parse(ae){if(ae.startsWith(S.d))return ae.substring(S.d.length)}}e.$aJ=S;function L(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$bJ=L;const v=new TextDecoder;function E(W){const ae=[];let de=!1;for(const $e of W)(ae.length===0||de)&&(ae.push($e),de=!0);let we=O(ae);const ye=y.$je.concat(ae.map($e=>y.$je.wrap($e))),le=N(ye);return we=we||le.byteLength!==ye.byteLength,{data:le,didCompression:we}}e.$cJ=E,e.$dJ=`${String.fromCharCode(27)}[A`;const D=e.$dJ.split("").map(W=>W.charCodeAt(0)),T=10;function O(W){let ae=!1;return W.forEach((de,we)=>{if(we===0||de.length<e.$dJ.length)return;const ye=W[we-1],le=de.subarray(0,e.$dJ.length);if(le[0]===D[0]&&le[1]===D[1]&&le[2]===D[2]){const $e=ye.lastIndexOf(T);if($e===-1)return;ae=!0,W[we-1]=ye.subarray(0,$e),W[we]=de.subarray(e.$dJ.length)}}),ae}function G(W){let ae=W;do W=ae,ae=W.replace(/[^\n]\x08/gm,"");while(ae.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const ae=W.match(/^(.*)\r+/m)[1];let de=W.match(/\r+(.*)$/m)[1];de=de+ae.slice(de.length,ae.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return W}const z="\b".charCodeAt(0),C="\r".charCodeAt(0);function N(W){return!W.buffer.includes(z)&&!W.buffer.includes(C)?W:y.$je.fromString(q(G(v.decode(W.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,69,12,16,2,33,23,41,100,84]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b){"use strict";var r,a,s,n,o,c,h,t,u,i,g,$,d,S,L,v,E;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$3M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$2M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestRunProfileKind=e.TestResultState=e.$HM=e.$GM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$FM=e.NotebookVariablesRequestKind=e.$EM=e.$DM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$CM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.ColorThemeKind=e.$wM=e.$vM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$uM=e.DebugConsoleMode=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$oM=e.$nM=e.FileChangeType=e.$mM=e.$lM=e.$kM=e.$jM=e.InlineCompletionTriggerKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.ConfigurationTarget=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YL=e.ViewBadge=e.ProgressLocation=e.$XL=e.$WL=e.TaskScope=e.ShellQuoting=e.$VL=e.$UL=e.$TL=e.TaskPanelKind=e.TaskRevealKind=e.$SL=e.TerminalLocation=e.$RL=e.$QL=e.$PL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OL=e.$NL=e.$ML=e.$LL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KL=e.StatusBarAlignment=e.ViewColumn=e.$JL=e.$IL=e.$HL=e.$GL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FL=e.$EL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.LanguageStatusSeverity=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CodeActionTriggerKind=e.$sL=e.$rL=e.SymbolTag=e.SymbolKind=e.$qL=e.$pL=e.DocumentHighlightKind=e.$oL=e.$nL=e.$mL=e.$lL=e.DiagnosticSeverity=e.DiagnosticTag=e.$kL=e.$jL=e.FileEditType=e.$iL=e.$hL=e.$gL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const De=oe.length===1?[]:oe[1];return Reflect.construct(B,De,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=oe;return Reflect.construct(B,Ge,De.constructor)}}})}var T;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=r=class{static from(...U){let oe=U;return new r(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_K=G,e.$_K=G=r=Je([D],G);let q=a=class{static Min(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let De=1;De<U.length;De++){const Ge=U[De];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let De=1;De<U.length;De++){const Ge=U[De];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(U){if(!U)return!1;if(U instanceof a)return!0;const{line:oe,character:De}=U;return typeof oe=="number"&&typeof De=="number"}static of(U){if(U instanceof a)return U;if(this.isPosition(U))return new a(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,oe){if(U<0)throw(0,M.$7)("line must be non-negative");if(oe<0)throw(0,M.$7)("character must be non-negative");this.c=U,this.e=oe}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,oe=0){if(U===null||oe===null)throw(0,M.$7)();let De;return typeof U>"u"?De=0:typeof U=="number"?De=U:(De=typeof U.lineDelta=="number"?U.lineDelta:0,oe=typeof U.characterDelta=="number"?U.characterDelta:0),De===0&&oe===0?this:new a(this.line+De,this.character+oe)}with(U,oe=this.character){if(U===null||oe===null)throw(0,M.$7)();let De;return typeof U>"u"?De=this.line:typeof U=="number"?De=U:(De=typeof U.line=="number"?U.line:this.line,oe=typeof U.character=="number"?U.character:this.character),De===this.line&&oe===this.character?this:new a(De,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$aL=q,e.$aL=q=a=Je([D],q);let z=s=class{static isRange(U){return U instanceof s?!0:U?q.isPosition(U.start)&&q.isPosition(U.end):!1}static of(U){if(U instanceof s)return U;if(this.isRange(U))return new s(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,oe,De,Ge){let xe,ut;if(typeof U=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new q(U,oe),ut=new q(De,Ge)):q.isPosition(U)&&q.isPosition(oe)&&(xe=q.of(U),ut=q.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(U){return s.isRange(U)?this.contains(U.start)&&this.contains(U.end):q.isPosition(U)?!(q.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const oe=q.Max(U.start,this.c),De=q.Min(U.end,this.e);if(!oe.isAfter(De))return new s(oe,De)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const oe=q.Min(U.start,this.c),De=q.Max(U.end,this.end);return new s(oe,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,oe=this.end){if(U===null||oe===null)throw(0,M.$7)();let De;return U?q.isPosition(U)?De=U:(De=U.start||this.start,oe=U.end||this.end):De=this.start,De.isEqual(this.c)&&oe.isEqual(this.end)?this:new s(De,oe)}toJSON(){return[this.start,this.end]}};e.$bL=z,e.$bL=z=s=Je([D],z);let C=n=class extends z{static isSelection(U){return U instanceof n?!0:U?z.isRange(U)&&q.isPosition(U.anchor)&&q.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,oe,De,Ge){let xe,ut;if(typeof U=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new q(U,oe),ut=new q(De,Ge)):q.isPosition(U)&&q.isPosition(oe)&&(xe=q.of(U),ut=q.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cL=C,e.$cL=C=n=Je([D],C);const N=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe,De){if(typeof U!="string"||U.length===0)throw(0,M.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,M.$7)("port");typeof De<"u"&&N(De),this.host=U,this.port=Math.round(oe),this.connectionToken=De}}e.$dL=W;class ae{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe){this.makeConnection=U,this.connectionToken=oe,typeof oe<"u"&&N(oe)}}e.$eL=ae;class de extends Error{static NotAvailable(U,oe){return new de(U,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(U){return new de(U,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,oe=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(U),this._message=U,this._code=oe,this._detail=De,Object.setPrototypeOf(this,de.prototype)}}e.$fL=de;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ye;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let le=o=class{static isTextEdit(U){return U instanceof o?!0:U?z.isRange(U)&&typeof U.newText=="string":!1}static replace(U,oe){return new o(U,oe)}static insert(U,oe){return o.replace(new z(U,U),oe)}static delete(U){return o.replace(U,"")}static setEndOfLine(U){const oe=new o(new z(new q(0,0),new q(0,0)),"");return oe.newEol=U,oe}get range(){return this.c}set range(U){if(U&&!z.isRange(U))throw(0,M.$7)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,M.$7)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,M.$7)("newEol");this.f=U}constructor(U,oe){this.c=U,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gL=le,e.$gL=le=o=Je([D],le);let $e=c=class{static isNotebookCellEdit(U){return U instanceof c?!0:U?ei.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,oe){return new c(U,oe)}static insertCells(U,oe){return new c(new ei(U,U),oe)}static deleteCells(U){return new c(U,[])}static updateCellMetadata(U,oe){const De=new c(new ei(U,U),[]);return De.newCellMetadata=oe,De}static updateNotebookMetadata(U){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=U,oe}constructor(U,oe){this.range=U,this.newCells=oe}};e.$hL=$e,e.$hL=$e=c=Je([D],$e);class ie{static isSnippetTextEdit(U){return U instanceof ie?!0:U?z.isRange(U.range)&&Z.isSnippetString(U.snippet):!1}static replace(U,oe){return new ie(U,oe)}static insert(U,oe){return ie.replace(new z(U,U),oe)}constructor(U,oe){this.range=U,this.snippet=oe}}e.$iL=ie;var be;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,oe,De,Ge){this.c.push({_type:1,from:U,to:oe,options:De,metadata:Ge})}createFile(U,oe,De){this.c.push({_type:1,from:void 0,to:U,options:oe,metadata:De})}deleteFile(U,oe,De){this.c.push({_type:1,from:U,to:void 0,options:oe,metadata:De})}e(U,oe,De){this.c.push({_type:3,metadata:De,uri:U,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(U,oe,De,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||De.length>0)&&this.c.push({_type:5,uri:U,index:xe,count:ut-xe,cells:De,metadata:Ge})}g(U,oe,De,Ge){this.c.push({_type:3,metadata:Ge,uri:U,edit:{editType:3,index:oe,metadata:De}})}replace(U,oe,De,Ge){this.c.push({_type:2,uri:U,edit:new le(oe,De),metadata:Ge})}insert(U,oe,De,Ge){this.replace(U,new z(oe,oe),De,Ge)}delete(U,oe,De){this.replace(U,oe,"",De)}has(U){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===U.toString())}set(U,oe){if(oe)for(const De of oe){if(!De)continue;let Ge,xe;Array.isArray(De)?(Ge=De[0],xe=De[1]):Ge=De,$e.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(U,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(U,Ge.newNotebookMetadata,xe):this.f(U,Ge.range,Ge.newCells,xe):ie.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:U,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:U,edit:Ge,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===U.toString()&&(this.c[De]=void 0);break}}(0,y.$Ib)(this.c)}}get(U){const oe=[];for(const De of this.c)De._type===2&&De.uri.toString()===U.toString()&&oe.push(De.edit);return oe}entries(){const U=new A.$Ac;for(const oe of this.c)if(oe._type===2){let De=U.get(oe.uri);De||(De=[oe.uri,[]],U.set(oe.uri,De)),De[1].push(oe.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jL=se,e.$jL=se=Je([D],se);let Z=h=class{static isSnippetString(U){return U instanceof h?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=h.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,oe=this.e++){if(typeof U=="function"){const De=new h;De.e=this.e,U(De),this.e=De.e,U=De.value}else U=h.c(U);return this.value+="${",this.value+=oe,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,oe=this.e++){const De=U.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(U,oe){if(typeof oe=="function"){const De=new h;De.e=this.e,oe(De),this.e=De.e,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$kL=Z,e.$kL=Z=h=Je([D],Z);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=t=class{static isLocation(U){return U instanceof t?!0:U?z.isRange(U.range)&&w.URI.isUri(U.uri):!1}constructor(U,oe){if(this.uri=U,oe)if(z.isRange(oe))this.range=z.of(oe);else if(q.isPosition(oe))this.range=new z(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lL=Ie,e.$lL=Ie=t=Je([D],Ie);let Le=class{static is(U){return U?typeof U.message=="string"&&U.location&&z.isRange(U.location.range)&&w.URI.isUri(U.location.uri):!1}constructor(U,oe){this.location=U,this.message=oe}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.location.range.isEqual(oe.location.range)&&U.location.uri.toString()===oe.location.uri.toString()}};e.$mL=Le,e.$mL=Le=Je([D],Le);let Ce=class{constructor(U,oe,De=ne.Error){if(!z.isRange(U))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=U,this.message=oe,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.severity===oe.severity&&U.code===oe.code&&U.severity===oe.severity&&U.source===oe.source&&U.range.isEqual(oe.range)&&(0,y.$ub)(U.tags,oe.tags)&&(0,y.$ub)(U.relatedInformation,oe.relatedInformation,Le.isEqual)}};e.$nL=Ce,e.$nL=Ce=Je([D],Ce);let ce=class{constructor(U,oe){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=oe}};e.$oL=ce,e.$oL=ce=Je([D],ce);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let Q=class{constructor(U,oe=te.Text){this.range=U,this.kind=oe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$pL=Q,e.$pL=Q=Je([D],Q);let ee=class{constructor(U,oe){this.uri=U,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.$qL=ee,e.$qL=ee=Je([D],ee);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var ve;(function(B){B[B.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Ae=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,oe,De,Ge,xe){this.name=U,this.kind=oe,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Ge instanceof Ie?this.location=Ge:De instanceof z&&(this.location=new Ie(Ge,De)),u.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$rL=Ae,e.$rL=Ae=u=Je([D],Ae);let he=i=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(i.validate)}constructor(U,oe,De,Ge,xe){this.name=U,this.detail=oe,this.kind=De,this.range=Ge,this.selectionRange=xe,this.children=[],i.validate(this)}};e.$sL=he,e.$sL=he=i=Je([D],he);var Ee;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ee||(e.CodeActionTriggerKind=Ee={}));let F=class{constructor(U,oe){this.title=U,this.kind=oe}};e.$tL=F,e.$tL=F=Je([D],F);let H=class{static{g=this}static{this.c="."}constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};e.$uL=H,e.$uL=H=g=Je([D],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let K=class{constructor(U,oe){if(this.range=U,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vL=K,e.$vL=K=Je([D],K);class j{constructor(U,oe,De,Ge,xe,ut){this.kind=U,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$wL=j;class Y{constructor(U,oe){this.fromRanges=oe,this.from=U}}e.$xL=Y;class x{constructor(U,oe){this.fromRanges=oe,this.to=U}}e.$yL=x;var ke;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ke||(e.LanguageStatusSeverity=ke={}));let Te=class{constructor(U,oe){this.range=U,this.command=oe}get isResolved(){return!!this.command}};e.$zL=Te,e.$zL=Te=Je([D],Te);let Ve=$=class{#e;static isMarkdownString(U){return U instanceof $?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,oe=!1){this.#e=new I.$hk(U,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,oe){return this.#e.appendCodeblock(oe??"",U),this}};e.$AL=Ve,e.$AL=Ve=$=Je([D],Ve);let Ke=class{constructor(U,oe){this.label=U,this.documentation=oe}};e.$BL=Ke,e.$BL=Ke=Je([D],Ke);let Xe=class{constructor(U,oe){this.label=U,this.documentation=oe,this.parameters=[]}};e.$CL=Xe,e.$CL=Xe=Je([D],Xe);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DL=st,e.$DL=st=Je([D],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(U){this.value=U}};e.$EL=at,e.$EL=at=Je([D],at);let ct=class{constructor(U,oe,De){this.position=U,this.label=oe,this.kind=De}};e.$FL=ct,e.$FL=ct=Je([D],ct);var Ue;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let _=class{constructor(U,oe){this.label=U,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GL=_,e.$GL=_=Je([D],_);let pe=class{constructor(U=[],oe=!1){this.items=U,this.isIncomplete=oe}};e.$HL=pe,e.$HL=pe=Je([D],pe);let Be=class{constructor(U,oe,De){this.insertText=U,this.range=oe,this.command=De}};e.$IL=Be,e.$IL=Be=Je([D],Be);let Qe=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$JL=Qe,e.$JL=Qe=Je([D],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,U){return`${k.$lm.toKey(B)}.${U}`}e.$KL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Kt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Ht;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(B){function U(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=U}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function U(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=U}(Nt||(e.SyntaxTokenType=Nt={}));let Yt=class{constructor(U,oe){if(oe&&!w.URI.isUri(oe))throw(0,M.$7)("target");if(!z.isRange(U)||U.isEmpty)throw(0,M.$7)("range");this.range=U,this.target=oe}};e.$LL=Yt,e.$LL=Yt=Je([D],Yt);let zt=class{constructor(U,oe,De,Ge){this.red=U,this.green=oe,this.blue=De,this.alpha=Ge}};e.$ML=zt,e.$ML=zt=Je([D],zt);let Rt=class{constructor(U,oe){if(oe&&!(oe instanceof zt))throw(0,M.$7)("color");if(!z.isRange(U)||U.isEmpty)throw(0,M.$7)("range");this.range=U,this.color=oe}};e.$NL=Rt,e.$NL=Rt=Je([D],Rt);let Ze=class{constructor(U){if(!U||typeof U!="string")throw(0,M.$7)("label");this.label=U}};e.$OL=Ze,e.$OL=Ze=Je([D],Ze);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(U,oe,De){if(this.startIndex=U,this.length=oe,this.tooltip=De,typeof U!="number"||U<0)throw(0,M.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,M.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,M.$7)("tooltip")}}e.$PL=$t;class Ut{constructor(U){this.uri=U}}e.$QL=Ut;class Vt{constructor(U){this.terminalCommand=U}}e.$RL=Vt;var kt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(U){if(this.options=U,typeof U!="object")throw(0,M.$7)("options")}}e.$SL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Dt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(U){switch(U){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(U,oe){if(this.label=oe,typeof U!="string"||typeof oe!="string")throw(0,M.$7)("name");this.c=U}get id(){return this.c}};e.$TL=Dt,e.$TL=Dt=d=Je([D],Dt);function qe(B){let U="";for(let oe=0;oe<B.length;oe++)U+=B[oe].replace(/,/g,",,")+",";return U}let Mt=class{constructor(U,oe,De){if(typeof U!="string")throw(0,M.$7)("process");this.e=[],this.c=U,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=De):this.f=oe)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,M.$7)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)U.push(oe);return qe(U)}};e.$UL=Mt,e.$UL=Mt=Je([D],Mt);let Wt=class{constructor(U,oe,De){if(this.f=[],Array.isArray(oe)){if(!U)throw(0,M.$7)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,M.$7)("command");this.e=U,this.f=oe,this.g=De}else{if(typeof U!="string")throw(0,M.$7)("commandLine");this.c=U,this.g=oe}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,M.$7)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,M.$7)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)U.push(typeof oe=="string"?oe:oe.value);return qe(U)}};e.$VL=Wt,e.$VL=Wt=Je([D],Wt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(U){this.c=U}computeId(){return"customExecution"+(0,R.$qg)()}set callback(U){this.c=U}get callback(){return this.c}}e.$WL=Ft;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,oe,De,Ge,xe,ut){this.k=!1,this.l=this.definition=U;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=De,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(U){this.j=U}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,R.$qg)()}}get definition(){return this.l}set definition(U){if(U==null)throw(0,M.$7)("Kind can't be undefined or null");this.A(),this.l=U}get scope(){return this.m}set target(U){this.A(),this.m=U}get name(){return this.n}set name(U){if(typeof U!="string")throw(0,M.$7)("name");this.A(),this.n=U}get execution(){return this.o}set execution(U){U===null&&(U=void 0),this.A(),this.o=U;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(U){if(Array.isArray(U))this.A(),this.q=U,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.A(),this.t=U}get source(){return this.u}set source(U){if(typeof U!="string"||U.length===0)throw(0,M.$7)("source must be a string of length > 0");this.A(),this.u=U}get group(){return this.w}set group(U){U===null&&(U=void 0),this.A(),this.w=U}get detail(){return this.z}set detail(U){U===null&&(U=void 0),this.z=U}get presentationOptions(){return this.x}set presentationOptions(U){U==null&&(U=Object.create(null)),this.A(),this.x=U}get runOptions(){return this.y}set runOptions(U){U==null&&(U=Object.create(null)),this.A(),this.y=U}};e.$XL=Se,e.$XL=Se=S=Je([D],Se);var Fe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(B){function U(oe){const De=oe;return(0,f.$Mf)(De.value)?De.tooltip&&!(0,f.$If)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=U})(fe||(e.ViewBadge=fe={}));let J=L=class{static isTreeItem(U,oe){const De=U;if(De.checkboxState!==void 0){const Ge=(0,f.$Mf)(De.checkboxState)?De.checkboxState:(0,f.$Kf)(De.checkboxState)&&(0,f.$Mf)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,f.$Mf)(De.checkboxState)&&(0,f.$Kf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==je.Checked&&Ge!==je.Unchecked||xe!==void 0&&!(0,f.$If)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(U instanceof L)return!0;if(De.label!==void 0&&!(0,f.$If)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,f.$If)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,f.$If)(De.iconPath)&&!w.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,f.$If)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,f.$If)(Ge.light)&&!w.URI.isUri(Ge.light)&&!(0,f.$If)(Ge.dark)&&!w.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,f.$If)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!w.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,f.$If)(De.tooltip)&&!(De.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Me.None&&De.collapsibleState>Me.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,f.$If)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(U,oe=Me.None){this.collapsibleState=oe,w.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$YL=J,e.$YL=J=L=Je([D],J);var Me;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Me||(e.TreeItemCollapsibleState=Me={}));var je;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(je||(e.TreeItemCheckboxState=je={}));let Ye=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$ZL=Ye,e.$ZL=Ye=Je([D],Ye);class We extends Ye{}e.$1L=We;class _e extends We{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$2L=_e;class mt{constructor(U,oe,De,Ge){this.name=U,this.uri=oe,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$3L=mt;let jt=class{#e=new Map;constructor(U){for(const[oe,De]of U??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(De):this.#e.set(this.#t(oe),[De])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,oe){this.#e.set(this.#t(U),[oe])}forEach(U,oe){for(const[De,Ge]of this.#e)for(const xe of Ge)U.call(oe,xe,De,this)}*[Symbol.iterator](){for(const[U,oe]of this.#e)for(const De of oe)yield[U,De]}#t(U){return U.toLowerCase()}};e.$4L=jt,e.$4L=jt=Je([D],jt);let Et=class{constructor(U){this.insertText=U}};e.$5L=Et,e.$5L=Et=Je([D],Et);let St=class{constructor(U,oe){this.label=oe,this.insertText=U}};e.$6L=St,e.$6L=St=Je([D],St);let wt=class{constructor(U,oe){this.id=U,this.color=oe}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$7L=wt,e.$7L=wt=Je([D],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let gi=class{constructor(U){this.id=U}};e.$8L=gi,e.$8L=gi=Je([D],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(U){this.c=U,this.e=w.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,oe){if(typeof U!="string"&&(!U||!w.URI.isUri(U)&&!w.URI.isUri(U.uri)))throw(0,M.$7)("base");if(typeof oe!="string")throw(0,M.$7)("pattern");typeof U=="string"?this.baseUri=w.URI.file(U):w.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9L=Si,e.$9L=Si=Je([D],Si);const Gi=new WeakMap;function It(B,U){Gi.set(B,U)}e.$0L=It;let ri=class{constructor(U,oe,De,Ge){this.enabled=typeof U=="boolean"?U:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,R.$qg)()),this.c}};e.$$L=ri,e.$$L=ri=Je([D],ri);let mi=class extends ri{constructor(U,oe,De,Ge,xe){if(super(oe,De,Ge,xe),U===null)throw(0,M.$7)("location");this.location=U}};e.$_L=mi,e.$_L=mi=Je([D],mi);let ci=class extends ri{constructor(U,oe,De,Ge,xe){super(oe,De,Ge,xe),this.functionName=U}};e.$aM=ci,e.$aM=ci=Je([D],ci);let Ii=class extends ri{constructor(U,oe,De,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,M.$7)("dataId");this.label=U,this.dataId=oe,this.canPersist=De}};e.$bM=Ii,e.$bM=Ii=Je([D],Ii);let Ci=class{constructor(U,oe,De){this.command=U,this.args=oe||[],this.options=De}};e.$cM=Ci,e.$cM=Ci=Je([D],Ci);let Ot=class{constructor(U,oe){this.port=U,this.host=oe}};e.$dM=Ot,e.$dM=Ot=Je([D],Ot);let $i=class{constructor(U){this.path=U}};e.$eM=$i,e.$eM=$i=Je([D],$i);let Pi=class{constructor(U){this.implementation=U}};e.$fM=Pi,e.$fM=Pi=Je([D],Pi);let ui=class{constructor(U,oe,De){this.session=U,this.threadId=oe,this.frameId=De}};e.$gM=ui,e.$gM=ui=Je([D],ui);let li=class{constructor(U,oe){this.session=U,this.threadId=oe}};e.$hM=li,e.$hM=li=Je([D],li);let ht=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$iM=ht,e.$iM=ht=Je([D],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(U,oe){this.range=U,this.text=oe}};e.$jM=_t,e.$jM=_t=Je([D],_t);let si=class{constructor(U,oe,De=!0){this.range=U,this.variableName=oe,this.caseSensitiveLookup=De}};e.$kM=si,e.$kM=si=Je([D],si);let pi=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$lM=pi,e.$lM=pi=Je([D],pi);let Ri=class{constructor(U,oe){this.frameId=U,this.stoppedLocation=oe}};e.$mM=Ri,e.$mM=Ri=Je([D],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(U){return new v(U,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(U){return new v(U,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(U){return new v(U,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(U){return new v(U,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(U){return new v(U,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(U){return new v(U,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(U,oe=l.FileSystemProviderErrorCode.Unknown,De){super(w.URI.isUri(U)?U.toString(!0):U),this.code=De?.name??"Unknown",(0,l.$Fk)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$nM=Ai,e.$nM=Ai=v=Je([D],Ai);let vi=class{constructor(U,oe,De){this.start=U,this.end=oe,this.kind=De}};e.$oM=vi,e.$oM=vi=Je([D],vi);var Yi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(U,oe=[]){this.tokenTypes=U,this.tokenModifiers=oe}}e.$pM=Mi;function un(B){return typeof B>"u"||(0,f.$Jf)(B)}class Fi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,U){this.m=!0;for(let oe=0,De=U.tokenTypes.length;oe<De;oe++)this.k.set(U.tokenTypes[oe],oe);for(let oe=0,De=U.tokenModifiers.length;oe<De;oe++)this.l.set(U.tokenModifiers[oe],oe)}}push(U,oe,De,Ge,xe){if(typeof U=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(U,oe,De,Ge,xe);if(z.isRange(U)&&typeof oe=="string"&&un(De))return this.n(U,oe,De);throw(0,M.$7)()}n(U,oe,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=U.start.line,xe=U.start.character,ut=U.end.character-U.start.character,gt=this.k.get(oe);let qt=0;if(De)for(const Zt of De){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);qt|=1<<ii>>>0}this.o(Ge,xe,ut,gt,qt)}o(U,oe,De,Ge,xe){if(this.f&&(U<this.c||U===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Zt,Hi+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Zt=ai,ii=Hi}}let ut=U,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=U,this.e=oe}static q(U){const oe=[],De=U.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Zt=U[5*gt],ii=U[5*qt];if(Zt===ii){const ni=U[5*gt+1],ai=U[5*qt+1];return ni-ai}return Zt-ii});const Ge=new Uint32Array(U.length);let xe=0,ut=0;for(let gt=0;gt<De;gt++){const qt=5*oe[gt],Zt=U[qt+0],ii=U[qt+1],ni=U[qt+2],ai=U[qt+3],Hi=U[qt+4],In=Zt-xe,zn=In===0?ii-ut:ii,Ki=5*gt;Ge[Ki+0]=In,Ge[Ki+1]=zn,Ge[Ki+2]=ni,Ge[Ki+3]=ai,Ge[Ki+4]=Hi,xe=Zt,ut=ii}return Ge}build(U){return this.f?new oi(new Uint32Array(this.g),U):new oi(Fi.q(this.g),U)}}e.$qM=Fi;class oi{constructor(U,oe){this.resultId=oe,this.data=U}}e.$rM=oi;class ln{constructor(U,oe,De){this.start=U,this.deleteCount=oe,this.data=De}}e.$sM=ln;class hn{constructor(U,oe){this.resultId=oe,this.edits=U}}e.$tM=hn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$uM=di,e.$uM=di=Je([D],di);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class en{static validate(U){if(typeof U.badge=="string"){let oe=(0,m.$jf)(U.badge,0);if(oe<U.badge.length&&(oe+=(0,m.$jf)(U.badge,oe)),U.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,oe,De){this.badge=U,this.tooltip=oe,this.color=De}}e.$vM=en;let Ti=class{constructor(U){this.kind=U}};e.$wM=Ti,e.$wM=Ti=Je([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(U){return U instanceof ei?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,oe){if(U<0)throw(0,M.$7)("start must be positive");if(oe<0)throw(0,M.$7)("end must be positive");U<=oe?(this.c=U,this.e=oe):(this.c=oe,this.e=U)}with(U){let oe=this.c,De=this.e;return U.start!==void 0&&(oe=U.start),U.end!==void 0&&(De=U.end),oe===this.c&&De===this.e?this:new ei(oe,De)}}e.$xM=ei;class yi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(U){return!0}constructor(U,oe,De,Ge,xe,ut,gt){this.kind=U,this.value=oe,this.languageId=De,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$yM=yi;class dn{constructor(U){this.cells=U}}e.$zM=dn;class Xt{static isNotebookCellOutputItem(U){return U instanceof Xt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const oe={name:U.name,message:U.message,stack:U.stack};return Xt.json(oe,"application/vnd.code.notebook.error")}static stdout(U){return Xt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Xt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,oe="application/octet-stream"){return new Xt(U,oe)}static#e=new TextEncoder;static text(U,oe=P.$fs.text){const De=Xt.#e.encode(String(U));return new Xt(De,oe)}static json(U,oe="text/x-json"){const De=JSON.stringify(U,void 0,"	");return Xt.text(De,oe)}constructor(U,oe){this.data=U,this.mime=oe;const De=(0,P.$js)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$AM=Xt;class Ei{static isNotebookCellOutput(U){return U instanceof Ei?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,oe=!1){const De=new Set,Ge=new Set;for(let xe=0;xe<U.length;xe++){const ut=U[xe],gt=(0,P.$js)(ut.mime);if(!De.has(gt)||(0,b.$bJ)(gt)){De.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?U:U.filter((xe,ut)=>!Ge.has(ut))}constructor(U,oe,De){this.items=Ei.ensureUniqueMimeTypes(U,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,R.$qg)(),this.metadata=oe??De)}}e.$BM=Ei;var ki;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var ze;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ze||(e.NotebookCellStatusBarAlignment=ze={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(U,oe){this.text=U,this.alignment=oe}}e.$CM=tn;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(U,oe=[]){this.uri=U,this.provides=(0,y.$3b)(oe)}}e.$DM=fn;class gn{constructor(U){this.label=U}}e.$EM=gn;var zi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(zi||(e.NotebookVariablesRequestKind=zi={}));let Ui=class{constructor(U,oe){this.label=U,this.timestamp=oe}};e.$FM=Ui,e.$FM=Ui=Je([D],Ui);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(U,oe){this.ranges=U,this.wordPattern=oe}}e.$GM=mn;class sn{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$HM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let ji=class{constructor(U=void 0,oe=void 0,De=void 0,Ge=!1){this.include=U,this.exclude=oe,this.profile=De,this.continuous=Ge}};e.$IM=ji,e.$IM=ji=Je([D],ji);let Bi=E=class{static diff(U,oe,De){const Ge=new E(U);return Ge.expectedOutput=oe,Ge.actualOutput=De,Ge}constructor(U){this.message=U}};e.$JM=Bi,e.$JM=Bi=E=Je([D],Bi);let Vi=class{constructor(U){this.id=U}};e.$KM=Vi,e.$KM=Vi=Je([D],Vi);class Di{constructor(U,oe){this.covered=U,this.total=oe}}e.$LM=Di;const Wi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(U,oe){const De=new Di(0,0),Ge=new Di(0,0),xe=new Di(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Ge.total+=1,Ge.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(U,De,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(U,oe,De,Ge){this.uri=U,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ge,Wi(oe),Wi(De),Wi(Ge)}}e.$MM=qi;class $n{constructor(U,oe,De=[]){this.executionCount=U,this.location=oe,this.branches=De}}e.$NM=$n;class pn{constructor(U,oe,De){this.executionCount=U,this.location=oe,this.label=De}}e.$OM=pn;class re{constructor(U,oe,De){this.name=U,this.executionCount=oe,this.location=De}}e.$PM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class bt{constructor(U,oe,De,Ge,xe,ut){this.kind=U,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$QM=bt;class Lt{constructor(U){this.uri=U}}e.$RM=Lt;class cn{constructor(U,oe){this.original=U,this.modified=oe}}e.$SM=cn;class Cn{constructor(U,oe,De,Ge){this.base=U,this.input1=oe,this.input2=De,this.result=Ge}}e.$TM=Cn;class Pn{constructor(U,oe){this.uri=U,this.viewType=oe}}e.$UM=Pn;class Rn{constructor(U){this.viewType=U}}e.$VM=Rn;class An{constructor(U,oe){this.uri=U,this.notebookType=oe}}e.$WM=An;class Ln{constructor(U,oe,De){this.original=U,this.modified=oe,this.notebookType=De}}e.$XM=Ln;class Mn{constructor(){}}e.$YM=Mn;class Fn{constructor(U,oe){this.uri=U,this.inputBoxUri=oe}}e.$ZM=Fn;class Tn{constructor(U){this.providerId=U}}e.$1M=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Nn{constructor(U,oe){this.label=U,this.values=oe}}e.$2M=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(U,oe){this.role=U,this.content=oe}}e.$3M=On;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Dn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[236],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class I{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(y.$0K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(P,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(P);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,f)??[]}getRelatedInformation(P,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(P,m,f){const w=this.b;return this.b++,this.a.set(w,f),this.c.$registerAiRelatedInformationProvider(w,m),new M.$_K(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$bgc=I}),define(Pe[237],Re([1,0,5,3,7,23]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class P{constructor(w){this.b=new Map,this.c=new y.$Vd,this.onDidChangeSessions=this.c.event,this.d=new m,this.f=new m,this.a=w.getProxy(M.$0K.MainThreadAuthentication)}async getSession(w,R,k,l={}){const p=A.$lm.toKey(w.identifier),b=[...k].sort().join(" ");return await this.d.getOrCreate(`${p} ${R} ${b}`,async()=>{await this.a.$ensureProvider(R);const r=w.displayName||w.name;return this.a.$getSession(R,k,p,r,l)})}async getSessions(w,R,k){const l=A.$lm.toKey(w.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(R);const b=w.displayName||w.name;return this.a.$getSessions(R,k,l,b)})}async removeSession(w,R){const k=this.b.get(w);return k?k.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,k,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:k,options:l??{supportsMultipleAccounts:!1}});const p=k.onDidChangeSessions(b=>this.a.$sendDidChangeSessions(w,b));return this.a.$registerAuthenticationProvider(w,R,l?.supportsMultipleAccounts??!1),new I.$_K(()=>{p.dispose(),this.b.delete(w),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,k){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.c.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$mgc=P;class m{constructor(){this.a=new Map}getOrCreate(w,R){const k=this.a.get(w);if(k)return k;const l=R().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[107],Re([1,0,2,3,7,4,17,14,18,12,19,24]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(M.$0K.MainThreadDecorations)}registerFileDecorationProvider(r,a){const s=l.c++;this.f.set(s,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(s,a.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const c=(0,f.$3b)(o);if(c.length<=l.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(i=>({uri:i,rank:(0,w.$Pe)(i.path,"/")})),t=(0,f.$zb)(h,(i,g)=>i.rank-g.rank||(0,w.$5e)(i.uri.path,g.uri.path)),u=[];e:for(const i of t){let g;for(const $ of i){const d=(0,R.$mc)($.uri.path);if(g!==d&&(g=d,u.push($.uri)>=l.d))break e}}this.g.$onDidChange(s,u)});return new I.$_K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,a,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(r);return await Promise.all(a.map(async h=>{try{const{uri:t,id:u}=h,i=await Promise.resolve(o.provideFileDecoration(y.URI.revive(t),s));if(!i)return;try{I.$vM.validate(i),i.badge&&typeof i.badge!="string"&&(0,k.$CF)(c,"codiconDecoration"),n[u]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),n}};e.$lhc=p,e.$lhc=p=l=Je([He(0,P.$bN),He(1,m.$nj)],p),e.$mhc=(0,A.$6h)("IExtHostDecorations")}),define(Pe[238],Re([1,0,15,2,7,3,11,20,12]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class w{static{this.a=0}constructor(k,l,p){this.d=l,this.e=p,this.b=new Map,this.c=k.getProxy(A.$0K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(P.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=w.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,k);let b;if(typeof l.onDidChange=="function"){let r;b=l.onDidChange(async a=>{if(a.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const s=this.$provideTextDocumentContent(p,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(a);if(!o)return;const c=(0,f.$Ze)(n);if(!o.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(y.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new I.$_K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(k,l){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$ohc=w}),define(Pe[108],Re([1,0,54,11,12,295,147,7,18]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;const w=new Map;function R(b,r){r?w.set(b,r):w.delete(b)}e.$dN=R;function k(b){return w.get(b)}class l extends A.$lv{constructor(r,a,s,n,o,c,h,t){super(a,s,n,o),this.c=r,this.m=c,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,f.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===M.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,s){return r.y(a,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,y.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,y.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const s=this.g,n=a.start.line,o=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,a.end.character)),c.join(s)}t(r){let a;if(r instanceof m.$aL?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new p(a,this.f[a],a===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),s=this.f[a.index].length;return new m.$aL(a.index,Math.min(a.remainder,s))}w(r){if(!(r instanceof m.$bL))throw new Error("Invalid argument");const a=this.x(r.start),s=this.x(r.end);return a===r.start&&s===r.end?r:new m.$bL(a.line,a.character,s.line,s.character)}x(r){if(!(r instanceof m.$aL))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:a,character:s}=r,n=!1;if(a<0)a=0,s=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,s=this.f[a].length,n=!0;else{const o=this.f[a].length;s<0?(s=0,n=!0):s>o&&(s=o,n=!0)}return n?new m.$aL(a,s):r}y(r,a){const s=this.x(r);if(!a)a=k(this.m);else if((0,I.$Ye)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,P.$xs)(s.character+1,(0,P.$vs)(a),this.f[s.line],0);if(n)return new m.$bL(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$eN=l;class p{constructor(r,a,s){this.a=r,this.b=a,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$bL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$bL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fN=p}),define(Pe[239],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class I{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(y.$0K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(P,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(P);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(m,f);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(P,m,f){const w=this.b;return this.b++,this.a.set(w,f),this.c.$registerAiEmbeddingVectorProvider(m,w),new M.$_K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$qhc=I}),define(Pe[62],Re([1,0,3,41,7,22,4,17,42,6,13,25,11]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0;let b=p=class{constructor(a,s){this.b=new Map,this.c=new R.$ch,this.a=a.getProxy(y.$0K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return p.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return p.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return p.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o,()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,A.$je.wrap(c))}catch(h){return p.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(t){return p.e(t)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(t){return p.e(t)}},isWritableFileSystem(o){const c=s.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(a,s,n){const o=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await a.stat(n)).type&M.FileType.Directory))throw I.$nM.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$Gk(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(s.basename(n)),n=s.dirname(n)}for(let c=o.length-1;c>=0;c--){n=s.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(h){if(M.$Gk(h)!==M.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof I.$nM)throw a;if(a instanceof M.$Ck)switch(a.code){case M.FileSystemProviderErrorCode.FileExists:throw I.$nM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$nM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$nM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$nM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$nM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$nM.Unavailable(a.message);default:throw new I.$nM(a.message,a.name)}if(!(a instanceof Error))throw new I.$nM(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw I.$nM.Unavailable(a.message);switch(a.name){case M.FileSystemProviderErrorCode.FileExists:throw I.$nM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$nM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$nM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$nM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$nM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$nM.Unavailable(a.message);default:throw new I.$nM(a.message,a.name)}}addFileSystemProvider(a,s,n){return this.b.set(a,{impl:s,extUri:n?.isCaseSensitive?k.$xg:k.$zg,isReadonly:!!n?.isReadonly}),(0,w.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??k.$xg}};e.$Dgc=b,e.$Dgc=b=p=Je([He(0,m.$bN),He(1,f.$egc)],b),e.$Egc=(0,P.$6h)("IExtHostConsumerFileSystem")}),define(Pe[240],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class I{constructor(P){this.a=new Map,this.b=new Map,this.c=P.getProxy(y.$0K.MainThreadIssueReporter)}async $getIssueReporterUri(P,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(P);if(!f)throw new Error("Issue request handler not found");const w=await f.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(P,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(P);if(!f)throw new Error("Issue data provider not found");const w=await f.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(P,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(P);if(!f)throw new Error("Issue data provider not found");const w=await f.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(P,m){const f=P.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new M.$_K(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(P,m){const f=P.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new M.$_K(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Hhc=I}),define(Pe[85],Re([1,0,4,27,14,62,2]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,y.$6h)("IExtensionStoragePaths");let m=class{constructor(w,R,k){this.d=R,this.f=k,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return P.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(w){if(this.c)return P.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return P.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ggc=m,e.$Ggc=m=Je([He(0,M.$rN),He(1,I.$nj),He(2,A.$Egc)],m)}),define(Pe[241],Re([1,0,7,17,5]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let A=class{constructor(m){this.a=new y.$wM(y.ColorThemeKind.Dark),this.b=new I.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=y.ColorThemeKind.Light;break;case"hcDark":f=y.ColorThemeKind.HighContrast;break;case"hcLight":f=y.ColorThemeKind.HighContrastLight;break;default:f=y.ColorThemeKind.Dark}this.a=new y.$wM(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$hc=A,e.$$hc=A=Je([He(0,M.$bN)],A)}),define(Pe[86],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wyb=e.$vyb=e.TunnelDtoConverter=void 0;class p extends f.$Jv{}var b;(function(a){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=s;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==f.TunnelPrivacyId.ConstantPrivate&&o.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$vyb=(0,P.$6h)("IExtHostTunnelService");let r=class extends I.$Tc{constructor(s,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(w.$0K.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,s.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){const o=this.u();return this.r.set(o,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,o),new l.$_K(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,n,o,c,h){const t=[];for(const i of s){const g=this.r.get(i);if(!g)return[];t.push(...await Promise.all(n.map(async $=>{let d;try{d=await g.provider.providePortAttributes({port:$,pid:o,commandLine:c},h)}catch{d=await g.provider.providePortAttributes($,o,c,h)}return{providedAttributes:d,port:$}})))}const u=t.filter(i=>!!i.providedAttributes);return u.length>0?u.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await s.provideTunnel(c,h,new y.$6d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(n&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),o=s.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$wyb=r,e.$wyb=r=Je([He(0,k.$bN),He(1,R.$rN),He(2,m.$nj)],r)}),define(Pe[8],Re([1,0,18,22,127,242,52,28,120,51,69,26,16,2,29,87,99,103,102,84,48,59,214,24,7]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aN=e.$_M=e.MarkdownString=e.$$M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(Se){function Fe(J){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Ye,positionColumn:We}=J,_e=new i.$aL(Me-1,je-1),mt=new i.$aL(Ye-1,We-1);return new i.$cL(_e,mt)}Se.to=Fe;function fe(J){const{anchor:Me,active:je}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Se.from=fe})(g||(e.Selection=g={}));var $;(function(Se){function Fe(J){if(!J)return;const{start:Me,end:je}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Se.from=Fe;function fe(J){if(!J)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Ye,endColumn:We}=J;return new i.$bL(Me-1,je-1,Ye-1,We-1)}Se.to=fe})($||(e.Range=$={}));var d;(function(Se){function Fe(fe){switch(fe){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Se.to=Fe})(d||(e.TokenType=d={}));var S;(function(Se){function Fe(J){return new i.$aL(J.lineNumber-1,J.column-1)}Se.to=Fe;function fe(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=fe})(S||(e.Position=S={}));var L;(function(Se){function Fe(Me,je,Ye){return(0,y.$Hb)((0,y.$3b)(Me).map(We=>fe(We,je,Ye)))}Se.from=Fe;function fe(Me,je,Ye){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ye?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,je),pattern:X.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ye?.isBuiltin}}function J(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(L||(e.DocumentSelector=L={}));var v;(function(Se){function Fe(J){switch(J){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Se.from=Fe;function fe(J){switch(J){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(v||(e.DiagnosticTag=v={}));var E;(function(Se){function Fe(J){let Me;return J.code&&((0,l.$If)(J.code)||(0,l.$Mf)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...$.from(J.range),message:J.message,source:J.source,code:Me,severity:T.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(D.from),tags:Array.isArray(J.tags)?(0,y.$Hb)(J.tags.map(v.from)):void 0}}Se.from=Fe;function fe(J){const Me=new i.$nL($.to(J),J.message,T.to(J.severity));return Me.source=J.source,Me.code=(0,l.$If)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(D.to),Me.tags=J.tags&&(0,y.$Hb)(J.tags.map(v.to)),Me}Se.to=fe})(E||(e.Diagnostic=E={}));var D;(function(Se){function Fe(J){return{...$.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Fe;function fe(J){return new i.$mL(new i.$lL(J.resource,$.to(J)),J.message)}Se.to=fe})(D||(e.DiagnosticRelatedInformation=D={}));var T;(function(Se){function Fe(J){switch(J){case i.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}Se.from=Fe;function fe(J){switch(J){case a.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Se.to=fe})(T||(e.DiagnosticSeverity=T={}));var O;(function(Se){function Fe(J){return typeof J=="number"&&J>=i.ViewColumn.One?J-1:J===i.ViewColumn.Beside?t.$cD:t.$bD}Se.from=Fe;function fe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(O||(e.ViewColumn=O={}));function G(Se){return typeof Se.range<"u"}function q(Se){return Se.length===0?!0:!!G(Se[0])}e.$$M=q;var z;(function(Se){function Fe(We){return We.map(Se.from)}Se.fromMany=Fe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function J(We){let _e;if(fe(We)){const{language:St,value:wt}=We;_e={value:"```"+St+`
`+wt+"\n```\n"}}else i.$AL.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const jt=St=>{try{let wt=p.URI.parse(St,!0);wt=wt.with({query:Me(wt.query,mt)}),mt[St]=wt}catch{}return""},Et=new f.marked.Renderer;return Et.link=jt,Et.image=St=>typeof St=="string"?jt(P.$pk(St).href):"",(0,f.marked)(_e.value,{renderer:Et}),_e}Se.from=J;function Me(We,_e){if(!We)return We;let mt;try{mt=(0,w.$Bh)(We)}catch{}if(!mt)return We;let jt=!1;return mt=(0,k.$xn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,jt=!0,St}else return}),jt?JSON.stringify(mt):We}function je(We){const _e=new i.$AL(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,_e}Se.to=je;function Ye(We){if(We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Ye})(z||(e.MarkdownString=z={}));function C(Se){return q(Se)?Se.map(Fe=>({range:$.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Se.map(Fe=>({range:$.from(Fe)}))}e.$_M=C;function N(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$aN=N;var W;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?N(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Fe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var ae;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?N(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?W.from(fe.before):void 0,after:fe.after?W.from(fe.after):void 0}}Se.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var de;(function(Se){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Fe})(de||(e.DecorationRangeBehavior=de={}));var we;(function(Se){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?de.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?N(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?W.from(fe.before):void 0,after:fe.after?W.from(fe.after):void 0}}Se.from=Fe})(we||(e.DecorationRenderOptions=we={}));var ye;(function(Se){function Fe(J){return{text:J.newText,eol:J.newEol&&tt.from(J.newEol),range:$.from(J.range)}}Se.from=Fe;function fe(J){const Me=new i.$gL($.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:tt.to(J.eol),Me}Se.to=fe})(ye||(e.TextEdit=ye={}));var le;(function(Se){function Fe(J,Me){const je={edits:[]};if(J instanceof i.$jL){const Ye=new m.$Bc;for(const We of J._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ye.add(We.to);for(const We of J._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,M.$De)(M.$je.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),je.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?je.edits.push({resource:We.uri,textEdit:ye.from(We.edit),versionId:Ye.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?je.edits.push({resource:We.uri,textEdit:{range:$.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ye.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?je.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&je.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Pt.from)}})}return je}Se.from=Fe;function fe(J){const Me=new i.$jL,je=new m.$Ac;for(const Ye of J.edits)if(Ye.textEdit){const We=Ye,_e=p.URI.revive(We.resource),mt=$.to(We.textEdit.range),jt=We.textEdit.text,Et=We.textEdit.insertAsSnippet;let St;Et?St=i.$iL.replace(mt,new i.$kL(jt)):St=i.$gL.replace(mt,jt);const wt=je.get(_e);wt?wt.push(St):je.set(_e,[St])}else Me.renameFile(p.URI.revive(Ye.oldResource),p.URI.revive(Ye.newResource),Ye.options);for(const[Ye,We]of je)Me.set(Ye,We);return Me}Se.to=fe})(le||(e.WorkspaceEdit=le={}));var $e;(function(Se){const Fe=Object.create(null);Fe[i.SymbolKind.File]=0,Fe[i.SymbolKind.Module]=1,Fe[i.SymbolKind.Namespace]=2,Fe[i.SymbolKind.Package]=3,Fe[i.SymbolKind.Class]=4,Fe[i.SymbolKind.Method]=5,Fe[i.SymbolKind.Property]=6,Fe[i.SymbolKind.Field]=7,Fe[i.SymbolKind.Constructor]=8,Fe[i.SymbolKind.Enum]=9,Fe[i.SymbolKind.Interface]=10,Fe[i.SymbolKind.Function]=11,Fe[i.SymbolKind.Variable]=12,Fe[i.SymbolKind.Constant]=13,Fe[i.SymbolKind.String]=14,Fe[i.SymbolKind.Number]=15,Fe[i.SymbolKind.Boolean]=16,Fe[i.SymbolKind.Array]=17,Fe[i.SymbolKind.Object]=18,Fe[i.SymbolKind.Key]=19,Fe[i.SymbolKind.Null]=20,Fe[i.SymbolKind.EnumMember]=21,Fe[i.SymbolKind.Struct]=22,Fe[i.SymbolKind.Event]=23,Fe[i.SymbolKind.Operator]=24,Fe[i.SymbolKind.TypeParameter]=25;function fe(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Se.from=fe;function J(Me){for(const je in Fe)if(Fe[je]===Me)return Number(je);return i.SymbolKind.Property}Se.to=J})($e||(e.SymbolKind=$e={}));var ie;(function(Se){function Fe(J){switch(J){case i.SymbolTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return i.SymbolTag.Deprecated}}Se.to=fe})(ie||(e.SymbolTag=ie={}));var be;(function(Se){function Fe(J){return{name:J.name,kind:$e.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:Ie.from(J.location)}}Se.from=Fe;function fe(J){const Me=new i.$rL(J.name,$e.to(J.kind),J.containerName,Ie.to(J.location));return Me.tags=J.tags&&J.tags.map(ie.to),Me}Se.to=fe})(be||(e.WorkspaceSymbol=be={}));var se;(function(Se){function Fe(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:$.from(J.range),selectionRange:$.from(J.selectionRange),kind:$e.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(Me.children=J.children.map(Fe)),Me}Se.from=Fe;function fe(J){const Me=new i.$sL(J.name,J.detail,$e.to(J.kind),$.to(J.range),$.to(J.selectionRange));return(0,y.$Lb)(J.tags)&&(Me.tags=J.tags.map(ie.to)),J.children&&(Me.children=J.children.map(fe)),Me}Se.to=fe})(se||(e.DocumentSymbol=se={}));var Z;(function(Se){function Fe(J){const Me=new i.$wL($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),$.to(J.range),$.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,je){if(Me=Me??J._sessionId,je=je??J._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:J.name,detail:J.detail,kind:$e.from(J.kind),uri:J.uri,range:$.from(J.range),selectionRange:$.from(J.selectionRange),tags:J.tags?.map(ie.from)}}Se.from=fe})(Z||(e.CallHierarchyItem=Z={}));var V;(function(Se){function Fe(fe){return new i.$xL(Z.to(fe.from),fe.fromRanges.map(J=>$.to(J)))}Se.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Se){function Fe(fe){return new i.$yL(Z.to(fe.to),fe.fromRanges.map(J=>$.to(J)))}Se.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Se){function Fe(J){return{range:J.range&&$.from(J.range),uri:J.uri}}Se.from=Fe;function fe(J){return new i.$lL(p.URI.revive(J.uri),$.to(J.range))}Se.to=fe})(Ie||(e.location=Ie={}));var Le;(function(Se){function Fe(J){const Me=J,je=J;return{originSelectionRange:Me.originSelectionRange?$.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:$.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?$.from(Me.targetSelectionRange):void 0}}Se.from=Fe;function fe(J){return{targetUri:p.URI.revive(J.uri),targetRange:$.to(J.range),targetSelectionRange:J.targetSelectionRange?$.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?$.to(J.originSelectionRange):void 0}}Se.to=fe})(Le||(e.DefinitionLink=Le={}));var Ce;(function(Se){function Fe(J){return{range:$.from(J.range),contents:z.fromMany(J.contents)}}Se.from=Fe;function fe(J){return new i.$oL(J.contents.map(z.to),$.to(J.range))}Se.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Se){function Fe(J){return{range:$.from(J.range),expression:J.expression}}Se.from=Fe;function fe(J){return new i.$iM($.to(J.range),J.expression)}Se.to=fe})(ce||(e.EvaluatableExpression=ce={}));var te;(function(Se){function Fe(J){if(J instanceof i.$jM)return{type:"text",range:$.from(J.range),text:J.text};if(J instanceof i.$kM)return{type:"variable",range:$.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof i.$lM)return{type:"expression",range:$.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Fe;function fe(J){switch(J.type){case"text":return{range:$.to(J.range),text:J.text};case"variable":return{range:$.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:$.to(J.range),expression:J.expression}}}Se.to=fe})(te||(e.InlineValue=te={}));var Q;(function(Se){function Fe(J){return{frameId:J.frameId,stoppedLocation:$.from(J.stoppedLocation)}}Se.from=Fe;function fe(J){return new i.$mM(J.frameId,$.to(J.stoppedLocation))}Se.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Se){function Fe(J){return{range:$.from(J.range),kind:J.kind}}Se.from=Fe;function fe(J){return new i.$pL($.to(J.range),J.kind)}Se.to=fe})(ee||(e.DocumentHighlight=ee={}));var me;(function(Se){function Fe(J){return{uri:J.uri,highlights:J.highlights.map(ee.from)}}Se.from=Fe;function fe(J){return new i.$qL(p.URI.revive(J.uri),J.highlights.map(ee.to))}Se.to=fe})(me||(e.MultiDocumentHighlight=me={}));var ve;(function(Se){function Fe(fe){switch(fe){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Se.to=Fe})(ve||(e.CompletionTriggerKind=ve={}));var Ae;(function(Se){function Fe(fe){return{triggerKind:ve.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Fe})(Ae||(e.CompletionContext=Ae={}));var he;(function(Se){function Fe(J){switch(J){case i.CompletionItemTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return i.CompletionItemTag.Deprecated}}Se.to=fe})(he||(e.CompletionItemTag=he={}));var Ee;(function(Se){const Fe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function fe(je){return Fe.get(je)??9}Se.from=fe;const J=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Me(je){return J.get(je)??i.CompletionItemKind.Property}Se.to=Me})(Ee||(e.CompletionItemKind=Ee={}));var F;(function(Se){function Fe(fe,J){const Me=new i.$GL(fe.label);return Me.insertText=fe.insertText,Me.kind=Ee.to(fe.kind),Me.tags=fe.tags?.map(he.to),Me.detail=fe.detail,Me.documentation=P.$jk(fe.documentation)?z.to(fe.documentation):fe.documentation,Me.sortText=fe.sortText,Me.filterText=fe.filterText,Me.preselect=fe.preselect,Me.commitCharacters=fe.commitCharacters,b.$Us.isIRange(fe.range)?Me.range=$.to(fe.range):typeof fe.range=="object"&&(Me.range={inserting:$.to(fe.range.insert),replacing:$.to(fe.range.replace)}),Me.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Me.insertText=new i.$kL(fe.insertText):(Me.insertText=fe.insertText,Me.textEdit=Me.range instanceof i.$bL?new i.$gL(Me.range,Me.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Me.additionalTextEdits=fe.additionalTextEdits.map(je=>ye.to(je))),Me.command=J&&fe.command?J.fromInternal(fe.command):void 0,Me}Se.to=Fe})(F||(e.CompletionItem=F={}));var H;(function(Se){function Fe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:z.fromStrict(J.documentation)}}Se.from=Fe;function fe(J){return{label:J.label,documentation:P.$jk(J.documentation)?z.to(J.documentation):J.documentation}}Se.to=fe})(H||(e.ParameterInformation=H={}));var K;(function(Se){function Fe(J){return{label:J.label,documentation:z.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}Se.from=Fe;function fe(J){return{label:J.label,documentation:P.$jk(J.documentation)?z.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}Se.to=fe})(K||(e.SignatureInformation=K={}));var j;(function(Se){function Fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}Se.from=Fe;function fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}Se.to=fe})(j||(e.SignatureHelp=j={}));var Y;(function(Se){function Fe(fe,J){const Me=new i.$FL(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(x.to.bind(void 0,fe)),J.kind&&ke.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(ye.to),Me.tooltip=P.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}Se.to=Fe})(Y||(e.InlayHint=Y={}));var x;(function(Se){function Fe(fe,J){const Me=new i.$EL(J.label);return Me.tooltip=P.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(Me.command=fe.fromInternal(J.command)),J.location&&(Me.location=Ie.to(J.location)),Me}Se.to=Fe})(x||(e.InlayHintLabelPart=x={}));var ke;(function(Se){function Fe(J){return J}Se.from=Fe;function fe(J){return J}Se.to=fe})(ke||(e.InlayHintKind=ke={}));var Te;(function(Se){function Fe(J){return{range:$.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Fe;function fe(J){let Me;if(J.url)try{Me=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new i.$LL($.to(J.range),Me)}Se.to=fe})(Te||(e.DocumentLink=Te={}));var Ve;(function(Se){function Fe(J){const Me=new i.$OL(J.label);return J.textEdit&&(Me.textEdit=ye.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(je=>ye.to(je))),Me}Se.to=Fe;function fe(J){return{label:J.label,textEdit:J.textEdit?ye.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>ye.from(Me)):void 0}}Se.from=fe})(Ve||(e.ColorPresentation=Ve={}));var Ke;(function(Se){function Fe(J){return new i.$ML(J[0],J[1],J[2],J[3])}Se.to=Fe;function fe(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=fe})(Ke||(e.Color=Ke={}));var Xe;(function(Se){function Fe(J){return{range:$.from(J.range)}}Se.from=Fe;function fe(J){return new i.$vL($.to(J.range))}Se.to=fe})(Xe||(e.SelectionRange=Xe={}));var st;(function(Se){function Fe(fe){switch(fe){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Se.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Fe(J){switch(J){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Fe;function fe(J){switch(J){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Se.to=fe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Fe(J){if(J===i.EndOfLine.CRLF)return 1;if(J===i.EndOfLine.LF)return 0}Se.from=Fe;function fe(J){if(J===1)return i.EndOfLine.CRLF;if(J===0)return i.EndOfLine.LF}Se.to=fe})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Fe})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Fe(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=Ue.from(J.kind)),Me}Se.from=Fe;function fe(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=Ue.to(J.kind)),Me}Se.to=fe})(ct||(e.FoldingRange=ct={}));var Ue;(function(Se){function Fe(J){if(J)switch(J){case i.FoldingRangeKind.Comment:return r.$Kt.Comment;case i.FoldingRangeKind.Imports:return r.$Kt.Imports;case i.FoldingRangeKind.Region:return r.$Kt.Region}}Se.from=Fe;function fe(J){if(J)switch(J.value){case r.$Kt.Comment.value:return i.FoldingRangeKind.Comment;case r.$Kt.Imports.value:return i.FoldingRangeKind.Imports;case r.$Kt.Region.value:return i.FoldingRangeKind.Region}}Se.to=fe})(Ue||(e.FoldingRangeKind=Ue={}));var vt;(function(Se){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?$.from(fe.selection):void 0,override:typeof fe.override=="boolean"?n.$EE.id:void 0}}Se.from=Fe})(vt||(e.TextEditorOpenOptions=vt={}));var X;(function(Se){function Fe(je){return je instanceof i.$9L?je.toJSON():typeof je=="string"?je:fe(je)||J(je)?new i.$9L(je.baseUri??je.base,je.pattern).toJSON():je}Se.from=Fe;function fe(je){const Ye=je;return Ye?p.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(je){const Ye=je;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new i.$9L(p.URI.revive(je.baseUri),je.pattern)}Se.to=Me})(X||(e.GlobPattern=X={}));var _;(function(Se){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const J=fe;return{language:J.language,scheme:J.scheme,pattern:X.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Fe})(_||(e.LanguageSelector=_={}));var pe;(function(Se){function Fe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ye=>Ye instanceof i.$bL)))}Se.is=Fe;function fe(J){return{documents:J.documents.map(Me=>Me.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ye=>$.from(Ye))})))}}Se.from=fe})(pe||(e.MappedEditsContext=pe={}));var Be;(function(Se){function Fe(J){return{start:J.start,end:J.end}}Se.from=Fe;function fe(J){return new i.$xM(J.start,J.end)}Se.to=fe})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Fe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Fe;function fe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Fe(fe){if(fe===o.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(fe===o.NotebookCellExecutionState.Pending)return;if(fe===o.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Fe(J){switch(J){case i.NotebookCellKind.Markup:return o.CellKind.Markup;case i.NotebookCellKind.Code:default:return o.CellKind.Code}}Se.from=Fe;function fe(J){switch(J){case o.CellKind.Markup:return i.NotebookCellKind.Markup;case o.CellKind.Code:default:return i.NotebookCellKind.Code}}Se.to=fe})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Fe(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const je of J.cells)i.$yM.validate(je),Me.cells.push(Pt.from(je));return Me}Se.from=Fe;function fe(J){const Me=new i.$zM(J.cells.map(Pt.to));return(0,l.$Vf)(J.metadata)||(Me.metadata=J.metadata),Me}Se.to=fe})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Fe(J){return{cellKind:rt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Kt.from):[]}}Se.from=Fe;function fe(J){return new i.$yM(rt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Kt.to):void 0,J.metadata,J.internalMetadata?Qe.to(J.internalMetadata):void 0)}Se.to=fe})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Fe(J){return{mime:J.mime,valueBytes:M.$je.wrap(J.data)}}Se.from=Fe;function fe(J){return new i.$AM(J.valueBytes.buffer,J.mime)}Se.to=fe})(Tt||(e.NotebookCellOutputItem=Tt={}));var Kt;(function(Se){function Fe(J){return{outputId:J.id,items:J.items.map(Tt.from),metadata:J.metadata}}Se.from=Fe;function fe(J){const Me=J.items.map(Tt.to);return new i.$BM(Me,J.outputId,J.metadata)}Se.to=fe})(Kt||(e.NotebookCellOutput=Kt={}));var Bt;(function(Se){function Fe(Me){return J(Me)?{include:X.from(Me.include)??void 0,exclude:X.from(Me.exclude)??void 0}:X.from(Me)??void 0}Se.from=Fe;function fe(Me){return J(Me)?{include:X.to(Me.include),exclude:X.to(Me.exclude)}:X.to(Me)}Se.to=fe;function J(Me){const je=Me;return je?!(0,l.$Rf)(je.include)&&!(0,l.$Rf)(je.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Fe(fe,J,Me){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(je,Me),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Fe})(yt||(e.NotebookStatusBarItem=yt={}));var Ht;(function(Se){function Fe(fe,J,Me){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:J.toInternal(je,Me),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Nt;(function(Se){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Yt;(function(Se){function Fe(J){return{uri:J.uri,provides:J.provides}}Se.from=Fe;function fe(J){return new i.$DM(p.URI.revive(J.uri),J.provides)}Se.to=fe})(Yt||(e.NotebookRendererScript=Yt={}));var zt;(function(Se){function Fe(J){return{message:z.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:$.from(J.location.range),uri:J.location.uri}}}Se.from=Fe;function fe(J){const Me=new i.$JM(typeof J.message=="string"?J.message:z.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?Ie.to(J.location):void 0,Me}Se.to=fe})(zt||(e.TestMessage=zt={}));var Rt;(function(Se){Se.namespace=h.$6J,Se.denamespace=h.$7J})(Rt||(e.TestTag=Rt={}));var Ze;(function(Se){function Fe(J){const Me=(0,s.$0M)(J).controllerId;return{extId:c.$2J.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(je=>Rt.namespace(Me,je.id)),range:b.$Us.lift($.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&z.fromStrict(J.error)||null}}Se.from=Fe;function fe(J){return{parent:void 0,error:void 0,id:c.$2J.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:je}=Rt.denamespace(Me);return new i.$KM(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:$.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=fe})(Ze||(e.TestItem=Ze={})),function(Se){function Fe(J){return{id:J.id}}Se.from=Fe;function fe(J){return new i.$KM(J.id)}Se.to=fe}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Fe=(J,Me)=>{const je=[];for(const[We,_e]of Me)c.$2J.compare(_e.item.extId,We)===2&&(Me.delete(We),je.push(_e));const Ye={...Ze.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(zt.to)})),children:je.map(We=>Fe(We,Me))};for(const We of Ye.children)We.parent=Ye;return Ye};function fe(J){const Me=[],je=new Map;for(const Ye of J.items){je.set(Ye.item.extId,Ye);const We=c.$2J.root(Ye.item.extId);J.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(Ye.item.extId))&&Me.push(Ye)}return{completedAt:J.completedAt,results:Me.map(Ye=>Fe(Ye,je))}}Se.to=fe})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Fe(je){return{covered:je.covered,total:je.total}}function fe(je){return"line"in je?S.from(je):$.from(je)}function J(je){return"branches"in je?{count:je.executionCount,location:fe(je.location),type:1,branches:je.branches.length?je.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&fe(Ye.location),label:Ye.label})):void 0}:{type:0,name:je.name,count:je.executionCount,location:fe(je.location)}}Se.fromDetailed=J;function Me(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),function:je.functionCoverage&&Fe(je.functionCoverage),details:je.detailedCoverage?.map(J)}}Se.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Fe(fe){switch(fe){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Se.to=Fe})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Fe(J){const Me=new i.$QM($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),$.to(J.range),$.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,je){if(Me=Me??J._sessionId,je=je??J._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:$e.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:$.from(J.range),selectionRange:$.from(J.selectionRange),tags:J.tags?.map(ie.from)}}Se.from=fe})($t||(e.TypeHierarchyItem=$t={}));var Ut;(function(Se){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Fe})(Ut||(e.ViewBadge=Ut={}));var Vt;(function(Se){function Fe(je,Ye,We){const _e=Ye.fileData;return _e?new i.$2L(new i.$3L(_e.name,p.URI.revive(_e.uri),_e.id,(0,A.$db)(()=>We(_e.id)))):je===R.$fs.uriList&&Ye.uriListData?new i.$1L(Me(Ye.uriListData)):new i.$1L(Ye.asString)}Se.to=Fe;async function fe(je,Ye){const We=await Ye.asString();if(je===R.$fs.uriList)return{asString:We,fileData:void 0,uriListData:J(We)};const _e=Ye.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=fe;function J(je){return I.$rt.split(je).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return p.URI.parse(Ye)}catch{}return Ye})}function Me(je){return I.$rt.create(je.map(Ye=>typeof Ye=="string"?Ye:p.URI.revive(Ye)))}})(Vt||(e.DataTransferItem=Vt={}));var kt;(function(Se){function Fe(J,Me){const je=J.items.map(([Ye,We])=>[Ye,Vt.to(Ye,We,Me)]);return new i.$4L(je)}Se.toDataTransfer=Fe;async function fe(J){const Me={items:[]},je=[];for(const[Ye,We]of J)je.push((async()=>{Me.items.push([Ye,await Vt.from(Ye,We)])})());return await Promise.all(je),Me}Se.from=fe})(kt||(e.DataTransfer=kt={}));var dt;(function(Se){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Se.from=Fe})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:dt.from(fe)}Se.from=Fe})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Fe(J){const Me=new i.$3M(Dt.to(J.role),J.content);return Me.name=J.name,Me}Se.to=Fe;function fe(J){return{role:Dt.from(J.role),content:J.content,name:J.name}}Se.from=fe})(xt||(e.ChatMessage=xt={}));var Dt;(function(Se){function Fe(J){switch(J){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Se.to=Fe;function fe(J){switch(J){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Se.from=fe})(Dt||(e.ChatMessageRole=Dt={}));var qe;(function(Se){function Fe(Me){const je={};for(const Ye of Object.keys(Me))je[Ye]=Me[Ye].map(Se.to);return je}Se.objectTo=Fe;function fe(Me){return{level:Mt.to(Me.level),kind:Me.kind,value:(0,p.$vc)(Me.value)?p.URI.revive(Me.value):Me.value,description:Me.description}}Se.to=fe;function J(Me){return{level:Mt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Se.from=J})(qe||(e.ChatVariable=qe={}));var Mt;(function(Se){function Fe(J){switch(J){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Se.to=Fe;function fe(J){switch(J){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Se.from=fe})(Mt||(e.ChatVariableLevel=Mt={}));var Wt;(function(Se){function Fe(fe){switch(fe){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return i.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Qt;(function(Se){function Fe(fe,J){return"placeholder"in J&&"resolvedContent"in J?{content:J.placeholder,kind:"asyncContent"}:"markdownContent"in J?((0,u.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.markdownContent),kind:"markdownContent"}):"content"in J?"vulnerabilities"in J&&J.vulnerabilities?((0,u.$CF)(fe,"chatAgents2Additions"),{content:J.content,vulnerabilities:J.vulnerabilities,kind:"vulnerability"}):typeof J.content=="string"?{content:J.content,kind:"content"}:((0,u.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.content),kind:"markdownContent"}):"documents"in J?{documents:J.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(je=>$.from(je))})),kind:"usedContext"}:"reference"in J?{reference:"uri"in J.reference?{uri:J.reference.uri,range:$.from(J.reference.range)}:J.reference,kind:"reference"}:"inlineReference"in J?{inlineReference:"uri"in J.inlineReference?{uri:J.inlineReference.uri,range:$.from(J.inlineReference.range)}:J.inlineReference,name:J.title,kind:"inlineReference"}:"agentName"in J?((0,u.$CF)(fe,"chatAgents2Additions"),{agentName:J.agentName,command:J.command,kind:"agentDetection"}):"treeData"in J?{treeData:J.treeData,kind:"treeData"}:"message"in J?{content:z.from(J.message),kind:"progressMessage"}:void 0}Se.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Ft;(function(Se){function Fe(fe,J,Me){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:J.toInternal(fe,Me)}Se.from=Fe})(Ft||(e.TerminalQuickFix=Ft={}))}),define(Pe[243],Re([1,0,3,17,8]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let A=class{constructor(m,f){this.a=m.getProxy(y.$0K.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>f.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,w){const R=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$ngc=A,e.$ngc=A=Je([He(0,M.$bN)],A)}),define(Pe[244],Re([1,0,68,6,3,8]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class P{static{this.a=0}constructor(w,R){this.extension=w,this.provider=R,this.handle=P.a++}}class m{static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(I.$0K.MainThreadChat)}registerChatProvider(w,R,k){const l=new P(w,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,R),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,R){const k=y.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof k=="number"&&this.d.$transferChatSession(k,R)}sendInteractiveRequestToProvider(w,R){this.d.$sendRequestToProvider(w,R)}async $prepareChat(w,R){const k=this.b.get(w);if(!k)return;const l=await k.provider.prepareSession(R);if(!l)return;const p=m.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,R){const k=this.b.get(w);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(R);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(b=>A.ChatReplyFollowup.from(b)):A.MarkdownString.from(p))}async $provideSampleQuestions(w,R){const k=this.b.get(w);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(R);if(l)return l?.map(p=>A.ChatReplyFollowup.from(p))}$releaseSession(w){this.c.delete(w)}}e.$ogc=m}),define(Pe[245],Re([1,0,13,20,40,5,63,16,2,157,72,3,8,7,205,24]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class a{static{this.a=0}constructor(o,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(k.$0K.MainThreadChatAgents2)}createChatAgent(o,c,h){const t=a.a++,u=new s(o,c,this.d,t,h);return this.b.set(t,u),this.d.$registerAgent(t,c,{}),u.apiAgent}async $invokeAgent(o,c,h,t,u,i){this.g.delete(c);const g=this.b.get(o);if(!g)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let $=!1;function d(){if($)throw new Error("Only valid while executing the command")}const S=new y.$qh;i.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(g.extension.identifier,S.p);const L=t.command?await g.validateSlashCommand(t.command):void 0,v=P.$Rd.create(!1);let E;try{const D=g.invoke({prompt:t.message,variables:l.ChatVariable.objectTo(t.variables),slashCommand:L},{history:u.history.map(l.ChatMessage.to)},new R.$vv(T=>{d(),typeof E>"u"&&"content"in T&&(E=v.elapsed());const O=l.ChatResponseProgress.from(g.extension,T);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(T));return}if("placeholder"in T&&"resolvedContent"in T){const G=Promise.all([this.d.$handleProgressChunk(h,O),T.resolvedContent]);(0,y.$Ug)(G,i).then(q=>{if(!q)return;const[z,C]=q,N=l.ChatResponseProgress.from(g.extension,C);if(!N){this.j.error("Unknown progress type: "+JSON.stringify(C));return}this.d.$handleProgressChunk(h,N,z??void 0)})}else this.d.$handleProgressChunk(h,O)}),i);return await(0,y.$Ug)(Promise.resolve(D).then(T=>{if(T){this.g.set(c,T);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,T);const G={firstProgress:E,totalElapsed:v.elapsed()};return{errorDetails:T.errorDetails,timings:G}}else this.g.delete(c)}),i)}catch(D){return this.j.error(D,g.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Qi)(D)),responseIsIncomplete:!0}}}finally{$=!0,S.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const h=this.b.get(o);return h?h.provideSlashCommand(c):[]}$provideFollowups(o,c,h){const t=this.b.get(o);if(!t)return Promise.resolve([]);const u=this.g.get(c);return u?t.provideFollowups(u,h):Promise.resolve([])}$acceptFeedback(o,c,h,t,u){const i=this.b.get(o);if(!i)return;const g=this.h.get(c)?.get(h);if(!g)return;let $;switch(t){case b.InteractiveSessionVoteDirection.Down:$=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:$=p.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze(u?{result:g,kind:$,reportIssue:u}:{result:g,kind:$}))}$acceptAction(o,c,h,t){const u=this.b.get(o);if(!u)return;const i=this.h.get(c)?.get(h);i&&t.action.kind!=="vote"&&u.acceptAction(Object.freeze({action:t.action,result:i}))}async $invokeCompletionProvider(o,c,h){const t=this.b.get(o);return t?(await t.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$qgc=a;class s{constructor(o,c,h,t,u){this.extension=o,this.t=c,this.u=h,this.w=t,this.x=u,this.o=new A.$Vd,this.q=new A.$Vd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async invokeCompletionProvider(o,c){return this.s?await this.s.provider.provideCompletionItems(o,c)??[]:[]}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,m.$Sf)(this.b));const c=this.b.find(h=>h.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const h=await this.d.provideFollowups(o,c);return h?h.map(t=>l.ChatFollowup.from(t)):[]}get apiAgent(){let o=!1,c=!1;const h=()=>{o||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof f.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$7L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(u){t.g=u,h()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(u){t.h=u,h()},get iconPath(){return t.i},set iconPath(u){t.i=u,h()},get slashCommandProvider(){return t.a},set slashCommandProvider(u){t.a=u,h()},get followupProvider(){return t.d},set followupProvider(u){t.d=u,h()},get isDefault(){return(0,r.$CF)(t.extension,"defaultChatAgent"),t.j},set isDefault(u){(0,r.$CF)(t.extension,"defaultChatAgent"),t.j=u,h()},get helpTextPrefix(){return(0,r.$CF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(u){if((0,r.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=u,h()},get helpTextPostfix(){return(0,r.$CF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(u){if((0,r.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=u,h()},get isSecondary(){return(0,r.$CF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(u){(0,r.$CF)(t.extension,"defaultChatAgent"),t.n=u,h()},get sampleRequest(){return t.m},set sampleRequest(u){t.m=u,h()},get supportIssueReporting(){return(0,r.$CF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(u){(0,r.$CF)(t.extension,"chatAgents2Additions"),t.r=u,h()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(u){if(t.s=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,u.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,r.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(o,c,h,t){return this.x(o,c,h,t)}}}),define(Pe[246],Re([1,0,20,6,3,8,72,23,13,5]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class R{constructor(b,r){this.stream=new f.$wh,this.stream=r??new f.$wh;const a=this;this.apiObj={option:b,response:a.stream.asyncIterable}}}class k{constructor(b,r){this.a=new w.$Vd,this.b=new Map,this.c=new f.$wh,this.d=!1;const a=this;this.apiObject={result:b,response:a.c.asyncIterable,onDidStartResponseStream:a.a.event,cancel(){r.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let r=this.b.get(b.index);r||(this.b.size===0?r=new R(b.index,this.c):r=new R(b.index),this.b.set(b.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new m.$nm,this.b=b.getProxy(I.$0K.MainThreadChatProvider)}registerProvider(b,r,a,s){const n=l.a++;return this.c.set(n,{extension:b,provider:a}),this.b.$registerProvider(n,r,{extension:b,model:s.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,r,a,s,n){const o=this.c.get(b);if(!o)return;const c=new P.$vv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return o.provider.provideChatResponse(a.map(A.ChatMessage.to),s,c,n)}allowListExtensionWhile(b,r){this.f.set(b,r),r.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,r){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const a=await this.b.$prepareChatAccess(r);if(!a)throw new Error(`ChatAccess '${r}' NOT found`);const s=this;return{get model(){return a.model},get isRevoked(){return!s.f.has(b)},makeRequest(n,o,c){if(!s.f.has(b))throw new Error("Access to chat has been revoked");const h=new y.$6d(c),t=Math.random()*1e6|0,u=s.b.$fetchResponse(b,r,t,n.map(A.ChatMessage.from),o??{},h.token),i=new k(u,h);return s.e.set(t,{res:i}),u.finally(()=>{s.e.delete(t)}),i.apiObject}}}async $handleResponseFragment(b,r){const a=this.e.get(b);a&&a.res.handleFragment(r)}}e.$pgc=l}),define(Pe[247],Re([1,0,6,3,15,8]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class P{static{this.a=0}constructor(f){this.b=new Map,this.c=f.getProxy(M.$0K.MainThreadChatVariables)}async $resolveVariable(f,w,R){const k=this.b.get(f);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:w},R);if(l)return l.map(A.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(f,w,R,k){const l=P.a++;return this.b.set(l,{extension:f.identifier,data:{name:w,description:R},resolver:k}),this.c.$registerVariable(l,{name:w,description:R}),(0,y.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$rgc=P}),define(Pe[248],Re([1,0,13,67,5,6,2,87,23,8,7,3,24]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;function p(b,r,a){const s=b.getProxy(k.$0K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$nm,r.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const S=this.b.get(d.handle);return S?S.value:d}else if(d&&d.$mid===7){const S=this.b.get(d.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.commentThreadHandle);return L?L.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);return L?d.$mid===8?L.value:{thread:L.value,text:d.text}:d}else if(d&&d.$mid===10){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const v=d.commentUniqueId,E=L.getCommentByUniqueId(v);return E||d}else if(d&&d.$mid===11){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const v=d.text,E=d.commentUniqueId,D=L.getCommentByUniqueId(E);return D?(typeof D.body=="string"?D.body=v:D.body=new R.$AL(v),D):d}return d}})}createCommentController(d,S,L){const v=n.a++,E=new c(d,v,S,L);this.b.set(E.handle,E);const D=this.c.get(d.identifier)||[];return D.push(E),this.c.set(d.identifier,D),E.value}async $createCommentThreadTemplate(d,S,L){const v=this.b.get(d);v&&v.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(d,S,L){const v=this.b.get(d);v&&v.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(d,S){this.b.get(d)?.$deleteCommentThread(S)}$provideCommentingRanges(d,S,L){const v=this.b.get(d);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const E=a.getDocument(P.URI.revive(S));return(0,y.$Yg)(async()=>{const D=await v.commentingRangeProvider.provideCommentingRanges(E,L);let T;return Array.isArray(D)?T={ranges:D,fileComments:!1}:D?T={ranges:D.ranges||[],fileComments:D.fileComments||!1}:T=D??void 0,T}).then(D=>{let T;return D&&(T={ranges:D.ranges.map(O=>w.Range.from(O)),fileComments:D.fileComments}),T})}$toggleReaction(d,S,L,v,E){const D=this.b.get(d);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,y.$Yg)(()=>{const T=D.getCommentThread(S);if(T){const O=T.getCommentByUniqueId(v.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,u(E))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,S,L,v,E,D,T,O){this.m=S,this.n=L,this.o=v,this.p=E,this.q=D,this.extensionDescription=T,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),s.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{s.$deleteCommentThread(S,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(q){G.range=q},get comments(){return G.comments},set comments(q){G.comments=q},get collapsibleState(){return G.collapsibleState},set collapsibleState(q){G.collapsibleState=q},get canReply(){return G.canReply},set canReply(q){G.canReply=q},get contextValue(){return G.contextValue},set contextValue(q){G.contextValue=q},get label(){return G.label},set label(q){G.label=q},get state(){return G.state},set state(q){G.state=q},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const d=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};d("range")&&(S.range=w.Range.from(this.p)),d("label")&&(S.label=this.label),d("contextValue")&&(S.contextValue=this.contextValue??null),d("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),d("collapsibleState")&&(S.collapseState=i(this.g)),d("canReply")&&(S.canReply=this.canReply),d("state")&&(S.state=g(this.h)),d("isTemplate")&&(S.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(d){for(const S of this.k){const L=S[0],v=S[1];if(d===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,M.$yh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,S,L,v){this.f=d,this.g=S,this.h=L,this.i=v,this.a=new Map,s.$registerCommentController(this.handle,L,v,this.f.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(D){E.options=D},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(D){E.commentingRangeProvider=D},get reactionHandler(){return E.reactionHandler},set reactionHandler(D){E.reactionHandler=D},createCommentThread(D,T,O){return E.createCommentThread(D,T,O).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,S,L){S===void 0&&(0,l.$CF)(this.f,"fileComments");const v=new o(this.id,this.handle,void 0,d,S,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(d,S){const L=new o(this.id,this.handle,void 0,P.URI.revive(d),w.Range.to(S),[],this.f,!0);return L.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(d,S){const L=this.a.get(d);L&&(L.range=w.Range.to(S))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function h($,d,S,L){let v=S.get(d);return v||(v=++$.commentHandle,S.set(d,v)),d.state!==void 0&&(0,l.$CF)(L,"commentsDraftState"),d.reactions?.some(E=>E.reactors!==void 0)&&(0,l.$CF)(L,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:v,body:typeof d.body=="string"?d.body:w.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(E=>t(E)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t($){return{label:$.label,iconPath:$.iconPath?w.$aN($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(d=>d.name):$.reactors}}function u($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?P.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(d=>({name:d}))}}function i($){if($!==void 0)switch($){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function g($){if($!==void 0)switch($){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$vgc=p}),define(Pe[249],Re([1,0,20,98,6,11,25,2,8,61,75,3,7]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class p{constructor(u,i){this.document=u,this.b=i,this.a=1,this.c=new R.$agc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,i){await this.f(u).undo(),i||this.disposeBackup()}async redo(u,i){await this.f(u).redo(),i||this.disposeBackup()}disposeEdits(u){for(const i of u)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=h(this.document.uri)+this.a++;return(0,P.$Hg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const i=this.c.get(u,0);if(!i)throw new Error("No edit found");return i}}class b{constructor(){this.a=new Map}get(u,i){return this.a.get(this.b(u,i))}add(u,i,g){const $=this.b(u,i.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${u} resource:${i.uri}`);const d=new p(i,g);return this.a.set($,d),d}delete(u,i){const g=this.b(u,i.uri);this.a.delete(g)}b(u,i){return`${u}@@@${i}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(u,i,g){return this.b(0,u,i,g)}addCustomProvider(u,i,g){return this.b(1,u,i,g)}get(u){return this.a.get(u)}b(u,i,g,$){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:u,extension:g,provider:$}),new l.$_K(()=>this.a.delete(i))}}class s{constructor(u,i,g,$,d){this.d=i,this.f=g,this.g=$,this.h=d,this.b=new a,this.c=new b,this.a=u.getProxy(k.$0K.MainThreadCustomEditors)}registerCustomEditorProvider(u,i,g,$){const d=new I.$Sc;return o(g)?(d.add(this.b.addTextProvider(i,u,g)),this.a.$registerTextEditorProvider((0,w.$Kgc)(u),i,$.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,w.$Igc)(u))):(d.add(this.b.addCustomProvider(i,u,g)),n(g)&&d.add(g.onDidChangeCustomDocument(S=>{const L=this.i(i,S.document.uri);if(c(S)){const v=L.addEdit(S);this.a.$onDidEdit(S.document.uri,i,v,S.label)}else this.a.$onContentChange(S.document.uri,i)})),this.a.$registerCustomEditorProvider((0,w.$Kgc)(u),i,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,w.$Igc)(u))),l.$_K.from(d,new l.$_K(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(u,i,g,$,d){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${i}'`);const L=m.URI.revive(u),v=await S.provider.openCustomDocument(L,{backupId:g,untitledDocumentData:$?.buffer},d);let E;return n(S.provider)&&this.f&&(E=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(i,v,E),{editable:n(S.provider)}}async $disposeCustomDocument(u,i){const g=this.b.get(i);if(!g)throw new Error(`No provider found for '${i}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${i}'`);const $=m.URI.revive(u),{document:d}=this.i(i,$);this.c.delete(i,d),d.dispose()}async $resolveCustomEditor(u,i,g,$,d,S){const L=this.b.get(g);if(!L)throw new Error(`No provider found for '${g}'`);const v=f.ViewColumn.to(d),E=this.g.createNewWebview(i,$.contentOptions,L.extension),D=this.h.createNewWebviewPanel(i,g,$.title,v,$.options,E,$.active),T=m.URI.revive(u);switch(L.type){case 1:{const{document:O}=this.i(g,T);return L.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(T);return L.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,i,g){this.i(i,u).disposeEdits(g)}async $onMoveCustomEditor(u,i,g){const $=this.b.get(g);if(!$)throw new Error(`No provider found for '${g}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const S=m.URI.revive(i),L=this.d.getDocument(S);await $.provider.moveCustomTextEditor(L,d,y.CancellationToken.None)}async $undo(u,i,g,$){return this.i(i,u).undo(g,$)}async $redo(u,i,g,$){return this.i(i,u).redo(g,$)}async $revert(u,i,g){const $=this.i(i,u);await this.j(i).revertCustomDocument($.document,g),$.disposeBackup()}async $onSave(u,i,g){const $=this.i(i,u);await this.j(i).saveCustomDocument($.document,g),$.disposeBackup()}async $onSaveAs(u,i,g,$){const d=this.i(i,u);return this.j(i).saveCustomDocumentAs(d.document,m.URI.revive(g),$)}async $backup(u,i,g){const $=this.i(i,u),S=await this.j(i).backupCustomDocument($.document,{destination:$.getNewBackupUri()},g);return $.updateBackup(S),S.id}i(u,i){const g=this.c.get(u,m.URI.revive(i));if(!g)throw new Error("No custom document found");return g}j(u){const g=this.b.get(u)?.provider;if(!g||!n(g))throw new Error("Custom document is not editable");return g}}e.$Ngc=s;function n(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const u=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Ti)(u)+""}}),define(Pe[250],Re([1,0,158,99,2,3,7,8,5,14,28,42]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0;class p{#e;#t;#i;constructor(a,s,n,o,c,h,t,u){this.d=a,this.e=s,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new R.$Ac(i=>h.getComparisonKey(i)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,s){if(!a){this.clear();return}this.j();let n=[];if(I.URI.isUri(a)){if(!s){this.delete(a);return}this.#i.set(a,s.slice()),n=[a]}else if(Array.isArray(a)){n=[];let h;a=[...a].sort(p.k);for(const t of a){const[u,i]=t;if((!h||u.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=u,n.push(u),this.#i.set(u,[])),i)this.#i.get(u)?.push(...i);else{const g=this.#i.get(u);g&&(g.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let t=[];const u=this.#i.get(h);if(u)if(u.length>this.g){t=[];const i=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const $ of u)if($.severity===i[g]&&t.push({...m.Diagnostic.from($),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(i=>({...m.Diagnostic.from(i),modelVersionId:this.h(h)}));if(o.push([h,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,s){this.j();for(const[n,o]of this)a.call(s,n,o,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const s=this.#i.get(a);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,s){return a[0].toString()<s[0].toString()?-1:a[0].toString()>s[0].toString()?1:0}}e.$fgc=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const s=new R.$Ac;for(const n of a)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(a,s,n,o){this.j=s,this.k=n,this.l=o,this.g=new Map,this.h=new f.$Zd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(A.$0K.MainThreadDiagnostics)}createDiagnosticCollection(a,s){const{g:n,f:o,h:c,j:h,k:t,l:u}=this,i=new class{$changeMany(d,S){o.$changeMany(d,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,d,S.length===0?"CLEARING":S)}$clear(d){o.$clear(d),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,d)}dispose(){o.dispose()}};let g;if(!s)s="_generated_diagnostic_collection_name_#"+l.c++,g=s;else if(!n.has(s))g=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do g=s+l.c++;while(n.has(g))}return new class extends p{constructor(){super(s,g,l.e,l.d,d=>u.getDocument(d)?.version,t.extUri,i,c),n.set(g,this)}dispose(){super.dispose(),n.delete(g)}}}getDiagnostics(a){if(a)return this.m(a);{const s=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let t=s.get(c.toString());typeof t>"u"&&(t=n.length,s.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(a){let s=[];for(const n of this.g.values())n.has(a)&&(s=s.concat(n.get(a)));return s}$acceptMarkersChange(a){if(!this.n){const s="_generated_mirror",n=new p(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of a)this.n.set(I.URI.revive(s),n.map(m.Diagnostic.to))}};e.$ggc=b,e.$ggc=b=l=Je([He(1,w.$nj),He(2,k.$egc)],b)}),define(Pe[251],Re([1,0,2,15,7,8,185]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class m{constructor(w,R,k,l={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=k,this.g=l,this.a=new P.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,k,l)=>{const b={dispose:this.a.push([R,k,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,R){const k=y.URI.revive(w);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const r of[...this.a]){if(l)break;const a=this.d.getDocument(k),s=await this.h(r,{document:a,reason:A.TextDocumentSaveReason.to(R)});b.push(s)}}finally{clearTimeout(p)}return b}h([w,R,k],l){const p=this.b.get(w);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,w,R,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const r=this.b.get(w);this.b.set(w,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,k,l){const p=[],b=Date.now(),{document:r,reason:a}=l,{version:s}=r,n=Object.freeze({document:r,reason:a,waitUntil(o){if(Object.isFrozen(p))throw(0,M.$8)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{R.apply(k,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),o(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(t=>t instanceof I.$gL))for(const{newText:t,newEol:u,range:i}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:i&&A.Range.from(i),text:t,eol:u&&A.EndOfLine.from(u)}});if(c.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$phc=m}),define(Pe[252],Re([1,0,5,6,2,3,108,8,16,26,7]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class k{constructor(p,b){this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=p.getProxy(A.$0K.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const b=this.g.getDocument(p);if(b)return b}getDocument(p){const b=this.getDocumentData(p);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return b.document}ensureDocumentData(p){const b=this.g.getDocument(p);if(b)return Promise.resolve(b);let r=this.h.get(p.toString());return r||(r=this.f.$tryOpenDocument(p).then(a=>{this.h.delete(p.toString());const s=I.URI.revive(a);return(0,f.$Tf)(this.g.getDocument(s))},a=>(this.h.delete(p.toString()),Promise.reject(a))),this.h.set(p.toString(),r)),r}createDocumentData(p){return this.f.$tryCreateDocument(p).then(b=>I.URI.revive(b))}$acceptModelLanguageChanged(p,b){const r=I.URI.revive(p),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(b),this.a.fire(a.document)}$acceptModelSaved(p){const b=I.URI.revive(p),r=this.g.getDocument(b);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(p,b){const r=I.URI.revive(p),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(b),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,b,r){const a=I.URI.revive(p),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(b);let n;b.isUndoing?n=R.TextDocumentChangeReason.Undo:b.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$wn)({document:s.document,contentChanges:b.changes.map(o=>({range:m.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(p,b){(0,P.$dN)(p,b)}}e.$cgc=k}),define(Pe[64],Re([1,0,253,5,16,2,4,3,17,8,7]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,P.$6h)("IExtHostEditorTabs");class k{constructor(a,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$RM(A.URI.revive(this.b.input.uri));case 2:return new R.$SM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new R.$TM(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new R.$UM(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$VM(this.b.input.viewType);case 4:return new R.$WM(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$XM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$YM;case 9:return new R.$ZM(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$1M(this.b.input.providerId);default:return}}}class l{constructor(a,s){this.c=[],this.d="",this.b=a,this.e=s;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return w.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new k(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const s=this.c.find(n=>n.tabId===a.tabDto.id);if(!s)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(a.tabDto),s}activeTabId(){return this.d}}let p=class{constructor(a){this.b=new M.$Vd,this.c=new M.$Vd,this.e=[],this.a=a.getProxy(m.$0K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,s={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,I.$Tf)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(a){const s=new Set(this.e.map(i=>i.groupId)),n=new Set(a.map(i=>i.groupId)),o=(0,y.$L)(s,n),c=this.e.filter(i=>o.removed.includes(i.groupId)).map(i=>i.apiObject),h=[],t=[];this.e=a.map(i=>{const g=new l(i,()=>this.d);return o.added.includes(g.groupId)?h.push(g.apiObject):t.push(g.apiObject),g});const u=(0,I.$Tf)(a.find(i=>i.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const s=this.e.find(n=>n.groupId===a.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const s=this.e.find(o=>o.groupId===a.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(s=>s.apiObject===a)}async i(a,s){const n=[];for(const o of a){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,s)}async j(a,s){const n=[];for(const o of a){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,s)}};e.$Pgc=p,e.$Pgc=p=Je([He(0,f.$bN)],p);function b(r){return r.tabs!==void 0}}),define(Pe[254],Re([1,0,2,3,6,7,8,296,12,22,24,52]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const a=this.a.indexOf(r);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),a=[];let s,n,o=14,c=14;for(const h of r){let t=s?(0,f.$bf)(s,h):0;for(t===0?n=1:n=c;t<h.length;t++)t+1===h.length?(o=c,c=9):c+=1,a.push([n,h.toUpperCase().charCodeAt(t),c]),a.push([n,h.toLowerCase().charCodeAt(t),c]),n=c;s=h,c=o}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$yZ(a)}}provideDocumentLinks(r){this.c();const a=[],s=m.$zZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const o=P.DocumentLink.to(n);o.target&&a.push(o)}return a}}class p{constructor(r,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(M.$0K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,a,s,n={}){if(p.j(s),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const o=this.h++;this.b.add(a),this.d.add(a),this.c.set(o,s);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$CF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$jk)(n.isReadonly)&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,a,c,h).catch(u=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${a}`),console.error(u)});const t=s.onDidChangeFile(u=>{const i=[];for(const g of u){const{uri:$,type:d}=g;if($.scheme!==a)continue;let S;switch(d){case A.FileChangeType.Changed:S=0;break;case A.FileChangeType.Created:S=1;break;case A.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:$,type:S})}this.a.$onFileSystemChange(o,i)});return(0,I.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:a,ctime:s,mtime:n,size:o,permissions:c}=r;return{type:a,ctime:s,mtime:n,size:o,permissions:c}}$stat(r,a){return Promise.resolve(this.l(r).stat(y.URI.revive(a))).then(s=>p.k(s))}$readdir(r,a){return Promise.resolve(this.l(r).readDirectory(y.URI.revive(a)))}$readFile(r,a){return Promise.resolve(this.l(r).readFile(y.URI.revive(a))).then(s=>w.$je.wrap(s))}$writeFile(r,a,s,n){return Promise.resolve(this.l(r).writeFile(y.URI.revive(a),s.buffer,n))}$delete(r,a,s){return Promise.resolve(this.l(r).delete(y.URI.revive(a),s))}$rename(r,a,s,n){return Promise.resolve(this.l(r).rename(y.URI.revive(a),y.URI.revive(s),n))}$copy(r,a,s,n){const o=this.l(r);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(y.URI.revive(a),y.URI.revive(s),n))}$mkdir(r,a){return Promise.resolve(this.l(r).createDirectory(y.URI.revive(a)))}$watch(r,a,s,n){const o=this.l(r).watch(y.URI.revive(s),n);this.f.set(a,o)}$unwatch(r,a){const s=this.f.get(a);s&&(s.dispose(),this.f.delete(a))}$open(r,a,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(a),s))}$close(r,a){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(a))}$read(r,a,s,n){const o=this.l(r);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$je.alloc(n);return Promise.resolve(o.read(a,s,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,a,s,n){const o=this.l(r);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,s,n.buffer,0,n.byteLength))}l(r){const a=this.c.get(r);if(!a){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return a}}e.$rhc=p}),define(Pe[255],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,r,a,s,n){this.a=Math.random(),this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,M.$Mj)(s),c=typeof s=="string",h=n?.correlate,t=a(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(h&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const i of u.created){const g=I.URI.revive(i);o(g.fsPath)&&(!c||b.getWorkspaceFolder(g))&&this.b.fire(g)}if(!n?.ignoreChangeEvents)for(const i of u.changed){const g=I.URI.revive(i);o(g.fsPath)&&(!c||b.getWorkspaceFolder(g))&&this.c.fire(g)}if(!n?.ignoreDeleteEvents)for(const i of u.deleted){const g=I.URI.revive(i);o(g.fsPath)&&(!c||b.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=m.$_K.from(this.i(p,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(p,b,r,a,s){const n=m.$_K.from();if(typeof r=="string")return n;const o=p.getProxy(A.$0K.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(M.$Ij)||r.pattern.includes(M.$Jj))&&(c=!0),o.$watch(b.identifier.value,this.a,r.baseUri,{recursive:c,excludes:a?.excludes??[]},!!s),m.$_K.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(p){this.a=p,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(I.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,b,r){this.j=p,this.k=b,this.l=r,this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.g=new y.$Xd,this.h=new y.$Xd,this.i=new y.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,r,a){return new w(this.j,p,b,this.a.event,P.GlobPattern.from(r),a)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(r,a,s)=>{const n=function(c){r.call(a,c)};return n.extension=p,b.event(n,void 0,s)}}async $onWillRunFileOperation(p,b,r,a){switch(p){case 2:return await this.n(this.g,{files:b.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))},r,a);case 1:return await this.n(this.i,{files:b.map(s=>I.URI.revive(s.target))},r,a);case 0:case 3:return await this.n(this.h,{files:b.map(s=>I.URI.revive(s.target))},r,a)}}async n(p,b,r,a){const s=new Set,n=[];if(await p.fireAsync(b,a,async(c,h)=>{const t=Date.now(),u=await Promise.resolve(c);u instanceof m.$jL&&(n.push([h.extension,u]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=P.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(s)}}}e.$shc=k}),define(Pe[256],Re([1,0,2,26,8,7,87,3,12,29,18,16,297,20,23,6,96,89,75,63,15,13,24,160]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class i{constructor(F,H){this.d=F,this.e=H}async provideDocumentSymbols(F,H){const K=this.d.getDocument(F),j=await this.e.provideDocumentSymbols(K,H);if(!(0,R.$Kb)(j))return j[0]instanceof A.$sL?j.map(I.DocumentSymbol.from):i.f(j)}static f(F){F=F.slice(0).sort((j,Y)=>{let x=j.location.range.start.compareTo(Y.location.range.start);return x===0&&(x=Y.location.range.end.compareTo(j.location.range.end)),x});const H=[],K=[];for(const j of F){const Y={name:j.name||"!!MISSING: name!!",kind:I.SymbolKind.from(j.kind),tags:j.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:I.Range.from(j.location.range),selectionRange:I.Range.from(j.location.range),children:[]};for(;;){if(K.length===0){K.push(Y),H.push(Y);break}const x=K[K.length-1];if(w.$Us.containsRange(x.range,Y.range)&&!w.$Us.equalsRange(x.range,Y.range)){x.children?.push(Y),K.push(Y);break}K.pop()}}return H}}class g{constructor(F,H,K,j,Y,x){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.l=x,this.d=new n.$agc("CodeLens"),this.e=new Map}async provideCodeLenses(F,H){const K=this.f.getDocument(F),j=await this.h.provideCodeLenses(K,H);if(!j||H.isCancellationRequested)return;const Y=this.d.add(j),x=new r.$Sc;this.e.set(Y,x);const ke={cacheId:Y,lenses:[]};for(let Te=0;Te<j.length;Te++)ke.lenses.push({cacheId:[Y,Te],range:I.Range.from(j[Te].range),command:this.g.toInternal(j[Te].command,x)});return ke}async resolveCodeLens(F,H){const K=F.cacheId&&this.d.get(...F.cacheId);if(!K)return;let j;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?j=K:j=await this.h.resolveCodeLens(K,H),j||(j=K),H.isCancellationRequested)return;const Y=F.cacheId&&this.e.get(F.cacheId[0]);if(Y){if(!j.command){const x=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,x),this.l.error(x);return}return F.command=this.g.toInternal(j.command,Y),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function $(Ee){return Array.isArray(Ee)?Ee.map(I.DefinitionLink.from):Ee?[I.DefinitionLink.from(Ee)]:[]}class d{constructor(F,H){this.d=F,this.e=H}async provideDefinition(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideDefinition(j,Y,K);return $(x)}}class S{constructor(F,H){this.d=F,this.e=H}async provideDeclaration(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideDeclaration(j,Y,K);return $(x)}}class L{constructor(F,H){this.d=F,this.e=H}async provideImplementation(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideImplementation(j,Y,K);return $(x)}}class v{constructor(F,H){this.d=F,this.e=H}async provideTypeDefinition(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideTypeDefinition(j,Y,K);return $(x)}}class E{constructor(F,H){this.d=F,this.e=H}async provideHover(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideHover(j,Y,K);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=j.getWordRangeAtPosition(Y)),x.range||(x.range=new A.$bL(Y,Y)),I.Hover.from(x)}}class D{constructor(F,H){this.d=F,this.e=H}async provideEvaluatableExpression(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideEvaluatableExpression(j,Y,K);if(x)return I.EvaluatableExpression.from(x)}}class T{constructor(F,H){this.d=F,this.e=H}async provideInlineValues(F,H,K,j){const Y=this.d.getDocument(F),x=await this.e.provideInlineValues(Y,I.Range.to(H),I.InlineValueContext.to(K),j);if(Array.isArray(x))return x.map(ke=>I.InlineValue.from(ke))}}class O{constructor(F,H){this.d=F,this.e=H}async provideDocumentHighlights(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideDocumentHighlights(j,Y,K);if(Array.isArray(x))return x.map(I.DocumentHighlight.from)}}class G{constructor(F,H){this.d=F,this.e=H}async provideMultiDocumentHighlights(F,H,K,j){const Y=this.d.getDocument(F),x=K.map(Ve=>this.d.getDocument(Ve)),ke=I.Position.to(H),Te=await this.e.provideMultiDocumentHighlights(Y,ke,x,j);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class q{constructor(F,H){this.d=F,this.e=H}async provideLinkedEditingRanges(F,H,K){const j=this.d.getDocument(F),Y=I.Position.to(H),x=await this.e.provideLinkedEditingRanges(j,Y,K);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(I.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(F,H){this.d=F,this.e=H}async provideReferences(F,H,K,j){const Y=this.d.getDocument(F),x=I.Position.to(H),ke=await this.e.provideReferences(Y,x,K,j);if(Array.isArray(ke))return ke.map(I.location.from)}}class C{static{this.d=1e3}constructor(F,H,K,j,Y,x,ke){this.g=F,this.h=H,this.j=K,this.k=j,this.l=Y,this.m=x,this.n=ke,this.e=new n.$agc("CodeAction"),this.f=new Map}async provideCodeActions(F,H,K,j){const Y=this.g.getDocument(F),x=l.$Ws.isISelection(H)?I.Selection.to(H):I.Range.to(H),ke=[];for(const nt of this.j.getDiagnostics(F))if(x.intersection(nt.range)&&ke.push(nt)>C.d)break;const Te={diagnostics:ke,only:K.only?new A.$uL(K.only):void 0,triggerKind:I.CodeActionTriggerKind.to(K.trigger)},Ve=await this.k.provideCodeActions(Y,x,Te,j);if(!(0,R.$Lb)(Ve)||j.isCancellationRequested)return;const Ke=this.e.add(Ve),Xe=new r.$Sc;this.f.set(Ke,Xe);const st=[];for(let nt=0;nt<Ve.length;nt++){const tt=Ve[nt];tt&&(C.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Xe)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ke,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Xe),diagnostics:tt.diagnostics&&tt.diagnostics.map(I.Diagnostic.from),edit:tt.edit&&I.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,t.$BF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:Ke,actions:st}}async resolveCodeAction(F,H){const[K,j]=F,Y=this.e.get(K,j);if(!Y||C.o(Y))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(Y,H)??Y;let ke;x.edit&&(ke=I.WorkspaceEdit.from(x.edit,void 0));let Te;if(x.command){const Ve=this.f.get(K);Ve&&(Te=this.h.toInternal(x.command,Ve))}return{edit:ke,command:Te}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,K,j,Y){this.d=F,this.e=H,this.f=K,this.g=j,this.h=Y}async prepareDocumentPaste(F,H,K,j){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(F),x=H.map(Ve=>I.Range.to(Ve)),ke=I.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Y,x,ke,j),j.isCancellationRequested)return;const Te=Array.from(ke).filter(([,Ve])=>!(Ve instanceof A.$1L));return I.DataTransfer.from(Te)}async providePasteEdits(F,H,K,j,Y){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(H),ke=K.map(Ke=>I.Range.to(Ke)),Te=I.DataTransfer.toDataTransfer(j,async Ke=>(await this.d.$resolvePasteFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentPasteEdits(x,ke,Te,Y);if(Ve)return{label:Ve.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:N.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?I.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class W{constructor(F,H){this.d=F,this.e=H}async provideDocumentFormattingEdits(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideDocumentFormattingEdits(j,H,K);if(Array.isArray(Y))return Y.map(I.TextEdit.from)}}class ae{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeFormattingEdits(F,H,K,j){const Y=this.d.getDocument(F),x=I.Range.to(H),ke=await this.e.provideDocumentRangeFormattingEdits(Y,x,K,j);if(Array.isArray(ke))return ke.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,H,K,j){(0,k.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(F),x=H.map(I.Range.to),ke=await this.e.provideDocumentRangesFormattingEdits(Y,x,K,j);if(Array.isArray(ke))return ke.map(I.TextEdit.from)}}class de{constructor(F,H){this.d=F,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,K,j,Y){const x=this.d.getDocument(F),ke=I.Position.to(H),Te=await this.e.provideOnTypeFormattingEdits(x,ke,K,j,Y);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class we{constructor(F,H){this.e=F,this.f=H,this.d=new n.$agc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const K=await this.e.provideWorkspaceSymbols(F,H);if(!(0,R.$Lb)(K))return{symbols:[]};const j=this.d.add(K),Y={cacheId:j,symbols:[]};for(let x=0;x<K.length;x++){const ke=K[x];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}Y.symbols.push({...I.WorkspaceSymbol.from(ke),cacheId:[j,x]})}return Y}async resolveWorkspaceSymbol(F,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const j=await this.e.resolveWorkspaceSymbol(K,H);return j&&(0,M.$yn)(F,I.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ye{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideRenameEdits(F,H,K,j){const Y=this.d.getDocument(F),x=I.Position.to(H);try{const ke=await this.e.provideRenameEdits(Y,x,K,j);return ke?I.WorkspaceEdit.from(ke):void 0}catch(ke){const Te=ye.g(ke);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(F,H,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(F),Y=I.Position.to(H);try{const x=await this.e.prepareRename(j,Y,K);let ke,Te;if(A.$bL.isRange(x)?(ke=x,Te=j.getText(x)):(0,k.$Kf)(x)&&(ke=x.range,Te=x.placeholder),!ke||!Te)return;if(ke.start.line>Y.line||ke.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ke),text:Te}}catch(x){const ke=ye.g(x);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class le{constructor(F,H){this.resultId=F,this.tokens=H}}class $e{constructor(F,H){this.f=F,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,H,K){const j=this.f.getDocument(F),Y=H!==0?this.d.get(H):null;let x=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,Y.resultId,K):await this.g.provideDocumentSemanticTokens(j,K);return Y&&this.d.delete(H),x?(x=$e.h(x),this.o($e.n(Y,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return $e.j(F)?$e.k(F)?F:new A.$rM(new Uint32Array(F.data),F.resultId):$e.l(F)?$e.m(F)?F:new A.$tM(F.edits.map(H=>new A.$sM(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(F,H){if(!$e.j(H)||!F||!F.tokens)return H;const K=F.tokens,j=K.length,Y=H.data,x=Y.length;let ke=0;const Te=Math.min(j,x);for(;ke<Te&&K[ke]===Y[ke];)ke++;if(ke===j&&ke===x)return new A.$tM([],H.resultId);let Ve=0;const Ke=Te-ke;for(;Ve<Ke&&K[j-Ve-1]===Y[x-Ve-1];)Ve++;return new A.$tM([{start:ke,deleteCount:j-ke-Ve,data:Y.subarray(ke,x-Ve)}],H.resultId)}o(F,H){if($e.j(F)){const K=this.e++;return this.d.set(K,new le(F.resultId,F.data)),(0,a.$w$)({id:K,type:"full",data:F.data})}if($e.l(F)){const K=this.e++;return $e.j(H)?this.d.set(K,new le(H.resultId,H.data)):this.d.set(K,new le(F.resultId)),(0,a.$w$)({id:K,type:"delta",deltas:(F.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ie{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeSemanticTokens(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideDocumentRangeSemanticTokens(j,I.Range.to(H),K);return Y?this.f(Y):null}f(F){return(0,a.$w$)({id:0,type:"full",data:F.data})}}class be{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,H,K,j,Y){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.d=new n.$agc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,H,K,j){const Y=this.f.getDocument(F),x=I.Position.to(H),ke=Y.getWordRangeAtPosition(x)||new A.$bL(x,x),Te=ke.with({end:x}),Ve=new o.$Rd,Ke=await this.h.provideCompletionItems(Y,x,j,I.CompletionContext.to(K));if(!Ke||j.isCancellationRequested)return;const Xe=Array.isArray(Ke)?new A.$HL(Ke):Ke,st=be.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),nt=new r.$Sc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:I.Range.from(ke),insert:I.Range.from(Te)},c:Xe.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Xe.items.length;ct++){const Ue=Xe.items[ct],vt=this.l(Ue,[st,ct],Te,ke);tt.push(vt)}return at}async resolveCompletionItem(F,H){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const j=this.l(K,F),Y=await this.h.resolveCompletionItem(K,H);if(!Y)return;const x=this.l(Y,F);return(j.h!==x.h||j.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==x.n||j.o!==x.o||!(0,M.$zn)(j.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H,K,j){const Y=this.e.get(H[0]);if(!Y)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,Y),ke={x:H,a:F.label,b:F.kind!==void 0?I.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(I.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:I.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(I.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke.h=F.textEdit.newText):typeof F.insertText=="string"?ke.h=F.insertText:F.insertText instanceof A.$kL&&(ke.h=F.insertText.value,ke.i|=4);let Te;return F.textEdit?Te=F.textEdit.range:F.range&&(Te=F.range),A.$bL.isRange(Te)?ke.j=I.Range.from(Te):Te&&(!K?.isEqual(Te.inserting)||!j?.isEqual(Te.replacing))&&(ke.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),ke}}class se{async provideInlineCompletions(F,H,K,j){}disposeCompletions(F){}handleDidShowCompletionItem(F,H,K){}handlePartialAccept(F,H,K){}}class Z extends se{constructor(F,H,K,j){super(),this.f=F,this.g=H,this.h=K,this.j=j,this.d=new V,this.e=(0,t.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,H,K,j){const Y=this.g.getDocument(F),x=I.Position.to(H),ke=await this.h.provideInlineCompletionItems(Y,x,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:I.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},j);if(!ke||j.isCancellationRequested)return;const Te=Array.isArray(ke)?ke:ke.items,Ve=this.e?Array.isArray(ke)?[]:ke.commands||[]:[],Ke=this.e&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Xe||(Xe=new r.$Sc),at=this.j.toInternal(nt.command,Xe));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?I.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ve.map(nt=>(Xe||(Xe=new r.$Sc),this.j.toInternal(nt,Xe))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H,K){const j=this.d.get(F)?.items[H];j&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(j,K)}handlePartialAccept(F,H,K){const j=this.d.get(F)?.items[H];j&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(j,K)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const H=this.e++;return this.d.set(H,F),H}disposeReferenceId(F){const H=this.d.get(F);return this.d.delete(F),H}get(F){return this.d.get(F)}}class ne{constructor(F,H){this.e=F,this.f=H,this.d=new n.$agc("SignatureHelp")}async provideSignatureHelp(F,H,K,j){const Y=this.e.getDocument(F),x=I.Position.to(H),ke=this.g(K),Te=await this.f.provideSignatureHelp(Y,x,j,ke);if(Te){const Ve=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:Ve}}}g(F){let H;if(F.activeSignatureHelp){const K=I.SignatureHelp.to(F.activeSignatureHelp),j=this.d.get(F.activeSignatureHelp.id,0);j?(H=j,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,H,K,j,Y){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.d=new n.$agc("InlayHints"),this.e=new Map}async provideInlayHints(F,H,K){const j=this.f.getDocument(F),Y=I.Range.to(H),x=await this.h.provideInlayHints(j,Y,K);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(K.isCancellationRequested)return;const ke=this.d.add(x);this.e.set(ke,new r.$Sc);const Te={hints:[],cacheId:ke};for(let Ve=0;Ve<x.length;Ve++)this.l(x[Ve],Y)&&Te.hints.push(this.m(x[Ve],[ke,Ve]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Te}async resolveInlayHint(F,H){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const j=await this.h.resolveInlayHint(K,H);if(j&&this.l(j))return this.m(j,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}m(F,H){const K=this.e.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const j={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(F.tooltip),position:I.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(I.TextEdit.from),kind:F.kind&&I.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")j.label=F.label;else{const Y=[];j.label=Y;for(const x of F.label){if(!x.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ke={label:x.value,tooltip:I.MarkdownString.fromStrict(x.tooltip)};A.$lL.isLocation(x.location)&&(ke.location=I.location.from(x.location)),x.command&&(ke.command=this.g.toInternal(x.command,K)),Y.push(ke)}}return j}}class Le{constructor(F,H){this.e=F,this.f=H,this.d=new n.$agc("DocumentLink")}async provideLinks(F,H){const K=this.e.getDocument(F),j=await this.f.provideDocumentLinks(K,H);if(!(!Array.isArray(j)||j.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(Le.g).map(I.DocumentLink.from)};{const Y=this.d.add(j),x={links:[],cacheId:Y};for(let ke=0;ke<j.length;ke++){if(!Le.g(j[ke]))continue;const Te=I.DocumentLink.from(j[ke]);Te.cacheId=[Y,ke],x.links.push(Te)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const j=await this.f.resolveDocumentLink(K,H);if(!(!j||!Le.g(j)))return I.DocumentLink.from(j)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,H){this.d=F,this.e=H}async provideColors(F,H){const K=this.d.getDocument(F),j=await this.e.provideDocumentColors(K,H);return Array.isArray(j)?j.map(x=>({color:I.Color.from(x.color),range:I.Range.from(x.range)})):[]}async provideColorPresentations(F,H,K){const j=this.d.getDocument(F),Y=I.Range.to(H.range),x=I.Color.to(H.color),ke=await this.e.provideColorPresentations(x,{document:j,range:Y},K);if(Array.isArray(ke))return ke.map(I.ColorPresentation.from)}}class ce{constructor(F,H){this.d=F,this.e=H}async provideFoldingRanges(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideFoldingRanges(j,H,K);if(Array.isArray(Y))return Y.map(I.FoldingRange.from)}}class te{constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideSelectionRanges(F,H,K){const j=this.d.getDocument(F),Y=H.map(I.Position.to),x=await this.e.provideSelectionRanges(j,Y,K);if(!(0,R.$Lb)(x))return[];if(x.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let Te=0;Te<Y.length;Te++){const Ve=[];ke.push(Ve);let Ke=Y[Te],Xe=x[Te];for(;;){if(!Xe.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(I.SelectionRange.from(Xe)),!Xe.parent)break;Ke=Xe.range,Xe=Xe.parent}}return ke}}class Q{constructor(F,H){this.f=F,this.g=H,this.d=new s.$gN(""),this.e=new Map}async prepareSession(F,H,K){const j=this.f.getDocument(F),Y=I.Position.to(H),x=await this.g.prepareCallHierarchy(j,Y,K);if(!x)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(x)?x.map(Te=>this.h(ke,Te)):[this.h(ke,x)]}async provideCallsTo(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(j,K);if(Y)return Y.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ke=>I.Range.from(ke))}))}async provideCallsFrom(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(j,K);if(Y)return Y.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ke=>I.Range.from(ke))}))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),j=I.CallHierarchyItem.from(H,F,K.size.toString(36));return K.set(j._itemId,H),j}j(F,H){return this.e.get(F)?.get(H)}}class ee{constructor(F,H){this.f=F,this.g=H,this.d=new s.$gN(""),this.e=new Map}async prepareSession(F,H,K){const j=this.f.getDocument(F),Y=I.Position.to(H),x=await this.g.prepareTypeHierarchy(j,Y,K);if(!x)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(x)?x.map(Te=>this.h(ke,Te)):[this.h(ke,x)]}async provideSupertypes(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(j,K);if(Y)return Y.map(x=>this.h(F,x))}async provideSubtypes(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(j,K);if(Y)return Y.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),j=I.TypeHierarchyItem.from(H,F,K.size.toString(36));return K.set(j._itemId,H),j}j(F,H){return this.e.get(F)?.get(H)}}class me{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,K,j,Y){this.d=F,this.e=H,this.f=K,this.g=j,this.h=Y}async provideDocumentOnDropEdits(F,H,K,j,Y){const x=this.e.getDocument(H),ke=I.Position.to(K),Te=I.DataTransfer.toDataTransfer(j,async Ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentDropEdits(x,ke,Te,Y);if(Ve)return{label:Ve.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:me.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?I.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class ve{constructor(F,H){this.d=F,this.e=H}async provideMappedEdits(F,H,K,j){const Y=y.URI.revive(F),x=this.d.getDocument(Y),ke=K.documents.map(Ke=>Ke.map(Xe=>({uri:y.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(st=>I.Range.to(st))}))),Te={documents:ke,selections:ke[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(x,H,Te,j);return Ve?I.WorkspaceEdit.from(Ve):null}}class Ae{constructor(F,H){this.adapter=F,this.extension=H}}class he{static{this.d=0}constructor(F,H,K,j,Y,x,ke,Te){this.g=H,this.h=K,this.j=j,this.k=Y,this.l=x,this.m=ke,this.n=Te,this.f=new Map,this.e=F.getProxy(m.$0K.MainThreadLanguageFeatures)}o(F,H){return I.DocumentSelector.from(F,this.g,H)}p(F){return new A.$_K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return he.d++}async s(F,H,K,j,Y,x=!1){const ke=this.f.get(F);if(!ke||!(ke.adapter instanceof H))return j;const Te=Date.now();x||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ve=K(ke.adapter,ke.extension);return Promise.resolve(Ve).catch(Ke=>{(0,c.$4)(Ke)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(Ke),this.n.onExtensionError(ke.extension.identifier,Ke))}).finally(()=>{x||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(Y)?(0,h.$Vg)(Ve,Y):Ve}t(F,H){const K=this.q();return this.f.set(K,new Ae(F,H)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,K,j){const Y=this.t(new i(this.h,K),F),x=j&&j.label||he.u(F);return this.e.$registerDocumentSymbolProvider(Y,this.o(H,F),x),this.p(Y)}$provideDocumentSymbols(F,H,K){return this.s(F,i,j=>j.provideDocumentSymbols(y.URI.revive(H),K),void 0,K)}registerCodeLensProvider(F,H,K){const j=this.q(),Y=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new Ae(new g(this.h,this.j.converter,K,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(j,this.o(H,F),Y);let x=this.p(j);if(Y!==void 0){const ke=K.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Y));x=A.$_K.from(x,ke)}return x}$provideCodeLenses(F,H,K){return this.s(F,g,j=>j.provideCodeLenses(y.URI.revive(H),K),void 0,K)}$resolveCodeLens(F,H,K){return this.s(F,g,j=>j.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(F,H){this.s(F,g,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,K){const j=this.t(new d(this.h,K),F);return this.e.$registerDefinitionSupport(j,this.o(H,F)),this.p(j)}$provideDefinition(F,H,K,j){return this.s(F,d,Y=>Y.provideDefinition(y.URI.revive(H),K,j),[],j)}registerDeclarationProvider(F,H,K){const j=this.t(new S(this.h,K),F);return this.e.$registerDeclarationSupport(j,this.o(H,F)),this.p(j)}$provideDeclaration(F,H,K,j){return this.s(F,S,Y=>Y.provideDeclaration(y.URI.revive(H),K,j),[],j)}registerImplementationProvider(F,H,K){const j=this.t(new L(this.h,K),F);return this.e.$registerImplementationSupport(j,this.o(H,F)),this.p(j)}$provideImplementation(F,H,K,j){return this.s(F,L,Y=>Y.provideImplementation(y.URI.revive(H),K,j),[],j)}registerTypeDefinitionProvider(F,H,K){const j=this.t(new v(this.h,K),F);return this.e.$registerTypeDefinitionSupport(j,this.o(H,F)),this.p(j)}$provideTypeDefinition(F,H,K,j){return this.s(F,v,Y=>Y.provideTypeDefinition(y.URI.revive(H),K,j),[],j)}registerHoverProvider(F,H,K,j){const Y=this.t(new E(this.h,K),F);return this.e.$registerHoverProvider(Y,this.o(H,F)),this.p(Y)}$provideHover(F,H,K,j){return this.s(F,E,Y=>Y.provideHover(y.URI.revive(H),K,j),void 0,j)}registerEvaluatableExpressionProvider(F,H,K,j){const Y=this.t(new D(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(H,F)),this.p(Y)}$provideEvaluatableExpression(F,H,K,j){return this.s(F,D,Y=>Y.provideEvaluatableExpression(y.URI.revive(H),K,j),void 0,j)}registerInlineValuesProvider(F,H,K,j){const Y=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new T(this.h,K),F);this.e.$registerInlineValuesProvider(x,this.o(H,F),Y);let ke=this.p(x);if(Y!==void 0){const Te=K.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(Y));ke=A.$_K.from(ke,Te)}return ke}$provideInlineValues(F,H,K,j,Y){return this.s(F,T,x=>x.provideInlineValues(y.URI.revive(H),K,j,Y),void 0,Y)}registerDocumentHighlightProvider(F,H,K){const j=this.t(new O(this.h,K),F);return this.e.$registerDocumentHighlightProvider(j,this.o(H,F)),this.p(j)}registerMultiDocumentHighlightProvider(F,H,K){const j=this.t(new G(this.h,K),F);return this.e.$registerMultiDocumentHighlightProvider(j,this.o(H,F)),this.p(j)}$provideDocumentHighlights(F,H,K,j){return this.s(F,O,Y=>Y.provideDocumentHighlights(y.URI.revive(H),K,j),void 0,j)}$provideMultiDocumentHighlights(F,H,K,j,Y){return this.s(F,G,x=>x.provideMultiDocumentHighlights(y.URI.revive(H),K,j.map(ke=>y.URI.revive(ke)),Y),void 0,Y)}registerLinkedEditingRangeProvider(F,H,K){const j=this.t(new q(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(j,this.o(H,F)),this.p(j)}$provideLinkedEditingRanges(F,H,K,j){return this.s(F,q,async Y=>{const x=await Y.provideLinkedEditingRanges(y.URI.revive(H),K,j);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?he.w(x.wordPattern):void 0}},void 0,j)}registerReferenceProvider(F,H,K){const j=this.t(new z(this.h,K),F);return this.e.$registerReferenceSupport(j,this.o(H,F)),this.p(j)}$provideReferences(F,H,K,j,Y){return this.s(F,z,x=>x.provideReferences(y.URI.revive(H),K,j,Y),void 0,Y)}registerCodeActionProvider(F,H,K,j){const Y=new r.$Sc,x=this.t(new C(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(H,F),{providedKinds:j?.providedCodeActionKinds?.map(ke=>ke.value),documentation:j?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,Y)}))},he.u(F),!!K.resolveCodeAction),Y.add(this.p(x)),Y}$provideCodeActions(F,H,K,j,Y){return this.s(F,C,x=>x.provideCodeActions(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveCodeAction(F,H,K){return this.s(F,C,j=>j.resolveCodeAction(H,K),{},void 0)}$releaseCodeActions(F,H){this.s(F,C,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,K){const j=this.t(new W(this.h,K),F);return this.e.$registerDocumentFormattingSupport(j,this.o(H,F),F.identifier,F.displayName||F.name),this.p(j)}$provideDocumentFormattingEdits(F,H,K,j){return this.s(F,W,Y=>Y.provideDocumentFormattingEdits(y.URI.revive(H),K,j),void 0,j)}registerDocumentRangeFormattingEditProvider(F,H,K){const j=typeof K.provideDocumentRangesFormattingEdits=="function",Y=this.t(new ae(this.h,K),F);return this.e.$registerRangeFormattingSupport(Y,this.o(H,F),F.identifier,F.displayName||F.name,j),this.p(Y)}$provideDocumentRangeFormattingEdits(F,H,K,j,Y){return this.s(F,ae,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(H),K,j,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(F,H,K,j,Y){return this.s(F,ae,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(H),K,j,Y),void 0,Y)}registerOnTypeFormattingEditProvider(F,H,K,j){const Y=this.t(new de(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(Y,this.o(H,F),j,F.identifier),this.p(Y)}$provideOnTypeFormattingEdits(F,H,K,j,Y,x){return this.s(F,de,ke=>ke.provideOnTypeFormattingEdits(y.URI.revive(H),K,j,Y,x),void 0,x)}registerWorkspaceSymbolProvider(F,H){const K=this.t(new we(H,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,H,K){return this.s(F,we,j=>j.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,H,K){return this.s(F,we,j=>j.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this.s(F,we,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,K){const j=this.t(new ye(this.h,K,this.l),F);return this.e.$registerRenameSupport(j,this.o(H,F),ye.supportsResolving(K)),this.p(j)}$provideRenameEdits(F,H,K,j,Y){return this.s(F,ye,x=>x.provideRenameEdits(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveRenameLocation(F,H,K,j){return this.s(F,ye,Y=>Y.resolveRenameLocation(y.URI.revive(H),K,j),void 0,j)}registerDocumentSemanticTokensProvider(F,H,K,j){const Y=this.t(new $e(this.h,K),F),x=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(H,F),j,x);let ke=this.p(Y);if(x){const Te=K.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(x));ke=A.$_K.from(ke,Te)}return ke}$provideDocumentSemanticTokens(F,H,K,j){return this.s(F,$e,Y=>Y.provideDocumentSemanticTokens(y.URI.revive(H),K,j),null,j)}$releaseDocumentSemanticTokens(F,H){this.s(F,$e,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,K,j){const Y=this.t(new ie(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(H,F),j),this.p(Y)}$provideDocumentRangeSemanticTokens(F,H,K,j){return this.s(F,ie,Y=>Y.provideDocumentRangeSemanticTokens(y.URI.revive(H),K,j),null,j)}registerCompletionItemProvider(F,H,K,j){const Y=this.t(new be(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(Y,this.o(H,F),j,be.supportsResolving(K),F.identifier),this.p(Y)}$provideCompletionItems(F,H,K,j,Y){return this.s(F,be,x=>x.provideCompletionItems(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveCompletionItem(F,H,K){return this.s(F,be,j=>j.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(F,H){this.s(F,be,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,K,j){const Y=new Z(F,this.h,K,this.j.converter),x=this.t(Y,F);return this.e.$registerInlineCompletionsSupport(x,this.o(H,F),Y.supportsHandleEvents,b.$lm.toKey(F.identifier.value),j?.yieldTo?.map(ke=>b.$lm.toKey(ke))||[]),this.p(x)}$provideInlineCompletions(F,H,K,j,Y){return this.s(F,se,x=>x.provideInlineCompletions(y.URI.revive(H),K,j,Y),void 0,Y)}$handleInlineCompletionDidShow(F,H,K,j){this.s(F,se,async Y=>{Y.handleDidShowCompletionItem(H,K,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,H,K,j){this.s(F,se,async Y=>{Y.handlePartialAccept(H,K,j)},void 0,void 0)}$freeInlineCompletionsList(F,H){this.s(F,se,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,K,j){const Y=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,x=this.t(new ne(this.h,K),F);return this.e.$registerSignatureHelpProvider(x,this.o(H,F),Y),this.p(x)}$provideSignatureHelp(F,H,K,j,Y){return this.s(F,ne,x=>x.provideSignatureHelp(y.URI.revive(H),K,j,Y),void 0,Y)}$releaseSignatureHelp(F,H){this.s(F,ne,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,K){const j=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new Ie(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(Y,this.o(H,F),typeof K.resolveInlayHint=="function",j,he.u(F));let x=this.p(Y);if(j!==void 0){const ke=K.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(j));x=A.$_K.from(x,ke)}return x}$provideInlayHints(F,H,K,j){return this.s(F,Ie,Y=>Y.provideInlayHints(y.URI.revive(H),K,j),void 0,j)}$resolveInlayHint(F,H,K){return this.s(F,Ie,j=>j.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(F,H){this.s(F,Ie,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,K){const j=this.t(new Le(this.h,K),F);return this.e.$registerDocumentLinkProvider(j,this.o(H,F),typeof K.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(F,H,K){return this.s(F,Le,j=>j.provideLinks(y.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(F,H,K){return this.s(F,Le,j=>j.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this.s(F,Le,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,K){const j=this.t(new Ce(this.h,K),F);return this.e.$registerDocumentColorProvider(j,this.o(H,F)),this.p(j)}$provideDocumentColors(F,H,K){return this.s(F,Ce,j=>j.provideColors(y.URI.revive(H),K),[],K)}$provideColorPresentations(F,H,K,j){return this.s(F,Ce,Y=>Y.provideColorPresentations(y.URI.revive(H),K,j),void 0,j)}registerFoldingRangeProvider(F,H,K){const j=this.q(),Y=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new Ae(new ce(this.h,K),F)),this.e.$registerFoldingRangeProvider(j,this.o(H,F),F.identifier,Y);let x=this.p(j);if(Y!==void 0){const ke=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));x=A.$_K.from(x,ke)}return x}$provideFoldingRanges(F,H,K,j){return this.s(F,ce,Y=>Y.provideFoldingRanges(y.URI.revive(H),K,j),void 0,j)}registerSelectionRangeProvider(F,H,K){const j=this.t(new te(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(j,this.o(H,F)),this.p(j)}$provideSelectionRanges(F,H,K,j){return this.s(F,te,Y=>Y.provideSelectionRanges(y.URI.revive(H),K,j),[],j)}registerCallHierarchyProvider(F,H,K){const j=this.t(new Q(this.h,K),F);return this.e.$registerCallHierarchyProvider(j,this.o(H,F)),this.p(j)}$prepareCallHierarchy(F,H,K,j){return this.s(F,Q,Y=>Promise.resolve(Y.prepareSession(y.URI.revive(H),K,j)),void 0,j)}$provideCallHierarchyIncomingCalls(F,H,K,j){return this.s(F,Q,Y=>Y.provideCallsTo(H,K,j),void 0,j)}$provideCallHierarchyOutgoingCalls(F,H,K,j){return this.s(F,Q,Y=>Y.provideCallsFrom(H,K,j),void 0,j)}$releaseCallHierarchy(F,H){this.s(F,Q,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,K){const j=this.t(new ee(this.h,K),F);return this.e.$registerTypeHierarchyProvider(j,this.o(H,F)),this.p(j)}$prepareTypeHierarchy(F,H,K,j){return this.s(F,ee,Y=>Promise.resolve(Y.prepareSession(y.URI.revive(H),K,j)),void 0,j)}$provideTypeHierarchySupertypes(F,H,K,j){return this.s(F,ee,Y=>Y.provideSupertypes(H,K,j),void 0,j)}$provideTypeHierarchySubtypes(F,H,K,j){return this.s(F,ee,Y=>Y.provideSubtypes(H,K,j),void 0,j)}$releaseTypeHierarchy(F,H){this.s(F,ee,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,K,j){const Y=this.q();this.f.set(Y,new Ae(new me(this.e,this.h,K,Y,F),F));const x=(0,t.$BF)(F,"dropMetadata")&&j?me.toInternalProviderId(F.identifier.value,j.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(H,F),x,(0,t.$BF)(F,"dropMetadata")?j:void 0),this.p(Y)}$provideDocumentOnDropEdits(F,H,K,j,Y,x){return this.s(F,me,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(H,y.URI.revive(K),j,Y,x)),void 0,void 0)}registerMappedEditsProvider(F,H,K){const j=this.t(new ve(this.h,K),F);return this.e.$registerMappedEditsProvider(j,this.o(H,F)),this.p(j)}$provideMappedEdits(F,H,K,j,Y){return this.s(F,ve,x=>Promise.resolve(x.provideMappedEdits(H,K,j,Y)),null,Y)}registerDocumentPasteEditProvider(F,H,K,j){const Y=this.q();this.f.set(Y,new Ae(new N(this.e,this.h,K,Y,F),F));const x=N.toInternalProviderId(F.identifier.value,j.id);return this.e.$registerPasteEditProvider(Y,this.o(H,F),x,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(F,H,K,j,Y){return this.s(F,N,x=>x.prepareDocumentPaste(y.URI.revive(H),K,j,Y),void 0,Y)}$providePasteEdits(F,H,K,j,Y,x){return this.s(F,N,ke=>ke.providePasteEdits(H,y.URI.revive(K),j,Y,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:he.w(F.decreaseIndentPattern),increaseIndentPattern:he.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?he.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?he.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:he.w(F.beforeText),afterText:F.afterText?he.w(F.afterText):void 0,previousLineText:F.previousLineText?he.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(he.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(H=>A.SyntaxTokenType.toString(H)):void 0}}static D(F){return F.map(he.C)}setLanguageConfiguration(F,H,K){const{wordPattern:j}=K;if(j&&(0,f.$Ye)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor(H,j):this.h.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const Y=this.q(),x={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?he.w(K.wordPattern):void 0,indentationRules:K.indentationRules?he.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?he.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?he.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,H,x),this.p(Y)}$setWordDefinitions(F){for(const H of F)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$kgc=he}),define(Pe[257],Re([1,0,3,8,7,31,13,6,24]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class w{constructor(k,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$0K.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,l){const p=k.version,b=M.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,b),a={type:I.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new I.$bL(l.line,l.character,l.line,l.character)};if(!r)return a;const s={range:M.Range.to(r.range),type:M.TokenType.to(r.type)};return!s.range.contains(l)||p!==k.version?a:s}createLanguageStatusItem(k,l,p){const b=this.f++,r=this.a,a=this.g,s=`${k.identifier.value}/${l}`;if(a.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(s);const n={selector:p,id:l,name:k.displayName??k.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new m.$Sc,h=()=>{if(o?.dispose(),!a.has(s)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,P.$8g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:s,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===I.LanguageStatusSeverity.Error?A.default.Error:n.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),o?.dispose(),r.$removeLanguageStatus(b),a.delete(s)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,h()},get selector(){return n.selector},set selector(u){n.selector=u,h()},get text(){return n.text},set text(u){n.text=u,h()},set text2(u){(0,f.$CF)(k,"languageStatusText"),n.text=u,h()},get text2(){return(0,f.$CF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,h()},get severity(){return n.severity},set severity(u){n.severity=u,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,h()},get command(){return n.command},set command(u){n.command=u,h()},get busy(){return n.busy},set busy(u){n.busy=u,h()}};return h(),t}}e.$Jhc=w}),define(Pe[258],Re([1,0,11,2,8,7,84]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;class m{constructor(k,l,p,b){this.start=k,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new A.$xM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,p){this.notebook=k,this.h=l,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(b){k.g=b},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,l,p){const b=p.map(I.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===k);if(r&&(l||(r.items.length=0),r.items.push(...b),r.items.length>1&&r.items.every(a=>P.$bJ(a.mime)))){const a=new Map,s=[];r.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),s.push(n.mime)),o.push(n.data)}),r.items.length=0,s.forEach(n=>{const o=P.$cJ(a.get(n));r.items.push({mime:n,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$uhc=f;class w{static{this.a=0}constructor(k,l,p,b,r){this.k=k,this.l=l,this.m=p,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,p){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const s of k.rawEvents)s.kind===P.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,b.contentChanges):s.kind===P.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,b.contentChanges):s.kind===P.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===P.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===P.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const a=new Map;for(let s=0;s<r.length;s++){const n=r[s],o=a.get(n.cell);if(o===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else b.cellChanges[o]={...b.cellChanges[o],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,p=k.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),k.with({start:l,end:p})}p(k){k=this.o(k);const l=[];for(let p=k.start;p<k.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,p){if(this.j)return;const b=[],r=[],a=[];if(k.reverse().forEach(s=>{const o=s[2].map(t=>{const u=new f(this,this.l,t);return l||r.push(f.asModelAddData(this.apiNotebook,t)),u}),c=new m(s[0],s[1],[],o),h=this.b.splice(s[0],s[1],...o);for(const t of h)a.push(t.uri),c.deletedItems.push(t.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),p)for(const s of b)p.push(s.asApiEvent())}s(k,l,p,b){const r=this.b.splice(k,l);this.b.splice(p,0,...r);const a=[new m(k,l,r.map(s=>s.apiCell),[]),new m(p,0,[],r)];for(const s of a)b.push(s.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,p,b){this.b[k].setOutputItems(l,p,b)}v(k,l){const p=this.b[k];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(k,l){const p=this.b[k];p.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$vhc=w}),define(Pe[259],Re([1,0,5,2,8,7]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class P{constructor(f,w,R,k={timeout:1500,errors:3}){this.b=f,this.c=w,this.d=R,this.f=k,this.a=new y.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(w,R,k)=>{const l=function(b){w.call(R,b)};return l.extension=f,this.a.event(l,void 0,k)}}async $participateInSave(f,w,R){const k=M.URI.revive(f),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},R,async(r,a)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof A.$jL?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const r of p){const{edits:a}=I.WorkspaceEdit.from(r);b.edits=b.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Lhc=P}),define(Pe[109],Re([1,0,15,8,7]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,w,R,k,l){this.id=m,this.f=f,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(I.$xM.isNotebookRange))throw(0,y.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,w){m.f.$tryRevealRange(m.id,M.NotebookRange.from(f),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$whc=A}),define(Pe[260],Re([1,0,5,14,8]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let A=class{constructor(m,f){this.c=m,this.d=f,this.a=new y.$Vd,this.b=new y.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const w=this.d.getEditorById(m);f.visibleRanges&&w._acceptVisibleRanges(f.visibleRanges.ranges.map(I.NotebookRange.to)),f.selections&&w._acceptSelections(f.selections.selections.map(I.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(I.ViewColumn.to(m[f]))}};e.$Nhc=A,e.$Nhc=A=Je([He(0,M.$nj)],A)}),define(Pe[261],Re([1,0,5,3,109]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class A{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(M.$0K.MainThreadNotebookRenderers)}$postRendererMessage(m,f,w){const R=this.c.getEditorById(m);this.a.get(f)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(R=>R.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(R,k,l)=>this.d(f).event(R,k,l),postMessage:(R,k)=>{I.$whc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const l=k&&I.$whc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,f,R)}}}d(m){let f=this.a.get(m);return f||(f=new y.$Vd({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$Qhc=A}),define(Pe[262],Re([1,0,8,72,20,67,15]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,p){const b=this.b++,{title:r,location:a,cancellable:s}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(b,{location:y.ProgressLocation.from(a),title:r,source:n,cancellable:s},k.isUnderDevelopment?void 0:k.identifier.value).catch(P.$2),this.d(b,p,!!s)}d(k,l,p){let b;p&&(b=new I.$6d,this.c.set(k,b));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),b?.dispose()};let a;try{a=l(new w(this.a,k),p&&b?b.token:I.CancellationToken.None)}catch(s){throw r(k),s}return a.then(s=>r(k),s=>r(k)),a}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$Uhc=m;function f(R,k){return R.message=k.message,typeof k.increment=="number"&&(typeof R.increment=="number"?R.increment+=k.increment:R.increment=k.increment),R}class w extends M.$vv{constructor(k,l){super(p=>this.throttledReport(p)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,A.$zh)(100,(R,k)=>f(R,k),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(Pe[263],Re([1,0,2,3,13,8]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class P{static{this.a=0}constructor(f,w){this.d=w,this.c=new Map,this.b=f.getProxy(M.$0K.MainThreadQuickDiff)}$provideOriginalResource(f,w,R){const k=y.URI.revive(w),l=this.c.get(f);return l?(0,I.$Yg)(()=>l.provideOriginalResource(k,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(f,w,R,k){const l=P.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,A.DocumentSelector.from(f,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Vhc=P}),define(Pe[264],Re([1,0,20,5,6,3,2,7,15,18,31,44,24,8]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;function b(r,a,s){const n=r.getProxy(A.$0K.MainThreadQuickOpen);class o{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,v,E=y.CancellationToken.None){this.c=void 0;const D=Promise.resolve(L),T=++this.f,O=n.$show(T,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},E),G={},q=O.then(()=>G);return Promise.race([q,D]).then(z=>{if(z===G)return;const C=(0,l.$BF)(S,"quickPickItemTooltip");return D.then(N=>{const W=[];for(let ae=0;ae<N.length;ae++){const de=N[ae];if(typeof de=="string")W.push({label:de,handle:ae});else if(de.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:de.label});else{de.tooltip&&!C&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const we=de.iconPath?i(de.iconPath):void 0;W.push({label:de.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:C?p.MarkdownString.fromStrict(de.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(N[ae])}),n.$setItems(T,W),O.then(ae=>{if(typeof ae=="number")return N[ae];if(Array.isArray(ae))return ae.map(de=>N[de])})})}).then(void 0,z=>{if(!(0,f.$4)(z))return n.$setError(T,z),Promise.reject(z)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=y.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,v=>{if(!(0,f.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let v;switch(L.severity){case m.InputBoxValidationSeverity.Info:v=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=L.message?R.default.Error:R.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(S,L=y.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===v.uri.toString())}createQuickPick(S){const L=new g(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new $(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const v=this.e.get(S);v instanceof g&&v._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const v=this.e.get(S);v instanceof g&&v._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,v){const E=this.e.get(S);E instanceof g&&E._fireDidTriggerItemButton(L,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Vd,this.q=new M.$Vd,this.r=new M.$Vd,this.s=new M.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,v)=>{const E=L===m.$uM.Back?-1:v;this.o.set(E,L)}),this.z({buttons:S.map((L,v)=>({...i(L.iconPath),tooltip:L.tooltip,handle:L===m.$uM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const v=S[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(d){if(d instanceof m.$7L)return{id:d.id};const S=u(d),L=t(d);return{dark:typeof S=="string"?P.URI.file(S):S,light:typeof L=="string"?P.URI.file(L):L}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function i(d){const S=h(d);let L,v;return"id"in S?v=k.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:v}}class g extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Vd,this.L=[],this.M=new M.$Vd,this.N=new M.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const L=(0,l.$BF)(this.O,"quickPickItemTooltip"),v=[];for(let E=0;E<S.length;E++){const D=S[E];if(D.kind===m.QuickPickItemKind.Separator)v.push({type:"separator",label:D.label});else{D.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const T=D.iconPath?i(D.iconPath):void 0;v.push({handle:E,label:D.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,G)=>({...i(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const E=v.buttons[L];E&&this.N.fire({button:E,item:v})}}class $ extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(a,s)}e.$Whc=b}),define(Pe[265],Re([1,0,2,5,67,6,13,3,18,138,14,23,44,8,24,11,21]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;function n(T){return T instanceof y.URI}function o(T,O){return T.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&a.$k?T.toString()===O.toString():T.toString().toLowerCase()===O.toString().toLowerCase()}function c(T){if(T)return typeof T.iconPath=="string"?y.URI.file(T.iconPath):y.URI.isUri(T.iconPath)||l.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function h(T){if(T.icon){if(y.URI.isUri(T.icon))return T.icon;if(l.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const O=T.icon;return{light:O.light,dark:O.dark}}}else return}function t(T,O){if(!T.iconPath&&!O.iconPath)return 0;if(T.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof T.iconPath=="string"?T.iconPath:y.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,q=typeof O.iconPath=="string"?O.iconPath:y.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Sq)(G,q)}function u(T,O){let G=0;if(T.strikeThrough!==O.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==O.faded)return T.faded?1:-1;if(T.tooltip!==O.tooltip)return(T.tooltip||"").localeCompare(O.tooltip||"");if(G=t(T,O),G!==0)return G;if(T.light&&O.light)G=t(T.light,O.light);else{if(T.light)return 1;if(O.light)return-1}if(G!==0)return G;if(T.dark&&O.dark)G=t(T.dark,O.dark);else{if(T.dark)return 1;if(O.dark)return-1}return G}function i(T,O){if(T.command!==O.command)return T.command<O.command?-1:1;if(T.title!==O.title)return T.title<O.title?-1:1;if(T.tooltip!==O.tooltip){if(T.tooltip!==void 0&&O.tooltip!==void 0)return T.tooltip<O.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(T.arguments===O.arguments)return 0;if(T.arguments)if(O.arguments){if(T.arguments.length!==O.arguments.length)return T.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<T.arguments.length;G++){const q=T.arguments[G],z=O.arguments[G];if(q!==z&&!(n(q)&&n(z)&&o(q,z)))return q<z?-1:1}return 0}function g(T,O){let G=(0,w.$Sq)(T.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(T.command&&O.command)G=i(T.command,O.command);else{if(T.command)return 1;if(O.command)return-1}if(G!==0)return G;if(T.decorations&&O.decorations)G=u(T.decorations,O.decorations);else{if(T.decorations)return 1;if(O.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,w.$Sq)(T.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,w.$Sq)(T.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function $(T,O){for(let G=0;G<T.length;G++)if(T[G]!==O[G])return!1;return!0}function d(T,O){return T.command===O.command&&T.title===O.title&&T.tooltip===O.tooltip&&(T.arguments&&O.arguments?$(T.arguments,O.arguments):T.arguments===O.arguments)}function S(T,O){return(0,f.$ub)(T,O,d)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,b.$CF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,b.$CF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,b.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,q,z,C){this.k=O,this.l=z,this.m=C,this.d="",this.e=new M.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(O,G){(0,b.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Xhc=L;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,q,z,C,N,W){this.q=O,this.s=G,this.t=q,this.u=z,this.v=C,this.multiDiffEditorEnableViewChanges=N,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const q=this.h.get(O);return q?(0,P.$Yg)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(g),q=(0,f.$Db)(this.o,O,g).map(N=>{const W=N.toInsert.map(ae=>{const de=this.e++;this.g.set(de,ae);const we=ae.resourceUri;let ye;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new A.$Sc;ye=this.s.converter.toInternal(ae.command,te),this.j.set(de,te)}else this.h.set(de,ae.command);const le=(0,b.$BF)(this.w,"scmMultiDiffEditor"),$e=le?ae.multiDiffEditorOriginalUri:void 0,ie=le?ae.multiFileDiffEditorModifiedUri:void 0,be=c(ae.decorations),se=ae.decorations&&c(ae.decorations.light)||be,Z=ae.decorations&&c(ae.decorations.dark)||be,V=[se,Z],ne=ae.decorations&&ae.decorations.tooltip||"",Ie=ae.decorations&&!!ae.decorations.strikeThrough,Le=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[de,we,V,ne,Ie,Le,Ce,ye,$e,ie],handle:de}});return{start:N.start,deleteCount:N.deleteCount,toInsert:W}}),z=q.map(({start:N,deleteCount:W,toInsert:ae})=>[N,W,ae.map(de=>de.rawResource)]),C=q.reverse();for(const{start:N,deleteCount:W,toInsert:ae}of C){const de=ae.map(ye=>ye.handle),we=this.n.splice(N,W,...de);for(const ye of we)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,b.$BF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,b.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,b.$CF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new A.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,b.$CF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,b.$CF)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(q=>q.map(z=>this.y.converter.toInternal(z,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new A.$Sc,this.t=O;const G=(O||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,q,z,C,N,W){this.x=O,this.y=z,this.z=C,this.A=N,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Vd,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=q;const ae=y.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new L(O,G,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,C,N,W,ae)}createResourceGroup(O,G,q){const z=(0,b.$BF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new v(this.#e,this.y,this.w,O,G,z,this.x),N=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,N),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const O=[],G=[];for(const[q,z]of this.C){z.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),O.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const N=q._takeResourceStateSnapshot();N.length>0&&G.push([q.handle,N]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&O.push([G.handle,q])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,I.$yh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$yh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,q,z){this.l=G,this.m=q,this.n=z,this.g=new Map,this.h=new k.$nm,this.j=new M.$Vd,this.e=O.getProxy(m.$0K.MainThreadSCM),this.f=O.getProxy(m.$0K.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const N=this.g.get(C.sourceControlHandle);if(!N)return C;const W=N.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const N=this.g.get(C.sourceControlHandle);return N?N.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const N=this.g.get(C.handle);return N||C}return C}})}createSourceControl(O,G,q,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,q,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const C=s.d++,N=new E(O,this.m,this.e,this.l,G,q,z);this.g.set(C,N);const W=this.h.get(O.identifier)||[];return W.push(N),this.h.set(O.identifier,W),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(O,G,q){const z=y.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const C=this.g.get(O);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$Yg)(()=>C.quickDiffProvider.provideOriginalResource(z,q)).then(N=>N||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const q=this.g.get(O);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,q,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,q);const C=this.g.get(O);if(!C)return Promise.resolve(void 0);const N=C.getResourceGroup(G);return N?N.$executeResourceCommand(q,z):Promise.resolve(void 0)}$validateInput(O,G,q){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,P.$Yg)(()=>z.inputBox.validateInput(G,q)).then(C=>{if(!C)return Promise.resolve(void 0);const N=p.MarkdownString.fromStrict(C.message);return N?Promise.resolve([N,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,G,q){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(G,q)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,G,q,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,z)??void 0}async $provideHistoryItems(O,G,q,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,q,z))?.map(W=>({...W,icon:h(W)}))??void 0}async $provideHistoryItemSummary(O,G,q,z){const C=this.g.get(O)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const N=await C.provideHistoryItemSummary(G,q,z);return N?{...N,icon:h(N)}:void 0}async $provideHistoryItemChanges(O,G,q,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,q,z)??void 0}};e.$Yhc=D,e.$Yhc=D=s=Je([He(3,R.$nj)],D)}),define(Pe[266],Re([1,0,3,8,2]),function(ge,e,y,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class A{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(y.$0K.MainThreadShare)}async $provideShare(m,f,w){return await this.c.get(m)?.provideShare({selection:M.Range.to(f.selection),resourceUri:I.URI.revive(f.resourceUri)},w)??void 0}registerShareProvider(m,f){const w=A.a++;return this.c.set(w,f),this.b.$registerShareProvider(w,M.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Zhc=A}),define(Pe[267],Re([1,0,7,3,163,6,8,16]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$8L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$8L("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,r,a,s=y.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=l,this.#t=p,a&&r){this.c=(0,y.$KL)(r.identifier,a);const o=b.get(this.c);o&&(s=o.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(f.a++);this.e=r,this.f=a,this.g=s,this.h=this.u(n)}u(l){if((0,m.$Mf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=f.b.get(this.o.id));const r=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,b,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$2hc=f;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new y.$_K(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,p){this.e=new Map,this.a=l.getProxy(M.$0K.MainThreadStatusBar),this.b=p,this.c=new w(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,r){return new f(this.a,this.b,this.e,l,p,b,r)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new y.$_K(()=>{b.dispose(),clearTimeout(r)})}}e.$3hc=R}),define(Pe[110],Re([1,0,29,103,48,76,59,8,2]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;const w=(o,c,h,t)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(i){if(!h(u,i)){const g=u;u=i,o.listener?.(t(i,g))}}}},R=(o,c)=>o===c,k={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(t=>h.id===t.id)))},l=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let h;const t=l(u=>({range:y.$Us.lift(m.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return h},set(u){o.listener?.({op:6}),k.range(h,u)||(h=u,o.listener?.(t(u)))}}})(),label:w(o,c,k.label,l(h=>({label:h}))),description:w(o,void 0,k.description,l(h=>({description:h}))),sortText:w(o,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:w(o,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,k.busy,l(h=>({busy:h}))),error:w(o,void 0,k.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],k.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),b=o=>{const c=I.$2J.fromString(o.extId),h=new a(c.controllerId,c.localId,o.label,f.URI.revive(o.uri)||void 0);return h.range=m.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(t=>m.TestTag.to({id:(0,P.$7J)(t).tagId})),h},r=o=>{let c;for(const h of o.tests){const t=b(h.item);(0,M.$0M)(t).parent=c,c=t}return c};e.$nN=r;class a{constructor(c,h,t,u){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const i=(0,M.$9M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof s?void 0:i.parent}},children:{value:(0,A.$8M)(i,M.$0M,a),enumerable:!0,writable:!1},...p(i,t)})}}e.$oN=a;class s extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$pN=s;class n extends A.$4M{constructor(c,h,t){super({controllerId:c,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:M.$0M,getChildren:u=>u.children,root:new s(c,h),toITestItem:m.TestItem.from})}}e.$qN=n}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,110,22,49,40,63,57,60,33]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=void 0;let i=class{#e;#t;#i;constructor(v,E,D){this.b=new Map,this.c=new Map,this.#e=v.getProxy(P.$0K.MainThreadCommands),this.d=E,this.#i=D,this.#t=v.getProxy(P.$0K.MainThreadTelemetry),this.converter=new g(this,T=>{const O=this.c.get(T);return O?.result===d.Void?O:void 0},E),this.f=[{processArgument(T){return(0,w.$Ch)(T)}},{processArgument(T){return(0,A.$xn)(T,function(O){if(R.$Us.isIRange(O))return I.Range.to(O);if(k.$Ts.isIPosition(O))return I.Position.to(O);if(R.$Us.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof s.$je)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const E=this.registerCommand(!1,v.id,async(...D)=>{const T=v.args.map((G,q)=>{if(!G.validate(D[q]))throw new Error(`Invalid argument '${G.name}' when running '${v.id}', received: ${typeof D[q]=="object"?JSON.stringify(D[q],null,"	"):D[q]} `);return G.convert(D[q])}),O=await this.executeCommand(v.internalId,...T);return v.result.convert(O,D,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new M.$_K(()=>{E.dispose(),this.c.delete(v.id)})}registerCommand(v,E,D,T,O,G){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:T,metadata:O,extension:G}),v&&this.#e.$registerCommand(E),new M.$_K(()=>{this.b.delete(E)&&v&&this.#e.$unregisterCommand(E)})}executeCommand(v,...E){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,E,!0)}async g(v,E,D){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,E,!1);{let T=!1;const O=(0,A.$xn)(E,function(G){if(G instanceof M.$aL)return I.Position.from(G);if(G instanceof M.$bL)return I.Range.from(G);if(G instanceof M.$lL)return I.location.from(G);if(M.$xM.isNotebookRange(G))return I.NotebookRange.from(G);if(G instanceof ArrayBuffer)return T=!0,s.$je.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return T=!0,s.$je.wrap(G);if(G instanceof s.$je)return T=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(v,T?new n.$Tv(O):O,D);return(0,w.$Ch)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(v,E,!1);throw G}}}async h(v,E,D){const T=this.b.get(v);if(!T)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:q}=T;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,y.$Zf)(E[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const z=c.$Rd.create();try{return await O.apply(G,E)}catch(C){if(v===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...E);N&&(v=N.command)}if(this.d.error(C,v,T.extension?.identifier),!D)throw C;if(T.extension?.identifier){const N=this.#i.onExtensionError(T.extension.identifier,C);this.d.trace("forwarded error to extension?",N,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Qi)(C)),this.id=v,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,v,z.elapsed())}}j(v,E,D){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$Lo(E),duration:D})}$executeContributedCommand(v,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const D=this.b.get(v);return D?(E=E.map(T=>this.f.reduce((O,G)=>G.processArgument(O,D.extension?.identifier),T)),this.h(v,E,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(E=>(v&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[E,D]of this.b){const{metadata:T}=D;T&&(v[E]=T)}return Promise.resolve(v)}};e.$wN=i,e.$wN=i=Je([He(0,r.$bN),He(1,f.$nj),He(2,t.$vN)],i),e.$xN=(0,b.$6h)("IExtHostCommands");class g{constructor(v,E,D){this.d=v,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,E){if(!v)return;const D={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return D;const T=this.f(v.command);if(T)D.id=T.internalId,D.arguments=T.args.map((O,G)=>O.convert(v.arguments&&v.arguments[G]));else if((0,m.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),E.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return D}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const E=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$yN=g;class ${static{this.Uri=new $("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new $("position","A position in a text document",v=>M.$aL.isPosition(v),I.Position.from)}static{this.Range=new $("range","A range in a text document",v=>M.$bL.isRange(v),I.Range.from)}static{this.Selection=new $("selection","A selection in a text document",v=>M.$cL.isSelection(v),I.Selection.from)}static{this.Number=new $("number","",v=>typeof v=="number",v=>v)}static{this.String=new $("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=$.Arr($.String)}static Arr(v){return new $(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,E=>Array.isArray(E)&&E.every(D=>v.validate(D)),E=>E.map(D=>v.convert(D)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",v=>v instanceof M.$wL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",v=>v instanceof M.$QM,I.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",v=>v instanceof a.$oN,I.TestItem.from)}constructor(v,E,D,T){this.name=v,this.description=E,this.validate=D,this.convert=T}optional(){return new $(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,E){return new $(v??this.name,E??this.description,this.validate,this.convert)}}e.$zN=$;class d{static{this.Void=new d("no result",v=>v)}constructor(v,E){this.description=v,this.convert=E}}e.$AN=d;class S{constructor(v,E,D,T,O){this.id=v,this.internalId=E,this.description=D,this.args=T,this.result=O}}e.$BN=S}),define(Pe[268],Re([1,0,18,11,2,87,96,35,32,8,7]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;const k=[new f.$BN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new f.$BN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,y.$Kb)(r))return;class s extends R.$rL{static to(o){const c=new s(o.name,w.SymbolKind.to(o.kind),o.containerName||"",new R.$lL(a[0],w.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=w.Range.to(o.selectionRange),c.children=o.children?o.children.map(s.to):[],c}}return r.map(s.to)})),new f.$BN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$zN.Uri,new f.$zN("options","Formatting options",r=>!0,r=>r)],new f.$AN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new f.$BN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$zN.Uri,f.$zN.Range,new f.$zN("options","Formatting options",r=>!0,r=>r)],new f.$AN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new f.$BN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$zN.Uri,f.$zN.Position,new f.$zN("ch","Trigger character",r=>typeof r=="string",r=>r),new f.$zN("options","Formatting options",r=>!0,r=>r)],new f.$AN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new f.$BN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",b)),new f.$BN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",b)),new f.$BN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",b)),new f.$BN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",b)),new f.$BN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location-instances.",p(w.location.to))),new f.$BN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new f.$BN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$zN.Uri,new f.$zN("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>R.$aL.isPosition(a)),r=>r.map(w.Position.from))],new f.$AN("A promise that resolves to an array of ranges.",r=>r.map(a=>{let s;for(const n of a.reverse())s=new R.$vL(w.Range.to(n),s);return s}))),new f.$BN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$zN.String.with("query","Search string")],new f.$AN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(w.WorkspaceSymbol.to))),new f.$BN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(w.CallHierarchyItem.to))),new f.$BN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$zN.CallHierarchyItem],new f.$AN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(w.CallHierarchyIncomingCall.to))),new f.$BN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$zN.CallHierarchyItem],new f.$AN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(w.CallHierarchyOutgoingCall.to))),new f.$BN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:w.Range.to(r.range),placeholder:r.text}})),new f.$BN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("newName","The new symbol name")],new f.$AN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return w.WorkspaceEdit.to(r)}})),new f.$BN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$zN.Uri,f.$zN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$AN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(w.DocumentLink.to))),new f.$BN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$zN.Uri],new f.$AN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$pM(r.tokenTypes,r.tokenModifiers)})),new f.$BN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$zN.Uri],new f.$AN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,P.$x$)(r);if(a.type==="full")return new R.$rM(a.data,void 0)})),new f.$BN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$zN.Uri,f.$zN.Range.optional()],new f.$AN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$pM(r.tokenTypes,r.tokenModifiers)})),new f.$BN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$zN.Uri,f.$zN.Range],new f.$AN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,P.$x$)(r);if(a.type==="full")return new R.$rM(a.data,void 0)})),new f.$BN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$zN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$AN("A promise that resolves to a CompletionList-instance.",(r,a,s)=>{if(!r)return new R.$HL([]);const n=r.suggestions.map(o=>w.CompletionItem.to(o,s));return new R.$HL(n,r.incomplete)})),new f.$BN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$AN("A promise that resolves to SignatureHelp.",r=>{if(r)return w.SignatureHelp.to(r)})),new f.$BN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$zN.Uri,f.$zN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$AN("A promise that resolves to an array of CodeLens-instances.",(r,a,s)=>p(n=>new R.$zL(w.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new f.$BN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$zN.Uri,new f.$zN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>R.$bL.isRange(r),r=>R.$cL.isSelection(r)?w.Selection.from(r):w.Range.from(r)),f.$zN.String.with("kind","Code action kind to return code actions for").optional(),f.$zN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$AN("A promise that resolves to an array of Command-instances.",(r,a,s)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const o=new R.$tL(n.title,n.kind?new R.$uL(n.kind):void 0);return n.edit&&(o.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(o.command=s.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(r))),new f.$BN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new R.$NL(w.Range.to(a.range),w.Color.to(a.color))):[])),new f.$BN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$zN("color","The color to show and insert",r=>r instanceof R.$ML,w.Color.from),new f.$zN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:w.Range.from(r.range)}))],new f.$AN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(w.ColorPresentation.to):[])),new f.$BN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$zN.Uri,f.$zN.Range],new f.$AN("A promise that resolves to an array of Inlay objects",(r,a,s)=>r.map(w.InlayHint.to.bind(void 0,s)))),new f.$BN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(w.FoldingRange.to)})),new f.$BN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$AN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>w.NotebookExclusiveDocumentPattern.to(a))})))),new f.$BN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$zN.Uri,f.$zN.Range,new f.$zN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof R.$bL,r=>w.InlineValueContext.from(r))],new f.$AN("A promise that resolves to an array of InlineValue objects",r=>r.map(w.InlineValue.to))),new f.$BN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$zN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,M.$fg)(r,M.Schemas.http,M.Schemas.https),r=>r),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional(),f.$zN.String.with("label","").optional()],f.$AN.Void),new f.$BN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$zN.Uri.with("resource","Resource to open"),f.$zN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional()],f.$AN.Void),new f.$BN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$zN.Uri.with("left","Left-hand side resource of the diff editor"),f.$zN.Uri.with("right","Right-hand side resource of the diff editor"),f.$zN.String.with("title","Human readable title for the diff editor").optional(),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)]).optional()],f.$AN.Void),new f.$BN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$zN.String.with("title","Human readable title for the changes editor"),new f.$zN("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[s,n,o]=a;if(!I.URI.isUri(s)||!I.URI.isUri(n)&&n!==void 0&&n!==null||!I.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},r=>r)],f.$AN.Void),new f.$BN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$zN.TypeHierarchyItem],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$zN.TypeHierarchyItem],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$zN.TestItem],f.$AN.Void),new f.$BN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$zN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$AN.Void),new f.$BN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$zN.String.with("name","The context key name"),new f.$zN("value","The context key value",()=>!0,r=>r)],f.$AN.Void),new f.$BN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$zN.Uri,f.$zN.StringArray,new f.$zN("MappedEditsContext","Mapped Edits Context",r=>w.MappedEditsContext.is(r),r=>w.MappedEditsContext.from(r))],new f.$AN("A promise that resolves to a workspace edit or null",r=>r?w.WorkspaceEdit.to(r):null))];class l{static register(a){k.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$5i)}}e.$lgc=l;function p(r){return a=>{if(Array.isArray(a))return a.map(r)}}function b(r){if(!Array.isArray(r))return;const a=[];for(const s of r)A.$Gt(s)?a.push(w.DefinitionLink.to(s)):a.push(w.location.to(s));return a}}),define(Pe[269],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class w{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=w.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,b,r,a){this.f=r,this.g=a,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$0K.MainThreadInlineChat),b.registerApiCommand(new m.$BN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$zN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?A.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?A.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?A.Position.from(s.position):void 0}})],m.$AN.Void))}registerProvider(p,b,r){const a=new w(p,b);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",r?.supportReportIssue??!1),(0,y.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(p,b,r,a){const s=this.b.get(p);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(b)),o=A.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new R(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:A.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,r,a){const s=this.b.get(p);if(!s)return;const n=this.d.get(b.id);if(!n)return;const o={prompt:r.prompt,selection:A.Selection.to(r.selection),wholeRange:A.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async L=>{if(!r.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:L.message,edits:L.edits?.map(A.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:P.$AL.isMarkdownString(L.content)?L.content.value:L.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,o,h,a));let u;try{u=await(0,f.$Ug)(t,a)}finally{c=!0}if(!u)return;const i=n.responses.push(u)-1,g={wholeRange:A.Range.from(u.wholeRange),placeholder:u.placeholder};if(!k.h(u))return{...g,id:i,type:"editorEdit",message:A.MarkdownString.from(u.contents),edits:[]};const{edits:$,contents:d}=u,S=d!==void 0?A.MarkdownString.from(d):void 0;return $ instanceof P.$jL?{...g,id:i,type:"bulkEdit",edits:A.WorkspaceEdit.from($),message:S}:{...g,id:i,type:"editorEdit",edits:$.map(A.TextEdit.from),message:S}}async $provideFollowups(p,b,r,a){const s=this.b.get(p),n=this.d.get(b),o=n?.responses[r];if(s&&o&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(n.session,o,a));return(await(0,f.$Ug)(c,a))?.map(A.ChatReplyFollowup.from)}}$handleFeedback(p,b,r,a){const s=this.b.get(p),n=this.d.get(b),o=n?.responses[r];if(s&&o){const c=A.InteractiveEditorResponseFeedbackKind.to(a);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$thc=k}),define(Pe[270],Re([1,0,2,32]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class I{constructor(P,m,f,w,R){this.a=m,this.b=f,this.c=w;const k=new M.$BN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$zN("showOptions","Show Options",l=>!0,l=>l),new M.$zN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$zN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$zN("title","Interactive editor title",l=>!0,l=>l)],new M.$AN("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(P,m,f,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Ghc=I}),define(Pe[271],Re([1,0,18,13,20,5,6,28,2,23,14,3,32,8,7,77,209,24,49]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0;let o=class{constructor(d,S,L,v,E){this.m=S,this.n=L,this.o=v,this.q=E,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(k.$0K.MainThreadNotebookKernels);const D=new l.$BN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$zN("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const O=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:O}}else if(T&&"notebookEditor"in T){const O=this.n.getIdByEditor(T.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return T})],l.$AN.Void);this.o.registerApiCommand(D)}createNotebookController(d,S,L,v,E,D){for(const ie of this.j.values())if(ie.controller.id===S&&w.$lm.equals(d.identifier,ie.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const T=this.k++,O=this;this.q.trace(`NotebookController[${T}], CREATED by ${d.identifier.value}, ${S}`);const G=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let q=!1;const z=new A.$Vd,C=new A.$Vd,N={id:g(d.identifier,S),notebookType:L,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:v||d.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let W=E??G,ae,de;this.a.$addKernel(T,N).catch(ie=>{console.log(ie),q=!0});let we=0;const ye=()=>{if(q)return;const ie=++we;Promise.resolve().then(()=>{ie===we&&this.a.$updateKernel(T,N)})},le=new m.$Ac,$e={get id(){return S},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(ie){N.label=ie??d.displayName??d.name,ye()},get detail(){return N.detail??""},set detail(ie){N.detail=ie,ye()},get description(){return N.description??""},set description(ie){N.description=ie,ye()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(ie){N.supportedLanguages=ie,ye()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){N.supportsExecutionOrder=ie,ye()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ie){W=ie??G},get interruptHandler(){return ae},set interruptHandler(ie){ae=ie,N.supportsInterrupt=!!ie,ye()},set variableProvider(ie){(0,s.$CF)(d,"notebookVariableProvider"),de=ie,N.hasVariableProvider=!!ie,ie?.onDidChangeVariables(be=>O.a.$variablesUpdated(be.uri)),ye()},get variableProvider(){return de},createNotebookCellExecution(ie){if(q)throw new Error("notebook controller is DISPOSED");if(!le.has(ie.notebook.uri))throw O.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,g(d.identifier,this.id))},createNotebookExecution(ie){if((0,s.$CF)(d,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!le.has(ie.uri))throw O.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return O._createNotebookExecution(ie,g(d.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${T}], DISPOSED`),q=!0,this.j.delete(T),z.dispose(),C.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ie,be){be===b.NotebookControllerAffinity2.Hidden&&(0,s.$CF)(d,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(T,ie.uri,be)},onDidReceiveMessage:C.event,postMessage(ie,be){return(0,s.$CF)(d,"notebookMessaging"),O.a.$postMessage(T,be&&O.n.getIdByEditor(be),ie)},asWebviewUri(ie){return(0,s.$CF)(d,"notebookMessaging"),(0,r.$Dvb)(ie,O.m.remote)}};return this.j.set(T,{extensionId:d.identifier,controller:$e,onDidReceiveMessage:C,onDidChangeSelection:z,associatedNotebooks:le}),$e}getIdByController(d){for(const[S,L]of this.j)if(L.controller===d)return g(L.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,S){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const E={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,E),E}registerKernelSourceActionProvider(d,S,L){const v=this.i++,E=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,D=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let T;return E!==void 0&&(T=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(v),D.a.$removeKernelSourceActionProvider(v,v),T?.dispose()}}}async $provideKernelSourceActions(d,S){const L=this.h.get(d);if(L){const v=new P.$Sc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,v))}return[]}$acceptNotebookAssociation(d,S,L){const v=this.j.get(d);if(v){const E=this.n.getNotebookDocument(f.URI.revive(S));L?v.associatedNotebooks.set(E.uri,!0):v.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,E.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:E.apiNotebook})}}async $executeCells(d,S,L){const v=this.j.get(d);if(!v)return;const E=this.n.getNotebookDocument(f.URI.revive(S)),D=[];for(const T of L){const O=E.getCell(T);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,E.uri.toString(),D.length),await v.controller.executeHandler.call(v.controller,D,E.apiNotebook,v.controller)}catch(T){this.q.error(`NotebookController[${d}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(d,S,L){const v=this.j.get(d);if(!v)return;const E=this.n.getNotebookDocument(f.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,E.apiNotebook);else for(const D of L){const T=E.getCell(D);T&&this.b.get(T.uri)?.cancel()}if(v.controller.interruptHandler){const D=this.c.get(E.uri);L.length&&Array.isArray(D)&&D.length&&D.forEach(T=>T.dispose())}}async $provideVariables(d,S,L,v,E,D,T){const O=this.j.get(d);if(!O)return;const G=this.n.getNotebookDocument(f.URI.revive(L)),q=O.controller.variableProvider;if(!q)return;let z;if(v){if(z=this.s[v],!z)return}else this.s={};const C=E==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,N=q.provideVariables(G.apiNotebook,z,C,D,T);for await(const W of N){if(T.isCancellationRequested)return;const ae={id:this.r++,name:W.variable.name,value:W.variable.value,hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount};this.s[ae.id]=W.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(d,S,L){const v=this.j.get(d);if(!v)return;const E=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:L}))}$cellExecutionChanged(d,S,L){const E=this.n.getNotebookDocument(f.URI.revive(d)).getCell(S);if(E){const D=L?p.NotebookCellExecutionState.to(L):b.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:E.apiCell,state:D})}}_createNotebookCellExecution(d,S){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const E=new h(S,v,this.a);this.b.set(v.uri,E);const D=E.onDidChangeState(()=>{E.state===c.Resolved&&(E.dispose(),D.dispose(),this.b.delete(v.uri))});return E.asApiObject()}_createNotebookExecution(d,S){const L=this.n.getNotebookDocument(d.uri),v=d.getCells().find(T=>{const O=L.getCellFromApiCell(T);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const E=new u(S,L,this.a),D=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),D.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[E,D]),E.asApiObject()}};e.$Ohc=o,e.$Ohc=o=Je([He(4,R.$nj)],o);var c;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(c||(c={}));class h extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new A.$Vd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$6d),this.h=new i(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const S=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$Tv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let S=this.m;if(d&&(S=this.m.notebook.getCellFromApiCell(d)),!S)throw new Error("INVALID cell");return S.handle}y(d){return d.map(S=>{const L=b.$BM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(d,S,L){const v=this.w(S),E=this.y((0,y.$3b)(d));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:E})}async C(d,S,L){return d=b.$BM.ensureUniqueMimeTypes((0,y.$3b)(d),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(L){d.j=L,d.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(L){if(d.f===c.Resolved||d.f===c.Started)throw new Error("Cannot call start again");d.f=c.Started,d.c.fire(),d.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(d.f===c.Resolved)throw new Error("Cannot call resolve twice");d.f=c.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new n.$Tv({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return d.t(),d.z([],L,!1)},appendOutput(L,v){return d.t(),d.z(L,v,!0)},replaceOutput(L,v){return d.t(),d.z(L,v,!1)},appendOutputItems(L,v){return d.t(),d.C(L,v,!0)},replaceOutputItems(L,v){return d.t(),d.C(L,v,!1)}})}}var t;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(t||(t={}));class u extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,L){super(),this.h=S,this.j=L,this.b=u.a++,this.c=new A.$Vd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new I.$6d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(d,S){this.f=d,this.g=S,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$qh,this.b=Date.now(),(0,M.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>d.complete())}}function g($,d){return`${$.value}/${d}`}e.$Phc=g}),define(Pe[65],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,44,13,8,32]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,I.$6h)("IExtHostTerminalService");class o{constructor(v,E,D,T){this.l=v,this._id=E,this.m=D,this.n=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,q=!0){O.q(),O.l.$sendText(O._id,G,q)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??E?.cwd??void 0,env:v.env??void 0,icon:$(v.iconPath)??void 0,color:r.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.o(v.location,E?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,E,D,T,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:T,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:E?.location||this.o(v,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,E){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in v?{viewColumn:s.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,E){this.h=Object.freeze({code:v,reason:E})}setDimensions(v,E){return v===this.d&&E===this.g||v===0||E===0?!1:(this.d=v,this.g=E,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(E=>{E!==v&&(this.b=Promise.resolve(v))})}}e.$2gc=o;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new y.$Vd,this.onProcessData=this.a.event,this.b=new y.$Vd,this.d=new y.$Vd,this.onDidChangeProperty=this.d.event,this.f=new y.$Vd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,E){this.g.setDimensions?.({columns:v,rows:E})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Vd,this.onDidChangeShell=this.N.event,this.O=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(M.$0K.MainThreadTerminalService),this.y=new b.$Prb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:T=>{const O=G=>{const q=G;return this.W(q.instanceId)?.value};switch(T?.$mid){case 15:return O(T);default:{if(Array.isArray(T))for(let G=0;G<T.length&&T[G].$mid===15;G++)T[G]=O(T[G]);return T}}}}),this.B({dispose:()=>{for(const[T,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,E){const D=new o(this.a,(0,p.$qg)(),v,v.name),T=new c(v.pty);return D.createExtensionTerminal(v.location,E,this.R(v,E).resolvedExtHostIdentifier,$(v.iconPath),d(v.color)).then(O=>{const G=this.S(O,T);this.h[O]=G}),this.f.push(D),D.value}R(v,E){if(E=E||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const D=v.location.parentTerminal;if(D){const T=this.f.find(O=>O.value===D);T&&(E.resolvedExtHostIdentifier=T._id)}}else v.location&&typeof v.location!="object"?E.location=v.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(v,E){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const T=new c(E),O=this.S(v,T);this.h[v]=O}async $acceptActiveTerminalChanged(v){const E=this.b;if(v===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.W(v);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,E){const D=this.W(v);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(v,E,D){const T=this.W(v);T&&T.setDimensions(E,D)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(v,E){const D=this.W(v);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(v,E,D){this.g.get(v)?.resize(E,D)}async $acceptTerminalTitleChange(v,E){const D=this.W(v);D&&(D.name=E)}async $acceptTerminalClosed(v,E,D){const T=this.Y(this.f,v);if(T!==null){const O=this.f.splice(T,1)[0];O.setExitStatus(E,D),this.H.fire(O.value)}}$acceptTerminalOpened(v,E,D,T){if(E){const q=this.Y(this.f,E);if(q!==null){this.f[q]._id=v,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const O={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},G=new o(this.a,v,O,D);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(v,E){this.W(v)?._setProcessId(E)}async $startExtensionTerminal(v,E){const D=this.W(v);if(!D)return{message:(0,w.localize)(0,null,v)};D.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async q=>{q===D.value&&(G.dispose(),O())})});const T=this.g.get(v);T?T.startSendingEvents(E):this.j[v]={initialDimensions:E}}S(v,E){const D=new m.$Sc;D.add(E.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),D.add(E.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,E.onProcessData),D.add(E.onProcessExit(O=>this.U(v,O))),this.g.set(v,E);const T=this.j[v];return T&&E instanceof c&&(E.startSendingEvents(T.initialDimensions),delete this.j[v]),D}$acceptProcessAckDataEvent(v,E){this.g.get(v)?.acknowledgeDataEvent(E)}$acceptProcessInput(v,E){this.g.get(v)?.input(E)}$acceptTerminalInteraction(v){const E=this.W(v);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(v,E){this.W(v)?.setSelection(E)}$acceptProcessResize(v,E,D){try{this.g.get(v)?.resize(E,D)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(v,E){this.g.get(v)?.shutdown(E)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(E=>this.a.$sendProcessProperty(v,{type:"cwd",value:E}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new f.$_K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,v.identifier.value),new f.$_K(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(v,E,D){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,D),this.a.$registerQuickFixProvider(v,E),new f.$_K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,E){const D=new l.$6d().token;if(D.isCancellationRequested)return;const T=this.D.get(v);if(!T)return;const O=await T.provideTerminalQuickFixes(E,D);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new m.$Sc;if(this.w.value=G,!Array.isArray(O))return O?s.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const q=[];for(const z of O){const C=s.TerminalQuickFix.from(z,this.Q.converter,G);C&&q.push(C)}return q}async $createContributedProfileTerminal(v,E){const D=new l.$6d().token;let T=await this.C.get(v)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,E);return}this.createTerminalFromOptions(T.options,E)}}async $provideLinks(v,E){const D=this.W(v);if(!D)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$6d;this.G.set(v,O);const G=[],q={terminal:D.value,line:E},z=[];for(const W of this.z)z.push(a.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:W,links:[]}));const de=await W.provideTerminalLinks(q,O.token)||[];O.token.isCancellationRequested||ae({provider:W,links:de})}));const C=await Promise.all(z);if(O.token.isCancellationRequested)return[];const N=new Map;for(const W of C)W&&W.links.length>0&&G.push(...W.links.map(ae=>{const de={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return N.set(de.id,{provider:W.provider,link:ae}),de}));return this.F.set(v,N),G}$activateLink(v,E){const D=this.F.get(v)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(v,E){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const D=this.h[v];D&&(D.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,E)}W(v){return this.X(this.f,v)}X(v,E){const D=this.Y(v,E);return D!==null?v[D]:null}Y(v,E){const D=v.findIndex(T=>T._id===E);return D===-1?null:D}getEnvironmentVariableCollection(v){let E=this.n.get(v.identifier.value);return E||(E=new u,this.$(v.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Z(v,E){const D=(0,k.$Mr)(E.map),T=(0,k.$Nr)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(v,E.persistent,D.length===0?void 0:D,T)}$initEnvironmentVariableCollections(v){v.forEach(E=>{const D=E[0],T=new u(E[1]);this.$(D,T)})}$acceptDefaultProfile(v,E){const D=this.s;this.s=v,this.u=E,D?.path!==v.path&&this.N.fire(v.path)}$(v,E){this.n.set(v,E),E.onDidChangeCollection(()=>{this.Z(v,E)})}};e.$3gc=t,e.$3gc=t=Je([He(1,n.$xN),He(2,P.$bN)],t);class u{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Vd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const E=this.h(v);let D=this.a.get(E);return D||(D=new i(this,v),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(v,E,D,T){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:T})}append(v,E,D,T){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:T})}prepend(v,E,D,T){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:T})}f(v,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(v,E.scope),T=this.map.get(D),O=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==E.value||T.type!==E.type||T.options?.applyAtProcessCreation!==O.applyAtProcessCreation||T.options?.applyAtShellIntegration!==O.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const G=this.g(v,E.scope),q={variable:v,...E,options:O};this.map.set(G,q),this.d.fire()}}get(v,E){const D=this.g(v,E),T=this.map.get(D);return T?S(T):void 0}g(v,E){const D=this.h(E);return D.length?`${v}:::${D}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const E=new Map;for(const[D,T]of this.map)this.h(T.scope)===this.h(v)&&E.set(T.variable,S(T));return E}delete(v,E){const D=this.g(v,E);this.map.delete(D),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(E);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,E){const D=this.h(E),T=this.descriptionMap.get(D);if(!T||T.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const G={description:O,scope:E};this.descriptionMap.set(D,G),this.d.fire()}}getDescription(v){const E=this.h(v);return this.descriptionMap.get(E)?.description}k(v){const E=this.h(v);this.descriptionMap.delete(E)}}class i{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,E){this.b=v,this.d=E,this.a=new y.$Vd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,E,D){this.b.replace(v,E,D,this.d)}append(v,E,D){this.b.append(v,E,D,this.d)}prepend(v,E,D){this.b.prepend(v,E,D,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,E){this.b.getVariableMap(this.d).forEach((D,T)=>v.call(E,T,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor(v,E){super(!1,v,E)}createTerminal(v,E,D){throw new R.$_}createTerminalFromOptions(v,E){throw new R.$_}};e.$4gc=g,e.$4gc=g=Je([He(0,n.$xN),He(1,P.$bN)],g);function $(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function d(L){return r.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[272],Re([1,0,13,22,20,5,242,98,6,26,16,33,14,3,17,110,8,7,48,76,59,24]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0;let t=class extends f.$Tc{constructor(z,C,N,W){super(),this.w=W,this.f=this.B(new A.$Vd),this.g=new Map,this.s=this.B(new A.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=z.getProxy(p.$0K.MainThreadTesting),this.m=new D(this.h),this.j=new $(this.h,C),N.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case 16:{const de=ae,we=de.tests[de.tests.length-1].item.extId;return this.g.get(n.$2J.root(we))?.collection.tree.get(we)?.actual??(0,r.$nN)(ae)}case 18:{const{extId:de,message:we}=ae;return{test:this.g.get(n.$2J.root(de))?.collection.tree.get(de)?.actual,message:a.TestMessage.to(we)}}default:return ae}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await N.executeCommand("_testing.getExplorerSelection"),de=we=>{const ye=this.g.get(n.$2J.root(we));if(ye)return n.$2J.isRoot(we)?ye.controller:ye.collection.tree.get(we)?.actual};return{include:ae?.include.map(de).filter(R.$Qf)||[],exclude:ae?.exclude.map(de).filter(R.$Qf)||[]}})}createTestController(z,C,N,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const ae=new f.$Sc,de=ae.add(new r.$qN(C,N,this.w));de.root.label=N;const we=new Map,ye=new Set,le=this.h,$e={items:de.root.children,get label(){return N},set label(be){N=be,de.root.label=be,le.$updateController(C,{label:N})},get refreshHandler(){return W},set refreshHandler(be){W=be,le.$updateController(C,{canRefresh:!!be})},get id(){return C},createRunProfile:(be,se,Z,V,ne,Ie)=>{let Le=(0,m.$Ti)(be);for(;we.has(Le);)Le++;return new O(this.h,we,z,ye,this.s.event,C,Le,be,se,Z,V,ne,Ie)},createTestItem(be,se,Z){return new r.$oN(C,be,se,Z)},createTestRun:(be,se,Z=!0)=>this.j.createTestRun(z,C,de,be,se,Z),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const se=be instanceof Array?be:[be];this.h.$markTestRetired(se.map(Z=>n.$2J.fromExtHostTestItem(Z,C).toString()))}},set resolveHandler(be){de.resolveHandler=be},get resolveHandler(){return de.resolveHandler},dispose:()=>{ae.dispose()}};le.$registerTestController(C,N,!!W),ae.add((0,f.$Rc)(()=>le.$unregisterTestController(C)));const ie={controller:$e,collection:de,profiles:we,extension:z,activeProfiles:ye};return this.g.set(C,ie),ae.add((0,f.$Rc)(()=>this.g.delete(C))),ae.add(de.onDidGenerateDiff(be=>le.$publishDiff(C,be.map(c.TestsDiffOp.serialize)))),$e}createTestObserver(){return this.m.checkout()}async runTests(z,C=I.CancellationToken.None){const N=d(z);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(N.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(ae=>n.$2J.fromExtHostTestItem(ae,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:G[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:z.exclude?.map(ae=>ae.id)},C)}$syncTests(){for(const{collection:z}of this.g.values())z.flushDiff();return Promise.resolve()}async $provideFileCoverage(z,C,N){return await this.j.getCoverageReport(z,C)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(z,C,N,W){return await this.j.getCoverageReport(z,C)?.resolveFileCoverage(N,W)??[]}$configureRunProfile(z,C){this.g.get(z)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(z){const C=new Map;for(const[N,W]of Object.entries(z)){const ae=this.g.get(N);if(!ae)continue;const de=new Map,we=W.filter(le=>!ae.activeProfiles.has(le)),ye=[...ae.activeProfiles].filter(le=>!W.includes(le));for(const le of we)de.set(le,!0),ae.activeProfiles.add(le);for(const le of ye)de.set(le,!1),ae.activeProfiles.delete(le);de.size&&C.set(N,de)}this.s.fire(C)}async $refreshTests(z,C){await this.g.get(z)?.controller.refreshHandler?.(C)}$publishTestResults(z){this.results=Object.freeze(z.map(C=>(0,w.$wn)(a.TestResults.to(C))).concat(this.results).sort((C,N)=>N.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(z,C){const N=this.g.get(n.$2J.fromString(z).controllerId)?.collection;N&&(await N.expand(z,C<0?1/0:C),N.flushDiff())}$acceptDiff(z){this.m.applyDiff(z.map(C=>c.TestsDiffOp.deserialize({asCanonicalUri:N=>N},C)))}async $runControllerTests(z,C){return Promise.all(z.map(N=>this.y(N,!1,C)))}async $startContinuousRun(z,C){const N=new I.$6d(C),W=await Promise.all(z.map(ae=>this.y(ae,!0,N.token)));return!C.isCancellationRequested&&!W.some(ae=>ae.error)&&await new Promise(ae=>C.onCancellationRequested(ae)),N.dispose(!0),W}async y(z,C,N){const W=this.g.get(z.controllerId);if(!W)return{};const{collection:ae,profiles:de,extension:we}=W,ye=de.get(z.profileId);if(!ye)return{};const le=z.testIds.map(se=>ae.tree.get(se)).filter(R.$Qf),$e=z.excludeExtIds.map(se=>W.collection.tree.get(se)).filter(R.$Qf).filter(se=>le.some(Z=>Z.fullId.compare(se.fullId)===2));if(!le.length)return{};const ie=new s.$IM(le.some(se=>se.actual instanceof r.$pN)?void 0:le.map(se=>se.actual),$e.map(se=>se.actual),ye,C),be=(0,c.$4J)(z)&&this.j.prepareForMainThreadTestRun(ie,S.fromInternal(z,W.collection),we,N);try{return await ye.runHandler(ie,N),{}}catch(se){return{error:String(se)}}finally{be&&(be.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(z)}};e.$7hc=t,e.$7hc=t=Je([He(0,b.$bN),He(1,l.$nj)],t);const u=1e4;var i;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(i||(i={}));class g extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(z,C,N,W,ae){super(),this.s=z,this.w=C,this.y=N,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Vd),this.m=this.B(new A.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$6d(ae));const de=this.B(new y.$fh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>de.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(z){const C=this.s.id,N=this.s.controllerId,W=(0,k.$qg)(),ae=this.y,de=this.m;let we;const ye=be=>(se,...Z)=>{if($e){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),be(se,...Z))},le=(be,se)=>{const Z=se instanceof Array?se.map(a.TestMessage.from):[a.TestMessage.from(se)];if(be.uri&&be.range){const V={range:a.Range.from(be.range),uri:be.uri};for(const ne of Z)ne.location=ne.location||V}this.w.$appendTestMessagesInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),Z)};let $e=!1;const ie={isPersisted:this.s.isPersisted,token:this.h.token,name:z,get coverageProvider(){return we?.provider},set coverageProvider(be){(0,h.$CF)(ae,"testCoverage"),we=be&&new L(be),de.fire({taskId:W,runId:C,coverage:we})},enqueued:ye(be=>{this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),1)}),skipped:ye(be=>{this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),5)}),started:ye(be=>{this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),2)}),errored:ye((be,se,Z)=>{le(be,se),this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),6,Z)}),failed:ye((be,se,Z)=>{le(be,se),this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,N).toString(),4,Z)}),passed:ye((be,se)=>{this.w.$updateTestStateInRun(C,W,n.$2J.fromExtHostTestItem(be,this.s.controllerId).toString(),3,se)}),appendOutput:(be,se,Z)=>{$e||(Z&&(this.s.isIncluded(Z)?this.F(Z):Z=void 0),this.w.$appendOutputToRun(C,W,M.$je.fromString(be),se&&a.location.from(se),Z&&n.$2J.fromExtHostTestItem(Z,N).toString()))},end:()=>{$e||($e=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:ie}),this.w.$startedTestRunTask(C,{id:W,name:z,running:!0}),ie}C(){for(const{run:z}of this.f.values())z.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(z){if(!(z instanceof r.$oN))throw new o.$6M(z.id);if(this.g.has(n.$2J.fromExtHostTestItem(z,this.s.controllerId).toString()))return;const C=[],N=this.s.colllection.root;for(;;){const W=a.TestItem.from(z);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),z===N))break;z=z.parent||N}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class ${get trackers(){return this.c.values()}constructor(z,C){this.g=z,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(z,C){return this.f.find(N=>N.runId===z)?.coverage.get(C)}prepareForMainThreadTestRun(z,C,N,W){return this.j(z,C,N,W)}cancelRunById(z){for(const C of this.c.values())if(C.id===z){C.cancel();return}}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,C,N,W,ae,de){const we=this.c.get(W);if(we)return we.createRun(ae);const ye=S.fromPublic(C,N,W,de),le=d(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:le&&{group:G[le.kind],id:le.profileId},exclude:W.exclude?.map(ie=>n.$2J.fromExtHostTestItem(ie,N.root.id).toString())??[],id:ye.id,include:W.include?.map(ie=>n.$2J.fromExtHostTestItem(ie,N.root.id).toString())??[N.root.id],persist:de});const $e=this.j(W,ye,z);return A.Event.once($e.onEnd)(()=>{this.g.$finishedExtensionTestRun(ye.id),$e.dispose()}),$e.createRun(ae)}j(z,C,N,W){const ae=new g(C,this.g,N,this.h,W);this.c.set(z,ae);let de;const we=ae.onDidCoverage(({runId:ye,taskId:le,coverage:$e})=>{de||(de={runId:ye,coverage:new Map},this.f.unshift(de),this.f.length>c.$9J&&this.f.pop()),de.coverage.set(le,$e),this.g.$signalCoverageAvailable(ye,le,!!$e)});return A.Event.once(ae.onEnd)(()=>{this.c.delete(z),we.dispose()}),ae}}e.$8hc=$;const d=q=>{if(q.profile){if(!(q.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class S{static fromPublic(z,C,N,W){return new S(z,(0,k.$qg)(),N.include?.map(ae=>n.$2J.fromExtHostTestItem(ae,z).toString())??[z],N.exclude?.map(ae=>n.$2J.fromExtHostTestItem(ae,z).toString())??[],W,C)}static fromInternal(z,C){return new S(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,C)}constructor(z,C,N,W,ae,de){this.controllerId=z,this.id=C,this.isPersisted=ae,this.colllection=de,this.c=N.map(we=>we+"\0"),this.f=W.map(we=>we+"\0")}isIncluded(z){const C=n.$2J.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const N of this.f)if(C===N||C.startsWith(N))return!1;for(const N of this.c)if(C===N||C.startsWith(N))return!0;return!1}}e.$9hc=S;class L{constructor(z){this.provider=z}async provideFileCoverage(z){this.c||(this.c=(async()=>this.provider.provideFileCoverage(z))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(z,C){const N=await this.c;let W=N?.[z];return!this.provider||!N||!W?[]:(W.detailedCoverage||(W=N[z]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,a.TestItem.toPlain(z.item)),this.c.has(z)||this.f.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.f.delete(z);const C=n.$2J.parentId(z.item.extId);if(C&&this.h.has(C.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{c:z,f:C,g:N}=this;return{get added(){return[...z].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...N].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class E extends c.$0J{constructor(){super(...arguments),this.s=new A.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}w(z,C){return{...z,revived:a.TestItem.toPlain(z.item),depth:C?C.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(z){this.f=z}checkout(){this.c||(this.c=this.g());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(C=>C.revived)},dispose:(0,P.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}g(){const z=new E({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}const T=(q,z,C,N)=>{C?Object.assign(C,N):z.$updateTestRunConfig(q.controllerId,q.profileId,N)};class O{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,T(this,this.#e,this.#n,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,T(this,this.#e,this.#n,{supportsContinuousRun:z}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(z){z!==this.isDefault&&(z?this.#i.add(this.profileId):this.#i.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,T(this,this.#e,this.#n,{tag:z?a.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,T(this,this.#e,this.#n,{hasConfigurationHandler:!!z}))}get onDidChangeDefault(){return(0,h.$CF)(this.#t,"testingActiveProfile"),A.Event.chain(this.#o,z=>z.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(R.$Qf))}constructor(z,C,N,W,ae,de,we,ye,le,$e,ie=!1,be=void 0,se=!1){this.controllerId=de,this.profileId=we,this.f=ye,this.kind=le,this.runHandler=$e,this._tag=be,this.g=se,this.#e=z,this.#r=C,this.#t=N,this.#i=W,this.#o=ae,C.set(we,this);const Z=G[le];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${le}`);ie&&W.add(we),this.#n={profileId:we,controllerId:de,tag:be?a.TestTag.namespace(this.controllerId,be.id):null,label:ye,group:Z,isDefault:ie,hasConfigurationHandler:!1,supportsContinuousRun:se},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$0hc=O;const G={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Pe[111],Re([1,0,54,15,89,8,7]),function(ge,e,y,M,I,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;class m{static{this.c=new I.$gN("TextEditorDecorationType")}constructor(l,p,b){const r=m.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,A.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$iN=m;class f{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof P.$aL)b=new P.$bL(l,l);else if(l instanceof P.$bL)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new P.$bL(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof P.$bL)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class w{constructor(l,p,b,r){this.c=l,this.d=p,this._accept(b),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(s){a.n(s)},get indentSize(){return a.g},set indentSize(s){a.p(s)},get insertSpaces(){return a.j},set insertSpaces(s){a.s(s)},get cursorStyle(){return a.k},set cursorStyle(s){a.t(s)},get lineNumbers(){return a.l},set lineNumbers(s){a.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(b=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,b=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(b=!0,p.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,b=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(b=!0,p.insertSpaces=r):this.j!==r&&(this.j=r,b=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,b=!0,p.lineNumbers=A.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$jN=w;class R{constructor(l,p,b,r,a,s,n,o){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=a,this.d=new w(this.j,this.id,s,b),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof P.$cL))throw(0,M.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof P.$cL)))throw(0,M.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new M.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new f(r.value,t);return h(u),c.m(u)},insertSnippet(h,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=c.c.map(g=>A.Range.from(g));else if(t instanceof P.$aL){const{lineNumber:g,column:$}=A.Position.from(t);i=[{startLineNumber:g,startColumn:$,endLineNumber:g,endColumn:$}]}else if(t instanceof P.$bL)i=[A.Range.from(t)];else{i=[];for(const g of t)if(g instanceof P.$bL)i.push(A.Range.from(g));else{const{lineNumber:$,column:d}=A.Position.from(g);i.push({startLineNumber:$,startColumn:d,endLineNumber:$,endColumn:d})}}return p.$tryInsertSnippet(l,r.value.version,h.value,i,u)},setDecorations(h,t){const u=t.length===0;u&&!c.h.has(h.key)||(u?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(A.$$M(t))return p.$trySetDecorations(l,h.key,A.$_M(t));{const i=new Array(4*t.length);for(let g=0,$=t.length;g<$;g++){const d=t[g];i[4*g]=d.start.line+1,i[4*g+1]=d.start.character+1,i[4*g+2]=d.end.line+1,i[4*g+3]=d.end.character+1}return p.$trySetDecorationsFast(l,h.key,i)}}))},revealRange(h,t){c.n(()=>p.$tryRevealRange(l,A.Range.from(h),t||P.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,A.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,y.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,y.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,y.ok)(!this.g),this.f=l}_acceptSelections(l){(0,y.ok)(!this.g),this.c=l}async l(){const l=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(a=>a.range);b.sort((a,s)=>a.end.line===s.end.line?a.end.character===s.end.character?a.start.line===s.start.line?a.start.character-s.start.character:a.start.line-s.start.line:a.end.character-s.end.character:a.end.line-s.end.line);for(let a=0,s=b.length-1;a<s;a++){const n=b[a].end;if(b[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(a=>({range:A.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?A.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$kN=R}),define(Pe[66],Re([1,0,54,5,6,2,4,3,108,17,111,8,14,28,11,68,39]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new M.$Vd,this.e=new M.$Vd,this.f=new M.$Vd,this.g=new M.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],u=[];if(c.removedDocuments)for(const i of c.removedDocuments){const g=A.URI.revive(i),$=this.c.get(g);$?.unref()&&(this.c.delete(g),h.push($.value))}if(c.addedDocuments)for(const i of c.addedDocuments){const g=A.URI.revive(i.uri);let $=this.c.get(g);if($&&g.scheme!==b.Schemas.vscodeNotebookCell&&g.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);$||($=new s(new f.$eN(this.h.getProxy(m.$0K.MainThreadDocuments),g,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(g,$),t.push($.value)),$.ref()}if(c.removedEditors)for(const i of c.removedEditors){const g=this.b.get(i);this.b.delete(i),g&&u.push(g)}if(c.addedEditors)for(const i of c.addedEditors){const g=A.URI.revive(i.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const $=this.c.get(g).value,d=new R.$kN(i.id,this.h.getProxy(m.$0K.MainThreadTextEditors),this.i,new a.$V(()=>$.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(S=>k.Range.to(S)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,d)}c.newActiveEditor!==void 0&&(y.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Oc)(h),(0,I.$Oc)(u),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$lN=n,e.$lN=n=Je([He(0,w.$bN),He(1,l.$nj)],n),e.$mN=(0,P.$6h)("IExtHostDocumentsAndEditors")}),define(Pe[273],Re([1,0,18,5,3,111,8,7]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class f{constructor(R,k){this.i=k,this.a=new M.$Vd,this.b=new M.$Vd,this.c=new M.$Vd,this.d=new M.$Vd,this.f=new M.$Vd,this.g=new M.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(I.$0K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const k=this.i.allEditors();return R?k:k.map(l=>l.value)}async showTextDocument(R,k,l){let p;typeof k=="number"?p={position:P.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?p={position:P.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?P.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:p={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(R.uri,p),r=b&&this.i.getEditor(b);if(r)return r.value;throw b?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new A.$iN(this.h,R,k).value}$acceptEditorPropertiesChanged(R,k){const l=this.i.getEditor(R);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const p=k.selections.selections.map(P.Selection.to);l._acceptSelections(p)}if(k.visibleRanges){const p=y.$Hb(k.visibleRanges.map(P.Range.to));l._acceptVisibleRanges(p)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:P.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const p=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),b=k.selections.selections.map(P.Selection.to);this.a.fire({textEditor:l.value,selections:b,kind:p})}if(k.visibleRanges){const p=y.$Hb(k.visibleRanges.map(P.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(R){for(const k in R){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const p=P.ViewColumn.to(R[k]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$tgc=f}),define(Pe[274],Re([1,0,2,4,3,6,7,8,23,16]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0,e.$_hc=(0,M.$6h)("IExtHostTimeline");class R{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$0K.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(r,a)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&f.$lm.equals(a,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:y.URI.revive(r.uri);return this.c.get(r.source)?.get(k(s))?.get(r.handle)}else return;return r}})}async $getTimeline(p,b,r,a){return this.b.get(p)?.provider.provideTimeline(y.URI.revive(b),r,a)}registerTimelineProvider(p,b,r,a){const s=new A.$Sc,n=this.d(b.id,a,s).bind(this);let o;b.onDidChange&&(o=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(h,t,u){t?.resetCache&&(s.clear(),c.get(b.id)?.clear());const i=await b.provideTimeline(h,t,u);if(i==null)return;const g=n(h,t);return{...i,source:b.id,items:i.items.map(g)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();o?.dispose(),s.dispose()}},r)}d(p,b,r){return(a,s)=>{let n;if(s?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const c=k(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,t=`${p}|${o.id??o.timestamp}`;n?.set(t,o);let u,i,g;o.iconPath&&(c instanceof P.$7L?g={id:c.id,color:c.color}:y.URI.isUri(c)?(u=c,i=c):{light:u,dark:i}=c);let $;return P.$AL.isMarkdownString(h.tooltip)?$=m.MarkdownString.from(h.tooltip):(0,w.$If)(h.tooltip)?$=h.tooltip:P.$AL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=m.MarkdownString.from(h.detail)):(0,w.$If)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=h.detail),{...h,id:h.id??void 0,handle:t,source:p,command:o.command?b.toInternal(o.command,r):void 0,icon:u,iconDark:i,themeIcon:g,tooltip:$,accessibilityInformation:o.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,A.$Rc)(()=>{for(const a of this.c.values())a.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$aic=R;function k(l){return l?.toString()}}),define(Pe[275],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,24]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;function s(c,h){if((0,R.$If)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends P.$Tc{constructor(h,t,u){super(),this.f=h,this.g=t,this.h=u,this.a=new Map,this.b=new r.$n8;function i(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>i(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map($=>i($)?this.r($):$):g})}registerTreeDataProvider(h,t,u){const i=this.createTreeView(h,{treeDataProvider:t},u);return{dispose:()=>i.dispose()}}createTreeView(h,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,S=this.m(h,t,u),L={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:i,dragMimeTypes:g,hasHandleDrag:$,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,L),E={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,a.$CF)(u,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,a.$CF)(u,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,p.$jk)(D)&&(0,a.$CF)(u,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,T)=>S.reveal(D,T),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(E),E}$getChildren(h,t){const u=this.a.get(h);return u?u.getChildren(t):Promise.reject(new m.$aF(h))}async $handleDrop(h,t,u,i,g,$,d,S){const L=this.a.get(h);if(!L)return Promise.reject(new m.$aF(h));const v=l.DataTransfer.toDataTransfer(u,async E=>(await this.f.$resolveDropFileData(h,t,E)).buffer);return d===h&&S&&await this.j(v,L,S,g,$),L.onDrop(v,i,g)}async j(h,t,u,i,g){const $=this.b.removeDragOperationTransfer(g);if($)(await $)?.forEach((d,S)=>{d&&h.set(S,d)});else if(g&&t.handleDrag){const d=t.handleDrag(u,h,i);this.b.addDragOperationTransfer(g,d),await d}return h}async $handleDrag(h,t,u,i){const g=this.a.get(h);if(!g)return Promise.reject(new m.$aF(h));const $=await this.j(new w.$4L,g,t,i,u);if(!(!$||i.isCancellationRequested))return l.DataTransfer.from($)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$aF(h);return t.hasResolve}$resolve(h,t,u){const i=this.a.get(h);if(!i)throw new m.$aF(h);return i.resolveTreeItem(t,u)}$setExpanded(h,t,u){const i=this.a.get(h);if(!i)throw new m.$aF(h);i.setExpanded(t,u)}$setSelectionAndFocus(h,t,u){const i=this.a.get(h);if(!i)throw new m.$aF(h);i.setSelectionAndFocus(t,u)}$setVisible(h,t){const u=this.a.get(h);if(!u){if(!t)return;throw new m.$aF(h)}u.setVisible(t)}$changeCheckboxState(h,t){const u=this.a.get(h);if(!u)throw new m.$aF(h);u.setCheckboxState(t)}m(h,t,u){const i=this.B(new o(h,t,this.f,this.g.converter,this.h,u));return this.a.set(h,i),i}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$bic=n;class o extends P.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Rf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,u,i,g,$){if(super(),this.I=h,this.J=u,this.L=i,this.M=g,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$6d,$.contributes&&$.contributes.views)for(const v in $.contributes.views)for(const E of $.contributes.views[v])E.id===h&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let d,S;const L=A.Event.debounce(this.F.event,(v,E)=>(v||(v={message:!1,elements:[]}),E.element!==!1&&(d||(d=new Promise(D=>S=D),this.G=this.G.then(()=>d)),Array.isArray(E.element)?v.elements.push(...E.element):v.elements.push(E.element)),E.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=S;return d=null,this.$(E).then(()=>D())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let u=this.X(h);return u||(u=await this.Y(t)),u?u.map(i=>i.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const u=(0,R.$Rf)(t.select)?!0:t.select,i=(0,R.$Rf)(t.focus)?!1:t.focus,g=(0,R.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then($=>this.W(h,$[$.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:$.map(S=>S.item)},{select:u,focus:i,expand:g})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:u,focus:i,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const u=this.getExtensionElement(h);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(h,t){const u=!(0,k.$ub)(this.s,h);this.s=h;const i=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async u=>{const i=this.getExtensionElement(u.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:u.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(h,t,u){const i=[];for(const g of h){const $=this.getExtensionElement(g);$&&i.push($)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,u){const i=t?this.getExtensionElement(t):void 0;if(!(!i&&t||!this.g?.handleDrop))return(0,f.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(i,h,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(h);if(u){const i=this.m.get(u);if(i){const g=await this.f.resolveTreeItem(i.extensionItem,u,t)??i.extensionItem;return this.hb(g),i.item.tooltip=this.eb(g.tooltip),i.item.command=this.fb(i.disposableStore,g.command),i.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(i=>(u.push(i),u))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$Yg)(()=>this.f.getParent(h))}W(h,t){const u=this.m.get(h);return u?Promise.resolve(u):(0,f.$Yg)(()=>this.f.getTreeItem(h)).then(i=>this.kb(h,i,t,!0)).then(i=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const $=this.m.get(g);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const u=this.getExtensionElement(h);t=u?this.m.get(u):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new b.$6d(this.Z.token);try{const u=h?this.m.get(h):void 0,i=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const g=(0,k.$Hb)(i||[]),$=await Promise.all((0,k.$Hb)(g).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const d=$.map((S,L)=>S?this.db(g[L],S,u):null);return(0,k.$Hb)(d)}finally{t.dispose()}}$(h){if(h.some(u=>!u))return this.Z.dispose(!0),this.Z=new b.$6d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(h);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(h){const t=new Set,u=h.map(g=>this.m.get(g));for(const g of u)if(g&&!t.has(g.item.handle)){let $=g;for(;$&&$.parent&&u.findIndex(d=>$&&$.parent&&d&&d.item.handle===$.parent.item.handle)===-1;){const d=this.j.get($.parent.item.handle);$=d?this.m.get(d):void 0}$&&!$.parent&&t.add(g.item.handle)}const i=[];return t.forEach(g=>{const $=this.j.get(g);if($){const d=this.m.get($);d&&(!d.parent||!t.has(d.parent.item.handle))&&i.push(g)}}),i}bb(h){const t={};return Promise.all(h.map(u=>this.cb(u).then(i=>{i&&(t[u]=i.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,f.$Yg)(()=>this.f.getTreeItem(t)).then(i=>{if(i){const g=this.ib(t,i,u.parent);return this.pb(t,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}db(h,t,u){const i=this.ib(h,t,u);if(t.id&&this.j.has(i.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(h,i),this.qb(i,u),i}eb(h){return w.$AL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,u,i;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,u=h.checkboxState.tooltip,i=h.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:i}}hb(h){if(!w.$YL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,u){this.hb(t);const i=this.B(new P.$Sc),g=this.kb(h,t,u),$=this.lb(t);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(i,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,R.$Rf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(h){return h.iconPath instanceof w.$7L?h.iconPath:void 0}kb(h,{id:t,label:u,resourceUri:i},g,$){if(t)return`${o.b}/${t}`;const d=s(u,this.N),S=g?g.item.handle:o.a;let L=d?d.label:i?(0,M.$Eg)(i):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,E=this.X(g)||[];let D,T=0;do{if(D=`${S}/${T}:${L}`,$||!this.j.has(D)||v===D)break;T++}while(T<=E.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$7L))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$7L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,u,i){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(h,t);const g=this.X(i)||[],$=g.filter(d=>d.item.handle===u.item.handle)[0];$&&g.splice(g.indexOf($),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const u of t.children){const i=this.j.get(u.item.handle);i&&this.sb(i)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const u of t.children){const i=this.j.get(u.item.handle);i&&this.sb(i)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[276],Re([1,0,5,6,2,33,8,61,3,7]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class R extends M.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(b,r,a,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=r,this.#o=a,this.#i=s.viewType,this.#n=s.panelOptions,this.#s=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:P.ViewColumn.from(b),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends M.$Tc{static c(){return(0,A.$qg)()}constructor(b,r,a){super(),this.j=r,this.m=a,this.g=new Map,this.h=new Map,this.f=b.getProxy(f.$0K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,r,a,s,n={}){const o=typeof s=="object"?s.viewColumn:s,c={viewColumn:P.ViewColumn.from(o),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$Igc)(b),t=k.c();this.f.$createWebviewPanel((0,m.$Kgc)(b),t,r,{title:a,panelOptions:l(n),webviewOptions:(0,m.$Lgc)(b,this.m,n),serializeBuffersForPostMessage:h},c);const u=this.j.createNewWebview(t,n,b);return this.createNewWebviewPanel(t,r,a,o,n,u,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((a,s)=>{const n=b[a],o=b[s];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const a of r){const s=this.getWebviewPanel(a);if(!s)continue;const n=b[a];s._updateViewState({active:n.active,visible:n.visible,viewColumn:P.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,r,a){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:a,extension:b}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$Igc)(b)}),new w.$_K(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,a,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(b,a.webviewOptions,c),t=this.createNewWebviewPanel(b,r,a.title,s,a.panelOptions,h,a.active);await o.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(b,r,a,s,n,o,c){const h=new R(b,this.f,o,{viewType:r,title:a,viewColumn:s,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$Mgc=k;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[277],Re([1,0,5,6,61,8,3,7]),function(ge,e,y,M,I,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class f extends M.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(k,l,p,b,r,a){super(),this.#n=!1,this.#u=this.B(new y.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Vd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=k,this.#t=l,this.#o=r,this.#r=a}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#n||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#n)throw new Error("Webview is disposed")}}class w{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(P.$0K.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,I.$Kgc)(k),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Igc)(k)}),new m.$_K(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,p,b,r){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:n}=a,o=this.d.createNewWebview(k,{},n),c=new f(k,this.a,l,p,o,!0);this.c.set(k,c),await s.resolveWebviewView(c,{state:b},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$eic=w}),define(Pe[278],Re([1,0,5,30,35,4]),function(ge,e,y,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.OutputChannelUpdateMode=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=void 0,e.$iK="text/x-code-output",e.$jK="output",e.$kK="Log",e.$lK="text/x-code-log-output",e.$mK="log",e.$nK="workbench.panel.output",e.$oK=new I.$kj("inOutput",!1),e.$pK=new I.$kj("activeLogOutput",!1),e.$qK=new I.$kj("outputView.scrollLock",!1),e.$rK=(0,A.$6h)("outputService");var P;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$sK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new y.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}M.$Hn.add(e.$sK.OutputChannels,new m),e.$tK=new I.$kj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,23,14,278,62,27,42,136,22,16,41,5,6]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0;class s extends P.$tj{get disposed(){return this.n}constructor(h,t,u,i,g){super(),this.id=h,this.name=t,this.r=u,this.s=i,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$je.fromString(t).byteLength,(0,P.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let o=class{constructor(h,t,u,i,g,$){this.i=t,this.j=u,this.k=i,this.l=g,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(y.$0K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(h,t,u){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const i=typeof t=="object"&&t.log,g=(0,p.$If)(t)?t:void 0;if((0,p.$If)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const d=this.i.environment.extensionLogLevel?.find(([L])=>A.$lm.equals(u.identifier,L))?.[1];d&&($=(0,P.$Dj)(d));const S=i?this.o(h,$,u):this.n(h,g,u);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),i?this.r(h,$??this.m.getLevel(),S):this.q(h,S)}async n(h,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,g=this.k.extUri.joinPath(i,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(h,g,t,u.identifier.value);return new s(d,h,$,this.a,u)}async o(h,t,u){const i=await this.p(u),g=h.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(i,`${g}.log`),d=`${u.identifier.value}.${g}`,S=this.l.createLogger($,{id:d,name:h,logLevel:t,extensionId:u.identifier.value});return new n(d,h,S,this.a,u)}p(h){let t=this.d.get(h.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(i){if((0,b.$Gk)(i)!==b.FileSystemProviderErrorCode.FileExists)throw i}return u})())}return t}q(h,t){let u=!1;const i=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return h},append(g){i(),t.then($=>$.append(g))},appendLine(g){i(),t.then($=>$.appendLine(g))},clear(){i(),t.then(g=>g.clear())},replace(g){i(),t.then($=>$.replace(g))},show(g,$){i(),t.then(d=>d.show(g,$))},hide(){i(),t.then(g=>g.hide())},dispose(){u=!0,t.then(g=>g.dispose())}}}r(h,t,u){const i=new a.$Sc,g=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},$=i.add(new r.$Vd);function d(S){t=S,$.fire(S)}return u.then(S=>{i.add(S),S.logLevel!==t&&d(S.logLevel),i.add(S.onDidChangeLogLevel(L=>d(L)))}),{...this.q(h,u),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(S,...L){g(),u.then(v=>v.trace(S,...L))},debug(S,...L){g(),u.then(v=>v.debug(S,...L))},info(S,...L){g(),u.then(v=>v.info(S,...L))},warn(S,...L){g(),u.then(v=>v.warn(S,...L))},error(S,...L){g(),u.then(v=>v.error(S,...L))},dispose(){i.dispose()}}}};e.$Rhc=o,e.$Rhc=o=Je([He(0,I.$bN),He(1,w.$rN),He(2,f.$Egc),He(3,R.$egc),He(4,P.$oj),He(5,P.$nj)],o),e.$Shc=(0,M.$6h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,y.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let A=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await I.getRoundTripTime();if(f===void 0)return;A=Math.min(A,f/2),await(0,M.$7g)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(A):P=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:P,current:A,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:(()=>typeof P>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Re([1,0,169,55,30,47,46,6,5,113,21,26]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new f.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const p=new l;I.$Hn.add(e.$VH.ConfigurationMigration,p);let b=class extends m.$Tc{constructor(s,n){super(),this.a=s,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const n of this.b.getWorkspace().folders)await this.f(n,s)}async f(s,n){await Promise.all([n.map(o=>this.g(o,s?.uri))])}async g(s,n){const o=this.a.inspect(s.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,t]of c){const u=[];for(const g of o.overrideIdentifiers??[]){const $=await this.h(s,{resource:n,overrideIdentifier:g},h);for(const d of $??[]){let S=u.find(([[L,v]])=>L===d[0]&&(0,k.$zn)(v.value,d[1].value));S||u.push(S=[d,[]]),S[1].push(g)}}const i=await this.h(s,{resource:n},h,o);for(const g of i??[])u.push([g,[]]);u.length&&await Promise.allSettled(u.map(async([[g,$],d])=>this.a.updateValue(g,$.value,{resource:n,overrideIdentifiers:d},t)))}}async h(s,n,o,c){const h=g=>t(this.a.inspect(g,n)),t=g=>{const $=g[o];return n.overrideIdentifier?$?.override:$?.value},u=c?t(c):h(s.key);if(u===void 0)return;const i=await s.migrateFn(u,h);return Array.isArray(i)?i:[[s.key,i]]}};e.$WH=b,e.$WH=b=Je([He(0,P.$zi),He(1,A.$ci)],b);let r=class extends m.$Tc{constructor(s){super(),(async()=>{if(!R.$i&&(await s.getEnvironment())?.os!==1)return;I.$Hn.as(M.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(4,null)},default:[],markdownDescription:(0,y.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(6,null),scope:2}}})})()}};e.$XH=r,e.$XH=r=Je([He(0,w.$Lm)],r)}),define(Pe[280],Re([1,0,34,11,19,25,177,279,55,4,30]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$hdb=e.$gdb=void 0,e.$gdb=(0,w.$6h)("editorResolverService"),e.$hdb="workbench.editorAssociations";const k=R.$Hn.as(f.$Mn.Configuration),l={...m.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,P.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var p;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function r(s){switch(s){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$idb=r;function a(s,n){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(I.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$Eg)(n);return y.$Lj(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}e.$jdb=a}),define(Pe[281],Re([1,0,45,11,19,21,25,2,4,198,47,215,113]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=void 0,e.$LK=(0,f.$6h)("pathService");let b=p=class{constructor(a,s,n,o){this.d=a,this.e=s,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(a,o,s)):this.h(a,s,n)}h(a,s,n){return a.scheme===M.Schemas.file||a.scheme===M.Schemas.vscodeRemote?(0,y.$6f)(n??(0,P.$Eg)(a),s===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,s){if(a.remoteAuthority)return M.Schemas.vscodeRemote;const n=(0,w.$IK)(s.getWorkspace());if(n)return n;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?I.$fc:I.$gc)}async fileURI(a){let s="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(s=a.substring(2),a="/"):(s=a.substring(2,o),a=a.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:a,query:"",fragment:""})}};e.$MK=b,e.$MK=b=p=Je([He(1,l.$Lm),He(2,k.$uK),He(3,R.$ci)],b)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oJ=e.$nJ=void 0;class y{constructor(P,m){this.line=P,this.character=m}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,m){return new y(0,0)}with(P){return new y(0,0)}}e.$nJ=y;class M{constructor(P,m,f,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(P,m),this.end=new y(f,w)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new M(0,0,0,0)}with(P){return new M(0,0,0,0)}}e.$oJ=M;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[43],Re([1,0,18,34,26,45,12,4,19,15,114,13]),function(ge,e,y,M,I,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.SearchErrorCode=e.$DJ=e.$CJ=e.SearchSortOrder=e.ViewMode=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.SearchCompletionExitCode=e.$xJ=e.$wJ=e.$vJ=e.QueryType=e.SearchProviderType=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$pJ="workbench.view.search",e.$qJ="workbench.panel.search",e.$rJ="workbench.view.search",e.$sJ="search-result",e.$tJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$uJ=(0,m.$6h)("searchService");var r;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(r||(e.SearchProviderType=r={}));var a;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(a||(e.QueryType=a={}));function s(le){return!!le.preview}e.$vJ=s;function n(le){return!!le.resource}e.$wJ=n;function o(le){return!!le.message}e.$xJ=o;var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$yJ=h;class t{constructor($e,ie,be,se){this.ranges=ie,this.webviewIndex=se;const Z=Array.isArray(ie)?ie:[ie];if(be&&be.matchLines===1&&u(Z)){$e=(0,P.$Bf)($e,be.matchLines);let V="",ne=0,Ie=0;const Le=Math.floor(be.charsPerLine/5),Ce=[];for(const ce of Z){const te=Math.max(ce.startColumn-Le,0),Q=ce.startColumn+be.charsPerLine;if(te>Ie+Le+b){const ee=l+(te-Ie)+p;V+=ee+$e.slice(te,Q),ne+=te-(Ie+ee.length)}else V+=$e.slice(Ie,Q);Ce.push(new g(0,ce.startColumn-ne,ce.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:$e,matches:(0,y.$2b)(ie,ne=>new i(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$zJ=t;function u(le){const $e=le[0].startLineNumber;for(const ie of le)if(ie.startLineNumber!==$e||ie.endLineNumber!==$e)return!1;return!0}class i{constructor($e,ie,be,se){this.startLineNumber=$e,this.startColumn=ie,this.endLineNumber=be,this.endColumn=se}}e.$AJ=i;class g extends i{constructor($e,ie,be){super($e,ie,$e,be)}}e.$BJ=g;var $;(function(le){le.List="list",le.Tree="tree"})($||(e.ViewMode=$={}));var d;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function S(le,$e=!0){const ie=le&&le.files&&le.files.exclude,be=$e&&le&&le.search&&le.search.exclude;if(!ie&&!be)return;if(!ie||!be)return ie||be;let se=Object.create(null);return se=I.$yn(se,I.$vn(ie)),se=I.$yn(se,I.$vn(be),!0),se}e.$CJ=S;function L(le,$e){return le.excludePattern&&M.$Lj(le.excludePattern,$e)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&M.$Lj(le.includePattern,$e)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(ie=>{const be=ie.folder.fsPath;if(A.$8f($e,be)){const se=f.$lc(be,$e);return!ie.includePattern||!!M.$Lj(ie.includePattern,se)}else return!1}):!1:!0}e.$DJ=L;var v;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class E extends Error{constructor($e,ie){super($e),this.code=ie}}e.$EJ=E;function D(le){const $e=le.message;if((0,w.$4)(le))return new E($e,v.canceled);try{const ie=JSON.parse($e);return new E(ie.message,ie.code)}catch{return new E($e,v.other)}}e.$FJ=D;function T(le){const $e={message:le.message,code:le.code};return new Error(JSON.stringify($e))}e.$GJ=T;function O(le){return le.type==="error"?!0:le.type==="success"}e.$HJ=O;function G(le){return le.type==="success"}e.$IJ=G;function q(le){return!!le.path}e.$JJ=q;function z(le,$e){const ie=le.searchPath?le.searchPath:le.relativePath;return(0,P.$yf)(ie,$e)}e.$KJ=z;class C{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LJ=C;function N(le,$e){const ie={...le||{},...$e||{}};return Object.keys(ie).filter(be=>{const se=ie[be];return typeof se=="boolean"&&se})}e.$MJ=N;class W{constructor($e,ie){this.c=null,this.a={...$e.excludePattern||{},...ie.excludePattern||{}},this.b=M.$Mj(this.a);let be=$e.includePattern;ie.includePattern&&(be?be={...be,...ie.includePattern}:be=ie.includePattern),be&&(this.c=M.$Mj(be))}matchesExcludesSync($e,ie,be){return!!(this.b&&this.b($e,ie,be))}includedInQuerySync($e,ie,be){return!(this.b&&this.b($e,ie,be)||this.c&&!this.c($e,ie,be))}includedInQuery($e,ie,be){const se=this.b($e,ie,be),Z=()=>this.c?!!this.c($e,ie,be):!0;return(0,k.$Sg)(se)?se.then(V=>V?!1:Z()):Z()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$NJ=W;function ae(le){for(const $e in le)if(typeof le[$e]!="boolean")return!0;return!1}function de(le){if(!le)return;let $e;return ie=>($e||($e=(le()||Promise.resolve([])).then(be=>be?ye(be):{})),$e.then(be=>!!be[ie]))}e.$OJ=de;function we(le){if(!le)return;let $e;return ie=>{if(!$e){const be=le();$e=be?ye(be):{}}return!!$e[ie]}}e.$PJ=we;function ye(le){const $e={};for(const ie of le)$e[ie]=!0;return $e}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,11,122,25,12,2,168,4,14,187,47,42,27,17,8,7,58,43,3,51]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u,i,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;function d(G,q,z){return new R.$wg(C=>E(C,z)).isEqual(G,q)}function S(G,q,z){return d(G.uri,q.uri,z)?0:(0,k.$5e)(G.uri.toString(),q.uri.toString())}function L(G,q,z){return G.index!==q.index?G.index<q.index?-1:1:d(G.uri,q.uri,z)?(0,k.$5e)(G.name,q.name):(0,k.$5e)(G.uri.toString(),q.uri.toString())}function v(G,q,z,C){const N=G.slice(0).sort((ae,de)=>z(ae,de,C)),W=q.slice(0).sort((ae,de)=>z(ae,de,C));return(0,y.$Eb)(N,W,(ae,de)=>z(ae,de,C))}function E(G,q){const z=q.getCapabilities(G.scheme);return!(z&&z&1024)}class D extends s.$mi{static toExtHostWorkspace(q,z,C,N){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:ae,folders:de,configuration:we,transient:ye,isUntitled:le}=q,$e=[],ie=z;z?de.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Le=D.o(C||z,Ie,N);Le?(Le.name=V.name,Le.index=V.index,$e.push(Le)):$e.push({uri:Ie,name:V.name,index:ne})}):$e.push(...de.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),$e.sort((V,ne)=>V.index<ne.index?-1:1);const be=new D(W,ae,$e,!!ye,we?l.URI.revive(we):null,!!le,V=>E(V,N)),{added:se,removed:Z}=v(ie?ie.workspaceFolders:[],be.workspaceFolders,S,N);return{workspace:be,added:se,removed:Z}}static o(q,z,C){for(let N=0;N<q.folders.length;N++){const W=q.workspaceFolders[N];if(d(W.uri,z,C))return W}}constructor(q,z,C,N,W,ae,de){super(q,C.map(we=>new s.$ni(we)),N,W,de),this.t=z,this.u=ae,this.q=[],this.s=m.$_h.forUris(de),C.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,z){return z&&this.s.get(q)&&(q=(0,R.$Gg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let T=class{constructor(q,z,C,N,W){this.c=new A.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new A.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new A.$Xd,this.B=new Map,this.h=N,this.s=C,this.t=W,this.j=new w.$9l,this.k=new M.$5g,this.o=q.getProxy(g.$0K.MainThreadWorkspace),this.q=q.getProxy(g.$0K.MainThreadMessageService);const ae=z.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,de=>E(de,C)):void 0}$initializeWorkspace(q,z){this.v=z,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,R.$Eg)((0,R.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,z,C,...N){const W=[];if(Array.isArray(N)&&N.forEach(le=>{l.URI.isUri(le.uri)&&!W.some($e=>d($e.uri,le.uri,this.s))&&W.push({uri:le.uri,name:le.name||(0,R.$Dg)(le.uri)})}),this.n||[z,C].some(le=>typeof le!="number"||le<0)||C===0&&W.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(z+C>ae.length)return!1;const de=ae.slice(0);de.splice(z,C,...W.map(le=>({uri:le.uri,name:le.name||(0,R.$Dg)(le.uri),index:void 0})));for(let le=0;le<de.length;le++){const $e=de[le];if(de.some((ie,be)=>be!==le&&d($e.uri,ie.uri,this.s)))return!1}de.forEach((le,$e)=>le.index=$e);const{added:we,removed:ye}=v(ae,de,L,this.s);if(we.length===0&&ye.length===0)return!1;if(this.o){const le=q.displayName||q.name;this.o.$updateWorkspaceFolders(le,z,C,W).then(void 0,$e=>{this.n=void 0;const ie={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,p.localize)(0,null,le,$e.toString()),ie,[])})}return this.y(de),!0}getWorkspaceFolder(q,z){if(this.x)return this.x.getWorkspaceFolder(q,z)}async getWorkspaceFolder2(q,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,z)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,z){let C,N="";if(typeof q=="string"?(C=l.URI.file(q),N=q):typeof q<"u"&&(C=q,N=q.fsPath),!C)return N;const W=this.getWorkspaceFolder(C,!0);if(!W)return N;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ae=(0,R.$Jg)(W.uri,C);return z&&W.name&&(ae=`${W.name}/${ae}`),ae}y(q){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:z,added:C,removed:N}=D.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:N}))}findFiles(q,z,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let ae;if(z===null?ae=!1:z&&(typeof z=="string"?ae=z:ae=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:we}=O(h.GlobPattern.from(q));return this.o.$startFileSearch(de??null,we??null,ae??null,C??null,W).then(ye=>Array.isArray(ye)?ye.map(le=>l.URI.revive(le)):[])}async findTextInFiles(q,z,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),de=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:we,folder:ye}=O(h.GlobPattern.from(z.include)),le=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$e={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:de,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:we,excludePattern:le},ie=!1;if(this.u[ae]=be=>{if(ie)return;const se=l.URI.revive(be.resource);be.results.forEach(Z=>{const V=(0,$.$Ch)(Z);(0,i.$vJ)(V)?C({uri:se,preview:{text:V.preview.text,matches:(0,y.$2b)(V.preview.matches,ne=>new t.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,y.$2b)(V.ranges,ne=>new t.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:se,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(q,ye??null,$e,ae,W);return delete this.u[ae],be||{}}catch(be){throw delete this.u[ae],be}}$handleTextSearchResult(q,z){this.u[z]?.(q)}async save(q){const z=await this.o.$save(q,{saveAs:!1});return l.URI.revive(z)}async saveAs(q){const z=await this.o.$save(q,{saveAs:!0});return l.URI.revive(z)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,z){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,z);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,C),(0,P.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(q,z){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const N=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!N),!N)return;const W=await N.provideEditSessionIdentity(C,z);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,z,C,N){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const ae=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!ae),!ae)return;const de=await ae.provideEditSessionIdentityMatch?.(z,C,N);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(q){return(z,C,N)=>{const W=function(de){z.call(C,de)};return W.extension=q,this.A.event(W,void 0,N)}}async $onWillCreateEditSessionIdentity(q,z,C){const N=await this.resolveWorkspaceFolder(l.URI.revive(q));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},z,async(W,ae)=>{const de=Date.now();await Promise.resolve(W),Date.now()-de>C&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(q,z){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,z);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerCanonicalUriProvider(N,C),(0,P.$Rc)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(q,z,C){const N=this.B.get(q.scheme);if(!N)return;const W=await N.provideCanonicalUri?.(l.URI.revive(q),z,C);if(W)return W}async $provideCanonicalUri(q,z,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:z},C)}};e.$ygc=T,e.$ygc=T=Je([He(0,c.$bN),He(1,o.$rN),He(2,n.$egc),He(3,r.$nj),He(4,u.$wgc)],T),e.$zgc=(0,b.$6h)("IExtHostWorkspace");function O(G){let q,z;return G&&(typeof G=="string"?q=G:(q=G.pattern,z=l.URI.revive(G.baseUri))),{includePattern:q,folder:z}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,55,16,13,4,17,14,2]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=void 0;function r(u,i){if(i){const g=i.split(".");let $=u;for(let d=0;$&&d<g.length;d++)$=$[g[d]];return $}}function a(u){return u instanceof b.URI}function s(u){return u&&u.uri instanceof b.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function o(u){return u&&u.uri instanceof b.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(a(u))return{resource:u};if(s(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(o(u))return{resource:u.uri};if(u===null)return{resource:null}}let h=class{constructor(i,g,$){this.a=i.getProxy(A.$0K.MainThreadConfiguration),this.c=g,this.b=$,this.d=new R.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new t(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,g){this.getConfigProvider().then($=>$.$acceptConfigurationChanged(i,g))}};e.$Agc=h,e.$Agc=h=Je([He(0,l.$bN),He(1,I.$zgc),He(2,p.$nj)],h);class t{constructor(i,g,$,d){this.a=new M.$Vd,this.b=i,this.f=d,this.c=g,this.e=m.$6n.parse($),this.d=this.k($.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,g){const $={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$6n.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(g,$))}getConfiguration(i,g,$){const d=c(g)||{},S=this.g(i?r(this.e.getValue(void 0,d,this.c.workspace),i):this.e.getValue(void 0,d,this.c.workspace));i&&this.h(i,d,$?.identifier);function L(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(E){return typeof r(S,E)<"u"},get:(E,D)=>{this.h(i?`${i}.${E}`:E,d,$?.identifier);let T=r(S,E);if(typeof T>"u")T=D;else{let O;const G=(q,z)=>{if((0,w.$Kf)(q)){let C;const N=()=>{O=O||(0,y.$vn)(S),C=C||r(O,z)};return new Proxy(q,{get:(W,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return N(),()=>C;if(O)return C=C||r(O,z),C[ae];const de=W[ae];return typeof ae=="string"?G(de,`${z}.${ae}`):de},set:(W,ae,de)=>(N(),C&&(C[ae]=de),!0),deleteProperty:(W,ae)=>(N(),C&&delete C[ae],!0),defineProperty:(W,ae,de)=>(N(),C&&Object.defineProperty(C,ae,de),!0)})}return Array.isArray(q)?(0,y.$vn)(q):q};T=G(T,E)}return T},update:(E,D,T,O)=>{E=i?`${i}.${E}`:E;const G=L(T);return D!==void 0?this.b.$updateConfigurationOption(G,E,D,d,O):this.b.$removeConfigurationOption(G,E,d,O)},inspect:E=>{E=i?`${i}.${E}`:E;const D=this.e.inspect(E,d,this.c.workspace);if(D)return{key:E,defaultValue:(0,y.$vn)(D.policy?.value??D.default?.value),globalValue:(0,y.$vn)(D.user?.value??D.application?.value),workspaceValue:(0,y.$vn)(D.workspace?.value),workspaceFolderValue:(0,y.$vn)(D.workspaceFolder?.value),defaultLanguageValue:(0,y.$vn)(D.default?.override),globalLanguageValue:(0,y.$vn)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,y.$vn)(D.workspace?.override),workspaceFolderLanguageValue:(0,y.$vn)(D.workspaceFolder?.override),languageIds:(0,y.$vn)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$yn)(v,S,!1),Object.freeze(v)}g(i){const g=$=>(0,w.$Kf)($)?new Proxy($,{get:(d,S)=>g(d[S]),set:(d,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(d,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(d,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):$;return g(i)}h(i,g,$){const d=f.$Wn.test(i)?4:this.d.get(i),S=$?`[${$.value}] `:"";if(d===4){typeof g?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){g?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,g){const $=new m.$8n(i,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,S)=>$.affectsConfiguration(d,c(S))})}k(i){return i.reduce((g,$)=>(g.set($[0],$[1]),g),new Map)}}e.$Bgc=t,e.$Cgc=(0,k.$6h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,66,37,20,65,17,27,4,11,21,14,79,220,15]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=e.$4hc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function q(C){if(C!=null)return C}G.from=q;function z(C){if(C!=null)return C}G.to=z})(h||(h={}));var t;(function(G){function q(C){if(C!=null)return C}G.from=q;function z(C){if(C!=null)return C}G.to=z})(t||(t={}));var u;(function(G){function q(C){if(C!=null)return C}G.from=q;function z(C){if(C!=null)return C}G.to=z})(u||(u={}));var i;(function(G){function q(N){if(N){const W=N;return W&&!!W.process}else return!1}G.is=q;function z(N){if(N==null)return;const W={process:N.process,args:N.args};return N.options&&(W.options=u.from(N.options)),W}G.from=z;function C(N){if(N!=null)return new P.$UL(N.process,N.args,N.options)}G.to=C})(i||(i={}));var g;(function(G){function q(C){if(C!=null)return C}G.from=q;function z(C){if(C!=null)return C}G.to=z})(g||(g={}));var $;(function(G){function q(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}G.is=q;function z(N){if(N==null)return;const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=g.from(N.options)),W}G.from=z;function C(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new P.$VL(N.commandLine,N.options):new P.$VL(N.command,N.args?N.args:[],N.options)}G.to=C})($||($={}));var d;(function(G){function q(N){if(N){const W=N;return W&&W.customExecution==="customExecution"}else return!1}G.is=q;function z(N){return{customExecution:"customExecution"}}G.from=z;function C(N,W){return W.get(N)}G.to=C})(d||(e.CustomExecutionDTO=d={}));var S;(function(G){function q(z,C){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===P.TaskScope.Workspace&&C&&C.workspaceFile?N=C.workspaceFile:N=o.$yG),{id:z._id,workspaceFolder:N}}G.from=q})(S||(e.TaskHandleDTO=S={}));var L;(function(G){function q(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}G.from=q})(L||(L={}));var v;(function(G){function q(N,W){if(N==null)return[];const ae=[];for(const de of N){const we=z(de,W);we&&ae.push(we)}return ae}G.fromMany=q;function z(N,W){if(N==null)return;let ae;N.execution instanceof P.$UL?ae=i.from(N.execution):N.execution instanceof P.$VL?ae=$.from(N.execution):N.execution&&N.execution instanceof P.$WL&&(ae=d.from(N.execution));const de=h.from(N.definition);let we;return N.scope?typeof N.scope=="number"?we=N.scope:we=N.scope.uri:we=P.TaskScope.Workspace,!de||!we?void 0:{_id:N._id,definition:de,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:we},execution:ae,isBackground:N.isBackground,group:L.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}G.from=z;async function C(N,W,ae){if(N==null)return;let de;i.is(N.execution)?de=i.to(N.execution):$.is(N.execution)?de=$.to(N.execution):d.is(N.execution)&&(de=d.to(N._id,ae));const we=h.to(N.definition);let ye;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ye=N.source.scope:ye=await W.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):ye=P.TaskScope.Workspace),!we||!ye)return;const le=new P.$XL(we,ye,N.name,N.source.label,de,N.problemMatchers);return N.isBackground!==void 0&&(le.isBackground=N.isBackground),N.group!==void 0&&(le.group=P.$TL.from(N.group._id),le.group&&N.group.isDefault&&(le.group=new P.$TL(le.group.id,le.group.label),N.group.isDefault===!0&&(le.group.isDefault=N.group.isDefault))),N.presentationOptions&&(le.presentationOptions=t.to(N.presentationOptions)),N._id&&(le._id=N._id),N.detail&&(le.detail=N.detail),le}G.to=C})(v||(e.TaskDTO=v={}));var E;(function(G){function q(C){return C}G.from=q;function z(C){if(C)return Object.assign(Object.create(null),C)}G.to=z})(E||(E={}));class D{#e;constructor(q,z,C){this._id=z,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let T=class{constructor(q,z,C,N,W,ae,de,we){this.q=new I.$Vd,this.r=new I.$Vd,this.s=new I.$Vd,this.u=new I.$Vd,this.a=q.getProxy(A.$0K.MainThreadTask),this.b=C,this.c=N,this.d=W,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,z,C){if(!C)return new P.$_K(()=>{});const N=this.x();return this.j.set(N,{type:z,provider:C,extension:q}),this.a.$registerTaskProvider(N,z),new P.$_K(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(q,z){this.a.$registerTaskSystem(q,z)}fetchTasks(q){return this.a.$fetchTasks(E.from(q)).then(async z=>{const C=[];for(const N of z){const W=await v.to(N,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(z=>q.push(z)),q}terminateTask(q){if(!(q instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,z,C){const N=this.m.get(q.id);N&&(this.o.set(q.id,N),this.e.attachPtyToTerminal(z,await N.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const z=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const z=await this.z(q.id);this.s.fire({execution:z,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const z=await this.z(q.id);this.u.fire({execution:z,exitCode:q.exitCode})}$provideTasks(q,z){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const N=[],W=(0,M.$Yg)(()=>C.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.v(z,N,C,ae));return new Promise(ae=>{W.then(de=>{Promise.all(N).then(()=>{ae(de)})})})}async $resolveTask(q,z){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(z.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${C.type}].`);const N=await v.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(N,R.CancellationToken.None);if(!W)return;this.A(W,C);const ae=v.from(W,C.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(ae.execution)&&await this.y(ae,W,!0),await this.w(ae)}x(){return this.h++}async y(q,z,C){const N=await this.a.$createTaskId(q);!C&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async z(q,z){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new c.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let N;return z?N=Promise.resolve(new D(this,q.id,z)):N=v.to(q.task,this.b,this.m).then(W=>{if(!W)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,q.id,W)}),this.l.set(q.id,N),N.then(W=>(this.k.set(q.id,W),W))}A(q,z){q._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let N=C.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=C.next()}};e.$4hc=T,e.$4hc=T=Je([He(0,l.$bN),He(1,p.$rN),He(2,m.$zgc),He(3,f.$mN),He(4,w.$Cgc),He(5,k.$1gc),He(6,s.$nj),He(7,n.$hgc)],T);let O=class extends T{constructor(q,z,C,N,W,ae,de,we){super(q,z,C,N,W,ae,de,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(q,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const C=v.from(z,q);if(C===void 0)throw new Error("Task is not valid");if(d.is(C.execution))await this.y(C,z,!1);else throw new c.$_;const N=await this.z(await this.a.$getTaskExecution(C),z);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),N}v(q,z,C,N){const W=[];if(N)for(const ae of N){if(this.A(ae,C),!ae.definition||!q[ae.definition.type]){const we=ae.source?ae.source:"No task source";this.f.warn(`The task [${we}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=v.from(ae,C.extension);de&&d.is(de.execution)?(W.push(de),z.push(this.y(de,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(d.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,z,C){}};e.$5hc=O,e.$5hc=O=Je([He(0,l.$bN),He(1,p.$rN),He(2,m.$zgc),He(3,f.$mN),He(4,w.$Cgc),He(5,k.$1gc),He(6,s.$nj),He(7,n.$hgc)],O),e.$6hc=(0,b.$6h)("IExtHostTask")}),define(Pe[282],Re([1,0,43,29]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=void 0;function I(P){return"cellResults"in P}e.$VJ=I,e.$WJ="rawCell#";function A(P,m){let f=-1;const w=[];let R=[];return P.forEach(l=>{l.range.startLineNumber!==f&&R.length>0&&(w.push([...R]),R=[]),R.push(l),f=l.range.endLineNumber}),R.length>0&&w.push([...R]),w.map(l=>{const p=[],b=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let a=b;a<=r;a++)p.push(m.getLineContent(a));return new y.$zJ(p.join(`
`)+`
`,l.map(a=>new M.$Us(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$XJ=A}),define(Pe[283],Re([1,0,162,22,5,6,28,12,16,2,41,75,3,32,8,7,49,258,109,26,11,210,282,280]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class i{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map($=>$.apiEditor)}constructor($,d,S,L,v,E){this.q=S,this.r=L,this.s=v,this.t=E,this.f=new Map,this.g=new P.$Ac,this.h=new Map,this.j=new I.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$agc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=$.getProxy(l.$0K.MainThreadNotebook),this.c=$.getProxy(l.$0K.MainThreadNotebookDocuments),this.d=$.getProxy(l.$0K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const T=D.notebookEditor?.notebookUri,O=D.cell.handle,q=this.g.get(T)?.getCell(O);if(q)return q.apiCell}if(D&&D.$mid===14){const T=D.uri,O=this.g.get(T);if(O)return O.apiNotebook}return D}}),i.B(d)}getEditorById($){const d=this.h.get($);if(!d)throw new Error(`unknown text editor: ${$}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor($){for(const[d,S]of this.h)if(S.apiEditor===$)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument($,d){const S=this.g.get($);if(!S&&!d)throw new Error(`NO notebook document for '${$}'`);return S}static u($,d){if(!d)return;const S=d.filenamePattern.map(L=>b.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(d.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:$.identifier,providerDisplayName:$.displayName||$.name,displayName:d.displayName,filenamePattern:S,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider($,d,S){const L=i.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?i.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,v,d);let E;return v!==void 0&&(E=S.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(v))),new r.$_K(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,v),E?.dispose()})}async createNotebookDocument($){const d=await this.c.$tryCreateNotebook({viewType:$.viewType,content:$.content&&b.NotebookData.from($.content)});return w.URI.revive(d)}async openNotebookDocument($){const d=this.g.get($);if(d)return d.apiNotebook;const S=await this.c.$tryOpenNotebook($),L=this.g.get(w.URI.revive(S));return(0,f.$Tf)(L?.apiNotebook)}async showNotebookDocument($,d){w.URI.isUri($)&&($=await this.openNotebookDocument($));let S;typeof d=="object"?S={position:b.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(b.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument($.uri,$.notebookType,S),v=L&&this.h.get(L)?.apiEditor;if(v)return v;throw L?new Error(`Could NOT open editor for "${$.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${$.uri.toString()}".`)}async $provideNotebookCellStatusBarItems($,d,S,L){const v=this.f.get($),E=w.URI.revive(d),D=this.g.get(E);if(!D||!v)return;const T=D.getCellFromIndex(S);if(!T)return;const O=await v.provideCellStatusBarItems(T.apiCell,L);if(!O)return;const G=new A.$Sc,q=this.p.add([G]),C=(Array.isArray(O)?O:[O]).map(N=>b.NotebookStatusBarItem.from(N,this.i,G));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems($){this.p.delete($)}registerNotebookSerializer($,d,S,L,v){if((0,m.$Je)(d))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:d,serializer:S,options:L}),this.b.$registerNotebookSerializer(E,{id:$.identifier,location:$.extensionLocation},d,b.NotebookDocumentContentOptions.from(L),i.u($,v)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook($,d,S){const L=this.x.get($);if(!L)throw new Error("NO serializer found");const v=await L.serializer.deserializeNotebook(d.buffer,S);return new a.$Tv(b.NotebookData.from(v))}async $notebookToData($,d,S){const L=this.x.get($);if(!L)throw new Error("NO serializer found");const v=await L.serializer.serializeNotebook(b.NotebookData.to(d.value),S);return M.$je.wrap(v)}async $saveNotebook($,d,S,L,v){const E=w.URI.revive(d),D=this.x.get($);if(!D)throw new Error("NO serializer found");const T=this.g.get(E);if(!T)throw new Error("Document NOT found");if(T.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new R.$Lk((0,y.localize)(0,null,this.z(E)),6);await this.y(E,L);const O={metadata:(0,o.$Dn)(T.apiNotebook.metadata,N=>!(D.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of T.apiNotebook.getCells()){const W=new r.$yM(N.kind,N.document.getText(),N.document.languageId,N.mime,D.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);W.metadata=(0,o.$Dn)(N.metadata,ae=>!(D.options?.transientCellMetadata??{})[ae]),O.cells.push(W)}const G=await D.serializer.serializeNotebook(O,v);await this.s.value.writeFile(E,G);const q=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:q.basename(E),isFile:(z.type&R.FileType.File)!==0,isDirectory:(z.type&R.FileType.Directory)!==0,isSymbolicLink:(z.type&R.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&R.FilePermission.Locked),etag:R.$Wk({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks($,d,S,L,v){const E=this.x.get($)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new P.$Bc;await(async(z,C,N)=>{await Promise.all(z.map(async W=>await Promise.all(W.filenamePatterns.map(ae=>{const de={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(de,C,we=>{we.forEach(ye=>{D.has(ye)||L.some($e=>W.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ie=>(0,u.$jdb)(ie,ye)))||D.add(ye)})})}))))})(S,v,d);const O=new P.$Ac;let G=!1;const q=Array.from(D).map(async z=>{const C=[];try{if(v.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((de,we)=>de+we.cellResults.length,0)>d.maxResults){G=!0;return}const N=[],W=this.g.get(z);if(W)W.apiNotebook.getCells().forEach(we=>N.push({input:we.document.getText(),outputs:we.outputs.flatMap(ye=>ye.items.map(le=>le.data.toString()))}));else{const de=await this.s.value.readFile(z),we=M.$je.fromString(de.toString()),ye=await E.deserializeNotebook(we.buffer,v);if(v.isCancellationRequested)return;b.NotebookData.from(ye).cells.forEach($e=>N.push({input:$e.source,outputs:$e.outputs.flatMap(ie=>ie.items.map(be=>be.valueBytes.toString()))}))}if(v.isCancellationRequested)return;N.forEach((de,we)=>{const ye=d.contentPattern.pattern,le=new h.$TQb(de.input,void 0,de.outputs),$e=le.findInInputs(ye),ie=le.findInOutputs(ye),be=ie.flatMap(se=>(0,t.$XJ)(se.matches,se.textBuffer)).map((se,Z)=>(se.webviewIndex=Z,se));if($e.length>0||ie.length>0){const se={index:we,contentResults:(0,t.$XJ)($e,le.inputTextBuffer),webviewResults:be};C.push(se)}});const ae={resource:z,cellResults:C};O.set(z,ae);return}catch{return}});return await Promise.all(q),{limitHit:G,results:[...O.values()]}}async y($,d){const S=await this.s.value.stat($);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==R.$Vk&&typeof S.mtime=="number"&&typeof S.size=="number"&&d.mtime<S.mtime&&d.etag!==R.$Wk({mtime:d.mtime,size:S.size}))throw new R.$Lk((0,y.localize)(1,null),3,d)}z($){return $.scheme===c.Schemas.file?$.fsPath:$.toString()}A($,d,S){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const L=new n.$whc(d,this.d,$,S.visibleRanges.map(b.NotebookRange.to),S.selections.map(b.NotebookRange.to),typeof S.viewColumn=="number"?b.ViewColumn.to(S.viewColumn):void 0);this.h.set(d,L)}$acceptDocumentAndEditorsDelta($){if($.value.removedDocuments)for(const S of $.value.removedDocuments){const L=w.URI.revive(S),v=this.g.get(L);v&&(v.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(v.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===L.toString()&&this.h.delete(E.id)}if($.value.addedDocuments){const S=[];for(const L of $.value.addedDocuments){const v=w.URI.revive(L.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const E=new s.$vhc(this.c,this.q,this.r,v,L);S.push(...L.cells.map(D=>s.$uhc.asModelAddData(E.apiNotebook,D))),this.g.get(v)?.dispose(),this.g.set(v,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(E.apiNotebook)}}if($.value.addedEditors)for(const S of $.value.addedEditors){if(this.h.has(S.id))return;const L=w.URI.revive(S.documentUri),v=this.g.get(L);v&&this.A(v,S.id,S)}const d=[];if($.value.removedEditors)for(const S of $.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),d.push(L))}if($.value.visibleEditors){this.l=$.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const v=S.has(L.id);L._acceptVisibility(v)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}$.value.newActiveEditor===null?this.k=void 0:$.value.newActiveEditor&&(this.h.get($.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${$.value.newActiveEditor}`),this.k=this.h.get($.value.newActiveEditor)),$.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B($){const d=p.$zN.String.with("notebookType","A notebook type"),S=new p.$BN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new p.$zN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>M.$je.wrap(v))],new p.$AN("Notebook Data",v=>b.NotebookData.to(v.value))),L=new p.$BN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new p.$zN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new a.$Tv(b.NotebookData.from(v)))],new p.$AN("Bytes",v=>v.buffer));$.registerApiCommand(S),$.registerApiCommand(L)}}e.$Fhc=i}),define(Pe[284],Re([1,0,19,20,40,34,25,63,43]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class w{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&A.$Mj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&A.$Mj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,r)=>{const a=s=>{this.f++,l(s)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),o=y.$nc(n);this.j&&this.j(n,o)||this.v(a,{base:s,basename:o})}),Promise.all(p.map(s=>this.p(s,a))).then(s=>{b({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,I.$Qi)(s)))})})}async p(l,p){const b=new M.$6d,r=this.q(l),a=this.r(),s=new f.$NJ(this.k,l),n=!s.hasSiblingExcludeClauses();let o;try{this.h.add(b),o=m.$Rd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,b.token),h=o.elapsed(),t=m.$Rd.create();return this.g&&!this.e||(c&&c.forEach(u=>{const i=y.$gc.relative(l.folder.path,u.path);if(n){const g=y.$nc(u.path);this.v(p,{base:l.folder,relativePath:i,basename:g});return}this.s(a,l.folder,i,p)}),this.g&&!this.e)?null:(this.u(a,s,p),{providerTime:h,postProcessTime:t.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,f.$MJ)(this.k.includePattern,l.includePattern),b=(0,f.$MJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,r){if(b===this.a){const s=y.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:s})}function a(s){const n=y.$nc(s),o=y.$mc(s);let c=l[o];c||(c=l[o]=[],a(o)),c.push({base:p,relativePath:s,basename:n})}a(b)}u({rootEntries:l,pathToEntries:p},b,r){const a=this,s=this.a;function n(o){const c=(0,f.$PJ)(()=>o.map(h=>h.basename));for(let h=0,t=o.length;h<t;h++){const u=o[h],{relativePath:i,basename:g}=u;if(b.matchesExcludesSync(i,g,s!==g?c:void 0))continue;const $=p[i];if($)n($);else{if(i===s)continue;a.v(r,u)}if(a.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,r){const a=this.c(l.cacheKey),s=new w(l,p,a&&a.token);let n=0;const o=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(s,R.a,o,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$6d),this.b.get(l)}d(l){return l.relativePath?{resource:P.$Hg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,r){const a=r.onCancellationRequested(()=>{l.cancel()}),s=o=>{o&&(n.push(o),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(s).then(o=>(n.length&&b(n),a.dispose(),o),o=>(n.length&&b(n),a.dispose(),Promise.reject(o)))}}e.$xhc=R}),define(Pe[285],Re([1,0,18,253,34,95,28,11,19,25,12,16,2,94,179,46,14,47,104,281,43]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=void 0;let h=class{constructor(E,D,T,O,G){this.a=E,this.b=D,this.c=T,this.d=O,this.e=G}text(E,D,T={}){E=this.f(E,T);const O=this.a.getValue(),G=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(s.$oi),T),type:2,contentPattern:E,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(E,D){const T=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const O={...E,wordSeparators:T.editor.wordSeparators};return this.j(E,D)&&(O.isCaseSensitive=!0),this.k(E)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(E,D){return E?(E=Array.isArray(E)?E.map($):$(E),D?this.parseSearchPaths(E):{pattern:u(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const T=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),G=E.length>1,q=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(N=>this.q(N,D,O)):E.map(N=>this.r(N,D,O,G))).filter(N=>!!N),z={_reason:D._reason,folderQueries:q,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:T.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const N=y.$Hb(y.$Rb(this.c.groups.map(de=>de.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const W=N.filter(de=>(0,c.$DJ)(z,de.fsPath)),ae=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...z,...ae}}const C=D.extraFileResources&&D.extraFileResources.filter(N=>(0,c.$DJ)(z,N.fsPath));return z.extraFileResources=C&&C.length?C:void 0,z}i(E){const D=[],T=new P.$Ac,O={};let G=!1;return E.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,w.$Lg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:f.$mc(q.fsPath)});let N=T.get(C);N||(G=!0,N={folder:C,includePattern:{}},D.push(N),T.set(C,N));const W=f.$lc(C.fsPath,q.fsPath);(0,k.$Tf)(N.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,O[q.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(R.$zf(E.pattern,!0))return!0}else if(R.$zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,p.$4B)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=ae=>f.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(E)?E:i(E)).map(ae=>{const de=this.e.resolvedUserHome;return de?(0,A.$Yv)(ae,de.scheme===m.Schemas.file?de.fsPath:de.path):ae}),G=M.$K(O,ae=>D(ae)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(ae=>R.$Ue(ae,"/")).map(ae=>R.$Ue(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),g(ae))),z={},C=this.m(G.searchPaths||[]);C&&C.length&&(z.searchPaths=C);const N=y.$Rb(q),W=u(...N);return W&&(z.pattern=W),z}l(E,D){return D.disregardExcludeSettings?void 0:(0,c.$CJ)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(O=>{let{pathPortion:G,globPortion:q}=t(O);return q&&(q=d(q)),this.n(G).flatMap(C=>this.o(C,q))}),T=new Map;return D.forEach(O=>{const G=O.searchPath.toString(),q=T.get(G);q?O.pattern&&(q.pattern=q.pattern||{},q.pattern[O.pattern]=!0):T.set(G,{searchPath:O.searchPath,pattern:O.pattern?u(O.pattern):void 0})}),Array.from(T.values())}n(E){if(f.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==m.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:l.URI.file(f.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=$(E),E.startsWith("../")||E===".."){const O=f.$gc.resolve(D.path,E);return[{searchPath:D.with({path:O})}]}const T=d(E);return[{searchPath:D,pattern:T}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const q=D.match(new RegExp(`^${R.$Oe(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(k.$Qf);if(O.length)return O.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&d(q)}});{const G=E.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:E,z=b.localize(0,null,q);throw new Error(z)}}}}o(E,D){const T=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,O=[{searchPath:E.searchPath,pattern:T}];return T&&!T.endsWith("**")&&O.push({searchPath:E.searchPath,pattern:T+"/**"}),O}q(E,D,T){const O=this.r((0,s.$oi)(E.searchPath),D,T,!1);return O?{...O,includePattern:E.pattern}:null}r(E,D,T,O){let G;const q=l.URI.isUri(E)?E:E.uri;if(T.searchPaths){const ae=T.searchPaths.filter(de=>(0,w.$Ag)(de.searchPath,q))[0];if(ae&&!ae.pattern)return null;ae&&(G=ae.pattern)}const z=this.a.getValue({resource:q}),N={...this.l(z,D)||{},...G||{}},W=l.URI.isUri(E)?(0,w.$Eg)(E):E.name;return{folder:q,folderName:O?W:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$NK=h,e.$NK=h=Je([He(0,r.$zi),He(1,s.$ci),He(2,n.$9C),He(3,a.$nj),He(4,o.$LK)],h);function t(v){const E=v.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,T=v.substr(0,D).match(/[/|\\][^/\\]*$/);if(T){let O=v.substr(0,T.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((T.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function i(v){return I.$Kj(v,",").map(E=>E.trim()).filter(E=>!!E.length)}function g(v){return[`**/${v}/**`,`**/${v}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function $(v){return v.replace(/\\/g,"/")}function d(v){return $(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,E){v=y.$Mb(v,O=>O.toString());const D=[],T=E.getWorkspace();return v&&v.forEach(O=>{let G;if(E.getWorkbenchState()===2)G=(0,w.$Jg)(T.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const q=E.getWorkspaceFolder(O);if(q){const z=q.name;if(T.folders.filter(N=>N.name===z).length===1){const N=(0,w.$Jg)(q.uri,O);N===""?G=`./${q.name}`:G=`./${q.name}/${N}`}else G=O.fsPath}}G&&D.push(S(G))}),D}e.$OK=L}),define(Pe[286],Re([1,0,25,2,20,15,4,285,43,47]),function(ge,e,y,M,I,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsb=e.$vsb=void 0;const R=7e3;function k(r,a){const s=a.activationEvents;if(!s)return Promise.resolve(void 0);const n=[],o=[];for(const g of s)if(/^workspaceContains:/.test(g)){const $=g.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||r.forceUsingSearch?o.push($):n.push($)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((g,$)=>{c=g}),t=g=>c({activationEvent:g}),u=Promise.all(n.map(g=>l(r,g,t))).then(()=>{}),i=p(r,a.identifier,o,t);return Promise.all([u,i]).then(()=>{c(void 0)}),h}e.$vsb=k;async function l(r,a,s){for(const n of r.folders)if(await r.exists(y.$Hg(M.URI.revive(n),a))){s(`workspaceContains:${a}`);return}}async function p(r,a,s,n){if(s.length===0)return Promise.resolve(void 0);const o=new I.$6d,c=r.checkExists(r.folders,s,o.token),h=setTimeout(async()=>{o.cancel(),r.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let t=!1;try{t=await c}catch(u){A.$4(u)||A.$1(u)}o.dispose(),clearTimeout(h),t&&n(`workspaceContains:${s.join(",")}`)}function b(r,a,s,n){const o=r.get(P.$5h),c=r.get(f.$uJ),t=o.createInstance(m.$NK).file(a.map(u=>(0,w.$oi)(M.URI.revive(u))),{_reason:"checkExists",includePattern:s,exists:!0});return c.fileSearch(t,n).then(u=>!!u.limitHit,u=>A.$4(u)?!1:Promise.reject(u))}e.$wsb=b}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,216,83,36,24,105,15,23,22,200,7,100,4,27,85,17,71,86,65,5,286,82,202,11,80,63,21,81]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u,i,g,$,d,S,L,v,E,D,T,O,G,q,z,C,N){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=e.$_gc=void 0,e.$_gc=(0,i.$6h)("IHostUtils");let ae=W=class extends m.$Tc{constructor(Z,V,ne,Ie,Le,Ce,ce,te,Q,ee,me,ve){super(),this.X=ve,this.a=this.B(new E.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ie,this.m=Le,this.s=Ce,this.t=Q,this.u=ee,this.w=me,this.y=this.g.getProxy(k.$0K.MainThreadWorkspace),this.z=this.g.getProxy(k.$0K.MainThreadTelemetry),this.C=this.g.getProxy(k.$0K.MainThreadExtensionService),this.D=new P.$5g,this.F=new P.$5g,this.G=new P.$5g,this.H=new P.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new s.$q8b(this.I,this.f.extensions.allExtensions);const Ae=new o.$mm(this.f.extensions.myExtensions);this.J=new s.$q8b(this.I,$e(this.L,Ae)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ye(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ye(this.J)}`)),this.M=new b.$Wgc(this.g,this.s),this.N=new T.$5gc(this.g),this.O=te,this.h=Z.createChild(new S.$4h([b.$Xgc,this.M],[T.$6gc,this.N])),this.P=this.B(new p.$Vgc(this.J,this.L,{onExtensionActivationError:(he,Ee,F)=>{this.C.$onExtensionActivationError(he,n.$3(Ee),F)},actualActivateExtension:async(he,Ee)=>{if(s.$q8b.isHostExtension(he,this.J,this.L))return await this.C.$activateExtension(he,Ee),new p.$Ugc;const F=this.J.getExtensionDescription(he);return this.db(F,Ee)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Z){n.$1(Z)}}async Y(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(Le=>Le.identifier).filter(Le=>this.isActivated(Le)).map(Le=>this.cb(Le))}catch{}await Promise.all(Z)}terminate(Z,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,P.$7g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const V=await this.C.$getExtension(Z);return V&&{...V,identifier:new o.$lm(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(Z,V){return this.P.activateByEvent(Z,V)}$(Z,V){return this.P.activateById(Z,V)}activateByIdWithErrors(Z,V){return this.$(Z,V).then(()=>{const ne=this.P.getActivatedExtension(Z);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async ab(Z){if(Z.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Z.fsPath);return w.URI.file(V)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Z=>new ie(Z))),this.Q}async bb(Z){const V=f.$_h.forUris(ne=>A.$yg.ignorePathCasing(ne));return await Promise.all(Z.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(Z){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return V;const ne=this.P.getActivatedExtension(Z);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(Ie)}try{(0,m.$Oc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(Ie)}return V}async db(Z,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.fb(Z,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Z,V,"success",Ie),ne},ne=>{throw this.eb(Z,V,"failure"),ne})}eb(Z,V,ne,Ie){const Le=we(Z,V);this.z.$publicLog2("extensionActivationTimes",{...Le,...Ie||{},outcome:ne})}fb(Z,V){const ne=we(Z,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(Z);if(!Ie)return Promise.resolve(new p.$Tgc(p.$Qgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Z.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Le=new p.$Rgc(V.startup);return Promise.all([this.vb(Z,(0,A.$Hg)(Z.extensionLocation,Ie),Le),this.gb(Z)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),W.hb(this.s,Z.identifier,Ce[0],Ce[1],Le))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),Ce))}gb(Z){const V=new h.$Zgc(Z,this.M),ne=new h.$Ygc(Z.identifier.value,!1,this.M),Ie=new O.$7gc(Z,this.N),Le=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ce=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let te,Q;const ee=(0,a.$BF)(Z,"ipc")?this.f.messagePorts?.get(o.$lm.toKey(Z.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(me){return M.$jc(Z.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Z).fsPath},get logPath(){return M.$jc(ce.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,Z.identifier.value)},get storageUri(){return ce.O.workspaceValue(Z)},get globalStorageUri(){return ce.O.globalValue(Z)},get extensionMode(){return Le},get extension(){return te===void 0&&(te=new le(ce,Z.identifier,Z,Ce,!1)),te},get extensionRuntime(){return(0,a.$CF)(Z,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!Q){if(!ee)return;const me=E.Event.buffer(E.Event.fromDOMEventEmitter(ee,"message",ve=>ve.data));ee.start(),Q={onDidReceiveMessage:me,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Z,V,ne,Ie,Le){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Z,V,ne,Ie,Le).then(Ce=>new p.$Sgc(!1,null,Le.build(),ne,Ce,Ie.subscriptions))}static ib(Z,V,ne,Ie,Le){if(typeof ne.activate=="function")try{Le.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ne.activate.apply(Ce,[Ie]);return Le.activateCallStop(),Le.activateResolveStart(),Promise.resolve(ce).then(te=>(Le.activateResolveStop(),te))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(Z,V){this.$(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(Z,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Le=V;Le<Z.length;Le+=1){const Ce=Z[Le];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Z,Le);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(Z=>{const V=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Le of Ie.activationEvents)Le==="onStartupFinished"&&this.jb(Ie,Le)})}mb(){const Z=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Le=Promise.all([Ie,Z,ne]).then(()=>{});return Promise.race([Le,(0,P.$7g)(1e4)]).then(()=>{this.lb()}),Le}nb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Z,V))).then(()=>{})}async ob(Z,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Z.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,te)=>this.y.$checkExists(Ce,ce,te)},Le=await(0,D.$vsb)(Ie,V);if(Le)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Le.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Z){throw console.error(Z),Z}}async qb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:V}=this.f.environment;if(!Z||!V)throw new Error(y.localize(0,null));const ne=await this.vb(null,V,new p.$Rgc(!1));if(!ne||typeof ne.run!="function")throw new Error(y.localize(1,null,V.toString()));return new Promise((Ie,Le)=>{const Ce=(Q,ee)=>{Q?(C.$t&&this.s.error("Test runner called back with error",Q),Le(Q)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,A.$vg)(V),te=ne.run(ce,Ce);te&&te.then&&te.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{C.$t&&this.s.error("Test runner finished with error",Q),Le(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,P.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,V){return this.R[Z]=V,(0,m.$Rc)(()=>{delete this.R[Z]})}async getRemoteExecServer(Z){const{resolver:V}=await this.sb(Z);return V?.resolveExecServer?.(Z,{resolveAttempt:0})}async sb(Z){const V=Z.indexOf("+");if(V===-1)throw new t.$fL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Z.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Z,V){const ne=z.$Rd.create(!1),Ie=()=>`[resolveAuthority(${(0,u.$_k)(Z)},${V})][${ne.elapsed()}ms] `,Le=K=>this.s.info(`${Ie()}${K}`),Ce=K=>this.s.warn(`${Ie()}${K}`),ce=(K,j=void 0)=>this.s.error(`${Ie()}${K}`,j),te=K=>{if(K instanceof t.$fL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},Q=async K=>{Le(`activating resolver for ${K}...`);const{resolver:j,authorityPrefix:Y}=await this.sb(K);if(!j)throw ce(`no resolver for ${Y}`),new t.$fL(`No remote extension installed to resolve ${Y}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:Y,remoteAuthority:K}},ee=Z.split(/@|%40/g).reverse();Le(`activating remote resolvers ${ee.join(" -> ")}`);let me;try{me=await Promise.all(ee.map(Q)).catch(async K=>{if(!(K instanceof t.$fL)||K._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Ce(`resolving nested authorities failed: ${K.message}`),[await Q(Z)]})}catch(K){return te(K)}const ve=new P.$eh;ve.cancelAndSet(()=>Le("waiting..."),1e3);let Ae,he;for(const[K,{authorityPrefix:j,resolver:Y,remoteAuthority:x}]of me.entries())try{if(K===me.length-1)Le("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${j}`),Ae=await Y.resolve(x,{resolveAttempt:V,execServer:he}),I.mark(`code/extHost/didResolveAuthorityOK/${j}`),Le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Y,t.$eL.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(Le(`invoking resolveExecServer() for ${x}`),I.mark(`code/extHost/willResolveExecServer/${j}`),he=await Y.resolveExecServer?.(x,{resolveAttempt:V,execServer:he}),!he)throw new t.$fL(`Exec server was not available for ${x}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(ke){return I.mark(`code/extHost/didResolveAuthorityError/${j}`),ce("returned an error",ke),ve.dispose(),te(ke)}ve.dispose();const Ee={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};Le(`returned ${t.$eL.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let H;if(t.$eL.isManagedResolvedAuthority(Ae)){const K=V;this.X.setFactory(K,Ae.makeConnection),H={authority:Z,connectTo:new u.$9k(K),connectionToken:Ae.connectionToken}}else H={authority:Z,connectTo:new u.$0k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:H,options:F,tunnelInformation:Ee}}}async $getCanonicalURI(Z,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$_k)(Z)})`);const{resolver:ne}=await this.sb(Z);if(!ne)return null;const Ie=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Le=await(0,P.$Yg)(()=>ne.getCanonicalURI(Ie));return Le||Ie}$startExtensionHost(Z){Z.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=de(this.I,this.L,this.J,Z);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ye(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ye(this.J)}`)),this.rb()}$activateByEvent(Z,V){return V===1?this.D.wait().then(ne=>this.Z(Z,!1)):this.G.wait().then(ne=>this.Z(Z,!1))}async $activate(Z,V){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.$(Z,V),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=de(this.I,this.L,this.J,Z),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ye(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ye(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const V=c.$je.alloc(Z),ne=Math.random()%256;for(let Ie=0;Ie<Z;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(Z){this.W=Z,this.a.fire()}};e.$ahc=ae,e.$ahc=ae=W=Je([He(0,i.$5h),He(1,e.$_gc),He(2,d.$bN),He(3,r.$zgc),He(4,l.$Cgc),He(5,R.$nj),He(6,g.$rN),He(7,$.$Fgc),He(8,L.$vyb),He(9,v.$1gc),He(10,q.$9gc),He(11,N.$0gc)],ae);function de(se,Z,V,ne){se.addActivationEvents(ne.addActivationEvents);const Ie=new s.$q8b(se,Z.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Le=new o.$mm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Le.delete(ce);for(const ce of ne.myToAdd)Le.add(ce);const Ce=$e(Ie,Le);return{globalRegistry:Ie,myExtensions:Ce}}function we(se,Z){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function ye(se){return se.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$bhc=(0,i.$6h)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Z,V,ne,Ie,Le){this.#e=Z,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.$hc((0,A.$vg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$chc=le;function $e(se,Z){return se.getAllExtensionDescriptions().filter(V=>Z.has(V.identifier))}class ie{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$dhc=ie;class be{constructor(Z){this.a=new o.$nm,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const V of Object.keys(Z))this.a.set(V,Z[V])}}}),define(Pe[287],Re([1,0,88,2,3,37,24,23,17,27,4,38,14,12]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;let r=class{constructor(c,h,t,u,i,g,$){this.c=c,this.d=h,this.e=t,this.f=u,this.g=i,this.h=g,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$lic=r,e.$lic=r=Je([He(2,R.$5h),He(3,A.$Cgc),He(4,k.$bhc),He(5,w.$rN),He(6,l.$nj)],r);let a=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,p.$Oe)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${i}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,u,i]=h,g=b.a.get(u);if(g!==void 0)return console.warn(`${u} as been renamed to ${g}, please update your imports`),t+g+i}c(c){return c.replace(/\\/g,"/")}};a=b=Je([He(0,w.$rN)],a);class s{constructor(c,h,t,u,i){this.c=c,this.d=h,this.e=t,this.f=u,this.g=i,this.nodeModuleName="vscode",this.a=new m.$nm}load(c,h){const t=this.d.findSubstr(h);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((i,g)=>u+=`	${g} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${u}`),this.b=this.c(P.$wF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$0K.MainThreadTelemetry);const u=t.getProxy(I.$0K.MainThreadWindow);this.c=(i,g)=>{const $=M.URI.parse(i);return g?this.g(i,g):$.scheme==="http"||$.scheme==="https"?u.$openUri($,i,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?u.$openUri($,i,{}):this.g(i,g)}}load(c,h,t){const u=this.e.findSubstr(h);return u&&(this.a=u.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([He(2,f.$bN)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,66,64,38,7,36,213,37]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0,e.$ehc=(0,P.$6h)("IExtHostVariableResolverProvider");class b extends l.$cO{constructor(s,n,o,c,h,t,u){function i(){if(o){const g=o.activeEditor();if(g)return g.document.uri;const $=c.tabGroups.all.find(d=>d.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$SM||$.input instanceof R.$XM)return $.input.modified;if($.input instanceof R.$RM||$.input instanceof R.$WM||$.input instanceof R.$UM)return $.input.uri}}}super({getFolderUri:g=>{const $=t.folders.filter(d=>d.name===g);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,$)=>h.getConfiguration(void 0,g).get($),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=i();if(g)return I.$hc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const g=i();if(g){const $=n.getWorkspaceFolder(g);if($)return I.$hc($.uri.fsPath)}}},getSelectedText:()=>{if(o){const g=o.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(o){const g=o.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>s.getExtension(g)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(A.env))}}let r=class extends M.$Tc{constructor(s,n,o,c,h){super(),this.b=s,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new y.$V(async()=>{const t=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,t,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$fhc=r,e.$fhc=r=Je([He(0,w.$bhc),He(1,k.$zgc),He(2,m.$mN),He(3,p.$Cgc),He(4,f.$Ogc)],r)}),define(Pe[117],Re([1,0,13,5,2,4,3,64,38,17,7,36,206,208,37,116]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0,e.$ghc=(0,A.$6h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,i,g,$,d,S){this.E=i,this.F=g,this.G=$,this.H=d,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Vd,this.n=new M.$Vd,this.o=new M.$Vd,this.u=new M.$Vd,this.k=u.getProxy(P.$0K.MainThreadDebugService),this.y=new M.$Vd,this.A=new M.$Vd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(u,i){const g=u;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let $=`debug:${encodeURIComponent(g.path||"")}`,d="?";return i&&($+=`${d}session=${encodeURIComponent(i.id)}`,d="&"),$+=`${d}ref=${g.sourceReference}`,I.URI.parse($)}else{if(g.path)return I.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const i=[];for(const g of u.getAllExtensionDescriptions())if(g.contributes){const $=g.contributes.debuggers;if($&&$.length>0)for(const d of $)(0,p.$bG)(d)&&i.push(d.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(i=>u.push(i)),u}addBreakpoints(u){const i=u.filter(d=>{const S=d.id;return this.w.has(S)?!1:(this.w.set(S,d),!0)});this.U(i,[],[]);const g=[],$=new Map;for(const d of i)if(d instanceof R.$_L){let S=$.get(d.location.uri.toString());S||(S={type:"sourceMulti",uri:d.location.uri,lines:[]},$.set(d.location.uri.toString(),S),g.push(S)),S.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$aM&&g.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(g)}removeBreakpoints(u){const i=u.filter(S=>this.w.delete(S.id));this.U([],i,[]);const g=i.filter(S=>S instanceof R.$_L).map(S=>S.id),$=i.filter(S=>S instanceof R.$aM).map(S=>S.id),d=i.filter(S=>S instanceof R.$bM).map(S=>S.id);return this.k.$unregisterBreakpoints(g,$,d)}startDebugging(u,i,g){return this.k.$startDebugging(u?u.uri:void 0,i,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,i,g){if(!i)return new R.$_K(()=>{});const $=this.d++;return this.f.push({type:u,handle:$,provider:i}),this.k.$registerDebugConfigurationProvider(u,g,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,$),new R.$_K(()=>{this.f=this.f.filter(d=>d.provider!==i),this.k.$unregisterDebugConfigurationProvider($)})}registerDebugAdapterDescriptorFactory(u,i,g){if(!g)return new R.$_K(()=>{});if(!this.Q(u,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const $=this.g++;return this.h.push({type:i,handle:$,factory:g}),this.k.$registerDebugAdapterDescriptorFactory(i,$),new R.$_K(()=>{this.h=this.h.filter(d=>d.factory!==g),this.k.$unregisterDebugAdapterDescriptorFactory($)})}registerDebugAdapterTrackerFactory(u,i){if(!i)return new R.$_K(()=>{});const g=this.i++;return this.j.push({type:u,handle:g,factory:i}),new R.$_K(()=>{this.j=this.j.filter($=>$.factory!==i)})}async $runInTerminal(u,i){return Promise.resolve(void 0)}async $substituteVariables(u,i){let g;const $=await this.W(u);return $&&(g={uri:$.uri,name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(g,i)}K(u,i){if(u.type==="implementation")return new c(u.implementation)}L(){}async $startDASession(u,i){const g=this,$=await this.V(i);return this.S(this.N($.type),$).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}' (extension might have failed to activate)`);const S=this.M(d),L=this.K(S,$);if(!L)throw new Error(`Couldn't create a debug adapter for type '${$.type}'.`);const v=L;return this.B.set(u,v),this.R($).then(E=>(E&&this.C.set(u,E),v.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const T=D,O={type:"response",seq:0,command:T.command,request_seq:T.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const G=await this.D.sign(T.arguments.value);O.body={signature:G},v.sendResponse(O)}else throw new Error("no signer")}catch(G){O.success=!1,O.message=G.message,v.sendResponse(O)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(D),D=(0,p.$gG)(D,!0),g.k.$acceptDAMessage(u,D)}),v.onError(D=>{E&&E.onError&&E.onError(D),this.k.$acceptDAError(u,D.name,D.message,D.stack)}),v.onExit(D=>{E&&E.onExit&&E.onExit(D??void 0,void 0),this.k.$acceptDAExit(u,D??void 0,void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),v.startSession()))})}$sendDAMessage(u,i){i=(0,p.$fG)(i,!1);const g=this.C.get(u);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(i),this.B.get(u)?.sendMessage(i)}$stopDASession(u){const i=this.C.get(u);this.C.delete(u),i&&i.onWillStopSession&&i.onWillStopSession();const g=this.B.get(u);return this.B.delete(u),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const i=[],g=[],$=[];if(u.added)for(const d of u.added){const S=d.id;if(S&&!this.w.has(S)){let L;if(d.type==="function")L=new R.$aM(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")L=new R.$bM(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const v=I.URI.revive(d.uri);L=new R.$_L(new R.$lL(v,new R.$aL(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$0L)(L,S),this.w.set(S,L),i.push(L)}}if(u.removed)for(const d of u.removed){const S=this.w.get(d);S&&(this.w.delete(d),g.push(S))}if(u.changed){for(const d of u.changed)if(d.id){const S=this.w.get(d.id);if(S){if(S instanceof R.$aM&&d.type==="function"){const L=S;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.functionName=d.functionName}else if(S instanceof R.$_L&&d.type==="source"){const L=S;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.location=new R.$lL(I.URI.revive(d.uri),new R.$aL(d.line,d.character))}$.push(S)}}}this.U(i,g,$)}async $acceptStackFrameFocus(u){let i;const g=u.sessionId?await this.V(u.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?i=new R.$hM(g,u.threadId):i=new R.$gM(g,u.threadId,u.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(u,i,g){return(0,y.$Yg)(async()=>{const $=this.P(u);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(i);return $.provideDebugConfigurations(d,g)}).then($=>{if(!$)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return $})}$resolveDebugConfiguration(u,i,g,$){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(i);return d.resolveDebugConfiguration(S,g,$)})}$resolveDebugConfigurationWithSubstitutedVariables(u,i,g,$){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(i);return d.resolveDebugConfigurationWithSubstitutedVariables(S,g,$)})}async $provideDebugAdapter(u,i){const g=this.O(u);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const $=await this.V(i);return this.S(g,$).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const i=await this.V(u);this.m.fire(i)}async $acceptDebugSessionTerminated(u){const i=await this.V(u);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,i){(await this.V(u))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(u,i){const $={session:await this.V(u),event:i.event,body:i.body};this.u.fire($)}M(u){if(u instanceof R.$cM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof R.$dM)return{type:"server",port:u.port,host:u.host};if(u instanceof R.$eM)return{type:"pipeServer",path:u.path};if(u instanceof R.$fM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const i=this.h.filter(g=>g.type===u);if(i.length>0)return i[0].factory}O(u){const i=this.h.filter(g=>g.handle===u);if(i.length>0)return i[0].factory}P(u){const i=this.f.filter(g=>g.handle===u);if(i.length>0)return i[0].provider}Q(u,i){if(u.contributes){const g=u.contributes.debuggers;if(g&&g.length>0){for(const $ of g)if($.label&&$.type&&$.type===i)return!0}}return!1}R(u){const g=u.configuration.type,$=this.j.filter(d=>d.type===g||d.type==="*").map(d=>(0,y.$Yg)(()=>d.factory.createDebugAdapterTracker(u)).then(S=>S,S=>null));return Promise.race([Promise.all($).then(d=>{const S=d.filter(L=>!!L);if(S.length>0)return new o(S)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,i){const g=i.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new R.$dM(g));if(u){const d=await this.F.getExtensionRegistry();return(0,y.$Yg)(()=>u.createDebugAdapterDescriptor(i,this.T(i,d))).then(S=>{if(S)return S})}const $=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,$))}T(u,i){}U(u,i,g){(u.length>0||i.length>0||g.length>0)&&this.y.fire(Object.freeze({added:u,removed:i,changed:g}))}async V(u){if(u)if(typeof u=="string"){const i=this.l.get(u);if(i)return i}else{let i=this.l.get(u.id);if(!i){const g=await this.W(u.folderUri),$=u.parent?this.l.get(u.parent):void 0;i=new s(this.k,u.id,u.type,u.name,g,u.configuration,$),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(u){if(u){const i=I.URI.revive(u);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$hhc=a,e.$hhc=a=Je([He(0,w.$bN),He(1,k.$zgc),He(2,f.$bhc),He(3,b.$Cgc),He(4,m.$Ogc),He(5,r.$ehc)],a);class s{constructor(u,i,g,$,d,S,L){this.d=u,this.f=i,this.g=g,this.h=$,this.i=d,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,i){return this.d.$customDebugAdapterRequest(this.f,u,i)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$ihc=s;class n{constructor(u){this.value=Object.freeze({append(i){u.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$jhc=n;class o{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(i=>i.onError?i.onError(u):void 0)}onExit(u,i){this.d.forEach(g=>g.onExit?g.onExit(u,i):void 0)}}class c extends l.$Nlb{constructor(u){super(),this.h=u,u.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends a{constructor(u,i,g,$,d,S){super(u,i,g,$,d,S)}};e.$khc=h,e.$khc=h=Je([He(0,w.$bN),He(1,k.$zgc),He(2,f.$bhc),He(3,b.$Cgc),He(4,m.$Ogc),He(5,r.$ehc)],h)}),define(Pe[288],Re([1,0,15,88,2,3,233,14,53,71,27,184,17,58,38,60]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(m.$nj),t=o.get(l.$bN).getProxy(A.$0K.MainThreadErrors);y.setUnexpectedErrorHandler(u=>{c.error(u);const i=y.$3(u);t.$onUnexpectedError(i)})}static async installFullHandler(o){const c=o.get(m.$nj),h=o.get(l.$bN),t=o.get(b.$bhc),u=o.get(r.$vN),i=h.getProxy(A.$0K.MainThreadExtensionService),g=h.getProxy(A.$0K.MainThreadErrors),$=await t.getExtensionPathIndex(),d=new WeakMap;function S(E,D){if(d.has(E))return d.get(E).stack;let T="",O,G;for(const z of D)T+=`
	at ${z.toString()}`,G=z.getFileName(),!O&&G&&(O=$.findSubstr(I.URI.file(G)));const q=`${E.name||"Error"}: ${E.message||""}${T}`;return d.set(E,{extensionIdentifier:O?.identifier,stack:q}),q}const L=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(E){if(E===S||!E||E[L]){v=E||S;return}v=function(D,T){return S(D,T),E.call(Error,D,T)},Object.assign(v,{[L]:!0})}}),y.setUnexpectedErrorHandler(E=>{c.error(E);const D=y.$3(E),T=d.get(E);if(!T?.extensionIdentifier){g.$onUnexpectedError(D);return}i.$onExtensionRuntimeError(T.extensionIdentifier,D);const O=u.onExtensionError(T.extensionIdentifier,E);c.trace("forwarded error to extension?",O,T)})}}e.$mic=a;class s{constructor(o,c,h,t,u){this.a=h,this.b=new P.$y8b(o,null,t),c=s.e(c,this.b);const i=new w.$4h(...(0,f.$Zr)());i.set(R.$rN,{_serviceBrand:void 0,...c,messagePorts:u}),i.set(l.$bN,new l.$cN(this.b)),i.set(p.$wgc,new p.$xgc(t)),i.set(b.$_gc,h);const g=new k.$Eq(i,!0);g.invokeFunction(a.installEarlyHandler),this.d=g.invokeFunction($=>$.get(m.$nj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction($=>$.get(b.$bhc)),this.c.initialize(),g.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(A.$0K.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=I.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(t=>I.URI.revive(c.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=I.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$nic=s}),define(Pe[289],Re([1,0,18,13,20,40,11,19,25,2,43]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class k{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new I.$6d(o);return new Promise((t,u)=>{this.a=new p(n);let i=!1;const g=($,d)=>{if(!i&&!this.b){const S=this.h($);r($)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,i=!0,h.cancel(),$=this.j($,this.d.maxResults-this.c));const L=this.h($);this.c+=L,(L>0||!r($))&&this.a.add($,d)}};Promise.all(c.map(($,d)=>this.k($,S=>g(S,d),h.token))).then($=>{h.dispose(),this.a.flush();const d=$.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||d,messages:(0,y.$Rb)($.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},$=>{h.dispose();const d=(0,A.$Qi)($);u(new Error(d))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new R.$NJ(this.d,n),t=[],u={report:$=>{if(!this.l($))return;const d=n.folder.scheme===P.Schemas.file?(0,R.$OJ)(()=>this.f.readdir(f.$Gg($.uri))):void 0,S=f.$Jg(n.folder,$.uri);if(S){const L=h.includedInQuery(S,m.$nc(S),d);(0,M.$Sg)(L)?t.push(L.then(v=>{v&&o($)})):L&&o($)}}},i=this.n(n),g=await this.e.provideTextSearchResults(l(this.d.contentPattern),i,u,c);return t.length&&await Promise.all(t),g}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,R.$MJ)(this.d.includePattern,n.includePattern),c=(0,R.$MJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$yhc=k;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!f.$Ag(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$zhc=p;function b(s){return r(s)?{preview:{matches:(0,y.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,y.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}e.$Ahc=r;class a{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bhc=a}),define(Pe[118],Re([1,0,6,3,4,284,17,58,14,2,289]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=e.$Chc=void 0,e.$Chc=(0,I.$6h)("IExtHostSearch");let k=class{constructor(r,a,s){this.k=r,this.l=a,this.n=s,this.c=this.k.getProxy(M.$0K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$xhc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,a){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,a),this.c.$registerTextSearchProvider(s,this.o(r)),(0,y.$Rc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,a){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,a),this.c.$registerFileSearchProvider(s,this.o(r)),(0,y.$Rc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,a,s,n){const o=l(s),c=this.h.get(r);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(r,a,h.map(t=>t.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,a,s){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,a,s,n){const o=this.e.get(r);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(s);return this.q(c,o).search(t=>this.c.$handleTextMatch(r,a,t),n)}$enableExtensionHostSearch(){}q(r,a){return new R.$yhc(r,a,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Dhc=k,e.$Dhc=k=Je([He(0,P.$bN),He(1,m.$wgc),He(2,f.$nj)],k);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(r=>w.URI.revive(r))}}e.$Ehc=l;function p(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Pe[290],Re([1,0,20,15,5,6,11,31,2,146,142,130,93,23,41,14,56,57,197,3,236,268,79,237,243,244,245,246,247,222,211,32,248,37,249,117,107,250,224,238,251,252,66,64,239,38,254,62,255,42,27,269,270,240,225,256,257,80,81,227,283,259,201,260,271,261,112,228,262,263,264,17,265,118,82,266,229,267,83,85,115,60,65,272,273,241,274,275,86,8,7,230,58,231,61,276,277,106,36,207,78,24,114]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u,i,g,$,d,S,L,v,E,D,T,O,G,q,z,C,N,W,ae,de,we,ye,le,$e,ie,be,se,Z,V,ne,Ie,Le,Ce,ce,te,Q,ee,me,ve,Ae,he,Ee,F,H,K,j,Y,x,ke,Te,Ve,Ke,Xe,st,nt,tt,at,ct,Ue,vt,X,_,pe,Be,Qe,it,rt,Ne,Pt,Tt,Kt,Bt,yt,Ht,Nt,Yt,zt,Rt,Ze,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;function Jt(lt){const $t=lt.get(Z.$rN),Ut=lt.get(se.$egc),Vt=lt.get(ie.$Egc),kt=lt.get(le.$bhc),dt=lt.get(Yt.$zgc),Ct=lt.get(Ue.$vN),xt=lt.get(T.$Cgc),Dt=lt.get(Tt.$wgc),qe=lt.get(ke.$bN),Mt=lt.get(tt.$Xgc),Wt=lt.get(at.$Fgc),Qt=lt.get(r.$oj),ft=lt.get(r.$nj),Ft=lt.get(it.$vyb),Se=lt.get(t.$hgc),Fe=lt.get(Nt.$gic),fe=lt.get(Ke.$6gc),J=lt.get(we.$Ogc),Me=lt.get(Q.$0gc);qe.set(o.$$K.ExtHostFileSystemInfo,Ut),qe.set(o.$$K.ExtHostLogLevelServiceShape,Qt),qe.set(o.$$K.ExtHostWorkspace,dt),qe.set(o.$$K.ExtHostConfiguration,xt),qe.set(o.$$K.ExtHostExtensionService,kt),qe.set(o.$$K.ExtHostStorage,Mt),qe.set(o.$$K.ExtHostTunnelService,Ft),qe.set(o.$$K.ExtHostWindow,Fe),qe.set(o.$$K.ExtHostSecretState,fe),qe.set(o.$$K.ExtHostTelemetry,Ct),qe.set(o.$$K.ExtHostEditorTabs,J),qe.set(o.$$K.ExtHostManagedSockets,Me);const je=qe.set(o.$$K.ExtHostDecorations,lt.get(q.$mhc)),Ye=qe.set(o.$$K.ExtHostDocumentsAndEditors,lt.get(de.$mN)),We=qe.set(o.$$K.ExtHostCommands,lt.get(E.$xN)),_e=qe.set(o.$$K.ExtHostTerminalService,lt.get(vt.$1gc)),mt=qe.set(o.$$K.ExtHostDebugService,lt.get(G.$ghc)),jt=qe.set(o.$$K.ExtHostSearch,lt.get(Ve.$Chc)),Et=qe.set(o.$$K.ExtHostTask,lt.get(ct.$6hc)),St=qe.set(o.$$K.ExtHostOutputService,lt.get(H.$Shc)),wt=qe.set(o.$$K.ExtHostLocalization,lt.get(te.$9gc)),gi=qe.set(o.$$K.ExtHostUrls,new Kt.$dic(qe)),At=qe.set(o.$$K.ExtHostDocuments,new ae.$cgc(qe,Ye)),Si=qe.set(o.$$K.ExtHostDocumentContentProviders,new N.$ohc(qe,Ye,ft)),Gi=qe.set(o.$$K.ExtHostDocumentSaveParticipant,new W.$phc(ft,At,qe.getProxy(o.$0K.MainThreadBulkEdits))),It=qe.set(o.$$K.ExtHostNotebook,new me.$Fhc(qe,We,Ye,At,Vt,jt)),ri=qe.set(o.$$K.ExtHostNotebookDocuments,new Ae.$Mhc(It)),mi=qe.set(o.$$K.ExtHostNotebookEditors,new he.$Nhc(ft,It)),ci=qe.set(o.$$K.ExtHostNotebookKernels,new Ee.$Ohc(qe,$t,It,We,ft)),Ii=qe.set(o.$$K.ExtHostNotebookRenderers,new F.$Qhc(qe,It)),Ci=qe.set(o.$$K.ExtHostNotebookDocumentSaveParticipant,new ve.$Lhc(ft,It,qe.getProxy(o.$0K.MainThreadBulkEdits))),Ot=qe.set(o.$$K.ExtHostEditors,new _.$tgc(qe,Ye)),$i=qe.set(o.$$K.ExtHostTreeViews,new Qe.$bic(qe.getProxy(o.$0K.MainThreadTreeViews),We,ft)),Pi=qe.set(o.$$K.ExtHostEditorInsets,new v.$ugc(qe.getProxy(o.$0K.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(o.$$K.ExtHostDiagnostics,new z.$ggc(qe,ft,Ut,Ye)),li=qe.set(o.$$K.ExtHostLanguages,new ce.$Jhc(qe,At,We.converter,Dt)),ht=qe.set(o.$$K.ExtHostLanguageFeatures,new Ce.$kgc(qe,Dt,At,We,ui,ft,Se,Ct)),Ji=qe.set(o.$$K.ExtHostFileSystem,new $e.$rhc(qe,ht)),_t=qe.set(o.$$K.ExtHostFileSystemEventService,new be.$shc(qe,ft,Ye)),si=qe.set(o.$$K.ExtHostQuickOpen,(0,x.$Whc)(qe,dt,We)),pi=qe.set(o.$$K.ExtHostSCM,new Te.$Yhc(qe,We,At,ft)),Ri=qe.set(o.$$K.ExtHostQuickDiff,new Y.$Vhc(qe,Dt)),Qi=qe.set(o.$$K.ExtHostShare,new Xe.$Zhc(qe,Dt)),Ai=qe.set(o.$$K.ExtHostComments,(0,D.$vgc)(qe,We,At)),vi=qe.set(o.$$K.ExtHostProgress,new j.$Uhc(qe.getProxy(o.$0K.MainThreadProgress))),Yi=qe.set(o.$$K.ExtHostLabelService,new Le.$Ihc(qe)),Li=qe.set(o.$$K.ExtHostTheming,new pe.$$hc(qe)),hi=qe.set(o.$$K.ExtHostAuthentication,new u.$mgc(qe)),Xi=qe.set(o.$$K.ExtHostTimeline,new Be.$aic(qe,We)),bi=qe.set(o.$$K.ExtHostWebviews,new Bt.$Jgc(qe,$t.remote,dt,ft,Se)),Mi=qe.set(o.$$K.ExtHostWebviewPanels,new yt.$Mgc(qe,bi,dt)),un=qe.set(o.$$K.ExtHostCustomEditors,new O.$Ngc(qe,At,Wt,bi,Mi)),Fi=qe.set(o.$$K.ExtHostWebviewViews,new Ht.$eic(qe,bi)),oi=qe.set(o.$$K.ExtHostTesting,new X.$7hc(qe,ft,We,Ye)),ln=qe.set(o.$$K.ExtHostUriOpeners,new Pt.$cic(qe)),hn=qe.set(o.$$K.ExtHostProfileContentHandlers,new K.$Thc(qe));qe.set(o.$$K.ExtHostInteractive,new ne.$Ghc(qe,It,Ye,We,ft));const Zi=qe.set(o.$$K.ExtHostInlineChat,new V.$thc(qe,We,At,ft)),di=qe.set(o.$$K.ExtHostChatProvider,new d.$pgc(qe,ft)),xi=qe.set(o.$$K.ExtHostChatAgents2,new $.$qgc(qe,di,ft)),_i=qe.set(o.$$K.ExtHostChatVariables,new S.$rgc(qe)),wi=qe.set(o.$$K.ExtHostChat,new g.$ogc(qe)),en=qe.set(o.$$K.ExtHostAiRelatedInformation,new c.$bgc(qe)),Ti=qe.set(o.$$K.ExtHostAiEmbeddingVector,new ye.$qhc(qe)),Ni=qe.set(o.$$K.ExtHostIssueReporter,new Ie.$Hhc(qe)),ei=qe.set(o.$$K.ExtHostStatusBar,new nt.$3hc(qe,We.converter)),yi=qe.set(o.$$K.ExtHostSpeech,new st.$1hc(qe)),dn=Object.values(o.$$K);qe.assertRegistered(dn);const Xt=new i.$ngc(qe,Ye),Ei=new L.$sgc(qe),ki=new ee.$Khc(qe,ft),Oi=new C.$nhc(qe);return h.$lgc.register(We),function(ze,ti,tn){function et(re){return(ue,Oe,ot)=>{const bt=re(Lt=>{try{ue.call(Oe,Lt)}catch(cn){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event`,{cause:cn})),Ct.onExtensionError(ze.identifier,cn)}});return ot?.push(bt),bt}}const pt=function(){let re=!ze.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const bt=ot;typeof bt.scheme>"u"&&ue(),typeof bt.exclusive=="boolean"&&(0,Ze.$CF)(ze,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,ue,Oe){return hi.getSession(ze,re,ue,Oe)},getSessions(re,ue){return(0,Ze.$CF)(ze,"authGetSessions"),hi.getSessions(ze,re,ue)},async hasSession(re,ue){return(0,Ze.$CF)(ze,"authSession"),!!await hi.getSession(ze,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},gn={registerCommand(re,ue,Oe){return We.registerCommand(!0,re,ue,Oe,void 0,ze)},registerTextEditorCommand(re,ue,Oe){return We.registerCommand(!0,re,(...ot)=>{const bt=Ot.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Lt=>{ue.apply(Oe,[bt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ze.$CF)(ze,"diffCommand"),We.registerCommand(!0,re,async(...ot)=>{const bt=Ye.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(bt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,ze)),executeCommand(re,...ue){return We.executeCommand(re,...ue)},getCommands(re=!1){return We.getCommands(re)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ue.$uN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return Ue.$tN.validateSender(re),Ct.instantiateLogger(ze,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,P.$eg)(re,P.Schemas.http)||(0,P.$eg)(re,P.Schemas.https))return re;throw ue}},get remoteName(){return(0,a.$bl)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$CF)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueUriRequestHandler(ze,re)},registerIssueDataProvider(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueDataProvider(ze,re)},get appQuality(){return(0,Ze.$CF)(ze,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$CF)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const Ui={createTestController(re,ue,Oe){return oi.createTestController(ze,re,ue,Oe)},createTestObserver(){return(0,Ze.$CF)(ze,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ze.$CF)(ze,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ze.$CF)(ze,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ze.$CF)(ze,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(re,ue){(0,Ze.$BF)(ze,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new le.$chc(kt,ze.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new le.$chc(kt,ze.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new le.$chc(kt,ze.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ze.$CF)(ze,"extensionsAny");const re=new p.$mm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new le.$chc(kt,ze.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ze.$BF)(ze,"extensionsAny")?et(I.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},rn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(ze.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,R.$Bt)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(ze,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(ze,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(ze,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(ze,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(ze,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(ze,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(ze,pt(re),ue,ze.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(ze,pt(re),ue,ze.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(ze,pt(re),ue,ze.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(ze,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(ze,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(ze,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(ze,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(ze,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(ze,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(ze,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(ze,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(ze,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(ze,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(ze,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(ze,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(ze,pt(re),ue,Oe):ht.registerSignatureHelpProvider(ze,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(ze,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(ze,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(ze,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(ze,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(ze,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(ze,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(ze,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(ze,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ze.$CF)(ze,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(ze,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(ze,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(ze,re,ue,(0,Ze.$BF)(ze,"dropMetadata")?Oe:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(f.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(ze,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Fe.getState(ze)},onDidChangeWindowState(re,ue,Oe){return et(Fe.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return ki.showMessage(ze,m.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return ki.showMessage(ze,m.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return ki.showMessage(ze,m.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(ze,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(ze,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,bt,Lt;return typeof re=="string"?(ot=re,bt=ue,Lt=Oe):(bt=re,Lt=ue),ei.createStatusBarEntry(ze,ot,bt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(ze,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,ze)},createWebviewPanel(re,ue,Oe,ot){return Mi.createWebviewPanel(ze,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,ze)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(ze,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ze.$CF)(ze,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,ze.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,ze)},createTreeView(re,ue){return $i.createTreeView(re,ue,ze)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(ze,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>un.registerCustomEditorProvider(ze,re,ue,Oe),registerFileDecorationProvider(re){return je.registerFileDecorationProvider(re,ze)},registerUriHandler(re){return gi.registerUriHandler(ze,re)},createQuickPick(){return si.createQuickPick(ze)},createInputBox(){return si.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(ze,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ze.$CF)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ze.$CF)(ze,"profileContentHandlers"),hn.registerProfileContentHandler(ze,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return J.tabGroups},registerShareProvider(re,ue){return(0,Ze.$CF)(ze,"shareProvider"),Qi.registerShareProvider(pt(re),ue)}},sn={get rootPath(){return Se.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new M.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(ze,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,ze.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ze.$CF)(ze,"findTextInFiles");let bt,Lt;return typeof ue=="object"?(bt=ue,Lt=Oe):(bt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,bt||{},Lt,ze.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Xt.applyWorkspaceEdit(re,ze,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let bt;return typeof ue=="boolean"?bt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ze.$CF)(ze,"createFileSystemWatcher"),bt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,ze,re,bt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new M.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(f.URI.file(re));else if(f.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Gi.getOnWillSaveTextDocumentEvent(ze))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(f.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=f.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(ze))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(ze,re,ue,Oe,(0,Ze.$BF)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(tn.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,tn.getConfiguration(re,ue,ze)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(ze,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,A.$Qc)(Ji.registerFileSystemProvider(ze,re,ue,Oe),Vt.addFileSystemProvider(re,ue,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"fileSearchProvider"),jt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"textSearchProvider"),jt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ze.$CF)(ze,"resolvers"),kt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ze.$CF)(ze,"resolvers"),Yi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ze.$CF)(ze,"resolvers"),kt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(ze))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(ze))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(ze))(re,ue,Oe),openTunnel:re=>((0,Ze.$CF)(ze,"tunnels"),Ft.openTunnel(ze,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ze.$CF)(ze,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ze.$CF)(ze,"tunnels"),et(Ft.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ze.$CF)(ze,"portsAttributes"),Ft.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ze.$CF)(ze,"tunnelFactory"),Ft.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ze.$CF)(ze,"timeline"),Xi.registerTimelineProvider(re,ue,ze.identifier,We.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ze.$CF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(ze))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},on={get inputBox(){return Se.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(re,ue,Oe){return pi.createSourceControl(ze,re,ue,Oe)}},an={createCommentController(re,ue){return Ai.createCommentController(ze,re,ue)}},ji={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ze.$CF)(ze,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(ze,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(ze,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(ze,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Vi={createNotebookController(re,ue,Oe,ot,bt){return ci.createNotebookController(ze,re,ue,Oe,ot,(0,Ze.$BF)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(ze,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(ze,re)},createNotebookControllerDetectionTask(re){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(ze,re)},registerKernelSourceActionProvider(re,ue){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.registerKernelSourceActionProvider(ze,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ze.$CF)(ze,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},Di={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return wt.getMessage(ze.identifier.value,{message:ue,args:Oe})}return wt.getMessage(ze.identifier.value,re[0])},get bundle(){return wt.getBundle(ze.identifier.value)},get uri(){return wt.getBundleUri(ze.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),Zi.registerProvider(ze,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),wi.registerChatProvider(ze,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),wi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ze.$CF)(ze,"interactive"),wi.transferChatSession(re,ue)}},qi={getRelatedInformation(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.getRelatedInformation(ze,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.registerRelatedInformationProvider(ze,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(ze,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"chatProvider"),di.registerProvider(ze.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ze.$CF)(ze,"chatRequestAccess"),di.requestChatResponseProvider(ze.identifier,re)},registerVariable(re,ue,Oe){return(0,Ze.$CF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ze.$CF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,re,ue)},createChatAgent(re,ue){return(0,Ze.$CF)(ze,"chatAgents2"),xi.createChatAgent(ze,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ze.$CF)(ze,"speech"),yi.registerProvider(ze.identifier,re,ue)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:ji,env:zi,extensions:nn,interactive:Wi,l10n:Di,languages:rn,notebooks:Vi,scm:on,speech:pn,tasks:Bi,tests:Ui,window:mn,workspace:sn,Breakpoint:Ne.$$L,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$3M,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$2M,CallHierarchyIncomingCall:Ne.$xL,CallHierarchyItem:Ne.$wL,CallHierarchyOutgoingCall:Ne.$yL,CancellationError:M.$5,CancellationTokenSource:y.$6d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$tL,CodeActionKind:Ne.$uL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$zL,Color:Ne.$ML,ColorInformation:Ne.$NL,ColorPresentation:Ne.$OL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$GL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$HL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$WL,DebugAdapterExecutable:Ne.$cM,DebugAdapterInlineImplementation:Ne.$fM,DebugAdapterNamedPipeServer:Ne.$eM,DebugAdapterServer:Ne.$dM,DebugConfigurationProviderTriggerKind:zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$nL,DiagnosticRelatedInformation:Ne.$mL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$_K,DocumentHighlight:Ne.$pL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$qL,DocumentLink:Ne.$LL,DocumentSymbol:Ne.$sL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$iM,InlineValueText:Ne.$jM,InlineValueVariableLookup:Ne.$kM,InlineValueEvaluatableExpression:Ne.$lM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Vd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$vM,FileDecoration2:Ne.$vM,FileSystemError:Ne.$nM,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$oM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$aM,InlineCompletionItem:Ne.$IL,InlineCompletionList:Ne.$JL,Hover:Ne.$oL,IndentAction:k.IndentAction,Location:Ne.$lL,MarkdownString:Ne.$AL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$BL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$aL,ProcessExecution:Ne.$UL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$uM,Range:Ne.$bL,RelativePattern:Ne.$9L,Selection:Ne.$cL,SelectionRange:Ne.$vL,SemanticTokens:Ne.$rM,SemanticTokensBuilder:Ne.$qM,SemanticTokensEdit:Ne.$sM,SemanticTokensEdits:Ne.$tM,SemanticTokensLegend:Ne.$pM,ShellExecution:Ne.$VL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$DL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$CL,SnippetString:Ne.$kL,SourceBreakpoint:Ne.$_L,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$rL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$XL,TaskGroup:Ne.$TL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$PL,TerminalQuickFixTerminalCommand:Ne.$RL,TerminalQuickFixOpener:Ne.$QL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$SL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$gL,SnippetTextEdit:Ne.$iL,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$8L,ThemeIcon:Ne.$7L,TreeItem:Ne.$YL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$QM,UIKind:Rt.UIKind,Uri:f.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$jL,DocumentDropEdit:Ne.$5L,DocumentPasteEdit:Ne.$6L,InlayHint:Ne.$FL,InlayHintLabelPart:Ne.$EL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$fL,ResolvedAuthority:Ne.$dL,ManagedResolvedAuthority:Ne.$eL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$FM,NotebookRange:Ne.$xM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$yM,NotebookData:Ne.$zM,NotebookRendererScript:Ne.$DM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$BM,NotebookCellOutputItem:Ne.$AM,NotebookCellStatusBarItem:Ne.$CM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$hL,NotebookKernelSourceAction:Ne.$EM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$HM,LinkedEditingRanges:Ne.$GM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$IM,TestMessage:Ne.$JM,TestMessage2:Ne.$JM,TestTag:Ne.$KM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$4L,DataTransferItem:Ne.$ZL,CoveredCount:Ne.$LM,FileCoverage:Ne.$MM,StatementCoverage:Ne.$NM,BranchCoverage:Ne.$OM,FunctionCoverage:Ne.$PM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$RM,TabInputTextDiff:Ne.$SM,TabInputTextMerge:Ne.$TM,TabInputCustom:Ne.$UM,TabInputNotebook:Ne.$WM,TabInputNotebookDiff:Ne.$XM,TabInputWebview:Ne.$VM,TabInputTerminal:Ne.$YM,TabInputInteractiveWindow:Ne.$ZM,TabInputChat:Ne.$1M,TelemetryTrustedValue:s.$Lo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$gM,ThreadFocus:Ne.$hM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$hic=Jt}),define(Pe[291],Re([1,0,53,112,36,107,37,32,66,65,115,117,118,83,86,79,106,62,42,82,60,64,226,14,116,80,81]),function(ge,e,y,M,I,A,P,m,f,w,R,k,l,p,b,r,a,s,n,o,c,h,t,u,i,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Yr)(g.$9gc,g.$8gc,1),(0,y.$Yr)(u.$oj,t.$iic,1),(0,y.$Yr)(r.$hgc,r.$igc,1),(0,y.$Yr)(m.$xN,m.$wN,0),(0,y.$Yr)(P.$Cgc,P.$Agc,0),(0,y.$Yr)(s.$Egc,s.$Dgc,0),(0,y.$Yr)(k.$ghc,k.$khc,0),(0,y.$Yr)(A.$mhc,A.$lhc,0),(0,y.$Yr)(f.$mN,f.$lN,0),(0,y.$Yr)($.$0gc,$.$$gc,0),(0,y.$Yr)(n.$egc,n.$dgc,0),(0,y.$Yr)(M.$Shc,M.$Rhc,1),(0,y.$Yr)(l.$Chc,l.$Dhc,0),(0,y.$Yr)(p.$Xgc,p.$Wgc,0),(0,y.$Yr)(R.$6hc,R.$5hc,0),(0,y.$Yr)(w.$1gc,w.$4gc,0),(0,y.$Yr)(b.$vyb,b.$wyb,0),(0,y.$Yr)(a.$gic,a.$fic,0),(0,y.$Yr)(I.$zgc,I.$ygc,0),(0,y.$Yr)(o.$6gc,o.$5gc,0),(0,y.$Yr)(c.$vN,c.$sN,0),(0,y.$Yr)(h.$Ogc,h.$Pgc,0),(0,y.$Yr)(i.$ehc,i.$fhc,0)}),define(Pe[292],Re([1,0,290,38,2,287,7,13,232]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class w extends A.$lic{j(){}getModule(p,b){for(const r of this.b){const a=r(p);if(a){p=a;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$ahc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$skc);const p=this.h.invokeFunction(y.$hic);this.r=this.h.createInstance(w,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,r){b=b.with({path:k(b.path,".js")});const a=p?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const s=I.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(s.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch($){throw console.error(a?`Loading code for extension ${a} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${b.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}p&&await this.w.initializeLocalizedMessages(p);const u={},i={exports:u},g=$=>{const d=this.r.getModule($,b);if(d===void 0)throw new Error(`Cannot load module '${$}'`);return d};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(i,u,g),i.exports!==u?i.exports:u}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,m.$7g)(10)}}e.$tkc=R;function k(l,p){return l.endsWith(p)?l:l+p}}),define(Pe[293],Re([1,0,70,53,14,38,199,85,292]),function(ge,e,y,M,I,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$Yr)(I.$nj,new y.$3h(P.$kic,[!0],!0)),(0,M.$Yr)(A.$bhc,f.$tkc,0),(0,M.$Yr)(m.$Fgc,m.$Ggc,0)}),define(Pe[298],Re([1,0,22,5,78,288,234,19,88,11,2,291,293]),function(ge,e,y,M,I,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(t){return/^(file|vscode-remote):/i.test(t)}const b=fetch.bind(self);function r(t){self.fetch=async function(u,i){return u instanceof Request||p(String(u))&&(u=(await t(R.URI.parse(String(u)))).toString(!0)),b(u,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,i,g,$,d){(async()=>(p(i.toString())&&(i=(await t(R.URI.parse(i.toString()))).toString(!0)),super.open(u,i,g??!0,$,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(u,i){if(/^file:/i.test(u.toString()))u=w.$og.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(v){function E(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?D(O,G):D(E(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,q,z,C){return super.open(O,E(G),q??!0,z,C)}};const T=importScripts.bind(self);self.importScripts=(...O)=>{T(...O.map(E))},T(v)}.toString()}('${u}'))`;i=i||{},i.name=i.name||m.$nc(u.toString());const d=new Blob([$],{type:"application/javascript"}),S=URL.createObjectURL(d);return new t(S,i)}}else self.Worker=class extends P.$ukc{constructor(t,u){super(l,t,{name:m.$nc(t.toString()),...u})}};const a=new class{constructor(){this.pid=void 0}exit(t){k()}};class s{constructor(){const u=new MessageChannel,i=new M.$Vd;let g=!1;l(u.port2,[u.port2]),u.port1.onmessage=$=>{const{data:d}=$;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const S=y.$je.wrap(new Uint8Array(d,0,d.byteLength));if((0,I.$um)(S,2)){g=!0,o("received terminate message from renderer");return}i.fire(S)},this.protocol={onMessage:i.event,send:$=>{if(!g){const d=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);u.port1.postMessage(d,[d])}}}}}function n(t){return new Promise(u=>{const i=t.onMessage(g=>{i.dispose();const $=JSON.parse(g.toString());t.send((0,I.$tm)(0)),u({protocol:t,initData:$})});t.send((0,I.$tm)(1))})}let o=t=>k();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(u){c(u)&&n(t.protocol).then(i=>{f.mark("code/extHost/didWaitForInitData");const g=new A.$nic(i.protocol,i.initData,a,null,u.data);r($=>g.asBrowserUri($)),o=$=>g.terminate($)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aed5f4d65d2dbfda2c98abd7eb371751016838ab/core/vs/workbench/api/worker/extensionHostWorker.js.map
